ALTER TABLE IMPOSNFTOT ADD VRADICFECP FLOAT
/

create or replace
PROCEDURE CRIA_VENCIMENTO(
          P_CDFILIAL      IN VARCHAR2,
          P_NRLANCTONF    IN VARCHAR2,
          P_IDENTRSAIDOP  IN VARCHAR2,
          P_VRPAGTO       IN FLOAT,
          P_DTEMISSAO     IN DATE,
          P_DTENTRSAID    IN DATE,
          P_CDCLIEFORN    IN VARCHAR2,
          P_CDFILIEMIRECE IN VARCHAR2,
          P_ORIGDESTNF    IN VARCHAR2,
          P_CDFILLANC     IN VARCHAR2,
          P_CDFILDEST     IN VARCHAR2,
          P_NRAUTOFORN    IN VARCHAR2,
          P_CDFILPEDIDO   IN VARCHAR2,
          P_NRPEDIDO      IN VARCHAR2)
AS
   V_IDFORMAPGTO     VARCHAR2(01);
   V_NRPARCPGTO      NUMBER;
   V_IDTIPODTPGT     VARCHAR2(4);

   V_COUNT         NUMBER;

   V_SEQUENCIAL      NUMBER;
   V_VRPARCVENC      NUMBER;
   V_NRPARCELAS      NUMBER;
   V_NRPARCELASST    NUMBER;
   V_VRPARCAUXI      NUMBER;
   V_INDIAS          NUMBER;
   V_INGUARDANRDIAS  NUMBER;

   V_DTVENCIMENTO    DATE;
   V_DTBASE          DATE;

   V_VRPAGTO         NUMBER;

   V_CDSERVCONT      VARCHAR2(5);

   V_CODIGO VARCHAR2(1);
   V_CDCLIEFORN VARCHAR2(21);

   V_IDGERPARCST  VARCHAR2(1);
   V_NRDIAPOSEMDOCST NUMBER;

   V_VRTOTIMPONF   NUMBER;
   V_VRTOTIMPONFPR NUMBER;

   V_IDTPPERIODO VARCHAR2(1);

   V_CDFORMPGTO VARCHAR2(2);

   V_CONSDIAUTILAUX VARCHAR2(1);
   V_DTEMISSAOAUX DATE;
   V_CDMODPGTO   VARCHAR2(05);
   V_NRSEQCONTRATO  NUMBER; 
   V_TPVENCCONT     NUMBER;
   V_DIAVENCCONT    NUMBER;
   V_DTCOMPVENC     DATE;
   V_DTVENC         DATE;
   V_DTEMISSAO      DATE;
   
   
   CURSOR C_PARCELAS (P_CLIEFORN VARCHAR2,
                      P_CODIGO VARCHAR2,
                      P_CDSERVCONT VARCHAR2,
                      P_CDFILIDEST VARCHAR2,
                      P_CDFILILANC VARCHAR2,
                      P_NRAUTOFORN VARCHAR2,
                      P_CDFILPEDIDO VARCHAR2,
                      P_NRPEDIDO VARCHAR2)
       IS
      SELECT NRDIASPGTO, VRPERCPGTO
        FROM
      (SELECT NVL(NRDIASPGTOFO, 0) AS NRDIASPGTO, NVL(VRPERCPGTOFO, 100) VRPERCPGTO
        FROM PRAZOPGTFORN
       WHERE CDFORNECED = P_CDCLIEFORN
         AND P_CODIGO = '0'
       UNION
      SELECT NVL(NRDIASPGTOCL, 0) AS NRDIASPGTO, NVL(VRPERCPGTOCL, 100) VRPERCPGTO
        FROM PRAZOPGTCLIE
       WHERE CDCLIENTE = P_CDCLIEFORN
         AND P_CODIGO = '1'
       UNION
      SELECT NVL(NRDIASPGTOSC, 0) AS NRDIASPGTO, NVL(VRPERCPGTOSC, 100) VRPERCPGTO
        FROM PZPGSERCONT
       WHERE CDCLIENTE = P_CDCLIEFORN
         AND CDSERVCONT = P_CDSERVCONT
         AND P_CODIGO = '2'
       UNION
      SELECT NVL(NRDIASPGTOAF, 0) AS NRDIASPGTO, NVL(VRPERCPGTOAF, 100) VRPERCPGTO
        FROM PRAZOPGTAF
       WHERE CDFILDEST = P_CDFILDEST
         AND CDFILLANC  = P_CDFILLANC
         AND NRAUTOFORN = P_NRAUTOFORN
         AND P_CODIGO = '3'
       UNION
      SELECT NVL(NRDIASPGTOPED, 0) AS NRDIASPGTO, NVL(VRPERCPGTOPED, 100) VRPERCPGTO
        FROM PRAZOPGTOPED
       WHERE CDFILIAL = P_CDFILPEDIDO
         AND NRPEDIDO = P_NRPEDIDO
         AND P_CODIGO = '4'
         UNION
      SELECT NVL(NRDIASMODPGTO, 0) AS NRDIASPGTO, NVL(VRPERCMODPGTO, 100) VRPERCPGTO
        FROM PRAZOMODPGTO
       WHERE CDMODPGTO = V_CDMODPGTO
         AND P_CODIGO = '5');
   FUNCTION FORMAPGTOFIXA(P_DTBASE      IN DATE,
                          P_IDUTDIAPGTO IN VARCHAR2,
                          V_NRDIAFIXO   IN VARCHAR2)
            RETURN DATE
   IS
      V_DATEVENCI    DATE;
      V_INDIAS       NUMBER;

   BEGIN
      IF NOT (P_DTBASE IS NULL) THEN
         /* FORMA FIXA Verifica se o numero informado no cadastro de forma de pagamento é maior
         ou igual ao dia da data de vencimento. Ou se o opção de gerar 1 parcela no proximo mes
         esteja marcada  */
         IF (P_IDUTDIAPGTO = 'I') THEN
            IF (V_NRDIAFIXO >= TO_NUMBER(TO_CHAR(P_DTBASE, 'DD'))) THEN
               /* pega o maior dia do mes */
               V_INDIAS :=  TO_NUMBER(TO_CHAR(LAST_DAY(P_DTBASE), 'DD'));

                /* Verifica se numero informado no cadastro de forma de pagamento é
                   maior que o ultimo dia do mes. Exemplo informou 31 no cadastro e o ultimo dia do e 30*/
               IF V_NRDIAFIXO > V_INDIAS THEN
                  /*Pega o maior dia do mes */
                  V_DATEVENCI := LAST_DAY(P_DTBASE);
               ELSE
                  /*Joga a data com o dia informado na parametrizcao */
                  V_DATEVENCI := TO_DATE(TO_CHAR(V_NRDIAFIXO)||'/'||TO_CHAR(P_DTBASE, 'MM/YYYY'), 'DD/MM/YYYY');
               END IF;
            ELSE
               V_DATEVENCI := ADD_MONTHS(P_DTBASE, 1);
               /*Vefica se o dia parametrizado é menor ou igual ao ÚLTIMO DIA do mes (próximo mês)*/
               /*
                 EXEMPLO:
                 PARAMTRIZEI VENCIMENTO PARA TODO DIA 30 DO PROX. MES
                 EMISSAO DA NOTA É DIA 01/01
                 DIA 30/02 NÃO EXISTE, PORTANTO ESTE IF É IMPORTANTE
               */
               IF (V_NRDIAFIXO <= TO_NUMBER(TO_CHAR(LAST_DAY(V_DATEVENCI), 'DD'))) THEN
                  V_DATEVENCI := TO_DATE(TO_CHAR(V_NRDIAFIXO)||'/'||TO_CHAR(V_DATEVENCI, 'MM/YYYY'), 'DD/MM/YYYY');
               ELSE
                  V_DATEVENCI := LAST_DAY(V_DATEVENCI);
               END IF;
            END IF;
         ELSE
            V_DATEVENCI := ADD_MONTHS(P_DTBASE, 1);
            /*Vefica se o dia parametrizado é menor ou igual ao ÚLTIMO DIA do mes (próximo mês)*/
            /*
                 EXEMPLO:
                 PARAMTRIZEI VENCIMENTO PARA TODO DIA 30 DO PROX. MES
                 EMISSAO DA NOTA É DIA 01/01
                 DIA 30/02 NÃO EXISTE, PORTANTO ESTE IF É IMPORTANTE
            */
            IF (V_NRDIAFIXO <= TO_NUMBER(TO_CHAR(LAST_DAY(V_DATEVENCI), 'DD'))) THEN
               V_DATEVENCI := TO_DATE(TO_CHAR(V_NRDIAFIXO)||'/'||TO_CHAR(V_DATEVENCI, 'MM/YYYY'), 'DD/MM/YYYY');
            ELSE
               V_DATEVENCI := LAST_DAY(V_DATEVENCI);
            END IF;
         END IF;
         RETURN(V_DATEVENCI);
      ELSE
         RETURN(V_DTEMISSAO);
      END IF;
   END;


   /*DETERMINA O DIA DA SEMANA OU DO MÊS EM QUE O PAGAMENTO DEVE CAIR*/
   FUNCTION DIAPGTO (P_DTBASE IN DATE,
                     P_IDTPPERIODO IN VARCHAR2,
                     P_CDFORMPGTO IN VARCHAR2) RETURN DATE
   IS
      V_DTVENCIMENTO DATE;
   BEGIN
      V_DTVENCIMENTO := P_DTBASE;
      IF P_IDTPPERIODO = 'M' THEN
         V_DTVENCIMENTO := UTIL_CRIAVENCIMENTO.DIAMES(P_CDFORMPGTO,
                                                      P_DTBASE);
      ELSIF p_IDTPPERIODO = 'S' THEN
         V_DTVENCIMENTO := UTIL_CRIAVENCIMENTO.DIASEMANA(P_CDFORMPGTO,
                                                         P_DTBASE);
      ELSE
         V_DTVENCIMENTO := UTIL_CRIAVENCIMENTO.DIASEMANAMES(P_CDFORMPGTO,
                                                            P_DTBASE);
      END IF;
      RETURN V_DTVENCIMENTO;
   END;


   /* DETERMINA A DATA REFERÊNCIA DA FORMA DE PAGAMENTO */
   FUNCTION DATAREFERENCIA(P_DTBASEREF IN DATE,
                 P_IDREFECALCPARC IN VARCHAR2)
            RETURN DATE
   IS
   P_DTBASE DATE;
   V_DIASEMANA NUMBER;
   BEGIN
      IF P_IDREFECALCPARC = 'FORA_SEMANA' THEN
         V_DIASEMANA := 8 - TO_CHAR(P_DTBASEREF, 'D');
         P_DTBASE := P_DTBASEREF + V_DIASEMANA;
        /* P_DTBASE := TO_DATE(TO_CHAR(P_DTBASEREF, 'DD') + V_DIASEMANA||TO_CHAR(P_DTBASEREF, '/MM/YYYY'), 'DD/MM/YYYY');  */
      ELSIF P_IDREFECALCPARC = 'FORA_DEZENA' THEN
         IF ((TO_CHAR(P_DTBASEREF, 'DD') >= 01) AND (TO_CHAR(P_DTBASEREF, 'DD') <= 10)) THEN
            P_DTBASE := TO_DATE('11/'||TO_CHAR(P_DTBASEREF, 'MM/YYYY'), 'DD/MM/YYYY');
         ELSIF ((TO_CHAR(P_DTBASEREF, 'DD') >= 11) AND (TO_CHAR(P_DTBASEREF, 'DD') <= 20)) THEN
            P_DTBASE := TO_DATE('21/'||TO_CHAR(P_DTBASEREF, 'MM/YYYY'), 'DD/MM/YYYY');
         ELSIF ((TO_CHAR(P_DTBASEREF, 'DD') >= 21) AND (TO_CHAR(P_DTBASEREF, 'DD') <= 31)) THEN
            P_DTBASE := TO_DATE('01/'||TO_CHAR(P_DTBASEREF, 'MM/YYYY'), 'DD/MM/YYYY');
            P_DTBASE := ADD_MONTHS(P_DTBASE, 1);
         END IF;
      ELSIF P_IDREFECALCPARC = 'FORA_QUINZENA' THEN
         IF ((TO_CHAR(P_DTBASEREF, 'DD') >= 01) AND (TO_CHAR(P_DTBASEREF, 'DD') <= 15)) THEN
            P_DTBASE := TO_DATE('16/'||TO_CHAR(P_DTBASEREF, 'MM/YYYY'), 'DD/MM/YYYY');
         ELSIF ((TO_CHAR(P_DTBASEREF, 'DD') >= 16) AND (TO_CHAR(P_DTBASEREF, 'DD') <= 31)) THEN
            P_DTBASE := TO_DATE('01/'||TO_CHAR(P_DTBASEREF, 'MM/YYYY'), 'DD/MM/YYYY');
            P_DTBASE := ADD_MONTHS(P_DTBASE, 1);
         END IF;
      ELSIF P_IDREFECALCPARC = 'FORA_MES' THEN
         P_DTBASE := TO_DATE('01/'||TO_CHAR(P_DTBASEREF, 'MM/YYYY'), 'DD/MM/YYYY');
         P_DTBASE := ADD_MONTHS(P_DTBASE, 1);
      ELSIF P_IDREFECALCPARC = 'DIA_DE_REFERENCIA' THEN
         P_DTBASE := P_DTBASEREF;
      END IF;
      RETURN(P_DTBASE);
   END;


   /*DETEMINA A DATA BASE E O NÚMERO DE DIAS A PARTIR DO TIPO DA FORMA DE PAGAMENTO
   E DO TIPO DA DATA DE PAGAMENTO*/
  
   PROCEDURE FORMAPGTO(P_INDIAS OUT NUMBER,
                       P_DTBASE OUT DATE,
                       P_DTEMISSAO IN DATE,
                       P_DTENTRSAID IN DATE,
                       P_IDTPFORPGT IN VARCHAR2,
                       P_IDTPPERIODO IN VARCHAR2,
                       P_IDUTDIAPGT IN VARCHAR2,
                       P_NRDIAFIXO IN VARCHAR2,
                       P_CODIGO IN VARCHAR2,
                       P_IDTIPODTPGT IN VARCHAR2,
                       P_CDFORMPGTO IN VARCHAR2,
                       P_IDREFECALCPARC IN VARCHAR2)
   IS
   V_DTAUX DATE;
   BEGIN
      IF NOT P_IDTPFORPGT IS NULL THEN
         IF P_IDTPFORPGT = 'V' THEN
            IF P_IDTIPODTPGT = 'EMIN' THEN
               P_INDIAS := 0;
               P_DTBASE := P_DTEMISSAO;
            ELSIF P_IDTIPODTPGT = 'EMEX' THEN
               P_INDIAS := 1;
               P_DTBASE := P_DTEMISSAO;
            ELSIF P_IDTIPODTPGT = 'ENIN' THEN
               P_INDIAS := 0;
               P_DTBASE := P_DTENTRSAID;
            ELSIF P_IDTIPODTPGT = 'ENEX' THEN
               P_INDIAS := 1;
               P_DTBASE := P_DTENTRSAID;
            ELSIF P_IDTIPODTPGT = 'DSIN' THEN
               P_INDIAS := 0;
               P_DTBASE := P_DTENTRSAID;
            ELSIF P_IDTIPODTPGT = 'DSEX' THEN
               P_INDIAS := 1;
               P_DTBASE := P_DTENTRSAID;
            END IF;
            

            /* CHAMA A FUNÇÃO PARA GERAR A DATA DE REFERÊNCIA DA FORMA DE PAGAMENTO*/
            
             IF NOT (P_DTBASE IS NULL) THEN
               P_DTBASE := DATAREFERENCIA(P_DTBASE, P_IDREFECALCPARC);
            END IF;

            V_DTAUX := P_DTBASE + P_INDIAS;
            V_DTAUX := V_DTAUX - 1;
            /*SE FOR NOTA FISCAL DE SERVIÇO, CONSIDERA O DIA DE PAGAMENTO*/
            IF (P_CODIGO = '2') AND NOT (P_CDFORMPGTO IS NULL) THEN
               V_DTAUX := DIAPGTO(V_DTAUX,
                                  P_IDTPPERIODO,
                                  P_CDFORMPGTO);
            END IF;
         ELSE
            P_DTBASE := P_DTEMISSAO;
            V_DTAUX := FORMAPGTOFIXA(P_DTEMISSAO ,P_IDUTDIAPGT, P_NRDIAFIXO);
         END IF;
         P_INDIAS := TRUNC(V_DTAUX - P_DTBASE);
         IF (P_INDIAS IS NULL) THEN
            P_INDIAS := 0;
         END IF;
      END IF;
   END;


   /*CORRIGE A DATA DE VENCIMENTO CONSIDERANDO FERIADO BANCÁRIO*/
   PROCEDURE CONSISTE_FERI_BANC(P_CDFILIEMIRECE IN VARCHAR2,
                                P_DTVENCIMENTO IN DATE,
                                P_DTVENC OUT DATE,
                                P_IDTIPODTPGTO IN VARCHAR2,
                                P_DTEMISSAO IN DATE)
   IS
      V_BOFERI BOOLEAN;
      V_NRDIASFERI NUMBER;
      V_DTANTERIOR DATE;
      V_IDCONSCALVENNF VARCHAR2(1);
   BEGIN
      V_BOFERI := TRUE;
      P_DTVENC := P_DTVENCIMENTO;

      BEGIN
         SELECT IDCONSCALVENNF
           INTO V_IDCONSCALVENNF
           FROM PARAMFILIAL
          WHERE CDFILIAL = P_CDFILIEMIRECE;
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
              V_IDCONSCALVENNF := NULL;
      END;
      
      WHILE V_BOFERI LOOP
         IF P_IDTIPODTPGTO = 'EMEX' OR P_IDTIPODTPGTO = 'ENEX' OR P_IDTIPODTPGTO = 'DSEX' THEN
           
            BEGIN
               IF V_IDCONSCALVENNF = 'F' THEN
                  SELECT COUNT(*)
                    INTO V_NRDIASFERI
                    FROM FERIFILI
                   WHERE CDFILIAL = P_CDFILIEMIRECE
                     AND DTFERIFILI BETWEEN P_DTEMISSAO+1 AND P_DTVENC;
               ELSIF V_IDCONSCALVENNF = 'C' THEN
                  SELECT COUNT(*)
                    INTO V_NRDIASFERI
                    FROM FERICOMP
                   WHERE CDFILIAL = P_CDFILIEMIRECE
                     AND DTFERICOMP BETWEEN P_DTEMISSAO+1 AND P_DTVENC;
               ELSE
                  SELECT COUNT(*)
                    INTO V_NRDIASFERI
                    FROM FERIBANC
                   WHERE CDFILIAL = P_CDFILIEMIRECE
                     AND DTFERIBANC BETWEEN P_DTEMISSAO+1 AND P_DTVENC;
               END IF;
            EXCEPTION
               WHEN NO_DATA_FOUND THEN
                  V_NRDIASFERI := 0;
            END;
         ELSE
            BEGIN 
               IF V_IDCONSCALVENNF = 'F' THEN
                  SELECT COUNT(*)
                    INTO V_NRDIASFERI
                    FROM FERIFILI
                   WHERE CDFILIAL = P_CDFILIEMIRECE
                     AND DTFERIFILI BETWEEN P_DTEMISSAO AND P_DTVENC;
               ELSIF V_IDCONSCALVENNF = 'C' THEN
                  SELECT COUNT(*)
                    INTO V_NRDIASFERI
                    FROM FERICOMP
                   WHERE CDFILIAL = P_CDFILIEMIRECE
                     AND DTFERICOMP BETWEEN P_DTEMISSAO AND P_DTVENC;
               ELSE
                  SELECT COUNT(*)
                    INTO V_NRDIASFERI
                    FROM FERIBANC
                   WHERE CDFILIAL = P_CDFILIEMIRECE
                     AND DTFERIBANC BETWEEN P_DTEMISSAO AND P_DTVENC;
               END IF;
            EXCEPTION
               WHEN NO_DATA_FOUND THEN
                  V_NRDIASFERI := 0;
            END;
         END IF;

         IF NOT(V_NRDIASFERI = 0) THEN
            V_DTANTERIOR := P_DTVENC;
            P_DTVENC := P_DTVENC + V_NRDIASFERI;
            WHILE V_BOFERI LOOP
               V_DTANTERIOR := V_DTANTERIOR+1;
               BEGIN
                  IF V_IDCONSCALVENNF = 'F' THEN
                     SELECT COUNT(*)
                       INTO V_NRDIASFERI
                       FROM FERIFILI
                      WHERE CDFILIAL = P_CDFILIEMIRECE
                        AND DTFERIFILI BETWEEN V_DTANTERIOR AND P_DTVENC;
                  ELSIF V_IDCONSCALVENNF = 'C' THEN
                     SELECT COUNT(*)
                       INTO V_NRDIASFERI
                       FROM FERICOMP
                      WHERE CDFILIAL = P_CDFILIEMIRECE
                        AND DTFERICOMP BETWEEN V_DTANTERIOR AND P_DTVENC;
                  ELSE
                     SELECT COUNT(*)
                       INTO V_NRDIASFERI
                       FROM FERIBANC
                      WHERE CDFILIAL = P_CDFILIEMIRECE
                        AND DTFERIBANC BETWEEN V_DTANTERIOR AND P_DTVENC;
                  END IF;
               EXCEPTION
                  WHEN NO_DATA_FOUND THEN
                     V_NRDIASFERI := 0;
               END;

               IF V_NRDIASFERI > 0 THEN
                  V_DTANTERIOR := P_DTVENC;
                  P_DTVENC := P_DTVENC + V_NRDIASFERI;
               ELSE
                  V_BOFERI := FALSE;
               END IF;
            END LOOP;
         ELSE
            V_BOFERI := FALSE;
         END IF;
      END LOOP;
   END;

   /*ALTERAÇÃO DOS PARÂMETROS NECESSÁRIOS PARA GERAÇÃO DO FINANCEIRO
     QUANTIDADE DE DIAS, DATA BASE, FORMA DE PAGAMENTO,NÚMERO DE PARCELAS*/
   PROCEDURE SET_PARAMETROS (P_CDCLIEFORN IN VARCHAR2,
                             P_IDENTRSAIDOP IN VARCHAR2,
                             P_DTEMISSAO IN DATE,
                             P_DTENTRSAID IN DATE,
                             P_CDFILDEST IN VARCHAR2,
                             P_CDFILLANC IN VARCHAR2,
                             P_NRAUTOFORN IN VARCHAR2,
                             P_CDFILPEDIDO IN VARCHAR2,
                             P_NRPEDIDO IN VARCHAR2,
                             P_CDSERVCONT IN VARCHAR2,
                             P_INDIAS OUT NUMBER,
                             P_DTBASE OUT DATE,
                             P_IDFORMAPGTO OUT VARCHAR2,
                             P_IDTIPODTPGT OUT VARCHAR2,
                             P_IDTPPERIODO OUT VARCHAR2,
                             P_NRPARCELAS OUT VARCHAR2,
                             P_NRPARCPGTO OUT VARCHAR2,
                             P_CDFORMPGTO OUT VARCHAR2,
                             P_CODIGO IN VARCHAR2)
   IS
      V_IDTPFORPGT     VARCHAR2(1);
      V_IDUTDIAPGT     VARCHAR2(1);
      V_NRDIAFIXO      VARCHAR2(2);
      V_IDREFECALCPARC VARCHAR2(30);
      V_DTAUX          DATE;
      V_CONSDIAUTIL    VARCHAR2(1);
      /*PARÂMETROS GERAIS PARA GERAÇÃO DA DATA BASE E QUANTIDADE DE DIAS*/
      CURSOR C_PARAMETRIZACAO_PGTO (P_CLIEFORN VARCHAR2,
                                    P_CODIGO VARCHAR2,
                                    P_CDSERVCONT VARCHAR2,
                                    P_CDFILIDEST VARCHAR2,
                                    P_CDFILILANC VARCHAR2,
                                    P_NRAUTOFORN VARCHAR2,
                                    P_CDFILPEDIDO VARCHAR2,
                                    P_NRPEDIDO VARCHAR2)
          IS
         SELECT IDTPFORPGT, IDUTDIAPGT, NRDIAPGFIX, IDTIPODTPGT, CDFORMPGT, IDTPPERIODO, NRPARCPGTO, IDREFECALCPARC, IDCONSDIAUTIL
           FROM
          (SELECT F.IDTPFORPGTFO IDTPFORPGT, F.IDUTDIAPGTFO IDUTDIAPGT, F.NRDIAPGFIXFO NRDIAPGFIX,
                  FP.IDTIPODTPGTO IDTIPODTPGT, F.CDFORMPGTO CDFORMPGT, FP.IDTPPERIODO IDTPPERIODO,
                  F.NRPARCPGTOFO NRPARCPGTO, FP.IDREFECALCPARC, FP.IDCONSDIAUTIL
             FROM FORNECEDOR F, FORMPGTO FP
            WHERE (F.CDFORNECED = P_CDCLIEFORN)
              AND (F.CDFORMPGTO = FP.CDFORMPGTO(+))
              AND (P_CODIGO = '0')
            UNION
           SELECT C.IDTPFORPGTCL IDTPFORPGT, C.IDUTDIAPGTCL IDUTDIAPGT , C.NRDIAPGFIXCL NRDIAPGFIX ,
                  FP.IDTIPODTPGTO IDTIPODTPGT, C.CDFORMPGTO CDFORMPGT, FP.IDTPPERIODO IDTPPERIODO,
                  C.NRPARCPGTOCL NRPARCPGTO, FP.IDREFECALCPARC, FP.IDCONSDIAUTIL
             FROM CLIENTE C, FORMPGTO FP
            WHERE (C.CDCLIENTE = P_CDCLIEFORN)
              AND (C.CDFORMPGTO = FP.CDFORMPGTO(+))
              AND (P_CODIGO = '1')
            UNION
           SELECT SC.IDTPFORPGTSC IDTPFORPGT, SC.IDUTDIAPGTSC IDUTDIAPGT, SC.NRDIAPGFIXSC NRDIAPGFIX,
                  FP.IDTIPODTPGTO IDTIPODTPGT, SC.CDFORMPGTO CDFORMPGT, FP.IDTPPERIODO IDTPPERIODO,
                  SC.NRPARCPGTOSC NRPARCPGTO, FP.IDREFECALCPARC, FP.IDCONSDIAUTIL
             FROM SERVCONTRAT SC, FORMPGTO FP
            WHERE (SC.CDCLIENTE  = P_CDCLIEFORN)
              AND (SC.CDSERVCONT = P_CDSERVCONT)
              AND (SC.CDFORMPGTO = FP.CDFORMPGTO(+))
              AND (P_CODIGO = '2')
            UNION
           SELECT A.IDTPFORPGTAF IDTPFORPGT, A.IDUTDIAPGTAF IDUTDIAPGT, A.NRDIAPGFIXAF NRDIAPGFIX,
                  FP.IDTIPODTPGTO IDTIPODTPGT, A.CDFORMPGTO CDFORMPGT, FP.IDTPPERIODO IDTPPERIODO,
                  NRPARCPGTOAF NRPARCPGTO, FP.IDREFECALCPARC, FP.IDCONSDIAUTIL
             FROM AUTOFORNE A, FORMPGTO FP
            WHERE (A.CDFILDEST  = P_CDFILDEST)
              AND (A.CDFILLANC  = P_CDFILLANC)
              AND (A.NRAUTOFORN = P_NRAUTOFORN)
              AND (A.CDFORMPGTO = FP.CDFORMPGTO(+))
              AND (P_CODIGO = '3')
            UNION
           SELECT P.IDTPFORPGTPED IDTPFORPGT, P.IDUTDIAPAGPED IDUTDIAPGT, P.NRDIAPGFIXPED NRDIAPGFIX,
                  FP.IDTIPODTPGTO IDTIPODTPGT, P.CDFORMPGTO CDFORMPGT, FP.IDTPPERIODO IDTPPERIODO,
                  NRPARCPGTOPED NRPARCPGTO, FP.IDREFECALCPARC, FP.IDCONSDIAUTIL
             FROM PEDIDO P, FORMPGTO FP
            WHERE (P.CDFILIAL   = P_CDFILPEDIDO)
              AND (P.NRPEDIDO   = P_NRPEDIDO)
              AND (P.CDFORMPGTO = FP.CDFORMPGTO(+))
              AND (P_CODIGO = '4')
            UNION
           SELECT M.IDTPFORPGTOMOD IDTPFORPGT, M.IDUTDIAPAGMOD IDUTDIAPGT, M.NRDIAPGFIXMOD NRDIAPGFIX,
                  FP.IDTIPODTPGTO IDTIPODTPGT, M.CDFORMPGTO CDFORMPGT, FP.IDTPPERIODO IDTPPERIODO,
                  NRPARCPGTOMOD NRPARCPGTO, FP.IDREFECALCPARC, '' AS IDCONSDIAUTIL
             FROM MODPGTO M, FORMPGTO FP
            WHERE (CDMODPGTO = V_CDMODPGTO)
              AND (M.CDFORMPGTO = FP.CDFORMPGTO(+))
              AND (P_CODIGO = '5')
              );
              
      CURSOR C_QTPARCELAS(P_CLIEFORN VARCHAR2,
                          P_CODIGO VARCHAR2,
                          P_CDSERVCONT VARCHAR2,
                          P_CDFILIDEST VARCHAR2,
                          P_CDFILILANC VARCHAR2,
                          P_NRAUTOFORN VARCHAR2,
                          P_CDFILPEDIDO VARCHAR2,
                          P_NRPEDIDO VARCHAR2)
          IS
          SELECT MAX(QTPARCELAS)  AS QTPARCELAS
            FROM
            (SELECT COUNT(*) AS QTPARCELAS
               FROM PRAZOPGTFORN
              WHERE CDFORNECED = P_CDCLIEFORN
                AND P_CODIGO = '0'
              UNION
             SELECT COUNT(*) AS QTPARCELAS
               FROM PRAZOPGTCLIE
              WHERE CDCLIENTE = P_CDCLIEFORN
                AND P_CODIGO = '1'
              UNION
             SELECT COUNT(*) AS QTPARCELAS
               FROM PZPGSERCONT
              WHERE CDCLIENTE = P_CDCLIEFORN
                AND CDSERVCONT = P_CDSERVCONT
                AND P_CODIGO = '2'
              UNION
             SELECT COUNT(*) AS QTPARCELAS
               FROM PRAZOPGTAF
              WHERE CDFILDEST  = P_CDFILDEST
                AND CDFILLANC  = P_CDFILLANC
                AND NRAUTOFORN = P_NRAUTOFORN
                AND P_CODIGO = '3'
              UNION
             SELECT COUNT(*) AS QTPARCELAS
               FROM PRAZOPGTOPED
              WHERE CDFILIAL = P_CDFILPEDIDO
                AND NRPEDIDO = P_NRPEDIDO
                AND P_CODIGO = '4'
              UNION
             SELECT COUNT(*) AS QTPARCELAS
               FROM PRAZOMODPGTO
              WHERE CDMODPGTO = V_CDMODPGTO
                AND P_CODIGO = '5');
   BEGIN
      
      OPEN C_PARAMETRIZACAO_PGTO(P_CDCLIEFORN,
                                 P_CODIGO,
                                 P_CDSERVCONT,
                                 P_CDFILDEST,
                                 P_CDFILLANC,
                                 P_NRAUTOFORN,
                                 P_CDFILPEDIDO,
                                 P_NRPEDIDO);
      FETCH C_PARAMETRIZACAO_PGTO INTO
         V_IDTPFORPGT,
         V_IDUTDIAPGT,
         V_NRDIAFIXO,
         P_IDTIPODTPGT,
         P_CDFORMPGTO,
         P_IDTPPERIODO,
         P_NRPARCPGTO,
         V_IDREFECALCPARC,
         V_CONSDIAUTIL;

      P_IDFORMAPGTO := V_IDTPFORPGT;

      V_CONSDIAUTILAUX := V_CONSDIAUTIL;
      
      IF NOT (V_IDTPFORPGT IS NULL) AND C_PARAMETRIZACAO_PGTO%FOUND THEN
         IF V_IDTPFORPGT = 'V' THEN
            /*QUANTIDADE DE PARCELAS*/
            OPEN C_QTPARCELAS(P_CDCLIEFORN,
                              P_CODIGO,
                              P_CDSERVCONT,
                              P_CDFILDEST,
                              P_CDFILLANC,
                              P_NRAUTOFORN,
                              P_CDFILPEDIDO,
                              P_NRPEDIDO);
            FETCH C_QTPARCELAS INTO P_NRPARCELAS;
         ELSE
            P_NRPARCELAS := P_NRPARCPGTO;
         END IF;
         
         /*DETEMINA A DATA BASE E O NÚMERO DE DIAS A PARTIR DO TIPO DA FORMA DE PAGAMENTO
           E DO TIPO DA DATA DE PAGAMENTO*/
           
         FORMAPGTO(P_INDIAS,
                   P_DTBASE,
                   P_DTEMISSAO,
                   P_DTENTRSAID,
                   V_IDTPFORPGT,
                   P_IDTPPERIODO,
                   V_IDUTDIAPGT,
                   V_NRDIAFIXO,
                   P_CODIGO,
                   P_IDTIPODTPGT,
                   P_CDFORMPGTO,
                   V_IDREFECALCPARC);
      ELSE
         P_INDIAS := 0;
         P_DTBASE := P_DTEMISSAO;
         P_IDFORMAPGTO := NULL;
         P_IDTIPODTPGT := NULL;
         P_IDTPPERIODO := NULL;
         P_NRPARCELAS := 1;
         P_NRPARCPGTO := 1;
      END IF;

      CLOSE C_PARAMETRIZACAO_PGTO;
      IF C_QTPARCELAS%ISOPEN THEN
         CLOSE C_QTPARCELAS;
      END IF;
   END;
BEGIN
   V_CDCLIEFORN := P_CDCLIEFORN;

   /* DETERMINA O CÓDIGO PARA PESQUISA DOS DADOS PARA VENCIMENTO :
   0 - FORNECEDOR
   1 - CLIENTE
   2 - CONTRATO DE SERVIÇO
   3 - AUTORIZAÇÃO DE FORNECIMENTO
   4 - PEDIDO
   5 - SRV
   */
   
   IF P_IDENTRSAIDOP = 'E' THEN
      V_CODIGO := '0';
   ELSIF P_IDENTRSAIDOP = 'S' THEN
      /*BUSCA O CONTRATO DE SERVIÇO RELACIONADO À NOTA*/
      BEGIN
         SELECT MAX(CDSERVCONT) AS CDSERVCONT
           INTO V_CDSERVCONT
           FROM SERVFATU
          WHERE (CDFILIAL   = P_CDFILIAL) AND
                (NRLANCTONF = P_NRLANCTONF);
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
               V_CDSERVCONT := NULL;
      END;
      
      IF (V_CDSERVCONT IS NULL) THEN
         V_CODIGO := '1';
      ELSE
         V_CODIGO := '2';
      END IF;
      
      /* VERIFICA SE A NOTA FOI GERADA NO SISTEMA SRV */
      BEGIN
         SELECT MAX(V.CDMODPGTO), MIN(V.DTINICOMPET)
           INTO V_CDMODPGTO, V_DTEMISSAO
           FROM FCT_APURACAO AP, FCT_VENCPREVCONT V, FCT_PARAMFATCONT PR
          WHERE AP.CDFILIAL = P_CDFILIAL
            AND AP.NRLANCTONF = P_NRLANCTONF
            AND AP.NRAPURACAO = V.NRAPURACAO
            AND V.IDFATURACONTR = 'O'
            AND V.NRSEQCONTRATO = PR.NRSEQCONTRATO
            AND PR.IDGERANFPARC = 'N';
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
               V_CDMODPGTO := NULL;
      END;

      
      IF (V_CDMODPGTO IS NOT NULL) THEN
         V_CODIGO := '5';
      END IF;       
    
      /*VERIFICA SE É DEVOLUÇÃO AO FORNECEDOR*/
      IF P_ORIGDESTNF = 'F' THEN
         /* BUSCA O CLIENTE RELACIONADO AO FORNECEDOR NO CADASTRO DE FORNECEDOR
          APENAS PARA NOTA DE DEVOLUÇÃO */
         BEGIN
            SELECT CDCLIENTE
              INTO V_CDCLIEFORN
              FROM FORNECEDOR
             WHERE CDFORNECED = P_CDCLIEFORN;
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_CDCLIEFORN := NULL;
         END;
         V_CODIGO := '2';
      END IF;
   ELSIF P_IDENTRSAIDOP = 'A' THEN
      V_CODIGO := '3';
   ELSIF P_IDENTRSAIDOP = 'P' THEN
      V_CODIGO := '4';
   END IF;

   /* VERIFICA GERAÇÃO DE PARCELA DE SUBST. TRIBUTÁRIA*/
   IF (V_CODIGO = '1') OR (V_CODIGO = '4') THEN
   
     /*BUSCA SE EXISTE ALGUEM IMPOSTO ACRESCER PARA GERAR PARCELA SEPADARA*/
     Begin
      SELECT COUNT(1)
        INTO V_COUNT
        FROM IMPOSNFTOT IT, IMPOSTO I
       WHERE IT.CDFILIAL = P_CDFILIAL
         AND IT.NRLANCTONF = P_NRLANCTONF
         AND IT.CDIMPOSTO= I.CDIMPOSTO
         AND I.IDTRATIMPO = 'A'
         AND I.IDGERAPARCFIN = 'S';
     Exception
        When No_Data_Found Then
           V_COUNT := 0;
     End;

     /*BUSCA  VALOR DO IMPOSTO ACRESCER PARA SOMAR NA PRIMEIRA PARCELA */
     Begin
        SELECT NVL(SUM(N.VRTOTIMPONF + NVL(VRADICFECP, 0)), 0)
          INTO V_VRTOTIMPONFPR
          FROM IMPOSNFTOT N, IMPOSTO I
         WHERE N.CDFILIAL = P_CDFILIAL
           AND N.NRLANCTONF = P_NRLANCTONF
           AND N.CDIMPOSTO= I.CDIMPOSTO
           AND I.IDTRATIMPO = 'A'
           AND IDGERAPARCFIN = 'P';
     Exception
        When No_Data_Found Then
           V_VRTOTIMPONFPR := 0;
     End;

   ELSE
      V_COUNT := 0;
   END IF;
   
   IF(V_CODIGO <> '5') THEN
         V_DTEMISSAO := P_DTEMISSAO;
   END IF;
   
   
   
   /*VALOR DA PARCELA DE SUBST. TRIBUTÁRIA*/
   V_VRTOTIMPONF  := 0;
   V_NRPARCELASST := 0;
   IF V_COUNT > 0 THEN
      Begin
         SELECT SUM(NVL(N.VRTOTIMPONF + NVL(VRADICFECP, 0), 0)), MAX(NRDIASEMISDOC)
           INTO V_VRTOTIMPONF, V_NRDIAPOSEMDOCST
           FROM IMPOSNFTOT N, IMPOSTO I
          WHERE N.CDFILIAL = P_CDFILIAL
            AND N.NRLANCTONF = P_NRLANCTONF
            AND N.CDIMPOSTO= I.CDIMPOSTO
            AND I.IDTRATIMPO = 'A'
            AND IDGERAPARCFIN = 'S';
      Exception
         When No_Data_Found Then
            V_VRTOTIMPONF := 0;
      End;

      /*LANÇA VENCIMENTO PARA O VALOR DA SUBST. TRIBUTÁRIA*/
      IF NOT (V_VRTOTIMPONF = 0) THEN
         V_NRPARCELASST := 1;

         INSERT INTO TRAB_VENCIMENTO
           (CDFILIALVENC, NRLANCTONFVENC, DTVENCIMENTO, VRVENCIMENTO, QTDIASVENC, NRSEQVENC, IDTPCONTATRABVEN)
         VALUES
           (P_CDFILIAL, P_NRLANCTONF, (V_DTEMISSAO + V_NRDIAPOSEMDOCST), ROUND(V_VRTOTIMPONF, 2), NVL(V_NRDIAPOSEMDOCST, 0), LPAD(TO_CHAR(V_NRPARCELASST), 5, '0'), 'S');
      END IF;
   END IF;

   V_INDIAS := 0;
   V_DTVENCIMENTO := NULL;

   /*DETERMINA A DATA BASE E O NÚMERO DE DIAS APÓS A EMISSÃO*/
   
   SET_PARAMETROS(V_CDCLIEFORN,
                  P_IDENTRSAIDOP,
                  V_DTEMISSAO,
                  P_DTENTRSAID,
                  P_CDFILDEST,
                  P_CDFILLANC,
                  P_NRAUTOFORN,
                  P_CDFILPEDIDO,
                  P_NRPEDIDO,
                  V_CDSERVCONT,
                  V_INGUARDANRDIAS,
                  V_DTBASE,
                  V_IDFORMAPGTO,
                  V_IDTIPODTPGT,
                  V_IDTPPERIODO,
                  V_NRPARCELAS,
                  V_NRPARCPGTO,
                  V_CDFORMPGTO,
                  V_CODIGO);

  
   /*ABATE A PARCELA DE IMPOSTO*/
   IF V_VRTOTIMPONFPR IS NULL THEN
      V_VRTOTIMPONFPR := 0;
   END IF;
   
  /*VERIFICA SE A NOTA FOI GERADA NO SISTEMA SERVICES */
   BEGIN
      SELECT CT.NRSEQCONTRATO, CT.IDTPDTVENC, CT.NRDIAVENPARCFAT, MAX(V.DTVENCIMENTO)
        INTO V_NRSEQCONTRATO, V_TPVENCCONT, V_DIAVENCCONT, V_DTCOMPVENC
        FROM FCT_APURACAO AP, FCT_VENCPREVCONT V, FCT_CONTRATO CT, FCT_PARAMFATCONT PR
       WHERE AP.CDFILIAL = P_CDFILIAL
         AND AP.NRLANCTONF = P_NRLANCTONF
         AND V.NRAPURACAO =  AP.NRAPURACAO
         AND ((V.IDFATURACONTR = 'A') OR ((V.IDFATURACONTR = 'O') AND (PR.IDGERANFPARC = 'S')))
         AND PR.NRSEQCONTRATO = CT.NRSEQCONTRATO
         AND CT.NRSEQCONTRATO = AP.NRSEQCONTRATO
         GROUP BY CT.NRSEQCONTRATO, CT.IDTPDTVENC, CT.NRDIAVENPARCFAT;
   EXCEPTION
      WHEN NO_DATA_FOUND THEN BEGIN
         V_NRSEQCONTRATO := NULL;
         V_TPVENCCONT := NULL;
         V_DIAVENCCONT := NULL;
         V_DTCOMPVENC := NULL;
      END;
   END;
   
   
   /* Se for gerada no SRV, verifica se o tipo de vencimento do contrato é o 5 - Forma de Pagamento do Cliente */
   IF V_TPVENCCONT IS NOT NULL THEN
      IF V_TPVENCCONT <> 5 THEN
         V_IDFORMAPGTO := NULL;
      END IF;
   END IF;
       
   /*ABATE A PARCELA DE IMPOSTO*/
   V_VRPAGTO := ROUND(P_VRPAGTO - V_VRTOTIMPONF - V_VRTOTIMPONFPR, 2);   
   IF V_IDFORMAPGTO IS NULL THEN /* SEM FORMA DE PAGAMENTO*/
      V_NRPARCELAS := 1;
      
     /* Rotina do SRV para pegar a data correta para o vencimento da parcela. */ 
      IF V_NRSEQCONTRATO IS NOT NULL THEN
         /* 1 - Quantidade dias anterior Data de Emissão */
         IF V_TPVENCCONT = 1 THEN
            V_DTVENC := P_DTENTRSAID-V_DIAVENCCONT; 
         END IF;
         /* 2 - Quantidade dias posterior Data de Emissão */
         IF V_TPVENCCONT = 2 THEN
            V_DTVENC := P_DTENTRSAID+V_DIAVENCCONT;
         END IF;
          /*3 - Próximo dia posterior data de emissão */
         IF V_TPVENCCONT = 3 THEN
            IF TO_NUMBER(TO_CHAR(P_DTENTRSAID,'DD')) > V_DIAVENCCONT THEN 
               V_DTVENC := TO_DATE(V_DIAVENCCONT||'/'||TO_CHAR(ADD_MONTHS(P_DTENTRSAID,1),'MM/YYYY'));
            ELSE
               V_DTVENC := TO_DATE(V_DIAVENCCONT||'/'||TO_CHAR(P_DTENTRSAID,'MM/YYYY'));
             END IF;
         END IF;
         /*4 - Próximo dia anterior data de emissão*/
         IF V_TPVENCCONT = 4 THEN
            IF TO_NUMBER(TO_CHAR(P_DTENTRSAID,'DD')) > V_DIAVENCCONT THEN 
               V_DTVENC := TO_DATE(V_DIAVENCCONT||'/'||TO_CHAR(P_DTENTRSAID,'MM/YYYY'));
            ELSE
               V_DTVENC := TO_DATE(V_DIAVENCCONT||'/'||TO_CHAR(ADD_MONTHS(P_DTENTRSAID,-1),'MM/YYYY'));
            END IF;
         END IF;
         
         V_DTVENC := V_DTCOMPVENC;
      ELSE
         /* Se não for do SRV, recebe a DTEMISSAO como fazia antes*/ 
         V_DTVENC := V_DTEMISSAO;
      END IF;
      
      INSERT INTO TRAB_VENCIMENTO
         (CDFILIALVENC, NRLANCTONFVENC, DTVENCIMENTO, VRVENCIMENTO, QTDIASVENC, NRSEQVENC, IDTPCONTATRABVEN)
      VALUES
         (P_CDFILIAL, P_NRLANCTONF, V_DTVENC, ROUND(V_VRPAGTO+V_VRTOTIMPONFPR, 2), 0, LPAD(TO_CHAR(1+V_NRPARCELASST),5, '0'), 'N');
   ELSIF (V_IDFORMAPGTO = 'F') THEN /*FORMA DE PAGAMENTO FIXA*/
      V_DTVENCIMENTO := V_DTBASE + V_INGUARDANRDIAS;
      V_VRPARCVENC := ROUND(V_VRPAGTO/V_NRPARCPGTO,2);
      V_SEQUENCIAL := 1;
      V_NRPARCELAS := V_NRPARCPGTO;
      /*LANÇA CONTAS PARA O MESMO DIA INDICADO PORÉM EM MESES DIFERENTES*/
      WHILE V_SEQUENCIAL <= V_NRPARCELAS LOOP
         IF V_SEQUENCIAL = V_NRPARCELAS THEN
            V_VRPARCVENC := V_VRPARCVENC + ROUND(V_VRPAGTO - (V_VRPARCVENC * V_NRPARCPGTO),2);
         END IF;
         /*INSERE OS DADOS DO VENCIMENTO*/
         INSERT INTO TRAB_VENCIMENTO
            (CDFILIALVENC, NRLANCTONFVENC, DTVENCIMENTO, VRVENCIMENTO, QTDIASVENC, NRSEQVENC, IDTPCONTATRABVEN)
         VALUES
            (P_CDFILIAL, P_NRLANCTONF, V_DTVENCIMENTO, ROUND(DECODE(V_SEQUENCIAL, 1, V_VRPARCVENC+V_VRTOTIMPONFPR, V_VRPARCVENC), 2), NVL(TRUNC(V_DTVENCIMENTO-V_DTEMISSAO), 0), LPAD(TO_CHAR(V_SEQUENCIAL+V_NRPARCELASST), 5, '0'), 'N');

         IF NOT (V_DTVENCIMENTO IS NULL) THEN
            V_DTVENCIMENTO := ADD_MONTHS(V_DTVENCIMENTO, 1);
         END IF;

         V_SEQUENCIAL := V_SEQUENCIAL + 1;
      END LOOP;
   ELSE /*FORMA DE PAGAMENTO VARIÁVEL*/
      V_SEQUENCIAL := 1;
      V_VRPARCAUXI := 0;
      

      /*PARCELAS PARA GERAÇÃO DE TIPO DE PAGAMENTO VARIÁVEL*/
      FOR C_PARC IN C_PARCELAS(V_CDCLIEFORN,
                               V_CODIGO,
                               V_CDSERVCONT,
                               P_CDFILDEST,
                               P_CDFILLANC,
                               P_NRAUTOFORN,
                               P_CDFILPEDIDO,
                               P_NRPEDIDO
                               ) LOOP

         V_VRPARCVENC := ROUND((V_VRPAGTO * (C_PARC.VRPERCPGTO/100)),2);
         V_VRPARCAUXI := V_VRPARCAUXI + V_VRPARCVENC;

         IF V_SEQUENCIAL = V_NRPARCELAS THEN
            V_VRPARCVENC := V_VRPARCVENC + ROUND((V_VRPAGTO - V_VRPARCAUXI),2);
         END IF;

         IF C_PARC.NRDIASPGTO = 0 THEN
            V_INDIAS := V_INGUARDANRDIAS +1;
         ELSE
            V_INDIAS := V_INGUARDANRDIAS + C_PARC.NRDIASPGTO;
         END IF;

         IF NOT V_DTBASE IS NULL THEN
            V_DTVENCIMENTO := V_DTBASE + V_INDIAS;
         END IF;

         IF V_IDTIPODTPGT = 'ENEX' OR V_IDTIPODTPGT = 'DSEX' OR
            V_IDTIPODTPGT = 'ENIN' OR V_IDTIPODTPGT = 'DSIN' THEN            
            V_DTEMISSAOAUX := P_DTENTRSAID;
         ELSE
            V_DTEMISSAOAUX := V_DTEMISSAO;
         END IF;
         
         IF V_CONSDIAUTILAUX = 'S' THEN
            CONSISTE_FERI_BANC(P_CDFILIEMIRECE,
                               V_DTVENCIMENTO,
                               V_DTVENCIMENTO,
                               V_IDTIPODTPGT,
                               V_DTEMISSAOAUX);
         END IF;

         /*CONSIDERA DIA DE PAGAMENTO. CASO FOR NOTA FISCAL DE SERVIÇO, O DIA DE PAGAMENTO JÁ FOI CONSISTIDO ANTERIORMENTE*/
         IF NOT (V_DTVENCIMENTO IS NULL) THEN
            V_DTVENCIMENTO := DIAPGTO(V_DTVENCIMENTO,
                                      V_IDTPPERIODO,
                                      V_CDFORMPGTO);
         END IF;

         INSERT INTO TRAB_VENCIMENTO
            (CDFILIALVENC, NRLANCTONFVENC, DTVENCIMENTO, VRVENCIMENTO, QTDIASVENC, NRSEQVENC, IDTPCONTATRABVEN)
         VALUES
            (P_CDFILIAL, P_NRLANCTONF, V_DTVENCIMENTO, ROUND(DECODE(V_SEQUENCIAL, 1, V_VRPARCVENC+V_VRTOTIMPONFPR, V_VRPARCVENC), 2), NVL(TRUNC(V_DTVENCIMENTO-V_DTEMISSAO), 0), LPAD(TO_CHAR(V_SEQUENCIAL+V_NRPARCELASST), 5, '0'), 'N');

         V_SEQUENCIAL := V_SEQUENCIAL + 1;
      END LOOP;
      
      
      IF V_SEQUENCIAL = 1 THEN /*FORMA DE PAGAMENTO VARIÁVEL NÃO INFORMADA. LANÇAMENTO À VISTA*/
         INSERT INTO TRAB_VENCIMENTO
            (CDFILIALVENC, NRLANCTONFVENC, DTVENCIMENTO, VRVENCIMENTO, QTDIASVENC, NRSEQVENC, IDTPCONTATRABVEN)
         VALUES
            (P_CDFILIAL, P_NRLANCTONF, V_DTEMISSAO, ROUND(V_VRPAGTO+V_VRTOTIMPONFPR, 2), 0, LPAD(TO_CHAR(1+V_NRPARCELASST),5, '0'), 'N');
      END IF;
   END IF;

   IF C_PARCELAS%ISOPEN THEN
      CLOSE C_PARCELAS;
   END IF;
   
END;
/

CREATE OR REPLACE FUNCTION VALOR_FECP_ITEM_NFE(
   P_CDFILIAL     IN ITEMPRODUTO.CDFILIAL%TYPE,
   P_NRLANCTONF   IN ITEMPRODUTO.NRLANCTONF%TYPE,
   P_NRSEQITPROD  IN ITEMPRODUTO.NRSEQITPROD%TYPE,
   P_CDIMPOSTO    IN IMPOSTO.CDIMPOSTO%TYPE,
   P_IDVALOR      IN ITEMPROIMPOS.IDVALORINFIT%TYPE,
   P_CDFISCAL     IN ITEMPROIMPOS.CDFISCALIT%TYPE DEFAULT NULL,
   P_NRITPROIMPOS IN ITEMPROIMPOS.NRITPROIMPOS%TYPE DEFAULT '1') RETURN NUMBER

AS
   V_VRADICALIQFECP   ITEMPROIMPOS.VRADICALIQFECP%TYPE;
   V_VRADICFECP       ITEMPROIMPOS.VRADICFECP%TYPE;
BEGIN
   SELECT NVL(MAX(I.VRADICALIQFECP),0),
          NVL(SUM(I.VRADICFECP),0)
   INTO   V_VRADICALIQFECP,
          V_VRADICFECP
     FROM ITEMPROIMPOS I, IMPOSTO P
    WHERE I.CDFILIAL     = P_CDFILIAL     AND
          I.NRLANCTONF   = P_NRLANCTONF   AND
          I.NRSEQITPROD  = P_NRSEQITPROD  AND
          I.CDIMPOSTO    = P.CDIMPOSTO    AND
          P.CDIMPOSTONFE = P_CDIMPOSTO    AND
          I.NRITPROIMPOS = P_NRITPROIMPOS AND
          I.CDFISCALIT   = NVL(P_CDFISCAL, I.CDFISCALIT);
   IF P_IDVALOR = 'A' THEN
      RETURN(V_VRADICALIQFECP);
   ELSIF P_IDVALOR = 'I' THEN
      RETURN(V_VRADICFECP);
   END IF;
END;
/

CREATE OR replace FUNCTION VALOR_FECP_NFE(
   P_CDFILIAL       IN ITEMPRODUTO.CDFILIAL%TYPE,
   P_NRLANCTONF     IN ITEMPRODUTO.NRLANCTONF%TYPE,
   P_CDIMPOSTONFE   IN IMPOSTO.CDIMPOSTO%TYPE,
   P_IDVALOR        IN ITEMPROIMPOS.IDVALORINFIT%TYPE,
   P_CDFISCAL       IN ITEMPROIMPOS.CDFISCALIT%TYPE DEFAULT NULL) RETURN NUMBER
AS
   V_VRADICALIQFECP   ITEMPROIMPOS.VRADICALIQFECP%TYPE;
   V_VRADICFECP       ITEMPROIMPOS.VRADICFECP%TYPE;
BEGIN
   SELECT NVL(MAX(VRADICALIQFECP),0),
          NVL(SUM(VRADICFECP),0)
   INTO   V_VRADICALIQFECP,
          V_VRADICFECP
   FROM ITEMPROIMPOS IT, IMPOSTO IP
   WHERE (CDFILIAL     = P_CDFILIAL    ) AND
         (NRLANCTONF   = P_NRLANCTONF  ) AND
         (CDIMPOSTONFE = P_CDIMPOSTONFE) AND
         (NRITPROIMPOS = '1'           ) AND
         (IT.CDIMPOSTO = IP.CDIMPOSTO  ) AND
         (CDFISCALIT = NVL(P_CDFISCAL, CDFISCALIT));
   IF P_IDVALOR = 'A' THEN
      RETURN(V_VRADICALIQFECP);
   ELSIF P_IDVALOR = 'I' THEN
      RETURN(V_VRADICFECP);
   END IF;
END;
/

CREATE OR REPLACE PROCEDURE GERA_GUIA_ICMS_ST(
   P_NRSEQUMAPAPU IN MAPAAPURAC.NRSEQUMAPAPU%TYPE,
   P_IDTIPOAPURA  IN MAPAAPURAC.IDBLOQMAPAPU%TYPE DEFAULT 'D')
AS
   V_VRIMPORECO    NUMBER;
   V_VRSALDCRED    NUMBER;
   V_NRSEQMAPAEST  NUMBER;
   V_SGESTADO      VARCHAR2(02);
   V_VRTOTADEBI    NUMBER;
   V_VRTOTACRED    NUMBER;
BEGIN

   /******** Deleta os registros na tabela, devido a regeração da guia ********/
   DELETE FROM MAPAAPURESTADO
    WHERE NRSEQUMAPAPU = P_NRSEQUMAPAPU;

   V_VRIMPORECO := 0;
   V_VRSALDCRED := 0;
   V_SGESTADO   := '';
   V_VRTOTADEBI := 0;
   V_VRTOTACRED := 0;

   /******** Busca os valores para geração da Guia por Estado - Para o Mobile (P_IDTIPOAPURA = M) as informações são
             quebradas por inscrição do substituto tributário também, no Delphi (P_IDTIPOAPURA = D) apenas por estado ********/
   FOR C_DADOS IN (SELECT REG.CDPAIS, REG.SGESTADO, DECODE(P_IDTIPOAPURA,'D','','M',REG.CDINSCESTAST) AS CDINSCESTAST,
                          SUM(DECODE(REG.IDENTRSAIDOP,'S',ROUND(VRCONTABILNF,2),0)) AS VRCTBLDEB,
                          SUM(DECODE(REG.IDENTRSAIDOP,'S',ROUND(VRBASECALC,2),0)) AS VRBASECALCDEB,
                          SUM(DECODE(REG.IDENTRSAIDOP,'E',ROUND(VRCONTABILNF,2),0)) AS VRCTBLCRED,
                          SUM(DECODE(REG.IDENTRSAIDOP,'E',ROUND(VRBASECALC,2),0)) AS VRBASECALCCRED,
                          SUM(DECODE(REG.IDENTRSAIDOP,'S',ROUND(VRIMPOSTONF,2),0)+ VALOR_FECP_NFE(REG.CDFILIAL, REG.NRLANCTONF,'80','I','1')) AS VRDEBITO,
                          SUM(DECODE(E.IDREGIMEICMSST,'1',DECODE(REG.IDENTRSAIDOP,'E',ROUND(VRCREDITO,  2),0),0)) AS VRCREDITO,
                          SUM(DECODE(E.IDREGIMEICMSST,'1',DECODE(REG.IDENTRSAIDOP,'E',ROUND(VRDEVMAPA,  2),0),0)) AS VRDEVMAPA,
                          SUM(DECODE(E.IDREGIMEICMSST,'1',DECODE(REG.IDENTRSAIDOP,'E',ROUND(VRRESSAMAPA,2),0),0)) AS VRRESSAMAPA
                     FROM EMPRESA E,
                          (SELECT DECODE(NF.IDORIGDESTNF,'L',EL.CDPAIS,  'C',EC.CDPAIS,  'F',EF.CDPAIS)   AS CDPAIS,
                                  DECODE(NF.IDORIGDESTNF,'L',EL.SGESTADO,'C',EC.SGESTADO,'F',EF.SGESTADO) AS SGESTADO,
                                  NF.IDENTRSAIDOP, NF.CDEMPRESA, NF.CDINSCESTAST,  SUM(IP.VRCONTABILNF) AS VRCONTABILNF,
                                  SUM(DECODE(IP.CDFISCALNF,'1',IP.VRBASECALCNF,0)) AS VRBASECALC,
                                  SUM(CASE WHEN CDFISCOPERNF NOT IN ('1410','1411','1414','1415','1660','1661','1662','2410','2411','2414','2415','2660','2661','2662','1603','2603')
                                       THEN DECODE(IP.CDFISCALNF,'1',IP.VRIMPOSTONF,0) ELSE 0 END) AS VRCREDITO,
                                  SUM(CASE WHEN CDFISCOPERNF NOT IN ('1401','1406','1407','1410','1411','1414','1415','1660','1661','1662','2401','2406','2407','2410','2411','2414','2415','2660','2661','2662')
                                       THEN DECODE(IP.CDFISCALNF,'1',IP.VRIMPOSTONF,0) ELSE 0 END) AS VRIMPOSTONF,
                                  SUM(CASE WHEN CDFISCOPERNF IN ('1410','1411','1414','1415','1660','1661','1662','2410','2411','2414','2415','2660','2661','2662')
                                       THEN DECODE(IP.CDFISCALNF,'1',IP.VRIMPOSTONF,0) ELSE 0 END) AS VRDEVMAPA,
                                  SUM(CASE WHEN CDFISCOPERNF IN ('1603', '2603')
                                       THEN DECODE(IP.CDFISCALNF,'1',IP.VRIMPOSTONF,0) ELSE 0 END) AS VRRESSAMAPA,
                                  NF.NRLANCTONF, NF.CDFILIAL
                             FROM IMPOSTONF IP, NOTAFISCAL NF, ENDECLIE EC, ENDEFORN EF, ENDEFILI EL
                            WHERE IP.NRSEQUMAPAPU    = P_NRSEQUMAPAPU
                              AND NF.CDFILIAL        = IP.CDFILIAL
                              AND NF.NRLANCTONF      = IP.NRLANCTONF
                              AND EC.CDCLIENTE(+)    = NF.CDCLIENTE
                              AND EC.IDTPENDECLIE(+) = 'P'
                              AND EF.CDFORNECED(+)   = NF.CDFORNECED
                              AND EF.IDTPENDEFORN(+) = 'P'
                              AND EL.CDFILIAL(+)     = DECODE(NF.IDENTRSAIDOP,'E',NF.CDFILIEMIT,NF.CDFILIRECE)
                              AND EL.IDTPENDEFILI(+) = 'P'
                            GROUP BY DECODE(NF.IDORIGDESTNF,'L',EL.CDPAIS,  'C',EC.CDPAIS,  'F',EF.CDPAIS),
                                  DECODE(NF.IDORIGDESTNF,'L',EL.SGESTADO,'C',EC.SGESTADO,'F',EF.SGESTADO),
                                  NF.IDENTRSAIDOP, NF.CDEMPRESA, NF.CDINSCESTAST, NF.NRLANCTONF, NF.CDFILIAL) REG
                    WHERE E.CDEMPRESA    = REG.CDEMPRESA
                    GROUP BY REG.CDPAIS, REG.SGESTADO, DECODE(P_IDTIPOAPURA,'D','','M',REG.CDINSCESTAST)
                    ORDER BY REG.SGESTADO) LOOP

      V_VRTOTADEBI := NVL(C_DADOS.VRDEBITO,0);
      V_VRTOTACRED := NVL(C_DADOS.VRCREDITO,0) + NVL(C_DADOS.VRRESSAMAPA,0) + NVL(C_DADOS.VRDEVMAPA,0);

      V_VRIMPORECO := NVL(V_VRTOTADEBI,0) - NVL(V_VRTOTACRED,0);

      IF V_VRIMPORECO < 0 THEN
         V_VRSALDCRED := ABS(V_VRIMPORECO);
         V_VRIMPORECO := 0;
      ELSE
         V_VRSALDCRED := 0;
      END IF;

      IF NVL(V_SGESTADO,' ') <> C_DADOS.SGESTADO THEN
         V_NRSEQMAPAEST := 1;
      END IF;

      /******** Insere o item ********/
      INSERT INTO MAPAAPURESTADO
         (NRSEQUMAPAPU, NRSEQMAPAAPUREST, CDPAIS, SGESTADO, CDINSCESTAST, CDRECESUBTRIB, DTVENCSUBTRIB,
          VRCTBLDEB, VRBASECALCDEB, VRDEBITONORMAL, VROUTROSDEBITOS, VRTOTADEBI,
          VRCTBLCRED, VRBASECALCCRED, VRCREDITONORMAL, VRDEVMAPA, VRRESSAMAPA, VROUTROSCREDITOS, VRTOTACRED,
          VRCREDANTERIOR, VRIMPARECOLHER, VRSALDOCREDOR)
      VALUES
         (P_NRSEQUMAPAPU, V_NRSEQMAPAEST, C_DADOS.CDPAIS, C_DADOS.SGESTADO, C_DADOS.CDINSCESTAST, '', '',
          C_DADOS.VRCTBLDEB, C_DADOS.VRBASECALCDEB, C_DADOS.VRDEBITO, 0, V_VRTOTADEBI,
          C_DADOS.VRCTBLCRED, C_DADOS.VRBASECALCCRED, C_DADOS.VRCREDITO, C_DADOS.VRDEVMAPA, C_DADOS.VRRESSAMAPA, 0, V_VRTOTACRED,
          0, V_VRIMPORECO, V_VRSALDCRED);

      V_SGESTADO     := C_DADOS.SGESTADO;
      V_NRSEQMAPAEST := V_NRSEQMAPAEST + 1;

   END LOOP;

   /******** Para os estados que o cliente possui inscrição do Substituto Tributário deve ser informada apuração,
             mesmo que não haja movimento ********/
   FOR C_INSCR IN (SELECT IE.CDPAIS, IE.SGESTADO, IE.CDINSCESTAST
                     FROM MAPAAPURAC MP, INSCRESTADST IE
                    WHERE MP.NRSEQUMAPAPU = P_NRSEQUMAPAPU
                      AND MP.CDEMPRESA    = IE.CDEMPRESA
                      AND MP.CDINSCESTA   = IE.CDINSCESTA
                      AND NOT EXISTS (SELECT CDPAIS, SGESTADO
                                           FROM MAPAAPURESTADO M
                                          WHERE M.CDPAIS       = IE.CDPAIS
                                            AND M.SGESTADO     = IE.SGESTADO
                                            AND M.NRSEQUMAPAPU = P_NRSEQUMAPAPU)) LOOP
      /******** Insere o item ********/
      INSERT INTO MAPAAPURESTADO
         (NRSEQUMAPAPU, NRSEQMAPAAPUREST, CDPAIS, SGESTADO, CDINSCESTAST, CDRECESUBTRIB, DTVENCSUBTRIB,
          VRCTBLDEB, VRBASECALCDEB, VRDEBITONORMAL, VROUTROSDEBITOS, VRTOTADEBI,
          VRCTBLCRED, VRBASECALCCRED, VRCREDITONORMAL, VRDEVMAPA, VRRESSAMAPA, VROUTROSCREDITOS, VRTOTACRED,
          VRCREDANTERIOR, VRIMPARECOLHER, VRSALDOCREDOR)
      VALUES
         (P_NRSEQUMAPAPU, 1, C_INSCR.CDPAIS, C_INSCR.SGESTADO, C_INSCR.CDINSCESTAST,
          '', '', 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0);

   END LOOP;

   /******** Para o estado da inscrição estadual do cliente deve ser informada apuração, mesmo que não haja movimento ********/
   FOR C_IE IN (SELECT IE.CDPAIS, IE.SGESTADO
                  FROM MAPAAPURAC MP, INSCRESTAD IE
                 WHERE MP.NRSEQUMAPAPU = P_NRSEQUMAPAPU
                   AND MP.CDEMPRESA    = IE.CDEMPRESA
                   AND MP.CDINSCESTA   = IE.CDINSCESTA
                   AND NOT EXISTS (SELECT M.CDPAIS, M.SGESTADO
                                     FROM MAPAAPURESTADO M
                                    WHERE M.CDPAIS       = IE.CDPAIS
                                      AND M.SGESTADO     = IE.SGESTADO
                                      AND M.NRSEQUMAPAPU = P_NRSEQUMAPAPU)) LOOP
      /******** Insere o item ********/
      INSERT INTO MAPAAPURESTADO
         (NRSEQUMAPAPU, NRSEQMAPAAPUREST, CDPAIS, SGESTADO, CDINSCESTAST, CDRECESUBTRIB, DTVENCSUBTRIB,
          VRCTBLDEB, VRBASECALCDEB, VRDEBITONORMAL, VROUTROSDEBITOS, VRTOTADEBI,
          VRCTBLCRED, VRBASECALCCRED, VRCREDITONORMAL, VRDEVMAPA, VRRESSAMAPA, VROUTROSCREDITOS, VRTOTACRED,
          VRCREDANTERIOR, VRIMPARECOLHER, VRSALDOCREDOR)
      VALUES
         (P_NRSEQUMAPAPU, 1, C_IE.CDPAIS, C_IE.SGESTADO, '',
          '', '', 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0);
   END LOOP;

   /******** Apaga o detalhamento por UF dos Estados que deixaram de existir após uma nova apuração do Mapa ********/
   DELETE FROM DETAUFMAPAEST
    WHERE NOT NRSEQUMAPAPU||CDPAIS||SGESTADO IN (SELECT NRSEQUMAPAPU||CDPAIS||SGESTADO
                                                   FROM MAPAAPURESTADO
                                                  WHERE NRSEQUMAPAPU = P_NRSEQUMAPAPU)
      AND NRSEQUMAPAPU = P_NRSEQUMAPAPU;
END;
/

CREATE OR REPLACE PROCEDURE IMPOSTO_SAIDA(
   P_EMPRESA    IN ALIQUOTA.CDEMPRESA%TYPE,
   P_INSCESTA   IN ALIQUOTA.CDINSCESTA%TYPE,
   P_TIPOOPER   IN INCIDENCIA.CDTIPOOPER%TYPE,
   P_CLIENTE    IN CLIENTE.CDCLIENTE%TYPE,
   P_FILIAL     IN NOTAFISCAL.CDFILIAL%TYPE,
   P_LANCTONF   IN NOTAFISCAL.NRLANCTONF%TYPE,
   P_INIVALID   IN ALIQUOTA.DTINIVALID%TYPE,
   P_VRNOTAFISC OUT NUMBER,
   P_LANCESTQ   IN LANCTOESTOQ.NRLANCESTQ%TYPE DEFAULT NULL,
   P_CDOPERADOR IN LANCTOESTOQ.CDOPERADOR%TYPE DEFAULT NULL)

IS
   V_TESTE          VARCHAR2(50);
   V_IDTRATIMPO     VARCHAR2(01);
   V_PAISORIG       VARCHAR2(04); -- Pais de origem (utiliza UF de Origem)
   V_ESTAORIG       VARCHAR2(02); -- Estado de origem (utiliza UF de Origem)
   V_MUNIORIG       VARCHAR2(04); -- Municipio de origem (utiliza municipio)
   V_PAISDEST       VARCHAR2(04);
   V_ESTADEST       VARCHAR2(02);
   V_MUNIDEST       VARCHAR2(04);
   V_IDUTMUNIORIG   VARCHAR2(04);
   V_PAISCFOP       VARCHAR2(04);
   V_ESTACFOP       VARCHAR2(02);
   V_CDPAISST       VARCHAR2(04);
   V_SGESTADOST     VARCHAR2(02);
   V_CDMUNICIPIOST  VARCHAR2(04);
   V_CDINSCESTAST   VARCHAR2(16);
   V_ALIQTEMP       VARCHAR2(14);
   V_NRALIQTEMP     VARCHAR2(14);
   V_DADOADIC       VARCHAR2(03);
   V_INCITEMP       VARCHAR2(14);
   V_CST1DIGT       VARCHAR2(1);
   V_CSTTEMP        VARCHAR2(14);
   V_FISCALIT       VARCHAR2(20);
   V_CFOPTEMP       VARCHAR2(14);
   V_FISOPEITEM     VARCHAR2(11);
   V_SUFXCFOPPR     VARCHAR2(03);
   V_SITUTRIBPR     VARCHAR2(03);
   V_NRINSJURNF     VARCHAR2(20);
   V_SERIE          VARCHAR2(05);
   V_TIPOMOVI       VARCHAR2(01);
   V_CDFISCOPER     VARCHAR2(11);
   V_CDFILIEMIT     VARCHAR2(04);
   V_CDFILIRECE     VARCHAR2(04);
   V_ORIGDESTOP     VARCHAR2(01);
   V_CDFISOPENTF    VARCHAR2(11);
   V_IDENDCFOP      VARCHAR2(01);
   V_IDENDEMIS      VARCHAR2(01);
   V_CDEMPRESA      VARCHAR2(02);
   V_CDINSCESTA     VARCHAR2(16);
   V_CDINTEGRACAO   VARCHAR2(16);
   V_IDORIGDESTNF   VARCHAR2(01);
   V_NRLANBOLREC    VARCHAR2(10);
   V_IDDOCFINANC    VARCHAR2(01);
   V_IDERROAVISO    VARCHAR2(01);
   V_IDDOCREPLIC    VARCHAR2(14);
   V_IDDOCESTOQ     VARCHAR2(14);
   V_IDSISTEMA      VARCHAR2(03);
   V_IDRETPROEXP    VARCHAR2(01);
   V_IDATUEST       VARCHAR2(01);
   V_NMTIPOOPER     VARCHAR2(30);
   V_NMFILIRECE     VARCHAR2(60);
   V_DESCLANC       VARCHAR2(60);
   V_CDFISCTEMP     VARCHAR2(01);
   V_CDDETALHEPRODTEMP VARCHAR2(05);
   V_TRATIMPST      VARCHAR2(01);
   V_IDTRIMPSTII    VARCHAR2(01);
   V_CDIMPOSTRIB    VARCHAR2(250);
   V_CDIMPOSICMS    VARCHAR2(250);
   V_IDCTRLESTQ     VARCHAR2(01);
   V_CDFILIAPFATU   VARCHAR2(04);
   V_NRAPFATUTNF    VARCHAR2(10);
   V_IDITEMISSAO    VARCHAR2(01);
   V_CDIMPOBCALC    VARCHAR2(02);
   V_IDIMPOSTONF    VARCHAR2(01);
   V_IDVRIMPSTRIB   VARCHAR2(01);
   V_IDDEVOLIST     VARCHAR2(01);
   V_IDUTILALMOX    VARCHAR2(01);
   V_IDUTILLCESTQ   VARCHAR2(01);
   V_IDUTILLOTE     VARCHAR2(01);
   V_IDPMCBASECAL   VARCHAR2(01);
   V_IDTPCOMPPROD   VARCHAR2(01);
   V_NRINSJURCLIE   VARCHAR2(20);
   V_UTIBB          VARCHAR2(01);

   V_CDSITTRIBTMP    CODSITUTRIBNFE.CDSITUTRIBNFE%TYPE;
   V_IDMODBCNFE      CODSITUTRIBNFE.IDMODBCNFE%TYPE;
   V_IDMOTIDESSTNFE  CODSITUTRIBNFE.IDMOTIDESSTNFE%TYPE;
   V_IDMODBCSTNFE    CODSITUTRIBNFE.IDMODBCSTNFE%TYPE;
   V_CDTPCRPICOSTNFE CODSITUTRIBNFE.CDTPCRPICOSTNFE%TYPE;
   V_CDNATUBCPCSTNFE CODSITUTRIBNFE.CDNATUBCPCSTNFE%TYPE;

   V_CDSITUTRIBNFE     CODSITUTRIBNFE.CDSITUTRIBNFE%TYPE;
   V_IDMODBCNFEIT      CODSITUTRIBNFE.IDMODBCNFE%TYPE;
   V_IDMODBCSTNFEIT    CODSITUTRIBNFE.IDMODBCSTNFE%TYPE;
   V_CDTPCRPICOSTNFEIT CODSITUTRIBNFE.CDTPCRPICOSTNFE%TYPE;
   V_CDNATUBCPCSTNFEIT CODSITUTRIBNFE.CDNATUBCPCSTNFE%TYPE;

   V_IDINTEREST   VARCHAR2(01);
   V_IDCONSPARFIS VARCHAR2(01);
   V_CDFISCOPERSN ITEMPRODUTO.CDFISCOPERSN%TYPE;
   V_IDINTERNA VARCHAR2(01);
   V_PARDEDTMP    NUMBER;
   V_PREDBCTMP    NUMBER;
   V_ALIQUTMP     NUMBER;
   V_COUNT        NUMBER;
   V_ERROAVISO    NUMBER;
   V_LIQUIITEM    NUMBER;
   V_TOTALNOTA    NUMBER;
   V_LIQUIDO      NUMBER;
   V_SOMAENCA     NUMBER;
   V_MENOENCA     NUMBER;
   V_SOMAIMPO     NUMBER;
   V_MENOIMPO     NUMBER;
   V_TOTAPRODENCA NUMBER;
   V_TOTAPRENIMPO NUMBER;
   V_TOTAIMPBCALC NUMBER;
   V_TOTAIMPBCDES NUMBER;
   V_TAXABASECALC NUMBER;
   V_TAXABCSUBSTR NUMBER;
   V_TAXAALIQUOTA NUMBER;
   V_PRODUENCARGO NUMBER;
   V_SEQUIMPOSTNF NUMBER;
   V_SOMAITEM     NUMBER;
   V_DESCITEM     NUMBER;
   V_BASECALCIT   NUMBER;
   V_BASECALCTO   NUMBER;
   V_BASECALCIRRF NUMBER;
   V_PBCSUBTRIB   NUMBER;
   V_IMPOSTOIT    NUMBER;
   V_VRIMPOSTO    NUMBER;
   V_FATOCONV     NUMBER;
   V_TOTABRUT     NUMBER;
   V_SOMAIMPONF   NUMBER;
   V_DESCIMPONF   NUMBER;
   V_QTDELANCTO   NUMBER;
   V_VRUNITLANCTO NUMBER;
   V_VRTOTALANCTO NUMBER;
   V_TOTACONTAB   NUMBER;
   V_VRBRUTO      NUMBER;
   V_VRCONTAB     NUMBER;
   V_IMPOCONTAB   NUMBER;
   V_TOTIMPOCONT  NUMBER;
   V_TOTIMPOBRUT  NUMBER;
   V_CONTIMPO     NUMBER;
   V_IMPOSRETI    NUMBER;
   V_CONTABCALC   NUMBER;
   V_PERDBCALC    NUMBER;
   V_FAIXATOLER   NUMBER;
   V_NRDECITOTANF NUMBER;
   V_IMPOSINFUSU  NUMBER;
   V_VRCONTAREC   NUMBER;
   V_VRDIFERENCA  NUMBER;
   V_EXISTE_ROT   NUMBER;
   V_NRSEQITPROD  NUMBER;
   V_VRFATOCONV   NUMBER;
   V_VRLIQUORIG   NUMBER;
   V_VRPESOBRUTO  NUMBER;
   V_VRIMPOSTOST  NUMBER;
   V_VRREDUCAO    NUMBER;
   V_VALOR        NUMBER;
   V_VRTOTAITEM   NUMBER;
   V_SOMATOTAITEM NUMBER;
   V_PERCENTITEM  NUMBER;
   V_SOMAQITEMPROD  NUMBER;
   V_SOMAVRBRUTITEM NUMBER;
   V_SOMAVRCONTITEM NUMBER;

   V_CDGRUPOFISC  VARCHAR2(03);
   V_CDGRPFISCSV  VARCHAR2(03);
   V_UTGRUPFISCS  VARCHAR2(01);
   V_CDORIGDESTNF VARCHAR2(21);

   V_IDOPERDEVONF VARCHAR2(01);
   V_CHAVE        VARCHAR2(21);
   V_IMPOSTO      VARCHAR2(02);
   V_IDRECALCULO  VARCHAR2(01);
   V_CDFILIMOVI   VARCHAR2(04);
   V_CDTIPOOPER   VARCHAR2(02);

   V_CDENCDESCBONDEV VARCHAR2(02);
   V_CDAJUCTPAG   VARCHAR2(04);
   V_VRPEDESCFORN FLOAT;
   V_VRENCARBONI  FLOAT;
   V_IDCONDESBONFORN VARCHAR2(01);
   V_DTINIVRPDESC DATE;
   V_IMPOSDESONERA NUMBER;
   V_DIFERENCA     FLOAT;
   V_VRFRETEITEM   FLOAT;
   V_VRSEGURITEM   FLOAT;
   V_VRENCARGODESC FLOAT;
   V_SUMVRDESCITEM FLOAT;
   V_VROUTRASDESPITEM FLOAT;
   V_VRDESPADUANEIRA  FLOAT;

   V_DSCDFISOPEIT VARCHAR2(450);
   V_DTVINGENTE   DATE;
   V_DTINIREFEFAT DATE;

   V_ICMS         VARCHAR2(01);
   V_IMPOICMS     VARCHAR2(02);

   V_CDSITUCRT         VARCHAR2(01);
   V_CDSIMPLESNACIONAL VARCHAR2(5);
   V_RBT12             FLOAT; --RECEITA BRUTA TOTAL DOS ÚLTIMOS 12 MESES
   V_RBA               FLOAT; --RECEITA BRUTA ACUMULADA
   V_VRSUBLIMITESN     FLOAT;
   V_VRALIQSIMPLES     FLOAT;
   V_APROVICMS         FLOAT;
   V_ALIQAPROVICMS     FLOAT;
   V_SIMPLES           VARCHAR2(01);
   V_CDFAIXA           VARCHAR2(5);
   V_ESTORNOCANC       VARCHAR2(01);

   /*Alíquota do imposto que possui diferencial de alíquota*/
   V_DIFALIQ           FLOAT;

   V_CDFISCOPERREGRA     VARCHAR2(10);
   V_DSCDFISOPEITREGRA   VARCHAR2(50);
   V_IDDIFEALIQREGRA     VARCHAR2(10);
   V_IDDIFALIQCUSPRREGRA VARCHAR2(10);
   V_CFOPINFUSU          VARCHAR2(01);
   V_CFOP1DIGT           VARCHAR2(01);

   w_A            CHAR(1):= 'A';
   w_C            CHAR(1):= 'C';
   w_D            CHAR(1):= 'D';
   w_N            CHAR(1):= 'N';
   w_S            CHAR(1):= 'S';
   w_R            CHAR(1):= 'R';
   w_P            CHAR(1):= 'P';
   w_I            CHAR(1):= 'I';
   w_L            CHAR(1):= 'L';
   w_V            CHAR(1):= 'V';
   w_O            CHAR(1):= 'O';
   w_F            CHAR(1):= 'F';
   w_U            CHAR(1):= 'U';
   w_0            CHAR(1):= '0';
   w_1            CHAR(1):= '1';
   w_2            CHAR(1):= '2';
   w_3            CHAR(1):= '3';
   w_4            CHAR(1):= '4';
   w_5            CHAR(1):= '5';
   w_8            CHAR(1):= '8';
   w_9            CHAR(1):= '9';
   w_01           CHAR(2):= '01';
   w_03           CHAR(2):= '03';
   w_09           CHAR(2):= '09';
   w_11           CHAR(2):= '11';
   w_12           CHAR(2):= '12';
   w_90           CHAR(2):= '90';
   w_000          CHAR(3):= '000';
   w_001          CHAR(3):= '001';
   w_101          CHAR(3):= '101';
   w_00000        CHAR(5):= '00000';
   w_VMN          CHAR(3):= 'VMN';
   w_EXP          CHAR(3):= 'EXP';
   w_VND          CHAR(3):= 'VND';
   w_Av04         CHAR(4):= 'AV04';
   w_Av05         CHAR(4):= 'AV05';
   w_Av06         CHAR(4):= 'AV06';
   w_Av09         CHAR(4):= 'AV09';
   w_Av10         CHAR(4):= 'AV10';
   w_Er03         CHAR(4):= 'ER03';
   w_Er04         CHAR(4):= 'ER04';
   w_Er06         CHAR(4):= 'ER06';

   V_IDIMPOBCALTPOP  VARCHAR2(01);
   V_IDIMBCALTPOPDE  VARCHAR2(01);
   V_QTITEMPROD      FLOAT;
   V_CDIMPOSTO       VARCHAR2(02);
   V_IDUTCTRLLOTE    VARCHAR2(01);
   V_MEDIA           NUMBER;
   V_BCICMSSTRETIDO  FLOAT;
   V_VRICMSSTRETIDO  FLOAT;
   V_NRLOTEESTQ      VARCHAR2(20);
   V_EXISTDSDADOSADIC  INTEGER;
   V_BCICMSRET       FLOAT;
   V_ICMSRET         FLOAT;
   V_IDCALCPESONF    VARCHAR2(01);
   V_IDUTDESCICMS    VARCHAR2(01);

   V_CDREGRAITALIQ    VARCHAR2(10);
   V_CARGA            FLOAT;
   V_CDIMPOSRECALC    VARCHAR2(200);
   V_CDCFOPINFUSU     VARCHAR2(11);
   V_DSCFOPINFUSU     VARCHAR2(50);

   V_IDUTVLRQTDEIMPO  VARCHAR2(01);
   V_VRFATOCONVES     FLOAT;
   V_DTENTRSAID       DATE;
   V_CDIMPOSTOI       VARCHAR2(02);
   V_CDPRODUTO        VARCHAR2(10);
   V_VRIMPOSTOVISUIT  FLOAT;
   V_IDALTERADO_ENCA  VARCHAR2(01);
   V_CDGRUPOFISCAUX   VARCHAR2(03);

   V_CDIMPOSIPI        VARCHAR2(02);
   V_IDGERIPIDESPA     VARCHAR2(01);
   V_IDGERICMSTDESPA   VARCHAR2(01);
   V_VRTOTALIPI        FLOAT;
   V_CDENCARGOOD       VARCHAR2(02);
   V_VRTOTALICMSST     FLOAT;
   V_CDENCARGOICMST    VARCHAR2(02);
   V_IDPEINFICMSTDEME  VARCHAR2(01);
   V_VRENCAICMSSTIT    FLOAT;
   V_VRICMSST          FLOAT;
   V_VRBASECALC        FLOAT;
   V_SOMAVRNOTAFISC    FLOAT;
   V_IDUTCTRLFISSAID   VARCHAR2(01);
   V_IDUTCTRLFISFIL    VARCHAR2(01);
   V_IDUTCTRLFIS       VARCHAR2(01);
   V_IDPERVISIMPSCRE   VARCHAR2(01);

   V_VRIMPOSST         FLOAT;
   V_VRADICFECPST      FLOAT;
   V_VRADICFECPSTAUX   FLOAT;
   V_DIFEVRBRUTO       FLOAT;

   V_VRPERDIFERE       FLOAT;
   V_PERDIFERE         FLOAT;
   V_IMPOSTOOPERA      FLOAT;
   V_IMPOSTODIFER      FLOAT;

   V_IDCONTCONFORIG    VARCHAR2(01);
   V_IDDESCIMPRECCONT  VARCHAR2(01);
   V_IDIMPORECUP       VARCHAR2(01);
   V_CDCCTBLATIV       VARCHAR2(20);
   V_IDATUESTTPOP      TIPOOPERAC.IDATUESTTPOP%TYPE;
   V_IDREMESSAINDU     TIPOOPERAC.IDREMESSAINDU%TYPE;
   V_CDALMOXINFO       AGENTETERCECLI.CDALMOXINFOCLI%TYPE;
   V_CDLOCALINFO       AGENTETERCECLI.CDLOCALINFOCLI%TYPE;
   V_CDFILIALENTR      CTRLMOVIESTQ.CDFILIALENTR%TYPE;
   V_NRLANESTENTR      NOVOCODIGO.NRSEQUENCIAL%TYPE;
   V_NRCTRLMOVEST      NOVOCODIGO.NRSEQUENCIAL%TYPE;
   V_BOLANESTENTR      BOOLEAN := TRUE;
   V_DSENDEDEVOEMBA    VARCHAR2(255);
   V_CDENQLEGALIPI     VARCHAR2(03);
   V_CDCEST            VARCHAR2(09);
   /* variáveis para geração de entrada no estoque (filial agente de terceiração */
   V_CDFILIAGENT       VARCHAR2(04);
   V_BOLANESTENTRAG    BOOLEAN := TRUE;
   V_NRLANESTENTRAG    NOVOCODIGO.NRSEQUENCIAL%TYPE;
   V_CDALMOXARIFEAG    ALMOXARIFADO.CDALMOXARIFE%TYPE;
   V_CDLOCALESTOQAG    LOCALESTOQUE.CDLOCALESTOQ%TYPE;
   V_IDUTILLOTEAG      VARCHAR2(01);
   V_NRLOTEESTQAG      VARCHAR2(20);
   V_NRSUBLOTEAG       VARCHAR2(04);
   V_NRLANCTONFAG      VARCHAR2(20);
   V_IDTPIJURNF        VARCHAR2(01);
   V_CDEMPRESAAG       VARCHAR2(02);
   V_CDINSCESTAAG      VARCHAR2(16);
   V_CDINSCMUNIAG      VARCHAR2(16);
   V_CDFILIORIG        VARCHAR2(04);
   V_TPOPERRETORNO     VARCHAR2(02);

   V_IDUTORIGPROD       VARCHAR2(01);
   V_VRPRODUTOBC       FLOAT;
   V_VRALIQUTMPDEST    VARCHAR2(14);
   V_CDIMPOSTOICMS     VARCHAR2(02);
   V_VRIMPOSTOICMS     FLOAT;
   V_VRBASECALCICMS    FLOAT;
   V_IDIMPSTCARGTRIB   VARCHAR2(01);

   V_VRIMPOSTOOPERAIT  FLOAT;
   V_VRPERDIFEREIT     FLOAT;
   V_VRIMPOSTODIFERIT  FLOAT;

   V_CDPAISFCT      VARCHAR2(04);
   V_SGESTADOFCT    VARCHAR2(02);
   V_CDMUNICIPIOFCT VARCHAR2(04);
   V_QTDREGFCT      FLOAT;

   V_IDPRESENCIAL      VARCHAR2(01);

   V_IDUTILPVRIMPBC    VARCHAR2(01);
   V_VRADICALIQFECP    FLOAT(126);
   V_VRADICFECP        FLOAT(126);
   V_IDCONSFINAL       VARCHAR2(01);
   V_STRVRADICALIQFECP VARCHAR2(15);
   V_STRVRADICFECP     VARCHAR2(15);

   V_NRINSESTDESNF     VARCHAR2(20);
   V_IDCONTRIBICMS     VARCHAR2(01);
   V_IDCONTRIBICMSAUX  VARCHAR2(01);

   V_ALIQICMSDEST      FLOAT;
   V_ALIQFECPDEST      FLOAT;
   V_CDIMPOSTOFECP     VARCHAR2(02);

   V_IDDIFECLI         VARCHAR2(01);
   V_CDFILIALPED       VARCHAR2(04);
   V_NRPEDIDO          VARCHAR2(10);
   V_DADOSADICENDPED   VARCHAR2(400);
   V_IDPRODPERIG       VARCHAR2(01);
   V_MSGPRODPERIG      VARCHAR2(500);
   V_GRAVAMSGPRODPERIG INTEGER;
   V_IDCALCDIFALDENT   VARCHAR2(01);
   V_NRREGISTROANP     VARCHAR2(10);
   V_DSREGISTROANP     VARCHAR2(255);
   V_IDUTILVENC        VARCHAR2(01);
   V_IDNOTADEVO        VARCHAR2(01);
   V_IDNFAJUSTE        VARCHAR2(01);
   V_IDVERLEIAUTENFE   VARCHAR2(04);
   V_MAJORAOUREDUZ     VARCHAR2(01);

   /* Variáveis para geração dos encargos de acordo com os impostos relacionados na nota fiscal de origem(importação de XML) */
   V_VRENCARGOIMPXML NUMBER;
   V_VRIMPENCXMLORIG NUMBER;
   V_UPDENCIMPXML    VARCHAR2(01);
   V_NRSEQITORIG     VARCHAR2(04);
   V_NRACESSONFORIG  VARCHAR2(44);
   V_IDNFORIGVIAXML  VARCHAR2(01);

   V_VRIMPORETNF     FLOAT;
   V_VRIMPORELAC     FLOAT;

   V_IDOPTANTESNCLIE VARCHAR2(01);
   V_CDCNAECLIE      VARCHAR2(07);
   V_VRMVA           FLOAT;

   V_IDENDEMISTPOPFIL VARCHAR2(01);

   V_CDBENEFFISCAL    VARCHAR2(10);

   V_IDUTILNFSE      VARCHAR2(01);

   /* Variáveis prestação de serviço */
   V_CDPAISSERV      VARCHAR2(04);
   V_SGESTADOSERV    VARCHAR2(02);
   V_CDMUNICIPIOSERV VARCHAR2(04);
   V_QTDREGSERV      NUMBER;

   V_IDENDCFOPCLIPRES VARCHAR2(01);

   V_IDCONSMVAPMC VARCHAR2(01);
   V_IDCONSCOMPBCPMC VARCHAR2(01);

   V_IDCONSDIFALIQ VARCHAR2(01);
   
   V_VRADICFECPNFTOT FLOAT;
BEGIN

--VARIÁVEIS COM A CHAVE PARA AS TABELAS TEMPORÁRIAS

   V_ALIQTEMP := P_FILIAL||P_LANCTONF;/* ALIQUOTA */
   V_INCITEMP := P_FILIAL||P_LANCTONF;/* INCIDENCIA */
   V_CSTTEMP  := P_FILIAL||P_LANCTONF;/* CST */
   V_CFOPTEMP := P_FILIAL||P_LANCTONF;/* CFOP */

   V_TOTALNOTA  := 0; /*VALOR TOTAL DA NOTA*/
   V_FAIXATOLER := 0.02; /* FAIXA DE TOLERANCIA DE VALORES (CONSISTE VRNOTAFISC X VRPRODUTOS E VENCIMENTOS X VALOR TOTAL DA NOTA)*/

   V_VRADICALIQFECP := NULL;
   V_VRADICFECP := NULL;
   V_CDBENEFFISCAL := NULL;

   Begin
      SELECT N.NRINSJURNF,
             N.CDSERIE,
             N.CDFILIEMIT,
             N.CDFILIRECE,
             NVL(P.IDUTILALMOX, w_N),
             NVL(P.IDUTILLCESTQ, w_N),
             NVL(P.IDUTILLOTE, w_N),
             N.CDINTEGRACAO,
             N.IDORIGDESTNF,
             N.IDDOCFINANC,
             N.IDDOCREPLIC,
             N.IDSISTEMA,
             NVL(P.IDCTRLESTQ, w_S),
             N.DTINIREFEFAT,
             N.CDINSCESTA,
             N.CDEMPRESA,
             N.IDTPIJURNF,
             NVL(N.IDPRESENCIAL, w_9),
             NVL(I.IDVERLEIAUTENFE, '3.10'),
             NVL(CDSITUCRT, '3'),
             NVL(VRSUBLIMITESN, 0)
        INTO V_NRINSJURNF,
             V_SERIE,
             V_CDFILIEMIT,
             V_CDFILIRECE,
             V_IDUTILALMOX,
             V_IDUTILLCESTQ,
             V_IDUTILLOTE,
             V_CDINTEGRACAO,
             V_IDORIGDESTNF,
             V_IDDOCFINANC,
             V_IDDOCREPLIC,
             V_IDSISTEMA,
             V_IDCTRLESTQ,
             V_DTINIREFEFAT,
             V_CDINSCESTA,
             V_CDEMPRESA,
             V_IDTPIJURNF,
             V_IDPRESENCIAL,
             V_IDVERLEIAUTENFE,
             V_CDSITUCRT,
             V_VRSUBLIMITESN
        FROM NOTAFISCAL N, PARAMFILIAL P, INSCRESTAD I, PARAMEMPRESA PE
       WHERE N.CDFILIAL = P_FILIAL   
         AND N.NRLANCTONF = P_LANCTONF 
         AND N.CDFILIEMIT = P.CDFILIAL(+)
         AND N.CDEMPRESA = I.CDEMPRESA
         AND N.CDINSCESTA = I.CDINSCESTA
         AND N.CDEMPRESA = PE.CDEMPRESA(+);
   Exception
      When No_Data_Found Then
         V_NRINSJURNF := Null;
         V_SERIE := Null;
         V_CDFILIEMIT := Null;
         V_CDFILIRECE := Null;
         V_IDUTILALMOX := w_N;
         V_IDUTILLCESTQ := w_N;
         V_IDUTILLOTE := w_N;
         V_CDINTEGRACAO := Null;
         V_IDORIGDESTNF:= Null;
         V_IDDOCFINANC := Null;
         V_IDDOCREPLIC := Null;
         V_IDSISTEMA := Null;
         V_IDCTRLESTQ := w_S;
         V_DTINIREFEFAT := Null;
         V_CDINSCESTA := Null;
         V_CDEMPRESA := Null;
         V_IDTPIJURNF := NULL;
         V_IDPRESENCIAL := w_9;
         V_IDVERLEIAUTENFE := '3.10';
         V_CDSITUCRT := '3';
         V_VRSUBLIMITESN := 0;
   End;

   /* LANCAMENTO DE ESTOQUE DO DOCUMENTO GERADO ATRAVES DE REPLICACAO */
   Begin
      SELECT CDFILIAL||NRLANCESTQ
      INTO   V_IDDOCESTOQ
      FROM LANCTOESTOQ
      WHERE CDFILIAL   = SUBSTR(V_IDDOCREPLIC, 1, 4) AND
            NRLANCTONF = SUBSTR(V_IDDOCREPLIC, 5, 10);
   Exception
      When No_Data_Found Then
         V_IDDOCESTOQ := Null;
   End;

   IF V_IDDOCESTOQ IS NULL THEN
      /* LANCAMENTO DE ESTOQUE DO DOCUMENTO GERADO ATRAVES DE INTEGRACAO (EX: IMPORTACAO DE NFS)*/
      Begin
         SELECT CDFILIAL||NRLANCESTQ
         INTO   V_IDDOCESTOQ
         FROM LANCTOESTOQ
         WHERE CDFILIAL   = SUBSTR(V_CDINTEGRACAO, 1, 4) AND
               NRLANCTONF = SUBSTR(V_CDINTEGRACAO, 5, 10);
      Exception
         When No_Data_Found Then
            V_IDDOCESTOQ := Null;
      End;
   END IF;

   /*NUMERO MAXIMO DE CASAS DECIMAIS*/
   SELECT NVL(NRDECITOTANF,2), 
          NVL(IDUTORIGPROD, 'N')
     INTO V_NRDECITOTANF, 
          V_IDUTORIGPROD
     FROM PARAMGERAL;

--MAIOR REGISTRO DA TABELA DE DADOS ADICIONAIS
   SELECT MAX(NRDADOADIC)
     INTO   V_DADOADIC
     FROM DADOSADIC
    WHERE (CDFILIAL   = P_FILIAL) AND
          (NRLANCTONF = P_LANCTONF);

   IF (V_DADOADIC IS NULL) THEN
      V_DADOADIC := W_001;
   ELSE
      V_DADOADIC := LPAD(RTRIM(TO_CHAR(TO_NUMBER(V_DADOADIC) + 1)),3,0);
      /*GERA O PROXIMO SEQUENCIAL A SER INSERIDO*/
   END IF;

   FOR C_MENSINSC IN (SELECT M.CDMENSAGEM, I.DSMENSINSCRESTA
                        FROM MENSINSCRESTAD I LEFT JOIN MENSAGEM M ON (M.CDMENSAGEM = I.CDMENSAGEM)
                       WHERE (I.CDEMPRESA = P_EMPRESA)
                         AND (I.CDINSCESTA = P_INSCESTA)
                         AND (I.IDENTRSAIDMENS <> 'E')
                         AND (((I.CDMENSAGEM IS NOT NULL) AND (M.IDSITUACAOMENS  = 'A')) OR (I.CDMENSAGEM IS NULL))
                         AND NOT EXISTS (SELECT DSDADOADIC
                                           FROM DADOSADIC
                                          WHERE (CDFILIAL = P_FILIAL)
                                            AND (NRLANCTONF = P_LANCTONF)
                                            AND (DSDADOADIC LIKE I.DSMENSINSCRESTA || '%'))
                       ORDER BY I.NRMENSINSCRESTA) LOOP

      /*PREENCHE AS MENSAGENS ATRELADAS A INSCRICAO ESTADUAL*/
      INSERT INTO DADOSADIC(CDFILIAL, NRLANCTONF, NRDADOADIC, CDMENSAGEM, DSDADOADIC)
                     VALUES(P_FILIAL, P_LANCTONF, V_DADOADIC, C_MENSINSC.CDMENSAGEM, C_MENSINSC.DSMENSINSCRESTA);

      V_DADOADIC := LPAD(RTRIM(TO_CHAR(TO_NUMBER(V_DADOADIC) + 1)),3,0);

   END LOOP;

   IF V_IDORIGDESTNF = 'C' THEN
      FOR C_MENSCLIENTE IN (SELECT M.CDMENSAGEM, C.DSMENSCLIENTE
                              FROM MENSCLIENTE C LEFT JOIN MENSAGEM M ON (M.CDMENSAGEM = C.CDMENSAGEM)
                             WHERE C.CDCLIENTE = P_CLIENTE
                               AND C.IDENTRSAIDMENS <> 'E'
                               AND (((C.CDMENSAGEM IS NOT NULL) AND (M.IDSITUACAOMENS  = 'A')) OR (C.CDMENSAGEM IS NULL))
                               AND NOT EXISTS (SELECT DSDADOADIC
                                                 FROM DADOSADIC
                                                WHERE (CDFILIAL = P_FILIAL)
                                                  AND (NRLANCTONF = P_LANCTONF)
                                                  AND (DSDADOADIC LIKE C.DSMENSCLIENTE || '%'))
                             ORDER BY C.NRMENSCLIENTE) 
      LOOP

         INSERT INTO DADOSADIC
            (CDFILIAL, 
             NRLANCTONF, 
             NRDADOADIC, 
             CDMENSAGEM, 
             DSDADOADIC)
         VALUES
            (P_FILIAL, 
             P_LANCTONF, 
             V_DADOADIC, 
             C_MENSCLIENTE.CDMENSAGEM, 
             C_MENSCLIENTE.DSMENSCLIENTE);

         V_DADOADIC := LPAD(RTRIM(TO_CHAR(TO_NUMBER(V_DADOADIC) + 1)),3,0);
      END LOOP;
   END IF;

   BEGIN
      SELECT TRANSLATE(SUBSTR('Devolver as embalagens vazias no seguinte endereço: ' || 
             PRE.DSPOSTORECEMB ||
             ', ' || PRE.DSENDERECEMB || 
             CASE NVL(PRE.DSCOMPENDERECEMB, '!X!X!') WHEN '!X!X!' THEN '' ELSE ', ' || PRE.DSCOMPENDERECEMB END ||
             ', ' || B.NMBAIRRO ||
             ', CEP:' || PRE.NRCEPRECEMB ||
             ', ' || M.NMMUNICIPIO ||
             ', ' || E.SGESTADO ||
             ', ' || P.NMPAIS ||
             CASE NVL(PRE.NRTELERECEMB, '!X!X!') WHEN '!X!X!' THEN '' ELSE '. Telefone: ' || PRE.NRTELERECEMB END ||
             CASE NVL(PRE.NRFAXRECEMB, '!X!X!') WHEN '!X!X!' THEN '' ELSE '. FAX: ' || PRE.NRFAXRECEMB END, 1, 255), 'áâãäæèïéìëíîçåñòóôöõàøúüûùýÁÂÃÄÆÈÏÉÌËÍÎÅÑÒÓÔÖÕÀØÚÜÛÙÝÇ', 'aaaaaeieieiicanoooooaouuuuyAAAAAEIEIEIIANOOOOOAOUUUUYC') AS DSENDEDEVOEMBA
        INTO V_DSENDEDEVOEMBA
        FROM NOTAFISCAL N JOIN ITEMPRODUTO I ON (N.CDFILIAL = I.CDFILIAL) AND
                                                (N.NRLANCTONF = I.NRLANCTONF)
                          JOIN PRODUTO PR ON (I.CDPRODUTO = PR.CDPRODUTO)
                          JOIN (SELECT P.CDPOSTORECEMB, PR.CDARVPROD
                                  FROM PRODPOSTORECEMB P JOIN PRODUTO PR ON (P.CDPRODUTO = PR.CDPRODUTO)) PPRE ON (INSTR(PR.CDARVPROD, NVL(RTRIM(PPRE.CDARVPROD), PR.CDARVPROD)) = 1)
                          JOIN CLIEPOSTORECEMB C ON (N.CDCLIENTE = C.CDCLIENTE) AND
                                                    (PPRE.CDPOSTORECEMB = C.CDPOSTORECEMB)
                          JOIN POSTORECEMB PRE ON (C.CDPOSTORECEMB = PRE.CDPOSTORECEMB)
                          JOIN PAIS P ON (PRE.CDPAIS = P.CDPAIS)
                          JOIN ESTADO E ON (PRE.CDPAIS = E.CDPAIS) AND
                                           (PRE.SGESTADO = E.SGESTADO)
                          JOIN MUNICIPIO M ON (PRE.CDPAIS = M.CDPAIS) AND
                                              (PRE.SGESTADO = M.SGESTADO) AND
                                              (PRE.CDMUNICIPIO = M.CDMUNICIPIO)
                          JOIN BAIRRO B ON (PRE.CDPAIS = B.CDPAIS) AND
                                           (PRE.SGESTADO = B.SGESTADO) AND
                                           (PRE.CDMUNICIPIO = B.CDMUNICIPIO) AND
                                           (PRE.CDBAIRRO = B.CDBAIRRO)
       WHERE N.CDFILIAL = P_FILIAL
         AND N.NRLANCTONF = P_LANCTONF
         AND NOT EXISTS (SELECT DSDADOADIC
                           FROM DADOSADIC
                          WHERE (CDFILIAL = P_FILIAL)
                            AND (NRLANCTONF = P_LANCTONF)
                            AND (DSDADOADIC LIKE TRANSLATE(SUBSTR('Devolver as embalagens vazias no seguinte endereço: ' || 
                                                 PRE.DSPOSTORECEMB ||
                                                 ', ' || PRE.DSENDERECEMB || 
                                                 CASE NVL(PRE.DSCOMPENDERECEMB, '!X!X!') WHEN '!X!X!' THEN '' ELSE ', ' || PRE.DSCOMPENDERECEMB END ||
                                                 ', ' || B.NMBAIRRO ||
                                                 ', CEP:' || PRE.NRCEPRECEMB ||
                                                 ', ' || M.NMMUNICIPIO ||
                                                 ', ' || E.SGESTADO ||
                                                 ', ' || P.NMPAIS ||
                                                 CASE NVL(PRE.NRTELERECEMB, '!X!X!') WHEN '!X!X!' THEN '' ELSE '. Telefone: ' || PRE.NRTELERECEMB END ||
                                                 CASE NVL(PRE.NRFAXRECEMB, '!X!X!') WHEN '!X!X!' THEN '' ELSE '. FAX: ' || PRE.NRFAXRECEMB END, 1, 255), 'áâãäæèïéìëíîçåñòóôöõàøúüûùýÁÂÃÄÆÈÏÉÌËÍÎÅÑÒÓÔÖÕÀØÚÜÛÙÝÇ', 'aaaaaeieieiicanoooooaouuuuyAAAAAEIEIEIIANOOOOOAOUUUUYC') || '%'));
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_DSENDEDEVOEMBA := NULL;
      WHEN TOO_MANY_ROWS THEN
         RAISE_APPLICATION_ERROR(-20501, 'Operação bloqueada. Existem mais de um posto de recolhimento de embalagens cadastradas no sistema.', TRUE);
   END;

   IF (V_DSENDEDEVOEMBA IS NOT NULL) THEN
      INSERT INTO DADOSADIC
         (CDFILIAL, 
          NRLANCTONF, 
          NRDADOADIC, 
          CDMENSAGEM, 
          DSDADOADIC)
      VALUES
         (P_FILIAL, 
          P_LANCTONF, 
          V_DADOADIC, 
          '',
          V_DSENDEDEVOEMBA);

      V_DADOADIC := LPAD(RTRIM(TO_CHAR(TO_NUMBER(V_DADOADIC) + 1)),3,0);
   END IF;

   --VARIÁVEIS PARA CONSULTA DE ALÍQUOTA, INCIDÊNCIA, CFOP
   Begin
      SELECT NVL(IDENDCFOPFIL,w_I), CDEMPRESA,   CDINSCESTA
      INTO   V_IDENDCFOP,           V_CDEMPRESA, V_CDINSCESTA
      FROM FILIAL
      WHERE (CDFILIAL = V_CDFILIEMIT);
   Exception
      When No_Data_Found Then
         V_IDENDCFOP:= w_I; V_CDEMPRESA:= Null; V_CDINSCESTA:= Null;
   End;

   BEGIN
      SELECT NVL(IDENDEMISTPOPFIL, w_P)
        INTO V_IDENDEMISTPOPFIL
        FROM TIPOOPERACFIL
       WHERE IDENTRSAIDOP = w_S
         AND CDTIPOOPER = P_TIPOOPER
         AND CDFILIAL = V_CDFILIEMIT;
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_IDENDEMISTPOPFIL := w_P;
   END;

   IF V_IDENDEMISTPOPFIL <> w_P THEN
      IF V_IDENDEMISTPOPFIL = w_I THEN
         BEGIN
            SELECT CDPAIS, 
                   SGESTADO,
                   CDMUNICIPIO
              INTO V_PAISORIG,
                   V_ESTAORIG,
                   V_MUNIORIG
              FROM INSCRESTAD
             WHERE CDEMPRESA  = P_EMPRESA 
               AND CDINSCESTA = P_INSCESTA;
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_PAISORIG := NULL; 
               V_ESTAORIG := NULL; 
               V_MUNIORIG := NULL;
         END;
      ELSE
         BEGIN
            SELECT CDPAIS,
                   SGESTADO,
                   CDMUNICIPIO
              INTO V_PAISORIG,
                   V_ESTAORIG,
                   V_MUNIORIG
              FROM ENDEFILI
             WHERE CDFILIAL     = V_CDFILIEMIT
               AND IDTPENDEFILI = V_IDENDEMISTPOPFIL;
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_PAISORIG := NULL;
               V_ESTAORIG := NULL;
               V_MUNIORIG := NULL;
         END;
      END IF;
   ELSE   
      IF V_IDENDCFOP = w_I THEN
         Begin
            SELECT CDPAIS    , SGESTADO  , CDMUNICIPIO
            INTO   V_PAISORIG, V_ESTAORIG, V_MUNIORIG
            FROM INSCRESTAD
            WHERE CDEMPRESA  = P_EMPRESA AND
                  CDINSCESTA = P_INSCESTA;
         Exception
            When No_Data_Found Then
               V_PAISORIG := Null; V_ESTAORIG := Null; V_MUNIORIG := Null;
         End;
      ELSE
         Begin
            SELECT CDPAIS    , SGESTADO  , CDMUNICIPIO
            INTO   V_PAISORIG, V_ESTAORIG, V_MUNIORIG
            FROM ENDEFILI
            WHERE (CDFILIAL     = V_CDFILIEMIT) AND
                  (IDTPENDEFILI = V_IDENDCFOP);
         Exception
            When No_Data_Found Then
               V_PAISORIG := Null; V_ESTAORIG := Null; V_MUNIORIG := Null;
         End;
      END IF;
   END IF;

   /*DESTINATÁRIO-REMETENTE DA NOTA*/
   IF V_IDORIGDESTNF IS NULL THEN
      Begin
         SELECT IDORIGDESTOP
         INTO   V_ORIGDESTOP
         FROM TIPOOPERAC
         WHERE IDENTRSAIDOP = w_S AND
               CDTIPOOPER   = P_TIPOOPER;
      Exception
         When No_Data_Found Then
            V_ORIGDESTOP := Null;
      End;
   ELSE
      V_ORIGDESTOP := V_IDORIGDESTNF;
   END IF;

   V_CDORIGDESTNF := P_CLIENTE;

   V_IDCONSFINAL := w_N;

   IF V_ORIGDESTOP = w_L THEN /*DESTINATARIO -> FILIAL */
      Begin
         SELECT NVL(IDENDCFOPFIL,w_I), NVL(IDENDEMISFIL,w_I), CDEMPRESA  , CDINSCESTA
         INTO   V_IDENDCFOP          , V_IDENDEMIS          , V_CDEMPRESA, V_CDINSCESTA
         FROM FILIAL
         WHERE (CDFILIAL = V_CDFILIRECE);
      Exception
         When No_Data_Found Then
            V_IDENDCFOP := w_I; V_IDENDEMIS := w_I; V_CDEMPRESA := Null; V_CDINSCESTA := Null;
      End;

      SELECT MAX(CDPAIS), MAX(SGESTADO), MAX(CDMUNICIPIO)
        INTO V_CDPAISST, V_SGESTADOST, V_CDMUNICIPIOST
        FROM ENDEFILI
       WHERE CDFILIAL = V_CDFILIRECE
         AND IDTPENDEFILI = 'P';

      SELECT MAX(CDINSCESTAST)
        INTO V_CDINSCESTAST
        FROM INSCRESTADST
       WHERE CDEMPRESA = P_EMPRESA
         AND CDINSCESTA = P_INSCESTA
         AND CDPAIS = V_CDPAISST
         AND SGESTADO = V_SGESTADOST;

      IF V_IDENDCFOP = w_I THEN
         Begin
            SELECT CDPAIS    , SGESTADO
            INTO   V_PAISCFOP, V_ESTACFOP
            FROM INSCRESTAD
            WHERE CDEMPRESA  = V_CDEMPRESA AND
                  CDINSCESTA = V_CDINSCESTA;
         Exception
            When No_Data_Found Then
               V_PAISCFOP := Null; V_ESTACFOP := Null;
         End;
      ELSE
         Begin
            SELECT CDPAIS    , SGESTADO
            INTO   V_PAISCFOP, V_ESTACFOP
            FROM ENDEFILI
            WHERE (CDFILIAL     = V_CDFILIRECE) AND
                  (IDTPENDEFILI = V_IDENDCFOP);
         Exception
            When No_Data_Found Then
               V_PAISCFOP := Null; V_ESTACFOP := Null;
         End;
      END IF;

      IF V_IDENDEMIS = w_I THEN
         Begin
            SELECT CDPAIS    , SGESTADO  , CDMUNICIPIO
            INTO   V_PAISDEST, V_ESTADEST, V_MUNIDEST
            FROM INSCRESTAD
            WHERE CDEMPRESA  = V_CDEMPRESA AND
                  CDINSCESTA = V_CDINSCESTA;
         Exception
            When No_Data_Found Then
               V_PAISDEST := Null; V_ESTADEST := Null; V_MUNIDEST := Null;
         End;
      ELSE
         Begin
            SELECT CDPAIS    , SGESTADO  , CDMUNICIPIO
            INTO   V_PAISDEST, V_ESTADEST, V_MUNIDEST
            FROM ENDEFILI
            WHERE CDFILIAL     = V_CDFILIRECE AND
                  IDTPENDEFILI = V_IDENDEMIS;
         Exception
            When No_Data_Found Then
               V_PAISDEST := Null; V_ESTADEST := Null; V_MUNIDEST := Null;
         End;
      END IF;

      V_CDORIGDESTNF := V_CDFILIRECE;

   ELSIF V_ORIGDESTOP = w_F THEN /*DESTINATARIO -> FORNECEDOR */
      BEGIN
         SELECT NVL(IDENDCFOPFOR,w_P), 
                NVL(IDENDEMISFOR,w_P),
                NVL(IDCONSFINAL,w_N),
                NRINSESTFORN,
                NVL(IDCONTRIBICMS,w_N)
           INTO V_IDENDCFOP,
                V_IDENDEMIS,
                V_IDCONSFINAL,
                V_NRINSESTDESNF,
                V_IDCONTRIBICMS
           FROM FORNECEDOR
          WHERE (CDFORNECED = P_CLIENTE);
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
            V_IDENDCFOP := w_P; 
            V_IDENDEMIS := w_P;
            V_IDCONSFINAL := w_N;
            V_NRINSESTDESNF := NULL;
            V_IDCONTRIBICMS := w_N;
      END;

      SELECT MAX(CDPAIS), MAX(SGESTADO), MAX(CDMUNICIPIO)
        INTO V_CDPAISST, V_SGESTADOST, V_CDMUNICIPIOST
        FROM ENDEFORN
       WHERE CDFORNECED = P_CLIENTE
         AND IDTPENDEFORN = 'P';

      SELECT MAX(CDINSCESTAST)
        INTO V_CDINSCESTAST
        FROM INSCRESTADST
       WHERE CDEMPRESA = P_EMPRESA
         AND CDINSCESTA = P_INSCESTA
         AND CDPAIS = V_CDPAISST
         AND SGESTADO = V_SGESTADOST;

      IF V_IDENDCFOP = w_I THEN
         Begin
            SELECT CDPAIS    , SGESTADO
            INTO   V_PAISCFOP, V_ESTACFOP
            FROM INSCRESTAD
            WHERE CDEMPRESA  = P_EMPRESA AND
                  CDINSCESTA = P_INSCESTA;
         Exception
            When No_Data_Found Then
               V_PAISCFOP := Null; V_ESTACFOP := Null;
         End;
      ELSE
         Begin
            SELECT CDPAIS    , SGESTADO
            INTO   V_PAISCFOP, V_ESTACFOP
            FROM ENDEFORN
            WHERE (CDFORNECED   = P_CLIENTE) AND
                  (IDTPENDEFORN = V_IDENDCFOP);
         Exception
            When No_Data_Found Then
               V_PAISCFOP := Null; V_ESTACFOP := Null;
         End;
      END IF;

      Begin
         SELECT CDPAIS,     SGESTADO,   CDMUNICIPIO
         INTO   V_PAISDEST, V_ESTADEST, V_MUNIDEST
         FROM ENDEFORN
         WHERE (CDFORNECED   = P_CLIENTE) AND
               (IDTPENDEFORN = V_IDENDEMIS);
      Exception
         When No_Data_Found Then
            V_PAISDEST := Null; V_ESTADEST := Null; V_MUNIDEST := Null;
      End;
   ELSE /*DESTINATARIO -> CLIENTE(DEFAULT) */
      BEGIN
         SELECT NVL(IDENDCFOPCLI,w_P),
                NVL(IDENDEMISCLI,w_P),
                NVL(IDUTDESCICMS, w_N),
                NVL(IDCONSFINAL,w_N),
                NRINSESTCLIE,
                NVL(IDCONTRIBICMS,w_N),
                CDCNAECLIE,
                NVL(IDOPTANTESNCLIE,w_N),
                NVL(IDENDCFOPCLIPRES, 'I')
           INTO V_IDENDCFOP,
                V_IDENDEMIS,
                V_IDUTDESCICMS,
                V_IDCONSFINAL,
                V_NRINSESTDESNF,
                V_IDCONTRIBICMS,
                V_CDCNAECLIE,
                V_IDOPTANTESNCLIE,
                V_IDENDCFOPCLIPRES
           FROM CLIENTE
          WHERE (CDCLIENTE = P_CLIENTE);
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
            V_IDENDCFOP := w_P;
            V_IDENDEMIS := w_P;
            V_IDUTDESCICMS := w_N;
            V_IDCONSFINAL := w_N;
            V_NRINSESTDESNF := NULL;
            V_IDCONTRIBICMS := w_N;
            V_CDCNAECLIE := NULL;
            V_IDOPTANTESNCLIE := w_N;
            V_IDENDCFOPCLIPRES := 'I';
      END;

      SELECT MAX(CDPAIS), MAX(SGESTADO), MAX(CDMUNICIPIO)
        INTO V_CDPAISST, V_SGESTADOST, V_CDMUNICIPIOST
        FROM ENDECLIE
       WHERE CDCLIENTE = P_CLIENTE
         AND IDTPENDECLIE = 'P';

      SELECT MAX(CDINSCESTAST)
        INTO V_CDINSCESTAST
        FROM INSCRESTADST
       WHERE CDEMPRESA = P_EMPRESA
         AND CDINSCESTA = P_INSCESTA
         AND CDPAIS = V_CDPAISST
         AND SGESTADO = V_SGESTADOST;

      IF V_IDENDCFOP = w_I THEN
         Begin
            SELECT CDPAIS    , SGESTADO, CDMUNICIPIO
            INTO   V_PAISCFOP, V_ESTACFOP, V_MUNIDEST
            FROM INSCRESTAD
            WHERE CDEMPRESA  = P_EMPRESA AND
                  CDINSCESTA = P_INSCESTA;
         Exception
            When No_Data_Found Then
               V_PAISCFOP := Null; V_ESTACFOP := Null; V_MUNIDEST := Null;
         End;
         V_PAISDEST := V_PAISCFOP;
         V_ESTADEST := V_ESTACFOP;
      ELSE

         Begin
            SELECT CDPAIS    , SGESTADO
            INTO   V_PAISCFOP, V_ESTACFOP
            FROM ENDECLIE
            WHERE (CDCLIENTE    = P_CLIENTE) AND
                  (IDTPENDECLIE = V_IDENDCFOP);
         Exception
            When No_Data_Found Then
               V_PAISCFOP := Null; V_ESTACFOP := Null;
         End;

         Begin
            SELECT CDPAIS    , SGESTADO  , CDMUNICIPIO
            INTO   V_PAISDEST, V_ESTADEST, V_MUNIDEST
            FROM ENDECLIE
            WHERE (CDCLIENTE    = P_CLIENTE) AND
                  (IDTPENDECLIE = V_IDENDEMIS);
         Exception
            When No_Data_Found Then
               V_PAISDEST := Null; V_ESTADEST := Null; V_MUNIDEST := Null;
         End;
      END IF;
   END IF;

   IF (V_NRINSESTDESNF IS NULL) OR (V_NRINSESTDESNF = '') THEN
      V_IDCONTRIBICMSAUX := 'N';
   ELSE
      V_IDCONTRIBICMSAUX := V_IDCONTRIBICMS;
   END IF;

   IF (V_CDINSCESTAST IS NOT NULL) OR (V_CDINSCESTAST = '')  THEN
      UPDATE NOTAFISCAL
         SET CDINSCESTAST = V_CDINSCESTAST
       WHERE CDFILIAL = P_FILIAL
         AND NRLANCTONF = P_LANCTONF;

      FOR C_MENSINSCESTAST IN (SELECT M.CDMENSAGEM, I.DSMENSINSCESTAST
                                 FROM MENSINSCESTAST I LEFT JOIN MENSAGEM M ON (M.CDMENSAGEM = I.CDMENSAGEM)
                                WHERE I.CDEMPRESA = P_EMPRESA
                                  AND I.CDINSCESTA = P_INSCESTA
                                  AND I.CDINSCESTAST = V_CDINSCESTAST
                                  AND I.IDENTRSAIDMENSST <> 'E'
                                  AND (((I.CDMENSAGEM IS NOT NULL) AND (M.IDSITUACAOMENS  = 'A')) OR (I.CDMENSAGEM IS NULL))
                                  AND NOT EXISTS (SELECT DSDADOADIC
                                                    FROM DADOSADIC
                                                   WHERE (CDFILIAL = P_FILIAL)
                                                     AND (NRLANCTONF = P_LANCTONF)
                                                     AND (DSDADOADIC LIKE I.DSMENSINSCESTAST || '%'))
                                ORDER BY NRMENSINSCESTAST) LOOP

         /*PREENCHE AS MENSAGENS ATRELADAS A INSCRICAO ESTADUAL DO SUBSTITUTO TRIBUTÁRIO*/
         INSERT INTO DADOSADIC(CDFILIAL, NRLANCTONF, NRDADOADIC, CDMENSAGEM, DSDADOADIC)
                        VALUES(P_FILIAL, P_LANCTONF, V_DADOADIC, C_MENSINSCESTAST.CDMENSAGEM, C_MENSINSCESTAST.DSMENSINSCESTAST);

         V_DADOADIC := LPAD(RTRIM(TO_CHAR(TO_NUMBER(V_DADOADIC) + 1)),3,0);

      END LOOP;
   END IF;

    -- PREENCHER CLASSIFICACAO FISCAL NCM NA TABELA ITEMPRODUTO
    FOR C_ITEMPRODUTO IN (SELECT I.CDFILIAL, I.NRLANCTONF, I.NRSEQITPROD, P.CDCLASFISC
                            FROM ITEMPRODUTO I, PRODUTO P
                           WHERE I.CDFILIAL   = P_FILIAL
                             AND I.NRLANCTONF = P_LANCTONF
                             AND I.CDPRODUTO = P.CDPRODUTO)
    LOOP
      UPDATE ITEMPRODUTO
         SET CDPRODNCMTRANS = C_ITEMPRODUTO.CDCLASFISC
       WHERE CDFILIAL    = C_ITEMPRODUTO.CDFILIAL
         AND NRLANCTONF  = C_ITEMPRODUTO.NRLANCTONF
         AND NRSEQITPROD = C_ITEMPRODUTO.NRSEQITPROD;
   END LOOP;

   /*
   ROTINA PARA VERIFICAR AS NOTAS DO SISTEMA FACILITIES. NESTAS NOTAS O SISTEMA
   NÃO VERIFICARÁ O PAIS, O ESTADO E NEM O MUNICÍPIO DO DESTINATÁRIO DA NOTA FISCAL
   E SIM DO LOCAL DE ATENDIMENTO DAQUELA PRESTAÇÃO DE SERVIÇO
   */
   V_QTDREGFCT := 0;
   BEGIN
      SELECT CDPAIS,
             SGESTADO,
             CDMUNICIPIO,
             COUNT(*)
        INTO V_CDPAISFCT,
             V_SGESTADOFCT,
             V_CDMUNICIPIOFCT,
             V_QTDREGFCT
        FROM FCT_DADOSNF
       WHERE CDFILIAL = P_FILIAL
         AND NRLANCTONF = P_LANCTONF
       GROUP BY CDPAIS, 
             SGESTADO, 
             CDMUNICIPIO;
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_CDPAISFCT := NULL;
         V_SGESTADOFCT := NULL;
         V_CDMUNICIPIOFCT := NULL;
         V_QTDREGFCT := 0;
   END;

   IF (V_QTDREGFCT > 0) THEN
      V_PAISDEST := V_CDPAISFCT;
      V_ESTADEST := V_SGESTADOFCT;
      V_MUNIDEST := V_CDMUNICIPIOFCT;
   END IF;

   /*
   QUANDO A OPERAÇÃO DA NOTA FISCAL FOR PRESENCIAL O SISTEMA USARÁ COMO ENDEREÇO
   DE DESTINO O MESMO ENDEREÇO DA ORIGEM. ESTÁ CONDIÇÃO FOI NECESSÁRIA PARA ATENDER
   A NOTA TÉCNICA 2015/003
   */
   IF V_IDPRESENCIAL = W_1 THEN
      V_PAISDEST := V_PAISORIG;
      V_ESTADEST := V_ESTAORIG;
      V_MUNIDEST := V_MUNIORIG;

      -- Verificar identificador de endereço CFOP conforme operação presencial

      IF (NVL(V_IDORIGDESTNF, 'C') = 'C') THEN
         IF V_IDENDCFOPCLIPRES = w_I THEN
            Begin
               SELECT CDPAIS, SGESTADO
                 INTO V_PAISCFOP, V_ESTACFOP
                 FROM INSCRESTAD
                WHERE CDEMPRESA  = P_EMPRESA
                  AND CDINSCESTA = P_INSCESTA;
            Exception
               When No_Data_Found Then
                  V_PAISCFOP := Null; V_ESTACFOP := Null;
            End;
         ELSE
            Begin
               SELECT CDPAIS, SGESTADO
                 INTO V_PAISCFOP, V_ESTACFOP
                 FROM ENDECLIE
                WHERE CDCLIENTE    = P_CLIENTE
                  AND IDTPENDECLIE = V_IDENDCFOPCLIPRES;
            Exception
               When No_Data_Found Then
                  V_PAISCFOP := Null; V_ESTACFOP := Null;
            End;
         END IF;
      END IF;   
   END IF;

   V_IDINTEREST := 'N';
   V_IDINTERNA  := 'N';
   IF ((V_PAISDEST = V_PAISORIG) AND (V_ESTADEST <> V_ESTAORIG)) THEN
      V_IDINTEREST := 'S';
   ELSIF (V_PAISDEST <> V_PAISORIG) THEN
      V_IDINTERNA := 'S';
   END IF;

   IF ((V_IDSISTEMA = 'VND') OR (V_IDSISTEMA = 'PDV')) AND (NVL(V_IDORIGDESTNF, 'C') <> 'L') THEN
      UPDATE ITEMPRODUTO
      SET VRTOTAITEM = TRUNC(VRTOTAITEM,2)
      WHERE CDFILIAL   = P_FILIAL AND
            NRLANCTONF = P_LANCTONF;
   ELSE
      UPDATE ITEMPRODUTO
      SET VRTOTAITEM = ROUND(VRTOTAITEM,5)  
      WHERE CDFILIAL   = P_FILIAL AND
            NRLANCTONF = P_LANCTONF;
   END IF;

   SELECT SUM(VRLIQUIDO)
     INTO V_LIQUIDO
     FROM (SELECT DECODE(QTITEMPROD, 0, (VRTOTAITEM - VRDESCITEM), (ROUND(QTITEMPROD,4) * ROUND(VRUNITITEM,10)) - ROUND(VRDESCITEM, 2)) AS VRLIQUIDO
             FROM ITEMPRODUTO
            WHERE CDFILIAL   = P_FILIAL
              AND NRLANCTONF = P_LANCTONF);

   /*PREENCHE O GRUPO FISCAL*/
   IF V_IDORIGDESTNF = w_U THEN /*LICENCA DE USO*/
      CONSULTA_GRUPOFISCAL(w_C           , V_CDORIGDESTNF, V_CDFILIEMIT, w_S, P_TIPOOPER, V_CDGRUPOFISC);
   ELSE /*DEMAIS DESTINATARIOS*/
      CONSULTA_GRUPOFISCAL(V_IDORIGDESTNF, V_CDORIGDESTNF, V_CDFILIEMIT, w_S, P_TIPOOPER, V_CDGRUPOFISC);
   END IF;

   /*VERIFICA SE A NOTA UTILIZA DOCUMENTO DE ORIGEM E SE O TIPO DE OPERAÇÃO É DE ESTORNO DE CANCELAMENTO*/
   BEGIN
      SELECT IDOPERDEVONF, 
             IDCONSPARFIS, 
             IDNFESTCANC,
             IDCALCDIFALDENT,
             IDUTILVENC,
             IDNOTADEVO,
             IDNFAJUSTE,
             IDUTILNFSE,
             NVL(IDCONTCONFORIG, 'S')
        INTO V_IDOPERDEVONF, 
             V_IDCONSPARFIS, 
             V_ESTORNOCANC,
             V_IDCALCDIFALDENT,
             V_IDUTILVENC,
             V_IDNOTADEVO,
             V_IDNFAJUSTE,
             V_IDUTILNFSE,
             V_IDCONTCONFORIG
        FROM TIPOOPERAC
       WHERE IDENTRSAIDOP = w_S
         AND CDTIPOOPER = P_TIPOOPER;
   EXCEPTION
      WHEN NO_DATA_FOUND THEN BEGIN
         V_IDOPERDEVONF := w_N;
         V_IDCONSPARFIS := w_S;
         V_ESTORNOCANC := w_N;
         V_IDCALCDIFALDENT := w_N;
         V_IDUTILVENC := w_N;
         V_IDNOTADEVO := w_N;
         V_IDNFAJUSTE := w_N;
         V_IDUTILNFSE := w_N;
         V_IDCONTCONFORIG := w_S;
      END;
   END;

   IF (V_IDUTILNFSE = 'S') THEN

      V_QTDREGSERV := 0;
      BEGIN
         SELECT CDPAISPRESSERV,
                SGESTADOPRESSERV,
                CDMUNICIPRESSERV,
                COUNT(*)
           INTO V_CDPAISSERV,
                V_SGESTADOSERV,
                V_CDMUNICIPIOSERV,
                V_QTDREGSERV
           FROM DADOSERVPRES
          WHERE CDFILIAL   = P_FILIAL
            AND NRLANCTONF = P_LANCTONF
          GROUP BY CDPAISPRESSERV,
                   SGESTADOPRESSERV,
                   CDMUNICIPRESSERV;
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
            V_CDPAISSERV      := NULL;
            V_SGESTADOSERV    := NULL;
            V_CDMUNICIPIOSERV := NULL;
            V_QTDREGSERV      := 0;
      END;

       IF (V_QTDREGSERV > 0) THEN
         V_PAISDEST := V_CDPAISSERV;
         V_ESTADEST := V_SGESTADOSERV;
         V_MUNIDEST := V_CDMUNICIPIOSERV;
      END IF;
   END IF;

   IF V_IDOPERDEVONF <> w_S THEN  /*SE NAO UTILIZA DOCUMENTO DE ORIGEM*/
      IF ((V_IDSISTEMA = 'VND') OR (V_IDSISTEMA = 'PDV')) AND (NVL(V_IDORIGDESTNF, 'C') <> 'L') THEN
         UPDATE ITEMPRODUTO
         SET VRBRUTITEM   = TRUNC((VRTOTAITEM - VRDESCITEM),2),
             VRCONTITEM   = TRUNC((VRTOTAITEM - VRDESCITEM),2)
         WHERE CDFILIAL   = P_FILIAL   AND
               NRLANCTONF = P_LANCTONF;
      ELSE
         UPDATE ITEMPRODUTO
         SET VRBRUTITEM   = ROUND((VRTOTAITEM - VRDESCITEM),5),
             VRCONTITEM   = ROUND((VRTOTAITEM - VRDESCITEM),5)
         WHERE CDFILIAL   = P_FILIAL   AND
               NRLANCTONF = P_LANCTONF;
      END IF;
      V_IDOPERDEVONF := w_N;
   ELSE
      IF ((V_IDSISTEMA = 'VND') OR (V_IDSISTEMA = 'PDV')) AND (NVL(V_IDORIGDESTNF, 'C') <> 'L') THEN
         UPDATE ITEMPRODUTO
         SET VRBRUTITEM   = TRUNC((VRTOTAITEM - VRDESCITEM),2),
             VRCONTITEM   = TRUNC((VRTOTAITEM - VRDESCITEM),2)
         WHERE CDFILIAL   = P_FILIAL   AND
               NRLANCTONF = P_LANCTONF;
      ELSE
         UPDATE ITEMPRODUTO
         SET VRBRUTITEM   = ROUND((VRTOTAITEM - VRDESCITEM),5),
             VRCONTITEM   = ROUND((VRTOTAITEM - VRDESCITEM),5)
         WHERE CDFILIAL   = P_FILIAL   AND
               NRLANCTONF = P_LANCTONF;
      END IF;

      SELECT COUNT(*)
      INTO   V_COUNT
      FROM ITEMNOTAFISC
      WHERE CDFILIAL   = P_FILIAL AND
            NRLANCTONF = P_LANCTONF;

      V_IDDEVOLIST := w_N; /*SE O DOCUMENTO DE ORIGEM E DE LISTA OU NAO*/
      IF (V_COUNT > 1) THEN
         V_IDDEVOLIST := w_S;
      END IF;

      IF (V_COUNT = 0) THEN
         V_IDOPERDEVONF := w_N;

         IF ((V_IDSISTEMA = 'VND') OR (V_IDSISTEMA = 'PDV')) AND (NVL(V_IDORIGDESTNF, 'C') <> 'L') THEN
            UPDATE ITEMPRODUTO
            SET VRBRUTITEM   = TRUNC((VRTOTAITEM - VRDESCITEM),2),
                VRCONTITEM   = TRUNC((VRTOTAITEM - VRDESCITEM),2)
            WHERE CDFILIAL   = P_FILIAL   AND
                  NRLANCTONF = P_LANCTONF;
         ELSE
            UPDATE ITEMPRODUTO
            SET VRBRUTITEM   = ROUND((VRTOTAITEM - VRDESCITEM),5),
                VRCONTITEM   = ROUND((VRTOTAITEM - VRDESCITEM),5)
            WHERE CDFILIAL   = P_FILIAL   AND
                  NRLANCTONF = P_LANCTONF;
         END IF;
      ELSE
         V_IDOPERDEVONF := w_S;
         IF (P_TIPOOPER = '03') OR (P_TIPOOPER = '05') OR (P_TIPOOPER = '11') THEN
            V_IDOPERDEVONF := w_N;
         END IF;
      END IF;
   END IF;

   DELETE 
     FROM DETESPCOMBNFE
    WHERE CDFILIAL = P_FILIAL
      AND NRLANCTONF = P_LANCTONF;

   /* GRAVA INFORMAÇÕES ADICIONAIS DO PRODUTO */
   V_IDPRODPERIG := 'N';
   FOR C_ITEMPRODINF IN (SELECT I.NRSEQITPROD, P.IDPRODPERIG, P.DSINFADICPROD, I.CDPRODUTO
                           FROM ITEMPRODUTO I, PRODUTO P
                          WHERE I.CDFILIAL = P_FILIAL
                            AND I.NRLANCTONF = P_LANCTONF
                            AND I.CDPRODUTO = P.CDPRODUTO)
   LOOP
      UPDATE ITEMPRODUTO
         SET DSINFADICPROD = C_ITEMPRODINF.DSINFADICPROD
       WHERE CDFILIAL = P_FILIAL
         AND NRLANCTONF = P_LANCTONF
         AND NRSEQITPROD = C_ITEMPRODINF.NRSEQITPROD;

      BEGIN
         SELECT NRREGISTROANP,
                DSREGISTROANP
           INTO V_NRREGISTROANP,
                V_DSREGISTROANP
           FROM INFADICPROD
          WHERE CDPRODUTO = C_ITEMPRODINF.CDPRODUTO;
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
            V_NRREGISTROANP := NULL;
            V_DSREGISTROANP := NULL;
      END;

      IF V_NRREGISTROANP IS NOT NULL THEN
         INSERT INTO DETESPCOMBNFE
            (CDFILIAL, NRLANCTONF, NRSEQITPROD, CDPAIS, 
             SGESTADO, CDPRODANP, DSPRODANP)
         VALUES
            (P_FILIAL, P_LANCTONF, C_ITEMPRODINF.NRSEQITPROD, V_PAISORIG, 
             V_ESTAORIG, SUBSTR(V_NRREGISTROANP, 1, 9), SUBSTR(V_DSREGISTROANP, 1, 255));
      END IF;

      IF C_ITEMPRODINF.IDPRODPERIG = 'S' THEN
         V_IDPRODPERIG := 'S';
      END IF;
   END LOOP;

   /* GRAVA MENSAGEM REFERENTE A PRODUTO PERIGOSO */
   IF V_IDPRODPERIG = 'S' THEN
      V_MSGPRODPERIG := 'Declaro que os produtos perigosos estão adequadamente ' ||
                        'classificados, embalados, identificados, e estivados ' ||
                        'para suportar os riscos das operações de transporte e ' ||
                        'que atendem às exigências da regulamentação.';
      BEGIN
         SELECT COUNT(DSDADOADIC)
           INTO V_GRAVAMSGPRODPERIG
           FROM DADOSADIC
          WHERE (CDFILIAL = P_FILIAL)
            AND (NRLANCTONF = P_LANCTONF)
            AND (DSDADOADIC LIKE SUBSTR(V_MSGPRODPERIG, 1, LENGTH(V_MSGPRODPERIG) - 19) || '%');
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
            V_GRAVAMSGPRODPERIG := 0;
      END;

      IF (V_GRAVAMSGPRODPERIG = 0) THEN
         INSERT INTO DADOSADIC(CDFILIAL, NRLANCTONF, NRDADOADIC, CDMENSAGEM, DSDADOADIC)
                        VALUES(P_FILIAL, P_LANCTONF, V_DADOADIC, NULL, V_MSGPRODPERIG);

         V_DADOADIC := LPAD(RTRIM(TO_CHAR(TO_NUMBER(V_DADOADIC) + 1)),3,0);
      END IF;
   End If;

   DELETE FROM DADOSADIC
    WHERE CDFILIAL = P_FILIAL
      AND NRLANCTONF = P_LANCTONF
      AND DSDADOADIC LIKE 'ICMS retido anteriormente por substituição tributária: BC %';

   DELETE FROM DADOSADIC
     WHERE CDFILIAL = P_FILIAL
       AND NRLANCTONF = P_LANCTONF
       AND DSDADOADIC LIKE 'Permite o aproveitamento do credito do ICMS no valor de R$ %';

-- ATUALIZAÇÃO DAS TABELAS DE NOTAFISCAL, ITEMPRODUTO E DADOS ADICIONAIS

   IF NOT(P_TIPOOPER IN ('03','07','09','10','12')) AND (V_IDOPERDEVONF <> w_S) THEN
   /*AS NOTAS QUE NAO UTILIZAM DOCUMENTO DE ORIGEM*/

      FOR C_ITEMPRODUTO IN (SELECT VRTOTAITEM, VRDESCITEM, IT.CDPRODUTO, NRSEQITPROD,
                                   CDCSTINFUSU, CDCFOPINFUSU, CDSUFXINFUSU, P.CDARVPROD,
                                   IT.QTITEMPROD, IT.IDORIGEMPROD, IT.VRUNITITEM
                            FROM ITEMPRODUTO IT, PRODUTO P
                            WHERE IT.CDFILIAL   = P_FILIAL   AND
                                  IT.NRLANCTONF = P_LANCTONF AND
                                  IT.CDPRODUTO  = P.CDPRODUTO) LOOP

         V_LIQUIITEM := C_ITEMPRODUTO.VRTOTAITEM - C_ITEMPRODUTO.VRDESCITEM;

         /*VERIFICA O CST POR ITEM*/
         CONSULTA_CST(w_S, P_EMPRESA, C_ITEMPRODUTO.CDARVPROD, P_INSCESTA, P_TIPOOPER, P_FILIAL, P_LANCTONF, V_CDGRUPOFISC, V_IDINTEREST, V_IDINTERNA, NULL, C_ITEMPRODUTO.IDORIGEMPROD);

         FOR C_CSTTEMP IN (SELECT DSMENSCSTTMP
                           FROM CSTTEMP
                           WHERE (NRCSTTEMP = V_CSTTEMP)    AND
                                 (DSMENSCSTTMP IS NOT NULL) AND
                                 (NOT EXISTS(SELECT DSDADOADIC
                                             FROM DADOSADIC
                                             WHERE (CDFILIAL   = P_FILIAL)   AND
                                                   (NRLANCTONF = P_LANCTONF) AND
                                                   (DSDADOADIC LIKE CSTTEMP.DSMENSCSTTMP || '%')))) LOOP

            IF NOT (C_CSTTEMP.DSMENSCSTTMP IS NULL) THEN
               /*PREENCHE AS MENSAGENS ATRELADAS AO CST*/
               INSERT INTO DADOSADIC(CDFILIAL, NRLANCTONF, NRDADOADIC, DSDADOADIC)
               VALUES(P_FILIAL, P_LANCTONF, V_DADOADIC, C_CSTTEMP.DSMENSCSTTMP);

               V_DADOADIC := LPAD(RTRIM(TO_CHAR(TO_NUMBER(V_DADOADIC) + 1)),3,0);
            END IF;
         END LOOP;

         IF V_PAISORIG = V_PAISCFOP THEN
            IF V_ESTAORIG = V_ESTACFOP THEN
               V_CFOP1DIGT := '5';
            ELSE
               V_CFOP1DIGT := '6';
            END IF;
         ELSE
            V_CFOP1DIGT := '7';
         END IF;

         /*VERIFICA CFOP POR ITEM*/
         CONSULTA_CFOP(w_S, P_EMPRESA, C_ITEMPRODUTO.CDARVPROD, P_INSCESTA, P_TIPOOPER, V_PAISORIG,
                        V_ESTAORIG, V_PAISCFOP, V_ESTACFOP, P_FILIAL, P_LANCTONF, V_CDGRUPOFISC, P_INIVALID, C_ITEMPRODUTO.IDORIGEMPROD );


         FOR C_CFOPTEMP IN (SELECT DSMENSCFOTMP
                            FROM CFOPTEMP
                            WHERE (NRCFOPTEMP = V_CFOPTEMP)  AND
                                  (DSMENSCFOTMP IS NOT NULL) AND
                                  (NOT EXISTS(SELECT DSDADOADIC
                                              FROM DADOSADIC
                                              WHERE (CDFILIAL   = P_FILIAL)   AND
                                                    (NRLANCTONF = P_LANCTONF) AND
                                                    (DSDADOADIC LIKE CFOPTEMP.DSMENSCFOTMP || '%')))) LOOP

            IF NOT (C_CFOPTEMP.DSMENSCFOTMP IS NULL) THEN
               /*PREENCHE AS MENSAGENS ATRELADAS AO CFOP*/
               INSERT INTO DADOSADIC(CDFILIAL, NRLANCTONF, NRDADOADIC, DSDADOADIC)
                              VALUES(P_FILIAL, P_LANCTONF, V_DADOADIC, C_CFOPTEMP.DSMENSCFOTMP);

               V_DADOADIC := LPAD(RTRIM(TO_CHAR(TO_NUMBER(V_DADOADIC) + 1)),3,0);
            END IF;
         END LOOP;

         V_CFOPINFUSU := 'N';         
         IF C_ITEMPRODUTO.CDCFOPINFUSU IS NULL THEN /*SE NAO HOUVER CFOP INFORMADO PELO USUARIO PARA O PRODUTO*/
            /*SE A DESCRIÇÃO DO CFOP NAO TIVER SIDO INFORMADA PELO USUARIO O SISTEMA ASSUME A DESCRICAO DO CFOP DOS ITENS*/
            UPDATE NOTAFISCAL
               SET DSCDFISOPENF = (SELECT MAX(DSCFOPTMP) FROM CFOPTEMP
                                  WHERE NRCFOPTEMP = V_CFOPTEMP)
            WHERE CDFILIAL   = P_FILIAL   AND
                  NRLANCTONF = P_LANCTONF;

            SELECT MAX(CDFISOPETMP), MAX(CDSUFCFOPTMP), SUBSTR(MAX(DSCFOPTMP),1,50)
            INTO   V_FISOPEITEM    , V_SUFXCFOPPR, V_DSCDFISOPEIT
            FROM CFOPTEMP
            WHERE NRCFOPTEMP = V_CFOPTEMP;

            SELECT MAX(CDSITTRIBTMP)
            INTO   V_SITUTRIBPR
            FROM CSTTEMP
            WHERE NRCSTTEMP = V_CSTTEMP;

         ELSE /*SE HOUVER CFOP INFORMADO PELO USUARIO PARA O PRODUTO*/
            V_CFOPINFUSU := 'S';
            V_FISOPEITEM := C_ITEMPRODUTO.CDCFOPINFUSU;
            V_SUFXCFOPPR := C_ITEMPRODUTO.CDSUFXINFUSU;
            V_SITUTRIBPR := C_ITEMPRODUTO.CDCSTINFUSU;

         END IF;

         IF V_IDDOCREPLIC IS NOT NULL THEN /*SE A NF FOI REPLICADA*/
            IF LENGTH(V_SITUTRIBPR) = 3 THEN
               V_SITUTRIBPR := SUBSTR(V_SITUTRIBPR,1,1) || w_90;
            ELSE
               V_SITUTRIBPR := w_90;
            END IF;
         END IF;

         /*VERIFICA CSOSN POR IMPOSTO*/
         CONSULTA_CSOSN('S', P_EMPRESA, C_ITEMPRODUTO.CDARVPROD, P_INSCESTA, P_TIPOOPER, P_FILIAL, P_LANCTONF, V_CDGRUPOFISC, V_IDINTEREST, V_CDFISCOPERSN);

         UPDATE ITEMPRODUTO
         SET CDFISOPEITEM  = V_FISOPEITEM,
             CDSUFXCFOPPR  = V_SUFXCFOPPR,
             CDSITUTRIBPR  = V_SITUTRIBPR,
             DSCDFISOPEIT  = V_DSCDFISOPEIT,
             CDFISCOPERSN  = V_CDFISCOPERSN
         WHERE CDFILIAL    = P_FILIAL AND
               NRLANCTONF  = P_LANCTONF AND
               NRSEQITPROD = C_ITEMPRODUTO.NRSEQITPROD;

         DELETE CFOPTEMP
         WHERE NRCFOPTEMP = V_CFOPTEMP;

         DELETE CSTTEMP
         WHERE NRCSTTEMP = V_CSTTEMP;

   -- ATUALIZAÇÃO DA TABELA DE IMPOSTOS POR ITEM.

         DELETE ITEMPROIMPOS
         WHERE (CDFILIAL    = P_FILIAL)   AND
               (NRLANCTONF  = P_LANCTONF) AND
               (NRSEQITPROD = C_ITEMPRODUTO.NRSEQITPROD);

         DELETE ITEMPROIMPOSORIG
         WHERE (CDFILIAL    = P_FILIAL)   AND
               (NRLANCTONF  = P_LANCTONF) AND
               (NRSEQITPROD = C_ITEMPRODUTO.NRSEQITPROD);

         SELECT COUNT(*)
         INTO   V_IMPOSINFUSU
         FROM IMPOSINFUSU
         WHERE (CDFILIAL    = P_FILIAL)   AND
               (NRLANCTONF  = P_LANCTONF) AND
               (NRSEQITPROD = C_ITEMPRODUTO.NRSEQITPROD);

         IF V_IMPOSINFUSU = 0 THEN
-- Verifica se há grupo fiscal por servico
            SELECT MAX(CDGRUPOFISC)
            INTO V_CDGRPFISCSV
            FROM SERVCLIE SC, SERVICO S
            WHERE SC.CDFILIAL   = V_CDFILIEMIT AND
                  SC.CDCLIENTE  = P_CLIENTE    AND
                  SC.CDFILIAL   = S.CDFILIAL   AND
                  SC.CDSERVFILI = S.CDSERVFILI AND
                  S.CDPRODUTO   = C_ITEMPRODUTO.CDPRODUTO;

            IF V_CDGRPFISCSV IS NULL THEN
               -- Verifica se há grupo fiscal por cliente da filial
               SELECT MAX(CDGRUPOFISC)
               INTO V_CDGRPFISCSV
               FROM CLIENFILIAL
               WHERE CDFILIAL   = V_CDFILIEMIT AND
                     CDCLIENTE  = P_CLIENTE;
            END IF;

            CONSULTA_INCIDENCIA(w_S, P_EMPRESA, C_ITEMPRODUTO.CDARVPROD, P_INSCESTA, P_TIPOOPER, P_FILIAL, P_LANCTONF, V_CDGRUPOFISC, V_CDGRPFISCSV,
                                V_IDINTEREST, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, C_ITEMPRODUTO.IDORIGEMPROD);

            FOR C_INCITEMP IN (SELECT DSMENSINCTMP
                               FROM INCITEMP
                               WHERE (NRINCITEMP = V_INCITEMP)  AND
                                     (DSMENSINCTMP IS NOT NULL) AND
                                     (NOT EXISTS(SELECT DSDADOADIC
                                                 FROM DADOSADIC
                                                 WHERE (CDFILIAL   = P_FILIAL)   AND
                                                       (NRLANCTONF = P_LANCTONF) AND
                                                       (DSDADOADIC LIKE INCITEMP.DSMENSINCTMP || '%')))) LOOP

               IF NOT(C_INCITEMP.DSMENSINCTMP IS NULL) THEN
               /*PREENCHE AS MENSAGENS ATRELADAS A INCIDENCIA*/
                  INSERT INTO DADOSADIC(CDFILIAL, NRLANCTONF, NRDADOADIC, DSDADOADIC)
                                 VALUES(P_FILIAL, P_LANCTONF, V_DADOADIC, C_INCITEMP.DSMENSINCTMP);

                  V_DADOADIC := LPAD(RTRIM(TO_CHAR(TO_NUMBER(V_DADOADIC) + 1)),3,0);
               END IF;
            END LOOP;

            FOR C_INCIDENCIA IN (SELECT DISTINCT (CDIMPOTEMP) AS CDIMPOTEMP, CDFISCTEMP, IDTRATIMPTMP, IDUTMUNIORIG,
                                        IDCONSISTENT, IDIMPORECUP, IDUTVLRQTDEIMPO, CDDETALHEPROD,
                                        CDREGRATMP, IP.CDIMPOSTONFE, IT.CDENQLEGALIPI, IT.CDCEST,
                                        IT.VRADICALIQFECP, IP.CDIMPOBASERET, IP.IDDESCRFONTE
                                 FROM INCITEMP IT, IMPOSTO IP
                                 WHERE (IT.NRINCITEMP = V_INCITEMP)    AND
                                       (IP.CDIMPOSTO  = IT.CDIMPOTEMP) AND
                                       (IP.IDPRODNOTA = w_P)
                                 ORDER BY CDIMPOTEMP) LOOP

               -- Se o imposto é retido (valor NF) e se utiliza o valor de outro imposto como base de cálculo
               IF ((C_INCIDENCIA.IDTRATIMPTMP = 'R') AND (C_INCIDENCIA.CDIMPOBASERET IS NOT NULL)) THEN
                  V_VRIMPORELAC := 0;

                  SELECT NVL(MAX(VRIMPOSTOIT),0)
                    INTO V_VRIMPORELAC
                    FROM ITEMPROIMPOS
                   WHERE CDFILIAL     = P_FILIAL
                     AND NRLANCTONF   = P_LANCTONF
                     AND NRSEQITPROD  = C_ITEMPRODUTO.NRSEQITPROD
                     AND CDIMPOSTO    = C_INCIDENCIA.CDIMPOBASERET
                     AND NRITPROIMPOS = W_1;

                  IF V_VRIMPORELAC <> 0 THEN
                     V_LIQUIITEM := V_VRIMPORELAC;
                  END IF;
               ELSE
                  V_LIQUIITEM := C_ITEMPRODUTO.VRTOTAITEM - C_ITEMPRODUTO.VRDESCITEM;   
               END IF;

               V_ALIQUTMP := 0;
               V_SIMPLES  := 'N';
               V_UTIBB    := 'N';
               V_VRADICALIQFECP := C_INCIDENCIA.VRADICALIQFECP;
               V_CDBENEFFISCAL := NULL;
--integração fiscal especifica com Compass_Argentina atraves da importação de aliquota do imposto IBB
--A aliquota de imposto 03(ibb) sera cadastrada na tabela paramintegraibb e tera prioridade sobre o
-- cadastro de aliquota realizado em sistema
               IF C_INCIDENCIA.CDIMPOTEMP = '03' THEN
                  IF V_IDORIGDESTNF = 'C' THEN
                     V_ALIQUTMP := 0;

                     V_DTVINGENTE := NVL(V_DTINIREFEFAT, P_INIVALID);

                     SELECT NVL(MAX(VRALIQUOTAIBB),NULL)
                     INTO   V_ALIQUTMP
                     FROM PARAMINTEGRAIBB
                     WHERE CDCLIENTE = P_CLIENTE AND
                           V_DTVINGENTE BETWEEN DTVIGINICIALIBB AND DTVIGFINALIBB;

                     IF V_ALIQUTMP IS NOT NULL THEN
                        V_NRALIQTEMP   := 0;
                        V_PARDEDTMP    := 0;
                        V_PREDBCTMP    := 0;
                        V_TRATIMPST    := w_0;
                        V_PBCSUBTRIB   := 0;
                        V_IDPMCBASECAL := 'N';
                        V_UTIBB        := 'S';
                     END IF;
                  END IF;
               END IF;


               /*VERIFICA CST POR IMPOSTO*/
               V_IMPOICMS := NULL;
               V_CDGRUPOFISCAUX := NULL;

               SELECT MAX(G.CDGRUPOFISC)
                 INTO V_CDGRUPOFISCAUX
                 FROM GRUPOFISCIMPFIL G,
                      (SELECT CDFILIEMIT AS CDFILIAL
                         FROM NOTAFISCAL
                        WHERE CDFILIAL = P_FILIAL
                              AND NRLANCTONF = P_LANCTONF) F
                WHERE G.CDFILIAL = F.CDFILIAL
                  AND NOT G.CDGRUPOFISC IS NULL
                  AND G.CDIMPOSTO = C_INCIDENCIA.CDIMPOTEMP;
               IF V_IDORIGDESTNF = 'C' THEN
                  SELECT NVL(MAX(G.CDGRUPOFISC), V_CDGRUPOFISCAUX)
                    INTO V_CDGRUPOFISCAUX
                    FROM GRFISIMPIECLIE G,
                         (SELECT CDCLIENTE
                            FROM NOTAFISCAL
                           WHERE CDFILIAL = P_FILIAL
                             AND NRLANCTONF = P_LANCTONF) N
                   WHERE G.CDCLIENTE = N.CDCLIENTE
                     AND G.CDEMPRESA = P_EMPRESA
                     AND G.CDINSCESTA = P_INSCESTA
                     AND NOT G.CDGRUPOFISC IS NULL
                     AND G.CDIMPOSTO = C_INCIDENCIA.CDIMPOTEMP;
               ELSE
                  SELECT NVL(MAX(G.CDGRUPOFISC), V_CDGRUPOFISCAUX)
                    INTO V_CDGRUPOFISCAUX
                    FROM GRFISIMPIEFORN G,
                        (SELECT CDFORNECED
                           FROM NOTAFISCAL
                          WHERE CDFILIAL = P_FILIAL
                            AND NRLANCTONF = P_LANCTONF) N
                   WHERE G.CDFORNECED = N.CDFORNECED
                     AND G.CDEMPRESA = P_EMPRESA
                     AND G.CDINSCESTA = P_INSCESTA
                     AND NOT G.CDGRUPOFISC IS NULL
                     AND G.CDIMPOSTO = C_INCIDENCIA.CDIMPOTEMP;
               END IF;

               IF V_CDGRUPOFISCAUX IS NULL THEN
                  CONSULTA_CST_NFE(w_S, P_EMPRESA, C_ITEMPRODUTO.CDARVPROD, P_INSCESTA, P_TIPOOPER, V_CDGRUPOFISC,C_INCIDENCIA.CDIMPOTEMP, V_IDINTEREST, V_IDINTERNA, P_FILIAL, P_LANCTONF, '', V_CDSITTRIBTMP, V_IDMODBCNFE, V_IDMODBCSTNFE, V_CDTPCRPICOSTNFE, V_CDNATUBCPCSTNFE, V_IDMOTIDESSTNFE, C_ITEMPRODUTO.IDORIGEMPROD);
               ELSE
                  CONSULTA_CST_NFE(w_S, P_EMPRESA, C_ITEMPRODUTO.CDARVPROD, P_INSCESTA, P_TIPOOPER, V_CDGRUPOFISCAUX,C_INCIDENCIA.CDIMPOTEMP, V_IDINTEREST, V_IDINTERNA, P_FILIAL, P_LANCTONF, '', V_CDSITTRIBTMP, V_IDMODBCNFE, V_IDMODBCSTNFE, V_CDTPCRPICOSTNFE, V_CDNATUBCPCSTNFE, V_IDMOTIDESSTNFE, C_ITEMPRODUTO.IDORIGEMPROD);
               END IF;
               V_CDSIMPLESNACIONAL := NULL;
               V_CDFAIXA := NULL;
               V_BCICMSSTRETIDO := 0;
               V_VRICMSSTRETIDO := 0;
               V_CDREGRAITALIQ  := NULL;

               /*SIMPLES NACIONAL*/
               IF (V_CDSITUCRT <> '3') THEN

                  CALCULA_ALIQUOTA_SN(P_EMPRESA, 
                                      P_TIPOOPER, 
                                      P_INIVALID,
                                      SUBSTR(V_FISOPEITEM, 2, 3), 
                                      C_INCIDENCIA.CDIMPOSTONFE, 
                                      V_VRSUBLIMITESN,
                                      'N',
                                      V_RBT12,
                                      V_RBA,
                                      V_CDSIMPLESNACIONAL,
                                      V_CDFAIXA,
                                      V_VRALIQSIMPLES);

                  IF (V_CDFAIXA IS NOT NULL) OR ((C_INCIDENCIA.CDIMPOSTONFE IN ('00', '31')) AND (V_RBT12 >= 3600000)) THEN

                     UPDATE ITEMPRODUTO
                        SET CDSIMPLESNACIONAL = V_CDSIMPLESNACIONAL
                      WHERE CDFILIAL    = P_FILIAL
                        AND NRLANCTONF  = P_LANCTONF
                        AND NRSEQITPROD = C_ITEMPRODUTO.NRSEQITPROD;

                     V_ALIQUTMP      := V_VRALIQSIMPLES;
                     V_CDREGRAITALIQ := C_INCIDENCIA.CDREGRATMP;
                     V_NRALIQTEMP    := 0;
                     V_PARDEDTMP     := 0;
                     V_PREDBCTMP     := 0;
                     V_TRATIMPST     := w_0;
                     V_PBCSUBTRIB    := 0;
                     V_IDPMCBASECAL  := 'N';
                     V_SIMPLES       := 'S';
                  END IF;
                  IF (V_CDFISCOPERSN = '500') OR (SUBSTR(V_CDFISCOPERSN,2, 3) = '500') THEN
                     V_CDIMPOSICMS  := null;
                     SELECT MAX(CDIMPOSTO)
                       INTO V_CDIMPOSICMS
                       FROM IMPOSTO
                      WHERE CDIMPOSTONFE = '00'
                        AND CDIMPOSTO = C_INCIDENCIA.CDIMPOTEMP;

                     IF V_CDIMPOSICMS IS NOT NULL THEN
                        V_ALIQUTMP := 0;
                     END IF;

                     /*Verifica se o imposto de st (hj o sistema só aceita o icms st)*/
                     /*IMPOSTO DE SUBSTITUICAO TRIBUTARIA*/
                     V_CDIMPOSTRIB  := null;
                     V_IDVRIMPSTRIB := null;
                     FOR C_ICMSST IN (SELECT CDIMPOSTRIB
                                        FROM IMPOSTO
                                       WHERE CDIMPOSTRIB = C_INCIDENCIA.CDIMPOTEMP)
                     LOOP
                        V_CDIMPOSTRIB := V_CDIMPOSTRIB||C_ICMSST.CDIMPOSTRIB||'_';
                     END LOOP;
                     V_BCICMSSTRETIDO := 0;
                     V_VRICMSSTRETIDO := 0;
                     IF V_CDIMPOSTRIB IS NOT NULL THEN
                        IF V_IDUTILLOTE = 'S' THEN
                           SELECT MAX(IDUTCTRLLOTE)
                             INTO V_IDUTCTRLLOTE
                             FROM PRODFILI
                            WHERE CDFILIAL  = V_CDFILIEMIT
                              AND CDPRODUTO = C_ITEMPRODUTO.CDPRODUTO;
                           IF V_IDUTCTRLLOTE = 'S' THEN
                              SELECT MAX(NRLOTEESTQ)
                                INTO V_NRLOTEESTQ
                                FROM ITEMPRODUTO
                               WHERE CDFILIAL    = P_FILIAL
                                 AND NRLANCTONF  = P_LANCTONF
                                 AND NRSEQITPROD = C_ITEMPRODUTO.NRSEQITPROD;

                              V_MEDIA := 0;
                              V_BCICMSSTRETIDO := 0;
                              V_VRICMSSTRETIDO := 0;
                              FOR C_ICMSSTRETIDO IN (SELECT II.CDFILIAL, II.NRLANCTONF, II.NRSEQITPROD, II.CDIMPOSTO,
                                                            ROUND(II.VRBASECALCIT/I.QTITEMPROD,2) AS VRBASE, ROUND(II.VRIMPOSTOIT/I.QTITEMPROD,2) AS VRIMPOSTO
                                                       FROM NOTAFISCAL N, ITEMPRODUTO I, ITEMPROIMPOS II
                                                      WHERE N.CDFILIAL = I.CDFILIAL
                                                        AND N.NRLANCTONF = I.NRLANCTONF
                                                        AND I.CDFILIAL = II.CDFILIAL
                                                        AND I.NRLANCTONF = II.NRLANCTONF
                                                        AND I.NRSEQITPROD = II.NRSEQITPROD
                                                        AND II.NRITPROIMPOS = '1'
                                                        AND N.IDENTRSAIDOP = 'E'
                                                        AND I.CDPRODUTO = C_ITEMPRODUTO.CDPRODUTO
                                                        AND I.NRLOTEESTQ = V_NRLOTEESTQ
                                                        AND N.DTENTRSAID <= P_INIVALID
                                                        AND (INSTR(V_CDIMPOSTRIB,II.CDIMPOSTO||'_') > 0))
                              LOOP
                                  V_MEDIA := V_MEDIA + 1;
                                  V_BCICMSSTRETIDO := V_BCICMSSTRETIDO + C_ICMSSTRETIDO.VRBASE;
                                  V_VRICMSSTRETIDO := V_VRICMSSTRETIDO + C_ICMSSTRETIDO.VRIMPOSTO;
                              END LOOP;
                              IF V_MEDIA > 0 THEN

                                 V_BCICMSSTRETIDO := ROUND(V_BCICMSSTRETIDO/V_MEDIA,2);
                                 V_VRICMSSTRETIDO := ROUND(V_VRICMSSTRETIDO/V_MEDIA,2);
                              ELSE
                                 V_BCICMSSTRETIDO := 0;
                                 V_VRICMSSTRETIDO := 0;
                              END IF;
                              V_BCICMSSTRETIDO := ROUND(V_BCICMSSTRETIDO * C_ITEMPRODUTO.QTITEMPROD,2);
                              V_VRICMSSTRETIDO := ROUND(V_VRICMSSTRETIDO * C_ITEMPRODUTO.QTITEMPROD,2);


                              IF V_BCICMSSTRETIDO <> 0 THEN

                                 SELECT COUNT(*)
                                   INTO V_EXISTDSDADOSADIC
                                   FROM DADOSADIC
                                  WHERE CDFILIAL = P_FILIAL
                                    AND NRLANCTONF = P_LANCTONF
                                    AND DSDADOADIC LIKE 'ICMS retido anteriormente por substituição tributária: BC %';

                                 IF V_EXISTDSDADOSADIC = 0 THEN

                                    /*PREENCHE AS MENSAGENS ATRELADAS A INSCRICAO ESTADUAL*/
                                    INSERT INTO DADOSADIC(CDFILIAL, NRLANCTONF, NRDADOADIC, DSDADOADIC)
                                                   VALUES(P_FILIAL, P_LANCTONF, V_DADOADIC, 'ICMS retido anteriormente por substituição tributária: BC '||DECODE(SUBSTR(LTRIM(TO_CHAR(ROUND(V_BCICMSSTRETIDO, 2), '9999999999999.99')), 1, 1), '.', '0'||LTRIM(TO_CHAR(ROUND(V_BCICMSSTRETIDO, 2), '9999999999999.99')), LTRIM(TO_CHAR(ROUND(V_BCICMSSTRETIDO, 2), '9999999999999.99')))|| ' Valor '|| DECODE(SUBSTR(LTRIM(TO_CHAR(ROUND(V_VRICMSSTRETIDO, 2), '9999999999999.99')), 1, 1), '.', '0'||LTRIM(TO_CHAR(ROUND(V_VRICMSSTRETIDO, 2), '9999999999999.99')), LTRIM(TO_CHAR(ROUND(V_VRICMSSTRETIDO, 2), '9999999999999.99'))));

                                    V_DADOADIC := LPAD(RTRIM(TO_CHAR(TO_NUMBER(V_DADOADIC) + 1)),3,0);
                                 ELSE
                                    UPDATE DADOSADIC
                                       SET DSDADOADIC = 'ICMS retido anteriormente por substituição tributária: BC '||DECODE(SUBSTR(LTRIM(TO_CHAR(ROUND(V_BCICMSSTRETIDO, 2), '9999999999999.99')), 1, 1), '.', '0'||LTRIM(TO_CHAR(ROUND(V_BCICMSSTRETIDO, 2), '9999999999999.99')), LTRIM(TO_CHAR(ROUND(V_BCICMSSTRETIDO, 2), '9999999999999.99')))|| ' Valor '|| DECODE(SUBSTR(LTRIM(TO_CHAR(ROUND(V_VRICMSSTRETIDO, 2), '9999999999999.99')), 1, 1), '.', '0'||LTRIM(TO_CHAR(ROUND(V_VRICMSSTRETIDO, 2), '9999999999999.99')), LTRIM(TO_CHAR(ROUND(V_VRICMSSTRETIDO, 2), '9999999999999.99')))
                                      WHERE CDFILIAL = P_FILIAL
                                        AND NRLANCTONF = P_LANCTONF
                                        AND DSDADOADIC LIKE 'ICMS retido anteriormente por substituição tributária: BC %';
                                 END IF;
                              END IF;
                           END IF;
                        ELSE
                           V_MEDIA := 0;
                           V_BCICMSSTRETIDO := 0;
                           V_VRICMSSTRETIDO := 0;
                           SELECT MAX(N.DTENTRSAID), MAX(II.CDIMPOSTO), MAX(I.CDPRODUTO),
                                  ROUND(SUM(II.VRBASECALCIT)/SUM(I.QTITEMPROD),2) AS VRBASE, ROUND(SUM(II.VRIMPOSTOIT)/SUM(I.QTITEMPROD),2) AS VRIMPOSTO
                             INTO V_DTENTRSAID, V_CDIMPOSTOI, V_CDPRODUTO, V_BCICMSSTRETIDO, V_VRICMSSTRETIDO
                             FROM NOTAFISCAL N, ITEMPRODUTO I, ITEMPROIMPOS II
                            WHERE N.CDFILIAL = I.CDFILIAL
                              AND N.NRLANCTONF = I.NRLANCTONF
                              AND I.CDFILIAL = II.CDFILIAL
                              AND I.NRLANCTONF = II.NRLANCTONF
                              AND I.NRSEQITPROD = II.NRSEQITPROD
                              AND II.NRITPROIMPOS = '1'
                              AND N.IDENTRSAIDOP = 'E'
                              AND I.CDPRODUTO = C_ITEMPRODUTO.CDPRODUTO
                              AND N.DTENTRSAID <= P_INIVALID
                              AND (INSTR(V_CDIMPOSTRIB,II.CDIMPOSTO||'_') > 0);

                           V_BCICMSSTRETIDO := ROUND(V_BCICMSSTRETIDO * C_ITEMPRODUTO.QTITEMPROD,2);
                           V_VRICMSSTRETIDO := ROUND(V_VRICMSSTRETIDO * C_ITEMPRODUTO.QTITEMPROD,2);


                           IF V_BCICMSSTRETIDO <> 0 THEN

                              SELECT COUNT(*)
                                INTO V_EXISTDSDADOSADIC
                                FROM DADOSADIC
                               WHERE CDFILIAL = P_FILIAL
                                 AND NRLANCTONF = P_LANCTONF
                                 AND DSDADOADIC LIKE 'ICMS retido anteriormente por substituição tributária: BC %';

                              IF V_EXISTDSDADOSADIC = 0 THEN

                                 /*PREENCHE AS MENSAGENS ATRELADAS A INSCRICAO ESTADUAL*/
                                 INSERT INTO DADOSADIC(CDFILIAL, NRLANCTONF, NRDADOADIC, DSDADOADIC)
                                                VALUES(P_FILIAL, P_LANCTONF, V_DADOADIC, 'ICMS retido anteriormente por substituição tributária: BC '||DECODE(SUBSTR(LTRIM(TO_CHAR(ROUND(V_BCICMSSTRETIDO, 2), '9999999999999.99')), 1, 1), '.', '0'||LTRIM(TO_CHAR(ROUND(V_BCICMSSTRETIDO, 2), '9999999999999.99')), LTRIM(TO_CHAR(ROUND(V_BCICMSSTRETIDO, 2), '9999999999999.99')))|| ' Valor '|| DECODE(SUBSTR(LTRIM(TO_CHAR(ROUND(V_VRICMSSTRETIDO, 2), '9999999999999.99')), 1, 1), '.', '0'||LTRIM(TO_CHAR(ROUND(V_VRICMSSTRETIDO, 2), '9999999999999.99')), LTRIM(TO_CHAR(ROUND(V_VRICMSSTRETIDO, 2), '9999999999999.99'))));

                                 V_DADOADIC := LPAD(RTRIM(TO_CHAR(TO_NUMBER(V_DADOADIC) + 1)),3,0);
                              ELSE
                                 UPDATE DADOSADIC
                                    SET DSDADOADIC = 'ICMS retido anteriormente por substituição tributária: BC '||DECODE(SUBSTR(LTRIM(TO_CHAR(ROUND(V_BCICMSSTRETIDO, 2), '9999999999999.99')), 1, 1), '.', '0'||LTRIM(TO_CHAR(ROUND(V_BCICMSSTRETIDO, 2), '9999999999999.99')), LTRIM(TO_CHAR(ROUND(V_BCICMSSTRETIDO, 2), '9999999999999.99')))|| ' Valor '|| DECODE(SUBSTR(LTRIM(TO_CHAR(ROUND(V_VRICMSSTRETIDO, 2), '9999999999999.99')), 1, 1), '.', '0'||LTRIM(TO_CHAR(ROUND(V_VRICMSSTRETIDO, 2), '9999999999999.99')), LTRIM(TO_CHAR(ROUND(V_VRICMSSTRETIDO, 2), '9999999999999.99')))
                                  WHERE CDFILIAL = P_FILIAL
                                    AND NRLANCTONF = P_LANCTONF
                                    AND DSDADOADIC LIKE 'ICMS retido anteriormente por substituição tributária: BC %';
                              END IF;
                           END IF;
                        END IF;
                     END IF;
                  END IF;
               END IF;

               IF (V_SIMPLES = 'N') OR ((V_SIMPLES = 'S') AND (C_INCIDENCIA.CDIMPOSTONFE = '00') AND (V_RBA > (V_VRSUBLIMITESN * 1.2))) THEN

                  DELETE ALIQTEMP
                   WHERE NRALIQTEMP = V_ALIQTEMP;

                  V_CDSIMPLESNACIONAL := NULL;
                  V_CDFAIXA := NULL;
                  V_VRADICALIQFECP := NULL;
                  IF (V_UTIBB = 'N')  THEN
                     IF C_INCIDENCIA.IDUTMUNIORIG = w_D THEN
                        SELECT MAX(IDGRUPFISSRV)
                        INTO V_UTGRUPFISCS
                        FROM IMPOSTO
                        WHERE CDIMPOSTO   = C_INCIDENCIA.CDIMPOTEMP;

                        IF V_UTGRUPFISCS = 'S' THEN
                           V_CDGRPFISCSV := NULL;
                           SELECT MAX(CDGRUPOFISC)
                           INTO V_CDGRPFISCSV
                           FROM SERVCLIE SC, SERVICO S
                           WHERE SC.CDFILIAL   = V_CDFILIEMIT AND
                                 SC.CDCLIENTE  = P_CLIENTE    AND
                                 SC.CDFILIAL   = S.CDFILIAL   AND
                                 SC.CDSERVFILI = S.CDSERVFILI AND
                                 S.CDPRODUTO   = C_ITEMPRODUTO.CDPRODUTO;
                           IF V_CDGRPFISCSV IS NULL THEN
                              SELECT MAX(CDGRUPOFISC)
                              INTO V_CDGRPFISCSV
                              FROM CLIENFILIAL
                             WHERE CDFILIAL   = V_CDFILIEMIT AND
                                   CDCLIENTE  = P_CLIENTE ;
                           END IF;
                           CONSULTA_ALIQUOTA(C_INCIDENCIA.CDIMPOTEMP, w_S, P_EMPRESA, C_ITEMPRODUTO.CDARVPROD, P_INSCESTA, V_PAISORIG,
                                             V_ESTAORIG, V_PAISDEST, V_ESTADEST, V_MUNIDEST, V_LIQUIITEM, P_INIVALID, P_FILIAL, P_LANCTONF, V_CDGRPFISCSV,P_TIPOOPER,
                                             NULL, NULL, NULL, NULL, NULL, NULL, C_ITEMPRODUTO.IDORIGEMPROD);
                        ELSE
                            /* CONSIDERA O MUNICIPIO DE DESTINO */
                            CONSULTA_ALIQUOTA(C_INCIDENCIA.CDIMPOTEMP, w_S, P_EMPRESA, C_ITEMPRODUTO.CDARVPROD, P_INSCESTA, V_PAISORIG,
                                              V_ESTAORIG, V_PAISDEST, V_ESTADEST, V_MUNIDEST, V_LIQUIITEM, P_INIVALID, P_FILIAL, P_LANCTONF, V_CDGRUPOFISC, P_TIPOOPER,
                                              NULL, NULL, NULL, NULL, NULL, NULL, C_ITEMPRODUTO.IDORIGEMPROD);
                        END IF;
                     ELSE
                       /* CONSIDERA O MUNICIPIO DE ORIGEM */
                        SELECT MAX(IDGRUPFISSRV)
                        INTO V_UTGRUPFISCS
                        FROM IMPOSTO
                        WHERE CDIMPOSTO   = C_INCIDENCIA.CDIMPOTEMP;

                        IF V_UTGRUPFISCS = 'S' THEN
                           V_CDGRPFISCSV := NULL;
                           SELECT MAX(CDGRUPOFISC)
                           INTO V_CDGRPFISCSV
                           FROM SERVCLIE SC, SERVICO S
                           WHERE SC.CDFILIAL   = V_CDFILIEMIT AND
                                 SC.CDCLIENTE  = P_CLIENTE    AND
                                 SC.CDFILIAL   = S.CDFILIAL   AND
                                 SC.CDSERVFILI = S.CDSERVFILI AND
                                 S.CDPRODUTO   = C_ITEMPRODUTO.CDPRODUTO;
                           IF V_CDGRPFISCSV IS NULL THEN
                              SELECT MAX(CDGRUPOFISC)
                              INTO V_CDGRPFISCSV
                              FROM CLIENFILIAL
                             WHERE CDFILIAL   = V_CDFILIEMIT AND
                                   CDCLIENTE  = P_CLIENTE ;
                           END IF;

                           CONSULTA_ALIQUOTA(C_INCIDENCIA.CDIMPOTEMP, w_S, P_EMPRESA, C_ITEMPRODUTO.CDARVPROD, P_INSCESTA, V_PAISORIG,
                                             V_ESTAORIG, V_PAISDEST, V_ESTADEST, V_MUNIORIG, V_LIQUIITEM, P_INIVALID, P_FILIAL, P_LANCTONF, V_CDGRPFISCSV, P_TIPOOPER,
                                             NULL, NULL, NULL, NULL, NULL, NULL, C_ITEMPRODUTO.IDORIGEMPROD);
                        ELSE
                            CONSULTA_ALIQUOTA(C_INCIDENCIA.CDIMPOTEMP, w_S, P_EMPRESA, C_ITEMPRODUTO.CDARVPROD, P_INSCESTA, V_PAISORIG,
                                              V_ESTAORIG, V_PAISDEST, V_ESTADEST, V_MUNIORIG, V_LIQUIITEM, P_INIVALID, P_FILIAL, P_LANCTONF, V_CDGRUPOFISC, P_TIPOOPER,
                                              NULL, NULL, NULL, NULL, NULL, NULL, C_ITEMPRODUTO.IDORIGEMPROD);
                        END IF;
                     END IF;

                     V_NRALIQTEMP      := 0;
                     V_PARDEDTMP       := 0;
                     V_PREDBCTMP       := 0;
                     V_ALIQUTMP        := 0;
                     V_IMPOSTOIT       := 0;
                     V_VRADICALIQFECP  := NULL;
                     V_IDCONSMVAPMC    := '3';
                     V_IDCONSCOMPBCPMC := '3';

                     SELECT NVL(MAX(NRALIQTEMP),0),      NVL(MAX(VRPARDEDTMP),0),     NVL(MAX(VRPREDBCTMP),0),        NVL(MAX(VRALIQUTMP),0),
                            NVL(MAX(IDTRIMPSTTMP), w_0), NVL(MAX(VRPBCSTTMP),0),      NVL(MAX(IDPMCBSCALTMP), w_S),   MAX(CDREGRATMP),
                            MAX(CDFISCOPER),             MAX(IDDIFEALIQ),             MAX(IDDIFALIQCUSPR),            MAX(VRADICALIQFECP),
                            MAX(CDBENEFFISCAL),          NVL(MAX(IDCONSMVAPMC), '3'), NVL(MAX(IDCONSCOMPBCPMC), '3'), NVL(MAX(IDCONSDIFALIQ), 'N')
                     INTO   V_NRALIQTEMP,                V_PARDEDTMP,                 V_PREDBCTMP,                    V_ALIQUTMP,
                            V_TRATIMPST,                 V_PBCSUBTRIB,                V_IDPMCBASECAL,                 V_CDREGRAITALIQ,
                            V_CDFISCOPERREGRA,           V_IDDIFEALIQREGRA,           V_IDDIFALIQCUSPRREGRA,          V_VRADICALIQFECP,
                            V_CDBENEFFISCAL,             V_IDCONSMVAPMC,              V_IDCONSCOMPBCPMC,              V_IDCONSDIFALIQ
                     FROM ALIQTEMP
                     WHERE (NRALIQTEMP = V_ALIQTEMP);

                     V_ICMS := 'N';
                     FOR C_ICMS IN (SELECT CDIMPOSTO
                                      FROM IMPOSTONFE N, IMPOSTO I
                                     WHERE N.CDIMPOSTONFE = I.CDIMPOSTONFE
                                       AND N.CDIMPOSTONFE = '00'
                                       AND I.CDIMPOSTO = C_INCIDENCIA.CDIMPOTEMP)
                     LOOP
                        V_ICMS := 'S';
                     END LOOP;

                     IF V_ICMS = 'S' THEN
                        IF (V_CDFISCOPERREGRA IS NOT NULL) THEN
                           V_CDFISCOPERREGRA   := V_CFOP1DIGT||V_CDFISCOPERREGRA;
                           V_DSCDFISOPEITREGRA := SUBSTR(DESCRICAO_CFOP(V_CDFISCOPERREGRA),1,45);

                           IF V_CFOPINFUSU <> 'S' THEN
                              V_FISOPEITEM := V_CDFISCOPERREGRA;
                           END IF;
                        END IF;

                        IF V_CFOPINFUSU <> 'S' THEN
                           IF (V_DSCDFISOPEITREGRA IS NOT NULL) THEN
                              UPDATE NOTAFISCAL
                                 SET DSCDFISOPENF = V_DSCDFISOPEITREGRA
                               WHERE CDFILIAL   = P_FILIAL   AND
                                     NRLANCTONF = P_LANCTONF;
                           ELSE
                              UPDATE NOTAFISCAL
                                 SET DSCDFISOPENF = (SELECT MAX(DSCFOPTMP)
                                                       FROM CFOPTEMP
                                                      WHERE NRCFOPTEMP = V_CFOPTEMP)
                               WHERE CDFILIAL   = P_FILIAL
                                 AND NRLANCTONF = P_LANCTONF;
                           END IF;
                        END IF;

                        UPDATE ITEMPRODUTO
                           SET CDFISOPEITEM  = V_FISOPEITEM,
                               CDSUFXCFOPPR  = V_SUFXCFOPPR,
                               CDSITUTRIBPR  = V_SITUTRIBPR,
                               DSCDFISOPEIT  = V_DSCDFISOPEIT,
                               CDFISCOPERSN  = V_CDFISCOPERSN
                         WHERE CDFILIAL    = P_FILIAL AND
                               NRLANCTONF  = P_LANCTONF AND
                               NRSEQITPROD = C_ITEMPRODUTO.NRSEQITPROD;
                     END IF;
                  END IF;
               END IF;
               V_CDIMPOSTRIB  := null;
               V_IDVRIMPSTRIB := null;
               /*IMPOSTO DE SUBSTITUICAO TRIBUTARIA*/
               FOR C_ICMSST IN (SELECT CDIMPOSTO
                                      FROM IMPOSTO
                                     WHERE CDIMPOSTRIB = C_INCIDENCIA.CDIMPOTEMP)
               LOOP
                  V_CDIMPOSTRIB := V_CDIMPOSTRIB||C_ICMSST.CDIMPOSTO||'_';
               END LOOP;

               -- UTILIZA O PRÓPRIO VALOR DO IMPOSTO NA SUA BASE DE CÁLCULO (IMPOSTO POR DENTRO)
               BEGIN
                  SELECT NVL(MAX(IDUTILPVRIMPBC), 'N')
                    INTO V_IDUTILPVRIMPBC
                    FROM IMPOSTO
                   WHERE CDIMPOSTO = C_INCIDENCIA.CDIMPOTEMP;
               EXCEPTION
                  WHEN NO_DATA_FOUND THEN
                     V_IDUTILPVRIMPBC := 'N';
               END;

               V_TAXABASECALC := (100 - V_PREDBCTMP)/100;
               V_TAXAALIQUOTA := (V_ALIQUTMP/100);
               V_TAXABCSUBSTR := 1 + (V_PBCSUBTRIB/100);
               V_BASECALCIT   := V_LIQUIITEM * V_TAXABASECALC;

               -- EM MG O CÁLCULO DA BASE É REALIZADO DE UMA FORMA DIFERENTE DE ACORDO COM A 
               -- ORIENTAÇÃO TRIBUTÁRIA DOLT/SUTRI Nº 003/2016. PARA ESTE PROCESSO É NECESSÁRIO
               -- CALCULAR O IMPOSTO POR DENTRO (ELE COMPONDO A BASE DE CÁLCULO DELE MESMO)
               IF (V_IDCALCDIFALDENT = 'S') THEN
                  IF ((V_PAISDEST = '0055') AND (UPPER(V_ESTADEST) = 'MG')) AND ((V_PAISORIG = '0055') AND (UPPER(V_ESTAORIG) = 'MG')) THEN
                     IF (V_IDCONSFINAL = 'S') THEN
                        IF (V_VRADICALIQFECP IS NOT NULL) AND (V_VRADICALIQFECP > 0) THEN
                           IF (V_IDUTILPVRIMPBC = 'S') THEN
                              IF C_INCIDENCIA.CDIMPOSTONFE = '00' THEN
                                 V_BASECALCIT := V_BASECALCIT/((100-V_ALIQUTMP)/100);
                              END IF;
                           END IF;
                        END IF;
                    END IF;
                  ELSIF ((V_PAISORIG = '0055') AND (UPPER(V_ESTAORIG) = 'MG')) THEN
                     V_ALIQICMSDEST := 0;
                     V_ALIQFECPDEST := 0;
                     IF (V_IDINTEREST = 'S') AND (V_IDCONSFINAL = 'S') AND (V_IDCONTRIBICMSAUX = 'N') AND (V_IDPRESENCIAL <> '1') THEN
                        IF C_INCIDENCIA.CDIMPOSTONFE = '00' THEN
                           -- CONSULTANDO A ALÍQUOTA INTERNA DO IMPOSTO
                           DELETE 
                             FROM ALIQTEMP
                            WHERE NRALIQTEMP = V_ALIQTEMP;

                           IF C_INCIDENCIA.IDUTMUNIORIG = w_D THEN
                              CONSULTA_ALIQUOTA(C_INCIDENCIA.CDIMPOTEMP, w_S, P_EMPRESA, C_ITEMPRODUTO.CDARVPROD, P_INSCESTA, V_PAISDEST,
                                                V_ESTADEST, V_PAISDEST, V_ESTADEST, V_MUNIDEST, V_LIQUIITEM, P_INIVALID, P_FILIAL, P_LANCTONF, V_CDGRPFISCSV, P_TIPOOPER,
                                                NULL, NULL, NULL, NULL, NULL, NULL, C_ITEMPRODUTO.IDORIGEMPROD);
                           ELSE
                              CONSULTA_ALIQUOTA(C_INCIDENCIA.CDIMPOTEMP, w_S, P_EMPRESA, C_ITEMPRODUTO.CDARVPROD, P_INSCESTA, V_PAISDEST,
                                                V_ESTADEST, V_PAISDEST, V_ESTADEST, V_MUNIORIG, V_LIQUIITEM, P_INIVALID, P_FILIAL, P_LANCTONF, V_CDGRUPOFISC, P_TIPOOPER,
                                                NULL, NULL, NULL, NULL, NULL, NULL, C_ITEMPRODUTO.IDORIGEMPROD);
                           END IF;
                           BEGIN
                              SELECT MAX(VRALIQUTMP)
                                INTO V_ALIQICMSDEST
                                FROM ALIQTEMP
                               WHERE NRALIQTEMP = V_ALIQTEMP;
                           EXCEPTION
                              WHEN NO_DATA_FOUND THEN
                                 V_ALIQICMSDEST := NULL;
                           END;
                           IF V_ALIQICMSDEST IS NULL THEN
                              BEGIN
                                 SELECT NVL(CONSULTA_QUADRO_ALIQUOTAS(V_ESTADEST, V_ESTADEST), 0)
                                   INTO V_ALIQICMSDEST
                                   FROM DUAL;
                              EXCEPTION
                                 WHEN NO_DATA_FOUND THEN
                                    V_ALIQICMSDEST := 0;
                              END;
                           END IF;
                            -- CONSULTANDO A ALÍQUOTA DO FCP (FUNDO DE COMBATE A POBREZA)
                           BEGIN
                              SELECT CDIMPOSTO
                                INTO V_CDIMPOSTOFECP
                                FROM IMPOSTO
                               WHERE CDIMPOSTONFE = '01';
                           EXCEPTION
                              WHEN NO_DATA_FOUND THEN
                                 V_CDIMPOSTOFECP := NULL;
                           END;
                           IF V_CDIMPOSTOFECP IS NOT NULL THEN
                              DELETE
                                FROM ALIQTEMP
                               WHERE NRALIQTEMP = V_ALIQTEMP;
                              --VERIFICANDO SE EXISTE A INCIDÊNCIA DE FECP PARA O PRODUTO
                              IF C_INCIDENCIA.IDUTMUNIORIG = w_D THEN
                                 CONSULTA_ALIQUOTA(V_CDIMPOSTOFECP, w_S, P_EMPRESA, C_ITEMPRODUTO.CDARVPROD, P_INSCESTA, V_PAISDEST,
                                                   V_ESTADEST, V_PAISDEST, V_ESTADEST, V_MUNIDEST, V_LIQUIITEM, P_INIVALID, P_FILIAL, P_LANCTONF, V_CDGRPFISCSV, P_TIPOOPER,
                                                   NULL, NULL, NULL, NULL, NULL, NULL, C_ITEMPRODUTO.IDORIGEMPROD);
                              ELSE
                                 CONSULTA_ALIQUOTA(V_CDIMPOSTOFECP, w_S, P_EMPRESA, C_ITEMPRODUTO.CDARVPROD, P_INSCESTA, V_PAISDEST,
                                                   V_ESTADEST, V_PAISDEST, V_ESTADEST, V_MUNIORIG, V_LIQUIITEM, P_INIVALID, P_FILIAL, P_LANCTONF, V_CDGRUPOFISC, P_TIPOOPER,
                                                   NULL, NULL, NULL, NULL, NULL, NULL, C_ITEMPRODUTO.IDORIGEMPROD);
                              END IF;
                              BEGIN
                                 SELECT NVL(MAX(VRALIQUTMP), 0)
                                   INTO V_ALIQFECPDEST
                                   FROM ALIQTEMP
                                  WHERE NRALIQTEMP = V_ALIQTEMP;
                              EXCEPTION
                                 WHEN NO_DATA_FOUND THEN
                                    V_ALIQFECPDEST := 0;
                              END;
                           ELSE
                              V_ALIQFECPDEST := 0;
                           END IF;                        
                           -- REALIZANDO O CÁLCULO DA BASE COM O IMPOSTO POR DENTRO
                           -- BASE DE CÁLCULO REAL = BASE DE CÁLCULO / (1 - ((ALIQUOTA DO IMPOSTO + ALIQUOTA DO FCP) / 100)
                           V_BASECALCIT := V_BASECALCIT/((100-(V_ALIQICMSDEST+V_ALIQFECPDEST))/100);
                        END IF;
                     END IF;
                  END IF;
               END IF;

               IF V_CDIMPOSTRIB IS NULL THEN
                  V_IDTRIMPSTII := '';

                  V_PERDBCALC := 100 - V_PREDBCTMP;

                  IF V_PBCSUBTRIB > 0 THEN
                     V_BASECALCIT := (V_BASECALCIT * V_TAXABCSUBSTR);
                     V_PREDBCTMP  := V_PBCSUBTRIB;
                     V_PERDBCALC  := 0;
                  END IF;

                  IF (C_INCIDENCIA.IDUTVLRQTDEIMPO = 'S') THEN
                     SELECT NVL(MAX(VRFATOCONVES), 1)
                       INTO V_VRFATOCONVES
                       FROM CONVPRODUTO
                      WHERE CDPRODUTO = C_ITEMPRODUTO.CDPRODUTO;

                     V_BASECALCTO  := (C_ITEMPRODUTO.QTITEMPROD * V_VRFATOCONVES);
                     V_IMPOSTOIT   := ((C_ITEMPRODUTO.QTITEMPROD * V_VRFATOCONVES) * V_ALIQUTMP) - V_PARDEDTMP;
                  ELSE
                     V_BASECALCTO  := V_BASECALCIT;
                     V_IMPOSTOIT   := (V_BASECALCIT * V_TAXAALIQUOTA) - V_PARDEDTMP;
                  END IF;
               ELSE
                  IF SUBSTR(V_SITUTRIBPR, 2, 2) = '60' THEN
                     V_IDTRIMPSTII := w_2;
                  ELSE 
                     V_IDTRIMPSTII := V_TRATIMPST;
                  END IF;

                  IF NVL(V_IDPMCBASECAL, W_N) = W_S THEN
                     CALCULA_BC_PMC(P_FILIAL,
                                    P_LANCTONF,
                                    C_ITEMPRODUTO.NRSEQITPROD,
                                    C_INCIDENCIA.CDIMPOTEMP,
                                    V_IDCONSMVAPMC,
                                    V_IDCONSCOMPBCPMC,
                                    V_PAISDEST,
                                    V_ESTADEST,
                                    C_ITEMPRODUTO.CDPRODUTO,
                                    C_ITEMPRODUTO.QTITEMPROD,
                                    C_ITEMPRODUTO.VRUNITITEM,
                                    C_ITEMPRODUTO.VRDESCITEM,
                                    V_PBCSUBTRIB,
                                    V_PREDBCTMP,
                                    NULL,
                                    NULL,
                                    NULL,
                                    NULL,
                                    NULL,
                                    NULL,
                                    'N',
                                    V_BASECALCTO);

                     V_IMPOSTOIT := (V_BASECALCTO * V_TAXAALIQUOTA) - V_PARDEDTMP;
                  ELSIF (V_IDCONSDIFALIQ = 'S') AND (C_INCIDENCIA.CDIMPOSTONFE = '80') THEN
                     CONSIDERA_DIFAL_ICMS(P_FILIAL,
                                          P_LANCTONF,
                                          C_ITEMPRODUTO.NRSEQITPROD,
                                          V_CDGRPFISCSV,
                                          V_PAISDEST,
                                          V_ESTADEST,
                                          V_MUNIDEST,
                                          V_PBCSUBTRIB,
                                          V_PREDBCTMP,
                                          V_BASECALCTO,
                                          V_IMPOSTOIT,
                                          V_VRADICFECP);
                  ELSE
                     UPDATE ITEMPRODUTO
                        SET IDUTILBCPMC = 'N'
                      WHERE CDFILIAL = P_FILIAL
                        AND NRLANCTONF = P_LANCTONF
                        AND NRSEQITPROD = C_ITEMPRODUTO.NRSEQITPROD;

                     V_PERDBCALC := 100 - V_PREDBCTMP;

                     IF V_PBCSUBTRIB > 0 THEN
                        V_BASECALCIT := (V_BASECALCIT * V_TAXABCSUBSTR);
                        V_PREDBCTMP  := V_PBCSUBTRIB;
                        V_PERDBCALC  := 0;
                     END IF;

                     V_BASECALCTO  := V_BASECALCIT;
                     V_IMPOSTOIT   := (V_BASECALCIT * V_TAXAALIQUOTA) - V_PARDEDTMP;
                  END IF;
               END IF; 

               V_CONTABCALC  := V_LIQUIITEM - (V_LIQUIITEM * V_TAXABASECALC);

               IF (V_IMPOSTOIT < 0) THEN
                  V_IMPOSTOIT := 0;
               END IF;

               IF (V_IDCONSDIFALIQ = 'N') THEN
                  V_VRADICFECPST := 0;
                  V_VRADICFECPSTAUX := 0;
                  IF (V_VRADICALIQFECP IS NOT NULL) AND (V_VRADICALIQFECP > 0) THEN
                     V_VRADICFECP := ROUND(V_BASECALCTO*(V_VRADICALIQFECP/100), 2);
                  END IF;
   
                  IF (V_CDIMPOSTRIB IS NOT NULL) THEN
                     V_VRIMPOSST   := 0;
                     V_VRIMPOSTOST := 0;
                     FOR C_SUBSTRIB IN (SELECT NVL(IDVRIMPSTRIB, 'N') IDVRIMPSTRIB, I.CDIMPOSTO
                                          FROM ITEMPROIMPOS I, IMPOSTO II
                                         WHERE (CDFILIAL     = P_FILIAL)
                                           AND (NRLANCTONF   = P_LANCTONF)
                                           AND (NRSEQITPROD  = C_ITEMPRODUTO.NRSEQITPROD)
                                           AND (NRITPROIMPOS = '1')
                                           AND (INSTR(V_CDIMPOSTRIB,II.CDIMPOSTO||'_') > 0)
                                           AND (I.CDIMPOSTO = II.CDIMPOSTO))
                     LOOP
                        IF (C_SUBSTRIB.IDVRIMPSTRIB = w_S) THEN
                           Begin
                              SELECT NVL(ROUND(MAX(VRIMPOSTOIT), 2),0),
                                     NVL(ROUND(MAX(VRADICFECP), 2),0)
                              INTO   V_VRIMPOSST,
                                     V_VRADICFECPSTAUX
                              FROM ITEMPROIMPOS I
                              WHERE (CDFILIAL     = P_FILIAL)                   AND
                                    (NRLANCTONF   = P_LANCTONF)                 AND
                                    (NRSEQITPROD  = C_ITEMPRODUTO.NRSEQITPROD)  AND
                                    (CDIMPOSTO    = C_SUBSTRIB.CDIMPOSTO)       AND
                                    (INSTR(V_CDIMPOSTRIB,CDIMPOSTO||'_') > 0)   AND
                                    (NRITPROIMPOS = w_1);
                           Exception
                              When No_Data_Found Then
                                 V_VRIMPOSST := 0;
                                 V_VRADICFECPSTAUX := 0;
                           End;
                        ELSE
                           V_VRIMPOSST := 0;
                           V_VRADICFECPSTAUX := 0;
                        END IF;
                        V_VRIMPOSTOST := V_VRIMPOSTOST + V_VRIMPOSST;
                        V_VRADICFECPST := V_VRADICFECPST + V_VRADICFECPSTAUX;
                     END LOOP;
   
                     V_IMPOSTOIT := V_IMPOSTOIT - V_VRIMPOSTOST;
   
                     IF V_IMPOSTOIT < 0 THEN
                        V_IMPOSTOIT := 0;
                     END IF;
                  END IF;
   
                  IF (V_VRADICALIQFECP IS NOT NULL) AND (V_VRADICALIQFECP > 0) THEN
                     V_VRADICFECP := V_VRADICFECP - V_VRADICFECPST;
                  END IF;
               END IF;

               /* Rotina para calcular o ICMS ST considerando % carga tributária média */
               V_IDIMPSTCARGTRIB := 'N';

               IF V_CDIMPOSTRIB IS NOT NULL THEN
                  BEGIN
                     SELECT NVL(VRCNAEBC, 0),
                            NVL(VRMVA, 0)
                       INTO V_VRPRODUTOBC,
                            V_VRMVA
                       FROM VRPERCCARGTRIBCNAE
                      WHERE IDENTRSAIDOP = w_S
                        AND CDTIPOOPER   = P_TIPOOPER
                        AND CDPAIS       = V_PAISDEST
                        AND SGESTADO     = V_ESTADEST
                        AND CDCNAE       = V_CDCNAECLIE
                        AND IDOPTANTESN  = V_IDOPTANTESNCLIE;
                  EXCEPTION
                     WHEN NO_DATA_FOUND THEN
                        V_VRPRODUTOBC := 0;
                        V_VRMVA := 0;
                  END;
                  IF V_VRPRODUTOBC = 0 THEN
                     BEGIN
                        SELECT NVL(VRPRODUTOBC, 0)
                          INTO V_VRPRODUTOBC
                          FROM VRPERCCARGTRIB
                         WHERE IDENTRSAIDOP = w_S
                           AND CDTIPOOPER   = P_TIPOOPER
                           AND CDPAIS       = V_PAISDEST
                           AND SGESTADO     = V_ESTADEST
                           AND CDPRODUTO    = C_ITEMPRODUTO.CDPRODUTO;
                     EXCEPTION
                        WHEN NO_DATA_FOUND THEN
                           V_VRPRODUTOBC := 0;
                     END;
                  END IF;

                  IF (V_VRPRODUTOBC > 0) THEN
                     BEGIN
                        SELECT I.CDIMPOSTO, I.VRIMPOSTOIT
                          INTO V_CDIMPOSTOICMS, V_VRIMPOSTOICMS
                          FROM IMPOSTONFE N, IMPOSTO P, ITEMPROIMPOS I
                         WHERE N.CDIMPOSTONFE = P.CDIMPOSTONFE
                           AND N.CDIMPOSTONFE = '00'
                           AND I.CDFILIAL     = P_FILIAL
                           AND I.NRLANCTONF   = P_LANCTONF
                           AND I.NRSEQITPROD = C_ITEMPRODUTO.NRSEQITPROD
                           AND I.CDIMPOSTO = NVL(P.CDIMPOSREGNORMA, P.CDIMPOSTO)
                           AND NOT P.CDIMPOSTRIB IS NULL
                           AND I.NRITPROIMPOS = '1';
                     EXCEPTION
                        When No_Data_Found Then
                           V_CDIMPOSTOICMS := NULL; V_VRIMPOSTOICMS := 0;
                     END;

                     DELETE ALIQTEMP
                      WHERE NRALIQTEMP = V_ALIQTEMP;

                     /* Verifica grupo fiscal */
                     SELECT MAX(IDGRUPFISSRV)
                     INTO V_UTGRUPFISCS
                     FROM IMPOSTO
                     WHERE CDIMPOSTO = V_CDIMPOSTOICMS;

                     IF V_UTGRUPFISCS = 'S' THEN
                        V_CDGRPFISCSV := NULL;
                        SELECT MAX(CDGRUPOFISC)
                        INTO V_CDGRPFISCSV
                        FROM SERVCLIE SC, SERVICO S
                        WHERE SC.CDFILIAL   = V_CDFILIEMIT AND
                              SC.CDCLIENTE  = P_CLIENTE    AND
                              SC.CDFILIAL   = S.CDFILIAL   AND
                              SC.CDSERVFILI = S.CDSERVFILI AND
                              S.CDPRODUTO   = C_ITEMPRODUTO.CDPRODUTO;

                        IF V_CDGRPFISCSV IS NULL THEN
                           SELECT MAX(CDGRUPOFISC)
                           INTO V_CDGRPFISCSV
                           FROM CLIENFILIAL
                          WHERE CDFILIAL   = V_CDFILIEMIT AND
                                CDCLIENTE  = P_CLIENTE;
                        END IF;

                        CONSULTA_ALIQUOTA(V_CDIMPOSTOICMS, w_S, P_EMPRESA, C_ITEMPRODUTO.CDARVPROD, P_INSCESTA, V_PAISDEST,
                                          V_ESTADEST, V_PAISDEST, V_ESTADEST, V_MUNIDEST, V_LIQUIITEM, P_INIVALID, P_FILIAL, P_LANCTONF, V_CDGRPFISCSV, P_TIPOOPER,
                                          NULL, NULL, NULL, NULL, NULL, NULL, C_ITEMPRODUTO.IDORIGEMPROD);

                     ELSE
                        CONSULTA_ALIQUOTA(V_CDIMPOSTOICMS, w_S, P_EMPRESA, C_ITEMPRODUTO.CDARVPROD, P_INSCESTA, V_PAISDEST,
                                          V_ESTADEST, V_PAISDEST, V_ESTADEST, V_MUNIDEST, V_LIQUIITEM, P_INIVALID, P_FILIAL, P_LANCTONF, V_CDGRUPOFISC, P_TIPOOPER,
                                          NULL, NULL, NULL, NULL, NULL, NULL, C_ITEMPRODUTO.IDORIGEMPROD);

                     END IF;

                     SELECT NVL(MAX(VRALIQUTMP),0)
                       INTO V_VRALIQUTMPDEST
                       FROM ALIQTEMP
                      WHERE (NRALIQTEMP = V_ALIQTEMP);

                     IF (V_VRALIQUTMPDEST <> 0) THEN
                        V_IMPOSTOIT  :=  ROUND(V_BASECALCIT * (V_VRPRODUTOBC/100), 2);
                        V_BASECALCTO :=  ROUND(((V_VRIMPOSTOICMS + V_IMPOSTOIT) / (V_VRALIQUTMPDEST/100)),5);  
                        V_IDIMPSTCARGTRIB := 'S';
                     END IF;

                     DELETE ALIQTEMP
                      WHERE NRALIQTEMP = V_ALIQTEMP;
                  END IF;
               END IF;

               /* ROTINA PARA CALCULAR O DIFERIMENTO DO IMPOSTO */
               V_PERDIFERE    := NULL;
               V_IMPOSTOOPERA := NULL;
               V_IMPOSTODIFER := NULL;

               IF C_INCIDENCIA.CDIMPOSTONFE = '00' THEN
                  IF V_CDSITTRIBTMP = 51 THEN
                     BEGIN
                        SELECT PD.VRPERDIFERE, 'S' 
                          INTO V_VRPERDIFERE, V_IDDIFECLI
                          FROM PRODDIFEREIMPCLI PD, PRODUTO PR
                         WHERE PD.CDPRODUTO = PR.CDPRODUTO
                           AND PD.CDPAIS = V_PAISORIG
                           AND PD.SGESTADO = V_ESTAORIG
                           AND PD.CDCLIENTE = P_CLIENTE
                           AND PR.CDARVPROD IN (SELECT MAX(PR.CDARVPROD) AS CDARVPROD
                                                  FROM PRODDIFEREIMPCLI PD, PRODUTO PR
                                                 WHERE PD.CDPRODUTO = PR.CDPRODUTO
                                                   AND PD.CDPAIS = V_PAISORIG
                                                   AND PD.SGESTADO = V_ESTAORIG
                                                   AND PD.CDCLIENTE = P_CLIENTE
                                                   AND INSTR(NVL(RTRIM(C_ITEMPRODUTO.CDARVPROD), PR.CDARVPROD), PR.CDARVPROD) = 1);
                     EXCEPTION
                        WHEN NO_DATA_FOUND THEN
                           V_VRPERDIFERE := NULL; V_IDDIFECLI := 'N';
                     END;

                     IF V_IDDIFECLI = 'N' THEN
                        BEGIN
                           SELECT PD.VRPERDIFERE
                             INTO V_VRPERDIFERE
                             FROM PRODDIFEREIMPOS PD, PRODUTO PR
                            WHERE PD.CDPRODUTO = PR.CDPRODUTO
                              AND PD.CDPAIS = V_PAISORIG
                              AND PD.SGESTADO = V_ESTAORIG
                              AND PR.CDARVPROD IN (SELECT MAX(PR.CDARVPROD) AS CDARVPROD
                                                     FROM PRODDIFEREIMPOS PD, PRODUTO PR
                                                    WHERE PD.CDPRODUTO = PR.CDPRODUTO
                                                      AND PD.CDPAIS = V_PAISORIG
                                                      AND PD.SGESTADO = V_ESTAORIG
                                                      AND INSTR(NVL(RTRIM(C_ITEMPRODUTO.CDARVPROD), PR.CDARVPROD), PR.CDARVPROD) = 1);
                        EXCEPTION
                           WHEN NO_DATA_FOUND THEN
                              V_VRPERDIFERE := NULL;
                        END;
                     END IF;

                     IF V_VRPERDIFERE IS NOT NULL THEN
                        V_PERDIFERE    := ROUND(V_VRPERDIFERE, 2);
                        V_IMPOSTOOPERA := ROUND(V_IMPOSTOIT, 2);
                        V_IMPOSTODIFER := ROUND((V_IMPOSTOOPERA * (V_VRPERDIFERE/100)), 2);
                        V_IMPOSTOIT := ROUND(V_IMPOSTOOPERA, 2) - ROUND(V_IMPOSTODIFER, 2);
                     END IF;
                  END IF;
               END IF;

               V_BASECALCIRRF := V_BASECALCTO;

               IF (V_ALIQUTMP = 0) AND (V_IMPOSTOIT = 0) THEN
                  V_BASECALCTO := 0;
               END IF;

               SELECT NVL(MAX(IDPERVISIMPSCRE),'S')
                 INTO V_IDPERVISIMPSCRE
                 FROM PARAMGERAL;

               IF V_IDPERVISIMPSCRE = 'S' THEN
                  V_VRIMPOSTOVISUIT := V_IMPOSTOIT;
               ELSE

                  IF (C_INCIDENCIA.CDFISCTEMP = '1') THEN
                     V_VRIMPOSTOVISUIT := V_IMPOSTOIT;
                  ELSE
                     V_VRIMPOSTOVISUIT := 0;
                  END IF;
               END IF;

               V_ICMS := 'N';
               FOR C_ICMS IN (SELECT CDIMPOSTO
                                FROM IMPOSTONFE N, IMPOSTO I
                               WHERE N.CDIMPOSTONFE = I.CDIMPOSTONFE
                                 AND N.CDIMPOSTONFE = '00'
                                 AND I.CDIMPOSTO = C_INCIDENCIA.CDIMPOTEMP)
               LOOP
                  V_ICMS := 'S';
               END LOOP;

               Begin
                  SELECT CDFILIAL
                  INTO   V_CHAVE
                  FROM ITEMPROIMPOS
                  WHERE CDFILIAL     = P_FILIAL                 AND
                        NRLANCTONF   = P_LANCTONF               AND
                        NRSEQITPROD  = C_ITEMPRODUTO.NRSEQITPROD  AND
                        CDIMPOSTO    = C_INCIDENCIA.CDIMPOTEMP AND
                        NRITPROIMPOS = w_1;
               Exception
                  When No_Data_Found Then
                     V_CHAVE := Null;
               End;

               IF V_CHAVE IS NULL THEN

                  IF (V_ICMS = 'S') THEN

                     IF C_ITEMPRODUTO.CDCFOPINFUSU IS NULL THEN

                        V_CDGRUPOFISCAUX := NULL;

                        SELECT MAX(G.CDGRUPOFISC)
                          INTO V_CDGRUPOFISCAUX
                          FROM GRUPOFISCIMPFIL G,
                               (SELECT CDFILIEMIT AS CDFILIAL
                                  FROM NOTAFISCAL
                                 WHERE CDFILIAL = P_FILIAL
                                       AND NRLANCTONF = P_LANCTONF) F
                         WHERE G.CDFILIAL = F.CDFILIAL
                           AND NOT G.CDGRUPOFISC IS NULL
                           AND G.CDIMPOSTO = C_INCIDENCIA.CDIMPOTEMP;
                        IF V_IDORIGDESTNF = 'C' THEN
                           SELECT NVL(MAX(G.CDGRUPOFISC), V_CDGRUPOFISCAUX)
                             INTO V_CDGRUPOFISCAUX
                             FROM GRFISIMPIECLIE G,
                                  (SELECT CDCLIENTE
                                     FROM NOTAFISCAL
                                    WHERE CDFILIAL = P_FILIAL
                                      AND NRLANCTONF = P_LANCTONF) N
                            WHERE G.CDCLIENTE = N.CDCLIENTE
                              AND G.CDEMPRESA = P_EMPRESA
                              AND G.CDINSCESTA = P_INSCESTA
                              AND NOT G.CDGRUPOFISC IS NULL
                              AND G.CDIMPOSTO = C_INCIDENCIA.CDIMPOTEMP;
                        ELSE
                           SELECT NVL(MAX(G.CDGRUPOFISC), V_CDGRUPOFISCAUX)
                             INTO V_CDGRUPOFISCAUX
                             FROM GRFISIMPIEFORN G,
                                 (SELECT CDFORNECED
                                    FROM NOTAFISCAL
                                   WHERE CDFILIAL = P_FILIAL
                                     AND NRLANCTONF = P_LANCTONF) N
                            WHERE G.CDFORNECED = N.CDFORNECED
                              AND G.CDEMPRESA = P_EMPRESA
                              AND G.CDINSCESTA = P_INSCESTA
                              AND NOT G.CDGRUPOFISC IS NULL
                              AND G.CDIMPOSTO = C_INCIDENCIA.CDIMPOTEMP;
                        END IF;

                        IF (V_CDGRUPOFISCAUX IS NOT NULL) THEN
                           CONSULTA_CFOP(w_S, P_EMPRESA, C_ITEMPRODUTO.CDARVPROD, P_INSCESTA, P_TIPOOPER, V_PAISORIG,
                                         V_ESTAORIG, V_PAISCFOP, V_ESTACFOP, P_FILIAL, P_LANCTONF, V_CDGRUPOFISCAUX, P_INIVALID, C_ITEMPRODUTO.IDORIGEMPROD);

                        ELSE
                           CONSULTA_CFOP(w_S, P_EMPRESA, C_ITEMPRODUTO.CDARVPROD, P_INSCESTA, P_TIPOOPER, V_PAISORIG,
                                         V_ESTAORIG, V_PAISCFOP, V_ESTACFOP, P_FILIAL, P_LANCTONF, V_CDGRUPOFISC, P_INIVALID, C_ITEMPRODUTO.IDORIGEMPROD);

                        END IF;
                        IF (V_CDFISCOPERREGRA IS NOT NULL) THEN
                           IF (LENGTH(V_CDFISCOPERREGRA) < 4) THEN
                              V_CDFISCOPERREGRA := V_CFOP1DIGT||V_CDFISCOPERREGRA;
                           END IF;
                           V_DSCDFISOPEITREGRA := SUBSTR(DESCRICAO_CFOP(V_CDFISCOPERREGRA),1,45);
                        END IF;

                        IF (V_DSCDFISOPEITREGRA IS NOT NULL) THEN
                           UPDATE NOTAFISCAL
                              SET DSCDFISOPENF = V_DSCDFISOPEITREGRA
                            WHERE CDFILIAL   = P_FILIAL   AND
                                  NRLANCTONF = P_LANCTONF;
                        ELSE
                           UPDATE NOTAFISCAL
                              SET DSCDFISOPENF = (SELECT MAX(DSCFOPTMP)
                                                    FROM CFOPTEMP
                                                   WHERE NRCFOPTEMP = V_CFOPTEMP)
                            WHERE CDFILIAL   = P_FILIAL
                              AND NRLANCTONF = P_LANCTONF;

                        END IF;

                        SELECT MAX(CDFISOPETMP), MAX(CDSUFCFOPTMP), SUBSTR(MAX(DSCFOPTMP),1,50)
                          INTO V_FISOPEITEM    , V_SUFXCFOPPR, V_DSCDFISOPEIT
                          FROM CFOPTEMP
                         WHERE NRCFOPTEMP = V_CFOPTEMP;

                        UPDATE ITEMPRODUTO
                           SET CDFISOPEITEM  = NVL(V_CDFISCOPERREGRA, V_FISOPEITEM),
                               CDSUFXCFOPPR  = V_SUFXCFOPPR,
                               DSCDFISOPEIT  = NVL(V_DSCDFISOPEITREGRA, V_DSCDFISOPEIT)
                         WHERE CDFILIAL    = P_FILIAL AND
                               NRLANCTONF  = P_LANCTONF AND
                               NRSEQITPROD = C_ITEMPRODUTO.NRSEQITPROD;

                        DELETE CFOPTEMP
                         WHERE NRCFOPTEMP = V_CFOPTEMP;
                     END IF;

                     Begin
                        SELECT MAX(CDCSTDIG1PROD)
                          INTO V_CST1DIGT
                          FROM PRODUTO
                         WHERE (CDARVPROD = C_ITEMPRODUTO.CDARVPROD);

                        IF V_CST1DIGT IS NULL THEN
                           SELECT MAX(CDCSTDIG1SAI)
                             INTO   V_CST1DIGT
                             FROM INSCRESTAD
                            WHERE (CDEMPRESA  = P_EMPRESA) AND
                                  (CDINSCESTA = P_INSCESTA);
                        END IF;
                     Exception
                        When No_Data_Found Then
                           V_CST1DIGT := Null;
                     End;

                     IF (V_IDUTORIGPROD = 'S') AND (C_ITEMPRODUTO.IDORIGEMPROD = 'E') THEN
                        V_CST1DIGT := '2';
                     END IF;

                     UPDATE ITEMPRODUTO
                        SET CDSITUTRIBPR  = V_CST1DIGT||NVL(V_CDSITTRIBTMP, SUBSTR(V_SITUTRIBPR, 2,2))
                      WHERE CDFILIAL    = P_FILIAL AND
                            NRLANCTONF  = P_LANCTONF AND
                            NRSEQITPROD = C_ITEMPRODUTO.NRSEQITPROD;

                     V_SITUTRIBPR := V_CST1DIGT||NVL(V_CDSITTRIBTMP, SUBSTR(V_SITUTRIBPR, 2,2));
                  END IF;

                  IF (NVL(V_CFOPINFUSU, 'N') <> 'S') AND (V_CDFISCOPERREGRA IS NOT NULL) THEN
                     V_FISOPEITEM := NVL(V_CDFISCOPERREGRA, V_FISOPEITEM);
                     V_DSCDFISOPEITREGRA := SUBSTR(DESCRICAO_CFOP(V_CDFISCOPERREGRA),1,45);
                  END IF;

                  /*IF (V_VRADICALIQFECP IS NOT NULL) AND (V_VRADICALIQFECP > 0) THEN
                     V_VRADICFECP := ROUND(V_BASECALCTO*(V_VRADICALIQFECP/100), 2);
                  END IF;*/

                  INSERT INTO ITEMPROIMPOS(
                     CDFILIAL, NRLANCTONF, NRSEQITPROD, CDIMPOSTO, NRITPROIMPOS, CDFISCALIT,
                     CDSITUTRIBIT, CDFISCOPERIT, CDSUFXCFOPIT, VRALIQITEM, VRPERREDBCIT, VRPARDEDIT,
                     VRCONTITIMP, VRBASECALCIT, VRIMPOSTOIT, IDERROSIMPIT, IDAVISIMPIT, IDTRIMPSTII,
                     CDSITUTRIBITNFE, IDMODBCITNFE, IDMODBCSTITNFE, CDTPCREDPICOITE, CDNATUBCALPCIT, IDMOTDESONERAIT,
                     CDSIMPLESNACIONAL, CDFAIXA, VRBCICMSSTRETIDO, VRICMSSTRETIDO, CDREGRAIT, CDDETALHEPROD,
                     VRIMPOSTOVISUIT, VRBCALCIRRF, VRPERDIFEREIT, VRIMPOSTOOPERAIT, VRIMPOSTODIFERIT,
                     CDENQLEGALIPI, CDCEST, IDIMPSTCARGTRIB, VRADICALIQFECP, VRADICFECP,
                     VRALIQINTEDEST, VRALIQFCP, CDBENEFFISCAL, IDCONSDIFALIQ)
                  VALUES(
                     P_FILIAL, P_LANCTONF, C_ITEMPRODUTO.NRSEQITPROD, C_INCIDENCIA.CDIMPOTEMP, w_1, C_INCIDENCIA.CDFISCTEMP,
                     V_SITUTRIBPR, V_FISOPEITEM, V_SUFXCFOPPR, V_ALIQUTMP, V_PREDBCTMP, V_PARDEDTMP,
                     ROUND(V_BASECALCTO,5), ROUND(V_BASECALCTO,2), V_IMPOSTOIT, w_00000, w_00000, V_IDTRIMPSTII,   
                     V_CDSITTRIBTMP, V_IDMODBCNFE, V_IDMODBCSTNFE, V_CDTPCRPICOSTNFE, V_CDNATUBCPCSTNFE, V_IDMOTIDESSTNFE,
                     V_CDSIMPLESNACIONAL, V_CDFAIXA, V_BCICMSSTRETIDO, V_VRICMSSTRETIDO, V_CDREGRAITALIQ, C_INCIDENCIA.CDDETALHEPROD,
                     V_VRIMPOSTOVISUIT, V_BASECALCIRRF, V_PERDIFERE, V_IMPOSTOOPERA, V_IMPOSTODIFER,
                     C_INCIDENCIA.CDENQLEGALIPI, C_INCIDENCIA.CDCEST, V_IDIMPSTCARGTRIB, V_VRADICALIQFECP, V_VRADICFECP, 
                     V_ALIQICMSDEST, V_ALIQFECPDEST, V_CDBENEFFISCAL, NVL(V_IDCONSDIFALIQ, 'N'));

                  IF (V_PREDBCTMP > 0) AND (V_PBCSUBTRIB = 0) THEN
                     IF V_SITUTRIBPR = '060' THEN
                        INSERT INTO ITEMPROIMPOS(
                           CDFILIAL, NRLANCTONF, NRSEQITPROD, CDIMPOSTO, NRITPROIMPOS, CDFISCALIT,
                           CDSITUTRIBIT, CDFISCOPERIT, CDSUFXCFOPIT, VRALIQITEM, VRPERREDBCIT, VRPARDEDIT,
                           VRCONTITIMP, VRBASECALCIT, VRIMPOSTOIT, IDERROSIMPIT, IDAVISIMPIT, CDSITUTRIBITNFE,
                           IDMODBCITNFE, IDMODBCSTITNFE, CDTPCREDPICOITE, CDNATUBCALPCIT, IDMOTDESONERAIT, CDSIMPLESNACIONAL,
                           CDFAIXA, VRBCICMSSTRETIDO, VRICMSSTRETIDO, CDREGRAIT, CDDETALHEPROD,
                           VRIMPOSTOVISUIT, CDENQLEGALIPI, CDCEST, IDIMPSTCARGTRIB)
                        VALUES(
                           P_FILIAL, P_LANCTONF, C_ITEMPRODUTO.NRSEQITPROD, C_INCIDENCIA.CDIMPOTEMP, w_2, w_2,
                           V_SITUTRIBPR, V_FISOPEITEM, V_SUFXCFOPPR, 0, V_PERDBCALC, V_PARDEDTMP,
                           V_CONTABCALC, 0, 0, w_00000, w_00000, V_CDSITTRIBTMP,
                           V_IDMODBCNFE, V_IDMODBCSTNFE, V_CDTPCRPICOSTNFE, V_CDNATUBCPCSTNFE, V_IDMOTIDESSTNFE, V_CDSIMPLESNACIONAL,
                           V_CDFAIXA, V_BCICMSSTRETIDO, V_VRICMSSTRETIDO, V_CDREGRAITALIQ, C_INCIDENCIA.CDDETALHEPROD,
                           V_VRIMPOSTOVISUIT, C_INCIDENCIA.CDENQLEGALIPI, C_INCIDENCIA.CDCEST, V_IDIMPSTCARGTRIB);
                     ELSE
                        INSERT INTO ITEMPROIMPOS(
                           CDFILIAL, NRLANCTONF, NRSEQITPROD, CDIMPOSTO, NRITPROIMPOS, CDFISCALIT,
                           CDSITUTRIBIT, CDFISCOPERIT, CDSUFXCFOPIT, VRALIQITEM, VRPERREDBCIT, VRPARDEDIT,
                           VRCONTITIMP, VRBASECALCIT, VRIMPOSTOIT, IDERROSIMPIT, IDAVISIMPIT, CDSITUTRIBITNFE,
                           IDMODBCITNFE, IDMODBCSTITNFE, CDTPCREDPICOITE, CDNATUBCALPCIT, IDMOTDESONERAIT, CDSIMPLESNACIONAL,
                           CDFAIXA, VRBCICMSSTRETIDO, VRICMSSTRETIDO, CDREGRAIT, CDDETALHEPROD,
                           VRIMPOSTOVISUIT, CDENQLEGALIPI, CDCEST, IDIMPSTCARGTRIB)
                        VALUES(
                           P_FILIAL, P_LANCTONF, C_ITEMPRODUTO.NRSEQITPROD, C_INCIDENCIA.CDIMPOTEMP, w_2, w_2,
                           V_SITUTRIBPR, V_FISOPEITEM, V_SUFXCFOPPR, 0, V_PERDBCALC, V_PARDEDTMP,
                           V_CONTABCALC, 0, 0, w_00000, w_00000, V_CDSITTRIBTMP,
                           V_IDMODBCNFE, V_IDMODBCSTNFE, V_CDTPCRPICOSTNFE, V_CDNATUBCPCSTNFE, V_IDMOTIDESSTNFE, V_CDSIMPLESNACIONAL,
                           V_CDFAIXA, V_BCICMSSTRETIDO, V_VRICMSSTRETIDO, V_CDREGRAITALIQ, C_INCIDENCIA.CDDETALHEPROD,
                           V_VRIMPOSTOVISUIT, C_INCIDENCIA.CDENQLEGALIPI, C_INCIDENCIA.CDCEST, V_IDIMPSTCARGTRIB);
                     END IF;
                  END IF;
               END IF;

               FOR C_ALIQTEMP IN (SELECT DSMENSALITMP
                                  FROM ALIQTEMP
                                  WHERE (NRALIQTEMP = V_ALIQTEMP)  AND
                                        (DSMENSALITMP IS NOT NULL) AND
                                        (NOT EXISTS(SELECT DSDADOADIC
                                                    FROM DADOSADIC
                                                    WHERE (CDFILIAL   = P_FILIAL)   AND
                                                          (NRLANCTONF = P_LANCTONF) AND
                                                          (DSDADOADIC LIKE ALIQTEMP.DSMENSALITMP || '%')))) LOOP

                  IF NOT(C_ALIQTEMP.DSMENSALITMP IS NULL) THEN
                     /*PREENCHE AS MENSAGENS ATRELADAS A ALIQUOTA*/
                     INSERT INTO DADOSADIC(CDFILIAL, NRLANCTONF, NRDADOADIC, DSDADOADIC)
                                    VALUES(P_FILIAL, P_LANCTONF, V_DADOADIC, C_ALIQTEMP.DSMENSALITMP);

                     V_DADOADIC := LPAD(RTRIM(TO_CHAR(TO_NUMBER(V_DADOADIC) + 1)),3,0);
                  END IF;
               END LOOP;

               DELETE ALIQTEMP
                WHERE NRALIQTEMP = V_ALIQTEMP;

               V_VRADICALIQFECP := NULL;
               V_VRADICFECP := NULL;

            END LOOP; --FIM DO LOOP DAS INCIDÊNCIAS

            DELETE INCITEMP
            WHERE NRINCITEMP = V_INCITEMP;

         ELSE
            /*IMPOSTOS INFORMADOS PELO USUARIO*/
            FOR C_IMPOSINFUSU IN (SELECT II.CDIMPOSTO, II.CDFISCINFUSU,
                                         II.VRALIQINFUSU, II.VRRDBCINFUSU, II.VRPDEDINFUSU,
                                         I.IDTRATIMPO, I.IDCONSISTENT, I.IDIMPORECUP
                                  FROM IMPOSINFUSU II, IMPOSTO I
                                  WHERE (II.CDFILIAL    = P_FILIAL)                  AND
                                        (II.NRLANCTONF  = P_LANCTONF)                AND
                                        (II.NRSEQITPROD = C_ITEMPRODUTO.NRSEQITPROD) AND
                                        (II.CDIMPOSTO   = I.CDIMPOSTO)) LOOP

               V_TAXABASECALC := (100 - C_IMPOSINFUSU.VRRDBCINFUSU)/100;
               V_TAXAALIQUOTA := (C_IMPOSINFUSU.VRALIQINFUSU/100);

               V_IMPOSTOIT  := ((V_LIQUIITEM * V_TAXABASECALC) * V_TAXAALIQUOTA) - C_IMPOSINFUSU.VRPDEDINFUSU;
               V_CONTABCALC := V_LIQUIITEM - (V_LIQUIITEM * V_TAXABASECALC);
               V_PERDBCALC  := 100 - C_IMPOSINFUSU.VRRDBCINFUSU;

               IF (V_IMPOSTOIT < 0) THEN
                  V_IMPOSTOIT := 0;
               END IF;

               IF (C_IMPOSINFUSU.VRALIQINFUSU = 0) AND (V_IMPOSTOIT = 0) THEN
                  V_BASECALCIT := 0;
               ELSE
                  V_BASECALCIT := V_LIQUIITEM * V_TAXABASECALC;
               END IF;

               Begin
                  SELECT CDFILIAL
                  INTO   V_CHAVE
                  FROM ITEMPROIMPOS
                  WHERE CDFILIAL     = P_FILIAL                 AND
                        NRLANCTONF   = P_LANCTONF               AND
                        NRSEQITPROD  = C_ITEMPRODUTO.NRSEQITPROD  AND
                        CDIMPOSTO    = C_IMPOSINFUSU.CDIMPOSTO AND
                        NRITPROIMPOS = w_1;
               Exception
                  When No_Data_Found Then
                     V_CHAVE := Null;
               End;
               SELECT NVL(MAX(IDPERVISIMPSCRE),'S')
                 INTO V_IDPERVISIMPSCRE
                 FROM PARAMGERAL;

               IF V_IDPERVISIMPSCRE = 'S' THEN
                  V_VRIMPOSTOVISUIT := V_IMPOSTOIT;
               ELSE
                  IF (C_IMPOSINFUSU.CDFISCINFUSU = '1') THEN
                     V_VRIMPOSTOVISUIT := V_IMPOSTOIT;
                  ELSE
                     V_VRIMPOSTOVISUIT := 0;
                  END IF;
               END IF;

               IF V_CHAVE IS NULL THEN

                  INSERT INTO ITEMPROIMPOS(
                     CDFILIAL, NRLANCTONF, NRSEQITPROD, CDIMPOSTO, NRITPROIMPOS, CDFISCALIT, CDSITUTRIBIT,
                     CDFISCOPERIT, CDSUFXCFOPIT, VRALIQITEM, VRPERREDBCIT, VRPARDEDIT, VRCONTITIMP,
                     VRBASECALCIT, VRIMPOSTOIT, IDERROSIMPIT, IDAVISIMPIT, VRIMPOSTOVISUIT)
                  VALUES(
                     P_FILIAL, P_LANCTONF, C_ITEMPRODUTO.NRSEQITPROD, C_IMPOSINFUSU.CDIMPOSTO, w_1, C_IMPOSINFUSU.CDFISCINFUSU, V_SITUTRIBPR,
                     V_FISOPEITEM, V_SUFXCFOPPR, C_IMPOSINFUSU.VRALIQINFUSU, C_IMPOSINFUSU.VRRDBCINFUSU, C_IMPOSINFUSU.VRPDEDINFUSU, V_BASECALCIT,
                     V_BASECALCIT, V_IMPOSTOIT, w_00000, w_00000, V_VRIMPOSTOVISUIT);


                  IF V_PREDBCTMP > 0 THEN
                     INSERT INTO ITEMPROIMPOS(
                        CDFILIAL, NRLANCTONF, NRSEQITPROD, CDIMPOSTO, NRITPROIMPOS, CDFISCALIT, CDSITUTRIBIT,
                        CDFISCOPERIT, CDSUFXCFOPIT, VRALIQITEM, VRPERREDBCIT, VRPARDEDIT, VRCONTITIMP,
                        VRBASECALCIT, VRIMPOSTOIT, IDERROSIMPIT, IDAVISIMPIT, VRIMPOSTOVISUIT)
                     VALUES(
                        P_FILIAL, P_LANCTONF, C_ITEMPRODUTO.NRSEQITPROD, C_IMPOSINFUSU.CDIMPOSTO, w_2, w_2, V_SITUTRIBPR,
                        V_FISOPEITEM, V_SUFXCFOPPR, 0, V_PERDBCALC, C_IMPOSINFUSU.VRPDEDINFUSU, ROUND(V_CONTABCALC,5),  
                        0, 0, w_00000, w_00000, 0);
                  END IF;
               END IF;
            END LOOP; --FIM DO LOOP DOS IMPOSTOS INFORMADOS PELO USUARIO
         END IF;
      END LOOP; --FIM DO LOOP DOS PRODUTOS

      DELETE FROM REGRANOTA
      WHERE CDFILIAL = P_FILIAL
        AND NRLANCTONF = P_LANCTONF;

      FOR C_IMPOSNOTA IN (SELECT DISTINCT CDREGRAIT
                            FROM ITEMPROIMPOS
                           WHERE CDFILIAL = P_FILIAL
                             AND NRLANCTONF = P_LANCTONF
                             AND CDREGRAIT IS NOT NULL
                          ORDER BY CDREGRAIT)
      LOOP

         FOR C_REGRAMSG IN (SELECT CDREGRAFISC, DSMENSREGRAFISC
                              FROM TABLE(MSG_REGRAFISCAL(C_IMPOSNOTA.CDREGRAIT, P_EMPRESA, 'S', P_TIPOOPER, P_INSCESTA)) M
                             WHERE NOT EXISTS(SELECT DSDADOADIC
                                             FROM DADOSADIC
                                             WHERE (CDFILIAL   = P_FILIAL)   AND
                                                   (NRLANCTONF = P_LANCTONF) AND
                                                   (DSDADOADIC = M.DSMENSREGRAFISC))) LOOP

            INSERT INTO DADOSADIC(CDFILIAL, NRLANCTONF, NRDADOADIC, DSDADOADIC)
                           VALUES(P_FILIAL, P_LANCTONF, V_DADOADIC, C_REGRAMSG.DSMENSREGRAFISC);

            V_DADOADIC := LPAD(RTRIM(TO_CHAR(TO_NUMBER(V_DADOADIC) + 1)),3,0);
         END LOOP;

         INSERT INTO REGRANOTA(CDFILIAL, NRLANCTONF, CDREGRAFISC)
                           VALUES(P_FILIAL, P_LANCTONF, C_IMPOSNOTA.CDREGRAIT);
      END LOOP;

      --RATEIO DOS ENCARGOS--------------------------------------------------------------------------------------------------------
      FOR C_ITEMENCARGO IN (SELECT IE.CDENCARGO AS CDENCARGO, VRITEMENCA, IDENCARGO,
                                   EN.CDCTBLENTREN, EN.CDCTBLSAIDEN
                            FROM ITEMENCARGO IE, ENCARGO EN
                            WHERE (IE.CDFILIAL   = P_FILIAL)     AND
                                  (IE.NRLANCTONF = P_LANCTONF)   AND
                                  (IE.VRITEMENCA > 0)            AND
                                  (EN.CDENCARGO  = IE.CDENCARGO)) LOOP
         V_TOTAPRODENCA := 0;
         FOR C_VRLIQRATEIO IN (SELECT DISTINCT(IP.NRSEQITPROD) AS NRSEQITPROD, (VRTOTAITEM - VRDESCITEM) AS VRLIQUIDO
                               FROM ITEMPRODUTO IP, ITEMPROIMPOS II
                               WHERE (IP.CDFILIAL    = P_FILIAL)       AND
                                     (IP.NRLANCTONF  = P_LANCTONF)     AND
                                     (II.CDFILIAL    = IP.CDFILIAL)    AND
                                     (II.NRLANCTONF  = IP.NRLANCTONF)  AND
                                     (II.NRSEQITPROD = IP.NRSEQITPROD) AND
                                     (EXISTS(SELECT BC.CDIMPOSTO
                                             FROM BASECALC BC
                                             WHERE (BC.CDENCARGO = C_ITEMENCARGO.CDENCARGO) AND
                                                   (BC.CDIMPOSTO = II.CDIMPOSTO)            AND
                                                   (BC.CDIMPOSTO IN (SELECT B.CDIMPOSTO
                                                                    FROM BASECALC B
                                                                    WHERE B.CDENCARGO = C_ITEMENCARGO.CDENCARGO))))) LOOP

            IF NOT (C_VRLIQRATEIO.VRLIQUIDO IS NULL) THEN
               V_TOTAPRODENCA := V_TOTAPRODENCA + C_VRLIQRATEIO.VRLIQUIDO;
            END IF;
         END LOOP;

         IF V_TOTAPRODENCA = 0 THEN
            SELECT SUM(VRTOTAITEM - VRDESCITEM)
            INTO   V_TOTAPRODENCA
            FROM ITEMPRODUTO IP
            WHERE (IP.CDFILIAL   = P_FILIAL)   AND
                  (IP.NRLANCTONF = P_LANCTONF);

            IF NOT V_TOTAPRODENCA IS NULL THEN
               FOR C_ATUAVRCONT IN (SELECT IP.NRSEQITPROD, (VRTOTAITEM - VRDESCITEM) AS VRLIQUIDO
                                    FROM ITEMPRODUTO IP
                                    WHERE (IP.CDFILIAL    = P_FILIAL) AND
                                          (IP.NRLANCTONF  = P_LANCTONF)) LOOP

                  IF (C_ITEMENCARGO.IDENCARGO = w_A) THEN
                     V_VRBRUTO  := (C_ITEMENCARGO.VRITEMENCA/V_TOTAPRODENCA);
                  ELSIF (C_ITEMENCARGO.IDENCARGO = w_D) THEN
                     V_VRBRUTO  := - (C_ITEMENCARGO.VRITEMENCA/V_TOTAPRODENCA);
                  ELSE
                     V_VRBRUTO := 0;
                  END IF;

                  IF (C_ITEMENCARGO.CDCTBLSAIDEN IS NULL) THEN
                     V_VRCONTAB := V_VRBRUTO;
                  ELSE
                     V_VRCONTAB := 0;
                  END IF;

                  IF ((V_IDSISTEMA = 'VND') OR (V_IDSISTEMA = 'PDV')) AND (NVL(V_IDORIGDESTNF, 'C') <> 'L') THEN
                     UPDATE ITEMPRODUTO
                     SET VRBRUTITEM = TRUNC(VRBRUTITEM + (V_VRBRUTO  * (VRTOTAITEM - VRDESCITEM)),2),
                         VRCONTITEM = TRUNC(VRCONTITEM + (V_VRCONTAB * (VRTOTAITEM - VRDESCITEM)),2)
                     WHERE CDFILIAL    = P_FILIAL   AND
                           NRLANCTONF  = P_LANCTONF AND
                           NRSEQITPROD = C_ATUAVRCONT.NRSEQITPROD;
                  ELSE
                     UPDATE ITEMPRODUTO
                     SET VRBRUTITEM = ROUND(VRBRUTITEM + (V_VRBRUTO  * (VRTOTAITEM - VRDESCITEM)),5),
                         VRCONTITEM = ROUND(VRCONTITEM + (V_VRCONTAB * (VRTOTAITEM - VRDESCITEM)),5)
                     WHERE CDFILIAL    = P_FILIAL   AND
                           NRLANCTONF  = P_LANCTONF AND
                           NRSEQITPROD = C_ATUAVRCONT.NRSEQITPROD;
                  END IF;
               END LOOP;
            END IF;
         ELSE
            FOR C_ATUAVRCONT IN (SELECT DISTINCT(IP.NRSEQITPROD) AS NRSEQITPROD, (VRTOTAITEM - VRDESCITEM) AS VRLIQUIDO
                                 FROM ITEMPRODUTO IP, ITEMPROIMPOS II
                                 WHERE (IP.CDFILIAL    = P_FILIAL)       AND
                                       (IP.NRLANCTONF  = P_LANCTONF)     AND
                                       (II.CDFILIAL    = IP.CDFILIAL)    AND
                                       (II.NRLANCTONF  = IP.NRLANCTONF)  AND
                                       (II.NRSEQITPROD = IP.NRSEQITPROD) AND
                                       (EXISTS(SELECT BC.CDIMPOSTO
                                               FROM BASECALC BC
                                               WHERE (BC.CDENCARGO = C_ITEMENCARGO.CDENCARGO) AND
                                                     (BC.CDIMPOSTO = II.CDIMPOSTO)            AND
                                                     (BC.CDIMPOSTO IN (SELECT B.CDIMPOSTO
                                                                       FROM BASECALC B
                                                                       WHERE B.CDENCARGO = C_ITEMENCARGO.CDENCARGO))))) LOOP

               IF (C_ITEMENCARGO.IDENCARGO = w_A) THEN
                  V_VRBRUTO  := (C_ITEMENCARGO.VRITEMENCA/V_TOTAPRODENCA);
               ELSIF (C_ITEMENCARGO.IDENCARGO = w_D) THEN
                  V_VRBRUTO  := - (C_ITEMENCARGO.VRITEMENCA/V_TOTAPRODENCA);
               ELSE
                  V_VRBRUTO := 0;
               END IF;

               IF (C_ITEMENCARGO.CDCTBLSAIDEN IS NULL) THEN
                  V_VRCONTAB := V_VRBRUTO;
               ELSE
                  V_VRCONTAB := 0;
               END IF;

               IF ((V_IDSISTEMA = 'VND') OR (V_IDSISTEMA = 'PDV')) AND (NVL(V_IDORIGDESTNF, 'C') <> 'L') THEN
                  UPDATE ITEMPRODUTO
                  SET VRBRUTITEM = TRUNC(VRBRUTITEM + (V_VRBRUTO  * (VRTOTAITEM - VRDESCITEM)),2),
                      VRCONTITEM = TRUNC(VRCONTITEM + (V_VRCONTAB * (VRTOTAITEM - VRDESCITEM)),2)
                  WHERE CDFILIAL    = P_FILIAL   AND
                        NRLANCTONF  = P_LANCTONF AND
                        NRSEQITPROD = C_ATUAVRCONT.NRSEQITPROD;
               ELSE
                  UPDATE ITEMPRODUTO
                  SET VRBRUTITEM = ROUND(VRBRUTITEM + (V_VRBRUTO  * (VRTOTAITEM - VRDESCITEM)),5),
                      VRCONTITEM = ROUND(VRCONTITEM + (V_VRCONTAB * (VRTOTAITEM - VRDESCITEM)),5)
                  WHERE CDFILIAL    = P_FILIAL   AND
                        NRLANCTONF  = P_LANCTONF AND
                        NRSEQITPROD = C_ATUAVRCONT.NRSEQITPROD;
               END IF;
            END LOOP;

            FOR C_ITEMPROIMPOS IN (SELECT II.NRSEQITPROD, II.NRITPROIMPOS, II.CDIMPOSTO, II.VRPERREDBCIT, II.VRALIQITEM,
                                          II.VRPARDEDIT, II.IDTRIMPSTII, (VRTOTAITEM - VRDESCITEM) AS VRLIQUIDO,
                                          NVL(II.VRALIQINTEDEST, 0) AS VRALIQINTEDEST, NVL(II.VRALIQFCP, 0) AS VRALIQFCP,
                                          NVL(IP.IDUTILBCPMC, 'N') AS IDUTILBCPMC, I.CDIMPOSTONFE, NVL(II.IDCONSDIFALIQ, 'N') AS IDCONSDIFALIQ 
                                   FROM ITEMPROIMPOS II, ITEMPRODUTO IP, BASECALC BC, IMPOSTO I
                                   WHERE (II.CDFILIAL     = P_FILIAL)                AND
                                         (II.NRLANCTONF   = P_LANCTONF)              AND
                                         (IP.CDFILIAL     = P_FILIAL)                AND
                                         (IP.NRLANCTONF   = P_LANCTONF)              AND
                                         (IP.NRSEQITPROD  = II.NRSEQITPROD)          AND
                                         (BC.CDIMPOSTO    = II.CDIMPOSTO)            AND
                                         (II.CDIMPOSTO    = I.CDIMPOSTO)             AND
                                         (BC.CDENCARGO    = C_ITEMENCARGO.CDENCARGO)
                                   ORDER BY 1, 2, 3) LOOP

               IF NOT((C_ITEMPROIMPOS.IDUTILBCPMC = W_S) AND (C_ITEMPROIMPOS.CDIMPOSTONFE = '80')) OR (C_ITEMPROIMPOS.IDUTILBCPMC <> W_S) THEN
                  IF C_ITEMPROIMPOS.IDCONSDIFALIQ <> W_S THEN

                     SELECT SUM(VRTOTAITEM - VRDESCITEM)
                       INTO V_TOTAPRENIMPO
                       FROM ITEMPRODUTO IP
                      WHERE IP.CDFILIAL   = P_FILIAL
                        AND IP.NRLANCTONF = P_LANCTONF;
   
                     IF (V_TOTAPRODENCA <> 0) THEN
                        IF (C_ITEMENCARGO.IDENCARGO = w_A) THEN
                           V_PRODUENCARGO := +(C_ITEMENCARGO.VRITEMENCA/V_TOTAPRENIMPO)*C_ITEMPROIMPOS.VRLIQUIDO;
                        ELSIF (C_ITEMENCARGO.IDENCARGO = w_D) THEN
                           V_PRODUENCARGO := -(C_ITEMENCARGO.VRITEMENCA/V_TOTAPRENIMPO)*C_ITEMPROIMPOS.VRLIQUIDO;
                        ELSE
                           V_PRODUENCARGO := 0;
                        END IF;
                     END IF;
   
                     V_IDVRIMPSTRIB := null;
                     BEGIN
                        SELECT CASE COUNT(*) WHEN 0 THEN 'M' ELSE 'R' END
                          INTO V_MAJORAOUREDUZ
                          FROM ITEMPROIMPOS
                         WHERE CDFILIAL = P_FILIAL 
                           AND NRLANCTONF = P_LANCTONF
                           AND NRSEQITPROD = C_ITEMPROIMPOS.NRSEQITPROD
                           AND CDIMPOSTO = C_ITEMPROIMPOS.CDIMPOSTO
                           AND NRITPROIMPOS = w_2;
                     EXCEPTION
                        WHEN NO_DATA_FOUND THEN
                           V_MAJORAOUREDUZ := 'M';
                     END;
   
                     V_VRIMPOSTOST := 0;
                     IF V_MAJORAOUREDUZ = 'R' THEN
                        V_TAXABASECALC := (100 - C_ITEMPROIMPOS.VRPERREDBCIT)/100;
                        V_TAXAALIQUOTA := (C_ITEMPROIMPOS.VRALIQITEM/100);
                     ELSE
                        V_TAXABASECALC := 1 + (C_ITEMPROIMPOS.VRPERREDBCIT)/100;
                        V_TAXAALIQUOTA := (C_ITEMPROIMPOS.VRALIQITEM/100);
   
                        SELECT NVL(MAX(IDVRIMPSTRIB), 'N')
                          INTO V_IDVRIMPSTRIB
                          FROM ITEMPROIMPOS I, IMPOSTO II
                         WHERE (CDFILIAL     = P_FILIAL)
                           AND (NRLANCTONF   = P_LANCTONF)
                           AND (NRSEQITPROD  = C_ITEMPROIMPOS.NRITPROIMPOS)
                           AND (INSTR(V_CDIMPOSTRIB,II.CDIMPOSTO||'_') > 0)
                           AND (I.CDIMPOSTO = II.CDIMPOSTO);
   
                        IF (C_ITEMPROIMPOS.IDTRIMPSTII <> w_1) AND (NVL(V_IDVRIMPSTRIB,w_N) = w_S) THEN
                           Begin
                              SELECT NVL(MAX(VRIMPOSTOIT),0)
                              INTO   V_VRIMPOSTOST
                              FROM ITEMPROIMPOS I
                              WHERE (CDFILIAL     = P_FILIAL)                   AND
                                    (NRLANCTONF   = P_LANCTONF)                 AND
                                    (INSTR(V_CDIMPOSTRIB,CDIMPOSTO||'_') > 0)   AND
                                    (NRITPROIMPOS = C_ITEMPROIMPOS.NRITPROIMPOS);
                           Exception
                              When No_Data_Found Then
                                 V_VRIMPOSTOST := 0;
                           End;
                        END IF;
                     END IF;
   
                     V_ICMS := 'N';
                     FOR C_ICMS IN (SELECT CDIMPOSTO
                                      FROM IMPOSTONFE N, IMPOSTO I
                                     WHERE N.CDIMPOSTONFE = I.CDIMPOSTONFE
                                       AND N.CDIMPOSTONFE = '00'
                                       AND I.CDIMPOSTO = C_ITEMPROIMPOS.CDIMPOSTO)
                     LOOP
                        V_ICMS := 'S';
                     END LOOP;
   
                     SELECT NVL(MAX(IDPERVISIMPSCRE), 'S')
                       INTO V_IDPERVISIMPSCRE
                       FROM PARAMGERAL;
   
                     UPDATE ITEMPROIMPOS
                        SET VRCONTITIMP  = VRCONTITIMP  + (V_PRODUENCARGO * V_TAXABASECALC),
                            VRBASECALCIT = VRBASECALCIT + ((V_PRODUENCARGO * V_TAXABASECALC) / (1 - ((C_ITEMPROIMPOS.VRALIQINTEDEST + C_ITEMPROIMPOS.VRALIQFCP) / 100))),
                            VRIMPOSTOIT  = (VRIMPOSTOIT  + (((V_PRODUENCARGO * V_TAXABASECALC) / (1 - ((C_ITEMPROIMPOS.VRALIQINTEDEST + C_ITEMPROIMPOS.VRALIQFCP) / 100))) * V_TAXAALIQUOTA)) - (((V_VRIMPOSTOST * V_TAXABASECALC) / (1 - ((C_ITEMPROIMPOS.VRALIQINTEDEST + C_ITEMPROIMPOS.VRALIQFCP) / 100))) * V_TAXAALIQUOTA),
                            VRIMPOSTOVISUIT = DECODE(V_IDPERVISIMPSCRE, 'S', (VRIMPOSTOIT  + ((V_PRODUENCARGO * V_TAXABASECALC) * V_TAXAALIQUOTA)) - ((V_VRIMPOSTOST * V_TAXABASECALC) * V_TAXAALIQUOTA),  DECODE(CDFISCALIT , '1', (VRIMPOSTOIT  + ((V_PRODUENCARGO * V_TAXABASECALC) * V_TAXAALIQUOTA)) - ((V_VRIMPOSTOST * V_TAXABASECALC) * V_TAXAALIQUOTA),0)),
                            VRADICFECP  = VRADICFECP  + ROUND((V_PRODUENCARGO * (VRADICALIQFECP / 100) * V_TAXABASECALC),2)
                      WHERE (CDFILIAL     = P_FILIAL)                   AND
                            (NRLANCTONF   = P_LANCTONF)                 AND
                            (NRSEQITPROD  = C_ITEMPROIMPOS.NRSEQITPROD) AND
                            (CDIMPOSTO    = C_ITEMPROIMPOS.CDIMPOSTO)   AND
                            (NRITPROIMPOS = C_ITEMPROIMPOS.NRITPROIMPOS);
                  END IF;
               END IF;

               /* ROTINA PARA RECALCULAR O DIFERIMENTO DO IMPOSTO */
               BEGIN
                  SELECT MAX(VRIMPOSTOOPERAIT), MAX(VRPERDIFEREIT)
                    INTO V_VRIMPOSTOOPERAIT, V_VRPERDIFEREIT
                    FROM ITEMPROIMPOS
                   WHERE (CDFILIAL     = P_FILIAL)                    AND
                         (NRLANCTONF   = P_LANCTONF)                  AND
                         (NRSEQITPROD  = C_ITEMPROIMPOS.NRSEQITPROD)  AND
                         (CDIMPOSTO    = C_ITEMPROIMPOS.CDIMPOSTO)    AND
                         (NRITPROIMPOS = C_ITEMPROIMPOS.NRITPROIMPOS) AND
                         (VRPERDIFEREIT <> 0);
               EXCEPTION
                  When No_Data_Found Then
                     V_VRIMPOSTOOPERAIT := 0; V_VRPERDIFEREIT := 0;
               END;

               IF V_VRPERDIFEREIT <> 0 THEN
                  V_VRIMPOSTOOPERAIT := ROUND((V_VRIMPOSTOOPERAIT + ((ROUND(V_PRODUENCARGO, 2) * V_TAXABASECALC) * V_TAXAALIQUOTA)) - ((V_VRIMPOSTOST * V_TAXABASECALC) * V_TAXAALIQUOTA),2);
                  V_VRIMPOSTODIFERIT := ROUND((V_VRIMPOSTOOPERAIT * V_VRPERDIFEREIT/100), 2);

                  UPDATE ITEMPROIMPOS
                     SET VRIMPOSTOOPERAIT = V_VRIMPOSTOOPERAIT,
                         VRIMPOSTODIFERIT = V_VRIMPOSTODIFERIT,
                         VRIMPOSTOIT = (V_VRIMPOSTOOPERAIT - V_VRIMPOSTODIFERIT),
                         VRIMPOSTOVISUIT = (V_VRIMPOSTOOPERAIT - V_VRIMPOSTODIFERIT)
                   WHERE (CDFILIAL     = P_FILIAL)                    AND
                         (NRLANCTONF   = P_LANCTONF)                  AND
                         (NRSEQITPROD  = C_ITEMPROIMPOS.NRSEQITPROD)  AND
                         (CDIMPOSTO    = C_ITEMPROIMPOS.CDIMPOSTO)    AND
                         (NRITPROIMPOS = C_ITEMPROIMPOS.NRITPROIMPOS) AND
                         (VRPERDIFEREIT <> 0);
               END IF;
            END LOOP;
         END IF;
      END LOOP;

      UPDATE ITEMPROIMPOS
      SET VRIMPOSTOIT = 0,
          VRIMPOSTOVISUIT = 0
      WHERE (NRLANCTONF  = P_LANCTONF) AND
            (CDFILIAL    = P_FILIAL)   AND
            (VRIMPOSTOIT < 0);

      UPDATE ITEMPROIMPOS
      SET VRBASECALCIT = 0
      WHERE (NRLANCTONF  = P_LANCTONF) AND
            (CDFILIAL    = P_FILIAL)   AND
            (VRBASECALCIT < 0);

      --CÁLCULO DO VALOR DOS IMPOSTOS QUE CONTÉM OUTROS IMPOSTOS NA SUA BASE DE CÁLCULO
      FOR C_PRODUTO IN (SELECT IP.NRSEQITPROD AS NRSEQITPROD, II.CDIMPOSTO, VRPERREDBCIT,
                               VRALIQITEM, VRPARDEDIT, CDFISCALIT, VRIMPOSTOIT, IDTRATIMPO,
                               IM.IDIMPORECUP, IM.CDCCTBLPASS, IM.CDCCTBLATIV, NRITPROIMPOS,
                               IDTRIMPSTII, IM.IDTIPCONTAB, II.VRBASECALCIT, II.IDIMPSTCARGTRIB,
                               IP.CDPRODUTO, P.CDARVPROD, IP.IDORIGEMPROD, IM.IDDESCRFONTE,
                               NVL(IP.IDUTILBCPMC, W_N) AS IDUTILBCPMC, NVL(VRADICFECP, 0) AS VRADICFECP,
                               NVL(VRADICALIQFECP, 0) AS VRADICALIQFECP, NVL(II.IDCONSDIFALIQ, W_N) AS IDCONSDIFALIQ 
                        FROM ITEMPRODUTO IP, ITEMPROIMPOS II, IMPOSTO IM, PRODUTO P
                        WHERE (IP.CDFILIAL     = P_FILIAL)      AND
                              (IP.NRLANCTONF   = P_LANCTONF)    AND
                              (II.CDFILIAL     = IP.CDFILIAL)   AND
                              (II.NRLANCTONF   = IP.NRLANCTONF) AND
                              (IM.CDIMPOSTO    = II.CDIMPOSTO)  AND
                              (II.NRITPROIMPOS = w_1)           AND
                              (II.NRSEQITPROD  = IP.NRSEQITPROD) AND
                              P.CDPRODUTO = IP.CDPRODUTO
                        ORDER BY NRSEQITPROD, CDIMPOSTO) LOOP

         V_IDIMPOBCALTPOP := NULL;

         SELECT TO_CHAR(MAX('S')) , NVL(SUM(VRIMPOSTOIT),0) AS VRIMPOBCALC
           INTO   V_IDIMPOBCALTPOP, V_TOTAIMPBCALC
           FROM ITEMPRODUTO IP, ITEMPROIMPOS II, BASECALCTPOPER BC , IMPOSTO I
          WHERE (BC.CDIMPOSTO    = C_PRODUTO.CDIMPOSTO)
            AND (IP.CDFILIAL     = P_FILIAL)
            AND (IP.NRLANCTONF   = P_LANCTONF)
            AND (II.NRLANCTONF   = IP.NRLANCTONF)
            AND (II.CDFILIAL     = IP.CDFILIAL)
            AND (IP.NRSEQITPROD  = C_PRODUTO.NRSEQITPROD)
            AND (II.NRSEQITPROD  = C_PRODUTO.NRSEQITPROD)
            AND (II.NRITPROIMPOS = C_PRODUTO.NRITPROIMPOS)
            AND ((SUBSTR(IP.CDSITUTRIBPR,2,2) = BC.CDCSTIMPOTPOP)  OR (BC.CDCSTIMPOTPOP  IS NULL))
            AND ((SUBSTR(IP.CDFISOPEITEM,2,4) = BC.CDCFOPIMPOTPOP) OR (BC.CDCFOPIMPOTPOP IS NULL))
            AND ((C_PRODUTO.CDFISCALIT        = BC.CDFISCIMPOTPOP) OR (BC.CDFISCIMPOTPOP IS NULL))
            AND (BC.IDENTRSAIDOP = 'S')
            AND (BC.CDTIPOOPER = P_TIPOOPER)
            AND (II.CDIMPOSTO = BC.CDIMPOBCALC)
            AND (BC.CDIMPOBCALC = I.CDIMPOSTO)
            AND (NVL(BC.IDTRATIMPOBCTPOP, I.IDTRATIMPO) <> 'D');

         IF V_IDIMPOBCALTPOP IS NULL THEN
            SELECT NVL(SUM(VRIMPOSTOIT),0) AS VRIMPOBCALC
              INTO   V_TOTAIMPBCALC
              FROM ITEMPRODUTO IP, ITEMPROIMPOS II, BASECALC BC, IMPOSTO I
             WHERE (BC.CDIMPOSTO    = C_PRODUTO.CDIMPOSTO)    AND
                   (IP.CDFILIAL     = P_FILIAL)               AND
                   (IP.NRLANCTONF   = P_LANCTONF)             AND
                   (II.NRLANCTONF   = IP.NRLANCTONF)          AND
                   (II.CDFILIAL     = IP.CDFILIAL)            AND
                   (IP.NRSEQITPROD  = C_PRODUTO.NRSEQITPROD)  AND
                   (II.NRSEQITPROD  = C_PRODUTO.NRSEQITPROD)  AND
                   (II.NRITPROIMPOS = C_PRODUTO.NRITPROIMPOS) AND
                   ((SUBSTR(IP.CDSITUTRIBPR,2,2) = BC.CDCSTIMPO)  OR (BC.CDCSTIMPO  IS NULL)) AND
                   ((SUBSTR(IP.CDFISOPEITEM,2,4) = BC.CDCFOPIMPO) OR (BC.CDCFOPIMPO IS NULL)) AND
                   ((C_PRODUTO.CDFISCALIT        = BC.CDFISCIMPO) OR (BC.CDFISCIMPO IS NULL)) AND
                   (II.CDIMPOSTO = BC.CDIMPOBCALC) AND
                   (BC.IDTIPOBCALC   = w_I)AND
                   (BC.CDIMPOBCALC = I.CDIMPOSTO)  AND
                   (NVL(BC.IDTRATIMPOBC, I.IDTRATIMPO) <> 'D');
         END IF;

         V_IDIMBCALTPOPDE := NULL;

         SELECT TO_CHAR(MAX('S')), (NVL(SUM(VRIMPOSTOIT),0)*-1) AS VRIMPOBCALC
           INTO V_IDIMBCALTPOPDE, V_TOTAIMPBCDES
           FROM ITEMPRODUTO IP, ITEMPROIMPOS II, BASECALCTPOPER BC, IMPOSTO I
          WHERE (BC.CDIMPOSTO    = C_PRODUTO.CDIMPOSTO)
            AND (IP.CDFILIAL     = P_FILIAL)
            AND (IP.NRLANCTONF   = P_LANCTONF)
            AND (II.NRLANCTONF   = IP.NRLANCTONF)
            AND (II.CDFILIAL     = IP.CDFILIAL)
            AND (IP.NRSEQITPROD  = C_PRODUTO.NRSEQITPROD)
            AND (II.NRSEQITPROD  = C_PRODUTO.NRSEQITPROD)
            AND (II.NRITPROIMPOS = C_PRODUTO.NRITPROIMPOS)
            AND ((SUBSTR(IP.CDSITUTRIBPR,2,2) = BC.CDCSTIMPOTPOP)  OR (BC.CDCSTIMPOTPOP  IS NULL))
            AND ((SUBSTR(IP.CDFISOPEITEM,2,4) = BC.CDCFOPIMPOTPOP) OR (BC.CDCFOPIMPOTPOP IS NULL))
            AND ((C_PRODUTO.CDFISCALIT        = BC.CDFISCIMPOTPOP) OR (BC.CDFISCIMPOTPOP IS NULL))
            AND (BC.IDENTRSAIDOP = 'S')
            AND (BC.CDTIPOOPER = P_TIPOOPER)
            AND (II.CDIMPOSTO = BC.CDIMPOBCALC)
            AND (BC.CDIMPOBCALC = I.CDIMPOSTO)
            AND (NVL(BC.IDTRATIMPOBCTPOP, I.IDTRATIMPO) = 'D');

         IF V_IDIMBCALTPOPDE IS NULL THEN

            SELECT (NVL(SUM(VRIMPOSTOIT),0)*-1) AS VRIMPOBCALC INTO V_TOTAIMPBCDES
              FROM ITEMPRODUTO IP, ITEMPROIMPOS II, BASECALC BC, IMPOSTO I
             WHERE (BC.CDIMPOSTO    = C_PRODUTO.CDIMPOSTO)    AND
                   (IP.CDFILIAL     = P_FILIAL)               AND
                   (IP.NRLANCTONF   = P_LANCTONF)             AND
                   (II.NRLANCTONF   = IP.NRLANCTONF)          AND
                   (II.CDFILIAL     = IP.CDFILIAL)            AND
                   (IP.NRSEQITPROD  = C_PRODUTO.NRSEQITPROD)  AND
                   (II.NRSEQITPROD  = C_PRODUTO.NRSEQITPROD)  AND
                   (II.NRITPROIMPOS = C_PRODUTO.NRITPROIMPOS) AND
                   ((SUBSTR(IP.CDSITUTRIBPR,2,2) = BC.CDCSTIMPO)  OR (BC.CDCSTIMPO  IS NULL)) AND
                   ((SUBSTR(IP.CDFISOPEITEM,2,4) = BC.CDCFOPIMPO) OR (BC.CDCFOPIMPO IS NULL)) AND
                   ((C_PRODUTO.CDFISCALIT        = BC.CDFISCIMPO) OR (BC.CDFISCIMPO IS NULL)) AND
                   (II.CDIMPOSTO = BC.CDIMPOBCALC) AND
                   (BC.IDTIPOBCALC   = 'I')        AND
                   (BC.CDIMPOBCALC = I.CDIMPOSTO)  AND
                   (NVL(BC.IDTRATIMPOBC, I.IDTRATIMPO) = 'D');
         END IF;

         V_VRIMPOSTO := C_PRODUTO.VRIMPOSTOIT;

         /*IMPOSTO PARA SUBSTITUIÇÃO TRIBUTARIA*/
         V_CDIMPOSTRIB  := null;
         V_IDVRIMPSTRIB := null;
         FOR C_ICMSST IN (SELECT CDIMPOSTO
                            FROM IMPOSTO
                           WHERE CDIMPOSTRIB = C_PRODUTO.CDIMPOSTO)
         LOOP
            V_CDIMPOSTRIB := V_CDIMPOSTRIB||C_ICMSST.CDIMPOSTO||'_';
         END LOOP;

         V_VRIMPOSTOST := 0;
         /*Só irá fazer o cálculo de outro imposto compondo a base de cálculo,
           se o valor do mesmo não estiver zerado OU
           se for o imposto de st, pois o icms pode ter sido recalculado(por ter alguem compondo sua bc)
           e o imposto st precisa retirar o valor final do st*/

         IF (NOT(V_TOTAIMPBCALC IS NULL) OR (V_TOTAIMPBCALC <> 0)) OR
            (NOT(V_TOTAIMPBCDES IS NULL) OR (V_TOTAIMPBCDES <> 0)) OR
            (V_CDIMPOSTRIB IS NOT NULL) THEN

            IF V_CDIMPOSTRIB IS NULL THEN
               V_TAXABASECALC := (100 - C_PRODUTO.VRPERREDBCIT)/100;
               V_TAXAALIQUOTA := (C_PRODUTO.VRALIQITEM/100);
               V_VRIMPOSTO    := V_VRIMPOSTO + (((V_TOTAIMPBCALC+V_TOTAIMPBCDES) * V_TAXABASECALC) * V_TAXAALIQUOTA);

               SELECT NVL(MAX(IDPERVISIMPSCRE), 'S')
                 INTO V_IDPERVISIMPSCRE
                 FROM PARAMGERAL;

               UPDATE ITEMPROIMPOS
                  SET VRBASECALCIT = VRBASECALCIT + ((V_TOTAIMPBCALC+V_TOTAIMPBCDES) * V_TAXABASECALC),
                      VRIMPOSTOIT  = VRIMPOSTOIT  + (((V_TOTAIMPBCALC+V_TOTAIMPBCDES) * V_TAXABASECALC) * V_TAXAALIQUOTA),
                      VRIMPOSTOVISUIT = DECODE(V_IDPERVISIMPSCRE, 'S', VRIMPOSTOIT  + (((V_TOTAIMPBCALC+V_TOTAIMPBCDES) * V_TAXABASECALC) * V_TAXAALIQUOTA), DECODE(CDFISCALIT, '1', VRIMPOSTOIT  + (((V_TOTAIMPBCALC+V_TOTAIMPBCDES) * V_TAXABASECALC) * V_TAXAALIQUOTA), 0)),
                      VRADICFECP  = VRADICFECP  + ROUND((((V_TOTAIMPBCALC+V_TOTAIMPBCDES) * V_TAXABASECALC) * (VRADICALIQFECP/100)),2)
                WHERE (CDFILIAL     = P_FILIAL)              AND
                      (NRLANCTONF   = P_LANCTONF)            AND
                      (NRSEQITPROD  = C_PRODUTO.NRSEQITPROD) AND
                      (CDIMPOSTO    = C_PRODUTO.CDIMPOSTO)   AND
                      (NRITPROIMPOS = C_PRODUTO.NRITPROIMPOS);

               /* ROTINA PARA RECALCULAR O DIFERIMENTO DO IMPOSTO */
               BEGIN
                  SELECT MAX(VRIMPOSTOOPERAIT), MAX(VRPERDIFEREIT)
                    INTO V_VRIMPOSTOOPERAIT, V_VRPERDIFEREIT
                    FROM ITEMPROIMPOS
                   WHERE (CDFILIAL     = P_FILIAL)               AND
                         (NRLANCTONF   = P_LANCTONF)             AND
                         (NRSEQITPROD  = C_PRODUTO.NRSEQITPROD)  AND
                         (CDIMPOSTO    = C_PRODUTO.CDIMPOSTO)    AND
                         (NRITPROIMPOS = C_PRODUTO.NRITPROIMPOS) AND
                         (VRPERDIFEREIT <> 0);
               EXCEPTION
                  When No_Data_Found Then
                     V_VRIMPOSTOOPERAIT := 0; V_VRPERDIFEREIT := 0;
               END;

               IF V_VRPERDIFEREIT <> 0 THEN
                  V_VRIMPOSTOOPERAIT := ROUND((V_VRIMPOSTOOPERAIT + ((ROUND((V_TOTAIMPBCALC+V_TOTAIMPBCDES), 2) * V_TAXABASECALC) * V_TAXAALIQUOTA)),2);
                  V_VRIMPOSTODIFERIT := ROUND((V_VRIMPOSTOOPERAIT * V_VRPERDIFEREIT/100), 2);

                  UPDATE ITEMPROIMPOS
                     SET VRIMPOSTOOPERAIT = V_VRIMPOSTOOPERAIT,
                         VRIMPOSTODIFERIT = V_VRIMPOSTODIFERIT,
                         VRIMPOSTOIT = (V_VRIMPOSTOOPERAIT - V_VRIMPOSTODIFERIT),
                         VRIMPOSTOVISUIT = (V_VRIMPOSTOOPERAIT - V_VRIMPOSTODIFERIT)
                   WHERE (CDFILIAL     = P_FILIAL)               AND
                         (NRLANCTONF   = P_LANCTONF)             AND
                         (NRSEQITPROD  = C_PRODUTO.NRSEQITPROD)  AND
                         (CDIMPOSTO    = C_PRODUTO.CDIMPOSTO)    AND
                         (NRITPROIMPOS = C_PRODUTO.NRITPROIMPOS) AND
                         (VRPERDIFEREIT <> 0);
               END IF;
            ELSE
               V_VRIMPOSST   := 0;
               V_VRIMPOSTOST := 0;
               FOR C_SUBSTRIB IN (SELECT NVL(IDVRIMPSTRIB, 'N') IDVRIMPSTRIB, I.CDIMPOSTO
                                    FROM ITEMPROIMPOS I, IMPOSTO II
                                   WHERE (CDFILIAL     = P_FILIAL)
                                     AND (NRLANCTONF   = P_LANCTONF)
                                     AND (NRSEQITPROD  = C_PRODUTO.NRSEQITPROD)
                                     AND (NRITPROIMPOS = '1')
                                     AND (INSTR(V_CDIMPOSTRIB,II.CDIMPOSTO||'_') > 0)
                                     AND (I.CDIMPOSTO = II.CDIMPOSTO))
               LOOP
                  IF (C_SUBSTRIB.IDVRIMPSTRIB = w_S) THEN
                     Begin
                        SELECT NVL(ROUND(MAX(VRIMPOSTOIT), 2),0)
                        INTO   V_VRIMPOSST
                        FROM ITEMPROIMPOS I
                        WHERE (CDFILIAL     = P_FILIAL)                   AND
                              (NRLANCTONF   = P_LANCTONF)                 AND
                              (NRSEQITPROD  = C_PRODUTO.NRSEQITPROD)  AND
                              (CDIMPOSTO    = C_SUBSTRIB.CDIMPOSTO)       AND
                              (INSTR(V_CDIMPOSTRIB,CDIMPOSTO||'_') > 0)   AND
                              (NRITPROIMPOS = w_1);
                     Exception
                        When No_Data_Found Then
                           V_VRIMPOSST := 0;
                     End;
                  ELSE
                     V_VRIMPOSST := 0;
                  END IF;
                  V_VRIMPOSTOST := V_VRIMPOSTOST + V_VRIMPOSST;
               END LOOP;

               IF (C_PRODUTO.IDUTILBCPMC = W_S) THEN 
                  V_TAXAALIQUOTA := C_PRODUTO.VRALIQITEM / 100;
                  V_VRIMPOSTO := C_PRODUTO.VRBASECALCIT * V_TAXAALIQUOTA;
               ELSIF (C_PRODUTO.IDCONSDIFALIQ = W_S) THEN
                  V_TAXAALIQUOTA := C_PRODUTO.VRALIQITEM / 100;
                  V_VRIMPOSTO := C_PRODUTO.VRIMPOSTOIT;
               ELSE
                  BEGIN
                     SELECT CASE COUNT(*) WHEN 0 THEN 'M' ELSE 'R' END
                       INTO V_MAJORAOUREDUZ
                       FROM ITEMPROIMPOS
                      WHERE CDFILIAL = P_FILIAL 
                        AND NRLANCTONF = P_LANCTONF
                        AND NRSEQITPROD = C_PRODUTO.NRSEQITPROD
                        AND CDIMPOSTO = C_PRODUTO.CDIMPOSTO
                        AND NRITPROIMPOS = w_2;
                  EXCEPTION
                     WHEN NO_DATA_FOUND THEN
                        V_MAJORAOUREDUZ := 'M';
                  END;

                  IF V_MAJORAOUREDUZ = 'R' THEN
                     V_TAXABASECALC := (100 - C_PRODUTO.VRPERREDBCIT)/100;
                  ELSE
                     V_TAXABASECALC := 1 + (C_PRODUTO.VRPERREDBCIT)/100;
                  END IF;

                  V_TAXAALIQUOTA := (C_PRODUTO.VRALIQITEM/100);
                  V_VRIMPOSTO := ((C_PRODUTO.VRBASECALCIT + ((V_TOTAIMPBCALC + V_TOTAIMPBCDES) * V_TAXABASECALC)) * V_TAXAALIQUOTA);
               END IF;
               
               SELECT NVL(MAX(IDPERVISIMPSCRE), 'S')
                 INTO V_IDPERVISIMPSCRE
                 FROM PARAMGERAL;

               -- ESSA CONDIÇÃO SERÁ FEITA PORQUE A BASE DE CÁLCULO NÃO SERÁ ALTERADO QUANDO O PRODUTO TIVER CONSIDERANDO 
               -- O DIFERENCIAL DE ALÍQUOTA DO ICMS, ISTO PORQUE A BASE DE CÁLCULO JÁ FOI CALCULADA NA PROCEDURE CONSIDERA_DIFAL_ICMS
               IF (C_PRODUTO.IDCONSDIFALIQ = W_S) THEN
                  UPDATE ITEMPROIMPOS
                     SET VRIMPOSTOVISUIT = DECODE(V_IDPERVISIMPSCRE, 'S', (VRIMPOSTOIT), DECODE(CDFISCALIT, '1', (VRIMPOSTOIT),0))
                   WHERE (CDFILIAL     = P_FILIAL)              AND
                         (NRLANCTONF   = P_LANCTONF)            AND
                         (NRSEQITPROD  = C_PRODUTO.NRSEQITPROD) AND
                         (CDIMPOSTO    = C_PRODUTO.CDIMPOSTO)   AND
                         (NRITPROIMPOS = C_PRODUTO.NRITPROIMPOS);
               ELSIF C_PRODUTO.IDIMPSTCARGTRIB <> 'S' THEN
                  IF V_VRIMPOSTOST > V_VRIMPOSTO THEN
                     UPDATE ITEMPROIMPOS
                     SET VRBASECALCIT = VRBASECALCIT + ((V_TOTAIMPBCALC+V_TOTAIMPBCDES) * V_TAXABASECALC),
                         VRIMPOSTOIT  = 0,
                         VRIMPOSTOVISUIT = 0
                     WHERE (CDFILIAL     = P_FILIAL)              AND
                           (NRLANCTONF   = P_LANCTONF)            AND
                           (NRSEQITPROD  = C_PRODUTO.NRSEQITPROD) AND
                           (CDIMPOSTO    = C_PRODUTO.CDIMPOSTO)   AND
                           (NRITPROIMPOS = C_PRODUTO.NRITPROIMPOS);
                     V_VRIMPOSTO := 0;
                  ELSE
                     -- ESSA CONDIÇÃO SERÁ FEITA PORQUE A BASE DE CÁLCULO NÃO SERÁ ALTERADO QUANDO O PRODUTO TIVER PMC,
                     -- ISTO PORQUE A BASE DE CÁLCULO JÁ FOI CALCULADA NA PROCEDURE CALCULA_BC_PMC
                     IF (C_PRODUTO.IDUTILBCPMC = W_S) THEN
                        UPDATE ITEMPROIMPOS
                           SET VRBASECALCIT = VRBASECALCIT,
                               VRIMPOSTOIT  = V_VRIMPOSTO - V_VRIMPOSTOST,
                               VRIMPOSTOVISUIT = DECODE(V_IDPERVISIMPSCRE, 'S', (V_VRIMPOSTO - V_VRIMPOSTOST), DECODE(CDFISCALIT, '1', (V_VRIMPOSTO - V_VRIMPOSTOST),0))
                         WHERE (CDFILIAL     = P_FILIAL)              AND
                               (NRLANCTONF   = P_LANCTONF)            AND
                               (NRSEQITPROD  = C_PRODUTO.NRSEQITPROD) AND
                               (CDIMPOSTO    = C_PRODUTO.CDIMPOSTO)   AND
                               (NRITPROIMPOS = C_PRODUTO.NRITPROIMPOS);
                     ELSE
                        UPDATE ITEMPROIMPOS
                           SET VRBASECALCIT = VRBASECALCIT + ((V_TOTAIMPBCALC+V_TOTAIMPBCDES) * V_TAXABASECALC),
                               VRIMPOSTOIT  = V_VRIMPOSTO - V_VRIMPOSTOST,
                               VRIMPOSTOVISUIT = DECODE(V_IDPERVISIMPSCRE, 'S', (V_VRIMPOSTO - V_VRIMPOSTOST), DECODE(CDFISCALIT, '1', (V_VRIMPOSTO - V_VRIMPOSTOST),0)),
                               VRADICFECP  = VRADICFECP + ROUND((((V_TOTAIMPBCALC+V_TOTAIMPBCDES) * V_TAXABASECALC) * (VRADICALIQFECP/100)),2)
                         WHERE (CDFILIAL     = P_FILIAL)              AND
                               (NRLANCTONF   = P_LANCTONF)            AND
                               (NRSEQITPROD  = C_PRODUTO.NRSEQITPROD) AND
                               (CDIMPOSTO    = C_PRODUTO.CDIMPOSTO)   AND
                               (NRITPROIMPOS = C_PRODUTO.NRITPROIMPOS);
                     END IF;
                     V_VRIMPOSTO := V_VRIMPOSTO - V_VRIMPOSTOST;
                  END IF;
               END IF;
            END IF;

            /* Rotina para calcular o ICMS ST considerando % carga tributária média */

            IF V_CDIMPOSTRIB IS NOT NULL THEN
               BEGIN
                  SELECT NVL(VRCNAEBC, 0),
                         NVL(VRMVA, 0)
                    INTO V_VRPRODUTOBC,
                         V_VRMVA
                    FROM VRPERCCARGTRIBCNAE
                   WHERE IDENTRSAIDOP = w_S
                     AND CDTIPOOPER   = P_TIPOOPER
                     AND CDPAIS       = V_PAISDEST
                     AND SGESTADO     = V_ESTADEST
                     AND CDCNAE       = V_CDCNAECLIE
                     AND IDOPTANTESN  = V_IDOPTANTESNCLIE;
               EXCEPTION
                  WHEN NO_DATA_FOUND THEN
                     V_VRPRODUTOBC := 0;
                     V_VRMVA := 0;
               END;
               IF V_VRPRODUTOBC = 0 THEN
                  BEGIN
                     SELECT NVL(VRPRODUTOBC, 0)
                       INTO V_VRPRODUTOBC
                       FROM VRPERCCARGTRIB
                      WHERE IDENTRSAIDOP = w_S
                        AND CDTIPOOPER   = P_TIPOOPER
                        AND CDPAIS       = V_PAISDEST
                        AND SGESTADO     = V_ESTADEST
                        AND CDPRODUTO    = C_PRODUTO.CDPRODUTO;
                  EXCEPTION
                     When No_Data_Found Then
                        V_VRPRODUTOBC := 0;
                  END;
               END IF;
               IF (V_VRPRODUTOBC > 0) THEN
                  BEGIN
                     SELECT I.CDIMPOSTO, I.VRIMPOSTOIT, I.VRBASECALCIT
                       INTO V_CDIMPOSTOICMS, V_VRIMPOSTOICMS, V_VRBASECALCICMS
                       FROM IMPOSTONFE N, IMPOSTO P, ITEMPROIMPOS I
                      WHERE N.CDIMPOSTONFE = P.CDIMPOSTONFE
                        AND N.CDIMPOSTONFE = '00'
                        AND I.CDFILIAL     = P_FILIAL
                        AND I.NRLANCTONF   = P_LANCTONF
                        AND I.NRSEQITPROD = C_PRODUTO.NRSEQITPROD
                        AND I.CDIMPOSTO = NVL(P.CDIMPOSREGNORMA, P.CDIMPOSTO)
                        AND NOT P.CDIMPOSTRIB IS NULL
                        AND I.NRITPROIMPOS = '1';
                  EXCEPTION
                     When No_Data_Found Then
                        V_CDIMPOSTOICMS := NULL; V_VRIMPOSTOICMS := 0; V_VRBASECALCICMS := 0;
                  END;

                  DELETE ALIQTEMP
                   WHERE NRALIQTEMP = V_ALIQTEMP;

                  /* Verifica grupo fiscal */
                  SELECT MAX(IDGRUPFISSRV)
                  INTO V_UTGRUPFISCS
                  FROM IMPOSTO
                  WHERE CDIMPOSTO = V_CDIMPOSTOICMS;

                  IF V_UTGRUPFISCS = 'S' THEN
                     V_CDGRPFISCSV := NULL;
                     SELECT MAX(CDGRUPOFISC)
                     INTO V_CDGRPFISCSV
                     FROM SERVCLIE SC, SERVICO S
                     WHERE SC.CDFILIAL   = V_CDFILIEMIT AND
                           SC.CDCLIENTE  = P_CLIENTE    AND
                           SC.CDFILIAL   = S.CDFILIAL   AND
                           SC.CDSERVFILI = S.CDSERVFILI AND
                           S.CDPRODUTO   = C_PRODUTO.CDPRODUTO;

                     IF V_CDGRPFISCSV IS NULL THEN
                        SELECT MAX(CDGRUPOFISC)
                        INTO V_CDGRPFISCSV
                        FROM CLIENFILIAL
                       WHERE CDFILIAL   = V_CDFILIEMIT AND
                             CDCLIENTE  = P_CLIENTE;
                     END IF;

                     CONSULTA_ALIQUOTA(V_CDIMPOSTOICMS, w_S, P_EMPRESA, C_PRODUTO.CDARVPROD, P_INSCESTA, V_PAISDEST,
                                       V_ESTADEST, V_PAISDEST, V_ESTADEST, V_MUNIDEST, V_LIQUIITEM, P_INIVALID, P_FILIAL, P_LANCTONF, V_CDGRPFISCSV, P_TIPOOPER,
                                       NULL, NULL, NULL, NULL, NULL, NULL, C_PRODUTO.IDORIGEMPROD);

                  ELSE
                     CONSULTA_ALIQUOTA(V_CDIMPOSTOICMS, w_S, P_EMPRESA, C_PRODUTO.CDARVPROD, P_INSCESTA, V_PAISDEST,
                                       V_ESTADEST, V_PAISDEST, V_ESTADEST, V_MUNIDEST, V_LIQUIITEM, P_INIVALID, P_FILIAL, P_LANCTONF, V_CDGRUPOFISC, P_TIPOOPER,
                                       NULL, NULL, NULL, NULL, NULL, NULL, C_PRODUTO.IDORIGEMPROD);

                  END IF;

                  SELECT NVL(MAX(VRALIQUTMP),0)
                    INTO V_VRALIQUTMPDEST
                    FROM ALIQTEMP
                   WHERE (NRALIQTEMP = V_ALIQTEMP);

                  IF (V_VRALIQUTMPDEST <> 0) THEN
                     IF V_VRMVA > 0 THEN
                        V_VRBASECALCICMS :=  /*V_VRBASECALCICMS + */(V_VRBASECALCICMS * (V_VRMVA/100));
                     END IF;
                     V_IMPOSTOIT  :=  ROUND(V_VRBASECALCICMS * (V_VRPRODUTOBC/100), 2);
                     V_BASECALCTO :=  ROUND(((V_VRIMPOSTOICMS + V_IMPOSTOIT) / (V_VRALIQUTMPDEST/100)),5);  

                     UPDATE ITEMPROIMPOS
                        SET VRBASECALCIT = V_BASECALCTO,
                            VRIMPOSTOIT  = V_IMPOSTOIT,
                            VRIMPOSTOVISUIT = DECODE(V_IDPERVISIMPSCRE, 'S', V_IMPOSTOIT, DECODE(CDFISCALIT, '1', V_IMPOSTOIT,0))
                      WHERE (CDFILIAL     = P_FILIAL)              AND
                            (NRLANCTONF   = P_LANCTONF)            AND
                            (NRSEQITPROD  = C_PRODUTO.NRSEQITPROD) AND
                            (CDIMPOSTO    = C_PRODUTO.CDIMPOSTO)   AND
                            (NRITPROIMPOS = C_PRODUTO.NRITPROIMPOS);
                  END IF;

                  DELETE ALIQTEMP
                   WHERE NRALIQTEMP = V_ALIQTEMP;
               END IF;
            END IF;

         END IF;

         V_IMPOCONTAB := 0;

         IF (C_PRODUTO.IDTRATIMPO = w_A) THEN
            IF (((C_PRODUTO.IDIMPORECUP = w_S)  AND (C_PRODUTO.CDFISCALIT = w_1)) OR
                ((C_PRODUTO.IDIMPORECUP <> w_S) AND (C_PRODUTO.CDCCTBLPASS IS NOT NULL))) AND
               (V_CDIMPOSTRIB IS NULL) AND (C_PRODUTO.IDTIPCONTAB = w_D) THEN

               IF ((V_IDSISTEMA = 'VND') OR (V_IDSISTEMA = 'PDV')) AND (NVL(V_IDORIGDESTNF, 'C') <> 'L') THEN
                  UPDATE ITEMPRODUTO
                  SET VRBRUTITEM = TRUNC((VRBRUTITEM + V_VRIMPOSTO),2)
                  WHERE CDFILIAL    = P_FILIAL   AND
                        NRLANCTONF  = P_LANCTONF AND
                        NRSEQITPROD = C_PRODUTO.NRSEQITPROD;
               ELSE
                  UPDATE ITEMPRODUTO
                  SET VRBRUTITEM = ROUND((VRBRUTITEM + V_VRIMPOSTO),5)
                  WHERE CDFILIAL    = P_FILIAL   AND
                        NRLANCTONF  = P_LANCTONF AND
                        NRSEQITPROD = C_PRODUTO.NRSEQITPROD;
               END IF;
            ELSE
               IF ((V_CDIMPOSTRIB IS NOT NULL) AND (C_PRODUTO.IDTRIMPSTII = w_0)) OR
                   (V_CDIMPOSTRIB IS NULL) THEN
                  IF ((V_IDSISTEMA = 'VND') OR (V_IDSISTEMA = 'PDV')) AND (NVL(V_IDORIGDESTNF, 'C') <> 'L') THEN
                     UPDATE ITEMPRODUTO
                     SET VRBRUTITEM = TRUNC((VRBRUTITEM + V_VRIMPOSTO + C_PRODUTO.VRADICFECP), 2),
                         VRCONTITEM = TRUNC((VRCONTITEM + V_VRIMPOSTO + C_PRODUTO.VRADICFECP), 2)
                     WHERE CDFILIAL    = P_FILIAL   AND
                           NRLANCTONF  = P_LANCTONF AND
                           NRSEQITPROD = C_PRODUTO.NRSEQITPROD;
                  ELSE
                     UPDATE ITEMPRODUTO
                     SET VRBRUTITEM = ROUND(VRBRUTITEM + V_VRIMPOSTO + C_PRODUTO.VRADICFECP, 5),
                         VRCONTITEM = ROUND(VRCONTITEM + V_VRIMPOSTO + C_PRODUTO.VRADICFECP, 5)
                     WHERE CDFILIAL    = P_FILIAL   AND
                           NRLANCTONF  = P_LANCTONF AND
                           NRSEQITPROD = C_PRODUTO.NRSEQITPROD;
                  END IF;
               END IF;
            END IF;
         ELSIF (C_PRODUTO.IDTRATIMPO = w_D) THEN
            IF ((C_PRODUTO.IDIMPORECUP = w_S) AND (C_PRODUTO.CDFISCALIT = w_1)) OR
               ((C_PRODUTO.IDIMPORECUP <> w_S) AND (C_PRODUTO.CDCCTBLATIV IS NOT NULL)) AND
               (C_PRODUTO.IDTIPCONTAB = w_D) THEN

               IF ((V_IDSISTEMA = 'VND') OR (V_IDSISTEMA = 'PDV')) AND (NVL(V_IDORIGDESTNF, 'C') <> 'L') THEN
                  UPDATE ITEMPRODUTO
                  SET VRBRUTITEM = TRUNC((VRBRUTITEM - V_VRIMPOSTO),2)
                  WHERE CDFILIAL    = P_FILIAL   AND
                        NRLANCTONF  = P_LANCTONF AND
                        NRSEQITPROD = C_PRODUTO.NRSEQITPROD;
               ELSE
                  UPDATE ITEMPRODUTO
                  SET VRBRUTITEM = ROUND(VRBRUTITEM - V_VRIMPOSTO,5)
                  WHERE CDFILIAL    = P_FILIAL   AND
                        NRLANCTONF  = P_LANCTONF AND
                        NRSEQITPROD = C_PRODUTO.NRSEQITPROD;
               END IF;
            ELSE
               IF ((V_IDSISTEMA = 'VND') OR (V_IDSISTEMA = 'PDV')) AND (NVL(V_IDORIGDESTNF, 'C') <> 'L') THEN
                  UPDATE ITEMPRODUTO
                  SET VRBRUTITEM = TRUNC((VRBRUTITEM - V_VRIMPOSTO),2),
                      VRCONTITEM = TRUNC((VRCONTITEM - V_VRIMPOSTO),2)
                  WHERE CDFILIAL    = P_FILIAL   AND
                        NRLANCTONF  = P_LANCTONF AND
                        NRSEQITPROD = C_PRODUTO.NRSEQITPROD;
               ELSE
                  UPDATE ITEMPRODUTO
                  SET VRBRUTITEM = ROUND(VRBRUTITEM - V_VRIMPOSTO,5),
                      VRCONTITEM = ROUND(VRCONTITEM - V_VRIMPOSTO,5)
                  WHERE CDFILIAL    = P_FILIAL   AND
                        NRLANCTONF  = P_LANCTONF AND
                        NRSEQITPROD = C_PRODUTO.NRSEQITPROD;
               END IF;
            END IF;
         ELSIF (C_PRODUTO.IDTRATIMPO = w_R) THEN
            IF (C_PRODUTO.IDIMPORECUP = w_S) THEN
               IF (C_PRODUTO.CDCCTBLATIV IS NULL) OR
                  (C_PRODUTO.CDFISCALIT <> w_1) THEN

                  V_IMPOCONTAB := - V_VRIMPOSTO;
               END IF;
            ELSE
               IF (C_PRODUTO.CDCCTBLATIV IS NULL) THEN
                  V_IMPOCONTAB := - V_VRIMPOSTO;
               ELSE
                  IF C_PRODUTO.IDDESCRFONTE = 'N' THEN
                     V_IMPOCONTAB := - V_VRIMPOSTO;

                     UPDATE ITEMPRODUTO
                     SET VRBRUTITEM = ROUND(VRBRUTITEM - V_VRIMPOSTO,5)
                     WHERE CDFILIAL    = P_FILIAL   AND
                           NRLANCTONF  = P_LANCTONF AND
                           NRSEQITPROD = C_PRODUTO.NRSEQITPROD;
                  END IF;
               END IF;
            END IF;

            IF C_PRODUTO.IDTIPCONTAB = w_D THEN
               IF ((V_IDSISTEMA = 'VND') OR (V_IDSISTEMA = 'PDV')) AND (NVL(V_IDORIGDESTNF, 'C') <> 'L') THEN
                  UPDATE ITEMPRODUTO
                  SET VRCONTITEM = TRUNC((VRCONTITEM + V_IMPOCONTAB),2)
                  WHERE CDFILIAL    = P_FILIAL   AND
                        NRLANCTONF  = P_LANCTONF AND
                        NRSEQITPROD = C_PRODUTO.NRSEQITPROD;
               ELSE
                  UPDATE ITEMPRODUTO
                  SET VRCONTITEM = VRCONTITEM + V_IMPOCONTAB
                  WHERE CDFILIAL    = P_FILIAL   AND
                        NRLANCTONF  = P_LANCTONF AND
                        NRSEQITPROD = C_PRODUTO.NRSEQITPROD;
               END IF;
            END IF;

         ELSIF C_PRODUTO.IDTRATIMPO = w_V THEN

            IF (V_ORIGDESTOP = w_L) THEN
               V_IDDESCIMPRECCONT := 'N';
               BEGIN
                  SELECT NVL(IDDESCIMPRECCOFI, 'N')
                    INTO V_IDDESCIMPRECCONT
                    FROM TIPOOPERAC
                   WHERE CDTIPOOPER   = P_TIPOOPER
                     AND IDORIGDESTOP = w_L
                     AND IDENTRSAIDOP = w_S;
               EXCEPTION
                  WHEN NO_DATA_FOUND THEN
                     V_IDDESCIMPRECCONT := 'N';
               END;
            END IF;

            IF (C_PRODUTO.IDIMPORECUP = w_S) AND (V_IDORIGDESTNF = w_L) AND (V_IDDESCIMPRECCONT = 'N')THEN
               IF (C_PRODUTO.CDCCTBLPASS IS NOT NULL) AND
                  (C_PRODUTO.CDFISCALIT = w_1) THEN

                  V_IMPOCONTAB := - V_VRIMPOSTO;
               END IF;
            END IF;

            IF C_PRODUTO.IDTIPCONTAB = w_D THEN
               IF ((V_IDSISTEMA = 'VND') OR (V_IDSISTEMA = 'PDV')) AND (NVL(V_IDORIGDESTNF, 'C') <> 'L') THEN
                  UPDATE ITEMPRODUTO
                  SET VRCONTITEM = TRUNC((VRCONTITEM + V_IMPOCONTAB),2)
                  WHERE CDFILIAL    = P_FILIAL   AND
                        NRLANCTONF  = P_LANCTONF AND
                        NRSEQITPROD = C_PRODUTO.NRSEQITPROD;
               ELSE
                  UPDATE ITEMPRODUTO
                  SET VRCONTITEM = VRCONTITEM + V_IMPOCONTAB
                  WHERE CDFILIAL    = P_FILIAL   AND
                        NRLANCTONF  = P_LANCTONF AND
                        NRSEQITPROD = C_PRODUTO.NRSEQITPROD;
               END IF;
            END IF;
         END IF;
      END LOOP;

      FOR C_ITEM IN (SELECT II.CDIMPOSTO,  I.NRSEQITPROD, II.NRITPROIMPOS
                  FROM ITEMPRODUTO I, ITEMPROIMPOS II
                  WHERE I.CDFILIAL    = P_FILIAL       AND
                        I.NRLANCTONF  = P_LANCTONF     AND
                        I.CDFILIAL    = II.CDFILIAL    AND
                        I.NRLANCTONF  = II.NRLANCTONF  AND
                        I.NRSEQITPROD = II.NRSEQITPROD ) LOOP

         V_ICMS := 'N';
         FOR C_ICMS IN (SELECT CDIMPOSTO
                          FROM IMPOSTONFE N, IMPOSTO I
                         WHERE N.CDIMPOSTONFE = I.CDIMPOSTONFE
                           AND N.CDIMPOSTONFE = '00'
                           AND I.CDIMPOSTO = C_ITEM.CDIMPOSTO)
         LOOP
            V_ICMS := 'S';
         END LOOP;

         IF (V_IDSISTEMA = 'VND') OR (V_IDSISTEMA = 'PDV')  AND (V_ICMS = 'S') THEN
            UPDATE ITEMPROIMPOS
               SET VRCONTITIMP  = TRUNC(VRCONTITIMP,2),
                   VRBASECALCIT = TRUNC(VRBASECALCIT,2),
                   VRIMPOSTOIT  = TRUNC(VRIMPOSTOIT,2),
                   VRIMPOSTOVISUIT = TRUNC(VRIMPOSTOVISUIT,2)
             WHERE (CDFILIAL     = P_FILIAL) AND
                   (NRLANCTONF   = P_LANCTONF) AND
                   (CDIMPOSTO    = C_ITEM.CDIMPOSTO) AND
                   (NRSEQITPROD  = C_ITEM.NRSEQITPROD) AND
                   (NRITPROIMPOS = C_ITEM.NRITPROIMPOS);
         ELSE
           UPDATE ITEMPROIMPOS
               SET VRCONTITIMP  = ROUND(VRCONTITIMP,5),    
                   VRBASECALCIT = ROUND(VRBASECALCIT,2),
                   VRIMPOSTOIT  = ROUND(VRIMPOSTOIT,2),
                   VRIMPOSTOVISUIT = ROUND(VRIMPOSTOVISUIT,2)
             WHERE (CDFILIAL     = P_FILIAL) AND
                   (NRLANCTONF   = P_LANCTONF) AND
                   (CDIMPOSTO    = C_ITEM.CDIMPOSTO) AND
                   (NRSEQITPROD  = C_ITEM.NRSEQITPROD) AND
                   (NRITPROIMPOS = C_ITEM.NRITPROIMPOS);
         END IF;
      END LOOP;

   --FIM DA ATUALIZAÇÃO NA TABELA DE ITEMPROIMPOS

   --TOTALIZAÇÃO DOS IMPOSTOS

      DELETE IMPOSNFTOT
      WHERE (CDFILIAL = P_FILIAL) AND
            (NRLANCTONF = P_LANCTONF);

      FOR C_IMPOSNFTOT IN (SELECT IT.CDIMPOSTO
                           FROM ITEMPROIMPOS IT
                           WHERE (IT.CDFILIAL   = P_FILIAL) AND
                                 (IT.NRLANCTONF = P_LANCTONF)
                           GROUP BY IT.CDIMPOSTO) LOOP

         V_IMPOSTOIT  := 0;
         V_BASECALCIT := 0;

         SELECT NVL(SUM(IT.VRIMPOSTOIT),0), 
                NVL(SUM(IT.VRBASECALCIT),0), 
                NVL(SUM(IT.VRADICFECP),0)
         INTO   V_IMPOSTOIT, 
                V_BASECALCIT,
                V_VRADICFECPNFTOT
         FROM ITEMPROIMPOS IT, IMPOSTO I
         WHERE (IT.CDFILIAL   = P_FILIAL)               AND
               (IT.NRLANCTONF = P_LANCTONF)             AND
               (IT.CDIMPOSTO  = C_IMPOSNFTOT.CDIMPOSTO) AND
               (IT.CDIMPOSTO  = I.CDIMPOSTO);

         V_ICMS := 'N';
         FOR C_ICMS IN (SELECT CDIMPOSTO
                          FROM IMPOSTONFE N, IMPOSTO I
                         WHERE N.CDIMPOSTONFE = I.CDIMPOSTONFE
                           AND N.CDIMPOSTONFE = '00'
                           AND I.CDIMPOSTO = C_IMPOSNFTOT.CDIMPOSTO)
         LOOP
            V_ICMS := 'S';
         END LOOP;

         IF ((V_IDSISTEMA = 'VND') OR (V_IDSISTEMA = 'PDV')) AND (V_ICMS = 'S') THEN
            INSERT INTO IMPOSNFTOT(CDFILIAL, NRLANCTONF, CDIMPOSTO, VRTOTIMPONF, VRTOTBCALCNF,
                                   VRADICFECP)
                           VALUES (P_FILIAL, P_LANCTONF, C_IMPOSNFTOT.CDIMPOSTO, TRUNC(V_IMPOSTOIT ,V_NRDECITOTANF), TRUNC(V_BASECALCIT, V_NRDECITOTANF),
                                   V_VRADICFECPNFTOT);
         ELSE
            INSERT INTO IMPOSNFTOT(CDFILIAL, NRLANCTONF, CDIMPOSTO, VRTOTIMPONF, VRTOTBCALCNF,
                                   VRADICFECP)
                           VALUES (P_FILIAL, P_LANCTONF, C_IMPOSNFTOT.CDIMPOSTO, ROUND(V_IMPOSTOIT ,V_NRDECITOTANF), ROUND(V_BASECALCIT, V_NRDECITOTANF),
                                   V_VRADICFECPNFTOT);
         END IF;
      END LOOP;

   --INCLUSÃO DOS IMPOSTOS DE CORPO DE NOTA EM CASO DE NOTA FISCAL--------------------------------------------------------------------------
      V_SEQUIMPOSTNF := w_01;

      DELETE IMPOSTONF
      WHERE (CDFILIAL   = P_FILIAL) AND
            (NRLANCTONF = P_LANCTONF);


      CONSULTA_INCIDENCIA(w_S, P_EMPRESA, '', P_INSCESTA, P_TIPOOPER, P_FILIAL, P_LANCTONF, V_CDGRUPOFISC, NULL, V_IDINTEREST);

      FOR C_INCIDENCIA IN (SELECT DISTINCT (CDIMPOTEMP) AS CDIMPOTEMP, CDFISCTEMP, IDUTMUNIORIG,
                                  IDTRATIMPTMP, IDIMPORECUP, CDDETALHEPROD, IP.CDIMPOSTONFE
                           FROM INCITEMP IT, IMPOSTO IP
                           WHERE (IT.NRINCITEMP  = V_INCITEMP)       AND
                                 (IT.CDIMPOTEMP  = IP.CDIMPOSTO)     AND
                                 (IP.IDPRODNOTA  = w_C)) LOOP
         V_ALIQUTMP := 0;
         V_UTIBB    := 'N';
         V_SIMPLES  := 'N';
--integração fiscal especifica com Compass_Argentina atraves da importação de aliquota do imposto IBB
--A aliquota de imposto 03(ibb) sera cadastrada na tabela paramintegraibb e tera prioridade sobre o
-- cadastro de aliquota realizado em sistema

         /*VERIFICA CST POR IMPOSTO*/
         V_IMPOICMS := NULL;
         V_CDGRUPOFISCAUX := NULL;

         SELECT MAX(G.CDGRUPOFISC)
           INTO V_CDGRUPOFISCAUX
           FROM GRUPOFISCIMPFIL G,
                (SELECT CDFILIEMIT AS CDFILIAL
                   FROM NOTAFISCAL
                  WHERE CDFILIAL = P_FILIAL
                        AND NRLANCTONF = P_LANCTONF) F
          WHERE G.CDFILIAL = F.CDFILIAL
            AND NOT G.CDGRUPOFISC IS NULL
            AND G.CDIMPOSTO = C_INCIDENCIA.CDIMPOTEMP;

         IF V_IDORIGDESTNF = 'C' THEN
            SELECT NVL(MAX(G.CDGRUPOFISC), V_CDGRUPOFISCAUX)
              INTO V_CDGRUPOFISCAUX
              FROM GRFISIMPIECLIE G,
                   (SELECT CDCLIENTE
                      FROM NOTAFISCAL
                     WHERE CDFILIAL = P_FILIAL
                       AND NRLANCTONF = P_LANCTONF) N
             WHERE G.CDCLIENTE = N.CDCLIENTE
               AND G.CDEMPRESA = P_EMPRESA
               AND G.CDINSCESTA = P_INSCESTA
               AND NOT G.CDGRUPOFISC IS NULL
               AND G.CDIMPOSTO = C_INCIDENCIA.CDIMPOTEMP;
         ELSE
            SELECT NVL(MAX(G.CDGRUPOFISC), V_CDGRUPOFISCAUX)
              INTO V_CDGRUPOFISCAUX
              FROM GRFISIMPIEFORN G,
                  (SELECT CDFORNECED
                     FROM NOTAFISCAL
                    WHERE CDFILIAL = P_FILIAL
                      AND NRLANCTONF = P_LANCTONF) N
             WHERE G.CDFORNECED = N.CDFORNECED
               AND G.CDEMPRESA = P_EMPRESA
               AND G.CDINSCESTA = P_INSCESTA
               AND NOT G.CDGRUPOFISC IS NULL
               AND G.CDIMPOSTO = C_INCIDENCIA.CDIMPOTEMP;
         END IF;

         IF V_CDGRUPOFISCAUX IS NULL THEN
            CONSULTA_CST_NFE(w_S, P_EMPRESA, '', P_INSCESTA, P_TIPOOPER, V_CDGRUPOFISC,C_INCIDENCIA.CDIMPOTEMP, V_IDINTEREST, V_IDINTERNA, P_FILIAL, P_LANCTONF, '', V_CDSITTRIBTMP, V_IDMODBCNFE, V_IDMODBCSTNFE, V_CDTPCRPICOSTNFE, V_CDNATUBCPCSTNFE, V_IDMOTIDESSTNFE);
         ELSE
            CONSULTA_CST_NFE(w_S, P_EMPRESA, '', P_INSCESTA, P_TIPOOPER, V_CDGRUPOFISCAUX,C_INCIDENCIA.CDIMPOTEMP, V_IDINTEREST, V_IDINTERNA, P_FILIAL, P_LANCTONF, '', V_CDSITTRIBTMP, V_IDMODBCNFE, V_IDMODBCSTNFE, V_CDTPCRPICOSTNFE, V_CDNATUBCPCSTNFE, V_IDMOTIDESSTNFE);
         END IF;
         V_CDSIMPLESNACIONAL := NULL;
         V_CDFAIXA := NULL;

         /*SIMPLES NACIONAL*/
         IF (V_CDSITUCRT <> '3') THEN

            CALCULA_ALIQUOTA_SN(P_EMPRESA, 
                                P_TIPOOPER, 
                                P_INIVALID, 
                                SUBSTR(V_FISOPEITEM, 2, 3), 
                                C_INCIDENCIA.CDIMPOSTONFE, 
                                V_VRSUBLIMITESN,
                                'N',
                                V_RBT12,
                                V_RBA,
                                V_CDSIMPLESNACIONAL,
                                V_CDFAIXA,
                                V_VRALIQSIMPLES);

            IF (V_CDFAIXA IS NOT NULL) OR ((C_INCIDENCIA.CDIMPOSTONFE IN ('00', '31')) AND (V_RBT12 >= 3600000)) THEN
               V_ALIQUTMP     := V_VRALIQSIMPLES;
               V_NRALIQTEMP   := 0;
               V_PARDEDTMP    := 0;
               V_PREDBCTMP    := 0;
               V_TRATIMPST    := w_0;
               V_PBCSUBTRIB   := 0;
               V_IDPMCBASECAL := 'N';
               V_SIMPLES      := 'S';
            END IF;
         END IF;

         IF C_INCIDENCIA.CDIMPOTEMP = '03' THEN
            IF V_IDORIGDESTNF = 'C' THEN
               V_ALIQUTMP := NULL;

               V_DTVINGENTE := NVL(V_DTINIREFEFAT, P_INIVALID);

               SELECT NVL(MAX(VRALIQUOTAIBB),NULL)
               INTO   V_ALIQUTMP
               FROM PARAMINTEGRAIBB
               WHERE CDCLIENTE = P_CLIENTE AND
                     V_DTVINGENTE BETWEEN DTVIGINICIALIBB AND DTVIGFINALIBB;


               IF V_ALIQUTMP IS NOT NULL THEN
                  V_NRALIQTEMP   := 0;
                  V_PARDEDTMP    := 0;
                  V_PREDBCTMP    := 0;
                  V_TRATIMPST    := w_0;
                  V_PBCSUBTRIB   := 0;
                  V_IDPMCBASECAL := 'N';
                  V_UTIBB        := 'S';
               END IF;
            END IF;
         END IF;

         IF (V_SIMPLES = 'N') THEN
            V_CDSIMPLESNACIONAL := NULL;
            V_CDFAIXA := NULL;
            IF (V_UTIBB = 'N')  THEN
               V_ALIQUTMP  := 0;
               V_PARDEDTMP := 0;
               V_PREDBCTMP := 0;
               V_ALIQUTMP  := 0;

               IF C_INCIDENCIA.IDUTMUNIORIG = w_D THEN
                  /* CONSIDERA O MUNICIPIO DE DESTINO */
                  CONSULTA_ALIQUOTA(C_INCIDENCIA.CDIMPOTEMP, w_S, P_EMPRESA, '', P_INSCESTA, V_PAISORIG,
                                    V_ESTAORIG, V_PAISDEST, V_ESTADEST, V_MUNIDEST, V_LIQUIITEM, P_INIVALID, P_FILIAL, P_LANCTONF, V_CDGRUPOFISC, P_TIPOOPER);
               ELSE
                  /* CONSIDERA O MUNICIPIO DE ORIGEM*/
                  CONSULTA_ALIQUOTA(C_INCIDENCIA.CDIMPOTEMP, w_S, P_EMPRESA, '', P_INSCESTA, V_PAISORIG,
                                    V_ESTAORIG, V_PAISDEST, V_ESTADEST, V_MUNIORIG, V_LIQUIITEM, P_INIVALID, P_FILIAL, P_LANCTONF, V_CDGRUPOFISC, P_TIPOOPER);
               END IF;

               SELECT MAX(NRALIQTEMP), MAX(VRPARDEDTMP),            MAX(VRPREDBCTMP),
                      MAX(VRALIQUTMP), NVL(MAX(IDTRIMPSTTMP), w_0), NVL(MAX(VRPBCSTTMP),0)
               INTO   V_NRALIQTEMP, V_PARDEDTMP, V_PREDBCTMP,
                      V_ALIQUTMP,   V_TRATIMPST, V_PBCSUBTRIB
               FROM ALIQTEMP
               WHERE (NRALIQTEMP = V_ALIQTEMP);

               IF (V_ALIQUTMP IS NULL) THEN
                  V_ALIQUTMP := 0;
               END IF;
            END IF;
         END IF;
         V_PRODUENCARGO := 0;

         SELECT SUM(VRITEMENCA) AS VRSOMAITEM
         INTO   V_SOMAITEM
         FROM ITEMENCARGO IE, ENCARGO EN, BASECALC BC
         WHERE (IE.CDFILIAL   = P_FILIAL)                AND
               (IE.NRLANCTONF = P_LANCTONF)              AND
               (EN.CDENCARGO  = IE.CDENCARGO)            AND
               (BC.CDENCARGO  = IE.CDENCARGO)            AND
               (BC.CDIMPOSTO  = C_INCIDENCIA.CDIMPOTEMP) AND
               (EN.IDENCARGO  = w_A);

         SELECT SUM(VRITEMENCA) AS VRDESCITEM
         INTO   V_DESCITEM
         FROM ITEMENCARGO IE, ENCARGO EN, BASECALC BC
         WHERE (IE.CDFILIAL   = P_FILIAL)                AND
               (IE.NRLANCTONF = P_LANCTONF)              AND
               (EN.CDENCARGO  = IE.CDENCARGO)            AND
               (BC.CDENCARGO  = IE.CDENCARGO)            AND
               (BC.CDIMPOSTO  = C_INCIDENCIA.CDIMPOTEMP) AND
               (EN.IDENCARGO  = w_D);

         IF V_SOMAITEM IS NULL THEN
            V_SOMAITEM := 0;
         END IF;

         IF V_DESCITEM IS NULL THEN
            V_DESCITEM := 0;
         END IF;

         IF (V_ALIQUTMP IS NULL) THEN --VERIFICAR VALOR DA ALÍQUOTA P/ IMPOSTO RECUPERÁVEL COM COD. FISCAL = '3'
            V_ALIQUTMP := 0;
         END IF;

         IF (V_PREDBCTMP IS NULL) THEN
            V_PREDBCTMP := 0;
         END IF;

         IF (V_PARDEDTMP IS NULL) THEN
             V_PARDEDTMP := 0;
         END IF;

         V_PRODUENCARGO := V_SOMAITEM - V_DESCITEM;

         V_TAXABASECALC := (100 - V_PREDBCTMP)/100;
         V_TAXAALIQUOTA := (V_ALIQUTMP/100);
         V_TAXABCSUBSTR := 1 + (V_PBCSUBTRIB/100);
         V_BASECALCIT   := (V_LIQUIDO + V_PRODUENCARGO) * V_TAXABASECALC;

         V_PERDBCALC    := 100 - V_PREDBCTMP;

         IF V_PBCSUBTRIB > 0 THEN
            V_BASECALCIT := (V_BASECALCIT * V_TAXABCSUBSTR);
            V_PREDBCTMP  := V_PBCSUBTRIB;
            V_PERDBCALC  := 0;
         END IF;

         V_CONTIMPO     := V_BASECALCIT;
         V_IMPOSTOIT    := (V_BASECALCIT * V_TAXAALIQUOTA) - V_PARDEDTMP;

         IF V_BASECALCIT < 0 THEN
            V_BASECALCIT := 0;
         END IF;

         V_CONTABCALC := (V_LIQUIDO + V_PRODUENCARGO) - ((V_LIQUIDO + V_PRODUENCARGO) * V_TAXABASECALC);
         V_PERDBCALC  := 100 - V_PREDBCTMP;

         IF V_IMPOSTOIT < 0 THEN
            V_IMPOSTOIT := 0;
         END IF;

         V_ICMS := 'N';
         FOR C_ICMS IN (SELECT CDIMPOSTO
                          FROM IMPOSTONFE N, IMPOSTO I
                         WHERE N.CDIMPOSTONFE = I.CDIMPOSTONFE
                           AND N.CDIMPOSTONFE = '00'
                           AND I.CDIMPOSTO = C_INCIDENCIA.CDIMPOTEMP)
         LOOP
            V_ICMS := 'S';
         END LOOP;

         IF ((V_IDSISTEMA = 'VND') OR (V_IDSISTEMA = 'PDV')) AND (V_ICMS = 'S') THEN
            INSERT INTO IMPOSNFTOT(CDFILIAL, NRLANCTONF, CDIMPOSTO              , VRTOTIMPONF                              , VRTOTBCALCNF)
                           VALUES (P_FILIAL, P_LANCTONF, C_INCIDENCIA.CDIMPOTEMP, TRUNC(NVL(V_IMPOSTOIT,0), V_NRDECITOTANF), TRUNC(NVL(V_BASECALCIT,0),V_NRDECITOTANF));
         ELSE
            INSERT INTO IMPOSNFTOT(CDFILIAL, NRLANCTONF, CDIMPOSTO              , VRTOTIMPONF                              , VRTOTBCALCNF)
                           VALUES (P_FILIAL, P_LANCTONF, C_INCIDENCIA.CDIMPOTEMP, ROUND(NVL(V_IMPOSTOIT,0), V_NRDECITOTANF), ROUND(NVL(V_BASECALCIT,0),V_NRDECITOTANF));
         END IF;

         IF (C_INCIDENCIA.IDIMPORECUP = w_S) OR (C_INCIDENCIA.IDIMPORECUP <> w_S AND V_ALIQUTMP <> 0) THEN
            IF (C_INCIDENCIA.IDIMPORECUP = w_S) AND
               (C_INCIDENCIA.CDFISCTEMP <> w_1) THEN
               V_BASECALCIT := 0;
               V_ALIQUTMP   := 0;
               V_IMPOSTOIT  := 0;
               V_PREDBCTMP  := 0;
               V_PARDEDTMP  := 0;
            END IF;

            V_ICMS := 'N';
            FOR C_ICMS IN (SELECT CDIMPOSTO
                             FROM IMPOSTONFE N, IMPOSTO I
                            WHERE N.CDIMPOSTONFE = I.CDIMPOSTONFE
                              AND N.CDIMPOSTONFE = '00'
                              AND I.CDIMPOSTO = C_INCIDENCIA.CDIMPOTEMP)
            LOOP
               V_ICMS := 'S';
            END LOOP;

            IF ((V_IDSISTEMA = 'VND') OR (V_IDSISTEMA = 'PDV')) AND (V_ICMS = 'S') THEN
               INSERT INTO IMPOSTONF(
                  CDFILIAL, NRLANCTONF, CDIMPOSTO, NRIMPOSNF, VRCONTABILNF, VRPERREDBCNF, VRBASECALCNF,
                  VRALIQNF, VRPARDEDNF, VRIMPOSTONF, CDFISCALNF, IDTRIMPOSTNF, CDSITUTRIBIMNFE,  CDTPCREDPICONF, CDNATUBCALPCNF, IDMOTDESONERANF)
               VALUES(
                  P_FILIAL, P_LANCTONF, C_INCIDENCIA.CDIMPOTEMP, V_SEQUIMPOSTNF, TRUNC(V_CONTIMPO,2), V_PREDBCTMP,
                  TRUNC(V_BASECALCIT,2), V_ALIQUTMP, TRUNC(V_PARDEDTMP,2), TRUNC(V_IMPOSTOIT,2), C_INCIDENCIA.CDFISCTEMP, V_TRATIMPST, V_CDSITTRIBTMP, V_CDTPCRPICOSTNFE, V_CDNATUBCPCSTNFE, V_IDMOTIDESSTNFE);
            ELSE
               INSERT INTO IMPOSTONF(
                  CDFILIAL, NRLANCTONF, CDIMPOSTO, NRIMPOSNF, VRCONTABILNF, VRPERREDBCNF, VRBASECALCNF,
                  VRALIQNF, VRPARDEDNF, VRIMPOSTONF, CDFISCALNF, IDTRIMPOSTNF, CDSITUTRIBIMNFE, CDTPCREDPICONF, CDNATUBCALPCNF, IDMOTDESONERANF)
               VALUES(
                  P_FILIAL, P_LANCTONF, C_INCIDENCIA.CDIMPOTEMP, V_SEQUIMPOSTNF, ROUND(V_CONTIMPO,2), V_PREDBCTMP,
                  ROUND(V_BASECALCIT,2), V_ALIQUTMP, ROUND(V_PARDEDTMP,2), ROUND(V_IMPOSTOIT,2), C_INCIDENCIA.CDFISCTEMP, V_TRATIMPST, V_CDSITTRIBTMP, V_CDTPCRPICOSTNFE, V_CDNATUBCPCSTNFE, V_IDMOTIDESSTNFE);
            END IF;

            V_SEQUIMPOSTNF := LPAD(RTRIM(TO_CHAR(TO_NUMBER(V_SEQUIMPOSTNF) + 1)),2,0);

            IF (C_INCIDENCIA.IDIMPORECUP = w_S) AND
               (V_PREDBCTMP > 0) AND
               (C_INCIDENCIA.CDFISCTEMP = w_1) THEN
               INSERT INTO IMPOSTONF(
                  CDFILIAL, NRLANCTONF, CDIMPOSTO, NRIMPOSNF, VRCONTABILNF, VRPERREDBCNF, VRBASECALCNF,
                  VRALIQNF, VRPARDEDNF, VRIMPOSTONF, CDFISCALNF, CDSITUTRIBIMNFE,
				      CDTPCREDPICONF, CDNATUBCALPCNF, IDMOTDESONERANF)
               VALUES(
                  P_FILIAL, P_LANCTONF, C_INCIDENCIA.CDIMPOTEMP, V_SEQUIMPOSTNF, V_CONTABCALC, V_PERDBCALC,
                  0, 0, V_PARDEDTMP, 0, w_2, V_CDSITTRIBTMP, V_CDTPCRPICOSTNFE, V_CDNATUBCPCSTNFE, V_IDMOTIDESSTNFE);

               V_SEQUIMPOSTNF := LPAD(RTRIM(TO_CHAR(TO_NUMBER(V_SEQUIMPOSTNF) + 1)),2,0);
            END IF;
         END IF;

         DELETE ALIQTEMP
         WHERE NRALIQTEMP = V_ALIQTEMP;
      END LOOP;

      V_TOTIMPOCONT := 0;
      V_TOTIMPOBRUT := 0;

      /*CONTABILIZACAO DOS IMPOSTOS DE CORPO DE NOTA*/
      FOR C_IMPOSCONTAB IN (SELECT VRTOTIMPONF, IDIMPORECUP, CDCCTBLPASS, CDCCTBLATIV,
                                   IDTRATIMPO,  CDFISCTEMP, IDTIPCONTAB
                            FROM IMPOSNFTOT INF, IMPOSTO IP, INCITEMP IT
                            WHERE CDFILIAL      = P_FILIAL      AND
                                  NRLANCTONF    = P_LANCTONF    AND
                                  IP.CDIMPOSTO  = INF.CDIMPOSTO AND
                                  IT.CDIMPOTEMP = IP.CDIMPOSTO  AND
                                  IT.NRINCITEMP = V_INCITEMP    AND
                                  IP.IDPRODNOTA = w_C) LOOP


         IF (C_IMPOSCONTAB.IDTRATIMPO = w_A) THEN
            IF C_IMPOSCONTAB.IDTIPCONTAB = w_D THEN
               V_TOTIMPOCONT := V_TOTIMPOCONT + C_IMPOSCONTAB.VRTOTIMPONF;
            END IF;
            V_TOTIMPOBRUT := V_TOTIMPOBRUT + C_IMPOSCONTAB.VRTOTIMPONF;

         ELSIF (C_IMPOSCONTAB.IDTRATIMPO = w_D) THEN
            IF C_IMPOSCONTAB.IDTIPCONTAB = w_D THEN
               V_TOTIMPOCONT := V_TOTIMPOCONT - C_IMPOSCONTAB.VRTOTIMPONF;
            END IF;
            V_TOTIMPOBRUT := V_TOTIMPOBRUT - C_IMPOSCONTAB.VRTOTIMPONF;

         ELSIF (C_IMPOSCONTAB.IDTRATIMPO = w_R) THEN
            IF (C_IMPOSCONTAB.IDIMPORECUP = w_S) THEN
               IF (C_IMPOSCONTAB.CDCCTBLATIV IS NULL) OR
                  (C_IMPOSCONTAB.CDFISCTEMP <> w_1) AND (C_IMPOSCONTAB.IDTIPCONTAB = w_D) THEN

                  V_TOTIMPOCONT := V_TOTIMPOCONT - C_IMPOSCONTAB.VRTOTIMPONF;
               END IF;
            ELSE
               IF (C_IMPOSCONTAB.CDCCTBLATIV IS NULL) AND (C_IMPOSCONTAB.IDTIPCONTAB = w_D) THEN
                  V_TOTIMPOCONT := V_TOTIMPOCONT - C_IMPOSCONTAB.VRTOTIMPONF;
               END IF;
            END IF;
         END IF;
      END LOOP;

      IF (V_TOTIMPOBRUT <> 0) OR (V_TOTIMPOCONT <> 0) THEN
         FOR C_ITPRODUTO IN (SELECT NRSEQITPROD, (VRTOTAITEM - VRDESCITEM) AS VRLIQUIDO
                             FROM ITEMPRODUTO
                             WHERE CDFILIAL   = P_FILIAL AND
                                   NRLANCTONF = P_LANCTONF)LOOP


            IF ((V_IDSISTEMA = 'VND') OR (V_IDSISTEMA = 'PDV')) AND (NVL(V_IDORIGDESTNF, 'C') <> 'L') THEN
               UPDATE ITEMPRODUTO
               SET VRBRUTITEM = TRUNC(VRBRUTITEM + ((V_TOTIMPOBRUT / V_LIQUIDO) * C_ITPRODUTO.VRLIQUIDO),2),
                   VRCONTITEM = TRUNC(VRCONTITEM + ((V_TOTIMPOCONT / V_LIQUIDO) * C_ITPRODUTO.VRLIQUIDO),2)
               WHERE CDFILIAL    = P_FILIAL   AND
                     NRLANCTONF  = P_LANCTONF AND
                     NRSEQITPROD = C_ITPRODUTO.NRSEQITPROD;
            ELSE
               UPDATE ITEMPRODUTO
               SET VRBRUTITEM = ROUND(VRBRUTITEM + ((V_TOTIMPOBRUT / V_LIQUIDO) * C_ITPRODUTO.VRLIQUIDO),5),
                   VRCONTITEM = ROUND(VRCONTITEM + ((V_TOTIMPOCONT / V_LIQUIDO) * C_ITPRODUTO.VRLIQUIDO),5)
               WHERE CDFILIAL    = P_FILIAL   AND
                     NRLANCTONF  = P_LANCTONF AND
                     NRSEQITPROD = C_ITPRODUTO.NRSEQITPROD;
            END IF;
         END LOOP;
      END IF;

      DELETE INCITEMP
      WHERE NRINCITEMP = V_INCITEMP;

      SELECT SUM(NVL(VRBCICMSSTRETIDO,0)), SUM(NVL(VRICMSSTRETIDO,0))
        INTO V_BCICMSRET, V_ICMSRET
        FROM ITEMPROIMPOS
       WHERE CDFILIAL = P_FILIAL
         AND NRLANCTONF = P_LANCTONF;

      IF V_ICMSRET <> 0 THEN
         SELECT COUNT(*)
           INTO V_EXISTDSDADOSADIC
           FROM DADOSADIC
          WHERE CDFILIAL = P_FILIAL
            AND NRLANCTONF = P_LANCTONF
            AND DSDADOADIC LIKE 'ICMS retido anteriormente por substituição tributária: BC %';

         IF V_EXISTDSDADOSADIC = 0 THEN

            /*PREENCHE AS MENSAGENS ATRELADAS A INSCRICAO ESTADUAL*/
            INSERT INTO DADOSADIC(CDFILIAL, NRLANCTONF, NRDADOADIC, DSDADOADIC)
                           VALUES(P_FILIAL, P_LANCTONF, V_DADOADIC, 'ICMS retido anteriormente por substituição tributária: BC '||DECODE(SUBSTR(LTRIM(TO_CHAR(ROUND(V_BCICMSRET, 2), '9999999999999.99')), 1, 1), '.', '0'||LTRIM(TO_CHAR(ROUND(V_BCICMSRET, 2), '9999999999999.99')), LTRIM(TO_CHAR(ROUND(V_BCICMSRET, 2), '9999999999999.99')))|| ' Valor '|| DECODE(SUBSTR(LTRIM(TO_CHAR(ROUND(V_ICMSRET, 2), '9999999999999.99')), 1, 1), '.', '0'||LTRIM(TO_CHAR(ROUND(V_ICMSRET, 2), '9999999999999.99')), LTRIM(TO_CHAR(ROUND(V_ICMSRET, 2), '9999999999999.99'))));

            V_DADOADIC := LPAD(RTRIM(TO_CHAR(TO_NUMBER(V_DADOADIC) + 1)),3,0);
         ELSE
            UPDATE DADOSADIC
               SET DSDADOADIC = 'ICMS retido anteriormente por substituição tributária: BC '||DECODE(SUBSTR(LTRIM(TO_CHAR(ROUND(V_BCICMSRET, 2), '9999999999999.99')), 1, 1), '.', '0'||LTRIM(TO_CHAR(ROUND(V_BCICMSRET, 2), '9999999999999.99')), LTRIM(TO_CHAR(ROUND(V_BCICMSRET, 2), '9999999999999.99')))|| ' Valor '|| DECODE(SUBSTR(LTRIM(TO_CHAR(ROUND(V_ICMSRET, 2), '9999999999999.99')), 1, 1), '.', '0'||LTRIM(TO_CHAR(ROUND(V_ICMSRET, 2), '9999999999999.99')), LTRIM(TO_CHAR(ROUND(V_ICMSRET, 2), '9999999999999.99')))
             WHERE CDFILIAL = P_FILIAL
               AND NRLANCTONF = P_LANCTONF
               AND DSDADOADIC LIKE 'ICMS retido anteriormente por substituição tributária: BC %';
         END IF;
      END IF;

      FOR C_ITEMPRODUTO_DIFAL IN (SELECT NRSEQITPROD
                                    FROM ITEMPRODUTO
                                   WHERE CDFILIAL = P_FILIAL
                                     AND NRLANCTONF = P_LANCTONF) LOOP
         GERA_ICMS_INTERESTADUAL(P_FILIAL, P_LANCTONF, C_ITEMPRODUTO_DIFAL.NRSEQITPROD, P_INIVALID);
      END LOOP;
      SELECT MAX(NRDADOADIC)
        INTO V_DADOADIC
        FROM DADOSADIC
       WHERE (CDFILIAL = P_FILIAL) 
         AND (NRLANCTONF = P_LANCTONF);
      IF (V_DADOADIC IS NULL) THEN
         V_DADOADIC := W_001;
      ELSE
         V_DADOADIC := LPAD(RTRIM(TO_CHAR(TO_NUMBER(V_DADOADIC) + 1)),3,0);
      END IF;
-- FIM DA TOTALIZAÇÃO DOS IMPOSTOS

-- NOTAS COM DOCUMENTO DE ORIGEM
   ELSIF (P_TIPOOPER IN ('07','10')) OR (V_IDOPERDEVONF = w_S) OR (V_ESTORNOCANC = w_S) THEN

      DELETE FROM ITEMPROIMPOS
      WHERE CDFILIAL   = P_FILIAL AND
            NRLANCTONF = P_LANCTONF;

      DELETE FROM ITEMPROIMPOSORIG
      WHERE CDFILIAL   = P_FILIAL AND
            NRLANCTONF = P_LANCTONF;

      V_VRTOTALIPI := 0;
      V_VRTOTALICMSST := 0;
      V_CDENCARGOICMST := NULL;
      V_CDENQLEGALIPI := NULL;
      V_CDCEST := NULL;

      SELECT NVL(MAX(IDGERICMSTDESPA), 'N'), MAX(CDENCARGOICMST), NVL(MAX(IDPEINFICMSTDEME), 'N'), NVL(MAX(IDGERIPIDESPA), 'N')
        INTO V_IDGERICMSTDESPA, V_CDENCARGOICMST, V_IDPEINFICMSTDEME, V_IDGERIPIDESPA
        FROM TIPOOPERAC
       WHERE IDENTRSAIDOP = 'S'
         AND CDTIPOOPER = P_TIPOOPER;

      SELECT MAX(IDUTCTRLFISSAID)
        INTO V_IDUTCTRLFISSAID
        FROM PARAMGERAL;

      SELECT MAX(IDUTCTRLFISSAID)
        INTO V_IDUTCTRLFISFIL
        FROM PARAMFILIAL
       WHERE CDFILIAL = V_CDFILIEMIT;

      IF V_IDUTCTRLFISSAID = 'S' THEN
         V_IDUTCTRLFIS := 'S';
      ELSE
         IF V_IDUTCTRLFISFIL = 'S' THEN
            V_IDUTCTRLFIS := 'S';
         ELSE
            V_IDUTCTRLFIS := 'N';
         END IF;
      END IF;

      V_UPDENCIMPXML := 'N';

      FOR C_ITEMPROD IN (SELECT IT.*, P.CDARVPROD
                         FROM ITEMPRODUTO IT, PRODUTO P
                         WHERE IT.CDFILIAL   = P_FILIAL   AND
                               IT.NRLANCTONF = P_LANCTONF AND
                               IT.CDPRODUTO  = P.CDPRODUTO) LOOP

         V_LIQUIITEM := C_ITEMPROD.VRTOTAITEM - C_ITEMPROD.VRDESCITEM;

         CONSULTA_CST(w_S, P_EMPRESA, C_ITEMPROD.CDARVPROD, P_INSCESTA, P_TIPOOPER, P_FILIAL, P_LANCTONF, V_CDGRUPOFISC, V_IDINTEREST, V_IDINTERNA, NULL, C_ITEMPROD.IDORIGEMPROD);

         SELECT MAX(CDSITTRIBTMP)
         INTO   V_SITUTRIBPR
         FROM CSTTEMP
         WHERE (NRCSTTEMP = V_CSTTEMP);

         IF (V_IDOPERDEVONF <> w_S) THEN
            FOR C_CSTTEMP IN (SELECT DSMENSCSTTMP
                              FROM CSTTEMP
                              WHERE (NRCSTTEMP = V_CSTTEMP) AND
                                    (DSMENSCSTTMP IS NOT NULL) AND
                                    (NOT EXISTS(SELECT DSDADOADIC
                                                FROM DADOSADIC
                                                WHERE (CDFILIAL   = P_FILIAL)   AND
                                                      (NRLANCTONF = P_LANCTONF) AND
                                                      (DSDADOADIC LIKE CSTTEMP.DSMENSCSTTMP || '%')))) LOOP

               IF NOT (C_CSTTEMP.DSMENSCSTTMP IS NULL) THEN
                  /*PREENCHE AS MENSAGENS ATRELADAS AO CST*/
                  INSERT INTO DADOSADIC(CDFILIAL, NRLANCTONF, NRDADOADIC, DSDADOADIC)
                                 VALUES(P_FILIAL, P_LANCTONF, V_DADOADIC, C_CSTTEMP.DSMENSCSTTMP);

                  V_DADOADIC := LPAD(RTRIM(TO_CHAR(TO_NUMBER(V_DADOADIC) + 1)),3,0);
               END IF;
            END LOOP;
         END IF;

         CONSULTA_CFOP(w_S, P_EMPRESA, C_ITEMPROD.CDARVPROD, P_INSCESTA, P_TIPOOPER, V_PAISORIG,
                        V_ESTAORIG, V_PAISCFOP, V_ESTACFOP, P_FILIAL, P_LANCTONF, V_CDGRUPOFISC, P_INIVALID, C_ITEMPROD.IDORIGEMPROD);

         FOR C_CFOPTEMP IN (SELECT DSMENSCFOTMP
                            FROM CFOPTEMP
                            WHERE (NRCFOPTEMP = V_CFOPTEMP) AND
                                  (DSMENSCFOTMP IS NOT NULL) AND
                                  (NOT EXISTS(SELECT DSDADOADIC
                                              FROM DADOSADIC
                                              WHERE (CDFILIAL   = P_FILIAL)   AND
                                                    (NRLANCTONF = P_LANCTONF) AND
                                                    (DSDADOADIC LIKE CFOPTEMP.DSMENSCFOTMP || '%')))) LOOP

            IF NOT(C_CFOPTEMP.DSMENSCFOTMP IS NULL) THEN
               /*PREENCHE AS MENSAGENS ATRELADAS AO CFOP*/
               INSERT INTO DADOSADIC(CDFILIAL, NRLANCTONF, NRDADOADIC, DSDADOADIC)
                              VALUES(P_FILIAL, P_LANCTONF, V_DADOADIC, C_CFOPTEMP.DSMENSCFOTMP);

               V_DADOADIC := LPAD(RTRIM(TO_CHAR(TO_NUMBER(V_DADOADIC) + 1)),3,0);
            END IF;
         END LOOP;

         IF (NVL(V_CFOPINFUSU, 'N') <> 'S') AND (V_CDFISCOPERREGRA IS NOT NULL) THEN
            V_DSCDFISOPEITREGRA := SUBSTR(DESCRICAO_CFOP(V_CDFISCOPERREGRA),1,45);
         END IF;

         IF (V_DSCDFISOPEITREGRA IS NOT NULL) THEN
            UPDATE NOTAFISCAL
               SET DSCDFISOPENF = V_DSCDFISOPEITREGRA
             WHERE CDFILIAL   = P_FILIAL   AND
                   NRLANCTONF = P_LANCTONF;
         ELSE
            UPDATE NOTAFISCAL
               SET DSCDFISOPENF = (SELECT MAX(DSCFOPTMP)
                                     FROM CFOPTEMP
                                    WHERE NRCFOPTEMP = V_CFOPTEMP)
             WHERE CDFILIAL   = P_FILIAL
               AND NRLANCTONF = P_LANCTONF;

         END IF;

         SELECT MAX(CDFISOPETMP), MAX(CDSUFCFOPTMP),SUBSTR(MAX(DSCFOPTMP),1,50)
         INTO   V_FISOPEITEM,     V_SUFXCFOPPR,     V_DSCDFISOPEIT
         FROM CFOPTEMP
         WHERE NRCFOPTEMP = V_CFOPTEMP;

         CONSULTA_CSOSN('S', P_EMPRESA, C_ITEMPROD.CDARVPROD, P_INSCESTA, P_TIPOOPER, P_FILIAL, P_LANCTONF, V_CDGRUPOFISC,V_IDINTEREST, V_CDFISCOPERSN);

         IF (NVL(V_CFOPINFUSU, 'N') <> 'S') AND (V_CDFISCOPERREGRA IS NOT NULL) THEN
            V_FISOPEITEM := NVL(V_CDFISCOPERREGRA, V_FISOPEITEM);
            V_DSCDFISOPEITREGRA := SUBSTR(DESCRICAO_CFOP(V_CDFISCOPERREGRA),1,45);
         END IF;

         UPDATE ITEMPRODUTO
         SET CDFISOPEITEM = V_FISOPEITEM,
             CDSUFXCFOPPR = V_SUFXCFOPPR,
             CDSITUTRIBPR  = NVL(V_SITUTRIBPR, C_ITEMPROD.CDSITUTRIBPR),
             DSCDFISOPEIT = V_DSCDFISOPEIT,
             CDFISCOPERSN = V_CDFISCOPERSN
         WHERE CDFILIAL    = P_FILIAL     AND
               NRLANCTONF  = P_LANCTONF   AND
               NRSEQITPROD = C_ITEMPROD.NRSEQITPROD;

         IF V_IDOPERDEVONF = w_S THEN
            FOR C_ITEMNOTAFISC IN (SELECT CDFILIALIT, NRLANCTONFIT
                                   FROM ITEMNOTAFISC
                                   WHERE CDFILIAL   = P_FILIAL AND
                                         NRLANCTONF = P_LANCTONF) LOOP


               IF V_IDDEVOLIST = w_S THEN /*SE A NOTA POSSUI VARIOS DOCUMENTOS DE ORIGEM*/
                  SELECT SUM(I.QTITEMPROD)
                    INTO V_SOMAQITEMPROD
                    FROM ITEMPRODUTO I
                   WHERE CDFILIAL    = C_ITEMNOTAFISC.CDFILIALIT                                               AND
                         NRLANCTONF  = C_ITEMNOTAFISC.NRLANCTONFIT                                             AND
                         CDPRODUTO   = C_ITEMPROD.CDPRODUTO                                                    AND
                         ROUND(VRUNITITEM, V_NRDECITOTANF) = ROUND(C_ITEMPROD.VRUNITITEM, V_NRDECITOTANF)      AND
                         (NVL(NRLOTEESTQ, ' ')  = (NVL(C_ITEMPROD.NRLOTEESTQ, ' ')))                           AND
                         (NVL(NRSUBLOTE , ' ')  = (NVL(C_ITEMPROD.NRSUBLOTE , ' ')));

                  SELECT NVL(MAX(C_ITEMPROD.QTITEMPROD / V_SOMAQITEMPROD),1) AS VRFATOCONV,
                         NVL(MAX(VRBRUTITEM),0), NVL(MAX(VRCONTITEM),0)
                  INTO   V_VRFATOCONV, V_VRBRUTO, V_VRCONTAB
                  FROM ITEMPRODUTO I
                  WHERE CDFILIAL    = C_ITEMNOTAFISC.CDFILIALIT                                               AND
                        NRLANCTONF  = C_ITEMNOTAFISC.NRLANCTONFIT                                             AND
                        CDPRODUTO   = C_ITEMPROD.CDPRODUTO                                                    AND
                        ROUND(VRUNITITEM, V_NRDECITOTANF) = ROUND(C_ITEMPROD.VRUNITITEM, V_NRDECITOTANF)      AND
                        (NVL(NRLOTEESTQ, ' ')  = (NVL(C_ITEMPROD.NRLOTEESTQ, ' ')))                           AND
                        (NVL(NRSUBLOTE , ' ')  = (NVL(C_ITEMPROD.NRSUBLOTE , ' ')));

                  IF V_CDINTEGRACAO IS NOT NULL THEN
                     IF ((V_IDSISTEMA = 'VND') OR (V_IDSISTEMA = 'PDV')) AND (NVL(V_IDORIGDESTNF, 'C') <> 'L') THEN
                        UPDATE ITEMPRODUTO
                        SET VRCONTITEM = TRUNC((V_VRCONTAB * V_VRFATOCONV),2),
                            VRBRUTITEM = TRUNC((V_VRBRUTO * V_VRFATOCONV),2)
                        WHERE CDFILIAL    = P_FILIAL                                                          AND
                              NRLANCTONF  = P_LANCTONF                                                        AND
                              CDPRODUTO   = C_ITEMPROD.CDPRODUTO                                              AND
                             ROUND(VRUNITITEM, V_NRDECITOTANF) = ROUND(C_ITEMPROD.VRUNITITEM, V_NRDECITOTANF) AND
                             (NVL(NRLOTEESTQ, ' ')  = (NVL(C_ITEMPROD.NRLOTEESTQ, ' ')))                      AND
                             (NVL(NRSUBLOTE , ' ')  = (NVL(C_ITEMPROD.NRSUBLOTE , ' ')));
                     ELSE
                        UPDATE ITEMPRODUTO
                        SET VRCONTITEM = ROUND(V_VRCONTAB * V_VRFATOCONV,5),
                            VRBRUTITEM = ROUND(V_VRBRUTO * V_VRFATOCONV,5)
                        WHERE CDFILIAL    = P_FILIAL                                                          AND
                              NRLANCTONF  = P_LANCTONF                                                        AND
                              CDPRODUTO   = C_ITEMPROD.CDPRODUTO                                              AND
                              VRUNITITEM  = C_ITEMPROD.VRUNITITEM                                             AND
                             (NVL(NRLOTEESTQ, ' ')  = (NVL(C_ITEMPROD.NRLOTEESTQ, ' ')))                      AND
                             (NVL(NRSUBLOTE , ' ')  = (NVL(C_ITEMPROD.NRSUBLOTE , ' ')));
                     END IF;

                  END IF;

                  /*IMPOSTOS POR ITEM DA NOTA DE ORIGEM*/
                  FOR C_ITEMPROIMPOS IN (SELECT VRPERREDBCIT, NRITPROIMPOS, IT.CDIMPOSTO, CDFISCALIT,
                                                VRALIQITEM, VRPARDEDIT, SUM(VRCONTITIMP) AS VRCONTITIMP,
                                                SUM(VRBASECALCIT) AS VRBASECALCIT, SUM(VRIMPOSTOIT) AS VRIMPOSTOIT,
                                                CDSITUTRIBITNFE AS CDSITUTRIBNFE, IDMODBCITNFE AS IDMODBCNFE, IDMODBCSTITNFE AS IDMODBCSTNFE,
                                                CDTPCREDPICOITE, CDNATUBCALPCIT, IDMOTDESONERAIT, IDTRIMPSTII, NVL(IDDIFALIQCUSPRI, 'N') AS IDDIFALIQCUSPRI,
                                                IM.CDIMPOSTONFE, IT.CDENQLEGALIPI, IT.CDCEST, IT.CDBENEFFISCAL
                                          FROM ITEMPROIMPOS IT, ITEMPRODUTO I, IMPOSTO IM
                                         WHERE IT.CDFILIAL    = C_ITEMNOTAFISC.CDFILIALIT                                         AND
                                               IT.NRLANCTONF  = C_ITEMNOTAFISC.NRLANCTONFIT                                       AND
                                               I.CDFILIAL     = C_ITEMNOTAFISC.CDFILIALIT                                         AND
                                               I.NRLANCTONF   = C_ITEMNOTAFISC.NRLANCTONFIT                                       AND
                                               IT.NRSEQITPROD = I.NRSEQITPROD                                                     AND
                                               IT.CDIMPOSTO   = IM.CDIMPOSTO                                                      AND
                                               I.CDPRODUTO = C_ITEMPROD.CDPRODUTO                                                 AND
                                               IT.NRITPROIMPOS = '1'                                                              AND
                                               ROUND(I.VRUNITITEM, V_NRDECITOTANF) = ROUND(C_ITEMPROD.VRUNITITEM, V_NRDECITOTANF) AND
                                               (NVL(I.NRLOTEESTQ, ' ') = (NVL(C_ITEMPROD.NRLOTEESTQ, ' ')))                       AND
                                               (NVL(I.NRSUBLOTE, ' ')  = (NVL(C_ITEMPROD.NRSUBLOTE,  ' ')))
                                         GROUP BY VRPERREDBCIT, IT.CDIMPOSTO, NRITPROIMPOS, CDFISCALIT, VRALIQITEM,
                                                  VRPARDEDIT,   CDSITUTRIBITNFE, IDMODBCITNFE, IDMODBCSTITNFE,
                                                  CDTPCREDPICOITE, CDNATUBCALPCIT, IDMOTDESONERAIT, IDTRIMPSTII, IDDIFALIQCUSPRI,
                                                  IM.CDIMPOSTONFE, IT.CDENQLEGALIPI, IT.CDCEST
                                         ORDER BY CDIMPOSTO) LOOP

                     V_CDBENEFFISCAL := NULL;

                     CONSULTA_INCIDENCIA(w_S, P_EMPRESA, C_ITEMPROD.CDARVPROD, P_INSCESTA, P_TIPOOPER, P_FILIAL, P_LANCTONF, V_CDGRUPOFISC,
                                        NULL, V_IDINTEREST, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, C_ITEMPROD.IDORIGEMPROD);

                     IF V_CDSITTRIBTMP IS NULL THEN
                        V_CDSITTRIBTMP := SUBSTR(V_SITUTRIBPR, 2, 2);
                     END IF;

                     BEGIN
                        SELECT MAX(CDFISCTEMP), MAX(CDDETALHEPROD), MAX(CDENQLEGALIPI), MAX(CDCEST)
                          INTO V_CDFISCTEMP, V_CDDETALHEPRODTEMP, V_CDENQLEGALIPI, V_CDCEST
                          FROM INCITEMP IT, IMPOSTO IP
                        WHERE IT.NRINCITEMP = V_INCITEMP
                          AND IP.CDIMPOSTO  = IT.CDIMPOTEMP
                          AND IP.IDPRODNOTA = w_P
                          AND IT.CDIMPOTEMP = C_ITEMPROIMPOS.CDIMPOSTO;
                     EXCEPTION
                        WHEN NO_DATA_FOUND THEN
                           V_CDFISCTEMP        := NULL;
                           V_CDDETALHEPRODTEMP := NULL;
                           V_CDENQLEGALIPI     := NULL;
                           V_CDCEST            := NULL;
                     END;

                     IF (C_ITEMPROIMPOS.VRPERREDBCIT > 0.00) AND
                        (C_ITEMPROIMPOS.NRITPROIMPOS = w_2) THEN
                        V_CDFISCTEMP := w_2;
                     ELSE
                        IF (V_CDFISCTEMP IS NULL) THEN
                            V_CDFISCTEMP := C_ITEMPROIMPOS.CDFISCALIT;
                        END IF;
                     END IF;

                     IF V_CDENQLEGALIPI IS NULL THEN
                        V_CDENQLEGALIPI := C_ITEMPROIMPOS.CDENQLEGALIPI;
                     END IF;

                     IF V_CDCEST IS NULL THEN
                        V_CDCEST := C_ITEMPROIMPOS.CDCEST;
                     END IF;

                     DELETE INCITEMP
                      WHERE NRINCITEMP = V_INCITEMP;

                     /*VERIFICA CST POR IMPOSTO*/
                     V_IMPOICMS := NULL;
                     V_CDGRUPOFISCAUX := NULL;

                     SELECT MAX(G.CDGRUPOFISC)
                       INTO V_CDGRUPOFISCAUX
                       FROM GRUPOFISCIMPFIL G,
                            (SELECT CDFILIEMIT AS CDFILIAL
                               FROM NOTAFISCAL
                              WHERE CDFILIAL = P_FILIAL
                                    AND NRLANCTONF = P_LANCTONF) F
                      WHERE G.CDFILIAL = F.CDFILIAL
                        AND NOT G.CDGRUPOFISC IS NULL
                        AND G.CDIMPOSTO = C_ITEMPROIMPOS.CDIMPOSTO;

                     IF V_IDORIGDESTNF = 'C' THEN
                        SELECT NVL(MAX(G.CDGRUPOFISC), V_CDGRUPOFISCAUX)
                          INTO V_CDGRUPOFISCAUX
                          FROM GRFISIMPIECLIE G,
                               (SELECT CDCLIENTE
                                  FROM NOTAFISCAL
                                 WHERE CDFILIAL = P_FILIAL
                                   AND NRLANCTONF = P_LANCTONF) N
                         WHERE G.CDCLIENTE = N.CDCLIENTE
                           AND G.CDEMPRESA = P_EMPRESA
                           AND G.CDINSCESTA = P_INSCESTA
                           AND NOT G.CDGRUPOFISC IS NULL
                           AND G.CDIMPOSTO = C_ITEMPROIMPOS.CDIMPOSTO;
                     ELSE
                        SELECT NVL(MAX(G.CDGRUPOFISC), V_CDGRUPOFISCAUX)
                          INTO V_CDGRUPOFISCAUX
                          FROM GRFISIMPIEFORN G,
                              (SELECT CDFORNECED
                                 FROM NOTAFISCAL
                                WHERE CDFILIAL = P_FILIAL
                                  AND NRLANCTONF = P_LANCTONF) N
                         WHERE G.CDFORNECED = N.CDFORNECED
                           AND G.CDEMPRESA = P_EMPRESA
                           AND G.CDINSCESTA = P_INSCESTA
                           AND NOT G.CDGRUPOFISC IS NULL
                           AND G.CDIMPOSTO = C_ITEMPROIMPOS.CDIMPOSTO;
                     END IF;

                     IF V_CDGRUPOFISCAUX IS NULL THEN
                        CONSULTA_CST_NFE(w_S, P_EMPRESA, C_ITEMPROD.CDARVPROD, P_INSCESTA, P_TIPOOPER, V_CDGRUPOFISC,C_ITEMPROIMPOS.CDIMPOSTO, V_IDINTEREST, V_IDINTERNA, P_FILIAL, P_LANCTONF, '', V_CDSITTRIBTMP, V_IDMODBCNFE, V_IDMODBCSTNFE, V_CDTPCRPICOSTNFE, V_CDNATUBCPCSTNFE, V_IDMOTIDESSTNFE, C_ITEMPROD.IDORIGEMPROD);
                     ELSE
                        CONSULTA_CST_NFE(w_S, P_EMPRESA, C_ITEMPROD.CDARVPROD, P_INSCESTA, P_TIPOOPER, V_CDGRUPOFISCAUX,C_ITEMPROIMPOS.CDIMPOSTO, V_IDINTEREST, V_IDINTERNA, P_FILIAL, P_LANCTONF, '', V_CDSITTRIBTMP, V_IDMODBCNFE, V_IDMODBCSTNFE, V_CDTPCRPICOSTNFE, V_CDNATUBCPCSTNFE, V_IDMOTIDESSTNFE, C_ITEMPROD.IDORIGEMPROD);
                     END IF;

                     IF (V_CDSITTRIBTMP IS NULL) THEN
                        V_CDSITUTRIBNFE := C_ITEMPROIMPOS.CDSITUTRIBNFE;
                     ELSE
                        V_CDSITUTRIBNFE := V_CDSITTRIBTMP;
                     END IF;

                     IF (V_IDMODBCNFE IS NULL) THEN
                        V_IDMODBCNFEIT := C_ITEMPROIMPOS.IDMODBCNFE;
                     ELSE
                        V_IDMODBCNFEIT := V_IDMODBCNFE;
                     END IF;

                     IF (V_IDMODBCSTNFE IS NULL) THEN
                        V_IDMODBCSTNFEIT := C_ITEMPROIMPOS.IDMODBCSTNFE;
                     ELSE
                        V_IDMODBCSTNFEIT := V_IDMODBCSTNFE;
                     END IF;

                     IF (C_ITEMPROIMPOS.CDTPCREDPICOITE IS NULL) THEN
                        V_CDTPCRPICOSTNFEIT := V_CDTPCRPICOSTNFE;
                     ELSE
                        V_CDTPCRPICOSTNFEIT := C_ITEMPROIMPOS.CDTPCREDPICOITE;
                     END IF;

                     IF (C_ITEMPROIMPOS.CDNATUBCALPCIT IS NULL) THEN
                        V_CDNATUBCPCSTNFEIT := V_CDNATUBCPCSTNFE;
                     ELSE
                        V_CDNATUBCPCSTNFEIT := C_ITEMPROIMPOS.CDNATUBCALPCIT;
                     END IF;

                     IF (V_IDMOTIDESSTNFE IS NULL) THEN
                        V_IDMOTIDESSTNFE := C_ITEMPROIMPOS.IDMOTDESONERAIT;
                     ELSE
                        V_IDMOTIDESSTNFE := V_IDMOTIDESSTNFE;
                     END IF;


                     SELECT NVL(MAX(IDUTMUNIORIG),'N')
                       INTO V_IDUTMUNIORIG
                       FROM IMPOSTO
                      WHERE CDIMPOSTO = C_ITEMPROIMPOS.CDIMPOSTO;

                     IF ((V_IDUTMUNIORIG = 'O') OR (V_IDUTMUNIORIG = 'N')) THEN
                        CONSULTA_ALIQUOTA(C_ITEMPROIMPOS.CDIMPOSTO, w_S, P_EMPRESA, C_ITEMPROD.CDARVPROD, P_INSCESTA, V_PAISORIG,
                                          V_ESTAORIG, V_PAISDEST, V_ESTADEST, V_MUNIORIG, V_LIQUIITEM, P_INIVALID, P_FILIAL, P_LANCTONF, V_CDGRUPOFISC, P_TIPOOPER,
                                          NULL, NULL, NULL, NULL, NULL, NULL, C_ITEMPROD.IDORIGEMPROD);
                     ELSE
                        CONSULTA_ALIQUOTA(C_ITEMPROIMPOS.CDIMPOSTO, w_S, P_EMPRESA, C_ITEMPROD.CDARVPROD, P_INSCESTA, V_PAISORIG,
                                          V_ESTAORIG, V_PAISDEST, V_ESTADEST, V_MUNIDEST, V_LIQUIITEM, P_INIVALID, P_FILIAL, P_LANCTONF, V_CDGRUPOFISC, P_TIPOOPER,
                                          NULL, NULL, NULL, NULL, NULL, NULL, C_ITEMPROD.IDORIGEMPROD);
                     END IF;

                     V_NRALIQTEMP := 0;
                     V_PARDEDTMP  := 0;
                     V_PREDBCTMP  := 0;
                     V_ALIQUTMP   := 0;
                     V_IMPOSTOIT  := 0;
                     V_CDTIPOOPER    := NULL;
                     V_CDREGRAITALIQ := NULL;

                     SELECT NVL(MAX(NRALIQTEMP),0),      NVL(MAX(VRPARDEDTMP),0), NVL(MAX(VRPREDBCTMP),0), NVL(MAX(VRALIQUTMP),0),
                            NVL(MAX(IDTRIMPSTTMP), w_0), NVL(MAX(VRPBCSTTMP),0),  NVL(MAX(IDPMCBSCALTMP), w_S),
                            MAX(CDTIPOOPERTMP),          MAX(CDREGRATMP),
                            MAX(CDFISCOPER),             MAX(IDDIFEALIQ),         MAX(IDDIFALIQCUSPR),
                            MAX(CDBENEFFISCAL)
                     INTO   V_NRALIQTEMP,                V_PARDEDTMP,             V_PREDBCTMP,             V_ALIQUTMP,
                            V_TRATIMPST,                 V_PBCSUBTRIB,            V_IDPMCBASECAL,
                            V_CDTIPOOPER,                V_CDREGRAITALIQ,
                            V_CDFISCOPERREGRA,           V_IDDIFEALIQREGRA,       V_IDDIFALIQCUSPRREGRA,
                            V_CDBENEFFISCAL
                     FROM ALIQTEMP
                     WHERE (NRALIQTEMP = V_ALIQTEMP);

                     IF V_CDBENEFFISCAL IS NULL THEN
                        V_CDBENEFFISCAL := C_ITEMPROIMPOS.CDBENEFFISCAL;
                     END IF;

                     /*Verifica alíquota parametrizada por tipo de operação desde que não seja nota de estorno de cancelamento*/

                     IF V_PAISORIG = V_PAISCFOP THEN
                        IF V_ESTAORIG = V_ESTACFOP THEN
                           V_CFOP1DIGT := '5';
                        ELSE
                           V_CFOP1DIGT := '6';
                        END IF;
                     ELSE
                        V_CFOP1DIGT := '7';
                     END IF;

                     IF V_CDFISCOPERREGRA IS NOT NULL THEN
                        IF (LENGTH(V_CDFISCOPERREGRA) < 4) THEN
                           V_CDFISCOPERREGRA := V_CFOP1DIGT||V_CDFISCOPERREGRA;
                        END IF;
                     END IF;

                     IF ((V_NRALIQTEMP IS NOT NULL) AND (V_CDTIPOOPER IS NOT NULL) AND (V_ESTORNOCANC <> w_S))THEN
                        IF /*(C_ITEMPROIMPOS.VRPERREDBCIT > 0.00) AND*/
                           (C_ITEMPROIMPOS.NRITPROIMPOS = w_2) THEN

                           V_CDIMPOSTRIB  := null;
                           V_IDVRIMPSTRIB := null;

                        ELSE
                           V_CDIMPOSTRIB  := null;
                           V_IDVRIMPSTRIB := null;

                           /*IMPOSTO DE SUBSTITUICAO TRIBUTARIA*/
                           FOR C_ICMSST IN (SELECT CDIMPOSTO
                                              FROM IMPOSTO
                                             WHERE CDIMPOSTRIB = C_ITEMPROIMPOS.CDIMPOSTO)
                           LOOP
                              V_CDIMPOSTRIB := V_CDIMPOSTRIB||C_ICMSST.CDIMPOSTO||'_';
                           END LOOP;

                           V_TAXABASECALC := (100 - V_PREDBCTMP)/100;
                           V_TAXAALIQUOTA := (V_ALIQUTMP/100);
                           V_TAXABCSUBSTR := 1 + (V_PBCSUBTRIB/100);
                           V_BASECALCIT   := V_LIQUIITEM * V_TAXABASECALC;

                           V_PERDBCALC    := 100 - V_PREDBCTMP;

                           IF V_PBCSUBTRIB > 0 THEN
                              V_BASECALCIT := (V_BASECALCIT * V_TAXABCSUBSTR);
                              V_PREDBCTMP  := V_PBCSUBTRIB;
                              V_PERDBCALC  := 0;
                           END IF;


                           V_BASECALCTO  := V_BASECALCIT;
                           V_IMPOSTOIT   := (V_BASECALCIT * V_TAXAALIQUOTA) - V_PARDEDTMP;

                           IF V_CDIMPOSTRIB IS NULL THEN
                              V_IDTRIMPSTII := '';
                           ELSE
                              IF SUBSTR(V_SITUTRIBPR, 2, 2) = '60' THEN
                                 V_IDTRIMPSTII := w_2;
                              ELSE 
                                 V_IDTRIMPSTII := V_TRATIMPST;
                              END IF;
                           END IF;

                           V_CONTABCALC  := V_LIQUIITEM - (V_LIQUIITEM * V_TAXABASECALC);

                           IF V_CDIMPOSTRIB IS NOT NULL THEN
                              SELECT NVL(MAX(IDVRIMPSTRIB), 'N')
                                INTO V_IDVRIMPSTRIB
                                FROM ITEMPROIMPOS I, IMPOSTO II
                               WHERE (CDFILIAL     = P_FILIAL)
                                 AND (NRLANCTONF   = P_LANCTONF)
                                 AND (NRSEQITPROD  = C_ITEMPROD.NRSEQITPROD)
                                 AND(INSTR(V_CDIMPOSTRIB,II.CDIMPOSTO||'_') > 0)
                                 AND (I.CDIMPOSTO = II.CDIMPOSTO);


                              IF (V_TRATIMPST = w_1) OR (NVL(V_IDVRIMPSTRIB,w_N) = w_N) THEN
                                 V_VRIMPOSTOST := 0;
                              ELSE
                                 Begin
                                    SELECT NVL(MAX(VRIMPOSTOIT),0)
                                      INTO   V_VRIMPOSTOST
                                      FROM ITEMPROIMPOS I
                                     WHERE (CDFILIAL     = P_FILIAL)
                                       AND (NRLANCTONF   = P_LANCTONF)
                                       AND (NRSEQITPROD  = C_ITEMPROD.NRSEQITPROD)
                                       AND (INSTR(V_CDIMPOSTRIB,CDIMPOSTO||'_') > 0)
                                       AND (NRITPROIMPOS = w_1);
                                 Exception
                                    When No_Data_Found Then
                                       V_VRIMPOSTOST := 0;
                                 End;

                              END IF;
                              V_IMPOSTOIT := V_IMPOSTOIT - V_VRIMPOSTOST;

                              IF V_IMPOSTOIT < 0 THEN
                                 V_IMPOSTOIT := 0;
                              END IF;
                           END IF;

                           IF (V_ALIQUTMP = 0) AND (V_IMPOSTOIT = 0) THEN
                              V_BASECALCTO := 0;
                           END IF;

                           Begin
                             SELECT CDFILIAL
                             INTO   V_CHAVE
                             FROM ITEMPROIMPOS
                             WHERE CDFILIAL     = P_FILIAL                 AND
                                   NRLANCTONF   = P_LANCTONF               AND
                                   NRSEQITPROD  = C_ITEMPROD.NRSEQITPROD   AND
                                   CDIMPOSTO    = C_ITEMPROIMPOS.CDIMPOSTO AND
                                   NRITPROIMPOS = C_ITEMPROIMPOS.NRITPROIMPOS;
                          Exception
                             When No_Data_Found Then
                                V_CHAVE := Null;
                          End;

                          IF V_CHAVE IS NULL THEN
                             V_ICMS := 'N';
                             FOR C_ICMS IN (SELECT CDIMPOSTO
                                              FROM IMPOSTONFE N, IMPOSTO I
                                             WHERE N.CDIMPOSTONFE = I.CDIMPOSTONFE
                                               AND N.CDIMPOSTONFE = '00'
                                               AND I.CDIMPOSTO = C_ITEMPROIMPOS.CDIMPOSTO)
                             LOOP
                                V_ICMS := 'S';
                             END LOOP;

                             IF (V_ICMS = 'S') THEN

                                V_CDGRUPOFISCAUX := NULL;

                                SELECT MAX(G.CDGRUPOFISC)
                                  INTO V_CDGRUPOFISCAUX
                                  FROM GRUPOFISCIMPFIL G,
                                       (SELECT CDFILIEMIT AS CDFILIAL
                                          FROM NOTAFISCAL
                                         WHERE CDFILIAL = P_FILIAL
                                               AND NRLANCTONF = P_LANCTONF) F
                                 WHERE G.CDFILIAL = F.CDFILIAL
                                   AND NOT G.CDGRUPOFISC IS NULL
                                   AND G.CDIMPOSTO = C_ITEMPROIMPOS.CDIMPOSTO;
                                IF V_IDORIGDESTNF = 'C' THEN
                                   SELECT NVL(MAX(G.CDGRUPOFISC), V_CDGRUPOFISCAUX)
                                     INTO V_CDGRUPOFISCAUX
                                     FROM GRFISIMPIECLIE G,
                                          (SELECT CDCLIENTE
                                             FROM NOTAFISCAL
                                            WHERE CDFILIAL = P_FILIAL
                                              AND NRLANCTONF = P_LANCTONF) N
                                    WHERE G.CDCLIENTE = N.CDCLIENTE
                                      AND G.CDEMPRESA = P_EMPRESA
                                      AND G.CDINSCESTA = P_INSCESTA
                                      AND NOT G.CDGRUPOFISC IS NULL
                                      AND G.CDIMPOSTO = C_ITEMPROIMPOS.CDIMPOSTO;
                                ELSE
                                   SELECT NVL(MAX(G.CDGRUPOFISC), V_CDGRUPOFISCAUX)
                                     INTO V_CDGRUPOFISCAUX
                                     FROM GRFISIMPIEFORN G,
                                         (SELECT CDFORNECED
                                            FROM NOTAFISCAL
                                           WHERE CDFILIAL = P_FILIAL
                                             AND NRLANCTONF = P_LANCTONF) N
                                    WHERE G.CDFORNECED = N.CDFORNECED
                                      AND G.CDEMPRESA = P_EMPRESA
                                      AND G.CDINSCESTA = P_INSCESTA
                                      AND NOT G.CDGRUPOFISC IS NULL
                                      AND G.CDIMPOSTO = C_ITEMPROIMPOS.CDIMPOSTO;
                                END IF;

                                IF (V_CDGRUPOFISCAUX IS NOT NULL) THEN
                                   CONSULTA_CFOP(w_S, P_EMPRESA, C_ITEMPROD.CDARVPROD, P_INSCESTA, P_TIPOOPER, V_PAISORIG,
                                                 V_ESTAORIG, V_PAISCFOP, V_ESTACFOP, P_FILIAL, P_LANCTONF, V_CDGRUPOFISCAUX, P_INIVALID, C_ITEMPROD.IDORIGEMPROD);

                                ELSE
                                   CONSULTA_CFOP(w_S, P_EMPRESA, C_ITEMPROD.CDARVPROD, P_INSCESTA, P_TIPOOPER, V_PAISORIG,
                                                 V_ESTAORIG, V_PAISCFOP, V_ESTACFOP, P_FILIAL, P_LANCTONF, V_CDGRUPOFISC, P_INIVALID, C_ITEMPROD.IDORIGEMPROD);
                                END IF;
                                IF (NVL(V_CFOPINFUSU, 'N') <> 'S') AND (V_CDFISCOPERREGRA IS NOT NULL) THEN
                                   V_FISOPEITEM        := NVL(V_CDFISCOPERREGRA, V_FISOPEITEM);
                                   V_DSCDFISOPEITREGRA := SUBSTR(DESCRICAO_CFOP(V_CDFISCOPERREGRA),1,45);
                                END IF;

                                UPDATE NOTAFISCAL
                                   SET DSCDFISOPENF = NVL(V_DSCDFISOPEITREGRA, (SELECT MAX(DSCFOPTMP)
                                                                                    FROM CFOPTEMP
                                                                                   WHERE NRCFOPTEMP = V_CFOPTEMP))
                                 WHERE CDFILIAL   = P_FILIAL   AND
                                       NRLANCTONF = P_LANCTONF;


                                SELECT MAX(CDFISOPETMP), MAX(CDSUFCFOPTMP), SUBSTR(MAX(DSCFOPTMP),1,50)
                                  INTO V_FISOPEITEM    , V_SUFXCFOPPR, V_DSCDFISOPEIT
                                  FROM CFOPTEMP
                                 WHERE NRCFOPTEMP = V_CFOPTEMP;

                                IF (NVL(V_CFOPINFUSU, 'N') <> 'S') AND (V_CDFISCOPERREGRA IS NOT NULL) THEN
                                   V_FISOPEITEM        := NVL(V_CDFISCOPERREGRA, V_FISOPEITEM);
                                   V_DSCDFISOPEITREGRA := SUBSTR(DESCRICAO_CFOP(V_CDFISCOPERREGRA),1,45);
                                END IF;

                                UPDATE ITEMPRODUTO
                                   SET CDFISOPEITEM  = V_FISOPEITEM,
                                       CDSUFXCFOPPR  = V_SUFXCFOPPR,
                                       DSCDFISOPEIT  = V_DSCDFISOPEIT
                                 WHERE CDFILIAL    = P_FILIAL AND
                                       NRLANCTONF  = P_LANCTONF AND
                                       NRSEQITPROD = C_ITEMPROD.NRSEQITPROD;

                                DELETE CFOPTEMP
                                 WHERE NRCFOPTEMP = V_CFOPTEMP;

                                Begin
                                   SELECT MAX(CDCSTDIG1PROD)
                                     INTO V_CST1DIGT
                                     FROM PRODUTO
                                    WHERE (CDARVPROD = C_ITEMPROD.CDARVPROD);

                                   IF V_CST1DIGT IS NULL THEN
                                      SELECT MAX(CDCSTDIG1SAI)
                                        INTO   V_CST1DIGT
                                        FROM INSCRESTAD
                                       WHERE (CDEMPRESA  = P_EMPRESA) AND
                                             (CDINSCESTA = P_INSCESTA);
                                   END IF;
                                Exception
                                   When No_Data_Found Then
                                      V_CST1DIGT := Null;
                                End;

                                IF (V_IDUTORIGPROD = 'S') AND (C_ITEMPROD.IDORIGEMPROD = 'E') THEN
                                   V_CST1DIGT := '2';
                                END IF;

                                UPDATE ITEMPRODUTO
                                   SET CDSITUTRIBPR  = V_CST1DIGT||NVL(V_CDSITTRIBTMP, SUBSTR(V_SITUTRIBPR, 2,2))
                                 WHERE CDFILIAL    = P_FILIAL AND
                                       NRLANCTONF  = P_LANCTONF AND
                                       NRSEQITPROD = C_ITEMPROD.NRSEQITPROD;

                                V_SITUTRIBPR := V_CST1DIGT||NVL(V_CDSITTRIBTMP, SUBSTR(V_SITUTRIBPR, 2,2));
                             END IF;


                             SELECT NVL(MAX(IDPERVISIMPSCRE), 'S')
                               INTO V_IDPERVISIMPSCRE
                               FROM PARAMGERAL;

                             IF V_IDPERVISIMPSCRE = 'S' THEN
                                V_VRIMPOSTOVISUIT := V_IMPOSTOIT;
                             ELSE
                                IF (V_CDFISCTEMP = '1') THEN
                                   V_VRIMPOSTOVISUIT := V_IMPOSTOIT;
                                ELSE
                                   V_VRIMPOSTOVISUIT := 0;
                                END IF;
                             END IF;

                             /* ROTINA PARA CALCULAR O DIFERIMENTO DO IMPOSTO */
                             V_PERDIFERE    := NULL;
                             V_IMPOSTOOPERA := NULL;
                             V_IMPOSTODIFER := NULL;
                             IF C_ITEMPROIMPOS.CDIMPOSTONFE = '00' THEN
                                IF V_CDSITTRIBTMP = 51 THEN
                                   BEGIN
                                      SELECT PD.VRPERDIFERE, 'S'
                                        INTO V_VRPERDIFERE, V_IDDIFECLI
                                        FROM PRODDIFEREIMPCLI PD, PRODUTO PR
                                       WHERE PD.CDPRODUTO = PR.CDPRODUTO
                                         AND PD.CDPAIS = V_PAISORIG
                                         AND PD.SGESTADO = V_ESTAORIG
                                         AND PD.CDCLIENTE = P_CLIENTE
                                         AND PR.CDARVPROD IN (SELECT MAX(PR.CDARVPROD) AS CDARVPROD
                                                                FROM PRODDIFEREIMPCLI PD, PRODUTO PR
                                                               WHERE PD.CDPRODUTO = PR.CDPRODUTO
                                                                 AND PD.CDPAIS = V_PAISORIG
                                                                 AND PD.SGESTADO = V_ESTAORIG
                                                                 AND PD.CDCLIENTE = P_CLIENTE
                                                                 AND INSTR(NVL(RTRIM(C_ITEMPROD.CDARVPROD), PR.CDARVPROD), PR.CDARVPROD) = 1);
                                   EXCEPTION
                                      WHEN NO_DATA_FOUND THEN
                                         V_VRPERDIFERE := NULL; V_IDDIFECLI := 'N';
                                   END;

                                   IF V_IDDIFECLI = 'N' THEN
                                      BEGIN
                                         SELECT PD.VRPERDIFERE
                                           INTO V_VRPERDIFERE
                                           FROM PRODDIFEREIMPOS PD, PRODUTO PR
                                          WHERE PD.CDPRODUTO = PR.CDPRODUTO
                                            AND PD.CDPAIS = V_PAISORIG
                                            AND PD.SGESTADO = V_ESTAORIG
                                            AND PR.CDARVPROD IN (SELECT MAX(PR.CDARVPROD) AS CDARVPROD
                                                                   FROM PRODDIFEREIMPOS PD, PRODUTO PR
                                                                  WHERE PD.CDPRODUTO = PR.CDPRODUTO
                                                                    AND PD.CDPAIS = V_PAISORIG
                                                                    AND PD.SGESTADO = V_ESTAORIG
                                                                    AND INSTR(NVL(RTRIM(C_ITEMPROD.CDARVPROD), PR.CDARVPROD), PR.CDARVPROD) = 1);
                                      EXCEPTION
                                         WHEN NO_DATA_FOUND THEN
                                            V_VRPERDIFERE := NULL;
                                      END;
                                   END IF;
                                   IF V_VRPERDIFERE IS NOT NULL THEN
                                      V_PERDIFERE    := V_VRPERDIFERE;
                                      V_IMPOSTOOPERA := V_IMPOSTOIT;
                                      V_IMPOSTODIFER := V_IMPOSTOOPERA * (V_VRPERDIFERE/100);
                                      V_IMPOSTOIT := V_IMPOSTOOPERA - V_IMPOSTODIFER;
                                   END IF;
                                END IF;
                             END IF;

                             IF ((V_IDSISTEMA = 'VND') OR (V_IDSISTEMA = 'PDV')) AND (V_ICMS = 'S') THEN
                                INSERT INTO ITEMPROIMPOS(
                                   CDFILIAL,        NRLANCTONF,   NRSEQITPROD,    CDIMPOSTO,       NRITPROIMPOS,   CDFISCALIT,
                                   CDSITUTRIBIT,    CDFISCOPERIT, CDSUFXCFOPIT,   VRALIQITEM,      VRPERREDBCIT,   VRPARDEDIT,
                                   VRCONTITIMP,     VRBASECALCIT, VRIMPOSTOIT,    IDERROSIMPIT,    IDAVISIMPIT,    IDTRIMPSTII,
                                   CDSITUTRIBITNFE, IDMODBCITNFE, IDMODBCSTITNFE, CDTPCREDPICOITE, CDNATUBCALPCIT, IDMOTDESONERAIT,
                                   CDDETALHEPROD, VRIMPOSTOVISUIT, CDREGRAIT, VRPERDIFEREIT, VRIMPOSTOOPERAIT, VRIMPOSTODIFERIT,
                                   CDENQLEGALIPI, CDCEST, CDBENEFFISCAL)
                                VALUES(
                                   P_FILIAL,                P_LANCTONF,     C_ITEMPROD.NRSEQITPROD, C_ITEMPROIMPOS.CDIMPOSTO, w_1,                 V_CDFISCTEMP,
                                   NVL(V_SITUTRIBPR, C_ITEMPROD.CDSITUTRIBPR), V_FISOPEITEM,   V_SUFXCFOPPR,           V_ALIQUTMP,               V_PREDBCTMP,         V_PARDEDTMP,
                                   TRUNC(V_BASECALCTO,2),   V_BASECALCTO,   TRUNC(V_IMPOSTOIT,2),   w_00000,                  w_00000,             V_IDTRIMPSTII,
                                   V_CDSITUTRIBNFE,         V_IDMODBCNFEIT, V_IDMODBCSTNFEIT,       V_CDTPCRPICOSTNFEIT,      V_CDNATUBCPCSTNFEIT, V_IDMOTIDESSTNFE,
                                   V_CDDETALHEPRODTEMP, TRUNC(V_VRIMPOSTOVISUIT,2), V_CDREGRAITALIQ, V_PERDIFERE, V_IMPOSTOOPERA, V_IMPOSTODIFER,
                                   V_CDENQLEGALIPI, V_CDCEST, V_CDBENEFFISCAL);
                             ELSE
                                INSERT INTO ITEMPROIMPOS(
                                   CDFILIAL,        NRLANCTONF,   NRSEQITPROD,     CDIMPOSTO,       NRITPROIMPOS,   CDFISCALIT,
                                   CDSITUTRIBIT,    CDFISCOPERIT, CDSUFXCFOPIT,    VRALIQITEM,      VRPERREDBCIT,   VRPARDEDIT,
                                   VRCONTITIMP,     VRBASECALCIT, VRIMPOSTOIT,     IDERROSIMPIT,    IDAVISIMPIT,    IDTRIMPSTII,
                                   CDSITUTRIBITNFE, IDMODBCITNFE, IDMODBCSTITNFE,  CDTPCREDPICOITE, CDNATUBCALPCIT, IDMOTDESONERAIT,
                                   CDDETALHEPROD, VRIMPOSTOVISUIT,   CDREGRAIT, VRPERDIFEREIT, VRIMPOSTOOPERAIT, VRIMPOSTODIFERIT,
                                   CDENQLEGALIPI, CDCEST, CDBENEFFISCAL)
                                VALUES(
                                   P_FILIAL,                P_LANCTONF,     C_ITEMPROD.NRSEQITPROD, C_ITEMPROIMPOS.CDIMPOSTO, w_1,                 V_CDFISCTEMP,
                                   NVL(V_SITUTRIBPR, C_ITEMPROD.CDSITUTRIBPR), V_FISOPEITEM,   V_SUFXCFOPPR,           V_ALIQUTMP,               V_PREDBCTMP,         V_PARDEDTMP,
                                   ROUND(V_BASECALCTO,5),   ROUND(V_BASECALCTO,2),   ROUND(V_IMPOSTOIT,2),   w_00000,                  w_00000,             V_IDTRIMPSTII,  
                                   V_CDSITUTRIBNFE,         V_IDMODBCNFEIT, V_IDMODBCSTNFEIT,       V_CDTPCRPICOSTNFEIT,      V_CDNATUBCPCSTNFEIT, V_IDMOTIDESSTNFE,
                                   V_CDDETALHEPRODTEMP, ROUND(V_VRIMPOSTOVISUIT,2), V_CDREGRAITALIQ, V_PERDIFERE, V_IMPOSTOOPERA, V_IMPOSTODIFER,
                                   V_CDENQLEGALIPI, V_CDCEST, V_CDBENEFFISCAL);
                             END IF;

                             IF (C_ITEMPROIMPOS.NRITPROIMPOS = w_1) THEN
                                IF (V_PREDBCTMP > 0) AND (V_PBCSUBTRIB = 0) THEN
                                   IF C_ITEMPROD.CDSITUTRIBPR = '060' THEN
                                      INSERT INTO ITEMPROIMPOS(
                                         CDFILIAL,        NRLANCTONF,      NRSEQITPROD,     CDIMPOSTO,       NRITPROIMPOS,   CDFISCALIT,
                                         CDSITUTRIBIT,    CDFISCOPERIT,    CDSUFXCFOPIT,    VRALIQITEM,      VRPERREDBCIT,   VRPARDEDIT,
                                         VRCONTITIMP,     VRBASECALCIT,    VRIMPOSTOIT,     IDERROSIMPIT,    IDAVISIMPIT,    IDTRIMPSTII,
                                         CDSITUTRIBITNFE, IDMODBCITNFE,    IDMODBCSTITNFE,  CDTPCREDPICOITE, CDNATUBCALPCIT, IDMOTDESONERAIT,
                                         CDDETALHEPROD, VRIMPOSTOVISUIT,   CDREGRAIT, CDENQLEGALIPI, CDCEST, CDBENEFFISCAL)
                                      VALUES(
                                         P_FILIAL,                P_LANCTONF,      C_ITEMPROD.NRSEQITPROD, C_ITEMPROIMPOS.CDIMPOSTO, w_2,                 w_2,
                                         NVL(V_SITUTRIBPR, C_ITEMPROD.CDSITUTRIBPR), V_FISOPEITEM,    V_SUFXCFOPPR,           0,                        V_PERDBCALC,         V_PARDEDTMP,
                                         V_CONTABCALC,            0,               0,                      w_00000,                  w_00000,             V_IDTRIMPSTII,
                                         V_CDSITUTRIBNFE,         V_IDMODBCNFEIT,  V_IDMODBCSTNFEIT,       V_CDTPCRPICOSTNFEIT,      V_CDNATUBCPCSTNFEIT, V_IDMOTIDESSTNFE,
                                         V_CDDETALHEPRODTEMP, 0, V_CDREGRAITALIQ, V_CDENQLEGALIPI, V_CDCEST, V_CDBENEFFISCAL);
                                   ELSE
                                      INSERT INTO ITEMPROIMPOS(
                                         CDFILIAL,        NRLANCTONF,     NRSEQITPROD,     CDIMPOSTO,       NRITPROIMPOS,   CDFISCALIT,
                                         CDSITUTRIBIT,    CDFISCOPERIT,   CDSUFXCFOPIT,    VRALIQITEM,      VRPERREDBCIT,   VRPARDEDIT,
                                         VRCONTITIMP,     VRBASECALCIT,   VRIMPOSTOIT,     IDERROSIMPIT,    IDAVISIMPIT,    IDTRIMPSTII,
                                         CDSITUTRIBITNFE, IDMODBCITNFE,   IDMODBCSTITNFE,  CDTPCREDPICOITE, CDNATUBCALPCIT, IDMOTDESONERAIT,
                                         CDDETALHEPROD,   VRIMPOSTOVISUIT,   CDREGRAIT, CDENQLEGALIPI,      CDCEST,         CDBENEFFISCAL)
                                      VALUES(
                                         P_FILIAL,                P_LANCTONF,     C_ITEMPROD.NRSEQITPROD, C_ITEMPROIMPOS.CDIMPOSTO, w_2,                 w_2,
                                         NVL(V_SITUTRIBPR, C_ITEMPROD.CDSITUTRIBPR), V_FISOPEITEM,   V_SUFXCFOPPR,           0,                        V_PERDBCALC,         V_PARDEDTMP,
                                         V_CONTABCALC,            0,              0,                      w_00000,                  w_00000,             V_IDTRIMPSTII,
                                         V_CDSITUTRIBNFE,         V_IDMODBCNFEIT, V_IDMODBCSTNFEIT,       V_CDTPCRPICOSTNFEIT,      V_CDNATUBCPCSTNFEIT, V_IDMOTIDESSTNFE,
                                         V_CDDETALHEPRODTEMP, 0, V_CDREGRAITALIQ, V_CDENQLEGALIPI,        V_CDCEST,                 V_CDBENEFFISCAL);
                                   END IF;
                                END IF;
                             END IF;
                          END IF;
                       END IF;
                     ELSE

                        Begin
                           SELECT CDFILIAL
                           INTO   V_CHAVE
                           FROM ITEMPROIMPOS
                           WHERE CDFILIAL     = P_FILIAL                 AND
                                 NRLANCTONF   = P_LANCTONF               AND
                                 NRSEQITPROD  = C_ITEMPROD.NRSEQITPROD   AND
                                 CDIMPOSTO    = C_ITEMPROIMPOS.CDIMPOSTO AND
                                 NRITPROIMPOS = C_ITEMPROIMPOS.NRITPROIMPOS;
                        Exception
                           When No_Data_Found Then
                              V_CHAVE := Null;
                        End;

                        SELECT NVL(MAX(IDPERVISIMPSCRE), 'S')
                          INTO V_IDPERVISIMPSCRE
                          FROM PARAMGERAL;

                        IF V_IDPERVISIMPSCRE = 'S' THEN
                           V_VRIMPOSTOVISUIT := (C_ITEMPROIMPOS.VRIMPOSTOIT * V_VRFATOCONV);
                        ELSE
                           IF (V_CDFISCTEMP = '1') THEN
                              V_VRIMPOSTOVISUIT := (C_ITEMPROIMPOS.VRIMPOSTOIT * V_VRFATOCONV);
                           ELSE
                              V_VRIMPOSTOVISUIT := 0;
                           END IF;
                        END IF;

                        IF V_CHAVE IS NULL THEN
                           V_ICMS := 'N';
                           FOR C_ICMS IN (SELECT CDIMPOSTO
                                            FROM IMPOSTONFE N, IMPOSTO I
                                           WHERE N.CDIMPOSTONFE = I.CDIMPOSTONFE
                                             AND N.CDIMPOSTONFE = '00'
                                             AND I.CDIMPOSTO = C_ITEMPROIMPOS.CDIMPOSTO)
                           LOOP
                              V_ICMS := 'S';
                           END LOOP;

                           IF ((V_IDSISTEMA = 'VND') OR (V_IDSISTEMA = 'PDV')) AND (V_ICMS = 'S') THEN
                              INSERT INTO ITEMPROIMPOS(CDFILIAL,     NRLANCTONF,     NRSEQITPROD,     CDIMPOSTO,      NRITPROIMPOS,    CDFISCALIT,
                                                       CDSITUTRIBIT, CDFISCOPERIT,   CDSUFXCFOPIT,    VRALIQITEM,     VRPERREDBCIT,    VRPARDEDIT,
                                                       VRCONTITIMP,  VRBASECALCIT,   VRIMPOSTOIT,     IDERROSIMPIT,   IDAVISIMPIT,     CDSITUTRIBITNFE,
                                                       IDMODBCITNFE, IDMODBCSTITNFE, CDTPCREDPICOITE, CDNATUBCALPCIT, IDMOTDESONERAIT, IDTRIMPSTII,
                                                       CDDETALHEPROD, VRIMPOSTOVISUIT, CDENQLEGALIPI, CDCEST, CDBENEFFISCAL)
                              VALUES(P_FILIAL, P_LANCTONF, C_ITEMPROD.NRSEQITPROD, C_ITEMPROIMPOS.CDIMPOSTO, C_ITEMPROIMPOS.NRITPROIMPOS, V_CDFISCTEMP,
                                     NVL(V_SITUTRIBPR, C_ITEMPROD.CDSITUTRIBPR), V_FISOPEITEM, V_SUFXCFOPPR, C_ITEMPROIMPOS.VRALIQITEM, C_ITEMPROIMPOS.VRPERREDBCIT, TRUNC((C_ITEMPROIMPOS.VRPARDEDIT * V_VRFATOCONV),2),
                                     TRUNC((C_ITEMPROIMPOS.VRCONTITIMP * V_VRFATOCONV),2), TRUNC((C_ITEMPROIMPOS.VRBASECALCIT * V_VRFATOCONV),2),
                                     TRUNC((C_ITEMPROIMPOS.VRIMPOSTOIT * V_VRFATOCONV),2), w_00000, w_00000, V_CDSITUTRIBNFE,
                                     V_IDMODBCNFEIT, V_IDMODBCSTNFEIT, V_CDTPCRPICOSTNFEIT, V_CDNATUBCPCSTNFEIT, V_IDMOTIDESSTNFE, C_ITEMPROIMPOS.IDTRIMPSTII,
                                     V_CDDETALHEPRODTEMP, V_VRIMPOSTOVISUIT, V_CDENQLEGALIPI, V_CDCEST, V_CDBENEFFISCAL);
                           ELSE
                              IF (C_ITEMPROIMPOS.NRITPROIMPOS = w_3)  THEN

                                 /*Inserir a linha de diferencial de alíquota*/

                                 V_DIFALIQ := 0;

                                 SELECT MAX(VRALIQITEM)
                                   INTO V_DIFALIQ
                                   FROM ITEMPROIMPOS IT, ITEMPRODUTO I
                                  WHERE IT.CDFILIAL     = C_ITEMNOTAFISC.CDFILIALIT
                                    AND IT.NRLANCTONF   = C_ITEMNOTAFISC.NRLANCTONFIT
                                    AND I.CDFILIAL      = C_ITEMNOTAFISC.CDFILIALIT
                                    AND I.NRLANCTONF    = C_ITEMNOTAFISC.NRLANCTONFIT
                                    AND IT.NRSEQITPROD  = I.NRSEQITPROD
                                    AND I.CDPRODUTO     = C_ITEMPROD.CDPRODUTO
                                    AND ROUND(I.VRUNITITEM, V_NRDECITOTANF) = ROUND(C_ITEMPROD.VRUNITITEM, V_NRDECITOTANF)
                                    AND (NVL(NRLOTEESTQ, ' ') = (NVL(C_ITEMPROD.NRLOTEESTQ, ' ')))
                                    AND (NVL(NRSUBLOTE, ' ')  = (NVL(C_ITEMPROD.NRSUBLOTE , ' ')))
                                    AND IT.CDIMPOSTO    = C_ITEMPROIMPOS.CDIMPOSTO
                                    AND IT.NRITPROIMPOS = w_1;

                                 IF  (V_ALIQUTMP = V_DIFALIQ) THEN

                                    INSERT INTO ITEMPROIMPOS(
                                       CDFILIAL,        NRLANCTONF,   NRSEQITPROD,    CDIMPOSTO,       NRITPROIMPOS,   CDFISCALIT,
                                       CDSITUTRIBIT,    CDFISCOPERIT, CDSUFXCFOPIT,   VRALIQITEM,      VRPERREDBCIT,   VRPARDEDIT,
                                       VRCONTITIMP,     VRBASECALCIT, VRIMPOSTOIT,    IDERROSIMPIT,    IDAVISIMPIT,    IDTRIMPSTII,
                                       CDSITUTRIBITNFE, IDMODBCITNFE, IDMODBCSTITNFE, CDTPCREDPICOITE, CDNATUBCALPCIT, IDMOTDESONERAIT,
                                       CDDETALHEPROD,   VRIMPOSTOVISUIT,   CDREGRAIT, IDDIFALIQCUSPRI, CDENQLEGALIPI,  CDCEST,
                                       CDBENEFFISCAL)
                                    VALUES(
                                       P_FILIAL, P_LANCTONF, C_ITEMPROD.NRSEQITPROD, C_ITEMPROIMPOS.CDIMPOSTO, C_ITEMPROIMPOS.NRITPROIMPOS, C_ITEMPROIMPOS.CDFISCALIT,
                                       C_ITEMPROD.CDSITUTRIBPR, V_FISOPEITEM, V_SUFXCFOPPR, C_ITEMPROIMPOS.VRALIQITEM, C_ITEMPROIMPOS.VRPERREDBCIT, (C_ITEMPROIMPOS.VRPARDEDIT * V_VRFATOCONV),
                                       ROUND((C_ITEMPROIMPOS.VRCONTITIMP * V_VRFATOCONV),5), (C_ITEMPROIMPOS.VRBASECALCIT * V_VRFATOCONV), 
                                       (C_ITEMPROIMPOS.VRIMPOSTOIT * V_VRFATOCONV), w_00000, w_00000, C_ITEMPROIMPOS.IDTRIMPSTII, C_ITEMPROIMPOS.CDSITUTRIBNFE,
                                       C_ITEMPROIMPOS.IDMODBCNFE, C_ITEMPROIMPOS.IDMODBCSTNFE, C_ITEMPROIMPOS.CDTPCREDPICOITE, C_ITEMPROIMPOS.CDNATUBCALPCIT, NVL(C_ITEMPROIMPOS.IDMOTDESONERAIT,'9'),
                                       V_CDDETALHEPRODTEMP, (C_ITEMPROIMPOS.VRIMPOSTOIT * V_VRFATOCONV), V_CDREGRAITALIQ, C_ITEMPROIMPOS.IDDIFALIQCUSPRI, V_CDENQLEGALIPI, V_CDCEST,
                                       V_CDBENEFFISCAL);
                                 END IF;
                                 /*Inserir a linha de diferencial de alíquota*/
                              ELSE

                                 INSERT INTO ITEMPROIMPOS(CDFILIAL,     NRLANCTONF,     NRSEQITPROD,     CDIMPOSTO,      NRITPROIMPOS,    CDFISCALIT,
                                                          CDSITUTRIBIT, CDFISCOPERIT,   CDSUFXCFOPIT,    VRALIQITEM,     VRPERREDBCIT,    VRPARDEDIT,
                                                          VRCONTITIMP,  VRBASECALCIT,   VRIMPOSTOIT,     IDERROSIMPIT,   IDAVISIMPIT,     CDSITUTRIBITNFE,
                                                          IDMODBCITNFE, IDMODBCSTITNFE, CDTPCREDPICOITE, CDNATUBCALPCIT, IDMOTDESONERAIT, IDTRIMPSTII,
                                                          CDDETALHEPROD, VRIMPOSTOVISUIT, IDDIFALIQCUSPRI, CDENQLEGALIPI, CDCEST,         CDBENEFFISCAL)
                                 VALUES(P_FILIAL, P_LANCTONF, C_ITEMPROD.NRSEQITPROD, C_ITEMPROIMPOS.CDIMPOSTO, C_ITEMPROIMPOS.NRITPROIMPOS, V_CDFISCTEMP,
                                        NVL(V_SITUTRIBPR, C_ITEMPROD.CDSITUTRIBPR), V_FISOPEITEM, V_SUFXCFOPPR, C_ITEMPROIMPOS.VRALIQITEM, C_ITEMPROIMPOS.VRPERREDBCIT, (C_ITEMPROIMPOS.VRPARDEDIT * V_VRFATOCONV),
                                        ROUND((C_ITEMPROIMPOS.VRCONTITIMP * V_VRFATOCONV),5), (C_ITEMPROIMPOS.VRBASECALCIT * V_VRFATOCONV),  
                                        (C_ITEMPROIMPOS.VRIMPOSTOIT * V_VRFATOCONV), w_00000, w_00000, V_CDSITUTRIBNFE,
                                        V_IDMODBCNFEIT, V_IDMODBCSTNFEIT, V_CDTPCRPICOSTNFEIT, V_CDNATUBCPCSTNFEIT, V_IDMOTIDESSTNFE, C_ITEMPROIMPOS.IDTRIMPSTII,
                                        V_CDDETALHEPRODTEMP, V_VRIMPOSTOVISUIT, C_ITEMPROIMPOS.IDDIFALIQCUSPRI, V_CDENQLEGALIPI, V_CDCEST, V_CDBENEFFISCAL);
                              END IF;
                           END IF;
                        END IF;
                     END IF;

                     DELETE ALIQTEMP
                      WHERE NRALIQTEMP = V_ALIQTEMP;
                  END LOOP;
               ELSE /*SE A NOTA POSSUI UM UNICO DOCUMENTO DE ORIGEM*/
                  Begin
                     SELECT SUM(I.QTITEMPROD)
                       INTO V_SOMAQITEMPROD
                       FROM ITEMPRODUTO I
                      WHERE CDFILIAL    = C_ITEMNOTAFISC.CDFILIALIT                                          AND
                            NRLANCTONF  = C_ITEMNOTAFISC.NRLANCTONFIT                                        AND
                            CDPRODUTO   = C_ITEMPROD.CDPRODUTO                                               AND
                            ROUND(VRUNITITEM, V_NRDECITOTANF) = ROUND(C_ITEMPROD.VRUNITITEM, V_NRDECITOTANF) AND
                            (NVL(NRLOTEESTQ, ' ')  = (NVL(C_ITEMPROD.NRLOTEESTQ, ' ')))                      AND
                            (NVL(NRSUBLOTE , ' ')  = (NVL(C_ITEMPROD.NRSUBLOTE , ' ')));

                     SELECT NVL(MAX(C_ITEMPROD.QTITEMPROD / V_SOMAQITEMPROD),1) AS VRFATOCONV,
                            NVL(SUM(VRBRUTITEM),0), NVL(SUM(VRCONTITEM),0), NVL(SUM(VRENCARGOIMPXML), 0)
                       INTO V_VRFATOCONV, V_VRBRUTO, V_VRCONTAB, V_VRENCARGOIMPXML
                       FROM ITEMPRODUTO I
                      WHERE CDFILIAL    = C_ITEMNOTAFISC.CDFILIALIT                                          AND
                            NRLANCTONF  = C_ITEMNOTAFISC.NRLANCTONFIT                                        AND
                            CDPRODUTO   = C_ITEMPROD.CDPRODUTO                                               AND
                            ROUND(VRUNITITEM, V_NRDECITOTANF) = ROUND(C_ITEMPROD.VRUNITITEM, V_NRDECITOTANF) AND
                            (NVL(NRLOTEESTQ, ' ')  = (NVL(C_ITEMPROD.NRLOTEESTQ, ' ')))                      AND
                            (NVL(NRSUBLOTE , ' ')  = (NVL(C_ITEMPROD.NRSUBLOTE , ' ')));
                  Exception
                     When No_Data_Found Then
                        V_VRFATOCONV := 1; V_VRBRUTO := 0; V_VRCONTAB := 0;
                  End;

                 /*IF P_TIPOOPER = '03' THEN
                    Begin
                       SELECT NVL(C_ITEMPROD.VRTOTAITEM / SUM(I.VRTOTAITEM) ,1) AS VRFATOCONV,
                              NVL(SUM(VRBRUTITEM),0), NVL(SUM(VRCONTITEM),0)
                       INTO   V_VRFATOCONV, V_VRBRUTO, V_VRCONTAB
                       FROM ITEMPRODUTO I
                       WHERE CDFILIAL    = C_ITEMNOTAFISC.CDFILIALIT                                          AND
                             NRLANCTONF  = C_ITEMNOTAFISC.NRLANCTONFIT                                        AND
                             CDPRODUTO   = C_ITEMPROD.CDPRODUTO                                               AND
                             ROUND(VRUNITITEM, V_NRDECITOTANF) = ROUND(C_ITEMPROD.VRUNITITEM, V_NRDECITOTANF) AND
                             (NVL(NRLOTEESTQ, ' ')  = (NVL(C_ITEMPROD.NRLOTEESTQ, ' ')))                      AND
                             (NVL(NRSUBLOTE , ' ')  = (NVL(C_ITEMPROD.NRSUBLOTE , ' ')));
                    Exception
                       When No_Data_Found Then
                          V_VRFATOCONV := 1; V_VRBRUTO := 0; V_VRCONTAB := 0;
                    End;
                 END IF;*/
                  IF P_TIPOOPER <> '03' THEN

                    UPDATE ITEMPRODUTO
                       SET VRCONTITEMORIG = ROUND(V_VRCONTAB * V_VRFATOCONV,5),
                           VRBRUTITEMORIG = ROUND(V_VRBRUTO * V_VRFATOCONV,5),
                           VRCONTITEM = ROUND(V_VRCONTAB * V_VRFATOCONV,5),
                           VRBRUTITEM = ROUND(V_VRBRUTO * V_VRFATOCONV,5),
                           VRENCARGOIMPXML = ROUND(V_VRENCARGOIMPXML * V_VRFATOCONV,2)
                     WHERE CDFILIAL    = P_FILIAL                                                           AND
                           NRLANCTONF  = P_LANCTONF                                                         AND
                           CDPRODUTO   = C_ITEMPROD.CDPRODUTO                                               AND
                           ROUND(VRUNITITEM, V_NRDECITOTANF) = ROUND(C_ITEMPROD.VRUNITITEM, V_NRDECITOTANF) AND
                           (NVL(NRLOTEESTQ, ' ') = (NVL(C_ITEMPROD.NRLOTEESTQ, ' ')))                        AND
                           (NVL(NRSUBLOTE , ' ') = (NVL(C_ITEMPROD.NRSUBLOTE , ' ')));
                  END IF;

                  IF V_CDINTEGRACAO IS NOT NULL THEN
                     IF ((V_IDSISTEMA = 'VND') OR (V_IDSISTEMA = 'PDV')) AND (NVL(V_IDORIGDESTNF, 'C') <> 'L') THEN
                        UPDATE ITEMPRODUTO
                        SET VRCONTITEM = TRUNC((V_VRCONTAB * V_VRFATOCONV),2),
                            VRBRUTITEM = TRUNC((V_VRBRUTO * V_VRFATOCONV),2)
                        WHERE CDFILIAL    = P_FILIAL                                                           AND
                              NRLANCTONF  = P_LANCTONF                                                         AND
                              CDPRODUTO   = C_ITEMPROD.CDPRODUTO                                               AND
                              ROUND(VRUNITITEM, V_NRDECITOTANF) = ROUND(C_ITEMPROD.VRUNITITEM, V_NRDECITOTANF) AND
                             (NVL(NRLOTEESTQ, ' ') = (NVL(C_ITEMPROD.NRLOTEESTQ, ' ')))                        AND
                             (NVL(NRSUBLOTE , ' ') = (NVL(C_ITEMPROD.NRSUBLOTE , ' ')));
                     ELSE

                        UPDATE ITEMPRODUTO
                        SET VRCONTITEM = ROUND(V_VRCONTAB * V_VRFATOCONV,5),
                            VRBRUTITEM = ROUND(V_VRBRUTO * V_VRFATOCONV,5)
                        WHERE CDFILIAL    = P_FILIAL                                                           AND
                              NRLANCTONF  = P_LANCTONF                                                         AND
                              CDPRODUTO   = C_ITEMPROD.CDPRODUTO                                               AND
                              ROUND(VRUNITITEM, V_NRDECITOTANF) = ROUND(C_ITEMPROD.VRUNITITEM, V_NRDECITOTANF) AND
                             (NVL(NRLOTEESTQ, ' ') = (NVL(C_ITEMPROD.NRLOTEESTQ, ' ')))                        AND
                             (NVL(NRSUBLOTE , ' ') = (NVL(C_ITEMPROD.NRSUBLOTE , ' ')));
                     END IF;
                  END IF;
                  V_CDIMPOSRECALC := NULL;

                  UPDATE ITEMPRODUTO
                     SET IDUTILBCPMC = 'N'
                   WHERE CDFILIAL = P_FILIAL
                     AND NRLANCTONF = P_LANCTONF
                     AND NRSEQITPROD = C_ITEMPROD.NRSEQITPROD;

                  IF (V_IDCONTCONFORIG = 'N') THEN
                     UPDATE ITEMPRODUTO
                        SET VRCONTITEMORIG = (VRTOTAITEM - VRDESCITEM),
                            VRCONTITEM     = (VRTOTAITEM - VRDESCITEM),
                            VRBRUTITEMORIG = VRTOTAITEM,
                            VRBRUTITEM     = VRTOTAITEM
                      WHERE CDFILIAL       = P_FILIAL
                        AND NRLANCTONF     = P_LANCTONF
                        AND NRSEQITPROD    = C_ITEMPROD.NRSEQITPROD;
                  END IF;

                  /*IMPOSTOS POR ITEM DA NOTA DE ORIGEM*/
                  FOR C_ITEMPROIMPOS IN (SELECT VRPERREDBCIT, NRITPROIMPOS, IT.CDIMPOSTO, CDFISCALIT,
                                                VRALIQITEM, VRPARDEDIT, SUM(VRCONTITIMP) AS VRCONTITIMP,
                                                SUM(VRBASECALCIT) AS VRBASECALCIT, SUM(VRIMPOSTOIT) AS VRIMPOSTOIT,
                                                CDSITUTRIBITNFE AS CDSITUTRIBNFE, IDMODBCITNFE AS IDMODBCNFE, IDMODBCSTITNFE AS IDMODBCSTNFE,
                                                CDTPCREDPICOITE, CDNATUBCALPCIT, IDMOTDESONERAIT, IDTRIMPSTII, NVL(IDDIFALIQCUSPRI, 'N') AS IDDIFALIQCUSPRI,
                                                IM.CDIMPOSTONFE, IT.CDENQLEGALIPI, IT.CDCEST,
                                                NVL(IT.VRADICFECP, 0) AS VRADICFECP, NVL(SUM(IT.VRADICALIQFECP), 0) AS VRADICALIQFECP,
                                                IT.CDBENEFFISCAL, I.CDFISOPEITEM
                                          FROM ITEMPROIMPOS IT, ITEMPRODUTO I, IMPOSTO IM
                                         WHERE IT.CDFILIAL    = C_ITEMNOTAFISC.CDFILIALIT                                         AND
                                               IT.NRLANCTONF  = C_ITEMNOTAFISC.NRLANCTONFIT                                       AND
                                               I.CDFILIAL     = C_ITEMNOTAFISC.CDFILIALIT                                         AND
                                               I.NRLANCTONF   = C_ITEMNOTAFISC.NRLANCTONFIT                                       AND
                                               IT.NRSEQITPROD = I.NRSEQITPROD                                                     AND
                                               IT.CDIMPOSTO   = IM.CDIMPOSTO                                                      AND
                                               I.CDPRODUTO = C_ITEMPROD.CDPRODUTO                                                 AND
                                               IT.NRITPROIMPOS = '1'                                                              AND
                                               ROUND(I.VRUNITITEM, V_NRDECITOTANF) = ROUND(C_ITEMPROD.VRUNITITEM, V_NRDECITOTANF) AND
                                               (NVL(I.NRLOTEESTQ, ' ') = (NVL(C_ITEMPROD.NRLOTEESTQ, ' ')))                       AND
                                               (NVL(I.NRSUBLOTE, ' ')  = (NVL(C_ITEMPROD.NRSUBLOTE,  ' ')))
                                         GROUP BY VRPERREDBCIT, IT.CDIMPOSTO, NRITPROIMPOS, CDFISCALIT, VRALIQITEM,
                                                  VRPARDEDIT,   CDSITUTRIBITNFE, IDMODBCITNFE, IDMODBCSTITNFE,
                                                  CDTPCREDPICOITE, CDNATUBCALPCIT, IDMOTDESONERAIT, IDTRIMPSTII, IDDIFALIQCUSPRI,
                                                  IM.CDIMPOSTONFE, IT.CDENQLEGALIPI, IT.CDCEST, IT.VRADICFECP,
                                                  IT.CDBENEFFISCAL, I.CDFISOPEITEM
                                         ORDER BY CDIMPOSTO) LOOP

                     /*IMPOSTO DE SUBSTITUICAO TRIBUTARIA*/
                     V_CDIMPOSTRIB  := null;

                     V_CDBENEFFISCAL := NULL;

                     FOR C_ICMSST IN (SELECT CDIMPOSTO
                                        FROM IMPOSTO
                                       WHERE CDIMPOSTRIB = C_ITEMPROIMPOS.CDIMPOSTO)
                     LOOP
                        V_CDIMPOSTRIB := V_CDIMPOSTRIB||C_ICMSST.CDIMPOSTO||'_';
                     END LOOP;

                     V_CDIMPOSIPI := null;
                     SELECT NVL(MAX(IDGERIPIDESPA), 'N'), MAX(CDIMPOSTOIPI)
                       INTO V_IDGERIPIDESPA, V_CDIMPOSIPI
                       FROM TIPOOPERAC
                      WHERE IDENTRSAIDOP = 'S'
                        AND CDTIPOOPER = P_TIPOOPER
                        AND CDIMPOSTOIPI = C_ITEMPROIMPOS.CDIMPOSTO;

                     IF (V_IDGERICMSTDESPA = 'S') AND (V_CDIMPOSTRIB IS NOT NULL) AND (V_IDUTCTRLFIS = 'S') THEN
                        IF NOT((C_ITEMPROIMPOS.VRPERREDBCIT > 0.00) AND (C_ITEMPROIMPOS.NRITPROIMPOS = w_2)) THEN
                           V_VRTOTALICMSST := V_VRTOTALICMSST + (C_ITEMPROIMPOS.VRIMPOSTOIT * V_VRFATOCONV);
                        END IF;
                        IF ((V_IDSISTEMA = 'VND') OR (V_IDSISTEMA = 'PDV')) AND (V_ICMS = 'S') THEN
                           INSERT INTO ITEMPROIMPOSORIG(CDFILIAL,     NRLANCTONF,     NRSEQITPROD,     CDIMPOSTO,      NRITPROIMPOS,    CDFISCALIT,
                                                    CDSITUTRIBIT, CDFISCOPERIT,   CDSUFXCFOPIT,    VRALIQITEM,     VRPERREDBCIT,    VRPARDEDIT,
                                                    VRCONTITIMP,  VRBASECALCIT,   VRIMPOSTOIT,     IDERROSIMPIT,   IDAVISIMPIT,     CDSITUTRIBITNFE,
                                                    IDMODBCITNFE, IDMODBCSTITNFE, CDTPCREDPICOITE, CDNATUBCALPCIT, IDMOTDESONERAIT, IDTRIMPSTII,
                                                    CDDETALHEPROD, CDENQLEGALIPI, CDCEST,          CDBENEFFISCAL)
                           VALUES(P_FILIAL, P_LANCTONF, C_ITEMPROD.NRSEQITPROD, C_ITEMPROIMPOS.CDIMPOSTO, C_ITEMPROIMPOS.NRITPROIMPOS, C_ITEMPROIMPOS.CDFISCALIT,
                                  C_ITEMPROD.CDSITUTRIBPR, V_FISOPEITEM, V_SUFXCFOPPR, C_ITEMPROIMPOS.VRALIQITEM, C_ITEMPROIMPOS.VRPERREDBCIT, TRUNC((C_ITEMPROIMPOS.VRPARDEDIT * V_VRFATOCONV),2),
                                  TRUNC((C_ITEMPROIMPOS.VRCONTITIMP * V_VRFATOCONV),2), TRUNC((C_ITEMPROIMPOS.VRBASECALCIT * V_VRFATOCONV),2),
                                  TRUNC((C_ITEMPROIMPOS.VRIMPOSTOIT * V_VRFATOCONV),2), w_00000, w_00000, C_ITEMPROIMPOS.CDSITUTRIBNFE,
                                  C_ITEMPROIMPOS.IDMODBCNFE, C_ITEMPROIMPOS.IDMODBCSTNFE, C_ITEMPROIMPOS.CDTPCREDPICOITE, C_ITEMPROIMPOS.CDNATUBCALPCIT, NVL(C_ITEMPROIMPOS.IDMOTDESONERAIT,'9'), C_ITEMPROIMPOS.IDTRIMPSTII,
                                  V_CDDETALHEPRODTEMP, C_ITEMPROIMPOS.CDENQLEGALIPI, C_ITEMPROIMPOS.CDCEST, C_ITEMPROIMPOS.CDBENEFFISCAL);
                        ELSE
                           INSERT INTO ITEMPROIMPOSORIG(CDFILIAL,     NRLANCTONF,     NRSEQITPROD,     CDIMPOSTO,      NRITPROIMPOS,    CDFISCALIT,
                                                    CDSITUTRIBIT, CDFISCOPERIT,   CDSUFXCFOPIT,    VRALIQITEM,     VRPERREDBCIT,    VRPARDEDIT,
                                                    VRCONTITIMP,  VRBASECALCIT,   VRIMPOSTOIT,     IDERROSIMPIT,   IDAVISIMPIT,     CDSITUTRIBITNFE,
                                                    IDMODBCITNFE, IDMODBCSTITNFE, CDTPCREDPICOITE, CDNATUBCALPCIT, IDMOTDESONERAIT, IDTRIMPSTII,
                                                    CDDETALHEPROD, CDENQLEGALIPI, CDCEST,          CDBENEFFISCAL)
                           VALUES(P_FILIAL, P_LANCTONF, C_ITEMPROD.NRSEQITPROD, C_ITEMPROIMPOS.CDIMPOSTO, C_ITEMPROIMPOS.NRITPROIMPOS, C_ITEMPROIMPOS.CDFISCALIT,
                                  C_ITEMPROD.CDSITUTRIBPR, V_FISOPEITEM, V_SUFXCFOPPR, C_ITEMPROIMPOS.VRALIQITEM, C_ITEMPROIMPOS.VRPERREDBCIT, (C_ITEMPROIMPOS.VRPARDEDIT * V_VRFATOCONV),
                                  ROUND((C_ITEMPROIMPOS.VRCONTITIMP * V_VRFATOCONV),2), (C_ITEMPROIMPOS.VRBASECALCIT * V_VRFATOCONV),
                                  (C_ITEMPROIMPOS.VRIMPOSTOIT * V_VRFATOCONV), w_00000, w_00000, C_ITEMPROIMPOS.CDSITUTRIBNFE,
                                  C_ITEMPROIMPOS.IDMODBCNFE, C_ITEMPROIMPOS.IDMODBCSTNFE, C_ITEMPROIMPOS.CDTPCREDPICOITE, C_ITEMPROIMPOS.CDNATUBCALPCIT, NVL(C_ITEMPROIMPOS.IDMOTDESONERAIT,'9'), C_ITEMPROIMPOS.IDTRIMPSTII,
                                  V_CDDETALHEPRODTEMP, C_ITEMPROIMPOS.CDENQLEGALIPI, C_ITEMPROIMPOS.CDCEST, C_ITEMPROIMPOS.CDBENEFFISCAL);
                        END IF;
                     END IF;
                     IF (V_IDGERIPIDESPA = 'S') AND (V_CDIMPOSIPI IS NOT NULL) AND (V_IDUTCTRLFIS = 'S') THEN
                        IF NOT((C_ITEMPROIMPOS.VRPERREDBCIT > 0.00) AND (C_ITEMPROIMPOS.NRITPROIMPOS = w_2)) THEN
                           V_VRTOTALIPI := V_VRTOTALIPI + (C_ITEMPROIMPOS.VRIMPOSTOIT * V_VRFATOCONV);
                        END IF;
                        IF ((V_IDSISTEMA = 'VND') OR (V_IDSISTEMA = 'PDV')) AND (V_ICMS = 'S') THEN
                           INSERT INTO ITEMPROIMPOSORIG(CDFILIAL,     NRLANCTONF,     NRSEQITPROD,     CDIMPOSTO,      NRITPROIMPOS,    CDFISCALIT,
                                                    CDSITUTRIBIT, CDFISCOPERIT,   CDSUFXCFOPIT,    VRALIQITEM,     VRPERREDBCIT,    VRPARDEDIT,
                                                    VRCONTITIMP,  VRBASECALCIT,   VRIMPOSTOIT,     IDERROSIMPIT,   IDAVISIMPIT,     CDSITUTRIBITNFE,
                                                    IDMODBCITNFE, IDMODBCSTITNFE, CDTPCREDPICOITE, CDNATUBCALPCIT, IDMOTDESONERAIT, IDTRIMPSTII,
                                                    CDDETALHEPROD, CDENQLEGALIPI, CDCEST, CDBENEFFISCAL)
                           VALUES(P_FILIAL, P_LANCTONF, C_ITEMPROD.NRSEQITPROD, C_ITEMPROIMPOS.CDIMPOSTO, C_ITEMPROIMPOS.NRITPROIMPOS, C_ITEMPROIMPOS.CDFISCALIT,
                                  C_ITEMPROD.CDSITUTRIBPR, V_FISOPEITEM, V_SUFXCFOPPR, C_ITEMPROIMPOS.VRALIQITEM, C_ITEMPROIMPOS.VRPERREDBCIT, TRUNC((C_ITEMPROIMPOS.VRPARDEDIT * V_VRFATOCONV),2),
                                  TRUNC((C_ITEMPROIMPOS.VRCONTITIMP * V_VRFATOCONV),2), TRUNC((C_ITEMPROIMPOS.VRBASECALCIT * V_VRFATOCONV),2),
                                  TRUNC((C_ITEMPROIMPOS.VRIMPOSTOIT * V_VRFATOCONV),2), w_00000, w_00000, C_ITEMPROIMPOS.CDSITUTRIBNFE,
                                  C_ITEMPROIMPOS.IDMODBCNFE, C_ITEMPROIMPOS.IDMODBCSTNFE, C_ITEMPROIMPOS.CDTPCREDPICOITE, C_ITEMPROIMPOS.CDNATUBCALPCIT, NVL(C_ITEMPROIMPOS.IDMOTDESONERAIT,'9'), C_ITEMPROIMPOS.IDTRIMPSTII,
                                  V_CDDETALHEPRODTEMP, C_ITEMPROIMPOS.CDENQLEGALIPI, C_ITEMPROIMPOS.CDCEST, C_ITEMPROIMPOS.CDBENEFFISCAL);
                        ELSE
                           INSERT INTO ITEMPROIMPOSORIG(CDFILIAL,     NRLANCTONF,     NRSEQITPROD,     CDIMPOSTO,      NRITPROIMPOS,    CDFISCALIT,
                                                    CDSITUTRIBIT, CDFISCOPERIT,   CDSUFXCFOPIT,    VRALIQITEM,     VRPERREDBCIT,    VRPARDEDIT,
                                                    VRCONTITIMP,  VRBASECALCIT,   VRIMPOSTOIT,     IDERROSIMPIT,   IDAVISIMPIT,     CDSITUTRIBITNFE,
                                                    IDMODBCITNFE, IDMODBCSTITNFE, CDTPCREDPICOITE, CDNATUBCALPCIT, IDMOTDESONERAIT, IDTRIMPSTII,
                                                    CDDETALHEPROD, CDENQLEGALIPI, CDCEST, CDBENEFFISCAL)
                           VALUES(P_FILIAL, P_LANCTONF, C_ITEMPROD.NRSEQITPROD, C_ITEMPROIMPOS.CDIMPOSTO, C_ITEMPROIMPOS.NRITPROIMPOS, C_ITEMPROIMPOS.CDFISCALIT,
                                  C_ITEMPROD.CDSITUTRIBPR, V_FISOPEITEM, V_SUFXCFOPPR, C_ITEMPROIMPOS.VRALIQITEM, C_ITEMPROIMPOS.VRPERREDBCIT, (C_ITEMPROIMPOS.VRPARDEDIT * V_VRFATOCONV),
                                  ROUND((C_ITEMPROIMPOS.VRCONTITIMP * V_VRFATOCONV),5), (C_ITEMPROIMPOS.VRBASECALCIT * V_VRFATOCONV),  
                                  (C_ITEMPROIMPOS.VRIMPOSTOIT * V_VRFATOCONV), w_00000, w_00000, C_ITEMPROIMPOS.CDSITUTRIBNFE,
                                  C_ITEMPROIMPOS.IDMODBCNFE, C_ITEMPROIMPOS.IDMODBCSTNFE, C_ITEMPROIMPOS.CDTPCREDPICOITE, C_ITEMPROIMPOS.CDNATUBCALPCIT, NVL(C_ITEMPROIMPOS.IDMOTDESONERAIT,'9'), C_ITEMPROIMPOS.IDTRIMPSTII,
                                  V_CDDETALHEPRODTEMP, C_ITEMPROIMPOS.CDENQLEGALIPI, C_ITEMPROIMPOS.CDCEST, C_ITEMPROIMPOS.CDBENEFFISCAL);
                        END IF;
                     END IF;

                     IF (NOT((V_IDGERICMSTDESPA = 'S') AND (V_CDIMPOSTRIB IS NOT NULL) OR (V_IDGERIPIDESPA = 'S')
                        AND (V_CDIMPOSIPI IS NOT NULL)) AND (V_IDUTCTRLFIS = 'S')) OR (V_IDUTCTRLFIS = 'N') THEN
                        -- Verifica se há grupo fiscal por servico
                        SELECT MAX(CDGRUPOFISC)
                        INTO V_CDGRPFISCSV
                        FROM SERVCLIE SC, SERVICO S
                        WHERE SC.CDFILIAL   = V_CDFILIEMIT AND
                              SC.CDCLIENTE  = P_CLIENTE    AND
                              SC.CDFILIAL   = S.CDFILIAL   AND
                              SC.CDSERVFILI = S.CDSERVFILI AND
                              S.CDPRODUTO   = C_ITEMPROD.CDPRODUTO;

                        IF V_CDGRPFISCSV IS NULL THEN
                        -- Verifica se há grupo fiscal por cliente da filial
                           SELECT MAX(CDGRUPOFISC)
                           INTO V_CDGRPFISCSV
                           FROM CLIENFILIAL
                           WHERE CDFILIAL   = V_CDFILIEMIT AND
                                 CDCLIENTE  = P_CLIENTE;
                        END IF;

                        CONSULTA_INCIDENCIA(w_S, P_EMPRESA, C_ITEMPROD.CDARVPROD, P_INSCESTA, P_TIPOOPER, P_FILIAL, P_LANCTONF, V_CDGRUPOFISC,
                                            V_CDGRPFISCSV, V_IDINTEREST, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, C_ITEMPROD.IDORIGEMPROD);

                        BEGIN
                           SELECT MAX(CDFISCTEMP), MAX(CDDETALHEPROD), MAX(CDENQLEGALIPI), MAX(CDCEST)
                             INTO   V_CDFISCTEMP, V_CDDETALHEPRODTEMP, V_CDENQLEGALIPI, V_CDCEST
                            FROM INCITEMP IT, IMPOSTO IP
                            WHERE IT.NRINCITEMP = V_INCITEMP
                              AND IP.CDIMPOSTO  = IT.CDIMPOTEMP
                              AND IP.IDPRODNOTA = w_P
                              AND IT.CDIMPOTEMP = C_ITEMPROIMPOS.CDIMPOSTO;
                        EXCEPTION
                           WHEN NO_DATA_FOUND THEN
                              V_CDFISCTEMP        := NULL;
                              V_CDDETALHEPRODTEMP := NULL;
                              V_CDENQLEGALIPI     := NULL;
                              V_CDCEST            := NULL;
                        END;

                        IF (C_ITEMPROIMPOS.VRPERREDBCIT > 0.00) AND
                           (C_ITEMPROIMPOS.NRITPROIMPOS = w_2) THEN
                           V_CDFISCTEMP := w_2;
                        ELSE
                           IF (V_CDFISCTEMP IS NULL) THEN
                               V_CDFISCTEMP := C_ITEMPROIMPOS.CDFISCALIT;
                           END IF;
                        END IF;

                        IF V_CDENQLEGALIPI IS NULL THEN
                           V_CDENQLEGALIPI := C_ITEMPROIMPOS.CDENQLEGALIPI;
                        END IF;

                        IF V_CDCEST IS NULL THEN
                           V_CDCEST := C_ITEMPROIMPOS.CDCEST;
                        END IF;

                        DELETE INCITEMP
                         WHERE NRINCITEMP = V_INCITEMP;

                        /*VERIFICA CST POR IMPOSTO*/
                        V_IMPOICMS := NULL;
                        V_CDGRUPOFISCAUX := NULL;

                        SELECT MAX(G.CDGRUPOFISC)
                          INTO V_CDGRUPOFISCAUX
                          FROM GRUPOFISCIMPFIL G,
                               (SELECT CDFILIEMIT AS CDFILIAL
                                  FROM NOTAFISCAL
                                 WHERE CDFILIAL = P_FILIAL
                                       AND NRLANCTONF = P_LANCTONF) F
                         WHERE G.CDFILIAL = F.CDFILIAL
                           AND NOT G.CDGRUPOFISC IS NULL
                           AND G.CDIMPOSTO = C_ITEMPROIMPOS.CDIMPOSTO;

                        IF V_IDORIGDESTNF = 'C' THEN
                           SELECT NVL(MAX(G.CDGRUPOFISC), V_CDGRUPOFISCAUX)
                             INTO V_CDGRUPOFISCAUX
                             FROM GRFISIMPIECLIE G,
                                  (SELECT CDCLIENTE
                                     FROM NOTAFISCAL
                                    WHERE CDFILIAL = P_FILIAL
                                      AND NRLANCTONF = P_LANCTONF) N
                            WHERE G.CDCLIENTE = N.CDCLIENTE
                              AND G.CDEMPRESA = P_EMPRESA
                              AND G.CDINSCESTA = P_INSCESTA
                              AND NOT G.CDGRUPOFISC IS NULL
                              AND G.CDIMPOSTO = C_ITEMPROIMPOS.CDIMPOSTO;
                        ELSE
                           SELECT NVL(MAX(G.CDGRUPOFISC), V_CDGRUPOFISCAUX)
                             INTO V_CDGRUPOFISCAUX
                             FROM GRFISIMPIEFORN G,
                                 (SELECT CDFORNECED
                                    FROM NOTAFISCAL
                                   WHERE CDFILIAL = P_FILIAL
                                     AND NRLANCTONF = P_LANCTONF) N
                            WHERE G.CDFORNECED = N.CDFORNECED
                              AND G.CDEMPRESA = P_EMPRESA
                              AND G.CDINSCESTA = P_INSCESTA
                              AND NOT G.CDGRUPOFISC IS NULL
                              AND G.CDIMPOSTO = C_ITEMPROIMPOS.CDIMPOSTO;
                        END IF;
                        IF V_CDGRUPOFISCAUX IS NULL THEN
                           CONSULTA_CST_NFE(w_S, P_EMPRESA, C_ITEMPROD.CDARVPROD, P_INSCESTA, P_TIPOOPER, V_CDGRUPOFISC,C_ITEMPROIMPOS.CDIMPOSTO, V_IDINTEREST, V_IDINTERNA, P_FILIAL, P_LANCTONF, '', V_CDSITTRIBTMP, V_IDMODBCNFE, V_IDMODBCSTNFE, V_CDTPCRPICOSTNFE, V_CDNATUBCPCSTNFE, V_IDMOTIDESSTNFE, C_ITEMPROD.IDORIGEMPROD);
                        ELSE
                           CONSULTA_CST_NFE(w_S, P_EMPRESA, C_ITEMPROD.CDARVPROD, P_INSCESTA, P_TIPOOPER, V_CDGRUPOFISCAUX,C_ITEMPROIMPOS.CDIMPOSTO, V_IDINTEREST, V_IDINTERNA, P_FILIAL, P_LANCTONF, '', V_CDSITTRIBTMP, V_IDMODBCNFE, V_IDMODBCSTNFE, V_CDTPCRPICOSTNFE, V_CDNATUBCPCSTNFE, V_IDMOTIDESSTNFE, C_ITEMPROD.IDORIGEMPROD);
                        END IF;

                        IF (V_CDSITTRIBTMP IS NULL) THEN
                           V_CDSITUTRIBNFE := C_ITEMPROIMPOS.CDSITUTRIBNFE;
                        ELSE
                           V_CDSITUTRIBNFE := V_CDSITTRIBTMP;
                        END IF;
                        IF (V_IDMODBCNFE IS NULL) THEN
                           V_IDMODBCNFEIT := C_ITEMPROIMPOS.IDMODBCNFE;
                        ELSE
                           V_IDMODBCNFEIT := V_IDMODBCNFE;
                        END IF;
                        IF (V_IDMODBCSTNFE IS NULL) THEN
                           V_IDMODBCSTNFEIT := C_ITEMPROIMPOS.IDMODBCSTNFE;
                        ELSE
                           V_IDMODBCSTNFEIT := V_IDMODBCSTNFE;
                        END IF;
                        IF (C_ITEMPROIMPOS.CDTPCREDPICOITE IS NULL) THEN
                           V_CDTPCRPICOSTNFEIT := V_CDTPCRPICOSTNFE;
                        ELSE
                           V_CDTPCRPICOSTNFEIT := C_ITEMPROIMPOS.CDTPCREDPICOITE;
                        END IF;

                        IF (C_ITEMPROIMPOS.CDNATUBCALPCIT IS NULL) THEN
                           V_CDNATUBCPCSTNFEIT := V_CDNATUBCPCSTNFE;
                        ELSE
                           V_CDNATUBCPCSTNFEIT := C_ITEMPROIMPOS.CDNATUBCALPCIT;
                        END IF;

                        IF (V_IDMOTIDESSTNFE IS NULL) THEN
                           V_IDMOTIDESSTNFE := C_ITEMPROIMPOS.IDMOTDESONERAIT;
                        ELSE
                           V_IDMOTIDESSTNFE := V_IDMOTIDESSTNFE;
                        END IF;

                        SELECT NVL(MAX(IDUTMUNIORIG),'N')
                          INTO V_IDUTMUNIORIG
                          FROM IMPOSTO
                         WHERE CDIMPOSTO = C_ITEMPROIMPOS.CDIMPOSTO;

                        IF ((V_IDUTMUNIORIG = 'O') OR (V_IDUTMUNIORIG = 'N')) THEN
                           CONSULTA_ALIQUOTA(C_ITEMPROIMPOS.CDIMPOSTO, w_S, P_EMPRESA, C_ITEMPROD.CDARVPROD, P_INSCESTA, V_PAISORIG,
                                             V_ESTAORIG, V_PAISDEST, V_ESTADEST, V_MUNIORIG, V_LIQUIITEM, P_INIVALID, P_FILIAL, P_LANCTONF, V_CDGRUPOFISC, P_TIPOOPER,
                                             NULL, NULL, NULL, NULL, NULL, NULL, C_ITEMPROD.IDORIGEMPROD);
                        ELSE
                           CONSULTA_ALIQUOTA(C_ITEMPROIMPOS.CDIMPOSTO, w_S, P_EMPRESA, C_ITEMPROD.CDARVPROD, P_INSCESTA, V_PAISORIG,
                                             V_ESTAORIG, V_PAISDEST, V_ESTADEST, V_MUNIDEST, V_LIQUIITEM, P_INIVALID, P_FILIAL, P_LANCTONF, V_CDGRUPOFISC, P_TIPOOPER,
                                             NULL, NULL, NULL, NULL, NULL, NULL, C_ITEMPROD.IDORIGEMPROD);
                        END IF;

                        V_NRALIQTEMP := 0;
                        V_PARDEDTMP  := 0;
                        V_PREDBCTMP  := 0;
                        V_ALIQUTMP   := 0;
                        V_IMPOSTOIT  := 0;
                        V_CDTIPOOPER    := NULL;
                        V_CDREGRAITALIQ := NULL;

                        SELECT NVL(MAX(NRALIQTEMP),0),      NVL(MAX(VRPARDEDTMP),0), NVL(MAX(VRPREDBCTMP),0), NVL(MAX(VRALIQUTMP),0),
                               NVL(MAX(IDTRIMPSTTMP), w_0), NVL(MAX(VRPBCSTTMP),0),  NVL(MAX(IDPMCBSCALTMP), w_S),
                               MAX(CDTIPOOPERTMP),          MAX(CDREGRATMP),
                               MAX(CDFISCOPER),             MAX(IDDIFEALIQ),         MAX(IDDIFALIQCUSPR),
                               MAX(CDBENEFFISCAL),          NVL(MAX(IDCONSMVAPMC), '3'), NVL(MAX(IDCONSCOMPBCPMC), '3')
                        INTO   V_NRALIQTEMP,                V_PARDEDTMP,             V_PREDBCTMP,             V_ALIQUTMP,
                               V_TRATIMPST,                 V_PBCSUBTRIB,            V_IDPMCBASECAL,
                               V_CDTIPOOPER,                V_CDREGRAITALIQ,
                               V_CDFISCOPERREGRA,           V_IDDIFEALIQREGRA,       V_IDDIFALIQCUSPRREGRA,
                               V_CDBENEFFISCAL,             V_IDCONSMVAPMC,          V_IDCONSCOMPBCPMC
                        FROM ALIQTEMP
                        WHERE (NRALIQTEMP = V_ALIQTEMP);

                        IF V_CDBENEFFISCAL IS NULL THEN
                           V_CDBENEFFISCAL := C_ITEMPROIMPOS.CDBENEFFISCAL;
                        END IF;

                        IF V_PAISORIG = V_PAISCFOP THEN
                           IF V_ESTAORIG = V_ESTACFOP THEN
                              V_CFOP1DIGT := '5';
                           ELSE
                              V_CFOP1DIGT := '6';
                           END IF;
                        ELSE
                           V_CFOP1DIGT := '7';
                        END IF;

                        IF V_CDFISCOPERREGRA IS NOT NULL THEN
                           IF (LENGTH(V_CDFISCOPERREGRA) < 4) THEN
                              V_CDFISCOPERREGRA := V_CFOP1DIGT||V_CDFISCOPERREGRA;
                           END IF;
                        ELSE
                           IF C_ITEMPROIMPOS.CDFISOPEITEM IS NOT NULL THEN
                              V_CDFISCOPERREGRA := V_CFOP1DIGT||SUBSTR(C_ITEMPROIMPOS.CDFISOPEITEM, 2, 3);
                           END IF;
                        END IF;       

                        V_ICMS := 'N';
                        FOR C_ICMS IN (SELECT CDIMPOSTO
                                         FROM IMPOSTONFE N, IMPOSTO I
                                        WHERE N.CDIMPOSTONFE = I.CDIMPOSTONFE
                                          AND N.CDIMPOSTONFE = '00'
                                          AND I.CDIMPOSTO = C_ITEMPROIMPOS.CDIMPOSTO)
                        LOOP
                           V_ICMS := 'S';
                        END LOOP;

                        IF (V_ICMS = 'S') THEN
                           IF (NVL(V_CFOPINFUSU, 'N') <> 'S') AND (V_CDFISCOPERREGRA IS NOT NULL) THEN
                              V_FISOPEITEM        := NVL(V_CDFISCOPERREGRA, V_FISOPEITEM);
                              V_DSCDFISOPEITREGRA := SUBSTR(DESCRICAO_CFOP(V_CDFISCOPERREGRA),1,45);
                           END IF;

                           UPDATE NOTAFISCAL
                              SET DSCDFISOPENF = NVL(V_DSCDFISOPEITREGRA, (SELECT MAX(DSCFOPTMP)
                                                                               FROM CFOPTEMP
                                                                              WHERE NRCFOPTEMP = V_CFOPTEMP))
                            WHERE CDFILIAL   = P_FILIAL   AND
                                  NRLANCTONF = P_LANCTONF;


                           SELECT MAX(CDFISOPETMP), MAX(CDSUFCFOPTMP), SUBSTR(MAX(DSCFOPTMP),1,50)
                             INTO V_FISOPEITEM    , V_SUFXCFOPPR, V_DSCDFISOPEIT
                             FROM CFOPTEMP
                            WHERE NRCFOPTEMP = V_CFOPTEMP;

                           IF (NVL(V_CFOPINFUSU, 'N') <> 'S') AND (V_CDFISCOPERREGRA IS NOT NULL) THEN
                              V_FISOPEITEM        := NVL(V_CDFISCOPERREGRA, V_FISOPEITEM);
                              V_DSCDFISOPEITREGRA := SUBSTR(DESCRICAO_CFOP(V_CDFISCOPERREGRA),1,45);
                           END IF;

                           UPDATE ITEMPRODUTO
                              SET CDFISOPEITEM  = V_FISOPEITEM,
                                  CDSUFXCFOPPR  = V_SUFXCFOPPR,
                                  DSCDFISOPEIT  = V_DSCDFISOPEIT
                            WHERE CDFILIAL    = P_FILIAL AND
                                  NRLANCTONF  = P_LANCTONF AND
                                  NRSEQITPROD = C_ITEMPROD.NRSEQITPROD;
                        END IF;

                        /*Verifica alíquota parametrizada por tipo de operação desde que não seja nota de estorno de cancelamento*/
                        IF ((V_NRALIQTEMP IS NOT NULL) AND (V_CDTIPOOPER IS NOT NULL) AND (V_ESTORNOCANC <> w_S)) THEN
                           V_CDIMPOSRECALC := V_CDIMPOSRECALC||C_ITEMPROIMPOS.CDIMPOSTO||'_';
                           IF (C_ITEMPROIMPOS.NRITPROIMPOS = w_2) THEN
                              V_CDIMPOSTRIB  := null;
                              V_IDVRIMPSTRIB := null;

                           ELSE
                              V_CDIMPOSTRIB  := null;
                              V_IDVRIMPSTRIB := null;

                              /*IMPOSTO DE SUBSTITUICAO TRIBUTARIA*/
                              FOR C_ICMSST IN (SELECT CDIMPOSTO
                                                 FROM IMPOSTO
                                                WHERE CDIMPOSTRIB = C_ITEMPROIMPOS.CDIMPOSTO)
                              LOOP
                                 V_CDIMPOSTRIB := V_CDIMPOSTRIB||C_ICMSST.CDIMPOSTO||'_';
                              END LOOP;

                              V_TAXABASECALC := (100 - V_PREDBCTMP)/100;
                              V_TAXAALIQUOTA := (V_ALIQUTMP/100);
                              V_TAXABCSUBSTR := 1 + (V_PBCSUBTRIB/100);
                              V_BASECALCIT   := V_LIQUIITEM * V_TAXABASECALC;

                              IF V_CDIMPOSTRIB IS NULL THEN
                                 V_IDTRIMPSTII := '';
                              ELSE
                                 IF SUBSTR(V_SITUTRIBPR, 2, 2) = '60' THEN
                                    V_IDTRIMPSTII := 2;
                                 ELSE 
                                    V_IDTRIMPSTII := V_TRATIMPST;
                                 END IF;

                                 IF NVL(V_IDPMCBASECAL, W_N) = W_S THEN
                                    CALCULA_BC_PMC(P_FILIAL,
                                                   P_LANCTONF,
                                                   C_ITEMPROD.NRSEQITPROD,
                                                   C_ITEMPROIMPOS.CDIMPOSTO,
                                                   V_IDCONSMVAPMC,
                                                   V_IDCONSCOMPBCPMC,
                                                   V_PAISDEST,
                                                   V_ESTADEST,
                                                   C_ITEMPROD.CDPRODUTO,
                                                   C_ITEMPROD.QTITEMPROD,
                                                   C_ITEMPROD.VRUNITITEM,
                                                   C_ITEMPROD.VRDESCITEM,
                                                   V_PBCSUBTRIB,
                                                   V_PREDBCTMP,
                                                   NULL,
                                                   NULL,
                                                   NULL,
                                                   NULL,
                                                   NULL,
                                                   NULL,
                                                   'N',
                                                   V_BASECALCTO);

                                    V_IMPOSTOIT := (V_BASECALCTO * V_TAXAALIQUOTA) - V_PARDEDTMP;
                                 ELSE
                                    V_BASECALCTO  := V_BASECALCIT;
                                    V_IMPOSTOIT   := (V_BASECALCIT * V_TAXAALIQUOTA) - V_PARDEDTMP;
                                 END IF;

                                 SELECT NVL(MAX(IDVRIMPSTRIB), 'N')
                                   INTO V_IDVRIMPSTRIB
                                   FROM ITEMPROIMPOS I, IMPOSTO II
                                  WHERE (CDFILIAL = P_FILIAL)
                                    AND (NRLANCTONF = P_LANCTONF)
                                    AND (NRSEQITPROD = C_ITEMPROD.NRSEQITPROD)
                                    AND (INSTR(V_CDIMPOSTRIB,II.CDIMPOSTO||'_') > 0)
                                    AND (I.CDIMPOSTO = II.CDIMPOSTO);

                                 IF (V_TRATIMPST = W_1) OR (NVL(V_IDVRIMPSTRIB, W_N) = W_N) THEN
                                    V_VRIMPOSTOST := 0;
                                 ELSE
                                    BEGIN
                                       SELECT NVL(MAX(VRIMPOSTOIT),0)
                                         INTO V_VRIMPOSTOST
                                         FROM ITEMPROIMPOS I
                                        WHERE (CDFILIAL = P_FILIAL)
                                          AND (NRLANCTONF = P_LANCTONF)
                                          AND (NRSEQITPROD = C_ITEMPROD.NRSEQITPROD)
                                          AND (INSTR(V_CDIMPOSTRIB,CDIMPOSTO||'_') > 0)
                                          AND (NRITPROIMPOS = w_1);
                                    EXCEPTION
                                       WHEN NO_DATA_FOUND THEN BEGIN
                                          V_VRIMPOSTOST := 0;
                                       END;
                                    END;
                                 END IF;
                                 V_IMPOSTOIT := V_IMPOSTOIT - V_VRIMPOSTOST;

                                 IF V_IMPOSTOIT < 0 THEN
                                    V_IMPOSTOIT := 0;
                                 END IF;

                                 IF (V_IDCONTCONFORIG = 'N') THEN
                                    IF NVL(V_IDPMCBASECAL, W_N) = W_S THEN
                                       UPDATE ITEMPRODUTO
                                          SET VRBRUTITEM = VRBRUTITEM + V_IMPOSTOIT,
                                              VRCONTITEM = VRCONTITEM + V_IMPOSTOIT
                                        WHERE CDFILIAL = P_FILIAL
                                          AND NRLANCTONF = P_LANCTONF
                                          AND NRSEQITPROD = C_ITEMPROD.NRSEQITPROD;
                                     END IF;
                                 END IF;
                              END IF;

                              IF NVL(V_IDPMCBASECAL, W_N) = W_N THEN
                                 V_PERDBCALC    := 100 - V_PREDBCTMP;

                                 IF V_PBCSUBTRIB > 0 THEN
                                    V_BASECALCIT := (V_BASECALCIT * V_TAXABCSUBSTR);
                                    V_PREDBCTMP  := V_PBCSUBTRIB;
                                    V_PERDBCALC  := 0;
                                 END IF;

                                 SELECT NVL(MAX(IDUTVLRQTDEIMPO), 'N')
                                   INTO V_IDUTVLRQTDEIMPO
                                   FROM IMPOSTO
                                  WHERE CDIMPOSTO = C_ITEMPROIMPOS.CDIMPOSTO;

                                 IF (V_IDUTVLRQTDEIMPO = 'S') THEN
                                    SELECT NVL(MAX(VRFATOCONVES), 1)
                                      INTO V_VRFATOCONVES
                                      FROM CONVPRODUTO
                                     WHERE CDPRODUTO = C_ITEMPROD.CDPRODUTO;

                                    V_BASECALCTO  := (C_ITEMPROD.QTITEMPROD * V_VRFATOCONVES);
                                    V_IMPOSTOIT   := ((C_ITEMPROD.QTITEMPROD * V_VRFATOCONVES) * V_ALIQUTMP) - V_PARDEDTMP;
                                 ELSE
                                    V_BASECALCTO  := V_BASECALCIT;
                                    V_IMPOSTOIT   := (V_BASECALCIT * V_TAXAALIQUOTA) - V_PARDEDTMP;
                                 END IF;
                              END IF;

                              V_CONTABCALC  := V_LIQUIITEM - (V_LIQUIITEM * V_TAXABASECALC);

                              IF (V_ALIQUTMP = 0) AND (V_IMPOSTOIT = 0) THEN
                                 V_BASECALCTO := 0;
                              END IF;

                              -- Alterar o valor contábil caso o parâmetro "Contabiliza conforme NF de origem" esteja desmarcado

                              IF (V_IDCONTCONFORIG = 'N') THEN

                                 V_IMPOCONTAB  := 0;
                                 V_IDIMPORECUP := NULL;
                                 V_CDCCTBLATIV := NULL;
                                 V_IDTRATIMPO  := NULL;

                                 SELECT NVL(IDIMPORECUP, 'N'), IDTRATIMPO, CDCCTBLATIV
                                   INTO V_IDIMPORECUP, V_IDTRATIMPO, V_CDCCTBLATIV
                                   FROM IMPOSTO
                                  WHERE CDIMPOSTO = C_ITEMPROIMPOS.CDIMPOSTO;

                                 IF (V_IDIMPORECUP = W_S) THEN
                                    IF (V_CDFISCTEMP = W_1) THEN
                                       IF (V_CDCCTBLATIV IS NOT NULL) THEN
                                          IF V_IDTRATIMPO = W_V THEN
                                             V_IMPOCONTAB := - V_IMPOSTOIT;
                                          END IF;
                                       END IF;
                                    ELSE
                                       IF V_IDTRATIMPO = W_A THEN
                                          V_IMPOCONTAB := V_IMPOSTOIT;
                                       ELSIF V_IDTRATIMPO IN (W_D,W_R) THEN
                                          V_IMPOCONTAB := - V_IMPOSTOIT;
                                       END IF;
                                    END IF;
                                 END IF;

                                 IF (ABS(NVL(V_IMPOCONTAB, 0)) > 0) THEN
                                    UPDATE ITEMPRODUTO
                                       SET VRCONTITEMORIG = (VRCONTITEM) + NVL(V_IMPOCONTAB, 0),
                                           VRCONTITEM     = (VRCONTITEM) + NVL(V_IMPOCONTAB, 0)
                                     WHERE CDFILIAL       = P_FILIAL
                                       AND NRLANCTONF     = P_LANCTONF
                                       AND NRSEQITPROD    = C_ITEMPROD.NRSEQITPROD;
                                 END IF;
                              END IF;
                              -- Alterar o valor contábil caso o parâmetro "Contabiliza conforme NF de origem" esteja desmarcado

                              Begin
                                 SELECT CDFILIAL
                                 INTO   V_CHAVE
                                 FROM ITEMPROIMPOS
                                 WHERE CDFILIAL     = P_FILIAL                 AND
                                       NRLANCTONF   = P_LANCTONF               AND
                                       NRSEQITPROD  = C_ITEMPROD.NRSEQITPROD   AND
                                       CDIMPOSTO    = C_ITEMPROIMPOS.CDIMPOSTO AND
                                       NRITPROIMPOS = C_ITEMPROIMPOS.NRITPROIMPOS;
                              Exception
                                 When No_Data_Found Then
                                    V_CHAVE := Null;
                              End;

                              SELECT NVL(MAX(IDPERVISIMPSCRE),'S')
                                INTO V_IDPERVISIMPSCRE
                                FROM PARAMGERAL;

                              IF V_IDPERVISIMPSCRE = 'S' THEN
                                 V_VRIMPOSTOVISUIT := V_IMPOSTOIT;
                              ELSE
                                 IF (V_CDFISCTEMP = '1') THEN
                                    V_VRIMPOSTOVISUIT := V_IMPOSTOIT;
                                 ELSE
                                    V_VRIMPOSTOVISUIT := 0;
                                 END IF;
                              END IF;

                              /* ROTINA PARA CALCULAR O DIFERIMENTO DO IMPOSTO */
                              V_PERDIFERE    := NULL;
                              V_IMPOSTOOPERA := NULL;
                              V_IMPOSTODIFER := NULL;
                              IF C_ITEMPROIMPOS.CDIMPOSTONFE = '00' THEN
                                 IF V_CDSITTRIBTMP = 51 THEN
                                    BEGIN
                                       SELECT PD.VRPERDIFERE, 'S'
                                         INTO V_VRPERDIFERE, V_IDDIFECLI
                                         FROM PRODDIFEREIMPCLI PD, PRODUTO PR
                                        WHERE PD.CDPRODUTO = PR.CDPRODUTO
                                          AND PD.CDPAIS = V_PAISORIG
                                          AND PD.SGESTADO = V_ESTAORIG
                                          AND PD.CDCLIENTE = P_CLIENTE
                                          AND PR.CDARVPROD IN (SELECT MAX(PR.CDARVPROD) AS CDARVPROD
                                                                 FROM PRODDIFEREIMPCLI PD, PRODUTO PR
                                                                WHERE PD.CDPRODUTO = PR.CDPRODUTO
                                                                  AND PD.CDPAIS = V_PAISORIG
                                                                  AND PD.SGESTADO = V_ESTAORIG
                                                                  AND PD.CDCLIENTE = P_CLIENTE
                                                                  AND INSTR(NVL(RTRIM(C_ITEMPROD.CDARVPROD), PR.CDARVPROD), PR.CDARVPROD) = 1);
                                    EXCEPTION
                                       WHEN NO_DATA_FOUND THEN
                                          V_VRPERDIFERE := NULL; V_IDDIFECLI := 'N';
                                    END;

                                    IF V_IDDIFECLI = 'N' THEN
                                       BEGIN
                                          SELECT PD.VRPERDIFERE
                                            INTO V_VRPERDIFERE
                                            FROM PRODDIFEREIMPOS PD, PRODUTO PR
                                           WHERE PD.CDPRODUTO = PR.CDPRODUTO
                                             AND PD.CDPAIS = V_PAISORIG
                                             AND PD.SGESTADO = V_ESTAORIG
                                             AND PR.CDARVPROD IN (SELECT MAX(PR.CDARVPROD) AS CDARVPROD
                                                                    FROM PRODDIFEREIMPOS PD, PRODUTO PR
                                                                   WHERE PD.CDPRODUTO = PR.CDPRODUTO
                                                                     AND PD.CDPAIS = V_PAISORIG
                                                                     AND PD.SGESTADO = V_ESTAORIG
                                                                     AND INSTR(NVL(RTRIM(C_ITEMPROD.CDARVPROD), PR.CDARVPROD), PR.CDARVPROD) = 1);
                                       EXCEPTION
                                          WHEN NO_DATA_FOUND THEN
                                             V_VRPERDIFERE := NULL;
                                       END;
                                    END IF;

                                    IF V_VRPERDIFERE IS NOT NULL THEN
                                       V_PERDIFERE    := V_VRPERDIFERE;
                                       V_IMPOSTOOPERA := V_IMPOSTOIT;
                                       V_IMPOSTODIFER := V_IMPOSTOOPERA * (V_VRPERDIFERE/100);
                                       V_IMPOSTOIT := V_IMPOSTOOPERA - V_IMPOSTODIFER;
                                    END IF;
                                 END IF;
                              END IF;

                              IF V_CHAVE IS NULL THEN
                                 V_ICMS := 'N';
                                 FOR C_ICMS IN (SELECT CDIMPOSTO
                                                  FROM IMPOSTONFE N, IMPOSTO I
                                                 WHERE N.CDIMPOSTONFE = I.CDIMPOSTONFE
                                                   AND N.CDIMPOSTONFE = '00'
                                                   AND I.CDIMPOSTO = C_ITEMPROIMPOS.CDIMPOSTO)
                                 LOOP
                                    V_ICMS := 'S';
                                 END LOOP;

                                 IF ((V_IDSISTEMA = 'VND') OR (V_IDSISTEMA = 'PDV')) AND (V_ICMS = 'S') THEN
                                    INSERT INTO ITEMPROIMPOS(
                                       CDFILIAL,        NRLANCTONF,   NRSEQITPROD,    CDIMPOSTO,       NRITPROIMPOS,   CDFISCALIT,
                                       CDSITUTRIBIT,    CDFISCOPERIT, CDSUFXCFOPIT,   VRALIQITEM,      VRPERREDBCIT,   VRPARDEDIT,
                                       VRCONTITIMP,     VRBASECALCIT, VRIMPOSTOIT,    IDERROSIMPIT,    IDAVISIMPIT,    IDTRIMPSTII,
                                       CDSITUTRIBITNFE, IDMODBCITNFE, IDMODBCSTITNFE, CDTPCREDPICOITE, CDNATUBCALPCIT, IDMOTDESONERAIT,
                                       CDDETALHEPROD,   VRIMPOSTOVISUIT,   CDREGRAIT, VRPERDIFEREIT, VRIMPOSTOOPERAIT, VRIMPOSTODIFERIT,
                                       CDENQLEGALIPI,   CDCEST,            CDBENEFFISCAL)
                                    VALUES(
                                       P_FILIAL,                P_LANCTONF,     C_ITEMPROD.NRSEQITPROD, C_ITEMPROIMPOS.CDIMPOSTO, w_1,                 V_CDFISCTEMP,
                                       NVL(V_SITUTRIBPR, C_ITEMPROD.CDSITUTRIBPR), V_FISOPEITEM,   V_SUFXCFOPPR,           V_ALIQUTMP,               V_PREDBCTMP,         V_PARDEDTMP,
                                       ROUND(V_BASECALCTO,2),   V_BASECALCTO,   TRUNC(V_IMPOSTOIT,2),   w_00000,                  w_00000,             V_IDTRIMPSTII,
                                       V_CDSITUTRIBNFE,         V_IDMODBCNFEIT, V_IDMODBCSTNFEIT,       V_CDTPCRPICOSTNFEIT,      V_CDNATUBCPCSTNFEIT, V_IDMOTIDESSTNFE,
                                       V_CDDETALHEPRODTEMP, TRUNC(V_VRIMPOSTOVISUIT,2), V_CDREGRAITALIQ, V_PERDIFERE, V_IMPOSTOOPERA, V_IMPOSTODIFER,
                                       V_CDENQLEGALIPI, V_CDCEST, V_CDBENEFFISCAL);
                                 ELSE
                                    IF (C_ITEMPROIMPOS.NRITPROIMPOS = w_3)  THEN

                                       /*Inserir a linha de diferencial de alíquota*/

                                       V_DIFALIQ := 0;

                                       SELECT MAX(VRALIQITEM)
                                         INTO V_DIFALIQ
                                         FROM ITEMPROIMPOS IT, ITEMPRODUTO I
                                        WHERE IT.CDFILIAL     = C_ITEMNOTAFISC.CDFILIALIT
                                          AND IT.NRLANCTONF   = C_ITEMNOTAFISC.NRLANCTONFIT
                                          AND I.CDFILIAL      = C_ITEMNOTAFISC.CDFILIALIT
                                          AND I.NRLANCTONF    = C_ITEMNOTAFISC.NRLANCTONFIT
                                          AND IT.NRSEQITPROD  = I.NRSEQITPROD
                                          AND I.CDPRODUTO     = C_ITEMPROD.CDPRODUTO
                                          AND ROUND(I.VRUNITITEM, V_NRDECITOTANF) = ROUND(C_ITEMPROD.VRUNITITEM, V_NRDECITOTANF)
                                          AND (NVL(NRLOTEESTQ, ' ') = (NVL(C_ITEMPROD.NRLOTEESTQ, ' ')))
                                          AND (NVL(NRSUBLOTE, ' ')  = (NVL(C_ITEMPROD.NRSUBLOTE , ' ')))
                                          AND IT.CDIMPOSTO    = C_ITEMPROIMPOS.CDIMPOSTO
                                          AND IT.NRITPROIMPOS = w_1;

                                       IF  (V_ALIQUTMP = V_DIFALIQ) THEN
                                          INSERT INTO ITEMPROIMPOS(
                                             CDFILIAL,        NRLANCTONF,   NRSEQITPROD,    CDIMPOSTO,       NRITPROIMPOS,   CDFISCALIT,
                                             CDSITUTRIBIT,    CDFISCOPERIT, CDSUFXCFOPIT,   VRALIQITEM,      VRPERREDBCIT,   VRPARDEDIT,
                                             VRCONTITIMP,     VRBASECALCIT, VRIMPOSTOIT,    IDERROSIMPIT,    IDAVISIMPIT,    IDTRIMPSTII,
                                             CDSITUTRIBITNFE, IDMODBCITNFE, IDMODBCSTITNFE, CDTPCREDPICOITE, CDNATUBCALPCIT, IDMOTDESONERAIT,
                                             CDDETALHEPROD,   VRIMPOSTOVISUIT, CDREGRAIT, IDDIFALIQCUSPRI,
                                             CDENQLEGALIPI,   CDCEST,          CDBENEFFISCAL)
                                          VALUES(
                                             P_FILIAL, P_LANCTONF, C_ITEMPROD.NRSEQITPROD, C_ITEMPROIMPOS.CDIMPOSTO, C_ITEMPROIMPOS.NRITPROIMPOS, C_ITEMPROIMPOS.CDFISCALIT,
                                             C_ITEMPROD.CDSITUTRIBPR, V_FISOPEITEM, V_SUFXCFOPPR, C_ITEMPROIMPOS.VRALIQITEM, C_ITEMPROIMPOS.VRPERREDBCIT, (C_ITEMPROIMPOS.VRPARDEDIT * V_VRFATOCONV),
                                             ROUND((C_ITEMPROIMPOS.VRCONTITIMP * V_VRFATOCONV),5), (C_ITEMPROIMPOS.VRBASECALCIT * V_VRFATOCONV),
                                             (C_ITEMPROIMPOS.VRIMPOSTOIT * V_VRFATOCONV), w_00000, w_00000, C_ITEMPROIMPOS.IDTRIMPSTII, C_ITEMPROIMPOS.CDSITUTRIBNFE,
                                             C_ITEMPROIMPOS.IDMODBCNFE, C_ITEMPROIMPOS.IDMODBCSTNFE, C_ITEMPROIMPOS.CDTPCREDPICOITE, C_ITEMPROIMPOS.CDNATUBCALPCIT, NVL(C_ITEMPROIMPOS.IDMOTDESONERAIT,'9'),
                                             V_CDDETALHEPRODTEMP, (C_ITEMPROIMPOS.VRIMPOSTOIT * V_VRFATOCONV), V_CDREGRAITALIQ, C_ITEMPROIMPOS.IDDIFALIQCUSPRI,
                                             V_CDENQLEGALIPI, V_CDCEST, V_CDBENEFFISCAL);
                                       /*Inserir a linha de diferencial de alíquota*/
                                       END IF;
                                    ELSE
                                       INSERT INTO ITEMPROIMPOS(
                                          CDFILIAL,        NRLANCTONF,   NRSEQITPROD,    CDIMPOSTO,       NRITPROIMPOS,   CDFISCALIT,
                                          CDSITUTRIBIT,    CDFISCOPERIT, CDSUFXCFOPIT,   VRALIQITEM,      VRPERREDBCIT,   VRPARDEDIT,
                                          VRCONTITIMP,     VRBASECALCIT, VRIMPOSTOIT,    IDERROSIMPIT,    IDAVISIMPIT,    IDTRIMPSTII,
                                          CDSITUTRIBITNFE, IDMODBCITNFE, IDMODBCSTITNFE, CDTPCREDPICOITE, CDNATUBCALPCIT, IDMOTDESONERAIT,
                                          CDDETALHEPROD,   VRIMPOSTOVISUIT,   CDREGRAIT, IDDIFALIQCUSPRI, VRPERDIFEREIT, VRIMPOSTOOPERAIT,
                                          VRIMPOSTODIFERIT, CDENQLEGALIPI, CDCEST, VRADICFECP, VRADICALIQFECP, 
                                          CDBENEFFISCAL)
                                       VALUES(
                                          P_FILIAL,                P_LANCTONF,     C_ITEMPROD.NRSEQITPROD, C_ITEMPROIMPOS.CDIMPOSTO, w_1,               V_CDFISCTEMP,
                                          NVL(V_SITUTRIBPR, C_ITEMPROD.CDSITUTRIBPR), V_FISOPEITEM,   V_SUFXCFOPPR,           V_ALIQUTMP,               V_PREDBCTMP,         V_PARDEDTMP,
                                          ROUND(V_BASECALCTO,5),   ROUND(V_BASECALCTO,2),   ROUND(V_IMPOSTOIT,2),   w_00000,                  w_00000,             V_IDTRIMPSTII,
                                          V_CDSITUTRIBNFE,         V_IDMODBCNFEIT, V_IDMODBCSTNFEIT,       V_CDTPCRPICOSTNFEIT,      V_CDNATUBCPCSTNFEIT, V_IDMOTIDESSTNFE,
                                          V_CDDETALHEPRODTEMP,     ROUND(V_VRIMPOSTOVISUIT,2),     V_CDREGRAITALIQ, C_ITEMPROIMPOS.IDDIFALIQCUSPRI, V_PERDIFERE, V_IMPOSTOOPERA,
                                          V_IMPOSTODIFER, V_CDENQLEGALIPI, V_CDCEST, (C_ITEMPROIMPOS.VRADICFECP * V_VRFATOCONV), C_ITEMPROIMPOS.VRADICALIQFECP,
                                          V_CDBENEFFISCAL);
                                    END IF;
                                 END IF;

                                 IF (C_ITEMPROIMPOS.NRITPROIMPOS = w_1) THEN
                                    IF (V_PREDBCTMP > 0) AND (V_PBCSUBTRIB = 0) THEN
                                       IF C_ITEMPROD.CDSITUTRIBPR = '060' THEN
                                          INSERT INTO ITEMPROIMPOS(
                                             CDFILIAL,        NRLANCTONF,     NRSEQITPROD,    CDIMPOSTO,       NRITPROIMPOS,   CDFISCALIT,
                                             CDSITUTRIBIT,    CDFISCOPERIT,   CDSUFXCFOPIT,   VRALIQITEM,      VRPERREDBCIT,   VRPARDEDIT,
                                             VRCONTITIMP,     VRBASECALCIT,   VRIMPOSTOIT,    IDERROSIMPIT,    IDAVISIMPIT,    IDTRIMPSTII,
                                             CDSITUTRIBITNFE, IDMODBCITNFE,   IDMODBCSTITNFE, CDTPCREDPICOITE, CDNATUBCALPCIT, IDMOTDESONERAIT,
                                             CDDETALHEPROD,   VRIMPOSTOVISUIT,   CDREGRAIT, CDENQLEGALIPI, CDCEST, VRADICFECP, VRADICALIQFECP,
                                             CDBENEFFISCAL)
                                          VALUES(
                                             P_FILIAL,                P_LANCTONF,     C_ITEMPROD.NRSEQITPROD, C_ITEMPROIMPOS.CDIMPOSTO, w_2,                 w_2,
                                             NVL(V_SITUTRIBPR, C_ITEMPROD.CDSITUTRIBPR), V_FISOPEITEM,   V_SUFXCFOPPR,           0,                        V_PERDBCALC,         V_PARDEDTMP,
                                             V_CONTABCALC,            0,              0,                      w_00000,                  w_00000,             V_IDTRIMPSTII,
                                             V_CDSITUTRIBNFE,         V_IDMODBCNFEIT, V_IDMODBCSTNFEIT,       V_CDTPCRPICOSTNFEIT,      V_CDNATUBCPCSTNFEIT, V_IDMOTIDESSTNFE,
                                             V_CDDETALHEPRODTEMP, 0,     V_CDREGRAITALIQ, V_CDENQLEGALIPI, V_CDCEST, (C_ITEMPROIMPOS.VRADICFECP * V_VRFATOCONV), C_ITEMPROIMPOS.VRADICALIQFECP,
                                             V_CDBENEFFISCAL);
                                       ELSE
                                          INSERT INTO ITEMPROIMPOS(
                                             CDFILIAL,        NRLANCTONF,     NRSEQITPROD,     CDIMPOSTO,       NRITPROIMPOS,   CDFISCALIT,
                                             CDSITUTRIBIT,    CDFISCOPERIT,   CDSUFXCFOPIT,    VRALIQITEM,      VRPERREDBCIT,   VRPARDEDIT,
                                             VRCONTITIMP,     VRBASECALCIT,   VRIMPOSTOIT,     IDERROSIMPIT,    IDAVISIMPIT,    IDTRIMPSTII,
                                             CDSITUTRIBITNFE, IDMODBCITNFE,   IDMODBCSTITNFE,  CDTPCREDPICOITE, CDNATUBCALPCIT, IDMOTDESONERAIT,
                                             CDDETALHEPROD,   VRIMPOSTOVISUIT,   CDREGRAIT, CDENQLEGALIPI, CDCEST, VRADICFECP, VRADICALIQFECP,
                                             CDBENEFFISCAL)
                                          VALUES(
                                             P_FILIAL,                P_LANCTONF,     C_ITEMPROD.NRSEQITPROD, C_ITEMPROIMPOS.CDIMPOSTO, w_2,                 w_2,
                                             NVL(V_SITUTRIBPR, C_ITEMPROD.CDSITUTRIBPR), V_FISOPEITEM,   V_SUFXCFOPPR,           0,                        V_PERDBCALC,         V_PARDEDTMP,
                                             V_CONTABCALC,            0,              0,                      w_00000,                  w_00000,             V_IDTRIMPSTII,
                                             V_CDSITUTRIBNFE,         V_IDMODBCNFEIT, V_IDMODBCSTNFEIT,       V_CDTPCRPICOSTNFEIT,      V_CDNATUBCPCSTNFEIT, V_IDMOTIDESSTNFE,
                                             V_CDDETALHEPRODTEMP,     0,     V_CDREGRAITALIQ, V_CDENQLEGALIPI, V_CDCEST, (C_ITEMPROIMPOS.VRADICFECP * V_VRFATOCONV), C_ITEMPROIMPOS.VRADICALIQFECP,
                                             V_CDBENEFFISCAL);
                                       END IF;
                                    END IF;
                                 END IF;
                                 IF ((V_IDSISTEMA = 'VND') OR (V_IDSISTEMA = 'PDV')) AND (V_ICMS = 'S') THEN
                                    INSERT INTO ITEMPROIMPOSORIG(CDFILIAL,     NRLANCTONF,     NRSEQITPROD,     CDIMPOSTO,      NRITPROIMPOS,    CDFISCALIT,
                                                             CDSITUTRIBIT, CDFISCOPERIT,   CDSUFXCFOPIT,    VRALIQITEM,     VRPERREDBCIT,    VRPARDEDIT,
                                                             VRCONTITIMP,  VRBASECALCIT,   VRIMPOSTOIT,     IDERROSIMPIT,   IDAVISIMPIT,     CDSITUTRIBITNFE,
                                                             IDMODBCITNFE, IDMODBCSTITNFE, CDTPCREDPICOITE, CDNATUBCALPCIT, IDMOTDESONERAIT, IDTRIMPSTII,
                                                             CDDETALHEPROD, CDENQLEGALIPI, CDCEST, CDBENEFFISCAL)
                                    VALUES(P_FILIAL, P_LANCTONF, C_ITEMPROD.NRSEQITPROD, C_ITEMPROIMPOS.CDIMPOSTO, C_ITEMPROIMPOS.NRITPROIMPOS, C_ITEMPROIMPOS.CDFISCALIT,
                                           C_ITEMPROD.CDSITUTRIBPR, V_FISOPEITEM, V_SUFXCFOPPR, C_ITEMPROIMPOS.VRALIQITEM, C_ITEMPROIMPOS.VRPERREDBCIT, TRUNC((C_ITEMPROIMPOS.VRPARDEDIT * V_VRFATOCONV),2),
                                           TRUNC((C_ITEMPROIMPOS.VRCONTITIMP * V_VRFATOCONV),5), TRUNC((C_ITEMPROIMPOS.VRBASECALCIT * V_VRFATOCONV),2), 
                                           TRUNC((C_ITEMPROIMPOS.VRIMPOSTOIT * V_VRFATOCONV),2), w_00000, w_00000, C_ITEMPROIMPOS.CDSITUTRIBNFE,
                                           C_ITEMPROIMPOS.IDMODBCNFE, C_ITEMPROIMPOS.IDMODBCSTNFE, C_ITEMPROIMPOS.CDTPCREDPICOITE, C_ITEMPROIMPOS.CDNATUBCALPCIT, NVL(C_ITEMPROIMPOS.IDMOTDESONERAIT,'9'), C_ITEMPROIMPOS.IDTRIMPSTII,
                                           V_CDDETALHEPRODTEMP, V_CDENQLEGALIPI, V_CDCEST, V_CDBENEFFISCAL);
                                 ELSE
                                    INSERT INTO ITEMPROIMPOSORIG(CDFILIAL,     NRLANCTONF,     NRSEQITPROD,     CDIMPOSTO,      NRITPROIMPOS,    CDFISCALIT,
                                                             CDSITUTRIBIT, CDFISCOPERIT,   CDSUFXCFOPIT,    VRALIQITEM,     VRPERREDBCIT,    VRPARDEDIT,
                                                             VRCONTITIMP,  VRBASECALCIT,   VRIMPOSTOIT,     IDERROSIMPIT,   IDAVISIMPIT,     CDSITUTRIBITNFE,
                                                             IDMODBCITNFE, IDMODBCSTITNFE, CDTPCREDPICOITE, CDNATUBCALPCIT, IDMOTDESONERAIT, IDTRIMPSTII,
                                                             CDDETALHEPROD, CDENQLEGALIPI, CDCEST, CDBENEFFISCAL)
                                    VALUES(P_FILIAL, P_LANCTONF, C_ITEMPROD.NRSEQITPROD, C_ITEMPROIMPOS.CDIMPOSTO, C_ITEMPROIMPOS.NRITPROIMPOS, C_ITEMPROIMPOS.CDFISCALIT,
                                           C_ITEMPROD.CDSITUTRIBPR, V_FISOPEITEM, V_SUFXCFOPPR, C_ITEMPROIMPOS.VRALIQITEM, C_ITEMPROIMPOS.VRPERREDBCIT, (C_ITEMPROIMPOS.VRPARDEDIT * V_VRFATOCONV),
                                           ROUND((C_ITEMPROIMPOS.VRCONTITIMP * V_VRFATOCONV),5), (C_ITEMPROIMPOS.VRBASECALCIT * V_VRFATOCONV), 
                                           (C_ITEMPROIMPOS.VRIMPOSTOIT * V_VRFATOCONV), w_00000, w_00000, C_ITEMPROIMPOS.CDSITUTRIBNFE,
                                           C_ITEMPROIMPOS.IDMODBCNFE, C_ITEMPROIMPOS.IDMODBCSTNFE, C_ITEMPROIMPOS.CDTPCREDPICOITE, C_ITEMPROIMPOS.CDNATUBCALPCIT, NVL(C_ITEMPROIMPOS.IDMOTDESONERAIT,'9'), C_ITEMPROIMPOS.IDTRIMPSTII,
                                           V_CDDETALHEPRODTEMP, V_CDENQLEGALIPI, V_CDCEST, V_CDBENEFFISCAL);
                                 END IF;
                              END IF;
                           END IF;
                        ELSE

                           Begin
                              SELECT CDFILIAL
                              INTO   V_CHAVE
                              FROM ITEMPROIMPOS
                              WHERE CDFILIAL     = P_FILIAL                 AND
                                    NRLANCTONF   = P_LANCTONF               AND
                                    NRSEQITPROD  = C_ITEMPROD.NRSEQITPROD   AND
                                    CDIMPOSTO    = C_ITEMPROIMPOS.CDIMPOSTO AND
                                    NRITPROIMPOS = C_ITEMPROIMPOS.NRITPROIMPOS;
                           Exception
                              When No_Data_Found Then
                                 V_CHAVE := Null;
                           End;
                           SELECT NVL(MAX(IDPERVISIMPSCRE), 'S')
                             INTO V_IDPERVISIMPSCRE
                             FROM PARAMGERAL;
                           IF V_IDPERVISIMPSCRE = 'S' THEN
                              V_VRIMPOSTOVISUIT := (C_ITEMPROIMPOS.VRIMPOSTOIT * V_VRFATOCONV);
                           ELSE
                              IF (V_CDFISCTEMP = '1') THEN
                                V_VRIMPOSTOVISUIT := (C_ITEMPROIMPOS.VRIMPOSTOIT * V_VRFATOCONV);
                              ELSE
                                V_VRIMPOSTOVISUIT := 0;
                              END IF;
                           END IF;

                           -- Alterar o valor contábil caso o parâmetro "Contabiliza conforme NF de origem" esteja desmarcado

                           IF (V_IDCONTCONFORIG =  'N') THEN

                              V_IMPOCONTAB  := 0;
                              V_IDIMPORECUP := NULL;
                              V_CDCCTBLATIV := NULL;
                              V_IDTRATIMPO  := NULL;

                              SELECT NVL(IDIMPORECUP, 'N'), IDTRATIMPO, CDCCTBLATIV
                                INTO V_IDIMPORECUP, V_IDTRATIMPO, V_CDCCTBLATIV
                                FROM IMPOSTO
                               WHERE CDIMPOSTO = C_ITEMPROIMPOS.CDIMPOSTO;

                              IF (V_IDIMPORECUP = W_S) THEN
                                 IF (V_CDFISCTEMP = W_1) THEN
                                    IF (V_CDCCTBLATIV IS NOT NULL) THEN
                                       IF V_IDTRATIMPO = W_V THEN
                                          V_IMPOCONTAB := - C_ITEMPROIMPOS.VRIMPOSTOIT;
                                       END IF;
                                    END IF;
                                 ELSE
                                    IF V_IDTRATIMPO = W_A THEN
                                       V_IMPOCONTAB := V_IMPOSTOIT;
                                    ELSIF V_IDTRATIMPO IN (W_D,W_R) THEN
                                       V_IMPOCONTAB := - C_ITEMPROIMPOS.VRIMPOSTOIT;
                                    END IF;
                                 END IF;
                              END IF;

                              IF (ABS(NVL(V_IMPOCONTAB, 0)) > 0) THEN
                                 UPDATE ITEMPRODUTO
                                    SET VRCONTITEMORIG = (VRCONTITEM) + NVL(V_IMPOCONTAB, 0),
                                        VRCONTITEM     = (VRCONTITEM) + NVL(V_IMPOCONTAB, 0)
                                  WHERE CDFILIAL       = P_FILIAL
                                    AND NRLANCTONF     = P_LANCTONF
                                    AND NRSEQITPROD    = C_ITEMPROD.NRSEQITPROD;
                              END IF;

                           END IF;
                           -- Alterar o valor contábil caso o parâmetro "Contabiliza conforme NF de origem" esteja desmarcado
                           IF V_CHAVE IS NULL THEN
                              V_ICMS := 'N';
                              FOR C_ICMS IN (SELECT CDIMPOSTO
                                               FROM IMPOSTONFE N, IMPOSTO I
                                              WHERE N.CDIMPOSTONFE = I.CDIMPOSTONFE
                                                AND N.CDIMPOSTONFE = '00'
                                                AND I.CDIMPOSTO = C_ITEMPROIMPOS.CDIMPOSTO)
                              LOOP
                                 V_ICMS := 'S';
                              END LOOP;

                              IF ((V_IDSISTEMA = 'VND') OR (V_IDSISTEMA = 'PDV')) AND (V_ICMS = 'S') THEN
                                 INSERT INTO ITEMPROIMPOS(CDFILIAL,     NRLANCTONF,     NRSEQITPROD,     CDIMPOSTO,      NRITPROIMPOS,    CDFISCALIT,
                                                          CDSITUTRIBIT, CDFISCOPERIT,   CDSUFXCFOPIT,    VRALIQITEM,     VRPERREDBCIT,    VRPARDEDIT,
                                                          VRCONTITIMP,  VRBASECALCIT,   VRIMPOSTOIT,     IDERROSIMPIT,   IDAVISIMPIT,     CDSITUTRIBITNFE,
                                                          IDMODBCITNFE, IDMODBCSTITNFE, CDTPCREDPICOITE, CDNATUBCALPCIT, IDMOTDESONERAIT, IDTRIMPSTII,
                                                          CDDETALHEPROD, VRIMPOSTOVISUIT, CDENQLEGALIPI, CDCEST, CDBENEFFISCAL)
                                 VALUES(P_FILIAL, P_LANCTONF, C_ITEMPROD.NRSEQITPROD, C_ITEMPROIMPOS.CDIMPOSTO, C_ITEMPROIMPOS.NRITPROIMPOS, V_CDFISCTEMP,
                                        NVL(V_SITUTRIBPR, C_ITEMPROD.CDSITUTRIBPR), V_FISOPEITEM, V_SUFXCFOPPR, C_ITEMPROIMPOS.VRALIQITEM, C_ITEMPROIMPOS.VRPERREDBCIT, TRUNC((C_ITEMPROIMPOS.VRPARDEDIT * V_VRFATOCONV),2),
                                        TRUNC((C_ITEMPROIMPOS.VRCONTITIMP * V_VRFATOCONV),2), TRUNC((C_ITEMPROIMPOS.VRBASECALCIT * V_VRFATOCONV),2),
                                        TRUNC((C_ITEMPROIMPOS.VRIMPOSTOIT * V_VRFATOCONV),2), w_00000, w_00000, V_CDSITUTRIBNFE,
                                        V_IDMODBCNFEIT, V_IDMODBCSTNFEIT, V_CDTPCRPICOSTNFEIT, V_CDNATUBCPCSTNFEIT, V_IDMOTIDESSTNFE, C_ITEMPROIMPOS.IDTRIMPSTII,
                                        V_CDDETALHEPRODTEMP, TRUNC(V_VRIMPOSTOVISUIT,2), V_CDENQLEGALIPI, V_CDCEST, V_CDBENEFFISCAL);
                              ELSE
                                 INSERT INTO ITEMPROIMPOS(CDFILIAL,     NRLANCTONF,     NRSEQITPROD,     CDIMPOSTO,      NRITPROIMPOS,    CDFISCALIT,
                                                          CDSITUTRIBIT, CDFISCOPERIT,   CDSUFXCFOPIT,    VRALIQITEM,     VRPERREDBCIT,    VRPARDEDIT,
                                                          VRCONTITIMP,  VRBASECALCIT,   VRIMPOSTOIT,     IDERROSIMPIT,   IDAVISIMPIT,     CDSITUTRIBITNFE,
                                                          IDMODBCITNFE, IDMODBCSTITNFE, CDTPCREDPICOITE, CDNATUBCALPCIT, IDMOTDESONERAIT, IDTRIMPSTII,
                                                          CDDETALHEPROD, VRIMPOSTOVISUIT, CDENQLEGALIPI, CDCEST, VRADICFECP, VRADICALIQFECP, 
                                                          CDBENEFFISCAL)
                                 VALUES(P_FILIAL, P_LANCTONF, C_ITEMPROD.NRSEQITPROD, C_ITEMPROIMPOS.CDIMPOSTO, C_ITEMPROIMPOS.NRITPROIMPOS, V_CDFISCTEMP,
                                        NVL(V_SITUTRIBPR, C_ITEMPROD.CDSITUTRIBPR), V_FISOPEITEM, V_SUFXCFOPPR, C_ITEMPROIMPOS.VRALIQITEM, C_ITEMPROIMPOS.VRPERREDBCIT, (C_ITEMPROIMPOS.VRPARDEDIT * V_VRFATOCONV),
                                        ROUND((C_ITEMPROIMPOS.VRCONTITIMP * V_VRFATOCONV),5), (C_ITEMPROIMPOS.VRBASECALCIT * V_VRFATOCONV),  
                                        (C_ITEMPROIMPOS.VRIMPOSTOIT * V_VRFATOCONV), w_00000, w_00000, V_CDSITUTRIBNFE,
                                        V_IDMODBCNFEIT, V_IDMODBCSTNFEIT, V_CDTPCRPICOSTNFEIT, V_CDNATUBCPCSTNFEIT, V_IDMOTIDESSTNFE, C_ITEMPROIMPOS.IDTRIMPSTII,
                                        V_CDDETALHEPRODTEMP, ROUND(V_VRIMPOSTOVISUIT,2), V_CDENQLEGALIPI, V_CDCEST, (C_ITEMPROIMPOS.VRADICFECP * V_VRFATOCONV), C_ITEMPROIMPOS.VRADICALIQFECP,
                                        V_CDBENEFFISCAL);
                              END IF;

                              IF ((V_IDSISTEMA = 'VND') OR (V_IDSISTEMA = 'PDV')) AND (V_ICMS = 'S') THEN
                                 INSERT INTO ITEMPROIMPOSORIG(CDFILIAL,     NRLANCTONF,     NRSEQITPROD,     CDIMPOSTO,      NRITPROIMPOS,    CDFISCALIT,
                                                          CDSITUTRIBIT, CDFISCOPERIT,   CDSUFXCFOPIT,    VRALIQITEM,     VRPERREDBCIT,    VRPARDEDIT,
                                                          VRCONTITIMP,  VRBASECALCIT,   VRIMPOSTOIT,     IDERROSIMPIT,   IDAVISIMPIT,     CDSITUTRIBITNFE,
                                                          IDMODBCITNFE, IDMODBCSTITNFE, CDTPCREDPICOITE, CDNATUBCALPCIT, IDMOTDESONERAIT, IDTRIMPSTII,
                                                          CDDETALHEPROD, CDENQLEGALIPI, CDCEST, CDBENEFFISCAL)
                                 VALUES(P_FILIAL, P_LANCTONF, C_ITEMPROD.NRSEQITPROD, C_ITEMPROIMPOS.CDIMPOSTO, C_ITEMPROIMPOS.NRITPROIMPOS, C_ITEMPROIMPOS.CDFISCALIT,
                                        C_ITEMPROD.CDSITUTRIBPR, V_FISOPEITEM, V_SUFXCFOPPR, C_ITEMPROIMPOS.VRALIQITEM, C_ITEMPROIMPOS.VRPERREDBCIT, TRUNC((C_ITEMPROIMPOS.VRPARDEDIT * V_VRFATOCONV),2),
                                        TRUNC((C_ITEMPROIMPOS.VRCONTITIMP * V_VRFATOCONV),2), TRUNC((C_ITEMPROIMPOS.VRBASECALCIT * V_VRFATOCONV),2),
                                        TRUNC((C_ITEMPROIMPOS.VRIMPOSTOIT * V_VRFATOCONV),2), w_00000, w_00000, C_ITEMPROIMPOS.CDSITUTRIBNFE,
                                        C_ITEMPROIMPOS.IDMODBCNFE, C_ITEMPROIMPOS.IDMODBCSTNFE, C_ITEMPROIMPOS.CDTPCREDPICOITE, C_ITEMPROIMPOS.CDNATUBCALPCIT, NVL(C_ITEMPROIMPOS.IDMOTDESONERAIT,'9'), C_ITEMPROIMPOS.IDTRIMPSTII,
                                        V_CDDETALHEPRODTEMP, C_ITEMPROIMPOS.CDENQLEGALIPI, C_ITEMPROIMPOS.CDCEST, V_CDBENEFFISCAL);
                              ELSE
                                 INSERT INTO ITEMPROIMPOSORIG(CDFILIAL,     NRLANCTONF,     NRSEQITPROD,     CDIMPOSTO,      NRITPROIMPOS,    CDFISCALIT,
                                                          CDSITUTRIBIT, CDFISCOPERIT,   CDSUFXCFOPIT,    VRALIQITEM,     VRPERREDBCIT,    VRPARDEDIT,
                                                          VRCONTITIMP,  VRBASECALCIT,   VRIMPOSTOIT,     IDERROSIMPIT,   IDAVISIMPIT,     CDSITUTRIBITNFE,
                                                          IDMODBCITNFE, IDMODBCSTITNFE, CDTPCREDPICOITE, CDNATUBCALPCIT, IDMOTDESONERAIT, IDTRIMPSTII,
                                                          CDDETALHEPROD, CDENQLEGALIPI, CDCEST, CDBENEFFISCAL)
                                 VALUES(P_FILIAL, P_LANCTONF, C_ITEMPROD.NRSEQITPROD, C_ITEMPROIMPOS.CDIMPOSTO, C_ITEMPROIMPOS.NRITPROIMPOS, C_ITEMPROIMPOS.CDFISCALIT,
                                        C_ITEMPROD.CDSITUTRIBPR, V_FISOPEITEM, V_SUFXCFOPPR, C_ITEMPROIMPOS.VRALIQITEM, C_ITEMPROIMPOS.VRPERREDBCIT, (C_ITEMPROIMPOS.VRPARDEDIT * V_VRFATOCONV),
                                        ROUND((C_ITEMPROIMPOS.VRCONTITIMP * V_VRFATOCONV),5), (C_ITEMPROIMPOS.VRBASECALCIT * V_VRFATOCONV), 
                                        (C_ITEMPROIMPOS.VRIMPOSTOIT * V_VRFATOCONV), w_00000, w_00000, C_ITEMPROIMPOS.CDSITUTRIBNFE,
                                        C_ITEMPROIMPOS.IDMODBCNFE, C_ITEMPROIMPOS.IDMODBCSTNFE, C_ITEMPROIMPOS.CDTPCREDPICOITE, C_ITEMPROIMPOS.CDNATUBCALPCIT, NVL(C_ITEMPROIMPOS.IDMOTDESONERAIT,'9'), C_ITEMPROIMPOS.IDTRIMPSTII,
                                        V_CDDETALHEPRODTEMP, C_ITEMPROIMPOS.CDENQLEGALIPI, C_ITEMPROIMPOS.CDCEST, V_CDBENEFFISCAL);
                              END IF;
                           END IF;
                        END IF;
                     END IF;

                     DELETE ALIQTEMP
                      WHERE NRALIQTEMP = V_ALIQTEMP;
                  END LOOP;
                  /*Imposto gerado como encargo na importaçdo de xml */
                  BEGIN
                     SELECT NVL(IDNFGERADAVIAXML, 'N')
                       INTO V_IDNFORIGVIAXML
                       FROM NOTAFISCAL N, ITEMPRODUTO IP
                      WHERE N.CDFILIAL   = C_ITEMNOTAFISC.CDFILIALIT
                        AND N.NRLANCTONF = C_ITEMNOTAFISC.NRLANCTONFIT
                        AND N.CDFILIAL   = IP.CDFILIAL
                        AND N.NRLANCTONF = IP.NRLANCTONF
                        AND IP.VRENCARGOIMPXML > 0
                        AND ROWNUM = 1;
                  EXCEPTION
                     WHEN NO_DATA_FOUND THEN
                        V_IDNFORIGVIAXML := 'N';
                  END;
                  /*Imposto gerado como encargo na importaçdo de xml*/
                  IF (V_IDNFORIGVIAXML = 'S') AND (V_UPDENCIMPXML = 'N') THEN
                     FOR C_ENCARGO IN (SELECT IMP.CDENCARGOIMPXML
                                         FROM IMPOSTONFE NFE, IMPOSTO IMP
                                        WHERE IMP.CDIMPOSTOXML(+) = NFE.CDIMPOSTONFE
                                          AND IMP.CDENCARGOIMPXML IS NOT NULL
                                         ORDER BY NFE.CDIMPOSTONFE) LOOP
                        UPDATE ITEMENCARGO
                           SET VRITEMENCA = 0
                         WHERE CDFILIAL   = P_FILIAL
                           AND NRLANCTONF = P_LANCTONF
                           AND CDENCARGO  = C_ENCARGO.CDENCARGOIMPXML
                           AND IDALTERADO = 'N';
                     END LOOP;
                     V_UPDENCIMPXML := 'S';
                  END IF;
                  IF (V_IDNFORIGVIAXML = 'S') THEN
                     BEGIN
                        SELECT SUM(I.VRENCARGOIMPXML), SUM(VRTOTAITEM - VRDESCITEM) AS VRLIQUORIG, I.NRSEQITPROD, N.NRACESSONFE
                          INTO V_VRENCARGOIMPXML, V_VRLIQUORIG, V_NRSEQITORIG, V_NRACESSONFORIG
                          FROM ITEMPRODUTO I, NOTAFISCAL N
                         WHERE I.CDFILIAL    = C_ITEMNOTAFISC.CDFILIALIT
                           AND I.NRLANCTONF  = C_ITEMNOTAFISC.NRLANCTONFIT
                           AND I.CDPRODUTO   = C_ITEMPROD.CDPRODUTO
                           AND I.CDFILIAL    = N.CDFILIAL
                           AND I.NRLANCTONF  = N.NRLANCTONF
                           AND ROUND(I.VRUNITITEM, V_NRDECITOTANF) = ROUND(C_ITEMPROD.VRUNITITEM, V_NRDECITOTANF)
                           AND (NVL(I.NRLOTEESTQ, ' ')  = (NVL(C_ITEMPROD.NRLOTEESTQ, ' ')))
                           AND (NVL(I.NRSUBLOTE , ' ')  = (NVL(C_ITEMPROD.NRSUBLOTE , ' ')))
                           AND  I.VRENCARGOIMPXML > 0
                           AND ROWNUM = 1 
                         GROUP BY I.NRSEQITPROD, N.NRACESSONFE;
                     EXCEPTION
                        WHEN NO_DATA_FOUND THEN
                           V_VRENCARGOIMPXML := 0; V_VRLIQUORIG := 0; V_NRSEQITORIG := NULL; V_NRACESSONFORIG := NULL;
                     END;
                     IF (V_VRENCARGOIMPXML > 0) THEN
                        V_VRFATOCONV :=  (C_ITEMPROD.VRTOTAITEM - C_ITEMPROD.VRDESCITEM)/ V_VRLIQUORIG;
                        FOR C_ENCARGOXML IN (SELECT IMP.CDENCARGOIMPXML, IMP.CDIMPOSTO
                                               FROM IMPOSTONFE NFE, IMPOSTO IMP
                                              WHERE IMP.CDIMPOSTOXML(+) = NFE.CDIMPOSTONFE
                                                AND IMP.CDENCARGOIMPXML IS NOT NULL) LOOP
                           BEGIN
                              SELECT IT.VRIMPOSTOIT
                                INTO V_VRIMPENCXMLORIG
                                FROM INTG_TRABITPROIMPOS IT, IMPOSTO I
                               WHERE IT.NRACESSONFE  = V_NRACESSONFORIG
                                 AND IT.CDIMPOSTOIT  = I.CDIMPOSTO
                                 AND LPAD(IT.NRSEQIMPOIT, 4, '0') = V_NRSEQITORIG
                                 AND IT.CDIMPOSTOIT = C_ENCARGOXML.CDIMPOSTO;
                           EXCEPTION
                              WHEN NO_DATA_FOUND THEN
                                 V_VRIMPENCXMLORIG := 0;
                           END;
                           IF V_VRIMPENCXMLORIG > 0 THEN
                              UPDATE ITEMENCARGO
                                 SET VRITEMENCA = VRITEMENCA + (V_VRIMPENCXMLORIG * V_VRFATOCONV)
                               WHERE CDFILIAL   = P_FILIAL
                                 AND NRLANCTONF = P_LANCTONF
                                 AND CDENCARGO  = C_ENCARGOXML.CDENCARGOIMPXML;
                           END IF;
                        END LOOP;
                     END IF;
                  END IF; -- Pegar o valor proporcional do imposto
               END IF;
            END LOOP;
         END IF;

         DELETE CFOPTEMP
          WHERE NRCFOPTEMP = V_CFOPTEMP;

         IF (V_IDOPERDEVONF <> w_S) THEN
            IF V_IDDOCREPLIC IS NOT NULL THEN
               IF LENGTH(V_SITUTRIBPR) = 3 THEN
                  V_SITUTRIBPR := SUBSTR(V_SITUTRIBPR,1,1) || w_90;
               ELSE
                  V_SITUTRIBPR := w_90;
               END IF;
            END IF;

            UPDATE ITEMPRODUTO
            SET CDSITUTRIBPR  = V_SITUTRIBPR
            WHERE CDFILIAL    = P_FILIAL   AND
                  NRLANCTONF  = P_LANCTONF AND
                  NRSEQITPROD = C_ITEMPROD.NRSEQITPROD;
         END IF;

         DELETE CSTTEMP
         WHERE NRCSTTEMP = V_CSTTEMP;

         V_IMPOCONTAB := 0;
      END LOOP;


      SELECT MAX(IDUTCTRLFISSAID)
        INTO V_IDUTCTRLFISSAID
        FROM PARAMGERAL;

      SELECT MAX(IDUTCTRLFISSAID)
        INTO V_IDUTCTRLFISFIL
        FROM PARAMFILIAL
       WHERE CDFILIAL = V_CDFILIEMIT;

      IF V_IDUTCTRLFISSAID = 'S' THEN
         V_IDUTCTRLFIS := 'S';
      ELSE
         IF V_IDUTCTRLFISFIL = 'S' THEN
            V_IDUTCTRLFIS := 'S';
         ELSE
            V_IDUTCTRLFIS := 'N';
         END IF;
      END IF;

      SELECT NVL(MAX(IDGERICMSTDESPA), 'N'), MAX(CDENCARGOICMST), NVL(MAX(IDPEINFICMSTDEME), 'N'), NVL(MAX(IDGERIPIDESPA), 'N')
        INTO V_IDGERICMSTDESPA, V_CDENCARGOICMST, V_IDPEINFICMSTDEME, V_IDGERIPIDESPA
        FROM TIPOOPERAC
       WHERE IDENTRSAIDOP = 'S'
         AND CDTIPOOPER = P_TIPOOPER;

      IF ((V_IDGERICMSTDESPA = 'S') OR (V_IDGERIPIDESPA = 'S')) AND (V_IDUTCTRLFIS = 'S') AND (V_IDNFORIGVIAXML = 'N') THEN
         UPDATE ITEMENCARGO
            SET VRITEMENCA = 0
          WHERE CDFILIAL = P_FILIAL
            AND NRLANCTONF = P_LANCTONF
            AND IDALTERADO = 'N';
      END IF;

      V_VRENCAICMSSTIT := 0;
      FOR C_ITEMNOTAFISC IN (SELECT CDFILIALIT, NRLANCTONFIT
                             FROM ITEMNOTAFISC
                             WHERE CDFILIAL   = P_FILIAL AND
                                   NRLANCTONF = P_LANCTONF) LOOP

         SELECT SUM(VRTOTAITEM - VRDESCITEM) AS VRLIQUORIG
         INTO   V_VRLIQUORIG
         FROM ITEMPRODUTO I
         WHERE CDFILIAL    = C_ITEMNOTAFISC.CDFILIALIT AND
               NRLANCTONF  = C_ITEMNOTAFISC.NRLANCTONFIT;

         IF V_VRLIQUORIG = 0 THEN
            V_VRFATOCONV := 0;
         ELSE
            V_VRFATOCONV := V_LIQUIDO / V_VRLIQUORIG;
         END IF;

         IF (V_IDNFORIGVIAXML = 'N') THEN
            SELECT SUM(VRITEMENCA)
              INTO V_VRENCAICMSSTIT
              FROM ITEMENCARGO
             WHERE CDFILIAL = C_ITEMNOTAFISC.CDFILIALIT
               AND NRLANCTONF = C_ITEMNOTAFISC.NRLANCTONFIT
               AND CDENCARGO = V_CDENCARGOICMST;

            FOR C_ITEMENCARGO IN (SELECT CDENCARGO, SUM(VRITEMENCA) AS VRITEMENCA
                                  FROM ITEMENCARGO
                                  WHERE CDFILIAL   = C_ITEMNOTAFISC.CDFILIALIT   AND
                                        NRLANCTONF = C_ITEMNOTAFISC.NRLANCTONFIT AND
                                        VRITEMENCA > 0
                                  GROUP BY CDENCARGO) LOOP

                SELECT NVL(MAX(IDALTERADO), 'N')
                  INTO V_IDALTERADO_ENCA
                  FROM ITEMENCARGO
                WHERE CDFILIAL   = P_FILIAL
                  AND NRLANCTONF = P_LANCTONF
                  AND CDENCARGO = C_ITEMENCARGO.CDENCARGO;
                IF V_IDALTERADO_ENCA = 'N' THEN
                   UPDATE ITEMENCARGO
                   SET VRITEMENCA = (C_ITEMENCARGO.VRITEMENCA * V_VRFATOCONV)
                   WHERE CDFILIAL   = P_FILIAL   AND
                         NRLANCTONF = P_LANCTONF AND
                         CDENCARGO  = C_ITEMENCARGO.CDENCARGO;
                END IF;
            END LOOP;
         END IF;   
      END LOOP;

      /*CALCULA DESCONTO DE BONIFICAÇÃO NA DEVOLUÇÃO DE NOTAS */
      SELECT MAX(CDENCDESCBONDEV)
        INTO V_CDENCDESCBONDEV
        FROM PARAMGERAL;

      IF V_CDENCDESCBONDEV IS NOT NULL THEN
         SELECT NVL(MAX(IDCONDESBONFORN), 'S') INTO V_IDCONDESBONFORN
           FROM PARAMFILIAL
          WHERE CDFILIAL = V_CDFILIEMIT;

         SELECT MAX(F.CDAJUCTPAG), MAX(F.VRPEDESCFORN), TO_DATE(NVL(MAX(DTINIVRPDESC), '01/01/0100'))
           INTO V_CDAJUCTPAG, V_VRPEDESCFORN, V_DTINIVRPDESC
           FROM FORNECEDOR F
          WHERE (F.CDFORNECED   = P_CLIENTE)
            AND (NOT F.VRPEDESCFORN IS NULL)
            AND (F.IDTPDESCFORN = 'B');

         IF (V_VRPEDESCFORN IS NOT NULL) AND (V_VRPEDESCFORN <> 0) AND (V_IDCONDESBONFORN = 'S') THEN

            IF (P_INIVALID >= V_DTINIVRPDESC) THEN
               V_VRENCARBONI := ROUND(V_LIQUIDO * (V_VRPEDESCFORN/100),2);

               UPDATE ITEMENCARGO
               SET VRITEMENCA = V_VRENCARBONI
               WHERE CDFILIAL = P_FILIAL
                 AND NRLANCTONF = P_LANCTONF
                 AND CDENCARGO = V_CDENCDESCBONDEV;
            END IF;
         END IF;
      END IF;

      DELETE FROM DADOSADIC
       WHERE CDFILIAL   = P_FILIAL
         AND NRLANCTONF = P_LANCTONF
         AND DSDADOADIC LIKE 'Base de Cálculo do ICMS ST%';
      DELETE FROM DADOSADIC
       WHERE CDFILIAL   = P_FILIAL
         AND NRLANCTONF = P_LANCTONF
         AND DSDADOADIC LIKE 'ICMS ST: R$%';
      DELETE FROM DADOSADIC
       WHERE CDFILIAL   = P_FILIAL
         AND NRLANCTONF = P_LANCTONF
         AND DSDADOADIC LIKE 'Valor de IPI: R$%';

      IF (V_IDUTCTRLFIS = 'S') THEN
         IF V_IDGERICMSTDESPA = 'S' THEN
            IF V_CDENCARGOICMST IS NOT NULL THEN
               SELECT NVL(MAX(IDALTERADO), 'N')
                 INTO V_IDALTERADO_ENCA
                 FROM ITEMENCARGO
               WHERE CDFILIAL   = P_FILIAL
                 AND NRLANCTONF = P_LANCTONF
                 AND CDENCARGO = V_CDENCARGOICMST;

               IF V_IDALTERADO_ENCA = 'N' THEN
                  UPDATE ITEMENCARGO
                     SET VRITEMENCA = 0
                   WHERE CDFILIAL = P_FILIAL
                     AND NRLANCTONF = P_LANCTONF
                     AND CDENCARGO = V_CDENCARGOICMST;
               END IF;

               SELECT MAX(CDENCARGO)
                 INTO V_CDENCARGOOD
                 FROM ENCARGO
                WHERE CDENCARGONFE = '04';

               IF V_CDENCARGOOD IS NOT NULL THEN
                  SELECT NVL(MAX(IDALTERADO), 'N')
                    INTO V_IDALTERADO_ENCA
                    FROM ITEMENCARGO
                   WHERE CDFILIAL = P_FILIAL
                     AND NRLANCTONF = P_LANCTONF
                     AND CDENCARGO = V_CDENCARGOOD;

                  IF V_IDALTERADO_ENCA = 'N' THEN
                     IF (V_VRENCAICMSSTIT > 0) OR (V_VRTOTALICMSST > 0) THEN
                        IF V_IDPEINFICMSTDEME = 'S' THEN
                           SELECT NVL(SUM(VRICMSST),0), NVL(SUM(VRBASECALC),0)
                             INTO V_VRICMSST, V_VRBASECALC
                             FROM INFICMSST
                            WHERE CDFILIAL = P_FILIAL
                              AND NRLANCTONF = P_LANCTONF;

                           IF V_VRICMSST > 0 THEN

                              UPDATE ITEMENCARGO
                                 SET VRITEMENCA = ROUND(VRITEMENCA + V_VRICMSST,2)
                               WHERE CDFILIAL = P_FILIAL
                                 AND NRLANCTONF = P_LANCTONF
                                 AND CDENCARGO = V_CDENCARGOOD;

                              IF V_VRBASECALC > 0 THEN
                                 SELECT COUNT(*)
                                   INTO V_EXISTDSDADOSADIC
                                   FROM DADOSADIC
                                  WHERE CDFILIAL = P_FILIAL
                                    AND NRLANCTONF = P_LANCTONF
                                    AND DSDADOADIC LIKE 'Base de Cálculo do ICMS ST%';

                                 IF V_EXISTDSDADOSADIC = 0 THEN

                                    INSERT INTO DADOSADIC(CDFILIAL, NRLANCTONF, NRDADOADIC, DSDADOADIC)
                                                   VALUES(P_FILIAL, P_LANCTONF, V_DADOADIC, 'Base de Cálculo do ICMS ST: R$'||DECODE(SUBSTR(LTRIM(TO_CHAR(ROUND(V_VRBASECALC , 2), '9999999999999.99')), 1, 1), '.', '0'||LTRIM(TO_CHAR(ROUND(V_VRBASECALC , 2), '9999999999999.99')), LTRIM(TO_CHAR(ROUND(V_VRBASECALC , 2), '9999999999999.99')))|| ' ICMS ST: R$'|| DECODE(SUBSTR(LTRIM(TO_CHAR(ROUND(V_VRICMSST, 2), '9999999999999.99')), 1, 1), '.', '0'||LTRIM(TO_CHAR(ROUND(V_VRICMSST, 2), '9999999999999.99')), LTRIM(TO_CHAR(ROUND(V_VRICMSST, 2), '9999999999999.99'))));

                                    V_DADOADIC := LPAD(RTRIM(TO_CHAR(TO_NUMBER(V_DADOADIC) + 1)),3,0);
                                 ELSE
                                    UPDATE DADOSADIC
                                       SET DSDADOADIC = 'Base de Cálculo do ICMS ST: R$'||DECODE(SUBSTR(LTRIM(TO_CHAR(ROUND(V_VRBASECALC, 2), '9999999999999.99')), 1, 1), '.', '0'||LTRIM(TO_CHAR(ROUND(V_VRBASECALC, 2), '9999999999999.99')), LTRIM(TO_CHAR(ROUND(V_VRBASECALC, 2), '9999999999999.99')))|| ' ICMS ST: R$'|| DECODE(SUBSTR(LTRIM(TO_CHAR(ROUND(V_VRICMSST, 2), '9999999999999.99')), 1, 1), '.', '0'||LTRIM(TO_CHAR(ROUND(V_VRICMSST, 2), '9999999999999.99')), LTRIM(TO_CHAR(ROUND(V_VRICMSST, 2), '9999999999999.99')))
                                      WHERE CDFILIAL = P_FILIAL
                                        AND NRLANCTONF = P_LANCTONF
                                        AND DSDADOADIC LIKE 'Base de Cálculo do ICMS ST%';
                                 END IF;
                              ELSE
                                 SELECT COUNT(*)
                                   INTO V_EXISTDSDADOSADIC
                                   FROM DADOSADIC
                                  WHERE CDFILIAL = P_FILIAL
                                    AND NRLANCTONF = P_LANCTONF
                                    AND DSDADOADIC LIKE 'ICMS ST: R$%';

                                 IF V_EXISTDSDADOSADIC = 0 THEN
                                    INSERT INTO DADOSADIC(CDFILIAL, NRLANCTONF, NRDADOADIC, DSDADOADIC)
                                                   VALUES(P_FILIAL, P_LANCTONF, V_DADOADIC, 'ICMS ST: R$ '||DECODE(SUBSTR(LTRIM(TO_CHAR(ROUND(V_VRICMSST, 2), '9999999999999.99')), 1, 1), '.', '0'||LTRIM(TO_CHAR(ROUND(V_VRICMSST, 2), '9999999999999.99')), LTRIM(TO_CHAR(ROUND(V_VRICMSST, 2), '9999999999999.99'))));

                                    V_DADOADIC := LPAD(RTRIM(TO_CHAR(TO_NUMBER(V_DADOADIC) + 1)),3,0);
                                 ELSE
                                    UPDATE DADOSADIC
                                       SET DSDADOADIC = 'ICMS ST: R$ '||DECODE(SUBSTR(LTRIM(TO_CHAR(ROUND(V_VRICMSST, 2), '9999999999999.99')), 1, 1), '.', '0'||LTRIM(TO_CHAR(ROUND(V_VRICMSST, 2), '9999999999999.99')), LTRIM(TO_CHAR(ROUND(V_VRICMSST, 2), '9999999999999.99')))
                                      WHERE CDFILIAL = P_FILIAL
                                        AND NRLANCTONF = P_LANCTONF
                                        AND DSDADOADIC LIKE 'ICMS ST: R$%';
                                 END IF;
                              END IF;
                           END IF;
                        ELSE
                           UPDATE ITEMENCARGO
                              SET VRITEMENCA = ROUND(VRITEMENCA + (V_VRENCAICMSSTIT * V_VRFATOCONV) + V_VRTOTALICMSST,2)
                            WHERE CDFILIAL = P_FILIAL
                              AND NRLANCTONF = P_LANCTONF
                              AND CDENCARGO = V_CDENCARGOOD;

                           SELECT COUNT(*)
                             INTO V_EXISTDSDADOSADIC
                             FROM DADOSADIC
                            WHERE CDFILIAL = P_FILIAL
                              AND NRLANCTONF = P_LANCTONF
                              AND DSDADOADIC LIKE 'ICMS ST: R$%';

                           IF V_EXISTDSDADOSADIC = 0 THEN
                              INSERT INTO DADOSADIC(CDFILIAL, NRLANCTONF, NRDADOADIC, DSDADOADIC)
                                             VALUES(P_FILIAL, P_LANCTONF, V_DADOADIC, 'ICMS ST: R$ '||DECODE(SUBSTR(LTRIM(TO_CHAR(ROUND(V_VRTOTALICMSST + (V_VRENCAICMSSTIT * V_VRFATOCONV), 2), '9999999999999.99')), 1, 1), '.', '0'||LTRIM(TO_CHAR(ROUND(V_VRTOTALICMSST + (V_VRENCAICMSSTIT * V_VRFATOCONV), 2), '9999999999999.99')), LTRIM(TO_CHAR(ROUND(V_VRTOTALICMSST + (V_VRENCAICMSSTIT * V_VRFATOCONV), 2), '9999999999999.99'))));

                              V_DADOADIC := LPAD(RTRIM(TO_CHAR(TO_NUMBER(V_DADOADIC) + 1)),3,0);
                           ELSE
                              UPDATE DADOSADIC
                                 SET DSDADOADIC = 'ICMS ST: R$ '||DECODE(SUBSTR(LTRIM(TO_CHAR(ROUND(V_VRTOTALICMSST + (V_VRENCAICMSSTIT * V_VRFATOCONV), 2), '9999999999999.99')), 1, 1), '.', '0'||LTRIM(TO_CHAR(ROUND(V_VRTOTALICMSST + (V_VRENCAICMSSTIT * V_VRFATOCONV), 2), '9999999999999.99')), LTRIM(TO_CHAR(ROUND(V_VRTOTALICMSST + (V_VRENCAICMSSTIT * V_VRFATOCONV), 2), '9999999999999.99')))
                                WHERE CDFILIAL = P_FILIAL
                                  AND NRLANCTONF = P_LANCTONF
                                  AND DSDADOADIC LIKE 'ICMS ST: R$%';
                           END IF;
                        END IF;
                     END IF;
                  END IF;
               END IF;
            END IF;
         END IF;
         IF (V_IDGERIPIDESPA = 'S') THEN
            SELECT MAX(CDENCARGO)
              INTO V_CDENCARGOOD
              FROM ENCARGO
             WHERE CDENCARGONFE = '04';

            IF V_CDENCARGOOD IS NOT NULL THEN
               SELECT NVL(MAX(IDALTERADO), 'N')
                 INTO V_IDALTERADO_ENCA
                 FROM ITEMENCARGO
                WHERE CDFILIAL   = P_FILIAL
                  AND NRLANCTONF = P_LANCTONF
                  AND CDENCARGO  = V_CDENCARGOOD;
               IF V_IDALTERADO_ENCA = 'N' THEN
                  IF (V_VRTOTALIPI > 0) THEN
                     UPDATE ITEMENCARGO
                        SET VRITEMENCA = ROUND(VRITEMENCA + V_VRTOTALIPI, 2)
                      WHERE CDFILIAL = P_FILIAL
                        AND NRLANCTONF = P_LANCTONF
                        AND CDENCARGO = V_CDENCARGOOD;

                     SELECT COUNT(*)
                       INTO V_EXISTDSDADOSADIC
                       FROM DADOSADIC
                      WHERE CDFILIAL = P_FILIAL
                        AND NRLANCTONF = P_LANCTONF
                        AND DSDADOADIC LIKE 'Valor de IPI: R$%';

                     IF (V_EXISTDSDADOSADIC = 0) THEN

                        INSERT INTO DADOSADIC(CDFILIAL, NRLANCTONF, NRDADOADIC, DSDADOADIC)
                                       VALUES(P_FILIAL, P_LANCTONF, V_DADOADIC, 'Valor de IPI: R$ '||DECODE(SUBSTR(LTRIM(TO_CHAR(ROUND(V_VRTOTALIPI, 2),'9999999999999.99')),1, 1),'.','0'||LTRIM(TO_CHAR(ROUND(V_VRTOTALIPI, 2),'9999999999999.99')),LTRIM(TO_CHAR(ROUND(V_VRTOTALIPI, 2),'9999999999999.99'))));

                        V_DADOADIC := LPAD(RTRIM(TO_CHAR(TO_NUMBER(V_DADOADIC) + 1)),3,0);
                     ELSE
                        UPDATE DADOSADIC
                           SET DSDADOADIC = 'Valor de IPI: R$ '||DECODE(SUBSTR(LTRIM(TO_CHAR(ROUND(V_VRTOTALIPI, 2), '9999999999999.99')), 1, 1), '.', '0'||LTRIM(TO_CHAR(ROUND(V_VRTOTALIPI, 2), '9999999999999.99')), LTRIM(TO_CHAR(ROUND(V_VRTOTALIPI, 2), '9999999999999.99')))
                          WHERE CDFILIAL = P_FILIAL
                            AND NRLANCTONF = P_LANCTONF
                            AND DSDADOADIC LIKE 'Valor de IPI: R$%';
                     END IF;
                  END IF;
               END IF;
            END IF;
         END IF;
      END IF;

      --RATEIO DOS ENCARGOS--------------------------------------------------------------------------------------------------------
      FOR C_ITEMENCARGO IN (SELECT IE.CDENCARGO AS CDENCARGO, VRITEMENCA, IDENCARGO,
                                   EN.CDCTBLENTREN, EN.CDCTBLSAIDEN
                            FROM ITEMENCARGO IE, ENCARGO EN
                            WHERE (IE.CDFILIAL   = P_FILIAL)     AND
                                  (IE.NRLANCTONF = P_LANCTONF)   AND
                                  (IE.VRITEMENCA > 0)            AND
                                  (EN.CDENCARGO  = IE.CDENCARGO)) LOOP
         V_TOTAPRODENCA := 0;
         FOR C_VRLIQRATEIO IN (SELECT DISTINCT(IP.NRSEQITPROD) AS NRSEQITPROD, (VRTOTAITEM - VRDESCITEM) AS VRLIQUIDO
                               FROM ITEMPRODUTO IP, ITEMPROIMPOS II
                               WHERE (IP.CDFILIAL    = P_FILIAL)       AND
                                     (IP.NRLANCTONF  = P_LANCTONF)     AND
                                     (II.CDFILIAL    = IP.CDFILIAL)    AND
                                     (II.NRLANCTONF  = IP.NRLANCTONF)  AND
                                     (II.NRSEQITPROD = IP.NRSEQITPROD) AND
                                     (EXISTS(SELECT BC.CDIMPOSTO
                                             FROM BASECALC BC
                                             WHERE (BC.CDENCARGO = C_ITEMENCARGO.CDENCARGO) AND
                                                   (BC.CDIMPOSTO = II.CDIMPOSTO)            AND
                                                   (BC.CDIMPOSTO IN (SELECT B.CDIMPOSTO
                                                                    FROM BASECALC B
                                                                    WHERE B.CDENCARGO = C_ITEMENCARGO.CDENCARGO))))) LOOP

            IF NOT (C_VRLIQRATEIO.VRLIQUIDO IS NULL) THEN
               V_TOTAPRODENCA := V_TOTAPRODENCA + C_VRLIQRATEIO.VRLIQUIDO;
            END IF;
         END LOOP;

         IF V_TOTAPRODENCA = 0 THEN
            IF (V_IDCONTCONFORIG = 'N') THEN
               SELECT SUM(VRTOTAITEM - VRDESCITEM)
               INTO   V_TOTAPRODENCA
               FROM ITEMPRODUTO IP
               WHERE (IP.CDFILIAL   = P_FILIAL)   AND
                     (IP.NRLANCTONF = P_LANCTONF);

               IF NOT V_TOTAPRODENCA IS NULL THEN
                  FOR C_ATUAVRCONT IN (SELECT IP.NRSEQITPROD, (VRTOTAITEM - VRDESCITEM) AS VRLIQUIDO
                                       FROM ITEMPRODUTO IP
                                       WHERE (IP.CDFILIAL    = P_FILIAL) AND
                                             (IP.NRLANCTONF  = P_LANCTONF)) LOOP

                     IF (C_ITEMENCARGO.IDENCARGO = w_A) THEN
                        V_VRBRUTO  := (C_ITEMENCARGO.VRITEMENCA/V_TOTAPRODENCA);
                     ELSIF (C_ITEMENCARGO.IDENCARGO = w_D) THEN
                        V_VRBRUTO  := - (C_ITEMENCARGO.VRITEMENCA/V_TOTAPRODENCA);
                     ELSE
                        V_VRBRUTO := 0;
                     END IF;

                     IF (C_ITEMENCARGO.CDCTBLSAIDEN IS NULL) THEN
                        V_VRCONTAB := V_VRBRUTO;
                     ELSE
                        V_VRCONTAB := 0;
                     END IF;

                     IF ((V_IDSISTEMA = 'VND') OR (V_IDSISTEMA = 'PDV')) AND (NVL(V_IDORIGDESTNF, 'C') <> 'L') THEN
                        UPDATE ITEMPRODUTO
                        SET VRBRUTITEM = TRUNC(VRBRUTITEM + (V_VRBRUTO  * (VRTOTAITEM - VRDESCITEM)),2),
                            VRCONTITEM = TRUNC(VRCONTITEM + (V_VRCONTAB * (VRTOTAITEM - VRDESCITEM)),2)
                        WHERE CDFILIAL    = P_FILIAL   AND
                              NRLANCTONF  = P_LANCTONF AND
                              NRSEQITPROD = C_ATUAVRCONT.NRSEQITPROD;
                     ELSE
                        UPDATE ITEMPRODUTO
                        SET VRBRUTITEM = ROUND(VRBRUTITEM + (V_VRBRUTO  * (VRTOTAITEM - VRDESCITEM)),5),
                            VRCONTITEM = ROUND(VRCONTITEM + (V_VRCONTAB * (VRTOTAITEM - VRDESCITEM)),5)
                        WHERE CDFILIAL    = P_FILIAL   AND
                              NRLANCTONF  = P_LANCTONF AND
                              NRSEQITPROD = C_ATUAVRCONT.NRSEQITPROD;
                     END IF;
                  END LOOP;
               END IF;
            END IF;
         ELSE
            IF (V_IDCONTCONFORIG = 'N') THEN
               FOR C_ATUAVRCONT IN (SELECT DISTINCT(IP.NRSEQITPROD) AS NRSEQITPROD, (VRTOTAITEM - VRDESCITEM) AS VRLIQUIDO
                                    FROM ITEMPRODUTO IP, ITEMPROIMPOS II
                                    WHERE (IP.CDFILIAL    = P_FILIAL)       AND
                                          (IP.NRLANCTONF  = P_LANCTONF)     AND
                                          (II.CDFILIAL    = IP.CDFILIAL)    AND
                                          (II.NRLANCTONF  = IP.NRLANCTONF)  AND
                                          (II.NRSEQITPROD = IP.NRSEQITPROD) AND
                                          (EXISTS(SELECT BC.CDIMPOSTO
                                                  FROM BASECALC BC
                                                  WHERE (BC.CDENCARGO = C_ITEMENCARGO.CDENCARGO) AND
                                                        (BC.CDIMPOSTO = II.CDIMPOSTO)            AND
                                                        (BC.CDIMPOSTO IN (SELECT B.CDIMPOSTO
                                                                          FROM BASECALC B
                                                                          WHERE B.CDENCARGO = C_ITEMENCARGO.CDENCARGO))))) LOOP

                  IF (C_ITEMENCARGO.IDENCARGO = w_A) THEN
                     V_VRBRUTO  := (C_ITEMENCARGO.VRITEMENCA/V_TOTAPRODENCA);
                  ELSIF (C_ITEMENCARGO.IDENCARGO = w_D) THEN
                     V_VRBRUTO  := - (C_ITEMENCARGO.VRITEMENCA/V_TOTAPRODENCA);
                  ELSE
                     V_VRBRUTO := 0;
                  END IF;

                  IF (C_ITEMENCARGO.CDCTBLSAIDEN IS NULL) THEN
                     V_VRCONTAB := V_VRBRUTO;
                  ELSE
                     V_VRCONTAB := 0;
                  END IF;

                  IF ((V_IDSISTEMA = 'VND') OR (V_IDSISTEMA = 'PDV')) AND (NVL(V_IDORIGDESTNF, 'C') <> 'L') THEN
                     UPDATE ITEMPRODUTO
                     SET VRBRUTITEM = TRUNC(VRBRUTITEM + (V_VRBRUTO  * (VRTOTAITEM - VRDESCITEM)),2),
                         VRCONTITEM = TRUNC(VRCONTITEM + (V_VRCONTAB * (VRTOTAITEM - VRDESCITEM)),2)
                     WHERE CDFILIAL    = P_FILIAL   AND
                           NRLANCTONF  = P_LANCTONF AND
                           NRSEQITPROD = C_ATUAVRCONT.NRSEQITPROD;
                  ELSE
                     UPDATE ITEMPRODUTO
                     SET VRBRUTITEM = ROUND(VRBRUTITEM + (V_VRBRUTO  * (VRTOTAITEM - VRDESCITEM)),5),
                         VRCONTITEM = ROUND(VRCONTITEM + (V_VRCONTAB * (VRTOTAITEM - VRDESCITEM)),5)
                     WHERE CDFILIAL    = P_FILIAL   AND
                           NRLANCTONF  = P_LANCTONF AND
                           NRSEQITPROD = C_ATUAVRCONT.NRSEQITPROD;
                  END IF;
               END LOOP;
            END IF;

            FOR C_ITEMPROIMPOS IN (SELECT II.NRSEQITPROD, II.NRITPROIMPOS, II.CDIMPOSTO, II.VRPERREDBCIT, II.VRALIQITEM,
                                          II.VRPARDEDIT, II.IDTRIMPSTII, (VRTOTAITEM - VRDESCITEM) AS VRLIQUIDO,
                                          NVL(II.VRALIQINTEDEST, 0) AS VRALIQINTEDEST, NVL(II.VRALIQFCP, 0) AS VRALIQFCP,
                                          NVL(IP.IDUTILBCPMC, 'N') AS IDUTILBCPMC, I.CDIMPOSTONFE
                                   FROM ITEMPROIMPOS II, ITEMPRODUTO IP, BASECALC BC, IMPOSTO I
                                   WHERE (II.CDFILIAL     = P_FILIAL)                AND
                                         (II.NRLANCTONF   = P_LANCTONF)              AND
                                         (IP.CDFILIAL     = P_FILIAL)                AND
                                         (IP.NRLANCTONF   = P_LANCTONF)              AND
                                         (IP.NRSEQITPROD  = II.NRSEQITPROD)          AND
                                         (BC.CDIMPOSTO    = II.CDIMPOSTO)            AND
                                         (II.CDIMPOSTO    = I.CDIMPOSTO)             AND
                                         (BC.CDENCARGO    = C_ITEMENCARGO.CDENCARGO)
                                   ORDER BY 1, 2, 3) LOOP

               IF NOT((C_ITEMPROIMPOS.IDUTILBCPMC = W_S) AND (C_ITEMPROIMPOS.CDIMPOSTONFE = '80')) OR (C_ITEMPROIMPOS.IDUTILBCPMC <> W_S) THEN

                  SELECT SUM(VRTOTAITEM - VRDESCITEM)
                    INTO V_TOTAPRENIMPO
                    FROM ITEMPRODUTO IP
                   WHERE IP.CDFILIAL   = P_FILIAL
                     AND IP.NRLANCTONF = P_LANCTONF;

                  IF (V_TOTAPRODENCA <> 0) THEN
                     IF (C_ITEMENCARGO.IDENCARGO = w_A) THEN
                        V_PRODUENCARGO := +(C_ITEMENCARGO.VRITEMENCA/V_TOTAPRENIMPO)*C_ITEMPROIMPOS.VRLIQUIDO;
                     ELSIF (C_ITEMENCARGO.IDENCARGO = w_D) THEN
                        V_PRODUENCARGO := -(C_ITEMENCARGO.VRITEMENCA/V_TOTAPRENIMPO)*C_ITEMPROIMPOS.VRLIQUIDO;
                     ELSE
                        V_PRODUENCARGO := 0;
                     END IF;
                  END IF;

                  V_IDVRIMPSTRIB := null;
                  BEGIN
                     SELECT CASE COUNT(*) WHEN 0 THEN 'M' ELSE 'R' END
                       INTO V_MAJORAOUREDUZ
                       FROM ITEMPROIMPOS
                      WHERE CDFILIAL = P_FILIAL 
                        AND NRLANCTONF = P_LANCTONF
                        AND NRSEQITPROD = C_ITEMPROIMPOS.NRSEQITPROD
                        AND CDIMPOSTO = C_ITEMPROIMPOS.CDIMPOSTO
                        AND NRITPROIMPOS = w_2;
                  EXCEPTION
                     WHEN NO_DATA_FOUND THEN
                        V_MAJORAOUREDUZ := 'M';
                  END;

                  V_VRIMPOSTOST := 0;
                  IF V_MAJORAOUREDUZ = 'R' THEN
                     V_TAXABASECALC := (100 - C_ITEMPROIMPOS.VRPERREDBCIT)/100;
                     V_TAXAALIQUOTA := (C_ITEMPROIMPOS.VRALIQITEM/100);
                  ELSE
                     V_TAXABASECALC := 1 + (C_ITEMPROIMPOS.VRPERREDBCIT)/100;
                     V_TAXAALIQUOTA := (C_ITEMPROIMPOS.VRALIQITEM/100);

                     SELECT NVL(MAX(IDVRIMPSTRIB), 'N')
                       INTO V_IDVRIMPSTRIB
                       FROM ITEMPROIMPOS I, IMPOSTO II
                      WHERE (CDFILIAL     = P_FILIAL)
                        AND (NRLANCTONF   = P_LANCTONF)
                        AND (NRSEQITPROD  = C_ITEMPROIMPOS.NRITPROIMPOS)
                        AND (INSTR(V_CDIMPOSTRIB,II.CDIMPOSTO||'_') > 0)
                        AND (I.CDIMPOSTO = II.CDIMPOSTO);

                     IF (C_ITEMPROIMPOS.IDTRIMPSTII <> w_1) AND (NVL(V_IDVRIMPSTRIB,w_N) = w_S) THEN
                        Begin
                           SELECT NVL(MAX(VRIMPOSTOIT),0)
                           INTO   V_VRIMPOSTOST
                           FROM ITEMPROIMPOS I
                           WHERE (CDFILIAL     = P_FILIAL)                   AND
                                 (NRLANCTONF   = P_LANCTONF)                 AND
                                 (INSTR(V_CDIMPOSTRIB,CDIMPOSTO||'_') > 0)   AND
                                 (NRITPROIMPOS = C_ITEMPROIMPOS.NRITPROIMPOS);
                        Exception
                           When No_Data_Found Then
                              V_VRIMPOSTOST := 0;
                        End;
                     END IF;
                  END IF;

                  V_ICMS := 'N';
                  FOR C_ICMS IN (SELECT CDIMPOSTO
                                   FROM IMPOSTONFE N, IMPOSTO I
                                  WHERE N.CDIMPOSTONFE = I.CDIMPOSTONFE
                                    AND N.CDIMPOSTONFE = '00'
                                    AND I.CDIMPOSTO = C_ITEMPROIMPOS.CDIMPOSTO)
                  LOOP
                     V_ICMS := 'S';
                  END LOOP;

                  SELECT NVL(MAX(IDPERVISIMPSCRE), 'S')
                    INTO V_IDPERVISIMPSCRE
                    FROM PARAMGERAL;

                  UPDATE ITEMPROIMPOS
                     SET VRCONTITIMP  = VRCONTITIMP  + (V_PRODUENCARGO * V_TAXABASECALC),
                         VRBASECALCIT = VRBASECALCIT + ((V_PRODUENCARGO * V_TAXABASECALC) / (1 - ((C_ITEMPROIMPOS.VRALIQINTEDEST + C_ITEMPROIMPOS.VRALIQFCP) / 100))),
                         VRIMPOSTOIT  = (VRIMPOSTOIT  + (((V_PRODUENCARGO * V_TAXABASECALC) / (1 - ((C_ITEMPROIMPOS.VRALIQINTEDEST + C_ITEMPROIMPOS.VRALIQFCP) / 100))) * V_TAXAALIQUOTA)) - (((V_VRIMPOSTOST * V_TAXABASECALC) / (1 - ((C_ITEMPROIMPOS.VRALIQINTEDEST + C_ITEMPROIMPOS.VRALIQFCP) / 100))) * V_TAXAALIQUOTA),
                         VRIMPOSTOVISUIT = DECODE(V_IDPERVISIMPSCRE, 'S', (VRIMPOSTOIT  + ((V_PRODUENCARGO * V_TAXABASECALC) * V_TAXAALIQUOTA)) - ((V_VRIMPOSTOST * V_TAXABASECALC) * V_TAXAALIQUOTA),  DECODE(CDFISCALIT , '1', (VRIMPOSTOIT  + ((V_PRODUENCARGO * V_TAXABASECALC) * V_TAXAALIQUOTA)) - ((V_VRIMPOSTOST * V_TAXABASECALC) * V_TAXAALIQUOTA),0)),
                         VRADICFECP  = VRADICFECP  + ROUND((V_PRODUENCARGO * (VRADICALIQFECP / 100) * V_TAXABASECALC),2)
                   WHERE (CDFILIAL     = P_FILIAL)                   AND
                         (NRLANCTONF   = P_LANCTONF)                 AND
                         (NRSEQITPROD  = C_ITEMPROIMPOS.NRSEQITPROD) AND
                         (CDIMPOSTO    = C_ITEMPROIMPOS.CDIMPOSTO)   AND
                         (NRITPROIMPOS = C_ITEMPROIMPOS.NRITPROIMPOS);
               END IF;

               /* ROTINA PARA RECALCULAR O DIFERIMENTO DO IMPOSTO */
               BEGIN
                  SELECT MAX(VRIMPOSTOOPERAIT), MAX(VRPERDIFEREIT)
                    INTO V_VRIMPOSTOOPERAIT, V_VRPERDIFEREIT
                    FROM ITEMPROIMPOS
                   WHERE (CDFILIAL     = P_FILIAL)                    AND
                         (NRLANCTONF   = P_LANCTONF)                  AND
                         (NRSEQITPROD  = C_ITEMPROIMPOS.NRSEQITPROD)  AND
                         (CDIMPOSTO    = C_ITEMPROIMPOS.CDIMPOSTO)    AND
                         (NRITPROIMPOS = C_ITEMPROIMPOS.NRITPROIMPOS) AND
                         (VRPERDIFEREIT <> 0);
               EXCEPTION
                  When No_Data_Found Then
                     V_VRIMPOSTOOPERAIT := 0; V_VRPERDIFEREIT := 0;
               END;

               IF V_VRPERDIFEREIT <> 0 THEN
                  V_VRIMPOSTOOPERAIT := ROUND((V_VRIMPOSTOOPERAIT + ((ROUND(V_PRODUENCARGO, 2) * V_TAXABASECALC) * V_TAXAALIQUOTA)) - ((V_VRIMPOSTOST * V_TAXABASECALC) * V_TAXAALIQUOTA),2);
                  V_VRIMPOSTODIFERIT := ROUND((V_VRIMPOSTOOPERAIT * V_VRPERDIFEREIT/100), 2);

                  UPDATE ITEMPROIMPOS
                     SET VRIMPOSTOOPERAIT = V_VRIMPOSTOOPERAIT,
                         VRIMPOSTODIFERIT = V_VRIMPOSTODIFERIT,
                         VRIMPOSTOIT = (V_VRIMPOSTOOPERAIT - V_VRIMPOSTODIFERIT),
                         VRIMPOSTOVISUIT = (V_VRIMPOSTOOPERAIT - V_VRIMPOSTODIFERIT)
                   WHERE (CDFILIAL     = P_FILIAL)                    AND
                         (NRLANCTONF   = P_LANCTONF)                  AND
                         (NRSEQITPROD  = C_ITEMPROIMPOS.NRSEQITPROD)  AND
                         (CDIMPOSTO    = C_ITEMPROIMPOS.CDIMPOSTO)    AND
                         (NRITPROIMPOS = C_ITEMPROIMPOS.NRITPROIMPOS) AND
                         (VRPERDIFEREIT <> 0);
               END IF;
            END LOOP;
         END IF;
      END LOOP;

      FOR C_PRODUTO IN (SELECT IP.NRSEQITPROD AS NRSEQITPROD, II.CDIMPOSTO, VRPERREDBCIT,
                               VRALIQITEM, VRPARDEDIT, CDFISCALIT, VRIMPOSTOIT, IDTRATIMPO,
                               IM.IDIMPORECUP, IM.CDCCTBLPASS, IM.CDCCTBLATIV, NRITPROIMPOS,
                               IDTRIMPSTII, IM.IDTIPCONTAB, II.VRBASECALCIT, IP.IDUTILBCPMC,
                               IM.CDIMPOSTONFE
                        FROM ITEMPRODUTO IP, ITEMPROIMPOS II, IMPOSTO IM
                        WHERE (IP.CDFILIAL     = P_FILIAL)      AND
                              (IP.NRLANCTONF   = P_LANCTONF)    AND
                              (II.CDFILIAL     = IP.CDFILIAL)   AND
                              (II.NRLANCTONF   = IP.NRLANCTONF) AND
                              (IM.CDIMPOSTO    = II.CDIMPOSTO)  AND
                              --(INSTR(V_CDIMPOSRECALC,II.CDIMPOSTO||'_') > 0) AND
                              (II.NRITPROIMPOS = w_1)           AND
                              (II.NRSEQITPROD  = IP.NRSEQITPROD)
                        ORDER BY NRSEQITPROD, CDIMPOSTO) LOOP

         IF NOT((C_PRODUTO.IDUTILBCPMC = W_S) AND (C_PRODUTO.CDIMPOSTONFE = '80')) OR (C_PRODUTO.IDUTILBCPMC <> W_S) THEN
            V_IDIMPOBCALTPOP := NULL;
   
            SELECT TO_CHAR(MAX('S')) , NVL(SUM(VRIMPOSTOIT),0) AS VRIMPOBCALC
              INTO   V_IDIMPOBCALTPOP, V_TOTAIMPBCALC
              FROM ITEMPRODUTO IP, ITEMPROIMPOS II, BASECALCTPOPER BC , IMPOSTO I
             WHERE (BC.CDIMPOSTO    = C_PRODUTO.CDIMPOSTO)
               AND (IP.CDFILIAL     = P_FILIAL)
               AND (IP.NRLANCTONF   = P_LANCTONF)
               AND (II.NRLANCTONF   = IP.NRLANCTONF)
               AND (II.CDFILIAL     = IP.CDFILIAL)
               AND (IP.NRSEQITPROD  = C_PRODUTO.NRSEQITPROD)
               AND (II.NRSEQITPROD  = C_PRODUTO.NRSEQITPROD)
               AND (II.NRITPROIMPOS = C_PRODUTO.NRITPROIMPOS)
               AND ((SUBSTR(IP.CDSITUTRIBPR,2,2) = BC.CDCSTIMPOTPOP)  OR (BC.CDCSTIMPOTPOP  IS NULL))
               AND ((SUBSTR(IP.CDFISOPEITEM,2,4) = BC.CDCFOPIMPOTPOP) OR (BC.CDCFOPIMPOTPOP IS NULL))
               AND ((C_PRODUTO.CDFISCALIT        = BC.CDFISCIMPOTPOP) OR (BC.CDFISCIMPOTPOP IS NULL))
               AND (BC.IDENTRSAIDOP = 'S')
               AND (BC.CDTIPOOPER = P_TIPOOPER)
               AND (II.CDIMPOSTO = BC.CDIMPOBCALC)
               AND (BC.CDIMPOBCALC = I.CDIMPOSTO)
               AND (NVL(BC.IDTRATIMPOBCTPOP, I.IDTRATIMPO) <> 'D');
   
            IF V_IDIMPOBCALTPOP IS NULL THEN
               SELECT NVL(SUM(VRIMPOSTOIT),0) AS VRIMPOBCALC
                 INTO   V_TOTAIMPBCALC
                 FROM ITEMPRODUTO IP, ITEMPROIMPOS II, BASECALC BC, IMPOSTO I
                WHERE (BC.CDIMPOSTO    = C_PRODUTO.CDIMPOSTO)    AND
                      (IP.CDFILIAL     = P_FILIAL)               AND
                      (IP.NRLANCTONF   = P_LANCTONF)             AND
                      (II.NRLANCTONF   = IP.NRLANCTONF)          AND
                      (II.CDFILIAL     = IP.CDFILIAL)            AND
                      (IP.NRSEQITPROD  = C_PRODUTO.NRSEQITPROD)  AND
                      (II.NRSEQITPROD  = C_PRODUTO.NRSEQITPROD)  AND
                      (II.NRITPROIMPOS = C_PRODUTO.NRITPROIMPOS) AND
                      ((SUBSTR(IP.CDSITUTRIBPR,2,2) = BC.CDCSTIMPO)  OR (BC.CDCSTIMPO  IS NULL)) AND
                      ((SUBSTR(IP.CDFISOPEITEM,2,4) = BC.CDCFOPIMPO) OR (BC.CDCFOPIMPO IS NULL)) AND
                      ((C_PRODUTO.CDFISCALIT        = BC.CDFISCIMPO) OR (BC.CDFISCIMPO IS NULL)) AND
                      (II.CDIMPOSTO = BC.CDIMPOBCALC) AND
                      (BC.IDTIPOBCALC   = w_I)AND
                      (BC.CDIMPOBCALC = I.CDIMPOSTO)  AND
                      (NVL(BC.IDTRATIMPOBC, I.IDTRATIMPO) <> 'D');
            END IF;
   
            V_IDIMBCALTPOPDE := NULL;
   
            SELECT TO_CHAR(MAX('S')), (NVL(SUM(VRIMPOSTOIT),0)*-1) AS VRIMPOBCALC
              INTO V_IDIMBCALTPOPDE, V_TOTAIMPBCDES
              FROM ITEMPRODUTO IP, ITEMPROIMPOS II, BASECALCTPOPER BC, IMPOSTO I
             WHERE (BC.CDIMPOSTO    = C_PRODUTO.CDIMPOSTO)
               AND (IP.CDFILIAL     = P_FILIAL)
               AND (IP.NRLANCTONF   = P_LANCTONF)
               AND (II.NRLANCTONF   = IP.NRLANCTONF)
               AND (II.CDFILIAL     = IP.CDFILIAL)
               AND (IP.NRSEQITPROD  = C_PRODUTO.NRSEQITPROD)
               AND (II.NRSEQITPROD  = C_PRODUTO.NRSEQITPROD)
               AND (II.NRITPROIMPOS = C_PRODUTO.NRITPROIMPOS)
               AND ((SUBSTR(IP.CDSITUTRIBPR,2,2) = BC.CDCSTIMPOTPOP)  OR (BC.CDCSTIMPOTPOP  IS NULL))
               AND ((SUBSTR(IP.CDFISOPEITEM,2,4) = BC.CDCFOPIMPOTPOP) OR (BC.CDCFOPIMPOTPOP IS NULL))
               AND ((C_PRODUTO.CDFISCALIT        = BC.CDFISCIMPOTPOP) OR (BC.CDFISCIMPOTPOP IS NULL))
               AND (BC.IDENTRSAIDOP = 'S')
               AND (BC.CDTIPOOPER = P_TIPOOPER)
               AND (II.CDIMPOSTO = BC.CDIMPOBCALC)
               AND (BC.CDIMPOBCALC = I.CDIMPOSTO)
               AND (NVL(BC.IDTRATIMPOBCTPOP, I.IDTRATIMPO) = 'D');
   
            IF V_IDIMBCALTPOPDE IS NULL THEN
   
               SELECT (NVL(SUM(VRIMPOSTOIT),0)*-1) AS VRIMPOBCALC INTO V_TOTAIMPBCDES
                 FROM ITEMPRODUTO IP, ITEMPROIMPOS II, BASECALC BC, IMPOSTO I
                WHERE (BC.CDIMPOSTO    = C_PRODUTO.CDIMPOSTO)    AND
                      (IP.CDFILIAL     = P_FILIAL)               AND
                      (IP.NRLANCTONF   = P_LANCTONF)             AND
                      (II.NRLANCTONF   = IP.NRLANCTONF)          AND
                      (II.CDFILIAL     = IP.CDFILIAL)            AND
                      (IP.NRSEQITPROD  = C_PRODUTO.NRSEQITPROD)  AND
                      (II.NRSEQITPROD  = C_PRODUTO.NRSEQITPROD)  AND
                      (II.NRITPROIMPOS = C_PRODUTO.NRITPROIMPOS) AND
                      ((SUBSTR(IP.CDSITUTRIBPR,2,2) = BC.CDCSTIMPO)  OR (BC.CDCSTIMPO  IS NULL)) AND
                      ((SUBSTR(IP.CDFISOPEITEM,2,4) = BC.CDCFOPIMPO) OR (BC.CDCFOPIMPO IS NULL)) AND
                      ((C_PRODUTO.CDFISCALIT        = BC.CDFISCIMPO) OR (BC.CDFISCIMPO IS NULL)) AND
                      (II.CDIMPOSTO = BC.CDIMPOBCALC) AND
                      (BC.IDTIPOBCALC   = 'I')        AND
                      (BC.CDIMPOBCALC = I.CDIMPOSTO)  AND
                      (NVL(BC.IDTRATIMPOBC, I.IDTRATIMPO) = 'D');
            END IF;
   
            V_VRIMPOSTO := C_PRODUTO.VRIMPOSTOIT;
   
            /*IMPOSTO PARA SUBSTITUIÇÃO TRIBUTARIA*/
            V_CDIMPOSTRIB  := null;
            V_IDVRIMPSTRIB := null;
            FOR C_ICMSST IN (SELECT CDIMPOSTO
                               FROM IMPOSTO
                              WHERE CDIMPOSTRIB = C_PRODUTO.CDIMPOSTO)
            LOOP
               V_CDIMPOSTRIB := V_CDIMPOSTRIB||C_ICMSST.CDIMPOSTO||'_';
            END LOOP;
   
            V_VRIMPOSTOST := 0;
            /*Só irá fazer o cálculo de outro imposto compondo a base de cálculo,
              se o valor do mesmo não estiver zerado OU
              se for o imposto de st, pois o icms pode ter sido recalculado(por ter alguem compondo sua bc)
              e o imposto st precisa retirar o valor final do st*/
   
            IF (NOT(V_TOTAIMPBCALC IS NULL) OR (V_TOTAIMPBCALC <> 0)) OR
               (NOT(V_TOTAIMPBCDES IS NULL) OR (V_TOTAIMPBCDES <> 0)) OR
               (V_CDIMPOSTRIB IS NOT NULL) THEN
   
               SELECT NVL(MAX(IDPERVISIMPSCRE),'S')
                 INTO V_IDPERVISIMPSCRE
                 FROM PARAMGERAL;
   
               IF V_CDIMPOSTRIB IS NULL THEN
                  V_TAXABASECALC := (100 - C_PRODUTO.VRPERREDBCIT)/100;
                  V_TAXAALIQUOTA := (C_PRODUTO.VRALIQITEM/100);
                  V_VRIMPOSTO    := V_VRIMPOSTO + (((V_TOTAIMPBCALC+V_TOTAIMPBCDES) * V_TAXABASECALC) * V_TAXAALIQUOTA);
   
                  UPDATE ITEMPROIMPOS
                     SET VRBASECALCIT = VRBASECALCIT + ((V_TOTAIMPBCALC+V_TOTAIMPBCDES) * V_TAXABASECALC),
                         VRIMPOSTOIT  = VRIMPOSTOIT  + (((V_TOTAIMPBCALC+V_TOTAIMPBCDES) * V_TAXABASECALC) * V_TAXAALIQUOTA),
                         VRIMPOSTOVISUIT = DECODE(V_IDPERVISIMPSCRE, 'S', VRIMPOSTOIT  + (((V_TOTAIMPBCALC+V_TOTAIMPBCDES) * V_TAXABASECALC) * V_TAXAALIQUOTA), DECODE(CDFISCALIT, '1', VRIMPOSTOIT  + (((V_TOTAIMPBCALC+V_TOTAIMPBCDES) * V_TAXABASECALC) * V_TAXAALIQUOTA), 0))
                   WHERE (CDFILIAL     = P_FILIAL)              AND
                         (NRLANCTONF   = P_LANCTONF)            AND
                         (NRSEQITPROD  = C_PRODUTO.NRSEQITPROD) AND
                         (CDIMPOSTO    = C_PRODUTO.CDIMPOSTO)   AND
                         (NRITPROIMPOS = C_PRODUTO.NRITPROIMPOS);
   
                  /* ROTINA PARA RECALCULAR O DIFERIMENTO DO IMPOSTO */
                  BEGIN
                     SELECT MAX(VRIMPOSTOOPERAIT), MAX(VRPERDIFEREIT)
                       INTO V_VRIMPOSTOOPERAIT, V_VRPERDIFEREIT
                       FROM ITEMPROIMPOS
                      WHERE (CDFILIAL     = P_FILIAL)               AND
                            (NRLANCTONF   = P_LANCTONF)             AND
                            (NRSEQITPROD  = C_PRODUTO.NRSEQITPROD)  AND
                            (CDIMPOSTO    = C_PRODUTO.CDIMPOSTO)    AND
                            (NRITPROIMPOS = C_PRODUTO.NRITPROIMPOS) AND
                            (VRPERDIFEREIT <> 0);
                  EXCEPTION
                     When No_Data_Found Then
                        V_VRIMPOSTOOPERAIT := 0; V_VRPERDIFEREIT := 0;
                  END;
   
                  IF V_VRPERDIFEREIT <> 0 THEN
                     V_VRIMPOSTOOPERAIT := ROUND((V_VRIMPOSTOOPERAIT + ((ROUND((V_TOTAIMPBCALC+V_TOTAIMPBCDES), 2) * V_TAXABASECALC) * V_TAXAALIQUOTA)),2);
                     V_VRIMPOSTODIFERIT := ROUND((V_VRIMPOSTOOPERAIT * V_VRPERDIFEREIT/100), 2);
   
                     UPDATE ITEMPROIMPOS
                        SET VRIMPOSTOOPERAIT = V_VRIMPOSTOOPERAIT,
                            VRIMPOSTODIFERIT = V_VRIMPOSTODIFERIT,
                            VRIMPOSTOIT = (V_VRIMPOSTOOPERAIT - V_VRIMPOSTODIFERIT),
                            VRIMPOSTOVISUIT = (V_VRIMPOSTOOPERAIT - V_VRIMPOSTODIFERIT)
                      WHERE (CDFILIAL     = P_FILIAL)               AND
                            (NRLANCTONF   = P_LANCTONF)             AND
                            (NRSEQITPROD  = C_PRODUTO.NRSEQITPROD)  AND
                            (CDIMPOSTO    = C_PRODUTO.CDIMPOSTO)    AND
                            (NRITPROIMPOS = C_PRODUTO.NRITPROIMPOS) AND
                            (VRPERDIFEREIT <> 0);
                  END IF;
               ELSE
                  V_VRIMPOSST   := 0;
                  V_VRIMPOSTOST := 0;
                  FOR C_SUBSTRIB IN (SELECT NVL(IDVRIMPSTRIB, 'N') IDVRIMPSTRIB, I.CDIMPOSTO
                                       FROM ITEMPROIMPOS I, IMPOSTO II
                                      WHERE (CDFILIAL     = P_FILIAL)
                                        AND (NRLANCTONF   = P_LANCTONF)
                                        AND (NRSEQITPROD  = C_PRODUTO.NRSEQITPROD)
                                        AND (NRITPROIMPOS = '1')
                                        AND (INSTR(V_CDIMPOSTRIB,II.CDIMPOSTO||'_') > 0)
                                        AND (I.CDIMPOSTO = II.CDIMPOSTO))
                  LOOP
                     IF (C_SUBSTRIB.IDVRIMPSTRIB = w_S) THEN
                        Begin
                           SELECT NVL(ROUND(MAX(VRIMPOSTOIT), 2),0)
                           INTO   V_VRIMPOSST
                           FROM ITEMPROIMPOS I
                           WHERE (CDFILIAL     = P_FILIAL)                   AND
                                 (NRLANCTONF   = P_LANCTONF)                 AND
                                 (NRSEQITPROD  = C_PRODUTO.NRSEQITPROD)  AND
                                 (CDIMPOSTO    = C_SUBSTRIB.CDIMPOSTO)       AND
                                 (INSTR(V_CDIMPOSTRIB,CDIMPOSTO||'_') > 0)   AND
                                 (NRITPROIMPOS = w_1);
                        Exception
                           When No_Data_Found Then
                              V_VRIMPOSST := 0;
                        End;
                     ELSE
                        V_VRIMPOSST := 0;
                     END IF;
                     V_VRIMPOSTOST := V_VRIMPOSTOST + V_VRIMPOSST;
                  END LOOP;
   
                  V_TAXABASECALC := 1 + (C_PRODUTO.VRPERREDBCIT)/100;
                  V_TAXAALIQUOTA := (C_PRODUTO.VRALIQITEM/100);
                  V_VRIMPOSTO := ((C_PRODUTO.VRBASECALCIT+ ((V_TOTAIMPBCALC+V_TOTAIMPBCDES) * V_TAXABASECALC)) * V_TAXAALIQUOTA);
   
                  SELECT NVL(MAX(IDPERVISIMPSCRE), 'S')
                    INTO V_IDPERVISIMPSCRE
                    FROM PARAMGERAL;
   
                  IF V_VRIMPOSTOST > V_VRIMPOSTO THEN
                     UPDATE ITEMPROIMPOS
                     SET VRBASECALCIT = VRBASECALCIT + ((V_TOTAIMPBCALC+V_TOTAIMPBCDES) * V_TAXABASECALC),
                         VRIMPOSTOIT  = 0,
                         VRIMPOSTOVISUIT = 0
                     WHERE (CDFILIAL     = P_FILIAL)              AND
                           (NRLANCTONF   = P_LANCTONF)            AND
                           (NRSEQITPROD  = C_PRODUTO.NRSEQITPROD) AND
                           (CDIMPOSTO    = C_PRODUTO.CDIMPOSTO)   AND
                           (NRITPROIMPOS = C_PRODUTO.NRITPROIMPOS);
                     V_VRIMPOSTO := 0;
                  ELSE
                     UPDATE ITEMPROIMPOS
                        SET VRBASECALCIT = VRBASECALCIT + ((V_TOTAIMPBCALC+V_TOTAIMPBCDES) * V_TAXABASECALC),
                            VRIMPOSTOIT  = V_VRIMPOSTO - V_VRIMPOSTOST,
                            VRIMPOSTOVISUIT = DECODE(V_IDPERVISIMPSCRE, 'S', V_VRIMPOSTO - V_VRIMPOSTOST, DECODE(CDFISCALIT, '1', V_VRIMPOSTO - V_VRIMPOSTOST, 0))
                      WHERE (CDFILIAL     = P_FILIAL)              AND
                            (NRLANCTONF   = P_LANCTONF)            AND
                            (NRSEQITPROD  = C_PRODUTO.NRSEQITPROD) AND
                            (CDIMPOSTO    = C_PRODUTO.CDIMPOSTO)   AND
                            (NRITPROIMPOS = C_PRODUTO.NRITPROIMPOS);
                     V_VRIMPOSTO := V_VRIMPOSTO - V_VRIMPOSTOST;
   
                     IF (V_IDCONTCONFORIG = 'N') THEN
                        UPDATE ITEMPRODUTO
                           SET VRBRUTITEM = VRBRUTITEM + V_VRIMPOSTO,
                               VRCONTITEM = VRCONTITEM + V_VRIMPOSTO
                         WHERE CDFILIAL = P_FILIAL
                           AND NRLANCTONF = P_LANCTONF
                           AND NRSEQITPROD = C_PRODUTO.NRSEQITPROD;
                     END IF;
   
                  END IF;
               END IF;
            END IF;
         END IF;
      END LOOP;

      IF V_IDOPERDEVONF = w_S THEN
         V_SEQUIMPOSTNF := w_01;

         DELETE ITEMPRODUTO
         WHERE (CDFILIAL   = P_FILIAL)   AND
               (NRLANCTONF = P_LANCTONF) AND
               (QTITEMPROD = 0);

         DELETE IMPOSNFTOT
         WHERE (CDFILIAL   = P_FILIAL) AND
               (NRLANCTONF = P_LANCTONF);

         --TOTALIZAÇÃO DOS IMPOSTOS
         FOR C_IMPOSNFTOT IN (SELECT IT.CDIMPOSTO
                              FROM ITEMPROIMPOS IT
                              WHERE (IT.CDFILIAL   = P_FILIAL) AND
                                    (IT.NRLANCTONF = P_LANCTONF)
                              GROUP BY IT.CDIMPOSTO) LOOP

            V_IMPOSTOIT  := 0;
            V_BASECALCIT := 0;

            SELECT NVL(SUM(IT.VRIMPOSTOIT),0), 
                   NVL(SUM(IT.VRBASECALCIT),0),
                   NVL(SUM(IT.VRADICFECP),0)
            INTO   V_IMPOSTOIT,
                   V_BASECALCIT,
                   V_VRADICFECPNFTOT
            FROM ITEMPROIMPOS IT, IMPOSTO I
            WHERE (IT.CDFILIAL   = P_FILIAL)               AND
                  (IT.NRLANCTONF = P_LANCTONF)             AND
                  (IT.CDIMPOSTO  = C_IMPOSNFTOT.CDIMPOSTO) AND
                  (IT.CDIMPOSTO  = I.CDIMPOSTO);

            V_ICMS := 'N';
            FOR C_ICMS IN (SELECT CDIMPOSTO
                             FROM IMPOSTONFE N, IMPOSTO I
                            WHERE N.CDIMPOSTONFE = I.CDIMPOSTONFE
                              AND N.CDIMPOSTONFE = '00'
                              AND I.CDIMPOSTO = C_IMPOSNFTOT.CDIMPOSTO)
            LOOP
               V_ICMS := 'S';
            END LOOP;

            IF ((V_IDSISTEMA = 'VND') OR (V_IDSISTEMA = 'PDV')) AND (V_ICMS = 'S') THEN
               INSERT INTO IMPOSNFTOT
                  (CDFILIAL, NRLANCTONF, CDIMPOSTO, VRTOTIMPONF, VRTOTBCALCNF,
                   VRADICFECP)
               VALUES 
                  (P_FILIAL, P_LANCTONF, C_IMPOSNFTOT.CDIMPOSTO, TRUNC(V_IMPOSTOIT ,V_NRDECITOTANF), TRUNC(V_BASECALCIT,V_NRDECITOTANF),
                   V_VRADICFECPNFTOT);
            ELSE
               INSERT INTO IMPOSNFTOT
                  (CDFILIAL, NRLANCTONF, CDIMPOSTO, VRTOTIMPONF, VRTOTBCALCNF,
                   VRADICFECP)
               VALUES
                  (P_FILIAL, P_LANCTONF, C_IMPOSNFTOT.CDIMPOSTO, ROUND(V_IMPOSTOIT ,V_NRDECITOTANF), ROUND(V_BASECALCIT,V_NRDECITOTANF),
                   V_VRADICFECPNFTOT);
            END IF;

         END LOOP;

         DELETE IMPOSTONF
         WHERE (CDFILIAL   = P_FILIAL) AND
               (NRLANCTONF = P_LANCTONF);

         FOR C_ITEMNOTAFISC IN (SELECT CDFILIALIT, NRLANCTONFIT
                                FROM ITEMNOTAFISC
                                WHERE CDFILIAL   = P_FILIAL AND
                                      NRLANCTONF = P_LANCTONF) LOOP

            SELECT SUM(VRTOTAITEM - VRDESCITEM) AS VRLIQUORIG
            INTO   V_VRLIQUORIG
            FROM ITEMPRODUTO I
            WHERE CDFILIAL    = C_ITEMNOTAFISC.CDFILIALIT AND
                  NRLANCTONF  = C_ITEMNOTAFISC.NRLANCTONFIT;

            IF V_VRLIQUORIG = 0 THEN
               V_VRFATOCONV := 0;
            ELSE
               V_VRFATOCONV := V_LIQUIDO / V_VRLIQUORIG;
            END IF;

            /*IMPOSTOS DE CORPO DA NOTA DE ORIGEM*/
            FOR C_IMPOSNFTOT IN (SELECT IT.CDIMPOSTO, IT.VRTOTIMPONF, IT.VRTOTBCALCNF
                                 FROM IMPOSNFTOT IT, IMPOSTO IP
                                 WHERE IT.CDFILIAL   = C_ITEMNOTAFISC.CDFILIALIT   AND
                                       IT.NRLANCTONF = C_ITEMNOTAFISC.NRLANCTONFIT AND
                                       IT.CDIMPOSTO  = IP.CDIMPOSTO AND
                                       IP.IDPRODNOTA = w_C) LOOP

               SELECT NVL(MAX(IDUTMUNIORIG),'N')
                 INTO V_IDUTMUNIORIG
                 FROM IMPOSTO
                WHERE CDIMPOSTO = C_IMPOSNFTOT.CDIMPOSTO;

               IF ((V_IDUTMUNIORIG = 'O') OR (V_IDUTMUNIORIG = 'N')) THEN
                  CONSULTA_ALIQUOTA(C_IMPOSNFTOT.CDIMPOSTO, w_S, P_EMPRESA, '', P_INSCESTA, V_PAISORIG,
                                    V_ESTAORIG, V_PAISDEST, V_ESTADEST, V_MUNIORIG, V_LIQUIITEM, P_INIVALID, P_FILIAL, P_LANCTONF, V_CDGRUPOFISC, P_TIPOOPER);
               ELSE
                  CONSULTA_ALIQUOTA(C_IMPOSNFTOT.CDIMPOSTO, w_S, P_EMPRESA, '', P_INSCESTA, V_PAISORIG,
                                    V_ESTAORIG, V_PAISDEST, V_ESTADEST, V_MUNIDEST, V_LIQUIITEM, P_INIVALID, P_FILIAL, P_LANCTONF, V_CDGRUPOFISC, P_TIPOOPER);
               END IF;

               SELECT MAX(NRALIQTEMP), MAX(VRPARDEDTMP), MAX(VRPREDBCTMP), MAX(VRALIQUTMP), NVL(MAX(IDTRIMPSTTMP), w_0), MAX(CDTIPOOPERTMP)
                 INTO   V_NRALIQTEMP,    V_PARDEDTMP,      V_PREDBCTMP,      V_ALIQUTMP,      V_TRATIMPST, V_CDTIPOOPER
                 FROM ALIQTEMP
                WHERE (NRALIQTEMP = V_ALIQTEMP);

               IF ((V_NRALIQTEMP IS NOT NULL) AND (V_CDTIPOOPER IS NOT NULL) AND (V_ESTORNOCANC <> w_S)) THEN
                  IF (V_ALIQUTMP IS NULL) THEN
                     V_ALIQUTMP := 0;
                  END IF;
                  V_PRODUENCARGO := 0;

                  SELECT SUM(VRITEMENCA) AS VRSOMAITEM
                    INTO   V_SOMAITEM
                    FROM ITEMENCARGO IE, ENCARGO EN, BASECALC BC
                   WHERE (IE.CDFILIAL   = P_FILIAL)
                     AND (IE.NRLANCTONF = P_LANCTONF)
                     AND (EN.CDENCARGO  = IE.CDENCARGO)
                     AND (BC.CDENCARGO  = IE.CDENCARGO)
                     AND (BC.CDIMPOSTO  = C_IMPOSNFTOT.CDIMPOSTO)
                     AND (EN.IDENCARGO  = w_A);

                  SELECT SUM(VRITEMENCA) AS VRDESCITEM
                    INTO   V_DESCITEM
                    FROM ITEMENCARGO IE, ENCARGO EN, BASECALC BC
                   WHERE (IE.CDFILIAL   = P_FILIAL)
                     AND (IE.NRLANCTONF = P_LANCTONF)
                     AND (EN.CDENCARGO  = IE.CDENCARGO)
                     AND (BC.CDENCARGO  = IE.CDENCARGO)
                     AND (BC.CDIMPOSTO  = C_IMPOSNFTOT.CDIMPOSTO)
                     AND (EN.IDENCARGO  = w_D);

                  IF V_SOMAITEM IS NULL THEN
                     V_SOMAITEM := 0;
                  END IF;

                  IF V_DESCITEM IS NULL THEN
                     V_DESCITEM := 0;
                  END IF;

                  IF (V_ALIQUTMP IS NULL) THEN
                     V_ALIQUTMP := 0;
                  END IF;

                  IF (V_PREDBCTMP IS NULL) THEN
                     V_PREDBCTMP := 0;
                  END IF;

                  IF (V_PARDEDTMP IS NULL) THEN
                     V_PARDEDTMP := 0;
                  END IF;

                  V_PRODUENCARGO := V_SOMAITEM - V_DESCITEM;

                  V_TAXABASECALC := (100 - V_PREDBCTMP)/100;
                  V_TAXAALIQUOTA := (V_ALIQUTMP/100);
                  V_BASECALCIT   := (V_LIQUIDO + V_PRODUENCARGO) * V_TAXABASECALC;

                  V_CONTIMPO     := V_BASECALCIT;
                  V_IMPOSTOIT    := (V_BASECALCIT * V_TAXAALIQUOTA) - V_PARDEDTMP;

                  IF V_BASECALCIT < 0 THEN
                     V_BASECALCIT := 0;
                  END IF;

                  V_CONTABCALC := (V_LIQUIDO + V_PRODUENCARGO) - ((V_LIQUIDO + V_PRODUENCARGO) * V_TAXABASECALC);
                  V_PERDBCALC  := 100 - V_PREDBCTMP;

                  IF V_IMPOSTOIT < 0 THEN
                     V_IMPOSTOIT := 0;
                  END IF;

                  V_ICMS := 'N';
                  FOR C_ICMS IN (SELECT CDIMPOSTO
                                   FROM IMPOSTONFE N, IMPOSTO I
                                  WHERE N.CDIMPOSTONFE = I.CDIMPOSTONFE
                                    AND N.CDIMPOSTONFE = '00'
                                    AND I.CDIMPOSTO = C_IMPOSNFTOT.CDIMPOSTO)
                  LOOP
                     V_ICMS := 'S';
                  END LOOP;

                  IF ((V_IDSISTEMA = 'VND') OR (V_IDSISTEMA = 'PDV')) AND (V_ICMS = 'S') THEN
                     INSERT INTO IMPOSNFTOT(CDFILIAL, NRLANCTONF, CDIMPOSTO, VRTOTIMPONF, VRTOTBCALCNF)
                                       VALUES (P_FILIAL, P_LANCTONF, C_IMPOSNFTOT.CDIMPOSTO, TRUNC(V_IMPOSTOIT ,V_NRDECITOTANF), TRUNC(V_BASECALCIT,V_NRDECITOTANF));
                  ELSE
                     INSERT INTO IMPOSNFTOT(CDFILIAL, NRLANCTONF, CDIMPOSTO, VRTOTIMPONF, VRTOTBCALCNF)
                                       VALUES (P_FILIAL, P_LANCTONF, C_IMPOSNFTOT.CDIMPOSTO, ROUND(V_IMPOSTOIT ,V_NRDECITOTANF), ROUND(V_BASECALCIT,V_NRDECITOTANF));
                  END IF;

               ELSE
                  V_IMPOSTOIT  := (C_IMPOSNFTOT.VRTOTIMPONF * V_VRFATOCONV);
                  V_BASECALCIT := (C_IMPOSNFTOT.VRTOTBCALCNF * V_VRFATOCONV);
                  V_ALIQUTMP   := NULL;
                  V_UTIBB      := 'N';

                  --integração fiscal especifica com Compass_Argentina atraves da importação de aliquota do imposto IBB
                  --A aliquota de imposto 03(ibb) sera cadastrada na tabela paramintegraibb e tera prioridade sobre o
                  -- cadastro de aliquota realizado em sistema
                  /*IF C_IMPOSNFTOT.CDIMPOSTO = '03' THEN
                     IF V_IDORIGDESTNF = 'C' THEN

                        V_DTVINGENTE := NVL(V_DTINIREFEFAT, P_INIVALID);

                        SELECT NVL(MAX(VRALIQUOTAIBB),NULL)
                        INTO   V_ALIQUTMP
                        FROM PARAMINTEGRAIBB
                        WHERE CDCLIENTE = P_CLIENTE AND
                              V_DTVINGENTE BETWEEN DTVIGINICIALIBB AND DTVIGFINALIBB;

                        IF V_ALIQUTMP IS NOT NULL THEN
                           V_UTIBB := 'S';
                        END IF;
                     END IF;
                  END IF;

                  IF V_UTIBB = 'S' THEN
                     INSERT INTO IMPOSNFTOT(CDFILIAL, NRLANCTONF, CDIMPOSTO, VRTOTIMPONF, VRTOTBCALCNF)
                                    VALUES (P_FILIAL, P_LANCTONF, C_IMPOSNFTOT.CDIMPOSTO, ROUND((V_LIQUIDO * (V_ALIQUTMP/100))  ,V_NRDECITOTANF), ROUND(V_LIQUIDO,V_NRDECITOTANF));
                  ELSE*/
                     V_ICMS := 'N';
                     FOR C_ICMS IN (SELECT CDIMPOSTO
                                      FROM IMPOSTONFE N, IMPOSTO I
                                     WHERE N.CDIMPOSTONFE = I.CDIMPOSTONFE
                                       AND N.CDIMPOSTONFE = '00'
                                       AND I.CDIMPOSTO = C_IMPOSNFTOT.CDIMPOSTO)
                      LOOP
                         V_ICMS := 'S';
                      END LOOP;

                     IF ((V_IDSISTEMA = 'VND') OR (V_IDSISTEMA = 'PDV')) AND (V_ICMS = 'S') THEN
                        INSERT INTO IMPOSNFTOT(CDFILIAL, NRLANCTONF, CDIMPOSTO, VRTOTIMPONF, VRTOTBCALCNF)
                                       VALUES (P_FILIAL, P_LANCTONF, C_IMPOSNFTOT.CDIMPOSTO, TRUNC(V_IMPOSTOIT ,V_NRDECITOTANF), TRUNC(V_BASECALCIT,V_NRDECITOTANF));
                     ELSE
                        INSERT INTO IMPOSNFTOT(CDFILIAL, NRLANCTONF, CDIMPOSTO, VRTOTIMPONF, VRTOTBCALCNF)
                                       VALUES (P_FILIAL, P_LANCTONF, C_IMPOSNFTOT.CDIMPOSTO, ROUND(V_IMPOSTOIT ,V_NRDECITOTANF), ROUND(V_BASECALCIT,V_NRDECITOTANF));
                     END IF;

                  --END IF;
               END IF;
               DELETE ALIQTEMP
               WHERE NRALIQTEMP = V_ALIQTEMP;
            END LOOP;

            FOR C_IMPOSTONF IN (SELECT IT.CDIMPOSTO, IT.NRIMPOSNF, IT.VRCONTABILNF, IT.VRPERREDBCNF, IT.VRBASECALCNF,
                                       IT.VRALIQNF, IT.VRPARDEDNF, IT.VRIMPOSTONF, IT.CDFISCALNF, IT.CDSITUTRIBNF,
                                       IT.CDFISCOPERNF, IT.CDSUFXCFOPNF, IDTRIMPOSTNF, IT.CDSITUTRIBIMNFE, IP.IDIMPORECUP,
									                     IT.CDTPCREDPICONF, IT.CDNATUBCALPCNF, IT.IDMOTDESONERANF
                                FROM IMPOSTONF IT, IMPOSTO IP
                                WHERE IT.CDFILIAL   = C_ITEMNOTAFISC.CDFILIALIT   AND
                                      IT.NRLANCTONF = C_ITEMNOTAFISC.NRLANCTONFIT AND
                                      IT.CDIMPOSTO  = IP.CDIMPOSTO                AND
                                      IP.IDPRODNOTA = w_C) LOOP
               /*VERIFICA CST POR IMPOSTO*/
               V_IMPOICMS := NULL;
               V_CDGRUPOFISCAUX := NULL;

               SELECT MAX(G.CDGRUPOFISC)
                 INTO V_CDGRUPOFISCAUX
                 FROM GRUPOFISCIMPFIL G,
                      (SELECT CDFILIEMIT AS CDFILIAL
                         FROM NOTAFISCAL
                        WHERE CDFILIAL = P_FILIAL
                              AND NRLANCTONF = P_LANCTONF) F
                WHERE G.CDFILIAL = F.CDFILIAL
                  AND NOT G.CDGRUPOFISC IS NULL
                  AND G.CDIMPOSTO = C_IMPOSTONF.CDIMPOSTO;
               IF V_IDORIGDESTNF = 'C' THEN
                  SELECT NVL(MAX(G.CDGRUPOFISC), V_CDGRUPOFISCAUX)
                    INTO V_CDGRUPOFISCAUX
                    FROM GRFISIMPIECLIE G,
                         (SELECT CDCLIENTE
                            FROM NOTAFISCAL
                           WHERE CDFILIAL = P_FILIAL
                             AND NRLANCTONF = P_LANCTONF) N
                   WHERE G.CDCLIENTE = N.CDCLIENTE
                     AND G.CDEMPRESA = P_EMPRESA
                     AND G.CDINSCESTA = P_INSCESTA
                     AND NOT G.CDGRUPOFISC IS NULL
                     AND G.CDIMPOSTO = C_IMPOSTONF.CDIMPOSTO;
               ELSE
                  SELECT NVL(MAX(G.CDGRUPOFISC), V_CDGRUPOFISCAUX)
                    INTO V_CDGRUPOFISCAUX
                    FROM GRFISIMPIEFORN G,
                        (SELECT CDFORNECED
                           FROM NOTAFISCAL
                          WHERE CDFILIAL = P_FILIAL
                            AND NRLANCTONF = P_LANCTONF) N
                   WHERE G.CDFORNECED = N.CDFORNECED
                     AND G.CDEMPRESA = P_EMPRESA
                     AND G.CDINSCESTA = P_INSCESTA
                     AND NOT G.CDGRUPOFISC IS NULL
                     AND G.CDIMPOSTO = C_IMPOSTONF.CDIMPOSTO;
               END IF;

               IF V_CDGRUPOFISCAUX IS NULL THEN
                  CONSULTA_CST_NFE(w_S, P_EMPRESA, '', P_INSCESTA, P_TIPOOPER, V_CDGRUPOFISC,C_IMPOSTONF.CDIMPOSTO, V_IDINTEREST, V_IDINTERNA, P_FILIAL, P_LANCTONF, '', V_CDSITTRIBTMP, V_IDMODBCNFE, V_IDMODBCSTNFE, V_CDTPCRPICOSTNFE, V_CDNATUBCPCSTNFE, V_IDMOTIDESSTNFE);
               ELSE
                  CONSULTA_CST_NFE(w_S, P_EMPRESA, '', P_INSCESTA, P_TIPOOPER, V_CDGRUPOFISCAUX,C_IMPOSTONF.CDIMPOSTO, V_IDINTEREST, V_IDINTERNA, P_FILIAL, P_LANCTONF, '', V_CDSITTRIBTMP, V_IDMODBCNFE, V_IDMODBCSTNFE, V_CDTPCRPICOSTNFE, V_CDNATUBCPCSTNFE, V_IDMOTIDESSTNFE);
               END IF;

               IF (C_IMPOSTONF.CDSITUTRIBIMNFE IS NULL) THEN
                  V_CDSITUTRIBNFE := V_CDSITTRIBTMP;
               ELSE
                  V_CDSITUTRIBNFE := C_IMPOSTONF.CDSITUTRIBIMNFE;
               END IF;

               IF (C_IMPOSTONF.CDTPCREDPICONF IS NULL) THEN
                  V_CDTPCRPICOSTNFEIT := V_CDTPCRPICOSTNFE;
               ELSE
                  V_CDTPCRPICOSTNFEIT := C_IMPOSTONF.CDTPCREDPICONF;
               END IF;

               IF (C_IMPOSTONF.CDNATUBCALPCNF IS NULL) THEN
                  V_CDNATUBCPCSTNFEIT := V_CDNATUBCPCSTNFE;
               ELSE
                  V_CDNATUBCPCSTNFEIT := C_IMPOSTONF.CDNATUBCALPCNF;
               END IF;

               IF (C_IMPOSTONF.IDMOTDESONERANF IS NULL) THEN
                  V_IDMOTIDESSTNFE := V_IDMOTIDESSTNFE;
               ELSE
                  V_IDMOTIDESSTNFE := C_IMPOSTONF.IDMOTDESONERANF;
               END IF;


               SELECT NVL(MAX(IDUTMUNIORIG),'N')
                 INTO V_IDUTMUNIORIG
                 FROM IMPOSTO
                WHERE CDIMPOSTO = C_IMPOSTONF.CDIMPOSTO;

               IF ((V_IDUTMUNIORIG = 'O') OR (V_IDUTMUNIORIG = 'N')) THEN
                  CONSULTA_ALIQUOTA(C_IMPOSTONF.CDIMPOSTO, w_S, P_EMPRESA, '', P_INSCESTA, V_PAISORIG,
                                    V_ESTAORIG, V_PAISDEST, V_ESTADEST, V_MUNIORIG, V_LIQUIITEM, P_INIVALID, P_FILIAL, P_LANCTONF, V_CDGRUPOFISC,P_TIPOOPER);
               ELSE
                  CONSULTA_ALIQUOTA(C_IMPOSTONF.CDIMPOSTO, w_S, P_EMPRESA, '', P_INSCESTA, V_PAISORIG,
                                    V_ESTAORIG, V_PAISDEST, V_ESTADEST, V_MUNIDEST, V_LIQUIITEM, P_INIVALID, P_FILIAL, P_LANCTONF, V_CDGRUPOFISC, P_TIPOOPER);
               END IF;

               SELECT MAX(NRALIQTEMP), MAX(VRPARDEDTMP), MAX(VRPREDBCTMP), MAX(VRALIQUTMP), NVL(MAX(IDTRIMPSTTMP), w_0), MAX(CDTIPOOPERTMP)
                 INTO   V_NRALIQTEMP,    V_PARDEDTMP,      V_PREDBCTMP,      V_ALIQUTMP,      V_TRATIMPST, V_CDTIPOOPER
                 FROM ALIQTEMP
                WHERE (NRALIQTEMP = V_ALIQTEMP);

               IF ((V_NRALIQTEMP IS NOT NULL) AND (V_CDTIPOOPER IS NOT NULL)) THEN
                  IF (V_ALIQUTMP IS NULL) THEN
                     V_ALIQUTMP := 0;
                  END IF;
                  V_PRODUENCARGO := 0;

                  SELECT SUM(VRITEMENCA) AS VRSOMAITEM
                    INTO   V_SOMAITEM
                    FROM ITEMENCARGO IE, ENCARGO EN, BASECALC BC
                   WHERE (IE.CDFILIAL   = P_FILIAL)
                     AND (IE.NRLANCTONF = P_LANCTONF)
                     AND (EN.CDENCARGO  = IE.CDENCARGO)
                     AND (BC.CDENCARGO  = IE.CDENCARGO)
                     AND (BC.CDIMPOSTO  = C_IMPOSTONF.CDIMPOSTO)
                     AND (EN.IDENCARGO  = w_A);

                  SELECT SUM(VRITEMENCA) AS VRDESCITEM
                    INTO   V_DESCITEM
                    FROM ITEMENCARGO IE, ENCARGO EN, BASECALC BC
                   WHERE (IE.CDFILIAL   = P_FILIAL)
                     AND (IE.NRLANCTONF = P_LANCTONF)
                     AND (EN.CDENCARGO  = IE.CDENCARGO)
                     AND (BC.CDENCARGO  = IE.CDENCARGO)
                     AND (BC.CDIMPOSTO  = C_IMPOSTONF.CDIMPOSTO)
                     AND (EN.IDENCARGO  = w_D);

                  IF V_SOMAITEM IS NULL THEN
                     V_SOMAITEM := 0;
                  END IF;

                  IF V_DESCITEM IS NULL THEN
                     V_DESCITEM := 0;
                  END IF;

                  IF (V_ALIQUTMP IS NULL) THEN
                     V_ALIQUTMP := 0;
                  END IF;

                  IF (V_PREDBCTMP IS NULL) THEN
                     V_PREDBCTMP := 0;
                  END IF;

                  IF (V_PARDEDTMP IS NULL) THEN
                     V_PARDEDTMP := 0;
                  END IF;

                  V_PRODUENCARGO := V_SOMAITEM - V_DESCITEM;

                  V_TAXABASECALC := (100 - V_PREDBCTMP)/100;
                  V_TAXAALIQUOTA := (V_ALIQUTMP/100);
                  V_BASECALCIT   := (V_LIQUIDO + V_PRODUENCARGO) * V_TAXABASECALC;

                  V_CONTIMPO     := V_BASECALCIT;
                  V_IMPOSTOIT    := (V_BASECALCIT * V_TAXAALIQUOTA) - V_PARDEDTMP;

                  IF V_BASECALCIT < 0 THEN
                     V_BASECALCIT := 0;
                  END IF;

                  V_CONTABCALC := (V_LIQUIDO + V_PRODUENCARGO) - ((V_LIQUIDO + V_PRODUENCARGO) * V_TAXABASECALC);
                  V_PERDBCALC  := 100 - V_PREDBCTMP;

                  IF V_IMPOSTOIT < 0 THEN
                     V_IMPOSTOIT := 0;
                  END IF;

                  IF (C_IMPOSTONF.IDIMPORECUP = w_S) OR (C_IMPOSTONF.IDIMPORECUP <> w_S AND V_ALIQUTMP <> 0) THEN
                     IF ((C_IMPOSTONF.IDIMPORECUP = w_S) AND (C_IMPOSTONF.CDFISCALNF <> w_1)) THEN
                        V_BASECALCIT := 0;
                        V_ALIQUTMP   := 0;
                        V_IMPOSTOIT  := 0;
                        V_PREDBCTMP  := 0;
                        V_PARDEDTMP  := 0;
                     END IF;

                     V_ICMS := 'N';
                     FOR C_ICMS IN (SELECT CDIMPOSTO
                                      FROM IMPOSTONFE N, IMPOSTO I
                                     WHERE N.CDIMPOSTONFE = I.CDIMPOSTONFE
                                       AND N.CDIMPOSTONFE = '00'
                                       AND I.CDIMPOSTO = C_IMPOSTONF.CDIMPOSTO)
                     LOOP
                        V_ICMS := 'S';
                     END LOOP;

                     IF ((V_IDSISTEMA = 'VND') OR (V_IDSISTEMA = 'PDV')) AND (V_ICMS = 'S') THEN
                        INSERT INTO IMPOSTONF(
                           CDFILIAL, NRLANCTONF, CDIMPOSTO, NRIMPOSNF, VRCONTABILNF, VRPERREDBCNF, VRBASECALCNF,
                           VRALIQNF, VRPARDEDNF, VRIMPOSTONF, CDFISCALNF, IDTRIMPOSTNF, CDSITUTRIBIMNFE, CDTPCREDPICONF, CDNATUBCALPCNF, IDMOTDESONERANF)
                        VALUES(
                           P_FILIAL, P_LANCTONF, C_IMPOSTONF.CDIMPOSTO, C_IMPOSTONF.NRIMPOSNF, TRUNC(V_CONTIMPO,2), V_PREDBCTMP,
                           TRUNC(V_BASECALCIT,2), V_ALIQUTMP, TRUNC(V_PARDEDTMP,2), TRUNC(V_IMPOSTOIT,2), C_IMPOSTONF.CDSUFXCFOPNF, C_IMPOSTONF.IDTRIMPOSTNF, V_CDSITTRIBTMP, V_CDTPCRPICOSTNFEIT, V_CDNATUBCPCSTNFEIT, V_IDMOTIDESSTNFE);
                     ELSE
                        INSERT INTO IMPOSTONF(
                           CDFILIAL, NRLANCTONF, CDIMPOSTO, NRIMPOSNF, VRCONTABILNF, VRPERREDBCNF, VRBASECALCNF,
                           VRALIQNF, VRPARDEDNF, VRIMPOSTONF, CDFISCALNF, IDTRIMPOSTNF, CDSITUTRIBIMNFE, CDTPCREDPICONF, CDNATUBCALPCNF, IDMOTDESONERANF)
                        VALUES(
                           P_FILIAL, P_LANCTONF, C_IMPOSTONF.CDIMPOSTO, C_IMPOSTONF.NRIMPOSNF, ROUND(V_CONTIMPO,2), V_PREDBCTMP,
                           V_BASECALCIT, V_ALIQUTMP, V_PARDEDTMP, V_IMPOSTOIT, C_IMPOSTONF.CDSUFXCFOPNF, C_IMPOSTONF.IDTRIMPOSTNF, V_CDSITTRIBTMP, V_CDTPCRPICOSTNFEIT, V_CDNATUBCPCSTNFEIT, V_IDMOTIDESSTNFE);
                     END IF;

                     IF ((C_IMPOSTONF.IDIMPORECUP = w_S) AND (V_PREDBCTMP > 0) AND (C_IMPOSTONF.CDFISCALNF = w_1)) THEN
                        INSERT INTO IMPOSTONF(
                           CDFILIAL, NRLANCTONF, CDIMPOSTO, NRIMPOSNF, VRCONTABILNF, VRPERREDBCNF, VRBASECALCNF,
                           VRALIQNF, VRPARDEDNF, VRIMPOSTONF, CDFISCALNF, CDSITUTRIBIMNFE, CDTPCREDPICONF, CDNATUBCALPCNF, IDMOTDESONERANF)
                        VALUES(
                           P_FILIAL, P_LANCTONF, C_IMPOSTONF.CDIMPOSTO, C_IMPOSTONF.NRIMPOSNF, V_CONTABCALC, V_PERDBCALC,
                           0, 0, V_PARDEDTMP, 0, w_2, V_CDSITTRIBTMP, V_CDTPCRPICOSTNFEIT, V_CDNATUBCPCSTNFEIT, V_IDMOTIDESSTNFE);
                     END IF;
                  END IF;

                  DELETE ALIQTEMP
                  WHERE NRALIQTEMP = V_ALIQTEMP;
               ELSE
                  V_ALIQUTMP   := NULL;
                  V_UTIBB      := 'N';
                  --integração fiscal especifica com Compass_Argentina atraves da importação de aliquota do imposto IBB
                  --A aliquota de imposto 03(ibb) sera cadastrada na tabela paramintegraibb e tera prioridade sobre o
                  -- cadastro de aliquota realizado em sistema
                  /*IF C_IMPOSTONF.CDIMPOSTO = '03' THEN
                     IF V_IDORIGDESTNF = 'C' THEN
                        V_DTVINGENTE := NVL(V_DTINIREFEFAT, P_INIVALID);

                        SELECT NVL(MAX(VRALIQUOTAIBB),NULL)
                        INTO   V_ALIQUTMP
                        FROM PARAMINTEGRAIBB
                        WHERE CDCLIENTE = P_CLIENTE AND
                              V_DTVINGENTE BETWEEN DTVIGINICIALIBB AND DTVIGFINALIBB;

                        IF V_ALIQUTMP IS NOT NULL THEN
                           V_UTIBB := 'S';
                        END IF;
                     END IF;
                  END IF;*/

                  IF V_UTIBB = 'S' THEN
                     V_ICMS := 'N';
                     FOR C_ICMS IN (SELECT CDIMPOSTO
                                      FROM IMPOSTONFE N, IMPOSTO I
                                     WHERE N.CDIMPOSTONFE = I.CDIMPOSTONFE
                                       AND N.CDIMPOSTONFE = '00'
                                       AND I.CDIMPOSTO = C_IMPOSTONF.CDIMPOSTO)
                     LOOP
                        V_ICMS := 'S';
                     END LOOP;

                     IF ((V_IDSISTEMA = 'VND') OR (V_IDSISTEMA = 'PDV')) AND (V_ICMS = 'S') THEN
                        INSERT INTO IMPOSTONF(
                           CDFILIAL, NRLANCTONF, CDIMPOSTO, NRIMPOSNF, VRCONTABILNF, VRPERREDBCNF, VRBASECALCNF,
                           VRALIQNF, VRPARDEDNF, VRIMPOSTONF, CDFISCALNF, CDSITUTRIBNF, CDFISCOPERNF, CDSUFXCFOPNF, IDTRIMPOSTNF, CDSITUTRIBIMNFE, CDTPCREDPICONF, CDNATUBCALPCNF, IDMOTDESONERANF)
                        VALUES(P_FILIAL, P_LANCTONF, C_IMPOSTONF.CDIMPOSTO, C_IMPOSTONF.NRIMPOSNF,
                               V_LIQUIDO, 0, V_LIQUIDO,
                               V_ALIQUTMP, 0, TRUNC((V_LIQUIDO * (V_ALIQUTMP/100)),2), C_IMPOSTONF.CDFISCALNF,
                               C_IMPOSTONF.CDSITUTRIBNF, C_IMPOSTONF.CDFISCOPERNF, C_IMPOSTONF.CDSUFXCFOPNF, C_IMPOSTONF.IDTRIMPOSTNF, C_IMPOSTONF.CDSITUTRIBIMNFE, V_CDTPCRPICOSTNFEIT, V_CDNATUBCPCSTNFEIT, V_IDMOTIDESSTNFE);
                     ELSE
                        INSERT INTO IMPOSTONF(
                           CDFILIAL, NRLANCTONF, CDIMPOSTO, NRIMPOSNF, VRCONTABILNF, VRPERREDBCNF, VRBASECALCNF,
                           VRALIQNF, VRPARDEDNF, VRIMPOSTONF, CDFISCALNF, CDSITUTRIBNF, CDFISCOPERNF, CDSUFXCFOPNF, IDTRIMPOSTNF, CDSITUTRIBIMNFE, CDTPCREDPICONF, CDNATUBCALPCNF, IDMOTDESONERANF)
                        VALUES(P_FILIAL, P_LANCTONF, C_IMPOSTONF.CDIMPOSTO, C_IMPOSTONF.NRIMPOSNF,
                               V_LIQUIDO, 0, V_LIQUIDO,
                               V_ALIQUTMP, 0, (V_LIQUIDO * (V_ALIQUTMP/100)), C_IMPOSTONF.CDFISCALNF,
                               C_IMPOSTONF.CDSITUTRIBNF, C_IMPOSTONF.CDFISCOPERNF, C_IMPOSTONF.CDSUFXCFOPNF, C_IMPOSTONF.IDTRIMPOSTNF, C_IMPOSTONF.CDSITUTRIBIMNFE, V_CDTPCRPICOSTNFEIT, V_CDNATUBCPCSTNFEIT, V_IDMOTIDESSTNFE);
                     END IF;
                  ELSE
                     V_ICMS := 'N';
                     FOR C_ICMS IN (SELECT CDIMPOSTO
                                      FROM IMPOSTONFE N, IMPOSTO I
                                     WHERE N.CDIMPOSTONFE = I.CDIMPOSTONFE
                                       AND N.CDIMPOSTONFE = '00'
                                       AND I.CDIMPOSTO = C_IMPOSTONF.CDIMPOSTO)
                     LOOP
                        V_ICMS := 'S';
                     END LOOP;

                     IF ((V_IDSISTEMA = 'VND') OR (V_IDSISTEMA = 'PDV')) AND (V_ICMS = 'S') THEN
                        INSERT INTO IMPOSTONF(
                           CDFILIAL, NRLANCTONF, CDIMPOSTO, NRIMPOSNF, VRCONTABILNF, VRPERREDBCNF, VRBASECALCNF,
                           VRALIQNF, VRPARDEDNF, VRIMPOSTONF, CDFISCALNF, CDSITUTRIBNF, CDFISCOPERNF, CDSUFXCFOPNF, IDTRIMPOSTNF, CDSITUTRIBIMNFE, CDTPCREDPICONF, CDNATUBCALPCNF, IDMOTDESONERANF)
                        VALUES(P_FILIAL, P_LANCTONF, C_IMPOSTONF.CDIMPOSTO, C_IMPOSTONF.NRIMPOSNF,
                               TRUNC((C_IMPOSTONF.VRCONTABILNF * V_VRFATOCONV),2), C_IMPOSTONF.VRPERREDBCNF, TRUNC((C_IMPOSTONF.VRBASECALCNF * V_VRFATOCONV),2),
                               C_IMPOSTONF.VRALIQNF, TRUNC((C_IMPOSTONF.VRPARDEDNF * V_VRFATOCONV),2), TRUNC((C_IMPOSTONF.VRIMPOSTONF * V_VRFATOCONV),2), C_IMPOSTONF.CDFISCALNF,
                               C_IMPOSTONF.CDSITUTRIBNF, C_IMPOSTONF.CDFISCOPERNF, C_IMPOSTONF.CDSUFXCFOPNF, C_IMPOSTONF.IDTRIMPOSTNF, C_IMPOSTONF.CDSITUTRIBIMNFE, V_CDTPCRPICOSTNFEIT, V_CDNATUBCPCSTNFEIT, V_IDMOTIDESSTNFE);
                     ELSE
                        INSERT INTO IMPOSTONF(
                           CDFILIAL, NRLANCTONF, CDIMPOSTO, NRIMPOSNF, VRCONTABILNF, VRPERREDBCNF, VRBASECALCNF,
                           VRALIQNF, VRPARDEDNF, VRIMPOSTONF, CDFISCALNF, CDSITUTRIBNF, CDFISCOPERNF, CDSUFXCFOPNF, IDTRIMPOSTNF, CDSITUTRIBIMNFE, CDTPCREDPICONF, CDNATUBCALPCNF, IDMOTDESONERANF)
                        VALUES(P_FILIAL, P_LANCTONF, C_IMPOSTONF.CDIMPOSTO, C_IMPOSTONF.NRIMPOSNF,
                               ROUND((C_IMPOSTONF.VRCONTABILNF * V_VRFATOCONV),2), C_IMPOSTONF.VRPERREDBCNF, (C_IMPOSTONF.VRBASECALCNF * V_VRFATOCONV),
                               C_IMPOSTONF.VRALIQNF, (C_IMPOSTONF.VRPARDEDNF * V_VRFATOCONV), (C_IMPOSTONF.VRIMPOSTONF * V_VRFATOCONV), C_IMPOSTONF.CDFISCALNF,
                               C_IMPOSTONF.CDSITUTRIBNF, C_IMPOSTONF.CDFISCOPERNF, C_IMPOSTONF.CDSUFXCFOPNF, C_IMPOSTONF.IDTRIMPOSTNF, C_IMPOSTONF.CDSITUTRIBIMNFE,  V_CDTPCRPICOSTNFEIT, V_CDNATUBCPCSTNFEIT, V_IDMOTIDESSTNFE);
                     END IF;

                  END IF;
                   V_SEQUIMPOSTNF := LPAD(RTRIM(TO_CHAR(TO_NUMBER(V_SEQUIMPOSTNF) + 1)),2,0);
               END IF;
               DELETE ALIQTEMP
               WHERE NRALIQTEMP = V_ALIQTEMP;
            END LOOP;
         END LOOP;

         DELETE FROM DADOSADIC
         WHERE CDFILIAL = P_FILIAL
           AND NRLANCTONF = P_LANCTONF
           AND DSDADOADIC LIKE 'Nota de Origem:%';   

         IF (V_IDCONTCONFORIG = 'N') THEN
            DELETE ITEMPROIMPOSORIG
             WHERE CDFILIAL   = P_FILIAL
               AND NRLANCTONF = P_LANCTONF;

            FOR C_IMPOSTOITENS IN (SELECT CDFILIAL,     NRLANCTONF,     NRSEQITPROD,     CDIMPOSTO,      NRITPROIMPOS,    CDFISCALIT,
                                          CDSITUTRIBIT, CDFISCOPERIT,   CDSUFXCFOPIT,    VRALIQITEM,     VRPERREDBCIT,    VRPARDEDIT,
                                          VRCONTITIMP,  VRBASECALCIT,   VRIMPOSTOIT,     IDERROSIMPIT,   IDAVISIMPIT,     CDSITUTRIBITNFE,
                                          IDMODBCITNFE, IDMODBCSTITNFE, CDTPCREDPICOITE, CDNATUBCALPCIT, IDMOTDESONERAIT, IDTRIMPSTII,
                                          CDDETALHEPROD, CDENQLEGALIPI, CDCEST,          CDBENEFFISCAL
                                     FROM ITEMPROIMPOS
                                    WHERE CDFILIAL   = P_FILIAL
                                      AND NRLANCTONF = P_LANCTONF) LOOP

               INSERT INTO ITEMPROIMPOSORIG(CDFILIAL,      NRLANCTONF,     NRSEQITPROD,     CDIMPOSTO,      NRITPROIMPOS,    CDFISCALIT,
                                            CDSITUTRIBIT,  CDFISCOPERIT,   CDSUFXCFOPIT,    VRALIQITEM,     VRPERREDBCIT,    VRPARDEDIT,
                                            VRCONTITIMP,   VRBASECALCIT,   VRIMPOSTOIT,     IDERROSIMPIT,   IDAVISIMPIT,     CDSITUTRIBITNFE,
                                            IDMODBCITNFE,  IDMODBCSTITNFE, CDTPCREDPICOITE, CDNATUBCALPCIT, IDMOTDESONERAIT, IDTRIMPSTII,
                                            CDDETALHEPROD, CDENQLEGALIPI,  CDCEST,          CDBENEFFISCAL)
                    VALUES (C_IMPOSTOITENS.CDFILIAL,      C_IMPOSTOITENS.NRLANCTONF,     C_IMPOSTOITENS.NRSEQITPROD,     C_IMPOSTOITENS.CDIMPOSTO,      C_IMPOSTOITENS.NRITPROIMPOS,    C_IMPOSTOITENS.CDFISCALIT,
                            C_IMPOSTOITENS.CDSITUTRIBIT,  C_IMPOSTOITENS.CDFISCOPERIT,   C_IMPOSTOITENS.CDSUFXCFOPIT,    C_IMPOSTOITENS.VRALIQITEM,     C_IMPOSTOITENS.VRPERREDBCIT,    C_IMPOSTOITENS.VRPARDEDIT,
                            C_IMPOSTOITENS.VRCONTITIMP,   C_IMPOSTOITENS.VRBASECALCIT,   C_IMPOSTOITENS.VRIMPOSTOIT,     C_IMPOSTOITENS.IDERROSIMPIT,   C_IMPOSTOITENS.IDAVISIMPIT,     C_IMPOSTOITENS.CDSITUTRIBITNFE,
                            C_IMPOSTOITENS.IDMODBCITNFE,  C_IMPOSTOITENS.IDMODBCSTITNFE, C_IMPOSTOITENS.CDTPCREDPICOITE, C_IMPOSTOITENS.CDNATUBCALPCIT, C_IMPOSTOITENS.IDMOTDESONERAIT, C_IMPOSTOITENS.IDTRIMPSTII,
                            C_IMPOSTOITENS.CDDETALHEPROD, C_IMPOSTOITENS.CDENQLEGALIPI,  C_IMPOSTOITENS.CDCEST,          C_IMPOSTOITENS.CDBENEFFISCAL);
            END LOOP;
         END IF;

         FOR C_ITEMNOTAFISC IN (SELECT IT.CDFILIALIT, IT.NRLANCTONFIT, NVL(N.NRNOTAFISCALELE, N.NRNOTAFISC) AS NRNOTA,
                                       TO_CHAR(N.DTEMISSAO,  'DD/MM/YYYY') AS DTEMISSAO, N.VRNOTAFISC
                             FROM ITEMNOTAFISC IT, NOTAFISCAL N
                             WHERE IT.CDFILIAL   = P_FILIAL
                               AND IT.NRLANCTONF = P_LANCTONF
                               AND IT.CDFILIALIT   = N.CDFILIAL
                               AND IT.NRLANCTONFIT = N.NRLANCTONF) LOOP

            INSERT INTO DADOSADIC(CDFILIAL, NRLANCTONF, NRDADOADIC, DSDADOADIC)
                           VALUES(P_FILIAL, P_LANCTONF, V_DADOADIC, 'Nota de Origem: '|| C_ITEMNOTAFISC.NRNOTA||' (Emissão: '|| C_ITEMNOTAFISC.DTEMISSAO||' Total: '||DECODE(SUBSTR(LTRIM(TO_CHAR(ROUND(C_ITEMNOTAFISC.VRNOTAFISC, 2), '9999999999999.99')), 1, 1), '.', '0'||LTRIM(TO_CHAR(ROUND(C_ITEMNOTAFISC.VRNOTAFISC, 2), '9999999999999.99')), LTRIM(TO_CHAR(ROUND(C_ITEMNOTAFISC.VRNOTAFISC, 2), '9999999999999.99')))|| ' )');
            V_DADOADIC := LPAD(RTRIM(TO_CHAR(TO_NUMBER(V_DADOADIC) + 1)),3,0);
         END LOOP;
      END IF;
-------------------
   ELSIF (P_TIPOOPER = w_03) THEN /*NOTA DE COMPLEMENTO*/

      FOR C_IMPOSITEMCOM IN (SELECT II.NRSEQITPROD,  II.CDIMPOSTO,     II.NRITPROIMPOS,   II.VRCONTITIMP,
                                    II.VRPERREDBCIT, II.VRBASECALCIT,  II.VRALIQITEM,     II.VRPARDEDIT,
                                    II.VRIMPOSTOIT,  II.CDFISCALIT,    I.IDUTVLRQTDEIMPO, II.CDSITUTRIBIT ,
                                    II.CDFISCOPERIT, II.VRPERMAJBCIT,  IT.CDPRODUTO,      IT.QTITEMPROD, 
                                    P.CDARVPROD,     II.CDENQLEGALIPI, II.CDCEST
                               FROM ITEMPROIMPOS II, IMPOSTO I, ITEMPRODUTO IT, PRODUTO P
                              WHERE (II.CDFILIAL   = P_FILIAL)
                                AND (II.NRLANCTONF = P_LANCTONF)
                                AND (II.NRITPROIMPOS = '1')
                                AND (II.CDIMPOSTO = I.CDIMPOSTO)
                                AND (P.CDPRODUTO  = IT.CDPRODUTO)
                                AND (II.CDFILIAL = IT.CDFILIAL)
                                AND (II.NRLANCTONF = IT.NRLANCTONF)
                                AND (II.NRSEQITPROD = IT.NRSEQITPROD)
                           ORDER BY II.NRSEQITPROD, II.CDIMPOSTO, II.NRITPROIMPOS) LOOP

         /*VERIFICA CSOSN POR IMPOSTO*/
         CONSULTA_CSOSN('S', P_EMPRESA, C_IMPOSITEMCOM.CDARVPROD, P_INSCESTA, P_TIPOOPER, P_FILIAL, P_LANCTONF, V_CDGRUPOFISC, V_IDINTEREST, V_CDFISCOPERSN);

         UPDATE ITEMPRODUTO
            SET CDFISCOPERSN  = V_CDFISCOPERSN
          WHERE CDFILIAL    = P_FILIAL
            AND NRLANCTONF  = P_LANCTONF
            AND NRSEQITPROD = C_IMPOSITEMCOM.NRSEQITPROD;

         IF (C_IMPOSITEMCOM.VRIMPOSTOIT = 0)  THEN
            IF (C_IMPOSITEMCOM.VRALIQITEM <> 0)  THEN

               V_TAXAALIQUOTA := (C_IMPOSITEMCOM.VRALIQITEM/100);
               V_TAXABASECALC := (100 - C_IMPOSITEMCOM.VRPERREDBCIT)/100;
               V_TAXABCSUBSTR := (100 + C_IMPOSITEMCOM.VRPERMAJBCIT)/100;

               SELECT MAX(VRTOTAITEM), MAX(QTITEMPROD)
                 INTO V_VRTOTAITEM, V_QTITEMPROD
                 FROM ITEMPRODUTO
                WHERE CDFILIAL = P_FILIAL
                  AND NRLANCTONF = P_LANCTONF
                  AND NRSEQITPROD = C_IMPOSITEMCOM.NRSEQITPROD;

               IF C_IMPOSITEMCOM.VRBASECALCIT > 0 THEN
                  V_BASECALCIT := C_IMPOSITEMCOM.VRBASECALCIT;
               ELSE
                  V_BASECALCIT := V_VRTOTAITEM * V_TAXABASECALC;
               END IF;

               V_PERDBCALC := 100 - C_IMPOSITEMCOM.VRPERREDBCIT;

               V_CONTABCALC  := V_VRTOTAITEM - (V_VRTOTAITEM * V_TAXABASECALC);

               IF C_IMPOSITEMCOM.VRPERMAJBCIT > 0 THEN

                  SELECT MAX(CDIMPOSTO)
                    INTO V_CDIMPOSTO
                    FROM IMPOSTO
                   WHERE CDIMPOSTRIB = C_IMPOSITEMCOM.CDIMPOSTO;

                  IF (V_CDIMPOSTO IS NOT NULL) THEN
                     V_BASECALCIT := (V_BASECALCIT * V_TAXABCSUBSTR);
                  ELSE
                     UPDATE ITEMPROIMPOS
                     SET VRPERMAJBCIT = 0
                    WHERE CDFILIAL = P_FILIAL
                      AND NRLANCTONF = P_LANCTONF
                      AND NRSEQITPROD = C_IMPOSITEMCOM.NRSEQITPROD
                      AND CDIMPOSTO = C_IMPOSITEMCOM.CDIMPOSTO;
                  END IF;
               END IF;

               /* ICMS-ST para nota fiscal de complento */

               V_CDIMPOSTRIB  := null;
               V_IDVRIMPSTRIB := null;
               /*IMPOSTO DE SUBSTITUICAO TRIBUTARIA*/
               FOR C_ICMSST IN (SELECT CDIMPOSTO
                                      FROM IMPOSTO
                                     WHERE CDIMPOSTRIB = C_IMPOSITEMCOM.CDIMPOSTO)
               LOOP
                  V_CDIMPOSTRIB := V_CDIMPOSTRIB||C_ICMSST.CDIMPOSTO||'_';
               END LOOP;

               IF V_CDIMPOSTRIB IS NOT NULL THEN
                  SELECT NVL(MAX(IDVRIMPSTRIB), 'N')
                    INTO V_IDVRIMPSTRIB
                    FROM ITEMPROIMPOS I, IMPOSTO II
                   WHERE (CDFILIAL     = P_FILIAL)
                     AND (NRLANCTONF   = P_LANCTONF)
                     AND (NRSEQITPROD  = C_IMPOSITEMCOM.NRSEQITPROD)
                     AND (INSTR(V_CDIMPOSTRIB,II.CDIMPOSTO||'_') > 0)
                     AND (I.CDIMPOSTO = II.CDIMPOSTO);

                  IF (NVL(V_IDVRIMPSTRIB,w_N) = w_N) THEN
                     V_VRIMPOSTOST := 0;
                  ELSE
                     Begin
                        SELECT NVL(MAX(VRIMPOSTOIT),0)
                        INTO   V_VRIMPOSTOST
                        FROM ITEMPROIMPOS I
                        WHERE (CDFILIAL     = P_FILIAL)                   AND
                              (NRLANCTONF   = P_LANCTONF)                 AND
                              (NRSEQITPROD  = C_IMPOSITEMCOM.NRSEQITPROD) AND
                              (INSTR(V_CDIMPOSTRIB,CDIMPOSTO||'_') > 0)  AND
                              (NRITPROIMPOS = w_1);
                     Exception
                        When No_Data_Found Then
                           V_VRIMPOSTOST := 0;
                     End;
                  END IF;
               END IF;
               /* ICMS-ST para nota fiscal de complento */


               IF (C_IMPOSITEMCOM.IDUTVLRQTDEIMPO = 'S') THEN
                  SELECT NVL(MAX(VRFATOCONVES), 1)
                    INTO V_VRFATOCONVES
                    FROM CONVPRODUTO
                   WHERE CDPRODUTO = C_IMPOSITEMCOM.CDPRODUTO;

                  IF (NVL(V_IDVRIMPSTRIB,w_N) = w_N) THEN
                     V_BASECALCTO  := (V_QTITEMPROD * V_VRFATOCONVES);
                     V_IMPOSTOIT   := ((V_QTITEMPROD * V_VRFATOCONVES) * C_IMPOSITEMCOM.VRALIQITEM) - C_IMPOSITEMCOM.VRPARDEDIT;
                  ELSE
                     V_BASECALCTO  := (V_QTITEMPROD * V_VRFATOCONVES);
                     V_IMPOSTOIT   := ((V_QTITEMPROD * V_VRFATOCONVES) * C_IMPOSITEMCOM.VRALIQITEM) - C_IMPOSITEMCOM.VRPARDEDIT - V_VRIMPOSTOST;
                     IF V_IMPOSTOIT < 0 THEN
                        V_IMPOSTOIT := 0;
                     END IF;
                  END IF;
               ELSE
                  IF (NVL(V_IDVRIMPSTRIB,w_N) = w_N) THEN
                     V_BASECALCTO  := V_BASECALCIT;
                     V_IMPOSTOIT   := (V_BASECALCIT * V_TAXAALIQUOTA) - C_IMPOSITEMCOM.VRPARDEDIT;
                  ELSE
                     V_BASECALCTO  := V_BASECALCIT;
                     V_IMPOSTOIT   := (V_BASECALCIT * V_TAXAALIQUOTA) - C_IMPOSITEMCOM.VRPARDEDIT - V_VRIMPOSTOST;
                     IF V_IMPOSTOIT < 0 THEN
                        V_IMPOSTOIT := 0;
                     END IF;
                  END IF;
               END IF;

               SELECT NVL(MAX(IDPERVISIMPSCRE),'S')
                 INTO V_IDPERVISIMPSCRE
                 FROM PARAMGERAL;

               IF V_IDPERVISIMPSCRE = 'S' THEN
                  V_VRIMPOSTOVISUIT := V_IMPOSTOIT;
               ELSE
                  IF C_IMPOSITEMCOM.CDFISCALIT = '1' THEN
                     V_VRIMPOSTOVISUIT := V_IMPOSTOIT;
                  ELSE
                     V_VRIMPOSTOVISUIT := 0;
                  END IF;
               END IF;

               IF ((V_IDSISTEMA = 'VND') OR (V_IDSISTEMA = 'PDV')) AND (V_ICMS = 'S') THEN
                  UPDATE ITEMPROIMPOS
                     SET VRCONTITIMP = V_BASECALCTO,
                         VRBASECALCIT = V_BASECALCTO,
                         VRIMPOSTOIT = TRUNC(V_IMPOSTOIT,2),
                         VRIMPOSTOVISUIT = TRUNC(VRIMPOSTOVISUIT,2)
                    WHERE CDFILIAL = P_FILIAL
                      AND NRLANCTONF = P_LANCTONF
                      AND NRSEQITPROD = C_IMPOSITEMCOM.NRSEQITPROD
                      AND CDIMPOSTO = C_IMPOSITEMCOM.CDIMPOSTO
                      AND NRITPROIMPOS = '1';
               ELSE
                  UPDATE ITEMPROIMPOS
                     SET VRCONTITIMP = V_BASECALCTO,
                         VRBASECALCIT = V_BASECALCTO,
                         VRIMPOSTOIT = ROUND(V_IMPOSTOIT,2),
                         VRIMPOSTOVISUIT = ROUND(V_VRIMPOSTOVISUIT,2)
                    WHERE CDFILIAL = P_FILIAL
                      AND NRLANCTONF = P_LANCTONF
                      AND NRSEQITPROD = C_IMPOSITEMCOM.NRSEQITPROD
                      AND CDIMPOSTO = C_IMPOSITEMCOM.CDIMPOSTO
                      AND NRITPROIMPOS = '1';
               END IF;

               IF (C_IMPOSITEMCOM.VRPERREDBCIT > 0)  THEN

                  Begin
                     SELECT CDFILIAL
                     INTO   V_CHAVE
                     FROM ITEMPROIMPOS
                     WHERE CDFILIAL     = P_FILIAL                 AND
                           NRLANCTONF   = P_LANCTONF               AND
                           NRSEQITPROD  = C_IMPOSITEMCOM.NRSEQITPROD  AND
                           CDIMPOSTO    = C_IMPOSITEMCOM.CDIMPOSTO AND
                           NRITPROIMPOS = '2';
                  Exception
                     When No_Data_Found Then
                        V_CHAVE := Null;
                  End;

                  IF V_CHAVE IS NULL THEN
                     INSERT INTO ITEMPROIMPOS(
                        CDFILIAL, NRLANCTONF, NRSEQITPROD, CDIMPOSTO,
                        NRITPROIMPOS, CDFISCALIT, VRALIQITEM, VRPERREDBCIT,
                        VRCONTITIMP, VRBASECALCIT, VRIMPOSTOIT, VRPARDEDIT,
                        CDSITUTRIBIT, CDFISCOPERIT, VRIMPOSTOVISUIT, CDENQLEGALIPI,
                        CDCEST)
                     VALUES(
                        P_FILIAL, P_LANCTONF, C_IMPOSITEMCOM.NRSEQITPROD, C_IMPOSITEMCOM.CDIMPOSTO,
                        '2', '2', 0, V_PERDBCALC,
                        V_CONTABCALC, 0, 0, 0,
                        C_IMPOSITEMCOM.CDSITUTRIBIT, C_IMPOSITEMCOM.CDFISCOPERIT, 0, C_IMPOSITEMCOM.CDENQLEGALIPI,
                        C_IMPOSITEMCOM.CDCEST);
                  ELSE
                     UPDATE ITEMPROIMPOS
                        SET VRCONTITIMP = V_CONTABCALC,
                            VRBASECALCIT = 0,
                            VRIMPOSTOIT = 0,
                            VRPERREDBCIT = V_PERDBCALC,
                            VRIMPOSTOVISUIT = 0
                    WHERE CDFILIAL = P_FILIAL
                      AND NRLANCTONF = P_LANCTONF
                      AND NRSEQITPROD = C_IMPOSITEMCOM.NRSEQITPROD
                      AND CDIMPOSTO = C_IMPOSITEMCOM.CDIMPOSTO
                      AND NRITPROIMPOS = '2';
                  END IF;
               END IF;

            END IF;
         END IF;
      END LOOP;

   --TOTALIZAÇÃO DOS IMPOSTOS
      FOR C_IMPOSNFCOMP IN (SELECT IT.CDFILIAL, IT.NRLANCTONF, IT.CDIMPOSTO
                           FROM IMPOSNFTOT IT, IMPOSTO I
                           WHERE IT.CDIMPOSTO  = I.CDIMPOSTO AND
                                 I.IDPRODNOTA  <> w_C        AND
                                 IT.CDFILIAL   = P_FILIAL    AND
                                 IT.NRLANCTONF = P_LANCTONF) LOOP

          DELETE IMPOSNFTOT
          WHERE (CDFILIAL   = P_FILIAL) AND
                (NRLANCTONF = P_LANCTONF) AND
                (CDIMPOSTO = C_IMPOSNFCOMP.CDIMPOSTO);

      END LOOP;

      DELETE IMPOSTONF
      WHERE (CDFILIAL   = P_FILIAL) AND
            (NRLANCTONF = P_LANCTONF);

      FOR C_IMPOSNFTOT IN (SELECT CDIMPOSTO, 
                                  NVL(SUM(ROUND(VRIMPOSTOIT,2)),0) AS VRIMPOSTOIT, 
                                  NVL(SUM(ROUND(VRBASECALCIT,2)),0) AS VRBASECALCIT,
                                  NVL(SUM(ROUND(VRADICFECP,2)),0) AS VRADICFECP
                           FROM ITEMPROIMPOS
                           WHERE (CDFILIAL   = P_FILIAL)   AND
                                 (NRLANCTONF = P_LANCTONF)
                           GROUP BY CDIMPOSTO) LOOP

         V_ICMS := 'N';
         FOR C_ICMS IN (SELECT CDIMPOSTO
                          FROM IMPOSTONFE N, IMPOSTO I
                         WHERE N.CDIMPOSTONFE = I.CDIMPOSTONFE
                           AND N.CDIMPOSTONFE = '00'
                           AND I.CDIMPOSTO = C_IMPOSNFTOT.CDIMPOSTO)
         LOOP
             V_ICMS := 'S';
         END LOOP;

         IF ((V_IDSISTEMA = 'VND') OR (V_IDSISTEMA = 'PDV')) AND (V_ICMS = 'S') THEN
            INSERT INTO IMPOSNFTOT(CDFILIAL, NRLANCTONF, CDIMPOSTO, VRTOTIMPONF, VRTOTBCALCNF,
                                   VRADICFECP)
                           VALUES (P_FILIAL, P_LANCTONF, C_IMPOSNFTOT.CDIMPOSTO, TRUNC(C_IMPOSNFTOT.VRIMPOSTOIT,V_NRDECITOTANF), TRUNC(C_IMPOSNFTOT.VRBASECALCIT,V_NRDECITOTANF),
                                   C_IMPOSNFTOT.VRADICFECP);
         ELSE
            INSERT INTO IMPOSNFTOT(CDFILIAL, NRLANCTONF, CDIMPOSTO, VRTOTIMPONF, VRTOTBCALCNF,
                                   VRADICFECP)
                           VALUES (P_FILIAL, P_LANCTONF, C_IMPOSNFTOT.CDIMPOSTO, ROUND(C_IMPOSNFTOT.VRIMPOSTOIT,V_NRDECITOTANF), ROUND(C_IMPOSNFTOT.VRBASECALCIT,V_NRDECITOTANF),
                                   C_IMPOSNFTOT.VRADICFECP);
         END IF;
      END LOOP;

      UPDATE ITEMPROIMPOS
         SET IDMODBCITNFE = '3'
       WHERE CDFILIAL = P_FILIAL
         AND NRLANCTONF = P_LANCTONF;

   ELSIF (P_TIPOOPER = w_09) OR (P_TIPOOPER = w_12) THEN /*VALE DE TRANSFERENCIA E NOTA DE DEBITO/CREDITO*/

      IF ((V_IDSISTEMA = 'VND') OR (V_IDSISTEMA = 'PDV')) AND (NVL(V_IDORIGDESTNF, 'C') <> 'L') THEN
         UPDATE ITEMPRODUTO
         SET VRBRUTITEM   = TRUNC((VRTOTAITEM - VRDESCITEM),2),
             VRCONTITEM   = TRUNC((VRTOTAITEM - VRDESCITEM),2)
         WHERE CDFILIAL   = P_FILIAL   AND
               NRLANCTONF = P_LANCTONF;
      ELSE
         UPDATE ITEMPRODUTO
         SET VRBRUTITEM   = ROUND((VRTOTAITEM - VRDESCITEM),5),
             VRCONTITEM   = ROUND((VRTOTAITEM - VRDESCITEM),5)
         WHERE CDFILIAL   = P_FILIAL   AND
               NRLANCTONF = P_LANCTONF;
      END IF;

      FOR C_ITPROD IN (SELECT I.CDPRODUTO, I.CDCFOPINFUSU, I.CDSUFXINFUSU, I.CDCSTINFUSU, I.NRSEQITPROD,
                              P.CDARVPROD, I.IDORIGEMPROD
                       FROM ITEMPRODUTO I, PRODUTO P
                       WHERE CDFILIAL   = P_FILIAL
                         AND NRLANCTONF = P_LANCTONF
                         AND I.CDPRODUTO = P.CDPRODUTO) LOOP

         CONSULTA_CST(w_S, P_EMPRESA, C_ITPROD.CDARVPROD, P_INSCESTA, P_TIPOOPER, P_FILIAL, P_LANCTONF, V_CDGRUPOFISC, V_IDINTEREST, V_IDINTERNA, NULL, C_ITPROD.IDORIGEMPROD);

         FOR C_CSTTEMP IN (SELECT DSMENSCSTTMP
                           FROM CSTTEMP
                           WHERE (NRCSTTEMP = V_CSTTEMP)    AND
                                 (DSMENSCSTTMP IS NOT NULL) AND
                                 (NOT EXISTS(SELECT DSDADOADIC
                                             FROM DADOSADIC
                                             WHERE (CDFILIAL   = P_FILIAL)   AND
                                                   (NRLANCTONF = P_LANCTONF) AND
                                                   (DSDADOADIC LIKE CSTTEMP.DSMENSCSTTMP || '%')))) LOOP

            IF NOT (C_CSTTEMP.DSMENSCSTTMP IS NULL) THEN
               INSERT INTO DADOSADIC(CDFILIAL, NRLANCTONF, NRDADOADIC, DSDADOADIC)
               VALUES(P_FILIAL, P_LANCTONF, V_DADOADIC, C_CSTTEMP.DSMENSCSTTMP);

               V_DADOADIC := LPAD(RTRIM(TO_CHAR(TO_NUMBER(V_DADOADIC) + 1)),3,0);
            END IF;
         END LOOP;

         CONSULTA_CFOP(w_S, P_EMPRESA, C_ITPROD.CDARVPROD, P_INSCESTA, P_TIPOOPER, V_PAISORIG,
                       V_ESTAORIG, V_PAISCFOP, V_ESTACFOP, P_FILIAL, P_LANCTONF, V_CDGRUPOFISC, P_INIVALID, C_ITPROD.IDORIGEMPROD);

         FOR C_CFOPTEMP IN (SELECT DSMENSCFOTMP
                            FROM CFOPTEMP
                            WHERE (NRCFOPTEMP = V_CFOPTEMP)  AND
                                  (DSMENSCFOTMP IS NOT NULL) AND
                                  (NOT EXISTS(SELECT DSDADOADIC
                                              FROM DADOSADIC
                                              WHERE (CDFILIAL   = P_FILIAL)   AND
                                                    (NRLANCTONF = P_LANCTONF) AND
                                                    (DSDADOADIC LIKE CFOPTEMP.DSMENSCFOTMP || '%')))) LOOP

            IF NOT (C_CFOPTEMP.DSMENSCFOTMP IS NULL) THEN
               INSERT INTO DADOSADIC(CDFILIAL, NRLANCTONF, NRDADOADIC, DSDADOADIC)
               VALUES(P_FILIAL, P_LANCTONF, V_DADOADIC, C_CFOPTEMP.DSMENSCFOTMP);

               V_DADOADIC := LPAD(RTRIM(TO_CHAR(TO_NUMBER(V_DADOADIC) + 1)),3,0);
            END IF;
         END LOOP;

         IF C_ITPROD.CDCFOPINFUSU IS NULL THEN
            UPDATE NOTAFISCAL
            SET DSCDFISOPENF = (SELECT MAX(DSCFOPTMP)
                                  FROM CFOPTEMP
                                  WHERE NRCFOPTEMP = V_CFOPTEMP)
            WHERE CDFILIAL   = P_FILIAL   AND
                  NRLANCTONF = P_LANCTONF;

            SELECT MAX(CDFISOPETMP), MAX(CDSUFCFOPTMP), SUBSTR(MAX(DSCFOPTMP),1,50)
            INTO   V_FISOPEITEM    , V_SUFXCFOPPR, V_DSCDFISOPEIT
            FROM CFOPTEMP
            WHERE NRCFOPTEMP = V_CFOPTEMP;

            SELECT MAX(CDSITTRIBTMP)
            INTO   V_SITUTRIBPR
            FROM CSTTEMP
            WHERE NRCSTTEMP = V_CSTTEMP;
         ELSE
            V_CFOPINFUSU := 'S';
            V_FISOPEITEM := C_ITPROD.CDCFOPINFUSU;
            V_SUFXCFOPPR := C_ITPROD.CDSUFXINFUSU;
            V_SITUTRIBPR := C_ITPROD.CDCSTINFUSU;
         END IF;

         IF V_IDDOCREPLIC IS NOT NULL THEN
            IF LENGTH(V_SITUTRIBPR) = 3 THEN
               V_SITUTRIBPR := SUBSTR(V_SITUTRIBPR,1,1) || w_90;
            ELSE
               V_SITUTRIBPR := w_90;
            END IF;
         END IF;

         CONSULTA_CSOSN('S', P_EMPRESA, C_ITPROD.CDARVPROD, P_INSCESTA, P_TIPOOPER, P_FILIAL, P_LANCTONF, V_CDGRUPOFISC, V_IDINTEREST,V_CDFISCOPERSN);

         UPDATE ITEMPRODUTO
         SET CDFISOPEITEM  = V_FISOPEITEM,
             CDSUFXCFOPPR  = V_SUFXCFOPPR,
             CDSITUTRIBPR  = V_SITUTRIBPR,
             DSCDFISOPEIT  = V_DSCDFISOPEIT,
             CDFISCOPERSN  = V_CDFISCOPERSN
         WHERE CDFILIAL    = P_FILIAL   AND
               NRLANCTONF  = P_LANCTONF AND
               NRSEQITPROD = C_ITPROD.NRSEQITPROD;

         DELETE CFOPTEMP
         WHERE NRCFOPTEMP = V_CFOPTEMP;

         DELETE CSTTEMP
         WHERE NRCSTTEMP = V_CSTTEMP;

         /*Consulta de nfe*/
         V_CDSITTRIBTMP    := NULL;
         V_IDMODBCNFE      := NULL;
         V_IDMODBCSTNFE    := NULL;
         V_CDTPCRPICOSTNFE := NULL;
         V_CDNATUBCPCSTNFE := NULL;

         FOR C_ITPROI IN (SELECT II.CDIMPOSTO, II.NRITPROIMPOS
                            FROM ITEMPROIMPOS II, IMPOSTO I
                           WHERE II.CDFILIAL   = P_FILIAL
                             AND II.NRLANCTONF = P_LANCTONF
                             AND II.NRSEQITPROD = C_ITPROD.NRSEQITPROD
                             AND II.CDIMPOSTO = I.CDIMPOSTO
                             AND I.IDPRODNOTA = 'P'
                          ORDER BY II.CDIMPOSTO) LOOP

             V_IMPOICMS := NULL;
             V_CDGRUPOFISCAUX := NULL;

             SELECT MAX(G.CDGRUPOFISC)
              INTO V_CDGRUPOFISCAUX
              FROM GRUPOFISCIMPFIL G,
                   (SELECT CDFILIEMIT AS CDFILIAL
                      FROM NOTAFISCAL
                     WHERE CDFILIAL = P_FILIAL
                           AND NRLANCTONF = P_LANCTONF) F
             WHERE G.CDFILIAL = F.CDFILIAL
               AND NOT G.CDGRUPOFISC IS NULL
               AND G.CDIMPOSTO = C_ITPROI.CDIMPOSTO;

             IF V_IDORIGDESTNF = 'C' THEN
                SELECT NVL(MAX(G.CDGRUPOFISC), V_CDGRUPOFISCAUX)
                 INTO V_CDGRUPOFISCAUX
                 FROM GRFISIMPIECLIE G,
                      (SELECT CDCLIENTE
                         FROM NOTAFISCAL
                        WHERE CDFILIAL = P_FILIAL
                          AND NRLANCTONF = P_LANCTONF) N
                WHERE G.CDCLIENTE = N.CDCLIENTE
                  AND G.CDEMPRESA = P_EMPRESA
                  AND G.CDINSCESTA = P_INSCESTA
                  AND NOT G.CDGRUPOFISC IS NULL
                  AND G.CDIMPOSTO = C_ITPROI.CDIMPOSTO;
             ELSE
                SELECT NVL(MAX(G.CDGRUPOFISC), V_CDGRUPOFISCAUX)
                  INTO V_CDGRUPOFISCAUX
                  FROM GRFISIMPIEFORN G,
                      (SELECT CDFORNECED
                         FROM NOTAFISCAL
                        WHERE CDFILIAL = P_FILIAL
                          AND NRLANCTONF = P_LANCTONF) N
                 WHERE G.CDFORNECED = N.CDFORNECED
                   AND G.CDEMPRESA = P_EMPRESA
                   AND G.CDINSCESTA = P_INSCESTA
                   AND NOT G.CDGRUPOFISC IS NULL
                   AND G.CDIMPOSTO = C_ITPROI.CDIMPOSTO;
             END IF;

             IF V_CDGRUPOFISCAUX IS NULL THEN
               CONSULTA_CST_NFE(w_S, P_EMPRESA, C_ITPROD.CDARVPROD, P_INSCESTA, P_TIPOOPER, V_CDGRUPOFISC,C_ITPROI.CDIMPOSTO, V_IDINTEREST, V_IDINTERNA, P_FILIAL, P_LANCTONF, '', V_CDSITTRIBTMP, V_IDMODBCNFE, V_IDMODBCSTNFE, V_CDTPCRPICOSTNFE, V_CDNATUBCPCSTNFE, V_IDMOTIDESSTNFE, C_ITPROD.IDORIGEMPROD);
             ELSE
               CONSULTA_CST_NFE(w_S, P_EMPRESA, C_ITPROD.CDARVPROD, P_INSCESTA, P_TIPOOPER, V_CDGRUPOFISCAUX,C_ITPROI.CDIMPOSTO, V_IDINTEREST, V_IDINTERNA, P_FILIAL, P_LANCTONF, '', V_CDSITTRIBTMP, V_IDMODBCNFE, V_IDMODBCSTNFE, V_CDTPCRPICOSTNFE, V_CDNATUBCPCSTNFE, V_IDMOTIDESSTNFE, C_ITPROD.IDORIGEMPROD);
             END IF;

             UPDATE ITEMPROIMPOS
               SET CDSITUTRIBITNFE = V_CDSITTRIBTMP,
                   IDMODBCITNFE = V_IDMODBCNFE,
                   IDMODBCSTITNFE = V_IDMODBCSTNFE,
                   CDTPCREDPICOITE = V_CDTPCRPICOSTNFE,
                   CDNATUBCALPCIT  = V_CDNATUBCPCSTNFE,
                   IDMOTDESONERAIT = V_IDMOTIDESSTNFE
               WHERE (CDFILIAL     = P_FILIAL)                   AND
                     (NRLANCTONF   = P_LANCTONF)                 AND
                     (NRSEQITPROD  = C_ITPROD.NRSEQITPROD) AND
                     (CDIMPOSTO    = C_ITPROI.CDIMPOSTO)   AND
                     (NRITPROIMPOS = C_ITPROI.NRITPROIMPOS);

         END LOOP;
      END LOOP;
   END IF;

   V_DIFERENCA := 0;
   /* RATEIO DOS ENCARGOS PARA OS PRODUTOS DA NOTA. ESTE RATEIO É NECESSÁRIO PARA A NOTA FISCAL ELETRÔNICA */
   FOR C_ITEMENCARGO IN (SELECT ENCARGO.CDENCARGONFE, SUM(ITEMENCARGO.VRITEMENCA) AS VRITEMENCA
                           FROM ITEMENCARGO, ENCARGO
                          WHERE ITEMENCARGO.CDENCARGO = ENCARGO.CDENCARGO
                            AND ENCARGO.CDENCARGONFE IN ('01', '02', '03', '04', '05')
                            AND NVL(ITEMENCARGO.VRITEMENCA, 0) >= 0
                            AND CDFILIAL = P_FILIAL
                            AND NRLANCTONF = P_LANCTONF
                          GROUP BY ENCARGO.CDENCARGONFE) LOOP
      /* ENCARGO FRETE */
      IF (C_ITEMENCARGO.CDENCARGONFE = '01') THEN
         IF (C_ITEMENCARGO.VRITEMENCA > 0) THEN
            FOR C_ITEMPRODUTO IN (SELECT NRSEQITPROD, VRTOTAITEM
                                    FROM ITEMPRODUTO
                                   WHERE CDFILIAL = P_FILIAL
                                     AND NRLANCTONF = P_LANCTONF) LOOP

               SELECT ITEMPRODUTO.VRTOTAITEM,
                      TOTAL.SOMATOTAITEM,
                      DECODE(TOTAL.SOMATOTAITEM, 0, 0, ((100 * ITEMPRODUTO.VRTOTAITEM) / TOTAL.SOMATOTAITEM)) AS PERCENTITEM
                 INTO V_VRTOTAITEM, V_SOMATOTAITEM, V_PERCENTITEM
                 FROM ITEMPRODUTO, (SELECT CDFILIAL, NRLANCTONF, SUM(VRTOTAITEM) SOMATOTAITEM
                                      FROM ITEMPRODUTO
                                     WHERE CDFILIAL = P_FILIAL
                                       AND NRLANCTONF = P_LANCTONF
                                     GROUP BY CDFILIAL, NRLANCTONF) TOTAL
                WHERE ITEMPRODUTO.CDFILIAL = TOTAL.CDFILIAL
                  AND ITEMPRODUTO.NRLANCTONF = TOTAL.NRLANCTONF
                  AND ITEMPRODUTO.NRSEQITPROD = C_ITEMPRODUTO.NRSEQITPROD;

               IF ((V_IDSISTEMA = 'VND') OR (V_IDSISTEMA = 'PDV')) AND (NVL(V_IDORIGDESTNF, 'C') <> 'L') THEN
                  UPDATE ITEMPRODUTO
                     SET VRFRETEITEM = TRUNC(C_ITEMENCARGO.VRITEMENCA * (V_PERCENTITEM / 100), 2)
                   WHERE CDFILIAL  = P_FILIAL
                     AND NRLANCTONF = P_LANCTONF
                     AND NRSEQITPROD = C_ITEMPRODUTO.NRSEQITPROD;
               ELSE
                  UPDATE ITEMPRODUTO
                     SET VRFRETEITEM = ROUND(C_ITEMENCARGO.VRITEMENCA * (V_PERCENTITEM / 100), 2)
                   WHERE CDFILIAL  = P_FILIAL
                     AND NRLANCTONF = P_LANCTONF
                     AND NRSEQITPROD = C_ITEMPRODUTO.NRSEQITPROD;
               END IF;
            END LOOP;
            /*AJUSTE DE VALORES*/
            SELECT SUM(VRFRETEITEM)
              INTO V_VRFRETEITEM
              FROM ITEMPRODUTO
             WHERE CDFILIAL = P_FILIAL
               AND NRLANCTONF = P_LANCTONF;

            V_DIFERENCA := C_ITEMENCARGO.VRITEMENCA - V_VRFRETEITEM;

            IF V_DIFERENCA <> 0 THEN
               UPDATE ITEMPRODUTO
                  SET VRFRETEITEM = VRFRETEITEM + V_DIFERENCA
                WHERE CDFILIAL = P_FILIAL
                  AND NRLANCTONF = P_LANCTONF
                  AND NRSEQITPROD = (SELECT MAX(NRSEQITPROD)
                                      FROM ITEMPRODUTO
                                      WHERE CDFILIAL = P_FILIAL
                                        AND NRLANCTONF = P_LANCTONF
                                        AND VRTOTAITEM = (SELECT MAX(VRTOTAITEM)
                                                           FROM ITEMPRODUTO
                                                          WHERE CDFILIAL = P_FILIAL
                                                            AND NRLANCTONF = P_LANCTONF));

            END IF;
         ELSE
            UPDATE ITEMPRODUTO
               SET VRFRETEITEM = 0
             WHERE CDFILIAL  = P_FILIAL
               AND NRLANCTONF = P_LANCTONF;
         END IF;
      END IF;

      /* ENCARGO SEGURO */
      IF (C_ITEMENCARGO.CDENCARGONFE = '02') THEN
         IF (C_ITEMENCARGO.VRITEMENCA > 0) THEN
            FOR C_ITEMPRODUTO IN (SELECT NRSEQITPROD, VRTOTAITEM
                                    FROM ITEMPRODUTO
                                   WHERE CDFILIAL = P_FILIAL
                                     AND NRLANCTONF = P_LANCTONF) LOOP

               SELECT ITEMPRODUTO.VRTOTAITEM,
                      TOTAL.SOMATOTAITEM,
                      DECODE(TOTAL.SOMATOTAITEM, 0, 0, ((100 * ITEMPRODUTO.VRTOTAITEM) / TOTAL.SOMATOTAITEM)) AS PERCENTITEM
                 INTO V_VRTOTAITEM, V_SOMATOTAITEM, V_PERCENTITEM
                 FROM ITEMPRODUTO, (SELECT CDFILIAL, NRLANCTONF, SUM(VRTOTAITEM) SOMATOTAITEM
                                      FROM ITEMPRODUTO
                                     WHERE CDFILIAL = P_FILIAL
                                       AND NRLANCTONF = P_LANCTONF
                                     GROUP BY CDFILIAL, NRLANCTONF) TOTAL
                WHERE ITEMPRODUTO.CDFILIAL = TOTAL.CDFILIAL
                  AND ITEMPRODUTO.NRLANCTONF = TOTAL.NRLANCTONF
                  AND ITEMPRODUTO.NRSEQITPROD = C_ITEMPRODUTO.NRSEQITPROD;

               IF ((V_IDSISTEMA = 'VND') OR (V_IDSISTEMA = 'PDV')) AND (NVL(V_IDORIGDESTNF, 'C') <> 'L') THEN
                  UPDATE ITEMPRODUTO
                     SET VRSEGURITEM = TRUNC(C_ITEMENCARGO.VRITEMENCA * (V_PERCENTITEM / 100), 2)
                   WHERE CDFILIAL  = P_FILIAL
                     AND NRLANCTONF = P_LANCTONF
                     AND NRSEQITPROD = C_ITEMPRODUTO.NRSEQITPROD;
               ELSE
                  UPDATE ITEMPRODUTO
                     SET VRSEGURITEM = ROUND(C_ITEMENCARGO.VRITEMENCA * (V_PERCENTITEM / 100), 2)
                   WHERE CDFILIAL  = P_FILIAL
                     AND NRLANCTONF = P_LANCTONF
                     AND NRSEQITPROD = C_ITEMPRODUTO.NRSEQITPROD;
               END IF;
            END LOOP;
            /*AJUSTE DE VALORES*/
            SELECT SUM(VRSEGURITEM)
              INTO V_VRSEGURITEM
              FROM ITEMPRODUTO
             WHERE CDFILIAL = P_FILIAL
               AND NRLANCTONF = P_LANCTONF;

            V_DIFERENCA := C_ITEMENCARGO.VRITEMENCA - V_VRSEGURITEM;

            IF V_DIFERENCA <> 0 THEN
               UPDATE ITEMPRODUTO
                  SET VRSEGURITEM = VRSEGURITEM + V_DIFERENCA
                WHERE CDFILIAL = P_FILIAL
                  AND NRLANCTONF = P_LANCTONF
                  AND NRSEQITPROD = (SELECT MAX(NRSEQITPROD)
                                      FROM ITEMPRODUTO
                                      WHERE CDFILIAL = P_FILIAL
                                        AND NRLANCTONF = P_LANCTONF
                                        AND VRTOTAITEM = (SELECT MAX(VRTOTAITEM)
                                                           FROM ITEMPRODUTO
                                                          WHERE CDFILIAL = P_FILIAL
                                                            AND NRLANCTONF = P_LANCTONF));

            END IF;
         ELSE
            UPDATE ITEMPRODUTO
               SET VRSEGURITEM = 0
             WHERE CDFILIAL  = P_FILIAL
               AND NRLANCTONF = P_LANCTONF;
         END IF;
      END IF;

      /* ENCARGO DESCONTO */
      IF (C_ITEMENCARGO.CDENCARGONFE = '03') THEN
         IF (C_ITEMENCARGO.VRITEMENCA > 0) THEN
            FOR C_ITEMPRODUTO IN (SELECT NRSEQITPROD, VRTOTAITEM
                                    FROM ITEMPRODUTO
                                   WHERE CDFILIAL = P_FILIAL
                                     AND NRLANCTONF = P_LANCTONF) LOOP

               SELECT ITEMPRODUTO.VRTOTAITEM,
                      TOTAL.SOMATOTAITEM,
                      DECODE(TOTAL.SOMATOTAITEM, 0, 0, ((100 * ITEMPRODUTO.VRTOTAITEM) / TOTAL.SOMATOTAITEM)) AS PERCENTITEM
                 INTO V_VRTOTAITEM, V_SOMATOTAITEM, V_PERCENTITEM
                 FROM ITEMPRODUTO, (SELECT CDFILIAL, NRLANCTONF, SUM(VRTOTAITEM) SOMATOTAITEM
                                      FROM ITEMPRODUTO
                                     WHERE CDFILIAL = P_FILIAL
                                       AND NRLANCTONF = P_LANCTONF
                                     GROUP BY CDFILIAL, NRLANCTONF) TOTAL
                WHERE ITEMPRODUTO.CDFILIAL = TOTAL.CDFILIAL
                  AND ITEMPRODUTO.NRLANCTONF = TOTAL.NRLANCTONF
                  AND ITEMPRODUTO.NRSEQITPROD = C_ITEMPRODUTO.NRSEQITPROD;

               IF ((V_IDSISTEMA = 'VND') OR (V_IDSISTEMA = 'PDV')) AND (NVL(V_IDORIGDESTNF, 'C') <> 'L') THEN
                  UPDATE ITEMPRODUTO
                     SET VRENCARGODESC = TRUNC(VRDESCITEM + (C_ITEMENCARGO.VRITEMENCA * (V_PERCENTITEM / 100)), 2)
                   WHERE CDFILIAL  = P_FILIAL
                     AND NRLANCTONF = P_LANCTONF
                     AND NRSEQITPROD = C_ITEMPRODUTO.NRSEQITPROD;
               ELSE
                  UPDATE ITEMPRODUTO
                     SET VRENCARGODESC = ROUND(VRDESCITEM + (C_ITEMENCARGO.VRITEMENCA * (V_PERCENTITEM / 100)), 2)
                   WHERE CDFILIAL  = P_FILIAL
                     AND NRLANCTONF = P_LANCTONF
                     AND NRSEQITPROD = C_ITEMPRODUTO.NRSEQITPROD;
               END IF;
            END LOOP;
            /*AJUSTE DE VALORES*/
            SELECT SUM(VRENCARGODESC)
              INTO V_VRENCARGODESC
              FROM ITEMPRODUTO
             WHERE CDFILIAL = P_FILIAL
               AND NRLANCTONF = P_LANCTONF;

            SELECT SUM(VRDESCITEM)
              INTO V_SUMVRDESCITEM
              FROM ITEMPRODUTO
             WHERE CDFILIAL  = P_FILIAL
               AND NRLANCTONF = P_LANCTONF;

            V_DIFERENCA := (C_ITEMENCARGO.VRITEMENCA+V_SUMVRDESCITEM) - V_VRENCARGODESC;

            IF V_DIFERENCA <> 0 THEN
               UPDATE ITEMPRODUTO
                  SET VRENCARGODESC = VRENCARGODESC + V_DIFERENCA
                WHERE CDFILIAL = P_FILIAL
                  AND NRLANCTONF = P_LANCTONF
                  AND NRSEQITPROD = (SELECT MAX(NRSEQITPROD)
                                      FROM ITEMPRODUTO
                                      WHERE CDFILIAL = P_FILIAL
                                        AND NRLANCTONF = P_LANCTONF
                                        AND VRTOTAITEM = (SELECT MAX(VRTOTAITEM)
                                                           FROM ITEMPRODUTO
                                                          WHERE CDFILIAL = P_FILIAL
                                                            AND NRLANCTONF = P_LANCTONF));

            END IF;
         ELSE
            UPDATE ITEMPRODUTO
               SET VRENCARGODESC = VRDESCITEM + 0
             WHERE CDFILIAL  = P_FILIAL
               AND NRLANCTONF = P_LANCTONF;
         END IF;
      END IF;
           /*ENCARGO OUTRAS DESPESAS*/
      IF (C_ITEMENCARGO.CDENCARGONFE = '04') THEN
         IF (C_ITEMENCARGO.VRITEMENCA > 0) THEN
            IF (V_IDNFORIGVIAXML = 'S') THEN
               FOR C_ITEMPRODUTO IN (SELECT NRSEQITPROD, VRTOTAITEM, VRENCARGOIMPXML
                                       FROM ITEMPRODUTO
                                      WHERE CDFILIAL = P_FILIAL
                                        AND NRLANCTONF = P_LANCTONF
                                        AND VRENCARGOIMPXML > 0) LOOP

                  SELECT ITEMPRODUTO.VRTOTAITEM,
                         TOTAL.SOMATOTAITEM,
                         DECODE(TOTAL.SOMATOTAITEM, 0, 0, ((100 * ITEMPRODUTO.VRTOTAITEM) / TOTAL.SOMATOTAITEM)) AS PERCENTITEM
                    INTO V_VRTOTAITEM, V_SOMATOTAITEM, V_PERCENTITEM
                    FROM ITEMPRODUTO, (SELECT CDFILIAL, NRLANCTONF, SUM(VRTOTAITEM) SOMATOTAITEM
                                         FROM ITEMPRODUTO
                                        WHERE CDFILIAL = P_FILIAL
                                          AND NRLANCTONF = P_LANCTONF
                                        GROUP BY CDFILIAL, NRLANCTONF) TOTAL
                   WHERE ITEMPRODUTO.CDFILIAL = TOTAL.CDFILIAL
                     AND ITEMPRODUTO.NRLANCTONF = TOTAL.NRLANCTONF
                     AND ITEMPRODUTO.NRSEQITPROD = C_ITEMPRODUTO.NRSEQITPROD;

                  IF ((V_IDSISTEMA = 'VND') OR (V_IDSISTEMA = 'PDV')) AND (NVL(V_IDORIGDESTNF, 'C') <> 'L') THEN
                     UPDATE ITEMPRODUTO
                        SET VROUTRASDESPITEM = VRENCARGOIMPXML
                      WHERE CDFILIAL  = P_FILIAL
                        AND NRLANCTONF = P_LANCTONF
                        AND NRSEQITPROD = C_ITEMPRODUTO.NRSEQITPROD;
                  ELSE
                     UPDATE ITEMPRODUTO
                        SET VROUTRASDESPITEM = VRENCARGOIMPXML
                      WHERE CDFILIAL  = P_FILIAL
                        AND NRLANCTONF = P_LANCTONF
                        AND NRSEQITPROD = C_ITEMPRODUTO.NRSEQITPROD;
                  END IF;
               END LOOP;
            ELSE
               FOR C_ITEMPRODUTO IN (SELECT NRSEQITPROD, VRTOTAITEM
                                       FROM ITEMPRODUTO
                                      WHERE CDFILIAL = P_FILIAL
                                        AND NRLANCTONF = P_LANCTONF) LOOP

                  SELECT ITEMPRODUTO.VRTOTAITEM,
                         TOTAL.SOMATOTAITEM,
                         DECODE(TOTAL.SOMATOTAITEM, 0, 0, ((100 * ITEMPRODUTO.VRTOTAITEM) / TOTAL.SOMATOTAITEM)) AS PERCENTITEM
                    INTO V_VRTOTAITEM, V_SOMATOTAITEM, V_PERCENTITEM
                    FROM ITEMPRODUTO, (SELECT CDFILIAL, NRLANCTONF, SUM(VRTOTAITEM) SOMATOTAITEM
                                         FROM ITEMPRODUTO
                                        WHERE CDFILIAL = P_FILIAL
                                          AND NRLANCTONF = P_LANCTONF
                                        GROUP BY CDFILIAL, NRLANCTONF) TOTAL
                   WHERE ITEMPRODUTO.CDFILIAL = TOTAL.CDFILIAL
                     AND ITEMPRODUTO.NRLANCTONF = TOTAL.NRLANCTONF
                     AND ITEMPRODUTO.NRSEQITPROD = C_ITEMPRODUTO.NRSEQITPROD;

                  IF ((V_IDSISTEMA = 'VND') OR (V_IDSISTEMA = 'PDV')) AND (NVL(V_IDORIGDESTNF, 'C') <> 'L') THEN
                     UPDATE ITEMPRODUTO
                        SET VROUTRASDESPITEM = TRUNC((C_ITEMENCARGO.VRITEMENCA * (V_PERCENTITEM / 100)), 2)
                      WHERE CDFILIAL  = P_FILIAL
                        AND NRLANCTONF = P_LANCTONF
                        AND NRSEQITPROD = C_ITEMPRODUTO.NRSEQITPROD;
                  ELSE
                     UPDATE ITEMPRODUTO
                        SET VROUTRASDESPITEM = ROUND((C_ITEMENCARGO.VRITEMENCA * (V_PERCENTITEM / 100)), 2)
                      WHERE CDFILIAL  = P_FILIAL
                        AND NRLANCTONF = P_LANCTONF
                        AND NRSEQITPROD = C_ITEMPRODUTO.NRSEQITPROD;
                  END IF;
               END LOOP;
            END IF;
            /*AJUSTE DE VALORES*/
            SELECT SUM(VROUTRASDESPITEM)
              INTO V_VROUTRASDESPITEM
              FROM ITEMPRODUTO
             WHERE CDFILIAL = P_FILIAL
               AND NRLANCTONF = P_LANCTONF;

            V_DIFERENCA := C_ITEMENCARGO.VRITEMENCA - V_VROUTRASDESPITEM;

            IF V_DIFERENCA <> 0 THEN
               UPDATE ITEMPRODUTO
                  SET VROUTRASDESPITEM = VROUTRASDESPITEM + V_DIFERENCA
                WHERE CDFILIAL = P_FILIAL
                  AND NRLANCTONF = P_LANCTONF
                  AND NRSEQITPROD = (SELECT MAX(NRSEQITPROD)
                                      FROM ITEMPRODUTO
                                      WHERE CDFILIAL = P_FILIAL
                                        AND NRLANCTONF = P_LANCTONF
                                        AND VRTOTAITEM = (SELECT MAX(VRTOTAITEM)
                                                           FROM ITEMPRODUTO
                                                          WHERE CDFILIAL = P_FILIAL
                                                            AND NRLANCTONF = P_LANCTONF));

            END IF;
         ELSE
            UPDATE ITEMPRODUTO
               SET VROUTRASDESPITEM = 0
             WHERE CDFILIAL  = P_FILIAL
               AND NRLANCTONF = P_LANCTONF;
         END IF;
      END IF;

      /*ENCARGO DESPESAS ADUANEIRAS*/
      IF (C_ITEMENCARGO.CDENCARGONFE = '05') THEN
         /*REFAZ O RATEIO DO ENCARGO VERIFICANDO A INCIDENCIA DO IMPOSTO DE IMPORTACAO*/
         UPDATE ITEMPRODUTO
            SET VRDESPADUANEIRA = 0
          WHERE CDFILIAL  = P_FILIAL
            AND NRLANCTONF = P_LANCTONF;
         IF (C_ITEMENCARGO.VRITEMENCA > 0) THEN
            FOR C_ITEMPRODUTO IN (SELECT DISTINCT(I.NRSEQITPROD)
                                    FROM ITEMPROIMPOS I, IMPOSTO II
                                   WHERE I.NRLANCTONF    = P_LANCTONF
                                     AND I.CDFILIAL      = P_FILIAL
                                     AND I.CDIMPOSTO     = II.CDIMPOSTO
                                     AND II.CDIMPOSTONFE = '20') LOOP

               SELECT ITEMPRODUTO.VRTOTAITEM,
                      TOTAL.SOMATOTAITEM,
                      DECODE(TOTAL.SOMATOTAITEM, 0, 0, ((100 * ITEMPRODUTO.VRTOTAITEM) / TOTAL.SOMATOTAITEM)) AS PERCENTITEM
                 INTO V_VRTOTAITEM, V_SOMATOTAITEM, V_PERCENTITEM
                 FROM ITEMPRODUTO, (SELECT CDFILIAL, NRLANCTONF, SUM(VRTOTAITEM) SOMATOTAITEM
                                      FROM ITEMPRODUTO
                                     WHERE CDFILIAL = P_FILIAL
                                       AND NRLANCTONF = P_LANCTONF
                                     GROUP BY CDFILIAL, NRLANCTONF) TOTAL
                WHERE ITEMPRODUTO.CDFILIAL = TOTAL.CDFILIAL
                  AND ITEMPRODUTO.NRLANCTONF = TOTAL.NRLANCTONF
                  AND ITEMPRODUTO.NRSEQITPROD = C_ITEMPRODUTO.NRSEQITPROD;

               IF ((V_IDSISTEMA = 'VND') OR (V_IDSISTEMA = 'PDV')) AND (NVL(V_IDORIGDESTNF, 'C') <> 'L') THEN
                  UPDATE ITEMPRODUTO
                     SET VRDESPADUANEIRA = TRUNC((C_ITEMENCARGO.VRITEMENCA * (V_PERCENTITEM / 100)), 2)
                   WHERE CDFILIAL  = P_FILIAL
                     AND NRLANCTONF = P_LANCTONF
                     AND NRSEQITPROD = C_ITEMPRODUTO.NRSEQITPROD;
               ELSE
                  UPDATE ITEMPRODUTO
                     SET VRDESPADUANEIRA = ROUND((C_ITEMENCARGO.VRITEMENCA * (V_PERCENTITEM / 100)), 2)
                   WHERE CDFILIAL  = P_FILIAL
                     AND NRLANCTONF = P_LANCTONF
                     AND NRSEQITPROD = C_ITEMPRODUTO.NRSEQITPROD;
               END IF;
            END LOOP;
            /*AJUSTE DE VALORES*/
            SELECT SUM(VRDESPADUANEIRA)
              INTO V_VRDESPADUANEIRA
              FROM ITEMPRODUTO
             WHERE CDFILIAL = P_FILIAL
               AND NRLANCTONF = P_LANCTONF;

            V_DIFERENCA := C_ITEMENCARGO.VRITEMENCA - V_VRDESPADUANEIRA;

            IF V_DIFERENCA <> 0 THEN
               UPDATE ITEMPRODUTO
                  SET VRDESPADUANEIRA = VRDESPADUANEIRA + V_DIFERENCA
                WHERE CDFILIAL = P_FILIAL
                  AND NRLANCTONF = P_LANCTONF
                  AND NRSEQITPROD = (SELECT MAX(II.NRSEQITPROD)
                                       FROM ITEMPRODUTO I, ITEMPROIMPOS II, IMPOSTO S
                                      WHERE I.CDFILIAL     = P_FILIAL
                                        AND I.NRLANCTONF   = P_LANCTONF
                                        AND I.CDFILIAL     = II.CDFILIAL
                                        AND I.NRLANCTONF   = II.NRLANCTONF
                                        AND I.NRSEQITPROD  = II.NRSEQITPROD
                                        AND II.CDIMPOSTO   = S.CDIMPOSTO
                                        AND S.CDIMPOSTONFE = '20'
                                        AND VRTOTAITEM = (SELECT MAX(VRTOTAITEM)
                                                            FROM ITEMPRODUTO I, ITEMPROIMPOS II, IMPOSTO S
                                                           WHERE I.CDFILIAL     = P_FILIAL
                                                             AND I.NRLANCTONF   = P_LANCTONF
                                                             AND I.CDFILIAL     = II.CDFILIAL
                                                             AND I.NRLANCTONF   = II.NRLANCTONF
                                                             AND I.NRSEQITPROD  = II.NRSEQITPROD
                                                             AND II.CDIMPOSTO   = S.CDIMPOSTO
                                                             AND S.CDIMPOSTONFE = '20'));

            END IF;
         ELSE
            UPDATE ITEMPRODUTO
               SET VRDESPADUANEIRA = 0
             WHERE CDFILIAL  = P_FILIAL
               AND NRLANCTONF = P_LANCTONF;
         END IF;
      END IF;      
   END LOOP;

--CÁLCULO DO VALOR TOTAL DA NOTA FISCAL

   SELECT SUM(VRITEMENCA)
   INTO   V_SOMAENCA
   FROM ITEMENCARGO IE, ENCARGO EN
   WHERE IE.CDFILIAL   = P_FILIAL     AND
         IE.NRLANCTONF = P_LANCTONF   AND
         IE.CDENCARGO  = EN.CDENCARGO AND
         IDENCARGO     = w_A;

   SELECT SUM(VRITEMENCA)
   INTO   V_MENOENCA
   FROM ITEMENCARGO IE, ENCARGO EN
   WHERE IE.CDFILIAL   = P_FILIAL     AND
         IE.NRLANCTONF = P_LANCTONF   AND
         IE.CDENCARGO  = EN.CDENCARGO AND
         IDENCARGO     = w_D;

   IF V_IDOPERDEVONF = 'S' THEN
      SELECT SUM(VRTOTIMPONF)
      INTO   V_SOMAIMPO
      FROM IMPOSNFTOT, IMPOSTO
      WHERE IMPOSNFTOT.CDFILIAL   = P_FILIAL          AND
            IMPOSNFTOT.NRLANCTONF = P_LANCTONF        AND
            IMPOSNFTOT.CDIMPOSTO  = IMPOSTO.CDIMPOSTO AND
            IDTRATIMPO            = w_A               AND
            NVL(IDACRPRODENTRNF, 'N') = 'N' AND
            NOT EXISTS(SELECT CDIMPOSTO
                       FROM IMPOSTO
                       WHERE IMPOSTO.CDIMPOSTRIB = IMPOSNFTOT.CDIMPOSTO);

   ELSE
      SELECT SUM(VRTOTIMPONF)
      INTO   V_SOMAIMPO
      FROM IMPOSNFTOT, IMPOSTO
      WHERE IMPOSNFTOT.CDFILIAL   = P_FILIAL          AND
            IMPOSNFTOT.NRLANCTONF = P_LANCTONF        AND
            IMPOSNFTOT.CDIMPOSTO  = IMPOSTO.CDIMPOSTO AND
            IDTRATIMPO            = w_A               AND
            NOT EXISTS(SELECT CDIMPOSTO
                       FROM IMPOSTO
                       WHERE IMPOSTO.CDIMPOSTRIB = IMPOSNFTOT.CDIMPOSTO);
   END IF;

   SELECT SUM(VRTOTIMPONF)
   INTO   V_MENOIMPO
   FROM IMPOSNFTOT, IMPOSTO
   WHERE IMPOSNFTOT.CDFILIAL   = P_FILIAL          AND
         IMPOSNFTOT.NRLANCTONF = P_LANCTONF        AND
         IMPOSNFTOT.CDIMPOSTO  = IMPOSTO.CDIMPOSTO AND
         IDTRATIMPO = w_D;

   IF NOT (V_LIQUIDO IS NULL) AND (P_TIPOOPER <> w_12) THEN
      V_TOTALNOTA := V_LIQUIDO;
   END IF;

   IF NOT (V_SOMAIMPO IS NULL) THEN
      V_TOTALNOTA := V_TOTALNOTA + V_SOMAIMPO;
   END IF;

   IF NOT (V_MENOIMPO IS NULL) THEN
      V_TOTALNOTA := V_TOTALNOTA - V_MENOIMPO;
   END IF;

   IF NOT (V_SOMAENCA IS NULL) THEN
      V_TOTALNOTA := V_TOTALNOTA + V_SOMAENCA;
   END IF;

   IF NOT (V_MENOENCA IS NULL) THEN
      V_TOTALNOTA := V_TOTALNOTA - V_MENOENCA;
   END IF;

   --VALOR SUBSTITUIÇÃO TRIBUTÁRIA COM IDENTIFICAÇÃO PARA ACRESCER AO TOTAL DA NF
   IF V_IDOPERDEVONF = 'S' THEN
      SELECT NVL(ROUND(SUM(VRIMPOSTOIT + NVL(VRADICFECP, 0)), V_NRDECITOTANF),0)
        INTO   V_SOMAIMPO
        FROM ITEMPROIMPOS IT, IMPOSTO I
       WHERE CDFILIAL     = P_FILIAL           AND
             NRLANCTONF   = P_LANCTONF         AND
             IT.CDIMPOSTO = I.CDIMPOSTO        AND
             NVL(I.IDACRPRODENTRNF, 'N') = 'N' AND
             NVL(IT.IDTRIMPSTII, '0')     = '0' AND
         EXISTS(SELECT CDIMPOSTO
                  FROM IMPOSTO
                 WHERE CDIMPOSTRIB = IT.CDIMPOSTO);
   ELSE
      SELECT NVL(ROUND(SUM(IT.VRIMPOSTOIT + NVL(VRADICFECP, 0)), V_NRDECITOTANF),0)
      INTO   V_SOMAIMPO
      FROM ITEMPROIMPOS IT, IMPOSTO I
      WHERE IT.CDFILIAL    = P_FILIAL    AND
            IT.NRLANCTONF  = P_LANCTONF  AND
            IT.CDIMPOSTO   = I.CDIMPOSTO AND
            NVL(IT.IDTRIMPSTII, '0')     = '0' AND
            EXISTS(SELECT CDIMPOSTO
                   FROM IMPOSTO
                   WHERE CDIMPOSTRIB = IT.CDIMPOSTO);
   END IF;

   IF NOT (V_SOMAIMPO IS NULL) THEN
      V_TOTALNOTA := V_TOTALNOTA + V_SOMAIMPO;
   END IF;

   -- Subtrai o valor dos importos a reter no valor da nota fiscal
   BEGIN
      SELECT SUM(VRIMPOSTOIT)
        INTO V_VRIMPORETNF
        FROM ITEMPROIMPOS T, IMPOSTO I
       WHERE CDFILIAL     = P_FILIAL
         AND NRLANCTONF   = P_LANCTONF
         AND I.CDIMPOSTO  = T.CDIMPOSTO
         AND IDTRATIMPO   = 'R'
         AND IDDESCRFONTE = 'N';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_VRIMPORETNF := 0;
   END;

   IF NOT (V_VRIMPORETNF IS NULL) THEN
      V_TOTALNOTA := V_TOTALNOTA - ROUND(V_VRIMPORETNF, 2);
   END IF;

   IF P_TIPOOPER = w_12 THEN

      FOR C_NOTABEBICRED IN (SELECT I.CDPRODUTO, VRTOTAITEM, IDITEMISSAO, IDTPNFCREDEB
                             FROM   ITEMPRODUTO I, ITEMISSAO T
                             WHERE  I.CDFILIAL   = P_FILIAL      AND
                                    I.NRLANCTONF = P_LANCTONF    AND
                                    I.CDPRODUTO  = T.CDPRODUTO
                             ORDER BY IDITEMISSAO) LOOP

          SELECT IDITEMISSAO
          INTO V_IDITEMISSAO
          FROM ITEMISSAO
          WHERE CDPRODUTO = C_NOTABEBICRED.CDPRODUTO;

          IF (V_IDITEMISSAO = w_D) THEN
             UPDATE ITEMPRODUTO
             SET IDTPNFCREDEB = w_2
             WHERE CDFILIAL   = P_FILIAL   AND
                   NRLANCTONF = P_LANCTONF AND
                   CDPRODUTO  = C_NOTABEBICRED.CDPRODUTO;

             V_TOTALNOTA := V_TOTALNOTA + C_NOTABEBICRED.VRTOTAITEM;
          ELSIF (V_IDITEMISSAO = w_C)  THEN
             UPDATE ITEMPRODUTO
             SET IDTPNFCREDEB = w_1
             WHERE CDFILIAL   = P_FILIAL   AND
                   NRLANCTONF = P_LANCTONF AND
                   CDPRODUTO  = C_NOTABEBICRED.CDPRODUTO;

             V_TOTALNOTA := V_TOTALNOTA - C_NOTABEBICRED.VRTOTAITEM;
          ELSE
             UPDATE ITEMPRODUTO
             SET IDTPNFCREDEB = w_3
             WHERE CDFILIAL   = P_FILIAL   AND
                   NRLANCTONF = P_LANCTONF AND
                   CDPRODUTO  = C_NOTABEBICRED.CDPRODUTO;

             V_TOTALNOTA := V_TOTALNOTA - C_NOTABEBICRED.VRTOTAITEM;
          END IF;

          SELECT CDFILIAPFATU, NRAPFATUTNF
          INTO V_CDFILIAPFATU, V_NRAPFATUTNF
          FROM NOTAFISCAL
          WHERE CDFILIAL   = P_FILIAL   AND
                NRLANCTONF = P_LANCTONF;

          IF NOT(V_CDFILIAPFATU IS NULL) AND NOT(V_NRAPFATUTNF IS NULL) THEN

             IF ((C_NOTABEBICRED.IDITEMISSAO = w_D) OR  (C_NOTABEBICRED.IDITEMISSAO = w_O)) AND
                (C_NOTABEBICRED.IDTPNFCREDEB IS NULL)  THEN
                V_TOTALNOTA := V_TOTALNOTA + C_NOTABEBICRED.VRTOTAITEM;
             ELSIF (C_NOTABEBICRED.IDITEMISSAO = w_C)  THEN
                V_TOTALNOTA := V_TOTALNOTA - C_NOTABEBICRED.VRTOTAITEM;
             ELSE
                V_TOTALNOTA := V_TOTALNOTA + C_NOTABEBICRED.VRTOTAITEM;
             END IF;
          END IF;
      END LOOP;
   END IF;

   /* AJUSTANDO O VALOR DO DIFERIMENTO CASO OCORRA ALGUMA DIFERENÇA DEVIDO AOS ARREDONDAMENTOS */
   FOR C_AJUSTA_DIFERIMENTO IN (SELECT IT.NRSEQITPROD, IT.VRIMPOSTOIT, IT.VRIMPOSTOOPERAIT, IT.VRIMPOSTODIFERIT, 
                                       IT.VRPERDIFEREIT
                                  FROM ITEMPROIMPOS IT JOIN IMPOSTO IM ON (IT.CDIMPOSTO = IM.CDIMPOSTO)
                                 WHERE (IT.VRIMPOSTOIT <> (IT.VRIMPOSTOOPERAIT - IT.VRIMPOSTODIFERIT))
                                   AND (IT.VRPERDIFEREIT IS NOT NULL)
                                   AND (IM.CDIMPOSTONFE = '00')
                                   AND (IT.NRITPROIMPOS = '1')
                                   AND (IT.CDFILIAL = P_FILIAL)
                                   AND (IT.NRLANCTONF = P_LANCTONF)
                                 ORDER BY IT.NRSEQITPROD)
   LOOP
      UPDATE ITEMPROIMPOS
         SET VRIMPOSTODIFERIT = VRIMPOSTODIFERIT + (C_AJUSTA_DIFERIMENTO.VRIMPOSTOOPERAIT - C_AJUSTA_DIFERIMENTO.VRIMPOSTOIT - C_AJUSTA_DIFERIMENTO.VRIMPOSTODIFERIT)
       WHERE CDFILIAL = P_FILIAL
         AND NRLANCTONF = P_LANCTONF
         AND NRSEQITPROD = C_AJUSTA_DIFERIMENTO.NRSEQITPROD;
   END LOOP;

   CONSULTA_DESONERACAO(P_FILIAL, P_LANCTONF, V_IMPOSDESONERA);

   V_TOTALNOTA := V_TOTALNOTA - V_IMPOSDESONERA;

   IF V_NRDECITOTANF <> 0 THEN
      V_TOTALNOTA := ROUND(V_TOTALNOTA, 2);
   END IF;

   IF (V_IDCONTCONFORIG = 'N') OR (V_IDOPERDEVONF <> w_S) THEN
      SELECT NVL(V_TOTALNOTA,0) - SUM(ROUND(NVL(VRBRUTITEM,0), 5))
        INTO V_DIFEVRBRUTO
        FROM ITEMPRODUTO
       WHERE CDFILIAL = P_FILIAL
         AND NRLANCTONF = P_LANCTONF;

      IF V_DIFEVRBRUTO <> 0 THEN
         UPDATE ITEMPRODUTO
            SET VRBRUTITEM = ROUND(VRBRUTITEM + V_DIFEVRBRUTO,5)
          WHERE CDFILIAL = P_FILIAL
            AND NRLANCTONF = P_LANCTONF
            AND NRSEQITPROD = (SELECT MAX(I.NRSEQITPROD)
                                 FROM ITEMPRODUTO I
                                WHERE I.CDFILIAL     = P_FILIAL
                                  AND I.NRLANCTONF   = P_LANCTONF
                                  AND VRTOTAITEM = (SELECT MAX(VRTOTAITEM)
                                                      FROM ITEMPRODUTO I
                                                     WHERE I.CDFILIAL     = P_FILIAL
                                                       AND I.NRLANCTONF   = P_LANCTONF));

      END IF;
   END IF;

-- RECALCULO DO VALOR CONTABIL DO ITEM

   FOR C_ITEM IN (SELECT II.CDIMPOSTO, I.VRBRUTITEM, I.NRSEQITPROD, I.VRCONTITEM
                  FROM ITEMPRODUTO I, ITEMPROIMPOS II
                  WHERE I.CDFILIAL    = P_FILIAL       AND
                        I.NRLANCTONF  = P_LANCTONF     AND
                        I.CDFILIAL    = II.CDFILIAL    AND
                        I.NRLANCTONF  = II.NRLANCTONF  AND
                        I.NRSEQITPROD = II.NRSEQITPROD ) LOOP
      V_ICMS := 'N';
      FOR C_ICMS IN (SELECT CDIMPOSTO
                       FROM IMPOSTONFE N, IMPOSTO I
                      WHERE N.CDIMPOSTONFE = I.CDIMPOSTONFE
                        AND N.CDIMPOSTONFE = '00'
                        AND I.CDIMPOSTO = C_ITEM.CDIMPOSTO)
      LOOP
         V_ICMS := 'S';
      END LOOP;

      IF ((V_IDSISTEMA = 'VND') OR (V_IDSISTEMA = 'PDV')) AND (V_ICMS = 'S') THEN
         UPDATE ITEMPROIMPOS
         SET VRCONTITIMP = TRUNC(VRCONTITIMP,2)
         WHERE (NRLANCTONF   = P_LANCTONF)         AND
               (CDFILIAL     = P_FILIAL)           AND
               (NRSEQITPROD  = C_ITEM.NRSEQITPROD) AND
               (CDIMPOSTO    = C_ITEM.CDIMPOSTO)   AND
               (NRITPROIMPOS = w_2);
      ELSE
         UPDATE ITEMPROIMPOS
         SET VRCONTITIMP = ROUND(VRCONTITIMP,5)    
         WHERE (NRLANCTONF   = P_LANCTONF)         AND
               (CDFILIAL     = P_FILIAL)           AND
               (NRSEQITPROD  = C_ITEM.NRSEQITPROD) AND
               (CDIMPOSTO    = C_ITEM.CDIMPOSTO)   AND
               (NRITPROIMPOS = w_2);
      END IF;

      Begin
         SELECT NVL(VRCONTITIMP,0)
         INTO   V_VRREDUCAO
         FROM ITEMPROIMPOS
         WHERE (NRLANCTONF   = P_LANCTONF)         AND
               (CDFILIAL     = P_FILIAL)           AND
               (NRSEQITPROD  = C_ITEM.NRSEQITPROD) AND
               (CDIMPOSTO    = C_ITEM.CDIMPOSTO)   AND
               (NRITPROIMPOS = w_2);
      Exception
         When No_Data_Found Then
            V_VRREDUCAO := 0;
      End;

      IF V_VRREDUCAO IS NULL THEN
         V_VRREDUCAO := 0;
      END IF;

      V_ICMS := 'N';
      FOR C_ICMS IN (SELECT CDIMPOSTO
                       FROM IMPOSTONFE N, IMPOSTO I
                      WHERE N.CDIMPOSTONFE = I.CDIMPOSTONFE
                        AND N.CDIMPOSTONFE = '00'
                        AND I.CDIMPOSTO = C_ITEM.CDIMPOSTO)
      LOOP
         V_ICMS := 'S';
      END LOOP;

      IF (NVL(V_IDUTDESCICMS, 'N') <> 'S') THEN
         IF ((V_IDSISTEMA = 'VND') OR (V_IDSISTEMA = 'PDV')) AND (V_ICMS = 'S') THEN
            UPDATE ITEMPROIMPOS
            SET VRCONTITIMP = TRUNC((C_ITEM.VRBRUTITEM - V_VRREDUCAO),2)
            WHERE (NRLANCTONF   = P_LANCTONF)         AND
                  (CDFILIAL     = P_FILIAL)           AND
                  (NRSEQITPROD  = C_ITEM.NRSEQITPROD) AND
                  (CDIMPOSTO    = C_ITEM.CDIMPOSTO)   AND
                  (NRITPROIMPOS = w_1)                AND
                  (NOT EXISTS(SELECT CDIMPOSTO
                              FROM IMPOSTO
                              WHERE CDIMPOSTRIB = ITEMPROIMPOS.CDIMPOSTO));
         ELSE
            UPDATE ITEMPROIMPOS
            SET VRCONTITIMP = ROUND((C_ITEM.VRBRUTITEM - V_VRREDUCAO),5)  
            WHERE (NRLANCTONF   = P_LANCTONF)         AND
                  (CDFILIAL     = P_FILIAL)           AND
                  (NRSEQITPROD  = C_ITEM.NRSEQITPROD) AND
                  (CDIMPOSTO    = C_ITEM.CDIMPOSTO)   AND
                  (NRITPROIMPOS = w_1)                AND
                  (NOT EXISTS(SELECT CDIMPOSTO
                              FROM IMPOSTO
                              WHERE CDIMPOSTRIB = ITEMPROIMPOS.CDIMPOSTO));
         END IF;
      ELSE
         IF ((V_IDSISTEMA = 'VND') OR (V_IDSISTEMA = 'PDV')) AND (V_ICMS = 'S') THEN
            UPDATE ITEMPROIMPOS
            SET VRCONTITIMP = TRUNC((C_ITEM.VRCONTITEM- V_VRREDUCAO),2)
            WHERE (NRLANCTONF   = P_LANCTONF)         AND
                  (CDFILIAL     = P_FILIAL)           AND
                  (NRSEQITPROD  = C_ITEM.NRSEQITPROD) AND
                  (CDIMPOSTO    = C_ITEM.CDIMPOSTO)   AND
                  (NRITPROIMPOS = w_1)                AND
                  (NOT EXISTS(SELECT CDIMPOSTO
                              FROM IMPOSTO
                              WHERE CDIMPOSTRIB = ITEMPROIMPOS.CDIMPOSTO));
         ELSE
            UPDATE ITEMPROIMPOS
            SET VRCONTITIMP = ROUND((C_ITEM.VRCONTITEM - V_VRREDUCAO),5)  
            WHERE (NRLANCTONF   = P_LANCTONF)         AND
                  (CDFILIAL     = P_FILIAL)           AND
                  (NRSEQITPROD  = C_ITEM.NRSEQITPROD) AND
                  (CDIMPOSTO    = C_ITEM.CDIMPOSTO)   AND
                  (NRITPROIMPOS = w_1)                AND
                  (NOT EXISTS(SELECT CDIMPOSTO
                              FROM IMPOSTO
                              WHERE CDIMPOSTRIB = ITEMPROIMPOS.CDIMPOSTO));
         END IF;
      END IF;

      IF ((V_IDSISTEMA = 'VND') OR (V_IDSISTEMA = 'PDV')) AND (V_ICMS = 'S') THEN
         UPDATE ITEMPROIMPOS
         SET VRCONTITIMP = TRUNC(C_ITEM.VRBRUTITEM,2)
         WHERE (NRLANCTONF   = P_LANCTONF)         AND
               (CDFILIAL     = P_FILIAL)           AND
               (NRSEQITPROD  = C_ITEM.NRSEQITPROD) AND
               (CDIMPOSTO    = C_ITEM.CDIMPOSTO)   AND
               (NRITPROIMPOS = w_1)                AND
               (EXISTS(SELECT CDIMPOSTO
                       FROM IMPOSTO
                       WHERE CDIMPOSTRIB = ITEMPROIMPOS.CDIMPOSTO));
      ELSE
         UPDATE ITEMPROIMPOS
         SET VRCONTITIMP = ROUND(C_ITEM.VRBRUTITEM,5)   
         WHERE (NRLANCTONF   = P_LANCTONF)         AND
               (CDFILIAL     = P_FILIAL)           AND
               (NRSEQITPROD  = C_ITEM.NRSEQITPROD) AND
               (CDIMPOSTO    = C_ITEM.CDIMPOSTO)   AND
               (NRITPROIMPOS = w_1)                AND
               (EXISTS(SELECT CDIMPOSTO
                       FROM IMPOSTO
                       WHERE CDIMPOSTRIB = ITEMPROIMPOS.CDIMPOSTO));
      END IF;

   END LOOP;

   ARREDONDA_BASECALC(w_S, P_FILIAL, P_LANCTONF);

   V_SEQUIMPOSTNF := w_01;

   UPDATE ITEMPROIMPOS
      SET CDFISCALIT = '2',
          VRBASECALCIT = 0	      
    WHERE CDFILIAL = P_FILIAL
      AND NRLANCTONF = P_LANCTONF
      AND VRPERREDBCIT > 0.00
      AND NRITPROIMPOS = '2';

   /*ESTE UPDATE ESTA SENDO REALIZADO PARA EVITAR QUE EXISTAM LANCAMENTOS COM BASE DE CÁLCULO E SEM IMPOSTO E SEM ALIQUOTA*/
   UPDATE ITEMPROIMPOS
      SET VRBASECALCIT = 0
    WHERE CDFILIAL     = P_FILIAL
      AND NRLANCTONF   = P_LANCTONF
      AND NRITPROIMPOS = W_1
      AND CDFISCALIT   = W_1
      AND VRALIQITEM   = 0.00
      AND VRIMPOSTOIT  = 0.00;

   /* GERANDO INFORMAÇÕES NA TABELA IMPOSTONF */
   IF V_NRDECITOTANF = 0 THEN
      IF V_IDOPERDEVONF = W_S THEN
         FOR C_IMPOSTONF IN (SELECT IT.CDIMPOSTO, 
                                    VRALIQITEM, 
                                    VRPERREDBCIT, 
                                    VRPARDEDIT, 
                                    CDFISCALIT,
                                    CDSITUTRIBIT, 
                                    CDFISCOPERIT, 
                                    CDSUFXCFOPIT, 
                                    IDTRIMPSTII,
                                    IT.VRADICALIQFECP,
                                    SUM(VRCONTITIMP) AS VRCONTITIMP,
                                    SUM(VRBASECALCIT) AS VRBASECALCIT, 
                                    SUM(VRIMPOSTOIT) AS VRIMPOSTOIT,
                                    MAX(NRITPROIMPOS) AS NRITPROIMPOS,
                                    SUM(VRBCICMSSTRETIDO) AS VRBCICMSSTRETIDO, 
                                    SUM(VRICMSSTRETIDO) VRICMSSTRETIDO,
                                    SUM(IT.VRADICFECP) AS VRADICFECP,
                                    NVL(IDDIFALIQCUSPRI, 'N') AS IDDIFALIQCUSPRI
                               FROM ITEMPROIMPOS IT, IMPOSTO I
                              WHERE (CDFILIAL = P_FILIAL)
                                AND (NRLANCTONF = P_LANCTONF)
                                AND (IT.CDIMPOSTO = I.CDIMPOSTO) 
                                AND (((CDFISCALIT = w_1) AND (IDIMPORECUP = w_S)) OR ((IDIMPORECUP <> w_S) AND (VRALIQITEM <> 0)))
                              GROUP BY IT.CDIMPOSTO, 
                                    VRALIQITEM, 
                                    VRPERREDBCIT, 
                                    VRPARDEDIT, 
                                    CDFISCALIT,
                                    CDSITUTRIBIT, 
                                    CDFISCOPERIT, 
                                    CDSUFXCFOPIT, 
                                    IDTRIMPSTII, 
                                    IT.VRADICALIQFECP,
                                    IDDIFALIQCUSPRI
                              UNION
                             SELECT IT.CDIMPOSTO, 
                                    0 AS VRALIQITEM, 
                                    0 AS VRPERREDBCIT, 
                                    0 AS VRPARDEDIT, 
                                    CDFISCALIT,
                                    CDSITUTRIBIT, 
                                    CDFISCOPERIT, 
                                    CDSUFXCFOPIT, 
                                    IDTRIMPSTII, 
                                    IT.VRADICALIQFECP,
                                    SUM(VRCONTITIMP) AS VRCONTITIMP,
                                    0 AS VRBASECALCIT, 
                                    0 AS VRIMPOSTOIT,
                                    MAX(NRITPROIMPOS) AS NRITPROIMPOS,
                                    SUM(VRBCICMSSTRETIDO) AS VRBCICMSSTRETIDO, 
                                    SUM(VRICMSSTRETIDO) AS VRICMSSTRETIDO,
                                    SUM(IT.VRADICFECP) AS VRADICFECP,
                                    NVL(IDDIFALIQCUSPRI, 'N') AS IDDIFALIQCUSPRI
                               FROM ITEMPROIMPOS IT, IMPOSTO I
                              WHERE (CDFILIAL = P_FILIAL)
                                AND (NRLANCTONF = P_LANCTONF)
                                AND (IT.CDIMPOSTO = I.CDIMPOSTO) 
                                AND (NRITPROIMPOS <> w_3)
                                AND (((CDFISCALIT <> w_1) AND (IDIMPORECUP = w_S)) OR ((IDIMPORECUP <> w_S) AND (VRALIQITEM = 0))) 
                              GROUP BY IT.CDIMPOSTO, 
                                    CDFISCALIT, 
                                    CDSITUTRIBIT,
                                    CDFISCOPERIT, 
                                    CDSUFXCFOPIT, 
                                    IDTRIMPSTII, 
                                    IT.VRADICALIQFECP,
                                    IDDIFALIQCUSPRI
                              UNION
                             SELECT IT.CDIMPOSTO, 
                                    VRALIQITEM, 
                                    VRPERREDBCIT, 
                                    VRPARDEDIT, 
                                    CDFISCALIT,
                                    CDSITUTRIBIT, 
                                    CDFISCOPERIT, 
                                    CDSUFXCFOPIT, 
                                    IDTRIMPSTII, 
                                    IT.VRADICALIQFECP,
                                    SUM(VRCONTITIMP) AS VRCONTITIMP,
                                    SUM(VRBASECALCIT) AS VRBASECALCIT, 
                                    SUM(VRIMPOSTOIT) AS VRIMPOSTOIT,
                                    MAX(NRITPROIMPOS) AS NRITPROIMPOS,
                                    SUM(VRBCICMSSTRETIDO) VRBCICMSSTRETIDO, 
                                    SUM(VRICMSSTRETIDO) VRICMSSTRETIDO,
                                    SUM(IT.VRADICFECP) AS VRADICFECP,
                                    NVL(IDDIFALIQCUSPRI, 'N') AS IDDIFALIQCUSPRI
                               FROM ITEMPROIMPOS IT, IMPOSTO I
                              WHERE (CDFILIAL = P_FILIAL)
                                AND (NRLANCTONF = P_LANCTONF)
                                AND (IT.CDIMPOSTO = I.CDIMPOSTO)
                                AND (NRITPROIMPOS = w_3)
                              GROUP BY 
                                    IT.CDIMPOSTO, 
                                    VRALIQITEM, 
                                    VRPERREDBCIT, 
                                    VRPARDEDIT, 
                                    CDFISCALIT,
                                    CDSITUTRIBIT, 
                                    CDFISCOPERIT, 
                                    CDSUFXCFOPIT, 
                                    IDTRIMPSTII, 
                                    IT.VRADICALIQFECP,
                                    IDDIFALIQCUSPRI) 
         LOOP
            V_ICMS := 'N';
            FOR C_ICMS IN (SELECT CDIMPOSTO
                             FROM IMPOSTONFE N, IMPOSTO I
                            WHERE N.CDIMPOSTONFE = I.CDIMPOSTONFE
                              AND N.CDIMPOSTONFE = '00'
                              AND I.CDIMPOSTO = C_IMPOSTONF.CDIMPOSTO)
            LOOP
               V_ICMS := 'S';
            END LOOP;
            
            IF ((V_IDSISTEMA = 'VND') OR (V_IDSISTEMA = 'PDV')) AND (V_ICMS = 'S') THEN
               INSERT INTO IMPOSTONF(
                  CDFILIAL, NRLANCTONF, CDIMPOSTO, NRIMPOSNF, 
                  VRCONTABILNF, VRPERREDBCNF, VRBASECALCNF, VRALIQNF, 
                  VRPARDEDNF, VRIMPOSTONF, CDFISCALNF, CDSITUTRIBNF,
                  CDFISCOPERNF, CDSUFXCFOPNF, IDIMPOSTONF, VRBCICMSSTRETIDO, 
                  VRICMSSTRETIDO, IDTRIMPOSTNF, IDDIFALIQCUSPRN, VRADICALIQFECP, 
                  VRADICFECP)
               VALUES(
                  P_FILIAL, P_LANCTONF, C_IMPOSTONF.CDIMPOSTO, V_SEQUIMPOSTNF, 
                  C_IMPOSTONF.VRCONTITIMP, C_IMPOSTONF.VRPERREDBCIT, C_IMPOSTONF.VRBASECALCIT, C_IMPOSTONF.VRALIQITEM, 
                  C_IMPOSTONF.VRPARDEDIT, TRUNC(C_IMPOSTONF.VRIMPOSTOIT,0), C_IMPOSTONF.CDFISCALIT, C_IMPOSTONF.CDSITUTRIBIT,
                  C_IMPOSTONF.CDFISCOPERIT, C_IMPOSTONF.CDSUFXCFOPIT, C_IMPOSTONF.NRITPROIMPOS, C_IMPOSTONF.VRBCICMSSTRETIDO, 
                  C_IMPOSTONF.VRICMSSTRETIDO, C_IMPOSTONF.IDTRIMPSTII, C_IMPOSTONF.IDDIFALIQCUSPRI, C_IMPOSTONF.VRADICALIQFECP, 
                  C_IMPOSTONF.VRADICFECP);
            ELSE
               INSERT INTO IMPOSTONF(
                  CDFILIAL, NRLANCTONF, CDIMPOSTO, NRIMPOSNF, 
                  VRCONTABILNF, VRPERREDBCNF, VRBASECALCNF, VRALIQNF, 
                  VRPARDEDNF, VRIMPOSTONF, CDFISCALNF, CDSITUTRIBNF,
                  CDFISCOPERNF, CDSUFXCFOPNF, IDIMPOSTONF, VRBCICMSSTRETIDO, 
                  VRICMSSTRETIDO, IDTRIMPOSTNF, IDDIFALIQCUSPRN, VRADICALIQFECP, 
                  VRADICFECP)
               VALUES(
                  P_FILIAL, P_LANCTONF, C_IMPOSTONF.CDIMPOSTO, V_SEQUIMPOSTNF, 
                  C_IMPOSTONF.VRCONTITIMP, C_IMPOSTONF.VRPERREDBCIT, C_IMPOSTONF.VRBASECALCIT, C_IMPOSTONF.VRALIQITEM, 
                  C_IMPOSTONF.VRPARDEDIT, ROUND(C_IMPOSTONF.VRIMPOSTOIT,0), C_IMPOSTONF.CDFISCALIT, C_IMPOSTONF.CDSITUTRIBIT,
                  C_IMPOSTONF.CDFISCOPERIT, C_IMPOSTONF.CDSUFXCFOPIT, C_IMPOSTONF.NRITPROIMPOS, C_IMPOSTONF.VRBCICMSSTRETIDO, 
                  C_IMPOSTONF.VRICMSSTRETIDO, C_IMPOSTONF.IDTRIMPSTII, C_IMPOSTONF.IDDIFALIQCUSPRI, C_IMPOSTONF.VRADICALIQFECP, 
                  C_IMPOSTONF.VRADICFECP);
            END IF;

            V_SEQUIMPOSTNF := LPAD(RTRIM(TO_CHAR(TO_NUMBER(V_SEQUIMPOSTNF) + 1)),2,0);
         END LOOP;
      ELSE
         FOR C_IMPOSTONF IN (SELECT IT.CDIMPOSTO, 
                                    VRALIQITEM, 
                                    VRPERREDBCIT, 
                                    VRPARDEDIT, 
                                    CDFISCALIT, 
                                    CDSITUTRIBIT,
                                    CDFISCOPERIT, 
                                    CDSUFXCFOPIT, 
                                    IDTRIMPSTII, 
                                    IT.VRADICALIQFECP,
                                    SUM(ROUND(VRCONTITIMP,5)) AS VRCONTITIMP, 
                                    SUM(VRBASECALCIT) AS VRBASECALCIT, 
                                    SUM(VRIMPOSTOIT) AS VRIMPOSTOIT, 
                                    NRITPROIMPOS, 
                                    SUM(VRBCICMSSTRETIDO) AS VRBCICMSSTRETIDO, 
                                    SUM(IT.VRADICFECP) AS VRADICFECP,
                                    SUM(VRICMSSTRETIDO) VRICMSSTRETIDO
                             FROM ITEMPROIMPOS IT, IMPOSTO I
                             WHERE (CDFILIAL = P_FILIAL)
                               AND (NRLANCTONF = P_LANCTONF)
                               AND (IT.CDIMPOSTO = I.CDIMPOSTO)
                               AND (((CDFISCALIT = w_1) AND (IDIMPORECUP = w_S)) OR ((IDIMPORECUP <> w_S) AND (VRALIQITEM <> 0)))
                             GROUP BY IT.CDIMPOSTO, 
                                   VRALIQITEM, 
                                   VRPERREDBCIT, 
                                   VRPARDEDIT, 
                                   CDFISCALIT,
                                   CDSITUTRIBIT,
                                   CDFISCOPERIT,
                                   CDSUFXCFOPIT,
                                   IDTRIMPSTII,
                                   IT.VRADICALIQFECP,
                                   NRITPROIMPOS
                             UNION
                            SELECT IT.CDIMPOSTO, 
                                   0 AS VRALIQITEM, 
                                   0 AS VRPERREDBCIT, 
                                   0 AS VRPARDEDIT, 
                                   CDFISCALIT, 
                                   CDSITUTRIBIT,
                                   CDFISCOPERIT, 
                                   CDSUFXCFOPIT, 
                                   IDTRIMPSTII, 
                                   IT.VRADICALIQFECP,
                                   SUM(ROUND(VRCONTITIMP,5)) AS VRCONTITIMP, 
                                   0 AS VRBASECALCIT, 
                                   0 AS VRIMPOSTOIT,  
                                   NRITPROIMPOS, 
                                   SUM(VRBCICMSSTRETIDO) AS VRBCICMSSTRETIDO, 
                                   SUM(IT.VRADICFECP) AS VRADICFECP,
                                   SUM(VRICMSSTRETIDO) AS VRICMSSTRETIDO
                              FROM ITEMPROIMPOS IT, IMPOSTO I
                             WHERE (CDFILIAL = P_FILIAL)
                               AND (NRLANCTONF = P_LANCTONF)
                               AND (IT.CDIMPOSTO = I.CDIMPOSTO)
                               AND (((IT.CDFISCALIT <> w_1) AND (IDIMPORECUP = w_S)) OR ((I.IDIMPORECUP  <> w_S) AND (VRALIQITEM = 0)))
                             GROUP BY IT.CDIMPOSTO, 
                                   CDFISCALIT, 
                                   CDSITUTRIBIT,
                                   CDFISCOPERIT, 
                                   CDSUFXCFOPIT, 
                                   IDTRIMPSTII, 
                                   IT.VRADICALIQFECP,
                                   NRITPROIMPOS) 
         LOOP
            V_ICMS := 'N';
            FOR C_ICMS IN (SELECT CDIMPOSTO
                             FROM IMPOSTONFE N, IMPOSTO I
                            WHERE N.CDIMPOSTONFE = I.CDIMPOSTONFE
                              AND N.CDIMPOSTONFE = '00'
                              AND I.CDIMPOSTO = C_IMPOSTONF.CDIMPOSTO)
            LOOP
               V_ICMS := 'S';
            END LOOP;

            IF ((V_IDSISTEMA = 'VND') OR (V_IDSISTEMA = 'PDV')) AND (V_ICMS = 'S') THEN
               INSERT INTO IMPOSTONF(
                  CDFILIAL, NRLANCTONF, CDIMPOSTO, NRIMPOSNF, 
                  VRCONTABILNF, VRPERREDBCNF, VRBASECALCNF, VRALIQNF, 
                  VRPARDEDNF, VRIMPOSTONF, CDFISCALNF, CDSITUTRIBNF,
                  CDFISCOPERNF, CDSUFXCFOPNF, IDIMPOSTONF, VRBCICMSSTRETIDO, 
                  VRICMSSTRETIDO, IDTRIMPOSTNF, VRADICALIQFECP, VRADICFECP)
               VALUES(
                  P_FILIAL, P_LANCTONF, C_IMPOSTONF.CDIMPOSTO, V_SEQUIMPOSTNF, 
                  C_IMPOSTONF.VRCONTITIMP, C_IMPOSTONF.VRPERREDBCIT, C_IMPOSTONF.VRBASECALCIT, C_IMPOSTONF.VRALIQITEM, 
                  C_IMPOSTONF.VRPARDEDIT, TRUNC(C_IMPOSTONF.VRIMPOSTOIT,0), C_IMPOSTONF.CDFISCALIT, C_IMPOSTONF.CDSITUTRIBIT,
                  C_IMPOSTONF.CDFISCOPERIT, C_IMPOSTONF.CDSUFXCFOPIT, C_IMPOSTONF.NRITPROIMPOS, C_IMPOSTONF.VRBCICMSSTRETIDO, 
                  C_IMPOSTONF.VRICMSSTRETIDO, C_IMPOSTONF.IDTRIMPSTII, C_IMPOSTONF.VRADICALIQFECP, C_IMPOSTONF.VRADICFECP);
            ELSE
               INSERT INTO IMPOSTONF(
                  CDFILIAL, NRLANCTONF, CDIMPOSTO, NRIMPOSNF, 
                  VRCONTABILNF, VRPERREDBCNF, VRBASECALCNF, VRALIQNF, 
                  VRPARDEDNF, VRIMPOSTONF, CDFISCALNF, CDSITUTRIBNF,
                  CDFISCOPERNF, CDSUFXCFOPNF, IDIMPOSTONF, VRBCICMSSTRETIDO, 
                  VRICMSSTRETIDO, IDTRIMPOSTNF, VRADICALIQFECP, VRADICFECP)
               VALUES(
                  P_FILIAL, P_LANCTONF, C_IMPOSTONF.CDIMPOSTO, V_SEQUIMPOSTNF, 
                  C_IMPOSTONF.VRCONTITIMP, C_IMPOSTONF.VRPERREDBCIT, C_IMPOSTONF.VRBASECALCIT, C_IMPOSTONF.VRALIQITEM, 
                  C_IMPOSTONF.VRPARDEDIT, ROUND(C_IMPOSTONF.VRIMPOSTOIT,0), C_IMPOSTONF.CDFISCALIT, C_IMPOSTONF.CDSITUTRIBIT,
                  C_IMPOSTONF.CDFISCOPERIT, C_IMPOSTONF.CDSUFXCFOPIT, C_IMPOSTONF.NRITPROIMPOS, C_IMPOSTONF.VRBCICMSSTRETIDO, 
                  C_IMPOSTONF.VRICMSSTRETIDO, C_IMPOSTONF.IDTRIMPSTII, C_IMPOSTONF.VRADICALIQFECP, C_IMPOSTONF.VRADICFECP);
            END IF;

            V_SEQUIMPOSTNF := LPAD(RTRIM(TO_CHAR(TO_NUMBER(V_SEQUIMPOSTNF) + 1)),2,0);
         END LOOP;
      END IF;

   ELSE
      IF V_IDOPERDEVONF = w_S THEN
         FOR C_IMPOSTONF IN (SELECT IT.CDIMPOSTO, 
                                    VRALIQITEM, 
                                    VRPERREDBCIT, 
                                    VRPARDEDIT, 
                                    CDFISCALIT, 
                                    CDSITUTRIBIT,
                                    CDFISCOPERIT, 
                                    CDSUFXCFOPIT, 
                                    IDTRIMPSTII, 
                                    IT.VRADICALIQFECP,
                                    SUM(VRCONTITIMP) AS VRCONTITIMP, 
                                    SUM(VRBASECALCIT) AS VRBASECALCIT, 
                                    SUM(VRIMPOSTOIT) AS VRIMPOSTOIT,
                                    MAX(NRITPROIMPOS) AS NRITPROIMPOS, 
                                    SUM(VRBCICMSSTRETIDO) AS VRBCICMSSTRETIDO, 
                                    SUM(VRICMSSTRETIDO) AS VRICMSSTRETIDO,
                                    SUM(IT.VRADICFECP) AS VRADICFECP,
                                    NVL(IDDIFALIQCUSPRI, 'N') AS IDDIFALIQCUSPRI
                               FROM ITEMPROIMPOS IT, IMPOSTO I
                              WHERE (CDFILIAL = P_FILIAL)
                                AND (NRLANCTONF = P_LANCTONF)
                                AND (IT.CDIMPOSTO = I.CDIMPOSTO)
                                AND (((CDFISCALIT = w_1) AND (IDIMPORECUP = w_S)) OR ((IDIMPORECUP <> w_S) AND (VRALIQITEM <> 0)))
                              GROUP BY IT.CDIMPOSTO, 
                                    VRALIQITEM, 
                                    VRPERREDBCIT, 
                                    VRPARDEDIT, 
                                    CDFISCALIT,
                                    CDSITUTRIBIT, 
                                    CDFISCOPERIT, 
                                    CDSUFXCFOPIT, 
                                    IDTRIMPSTII, 
                                    IT.VRADICALIQFECP,
                                    IDDIFALIQCUSPRI
                              UNION
                             SELECT IT.CDIMPOSTO, 
                                    0 AS VRALIQITEM, 
                                    0 AS VRPERREDBCIT, 
                                    0 AS VRPARDEDIT, 
                                    CDFISCALIT, 
                                    CDSITUTRIBIT,
                                    CDFISCOPERIT, 
                                    CDSUFXCFOPIT, 
                                    IDTRIMPSTII, 
                                    IT.VRADICALIQFECP,
                                    SUM(VRCONTITIMP) AS VRCONTITIMP, 
                                    0 AS VRBASECALCIT, 
                                    0 AS VRIMPOSTOIT,
                                    MAX(NRITPROIMPOS) AS NRITPROIMPOS, 
                                    SUM(VRBCICMSSTRETIDO) AS VRBCICMSSTRETIDO, 
                                    SUM(VRICMSSTRETIDO) AS VRICMSSTRETIDO,
                                    SUM(IT.VRADICFECP) AS VRADICFECP,
                                    NVL(IDDIFALIQCUSPRI, 'N') AS IDDIFALIQCUSPRI
                               FROM ITEMPROIMPOS IT, IMPOSTO I
                              WHERE (CDFILIAL = P_FILIAL)
                                AND (NRLANCTONF = P_LANCTONF)
                                AND (IT.CDIMPOSTO = I.CDIMPOSTO)
                                AND (NRITPROIMPOS <> w_3)
                                AND (((CDFISCALIT <> w_1) AND (IDIMPORECUP = w_S)) OR ((IDIMPORECUP <> w_S) AND (VRALIQITEM = 0)))
                              GROUP BY IT.CDIMPOSTO, 
                                    CDFISCALIT, 
                                    CDSITUTRIBIT,
                                    CDFISCOPERIT, 
                                    CDSUFXCFOPIT, 
                                    IDTRIMPSTII, 
                                    IT.VRADICALIQFECP,
                                    IDDIFALIQCUSPRI
                              UNION
                             SELECT IT.CDIMPOSTO, 
                                    VRALIQITEM, 
                                    VRPERREDBCIT, 
                                    VRPARDEDIT, 
                                    CDFISCALIT, 
                                    CDSITUTRIBIT,
                                    CDFISCOPERIT, 
                                    CDSUFXCFOPIT, 
                                    IDTRIMPSTII, 
                                    IT.VRADICALIQFECP,
                                    SUM(VRCONTITIMP) AS VRCONTITIMP, 
                                    SUM(VRBASECALCIT) AS VRBASECALCIT, 
                                    SUM(VRIMPOSTOIT) AS VRIMPOSTOIT,
                                    MAX(NRITPROIMPOS) AS NRITPROIMPOS, 
                                    SUM(VRBCICMSSTRETIDO) AS VRBCICMSSTRETIDO, 
                                    SUM(VRICMSSTRETIDO) AS VRICMSSTRETIDO,
                                    SUM(IT.VRADICFECP) AS VRADICFECP,
                                    NVL(IDDIFALIQCUSPRI, 'N') AS IDDIFALIQCUSPRI
                               FROM ITEMPROIMPOS IT, IMPOSTO I
                              WHERE (CDFILIAL = P_FILIAL)
                                AND (NRLANCTONF = P_LANCTONF)
                                AND (IT.CDIMPOSTO = I.CDIMPOSTO) 
                                AND (NRITPROIMPOS = w_3)
                              GROUP BY IT.CDIMPOSTO, 
                                    VRALIQITEM, 
                                    VRPERREDBCIT, 
                                    VRPARDEDIT, 
                                    CDFISCALIT,
                                    CDSITUTRIBIT,
                                    CDFISCOPERIT,
                                    CDSUFXCFOPIT,
                                    IDTRIMPSTII,
                                    IT.VRADICALIQFECP,
                                    IDDIFALIQCUSPRI) 
         LOOP
            V_ICMS := 'N';
            FOR C_ICMS IN (SELECT CDIMPOSTO
                             FROM IMPOSTONFE N, IMPOSTO I
                            WHERE N.CDIMPOSTONFE = I.CDIMPOSTONFE
                              AND N.CDIMPOSTONFE = '00'
                              AND I.CDIMPOSTO = C_IMPOSTONF.CDIMPOSTO)
            LOOP
               V_ICMS := 'S';
            END LOOP;

            IF ((V_IDSISTEMA = 'VND') OR (V_IDSISTEMA = 'PDV')) AND (V_ICMS = 'S') THEN
               INSERT INTO IMPOSTONF(
                  CDFILIAL, NRLANCTONF, CDIMPOSTO, NRIMPOSNF, 
                  VRCONTABILNF, VRPERREDBCNF, VRBASECALCNF, VRALIQNF, 
                  VRPARDEDNF, VRIMPOSTONF, CDFISCALNF, CDSITUTRIBNF,
                  CDFISCOPERNF, CDSUFXCFOPNF, IDIMPOSTONF, VRBCICMSSTRETIDO, 
                  VRICMSSTRETIDO, IDTRIMPOSTNF, IDDIFALIQCUSPRN, VRADICALIQFECP, 
                  VRADICFECP)
               VALUES(
                  P_FILIAL, P_LANCTONF, C_IMPOSTONF.CDIMPOSTO, V_SEQUIMPOSTNF, 
                  TRUNC(C_IMPOSTONF.VRCONTITIMP,V_NRDECITOTANF), C_IMPOSTONF.VRPERREDBCIT, C_IMPOSTONF.VRBASECALCIT, C_IMPOSTONF.VRALIQITEM, 
                  C_IMPOSTONF.VRPARDEDIT, TRUNC(C_IMPOSTONF.VRIMPOSTOIT,V_NRDECITOTANF), C_IMPOSTONF.CDFISCALIT, C_IMPOSTONF.CDSITUTRIBIT,
                  C_IMPOSTONF.CDFISCOPERIT, C_IMPOSTONF.CDSUFXCFOPIT, C_IMPOSTONF.NRITPROIMPOS, C_IMPOSTONF.VRBCICMSSTRETIDO, 
                  C_IMPOSTONF.VRICMSSTRETIDO, C_IMPOSTONF.IDTRIMPSTII, C_IMPOSTONF.IDDIFALIQCUSPRI, C_IMPOSTONF.VRADICALIQFECP, 
                  C_IMPOSTONF.VRADICFECP);
            ELSE
               INSERT INTO IMPOSTONF(
                  CDFILIAL, NRLANCTONF, CDIMPOSTO, NRIMPOSNF, 
                  VRCONTABILNF, VRPERREDBCNF, VRBASECALCNF, VRALIQNF, 
                  VRPARDEDNF, VRIMPOSTONF, CDFISCALNF, CDSITUTRIBNF,
                  CDFISCOPERNF, CDSUFXCFOPNF, IDIMPOSTONF, VRBCICMSSTRETIDO, 
                  VRICMSSTRETIDO, IDTRIMPOSTNF, IDDIFALIQCUSPRN, VRADICALIQFECP, 
                  VRADICFECP)
               VALUES(
                  P_FILIAL, P_LANCTONF, C_IMPOSTONF.CDIMPOSTO, V_SEQUIMPOSTNF, 
                  ROUND(C_IMPOSTONF.VRCONTITIMP,5), C_IMPOSTONF.VRPERREDBCIT, C_IMPOSTONF.VRBASECALCIT, C_IMPOSTONF.VRALIQITEM, 
                  C_IMPOSTONF.VRPARDEDIT, ROUND(C_IMPOSTONF.VRIMPOSTOIT,V_NRDECITOTANF), C_IMPOSTONF.CDFISCALIT, C_IMPOSTONF.CDSITUTRIBIT,
                  C_IMPOSTONF.CDFISCOPERIT, C_IMPOSTONF.CDSUFXCFOPIT, C_IMPOSTONF.NRITPROIMPOS, C_IMPOSTONF.VRBCICMSSTRETIDO, 
                  C_IMPOSTONF.VRICMSSTRETIDO, C_IMPOSTONF.IDTRIMPSTII, C_IMPOSTONF.IDDIFALIQCUSPRI, C_IMPOSTONF.VRADICALIQFECP, 
                  C_IMPOSTONF.VRADICFECP);
            END IF;

            V_SEQUIMPOSTNF := LPAD(RTRIM(TO_CHAR(TO_NUMBER(V_SEQUIMPOSTNF) + 1)),2,0);
         END LOOP;
      ELSE
         FOR C_IMPOSTONF IN (SELECT IT.CDIMPOSTO, 
                                    VRALIQITEM, 
                                    VRPERREDBCIT, 
                                    VRPARDEDIT, 
                                    CDFISCALIT, 
                                    CDSITUTRIBIT,
                                    CDFISCOPERIT, 
                                    CDSUFXCFOPIT, 
                                    IDTRIMPSTII, 
                                    IT.VRADICALIQFECP,
                                    SUM(ROUND(VRCONTITIMP,5)) AS VRCONTITIMP,
                                    SUM(VRBASECALCIT) AS VRBASECALCIT, 
                                    SUM(VRIMPOSTOIT) AS VRIMPOSTOIT,  
                                    NRITPROIMPOS, 
                                    SUM(VRBCICMSSTRETIDO) AS VRBCICMSSTRETIDO, 
                                    SUM(IT.VRADICFECP) AS VRADICFECP,
                                    SUM(VRICMSSTRETIDO) AS VRICMSSTRETIDO
                               FROM ITEMPROIMPOS IT, IMPOSTO I
                              WHERE (CDFILIAL = P_FILIAL)
                                AND (NRLANCTONF = P_LANCTONF) 
                                AND (IT.CDIMPOSTO = I.CDIMPOSTO) 
                                AND (((CDFISCALIT  = w_1) AND (IDIMPORECUP = w_S)) OR ((IDIMPORECUP <> w_S) AND (VRALIQITEM <> 0)))
                              GROUP BY IT.CDIMPOSTO, 
                                    VRALIQITEM, 
                                    VRPERREDBCIT, 
                                    VRPARDEDIT, 
                                    CDFISCALIT,
                                    CDSITUTRIBIT, 
                                    CDFISCOPERIT, 
                                    CDSUFXCFOPIT, 
                                    IDTRIMPSTII, 
                                    IT.VRADICALIQFECP,
                                    NRITPROIMPOS
                              UNION
                             SELECT IT.CDIMPOSTO, 
                                    0 AS VRALIQITEM, 
                                    0 AS VRPERREDBCIT, 
                                    0 AS VRPARDEDIT, 
                                    CDFISCALIT, 
                                    CDSITUTRIBIT,
                                    CDFISCOPERIT, 
                                    CDSUFXCFOPIT, 
                                    IDTRIMPSTII, 
                                    IT.VRADICALIQFECP,
                                    SUM(ROUND(VRCONTITIMP,5)) AS VRCONTITIMP, 
                                    0 AS VRBASECALCIT, 
                                    0 AS VRIMPOSTOIT,
                                    NRITPROIMPOS, 
                                    SUM(VRBCICMSSTRETIDO) AS VRBCICMSSTRETIDO, 
                                    SUM(IT.VRADICFECP) AS VRADICFECP,
                                    SUM(VRICMSSTRETIDO) AS VRICMSSTRETIDO
                               FROM ITEMPROIMPOS IT, IMPOSTO I
                              WHERE (CDFILIAL      = P_FILIAL)
                                AND (NRLANCTONF    = P_LANCTONF)
                                AND (IT.CDIMPOSTO  = I.CDIMPOSTO)
                                AND (((IT.CDFISCALIT <> w_1) AND (IDIMPORECUP = w_S)) OR ((I.IDIMPORECUP  <> w_S) AND (VRALIQITEM = 0)))
                              GROUP BY 
                                    IT.CDIMPOSTO,
                                    CDFISCALIT,
                                    CDSITUTRIBIT,
                                    CDFISCOPERIT, 
                                    CDSUFXCFOPIT, 
                                    IDTRIMPSTII, 
                                    IT.VRADICALIQFECP,
                                    NRITPROIMPOS) 
         LOOP
            V_ICMS := 'N';
            FOR C_ICMS IN (SELECT CDIMPOSTO
                             FROM IMPOSTONFE N, IMPOSTO I
                            WHERE N.CDIMPOSTONFE = I.CDIMPOSTONFE
                              AND N.CDIMPOSTONFE = '00'
                              AND I.CDIMPOSTO = C_IMPOSTONF.CDIMPOSTO)
            LOOP
               V_ICMS := 'S';
            END LOOP;

            IF ((V_IDSISTEMA = 'VND') OR (V_IDSISTEMA = 'PDV')) AND (V_ICMS = 'S') THEN
               INSERT INTO IMPOSTONF(
                  CDFILIAL, NRLANCTONF, CDIMPOSTO, NRIMPOSNF, 
                  VRCONTABILNF, VRPERREDBCNF, VRBASECALCNF, VRALIQNF, 
                  VRPARDEDNF, VRIMPOSTONF, CDFISCALNF, CDSITUTRIBNF,
                  CDFISCOPERNF, CDSUFXCFOPNF, IDIMPOSTONF, VRBCICMSSTRETIDO, 
                  VRICMSSTRETIDO, IDTRIMPOSTNF, VRADICALIQFECP, VRADICFECP)
               VALUES(
                  P_FILIAL, P_LANCTONF, C_IMPOSTONF.CDIMPOSTO, V_SEQUIMPOSTNF, 
                  C_IMPOSTONF.VRCONTITIMP, C_IMPOSTONF.VRPERREDBCIT, C_IMPOSTONF.VRBASECALCIT, C_IMPOSTONF.VRALIQITEM, 
                  C_IMPOSTONF.VRPARDEDIT, TRUNC(C_IMPOSTONF.VRIMPOSTOIT, V_NRDECITOTANF), C_IMPOSTONF.CDFISCALIT, C_IMPOSTONF.CDSITUTRIBIT,
                  C_IMPOSTONF.CDFISCOPERIT, C_IMPOSTONF.CDSUFXCFOPIT, C_IMPOSTONF.NRITPROIMPOS, C_IMPOSTONF.VRBCICMSSTRETIDO, 
                  C_IMPOSTONF.VRICMSSTRETIDO, C_IMPOSTONF.IDTRIMPSTII, C_IMPOSTONF.VRADICALIQFECP, C_IMPOSTONF.VRADICFECP);
            ELSE
               INSERT INTO IMPOSTONF(
                  CDFILIAL, NRLANCTONF, CDIMPOSTO, NRIMPOSNF, 
                  VRCONTABILNF, VRPERREDBCNF, VRBASECALCNF, VRALIQNF, 
                  VRPARDEDNF, VRIMPOSTONF, CDFISCALNF, CDSITUTRIBNF,
                  CDFISCOPERNF, CDSUFXCFOPNF, IDIMPOSTONF, VRBCICMSSTRETIDO, 
                  VRICMSSTRETIDO, IDTRIMPOSTNF, VRADICALIQFECP, VRADICFECP)
               VALUES(
                  P_FILIAL, P_LANCTONF, C_IMPOSTONF.CDIMPOSTO, V_SEQUIMPOSTNF, 
                  C_IMPOSTONF.VRCONTITIMP, C_IMPOSTONF.VRPERREDBCIT, C_IMPOSTONF.VRBASECALCIT, C_IMPOSTONF.VRALIQITEM, 
                  C_IMPOSTONF.VRPARDEDIT, ROUND(C_IMPOSTONF.VRIMPOSTOIT, V_NRDECITOTANF), C_IMPOSTONF.CDFISCALIT, C_IMPOSTONF.CDSITUTRIBIT,
                  C_IMPOSTONF.CDFISCOPERIT, C_IMPOSTONF.CDSUFXCFOPIT, C_IMPOSTONF.NRITPROIMPOS, C_IMPOSTONF.VRBCICMSSTRETIDO, 
                  C_IMPOSTONF.VRICMSSTRETIDO, C_IMPOSTONF.IDTRIMPSTII, C_IMPOSTONF.VRADICALIQFECP, C_IMPOSTONF.VRADICFECP);
            END IF;
            V_SEQUIMPOSTNF := LPAD(RTRIM(TO_CHAR(TO_NUMBER(V_SEQUIMPOSTNF) + 1)),2,0);
         END LOOP;
      END IF;
   END IF;
   
   FOR C_CARGA IN (SELECT DISTINCT CDIMPOSTO
                     FROM IMPOSTONF
                     WHERE CDFILIAL = P_FILIAL
                       AND NRLANCTONF = P_LANCTONF) LOOP

      V_CARGA := VALOR_CARGA_TRIBUTARIA(C_CARGA.CDIMPOSTO, P_FILIAL, P_LANCTONF);
      IF V_CARGA > 0 THEN
         UPDATE IMPOSTONF
            SET VRIMPCARGATRIBI = V_CARGA
           WHERE CDFILIAL = P_FILIAL
             AND NRLANCTONF = P_LANCTONF
             AND CDIMPOSTO = C_CARGA.CDIMPOSTO
             AND NRIMPOSNF = (SELECT MAX(NRIMPOSNF)
                                      FROM IMPOSTONF
                                      WHERE CDFILIAL = P_FILIAL
                                        AND NRLANCTONF = P_LANCTONF
                                        AND CDIMPOSTO = C_CARGA.CDIMPOSTO);

      END IF;
   END LOOP;

   FOR C_IMPOSTORETI IN (SELECT N.CDEMPRESA, I.CDIMPOSTO, N.IDTPIJURNF, N.NRINSJURNF, N.DTENTRSAID
                         FROM IMPOSTO I, NOTAFISCAL N, IMPOSTONF IP
                         WHERE N.CDFILIAL   = P_FILIAL      AND
                               N.NRLANCTONF = P_LANCTONF    AND
                               N.CDFILIAL   = IP.CDFILIAL   AND
                               N.NRLANCTONF = IP.NRLANCTONF AND
                               IP.CDIMPOSTO = I.CDIMPOSTO   AND
                               I.IDTRATIMPO   = w_R         AND
                               I.IDUTVRMENSBC = w_S) LOOP
      BASECALC_RETIDO('S', P_FILIAL, P_LANCTONF, C_IMPOSTORETI.IDTPIJURNF, C_IMPOSTORETI.NRINSJURNF,
                         C_IMPOSTORETI.DTENTRSAID, C_IMPOSTORETI.CDIMPOSTO, w_S, C_IMPOSTORETI.CDEMPRESA,
                         P_INSCESTA, V_PAISORIG, V_ESTAORIG, V_PAISDEST, V_ESTADEST, V_CDGRUPOFISC, V_CDGRPFISCSV, P_TIPOOPER);
   END LOOP;

/* SE O IPI COMPOR A BASE DE CALCULO DO ICMS E O ICMS TIVER O CODIGO FISCAL IGUAL A 1 SERA ATUALIZADO COM O IDENTIFICADOR 4 */
   FOR C_IMPFISC IN (SELECT CDFILIAL, NRLANCTONF, CDIMPOSTO, CDSITUTRIBNF, CDFISCOPERNF, CDFISCALNF
                       FROM IMPOSTONF IP
                      WHERE IP.CDFILIAL = P_FILIAL
                        AND IP.NRLANCTONF = P_LANCTONF
                        AND IP.IDIMPOSTONF = w_1
                        AND IP.CDFISCALNF = w_1) LOOP


      SELECT MAX(BC.CDIMPOBCALC) AS CDIMPOBCALC
        INTO V_CDIMPOBCALC
        FROM BASECALCTPOPER BC
       WHERE (BC.IDENTRSAIDOP = 'S')
         AND (BC.CDTIPOOPER = P_TIPOOPER)
         AND (BC.CDIMPOSTO = C_IMPFISC.CDIMPOSTO)
         AND (BC.CDIMPOBCALC IS NOT NULL)
         AND ((SUBSTR(C_IMPFISC.CDSITUTRIBNF,2,2)  = BC.CDCSTIMPOTPOP)  OR (BC.CDCSTIMPOTPOP  IS NULL))
         AND ((SUBSTR(C_IMPFISC.CDFISCOPERNF,2,4) = BC.CDCFOPIMPOTPOP) OR (BC.CDCFOPIMPOTPOP IS NULL))
         AND (C_IMPFISC.CDFISCALNF = BC.CDFISCIMPOTPOP) OR (BC.CDFISCIMPOTPOP IS NULL);

      IF V_CDIMPOBCALC IS NULL THEN
         SELECT MAX(BC.CDIMPOBCALC) AS CDIMPOBCALC
           INTO V_CDIMPOBCALC
           FROM BASECALC BC
          WHERE BC.CDIMPOSTO = C_IMPFISC.CDIMPOSTO
            AND BC.CDIMPOBCALC IS NOT NULL
            AND ((SUBSTR(C_IMPFISC.CDSITUTRIBNF,2,2)  = BC.CDCSTIMPO)  OR (BC.CDCSTIMPO  IS NULL))
            AND ((SUBSTR(C_IMPFISC.CDFISCOPERNF,2,10) = BC.CDCFOPIMPO) OR (BC.CDCFOPIMPO IS NULL))
            AND (C_IMPFISC.CDFISCALNF = BC.CDFISCIMPO) OR (BC.CDFISCIMPO IS NULL)
            AND BC.IDTIPOBCALC = 'I';

         IF NOT V_CDIMPOBCALC IS NULL THEN
            UPDATE IMPOSTONF
               SET IDIMPOSTONF = w_4
             WHERE CDFILIAL   = C_IMPFISC.CDFILIAL
               AND NRLANCTONF = C_IMPFISC.NRLANCTONF
               AND CDIMPOSTO  = V_CDIMPOBCALC;
         END IF;
      ELSE
         UPDATE IMPOSTONF
         SET IDIMPOSTONF = '4'
         WHERE CDFILIAL   = C_IMPFISC.CDFILIAL   AND
               NRLANCTONF = C_IMPFISC.NRLANCTONF AND
               CDIMPOSTO  = V_CDIMPOBCALC;
      END IF;
   END LOOP;

   UPDATE NOTAFISCAL
   SET VRNOTAFISC = NVL(V_TOTALNOTA,0),
       VRPRODUTOS = NVL(V_LIQUIDO,0),
       VRDISPNFDEVO = NVL(V_TOTALNOTA,0),
       IDERROS    = w_000
   WHERE CDFILIAL   = P_FILIAL AND
         NRLANCTONF = P_LANCTONF;

   DELETE
     FROM INFOPAGANFE
    WHERE CDFILIAL = P_FILIAL
      AND NRLANCTONF = P_LANCTONF;

   SELECT ROUND(NVL(SUM(IT.VRTOTIMPONF),0), V_NRDECITOTANF)
     INTO V_IMPOSRETI
     FROM IMPOSNFTOT IT, IMPOSTO I
    WHERE I.CDIMPOSTO    = IT.CDIMPOSTO
      AND IT.CDFILIAL    = P_FILIAL
      AND IT.NRLANCTONF  = P_LANCTONF
      AND ((I.IDDESCRFONTE <> w_A) AND (I.IDDESCRFONTE <> 'N'))
      AND I.IDTRATIMPO   = w_R;

   V_TOTALNOTA  := V_TOTALNOTA - V_IMPOSRETI;
   P_VRNOTAFISC := V_TOTALNOTA;

   SELECT NVL(SUM(VRORIGREC),0), MAX(NRLANBOLREC)
   INTO   V_VRCONTAREC,          V_NRLANBOLREC
   FROM CONTARECEBER
   WHERE CDFILIAL   = P_FILIAL AND
         NRLANCTONF = P_LANCTONF;

   /*IF (V_VRCONTAREC <> V_TOTALNOTA) AND (V_IMPOSRETI > 0) AND
      (V_IDDOCFINANC <> w_L) AND (V_NRLANBOLREC IS NULL) THEN
      APURAC_VENC(P_FILIAL, P_CLIENTE, P_LANCTONF);
   END IF;*/

   --ATUALIZAÇÃO DO CÓDIGO FISCAL DA OPERAÇÃO NA TABELA DE NOTA FISCAL

   SELECT MAX(CDCFOPINFUSU), MAX(DSCFOPINFUSU)
     INTO V_CDCFOPINFUSU,    V_DSCFOPINFUSU
     FROM NOTAFISCAL
    WHERE CDFILIAL = P_FILIAL
      AND NRLANCTONF = P_LANCTONF;

   IF (V_CDCFOPINFUSU IS NULL)  THEN
      SELECT COUNT(DISTINCT CDFISOPEITEM), MAX(CDFISOPEITEM)
        INTO   V_COUNT                     , V_CDFISOPENTF
        FROM ITEMPRODUTO
       WHERE (CDFILIAL   = P_FILIAL) AND
             (NRLANCTONF = P_LANCTONF);

      IF (V_COUNT > 1) THEN
         UPDATE NOTAFISCAL
         SET CDFISOPENTF = '***'
         WHERE CDFILIAL   = P_FILIAL
           AND NRLANCTONF = P_LANCTONF;
      ELSIF (V_COUNT <= 1) THEN
         UPDATE NOTAFISCAL
            SET CDFISOPENTF = V_CDFISOPENTF
          WHERE (CDFILIAL   = P_FILIAL)
            AND (NRLANCTONF = P_LANCTONF);
      END IF;
   ELSE
      UPDATE NOTAFISCAL
         SET CDFISOPENTF  = V_CDCFOPINFUSU
       WHERE CDFILIAL   = P_FILIAL
         AND NRLANCTONF = P_LANCTONF;

      UPDATE ITEMPRODUTO
         SET CDFISOPEITEM = V_CDCFOPINFUSU
       WHERE CDFILIAL   = P_FILIAL
         AND NRLANCTONF = P_LANCTONF;

      UPDATE ITEMPROIMPOS
         SET CDFISCOPERIT = V_CDCFOPINFUSU
       WHERE CDFILIAL   = P_FILIAL
         AND NRLANCTONF = P_LANCTONF;

      UPDATE IMPOSTONF
         SET CDFISCOPERNF = V_CDCFOPINFUSU
       WHERE CDFILIAL   = P_FILIAL
         AND NRLANCTONF = P_LANCTONF;
   END IF;

   IF (V_DSCFOPINFUSU IS NOT NULL)  THEN
      UPDATE NOTAFISCAL
         SET DSCDFISOPENF = V_DSCFOPINFUSU
       WHERE CDFILIAL   = P_FILIAL
         AND NRLANCTONF = P_LANCTONF;
   END IF;

   UPDATE ITEMPRODUTO
   SET IDAVISOSITEM  = w_00000
   WHERE (CDFILIAL   = P_FILIAL) AND
         (NRLANCTONF = P_LANCTONF);

   UPDATE ITEMPROIMPOS
   SET IDAVISIMPIT   = w_00000,
       IDERROSIMPIT  = w_00000
   WHERE (CDFILIAL   = P_FILIAL) AND
         (NRLANCTONF = P_LANCTONF);


--IDENTIFICADOR DE ERROS E AVISOS
   IF NOT(P_TIPOOPER IN ('09', '10', '12')) THEN /*VALE DE TRANSFERENCIA, SAIDA SEM NOTA, NOTA DE CREDITO/DEBITO*/
      /* (AVISO) ITEM COM CÓDIGO DA SITUAÇÃO TRIBUTÁRIA INVÁLIDO */
      Begin
         SELECT IDERROAVISOFIL
         INTO   V_IDERROAVISO
         FROM ERROAVISONFFIL
         WHERE CDERROAVISOFIL = w_Av09
           AND CDFILIAL = V_CDFILIEMIT;
      Exception
         When No_Data_Found Then
            V_IDERROAVISO := Null;
      End;

      IF V_IDERROAVISO IS NULL THEN
         Begin
            SELECT IDERROAVISO
            INTO   V_IDERROAVISO
            FROM ERROAVISONF
            WHERE CDERROAVISO = w_Av09;
         Exception
            When No_Data_Found Then
               V_IDERROAVISO := Null;
         End;
      END IF;

      UPDATE ITEMPRODUTO
      SET IDAVISOSITEM = w_1 || SUBSTR(IDAVISOSITEM,2,4)
      WHERE (CDFILIAL   = P_FILIAL)   AND
            (NRLANCTONF = P_LANCTONF) AND
            ((CDSITUTRIBPR IS NULL) OR (LENGTH(TRIM(CDSITUTRIBPR)) < 3)) AND
            (V_IDERROAVISO <> w_N) AND
            (V_IDCONSPARFIS <> w_N);

      /* (AVISO) ITEM COM CÓDIGO FISCAL DE OPERAÇÃO INVÁLIDO */
      Begin
         SELECT IDERROAVISOFIL
         INTO   V_IDERROAVISO
         FROM ERROAVISONFFIL
         WHERE CDERROAVISOFIL = w_Av10
           AND CDFILIAL = V_CDFILIEMIT;
      Exception
         When No_Data_Found Then
            V_IDERROAVISO := Null;
      End;

      IF V_IDERROAVISO IS NULL THEN
         Begin
            SELECT IDERROAVISO
            INTO   V_IDERROAVISO
            FROM ERROAVISONF
            WHERE CDERROAVISO = w_Av10;
         Exception
            When No_Data_Found Then
               V_IDERROAVISO := Null;
         End;
      END IF;

      UPDATE ITEMPRODUTO
      SET IDAVISOSITEM = SUBSTR(IDAVISOSITEM,1,1) || w_1 || SUBSTR(IDAVISOSITEM,3,3)
      WHERE (CDFILIAL   = P_FILIAL)   AND
            (NRLANCTONF = P_LANCTONF) AND
            ((CDFISOPEITEM IS NULL) OR (LENGTH(CDFISOPEITEM) < 3)) AND
            (V_IDERROAVISO <> w_N) AND
            (V_IDCONSPARFIS <> w_N);

      IF NOT(P_TIPOOPER IN ('07', '12')) THEN
         /* (AVISO) IMPOSTO DO ITEM DA ENTRADA COM CÓDIGO FISCAL INVÁLIDO */
         Begin
            SELECT IDERROAVISOFIL
            INTO   V_IDERROAVISO
            FROM ERROAVISONFFIL
            WHERE CDERROAVISOFIL = w_Av04
              AND CDFILIAL = V_CDFILIEMIT;
         Exception
            When No_Data_Found Then
               V_IDERROAVISO := Null;
         End;

         IF V_IDERROAVISO IS NULL THEN
            Begin
               SELECT IDERROAVISO
               INTO   V_IDERROAVISO
               FROM ERROAVISONF
               WHERE CDERROAVISO = w_Av04;
            Exception
               When No_Data_Found Then
                  V_IDERROAVISO := Null;
            End;
         END IF;

         UPDATE ITEMPROIMPOS
         SET IDAVISIMPIT = SUBSTR(IDAVISIMPIT,1,1) || w_1 || SUBSTR(IDAVISIMPIT,3,3)
         WHERE (CDFILIAL   = P_FILIAL)   AND
               (NRLANCTONF = P_LANCTONF) AND
               ((CDFISCALIT IS NULL) OR LENGTH(CDFISCALIT) <> 1) AND
               (V_IDERROAVISO <> w_N);

         /* (AVISO) IMPOSTO DO ITEM COM SITUAÇÃO TRIBUTÁRIA(CST) INVÁLIDA */
         Begin
            SELECT IDERROAVISOFIL
            INTO   V_IDERROAVISO
            FROM ERROAVISONFFIL
            WHERE CDERROAVISOFIL = w_Av05
              AND CDFILIAL = V_CDFILIEMIT;
         Exception
            When No_Data_Found Then
               V_IDERROAVISO := Null;
         End;

         IF V_IDERROAVISO IS NULL THEN
            Begin
               SELECT IDERROAVISO
               INTO   V_IDERROAVISO
               FROM ERROAVISONF
               WHERE CDERROAVISO = w_Av05;
            Exception
               When No_Data_Found Then
                  V_IDERROAVISO := Null;
            End;
         END IF;

         UPDATE ITEMPROIMPOS
         SET IDAVISIMPIT = SUBSTR(IDAVISIMPIT,1,2) || w_1 || SUBSTR(IDAVISIMPIT,4,2)
         WHERE (CDFILIAL   = P_FILIAL)   AND
               (NRLANCTONF = P_LANCTONF) AND
               ((CDSITUTRIBIT IS NULL) OR (LENGTH(CDSITUTRIBIT) < 2))AND
               (V_IDERROAVISO <> w_N)    AND
               (V_IDCONSPARFIS <> w_N);

         /* (AVISO) IMPOSTO DO ITEM COM CÓD. FISCAL OPERAÇÃO - CFOP INVÁLIDO */
         Begin
            SELECT IDERROAVISOFIL
            INTO   V_IDERROAVISO
            FROM ERROAVISONFFIL
            WHERE CDERROAVISOFIL = w_Av06
              AND CDFILIAL = V_CDFILIEMIT;
         Exception
            When No_Data_Found Then
               V_IDERROAVISO := Null;
         End;

         IF V_IDERROAVISO IS NULL THEN
            Begin
               SELECT IDERROAVISO
               INTO   V_IDERROAVISO
               FROM ERROAVISONF
               WHERE CDERROAVISO = w_Av06;
            Exception
               When No_Data_Found Then
                  V_IDERROAVISO := Null;
            End;
         END IF;

         UPDATE ITEMPROIMPOS
         SET IDAVISIMPIT = SUBSTR(IDAVISIMPIT,1,3) || w_1 || SUBSTR(IDAVISIMPIT,5,1)
         WHERE (CDFILIAL   = P_FILIAL)   AND
               (NRLANCTONF = P_LANCTONF) AND
               ((CDFISCOPERIT IS NULL) OR (LENGTH(CDFISCOPERIT) < 3)) AND
               (V_IDERROAVISO <> w_N)    AND
               (V_IDCONSPARFIS <> w_N);

      END IF;
   END IF;

   SELECT MAX(TO_NUMBER(IDAVISOSITEM))
   INTO   V_ERROAVISO
   FROM ITEMPRODUTO
   WHERE (CDFILIAL   = P_FILIAL) AND
         (NRLANCTONF = P_LANCTONF);

   IF (V_ERROAVISO > 0) THEN
      UPDATE NOTAFISCAL
      SET IDAVISOS = w_1
      WHERE (CDFILIAL   = P_FILIAL) AND
            (NRLANCTONF = P_LANCTONF);
   ELSE
      SELECT MAX(TO_NUMBER(IDAVISIMPIT))
      INTO   V_ERROAVISO
      FROM ITEMPROIMPOS
      WHERE (CDFILIAL   = P_FILIAL) AND
            (NRLANCTONF = P_LANCTONF);

      IF (V_ERROAVISO > 0) THEN
         UPDATE NOTAFISCAL
         SET IDAVISOS = w_1
         WHERE (CDFILIAL   = P_FILIAL) AND
               (NRLANCTONF = P_LANCTONF);
      ELSE
         UPDATE NOTAFISCAL
         SET IDAVISOS = w_0
         WHERE (CDFILIAL   = P_FILIAL) AND
               (NRLANCTONF = P_LANCTONF);
      END IF;
   END IF;

   /*(ERRO) ITEM COM VALOR UNITARIO IGUAL A ZERO*/
   Begin
     SELECT IDERROAVISOFIL
      INTO  V_IDERROAVISO
      FROM ERROAVISONFFIL
      WHERE CDERROAVISOFIL = w_Er04
        AND CDFILIAL = V_CDFILIEMIT;
   Exception
      When No_Data_Found Then
         V_IDERROAVISO := Null;
   End;

   IF V_IDERROAVISO IS NULL THEN
      Begin
        SELECT IDERROAVISO
         INTO  V_IDERROAVISO
         FROM ERROAVISONF
         WHERE CDERROAVISO = w_Er04;
      Exception
         When No_Data_Found Then
            V_IDERROAVISO := Null;
      End;
   END IF;

   IF P_TIPOOPER <> '03' THEN
      UPDATE NOTAFISCAL
      SET IDERROS = w_101
      WHERE CDFILIAL   =  P_FILIAL    AND
            NRLANCTONF =  P_LANCTONF  AND
            V_IDERROAVISO <> w_N      AND
            NRLANCTONF = (SELECT MAX(NRLANCTONF)
                          FROM ITEMPRODUTO
                          WHERE CDFILIAL   =  P_FILIAL   AND
                                NRLANCTONF =  P_LANCTONF AND
                                VRUNITITEM = 0           AND
                                QTITEMPROD > 0);

   END IF;

   IF P_TIPOOPER = w_11 THEN
      Begin
         SELECT IDERROAVISOFIL
         INTO   V_IDERROAVISO
         FROM ERROAVISONFFIL
         WHERE CDERROAVISOFIL = w_Er06
           AND CDFILIAL = V_CDFILIEMIT;
      Exception
         When No_Data_Found Then
            V_IDERROAVISO := Null;
      End;

      IF V_IDERROAVISO IS NULL THEN
         Begin
            SELECT IDERROAVISO
            INTO   V_IDERROAVISO
            FROM ERROAVISONF
            WHERE CDERROAVISO = w_Er06;
         Exception
            When No_Data_Found Then
               V_IDERROAVISO := Null;
         End;
      END IF;
      /* (ERRO) SOMA DAS SAÍDAS SEM NOTA FISCAL DIFERE DO VALOR TOTAL DA NOTA */
      UPDATE NOTAFISCAL
      SET IDERROS = w_1||SUBSTR(IDERROS,2,2)
      WHERE CDFILIAL   =  P_FILIAL    AND
            NRLANCTONF =  P_LANCTONF  AND
            V_IDERROAVISO <> w_N      AND
            V_FAIXATOLER < (SELECT ABS(SUM(N.VRNOTAFISC) - NOTAFISCAL.VRNOTAFISC)
                            FROM ITEMNOTAFISC I, NOTAFISCAL N
                            WHERE I.CDFILIAL   = P_FILIAL      AND
                                  I.NRLANCTONF = P_LANCTONF    AND
                                  N.CDFILIAL   = I.CDFILIALIT  AND
                                  N.NRLANCTONF = I.NRLANCTONFIT);
   END IF;

   -- CALCULANDO PESO BRUTO DOS PRODUTOS DA NOTA FISCAL
   BEGIN

      SELECT VRPBRUTOVOLU
      INTO V_VRPESOBRUTO
      FROM NOTAFISCAL
      WHERE CDFILIAL   = P_FILIAL AND
            NRLANCTONF = P_LANCTONF;

   EXCEPTION

      WHEN No_Data_Found THEN
         V_VRPESOBRUTO := Null;

   END;

   IF (V_VRPESOBRUTO IS NULL) OR (V_VRPESOBRUTO = 0) THEN

      BEGIN

         SELECT SUM(QTITEMPROD * PR.VRPESOBRUTPR)
           INTO V_VRPESOBRUTO
           FROM ITEMPRODUTO I, PRODUTO PR
          WHERE I.CDFILIAL    = P_FILIAL
            AND I.NRLANCTONF  = P_LANCTONF
            AND PR.CDPRODUTO  = I.CDPRODUTO;

      EXCEPTION

         WHEN No_Data_Found THEN
            V_VRPESOBRUTO := Null;

      END;

      IF (V_VRPESOBRUTO IS NULL) OR (V_VRPESOBRUTO = 0) THEN

         SELECT SUM(QTITEMPROD * PA.VRPESOUNID * PR.VRFATOCONV)
         INTO   V_VRPESOBRUTO
         FROM ITEMPRODUTO I, PRODUTO PR, PRODUTO PA
         WHERE I.CDFILIAL    = P_FILIAL       AND
               I.NRLANCTONF  = P_LANCTONF     AND
               PR.CDPRODUTO  = I.CDPRODUTO    AND
               PR.CDPRODESTO = PA.CDPRODUTO;

         IF (V_VRPESOBRUTO <> 0) THEN

            UPDATE NOTAFISCAL
            SET VRPBRUTOVOLU = V_VRPESOBRUTO
            WHERE (CDFILIAL   = P_FILIAL)   AND
                  (NRLANCTONF = P_LANCTONF);

         END IF;

      ELSE

         UPDATE NOTAFISCAL
            SET VRPBRUTOVOLU = V_VRPESOBRUTO
          WHERE CDFILIAL   = P_FILIAL
            AND NRLANCTONF = P_LANCTONF;

      END IF;

   END IF;

   -- CALCULANDO PESO LÍQUIDO DOS PRODUTOS DA NOTA FISCAL
   BEGIN

      SELECT VRPLIQUVOLU
      INTO V_VRLIQUORIG
      FROM NOTAFISCAL
      WHERE CDFILIAL   = P_FILIAL AND
            NRLANCTONF = P_LANCTONF;

   EXCEPTION

      WHEN No_Data_Found THEN
         V_VRLIQUORIG := Null;

   END;

   IF (V_VRLIQUORIG IS NULL) OR (V_VRLIQUORIG = 0) THEN

      SELECT NVL(IDCALCPESONF,'N')
      INTO   V_IDCALCPESONF
      FROM PARAMGERAL;

      IF(V_IDCALCPESONF = 'S') THEN

         SELECT SUM(I.QTITEMPROD * NVL(P.VRPESOLIQUPR, 0)) VRPLIQUEVOLU
           INTO V_VRLIQUORIG
           FROM ITEMPRODUTO I, PRODUTO P
          WHERE I.CDPRODUTO   = P.CDPRODUTO
            AND I.CDFILIAL    = P_FILIAL
            AND I.NRLANCTONF  = P_LANCTONF;

         IF V_VRLIQUORIG IS NOT NULL AND V_VRLIQUORIG <> 0 THEN

            UPDATE NOTAFISCAL
               SET VRPLIQUVOLU = V_VRLIQUORIG
             WHERE CDFILIAL   = P_FILIAL
               AND NRLANCTONF = P_LANCTONF;

         END IF;

      END IF;

   END IF;

--ATUALIZAÇÃO DO CÓDIGO FISCAL DA OPERAÇÃO NA TABELA DE NOTA FISCAL

   SELECT COUNT(DISTINCT CDFISOPEITEM), MAX(CDFISOPEITEM)
   INTO   V_COUNT                     , V_CDFISOPENTF
   FROM ITEMPRODUTO
   WHERE (CDFILIAL   = P_FILIAL) AND
         (NRLANCTONF = P_LANCTONF);

   IF (V_COUNT > 1) THEN
      UPDATE NOTAFISCAL
      SET CDFISOPENTF = '***'
      WHERE CDFILIAL   = P_FILIAL   AND
            NRLANCTONF = P_LANCTONF AND
            CDFISOPENTF IS NULL;
   ELSIF (V_COUNT = 1) THEN
      Begin
         SELECT CDFISOPENTF
         INTO   V_CDFISOPENTF
         FROM NOTAFISCAL
         WHERE CDFILIAL   = P_FILIAL AND
               NRLANCTONF = P_LANCTONF;
      Exception
         When No_Data_Found Then
            V_CDFISOPENTF := Null;
      End;

      IF (V_CDFISOPENTF IS NULL) OR (V_CDFISOPENTF = '***') THEN
         UPDATE NOTAFISCAL
         SET (CDFISOPENTF) = (SELECT MAX(CDFISOPEITEM) AS CDFISOPEITEM
                              FROM ITEMPRODUTO
                              WHERE (CDFILIAL   = P_FILIAL) AND
                                    (NRLANCTONF = P_LANCTONF))
         WHERE (CDFILIAL   = P_FILIAL)   AND
               (NRLANCTONF = P_LANCTONF) AND
               (NVL(CDFISOPENTF, '***') = '***');
      ELSE
         UPDATE ITEMPRODUTO
         SET CDFISOPEITEM = V_CDFISOPENTF
         WHERE CDFILIAL   = P_FILIAL   AND
               NRLANCTONF = P_LANCTONF;

         UPDATE ITEMPROIMPOS
         SET CDFISCOPERIT = V_CDFISOPENTF
         WHERE CDFILIAL   = P_FILIAL   AND
               NRLANCTONF = P_LANCTONF;

         UPDATE IMPOSTONF
         SET CDFISCOPERNF = V_CDFISOPENTF
         WHERE CDFILIAL   = P_FILIAL   AND
               NRLANCTONF = P_LANCTONF;
      END IF;
   END IF;

   IF V_CDINTEGRACAO IS NOT NULL THEN
--INCLUSÃO DOS ENCARGOS DA NF EM CASO DE IMPORTAÇÃO
      INSERT INTO ITEMENCARGO
      (CDFILIAL, NRLANCTONF, CDENCARGO, VRITEMENCA)
      (SELECT P_FILIAL, P_LANCTONF, CDENCARGO, 0 AS VRITEMENCA
       FROM ENCARGO
       MINUS
       SELECT CDFILIAL, NRLANCTONF, CDENCARGO, 0 AS VRITEMENCA
       FROM ITEMENCARGO
       WHERE CDFILIAL   = P_FILIAL AND
             NRLANCTONF = P_LANCTONF);

      Begin
         SELECT IDERROAVISO
         INTO   V_IDERROAVISO
         FROM ERROAVISONF
         WHERE CDERROAVISO = w_Er03;
      Exception
         When No_Data_Found Then
            V_IDERROAVISO := Null;
      End;

      UPDATE NOTAFISCAL N
      SET IDERROS = w_11||SUBSTR(IDERROS, 3, 1)
      WHERE CDFILIAL   =  P_FILIAL   AND
            NRLANCTONF =  P_LANCTONF AND
            V_IDERROAVISO <> w_N     AND
            V_FAIXATOLER < (SELECT NVL(ABS(NVL(SUM(C.VRORIGREC), (N.VRNOTAFISC - MAX(I.VRIMPOSRETI))) - (N.VRNOTAFISC - MAX(I.VRIMPOSRETI))), V_FAIXATOLER)
                            FROM CONTARECEBER C,
                                 (SELECT NVL(SUM(IT.VRTOTIMPONF),0) AS VRIMPOSRETI
                                  FROM IMPOSNFTOT IT, IMPOSTO I
                                  WHERE I.CDIMPOSTO    = IT.CDIMPOSTO AND
                                        IT.CDFILIAL    = P_FILIAL     AND
                                        IT.NRLANCTONF  = P_LANCTONF   AND
                                        I.IDDESCRFONTE <> w_A         AND
                                        I.IDTRATIMPO   = w_R) I
                            WHERE C.CDFILIAL   = P_FILIAL AND
                                  C.NRLANCTONF = P_LANCTONF);
   END IF;


   /* ESTA ROTINA ABAIXO SERVE PARA ATUALIZAR O VALOR CONTÁBIL E BRUTO DOS PRODUTOS COM A DIFERENÇA
      DE CENTAVOS ENTRE O VALOR DOS IMPOSTOS POR ÍTEM E A SUA RESPECTIVA TOTALIZAÇÃO. ESTA DIFERENÇA
      É IGNORADA NO FECHAMENTO DA NF CASO O CLIENTE TRABALHE COM UM NÚMERO MENOR DE CASAS DECIMAIS E
      PROVOCA ERROS NA CONTABILIZAÇÃO*/

   IF (V_NRDECITOTANF <> 2) AND (V_IDOPERDEVONF <> w_S) THEN
      FOR C_ATUAVRCONT IN (SELECT T.CDIMPOSTO, SUM(T.VRIMPOSTOIT) AS VRIMPOSTOIT, T.CDFISCALIT,
                                  I.IDIMPORECUP, I.CDCCTBLATIV, I.CDCCTBLPASS, I.IDTRATIMPO, I.IDTIPCONTAB, I.IDDESCRFONTE
                           FROM ITEMPROIMPOS T, IMPOSTO I
                           WHERE T.CDFILIAL     = P_FILIAL    AND
                                 T.NRLANCTONF   = P_LANCTONF  AND
                                 T.NRITPROIMPOS = w_1         AND
                                 T.CDIMPOSTO    = I.CDIMPOSTO
                           GROUP BY T.CDIMPOSTO, T.CDFISCALIT, I.IDIMPORECUP,
                                    I.CDCCTBLATIV, I.CDCCTBLPASS, I.IDTRATIMPO, I.IDTIPCONTAB, I.IDDESCRFONTE) LOOP

         SELECT SUM(VRTOTIMPONF) - C_ATUAVRCONT.VRIMPOSTOIT
         INTO   V_VRDIFERENCA
         FROM IMPOSNFTOT
         WHERE CDFILIAL   = P_FILIAL   AND
               NRLANCTONF = P_LANCTONF AND
               CDIMPOSTO  = C_ATUAVRCONT.CDIMPOSTO;

         SELECT SUM(VRBRUTITEM), SUM(VRCONTITEM)
         INTO   V_VRBRUTO      , V_VRCONTAB
         FROM ITEMPRODUTO I, ITEMPROIMPOS T
         WHERE T.CDFILIAL     = I.CDFILIAL    AND
               T.NRLANCTONF   = I.NRLANCTONF  AND
               T.NRSEQITPROD  = I.NRSEQITPROD AND
               T.CDFILIAL     = P_FILIAL      AND
               T.NRLANCTONF   = P_LANCTONF    AND
               T.NRITPROIMPOS = w_1           AND
               T.CDIMPOSTO    = C_ATUAVRCONT.CDIMPOSTO;

         IF V_VRDIFERENCA <> 0 THEN
            IF (C_ATUAVRCONT.IDTRATIMPO = w_A) THEN
               IF ((C_ATUAVRCONT.IDIMPORECUP = w_S)  AND (C_ATUAVRCONT.CDFISCALIT = w_1)) OR
                  ((C_ATUAVRCONT.IDIMPORECUP <> w_S) AND (C_ATUAVRCONT.CDCCTBLPASS IS NOT NULL)) AND
                  (C_ATUAVRCONT.IDTIPCONTAB = w_D) THEN
                  V_ICMS := 'N';
                  FOR C_ICMS IN (SELECT CDIMPOSTO
                                   FROM IMPOSTONFE N, IMPOSTO I
                                  WHERE N.CDIMPOSTONFE = I.CDIMPOSTONFE
                                    AND N.CDIMPOSTONFE = '00'
                                    AND I.CDIMPOSTO = C_ATUAVRCONT.CDIMPOSTO)
                  LOOP
                     V_ICMS := 'S';
                  END LOOP;

                  IF ((V_IDSISTEMA = 'VND') OR (V_IDSISTEMA = 'PDV')) AND (V_ICMS = 'S') THEN
                     UPDATE ITEMPRODUTO
                     SET VRBRUTITEM = TRUNC(VRBRUTITEM + ((V_VRDIFERENCA / V_VRBRUTO)  * VRBRUTITEM),2)
                     WHERE EXISTS(SELECT CDFILIAL, NRLANCTONF, NRSEQITPROD
                                  FROM ITEMPROIMPOS T
                                  WHERE T.CDFILIAL    = P_FILIAL                AND
                                        T.NRLANCTONF  = P_LANCTONF              AND
                                        T.NRSEQITPROD = ITEMPRODUTO.NRSEQITPROD AND
                                        T.CDIMPOSTO   = C_ATUAVRCONT.CDIMPOSTO);
                  ELSE
                     UPDATE ITEMPRODUTO
                     SET VRBRUTITEM = ROUND(VRBRUTITEM + ((V_VRDIFERENCA / V_VRBRUTO)  * VRBRUTITEM),5)
                     WHERE EXISTS(SELECT CDFILIAL, NRLANCTONF, NRSEQITPROD
                                  FROM ITEMPROIMPOS T
                                  WHERE T.CDFILIAL    = P_FILIAL                AND
                                        T.NRLANCTONF  = P_LANCTONF              AND
                                        T.NRSEQITPROD = ITEMPRODUTO.NRSEQITPROD AND
                                        T.CDIMPOSTO   = C_ATUAVRCONT.CDIMPOSTO);
                  END IF;
               ELSE
                  V_ICMS := 'N';
                  FOR C_ICMS IN (SELECT CDIMPOSTO
                                   FROM IMPOSTONFE N, IMPOSTO I
                                  WHERE N.CDIMPOSTONFE = I.CDIMPOSTONFE
                                    AND N.CDIMPOSTONFE = '00'
                                    AND I.CDIMPOSTO = C_ATUAVRCONT.CDIMPOSTO)
                  LOOP
                     V_ICMS := 'S';
                  END LOOP;

                  IF ((V_IDSISTEMA = 'VND') OR (V_IDSISTEMA = 'PDV')) AND (V_ICMS = 'S') THEN
                     UPDATE ITEMPRODUTO
                     SET VRBRUTITEM = TRUNC(VRBRUTITEM + ((V_VRDIFERENCA / V_VRBRUTO)  * VRBRUTITEM),2),
                         VRCONTITEM = TRUNC(VRCONTITEM + ((V_VRDIFERENCA / V_VRCONTAB) * VRCONTITEM),2)
                     WHERE EXISTS(SELECT CDFILIAL, NRLANCTONF, NRSEQITPROD
                                  FROM ITEMPROIMPOS T
                                  WHERE T.CDFILIAL    = P_FILIAL                AND
                                        T.NRLANCTONF  = P_LANCTONF              AND
                                        T.NRSEQITPROD = ITEMPRODUTO.NRSEQITPROD AND
                                        T.CDIMPOSTO   = C_ATUAVRCONT.CDIMPOSTO);
                  ELSE
                     UPDATE ITEMPRODUTO
                     SET VRBRUTITEM = ROUND(VRBRUTITEM + ((V_VRDIFERENCA / V_VRBRUTO)  * VRBRUTITEM),5),
                         VRCONTITEM = ROUND(VRCONTITEM + ((V_VRDIFERENCA / V_VRCONTAB) * VRCONTITEM),5)
                     WHERE EXISTS(SELECT CDFILIAL, NRLANCTONF, NRSEQITPROD
                                  FROM ITEMPROIMPOS T
                                  WHERE T.CDFILIAL    = P_FILIAL                AND
                                        T.NRLANCTONF  = P_LANCTONF              AND
                                        T.NRSEQITPROD = ITEMPRODUTO.NRSEQITPROD AND
                                        T.CDIMPOSTO   = C_ATUAVRCONT.CDIMPOSTO);
                  END IF;

               END IF;
            ELSIF (C_ATUAVRCONT.IDTRATIMPO = w_D) THEN
               IF ((C_ATUAVRCONT.IDIMPORECUP = w_S) AND (C_ATUAVRCONT.CDFISCALIT = w_1))  OR
                  ((C_ATUAVRCONT.IDIMPORECUP <> w_S) AND (C_ATUAVRCONT.CDCCTBLATIV IS NOT NULL)) AND
                  (C_ATUAVRCONT.IDTIPCONTAB = w_D) THEN

                  V_ICMS := 'N';
                  FOR C_ICMS IN (SELECT CDIMPOSTO
                                   FROM IMPOSTONFE N, IMPOSTO I
                                  WHERE N.CDIMPOSTONFE = I.CDIMPOSTONFE
                                    AND N.CDIMPOSTONFE = '00'
                                    AND I.CDIMPOSTO = C_ATUAVRCONT.CDIMPOSTO)
                  LOOP
                     V_ICMS := 'S';
                  END LOOP;

                  IF ((V_IDSISTEMA = 'VND') OR (V_IDSISTEMA = 'PDV')) AND (V_ICMS = 'S') THEN
                     UPDATE ITEMPRODUTO
                     SET VRBRUTITEM = TRUNC(VRBRUTITEM - ((V_VRDIFERENCA / V_VRBRUTO)  * VRBRUTITEM),2)
                     WHERE EXISTS(SELECT CDFILIAL, NRLANCTONF, NRSEQITPROD
                                  FROM ITEMPROIMPOS T
                                  WHERE T.CDFILIAL    = P_FILIAL                AND
                                        T.NRLANCTONF  = P_LANCTONF              AND
                                        T.NRSEQITPROD = ITEMPRODUTO.NRSEQITPROD AND
                                        T.CDIMPOSTO   = C_ATUAVRCONT.CDIMPOSTO);
                  ELSE
                     UPDATE ITEMPRODUTO
                     SET VRBRUTITEM = ROUND(VRBRUTITEM - ((V_VRDIFERENCA / V_VRBRUTO)  * VRBRUTITEM),5)
                     WHERE EXISTS(SELECT CDFILIAL, NRLANCTONF, NRSEQITPROD
                                  FROM ITEMPROIMPOS T
                                  WHERE T.CDFILIAL    = P_FILIAL                AND
                                        T.NRLANCTONF  = P_LANCTONF              AND
                                        T.NRSEQITPROD = ITEMPRODUTO.NRSEQITPROD AND
                                        T.CDIMPOSTO   = C_ATUAVRCONT.CDIMPOSTO);
                  END IF;
               ELSE
                  V_ICMS := 'N';
                  FOR C_ICMS IN (SELECT CDIMPOSTO
                                   FROM IMPOSTONFE N, IMPOSTO I
                                  WHERE N.CDIMPOSTONFE = I.CDIMPOSTONFE
                                    AND N.CDIMPOSTONFE = '00'
                                    AND I.CDIMPOSTO = C_ATUAVRCONT.CDIMPOSTO)
                  LOOP
                     V_ICMS := 'S';
                  END LOOP;

                  IF ((V_IDSISTEMA = 'VND') OR (V_IDSISTEMA = 'PDV')) AND (V_ICMS = 'S') THEN
                     UPDATE ITEMPRODUTO
                     SET VRBRUTITEM = TRUNC(VRBRUTITEM - ((V_VRDIFERENCA / V_VRBRUTO)  * VRBRUTITEM),2),
                         VRCONTITEM = TRUNC(VRCONTITEM - ((V_VRDIFERENCA / V_VRCONTAB) * VRCONTITEM),2)
                     WHERE EXISTS(SELECT CDFILIAL, NRLANCTONF, NRSEQITPROD
                                  FROM ITEMPROIMPOS T
                                  WHERE T.CDFILIAL    = P_FILIAL                AND
                                        T.NRLANCTONF  = P_LANCTONF              AND
                                        T.NRSEQITPROD = ITEMPRODUTO.NRSEQITPROD AND
                                        T.CDIMPOSTO   = C_ATUAVRCONT.CDIMPOSTO);
                  ELSE
                     UPDATE ITEMPRODUTO
                     SET VRBRUTITEM = ROUND(VRBRUTITEM - ((V_VRDIFERENCA / V_VRBRUTO)  * VRBRUTITEM),5),
                         VRCONTITEM = ROUND(VRCONTITEM - ((V_VRDIFERENCA / V_VRCONTAB) * VRCONTITEM),5)
                     WHERE EXISTS(SELECT CDFILIAL, NRLANCTONF, NRSEQITPROD
                                  FROM ITEMPROIMPOS T
                                  WHERE T.CDFILIAL    = P_FILIAL                AND
                                        T.NRLANCTONF  = P_LANCTONF              AND
                                        T.NRSEQITPROD = ITEMPRODUTO.NRSEQITPROD AND
                                        T.CDIMPOSTO   = C_ATUAVRCONT.CDIMPOSTO);
                  END IF;
               END IF;
            ELSIF (C_ATUAVRCONT.IDTRATIMPO = w_R) THEN
               IF (C_ATUAVRCONT.IDIMPORECUP = w_S) THEN
                  IF (C_ATUAVRCONT.CDCCTBLATIV IS NULL) OR
                     (C_ATUAVRCONT.CDFISCALIT <> w_1) THEN

                     V_IMPOCONTAB := - V_VRIMPOSTO;
                  END IF;
               ELSE
                  IF (C_ATUAVRCONT.CDCCTBLATIV IS NULL) THEN
                     V_IMPOCONTAB := - V_VRIMPOSTO;
                  ELSE
                     IF C_ATUAVRCONT.IDDESCRFONTE = 'N' THEN
                        V_IMPOCONTAB := - V_VRIMPOSTO;
                     END IF;
                  END IF;
               END IF;

               IF (C_ATUAVRCONT.IDTIPCONTAB = w_D) THEN
                  V_ICMS := 'N';
                  FOR C_ICMS IN (SELECT CDIMPOSTO
                                   FROM IMPOSTONFE N, IMPOSTO I
                                  WHERE N.CDIMPOSTONFE = I.CDIMPOSTONFE
                                    AND N.CDIMPOSTONFE = '00'
                                    AND I.CDIMPOSTO = C_ATUAVRCONT.CDIMPOSTO)
                  LOOP
                     V_ICMS := 'S';
                  END LOOP;

                  IF ((V_IDSISTEMA = 'VND') OR (V_IDSISTEMA = 'PDV')) AND (V_ICMS = 'S') THEN
                     UPDATE ITEMPRODUTO
                     SET VRCONTITEM = TRUNC(VRCONTITEM + ((V_VRDIFERENCA / V_VRCONTAB) * VRCONTITEM),2)
                     WHERE EXISTS(SELECT CDFILIAL, NRLANCTONF, NRSEQITPROD
                                  FROM ITEMPROIMPOS T
                                  WHERE T.CDFILIAL    = P_FILIAL                AND
                                        T.NRLANCTONF  = P_LANCTONF              AND
                                        T.NRSEQITPROD = ITEMPRODUTO.NRSEQITPROD AND
                                        T.CDIMPOSTO   = C_ATUAVRCONT.CDIMPOSTO);
                  ELSE
                     UPDATE ITEMPRODUTO
                     SET VRCONTITEM = ROUND(VRCONTITEM + ((V_VRDIFERENCA / V_VRCONTAB) * VRCONTITEM),5)
                     WHERE EXISTS(SELECT CDFILIAL, NRLANCTONF, NRSEQITPROD
                                  FROM ITEMPROIMPOS T
                                  WHERE T.CDFILIAL    = P_FILIAL                AND
                                        T.NRLANCTONF  = P_LANCTONF              AND
                                        T.NRSEQITPROD = ITEMPRODUTO.NRSEQITPROD AND
                                        T.CDIMPOSTO   = C_ATUAVRCONT.CDIMPOSTO);
                  END IF;
               END IF;
            END IF;
         END IF;
      END LOOP;
   END IF;

   BEGIN
      SELECT CDFILIALPED, NRPEDIDO
        INTO V_CDFILIALPED, V_NRPEDIDO
        FROM ITEMPRODUTO
       WHERE CDFILIAL = P_FILIAL
         AND NRLANCTONF = P_LANCTONF
         AND ROWNUM = 1;
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_CDFILIALPED := NULL;
         V_NRPEDIDO := NULL;
   END;

   IF (V_CDFILIALPED IS NOT NULL) AND (V_NRPEDIDO IS NOT NULL) THEN
      BEGIN
         SELECT DADOSADICENDPED
           INTO V_DADOSADICENDPED
           FROM (SELECT ('DADO PARA ENTREGA - CLIENTE: '||C.NRINSJURCLIE||' '||C.NMRAZSOCCLIE||
                         ' - ENDEREÇO: '|| D.DSENDEPED||
                         ' - BAIRRO: '||D.NMBAIRROPED||
                         ' - MUNICIPIO: '||D.NMMUNIPED||
                         ' - ESTADO: '||D.SGESTADOPED||
                         ' - CEP: '||NRCEPPED) AS DADOSADICENDPED
                   FROM DADOSENDPED D, CLIENTE C
                  WHERE D.CDCLIENTE = C.CDCLIENTE
                    AND C.IDENDEMISCLI <> D.IDTPENDECLIE
                    AND D.CDFILIAL = V_CDFILIALPED
                    AND NRPEDIDO = V_NRPEDIDO) DEP
          WHERE NOT EXISTS(SELECT DSDADOADIC
                             FROM DADOSADIC                                     
                            WHERE CDFILIAL   = P_FILIAL
                              AND NRLANCTONF = P_LANCTONF
                              AND DSDADOADIC = DEP.DADOSADICENDPED);
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
            V_DADOSADICENDPED := NULL;
      END;

      IF V_DADOSADICENDPED IS NOT NULL THEN
         INSERT INTO DADOSADIC
            (CDFILIAL, NRLANCTONF, NRDADOADIC, DSDADOADIC)
         VALUES
            (P_FILIAL, P_LANCTONF, V_DADOADIC, SUBSTR(V_DADOSADICENDPED, 1, 250));

         V_DADOADIC := LPAD(RTRIM(TO_CHAR(TO_NUMBER(V_DADOADIC) + 1)),3,0);
      END IF;
   ELSE
      FOR C_ENDDADOSADIC IN (SELECT DSDADOADIC FROM (
                             SELECT '' AS NRDADOADIC,'999' AS CDMENSAGEM,('DESTINO - FILIAL: '||F.NRINSJURFILI||' '||F.NMFILIAL||' -  ENDEREÇO: '||
                                    E.DSENDEFILI||' - BAIRRO: '||E.NMBAIRFILI||' - MUNICIPIO: '||M.NMMUNICIPIO||' - ESTADO: '||M.SGESTADO) AS DSDADOADIC
                               FROM NOTAFISCAL N INNER JOIN ENDEFILI E ON (CASE WHEN N.IDENTRSAIDOP = 'S' THEN N.CDFILIRECE ELSE N.CDFILIEMIT END) = E.CDFILIAL
                                                 INNER JOIN FILIAL F    ON E.CDFILIAL   = F.CDFILIAL
                                                 INNER JOIN MUNICIPIO M ON E.CDMUNICIPIO = M.CDMUNICIPIO
                                                                       AND E.CDPAIS      = M.CDPAIS
                                                                       AND E.SGESTADO    = M.SGESTADO
                              WHERE N.CDFILIAL     = P_FILIAL
                                AND N.NRLANCTONF   = P_LANCTONF
                                AND N.IDORIGDESTNF = 'L'
                                AND E.IDTPENDEFILI = 'T'
                             UNION ALL
                             SELECT '' AS NRDADOADIC, '999' AS CDMENSAGEM,('DESTINO - CLIENTE: '||C.NRINSJURCLIE||' '||C.NMRAZSOCCLIE||' -  ENDEREÇO: '||
                                    E.DSENDECLIE||' - BAIRRO: '||E.NMBAIRCLIE||' - MUNICIPIO: '||M.NMMUNICIPIO||' - ESTADO: '||M.SGESTADO) AS DSDADOADIC
                               FROM NOTAFISCAL N INNER JOIN ENDECLIE E ON N.CDCLIENTE = E.CDCLIENTE
                                                 INNER JOIN CLIENTE  C ON E.CDCLIENTE = C.CDCLIENTE
                                                 INNER JOIN MUNICIPIO M ON E.CDMUNICIPIO = M.CDMUNICIPIO
                                                                       AND E.CDPAIS      = M.CDPAIS
                                                                       AND E.SGESTADO    = M.SGESTADO
                              WHERE N.CDFILIAL     = P_FILIAL
                                AND N.NRLANCTONF   = P_LANCTONF
                                AND E.IDTPENDECLIE = 'T'
                             UNION ALL
                             SELECT '' AS NRDADOADIC, '999' AS CDMENSAGEM,('DESTINO - FORNECEDOR: '||F.NRINSJURFORN||' '||F.NMRAZSOCFORN||' -  ENDEREÇO: '||
                                    E.DSENDEFORN||' - BAIRRO: '||E.NMBAIRFORN||' - MUNICIPIO: '||M.NMMUNICIPIO||' - ESTADO: '||M.SGESTADO) AS DSDADOADIC
                               FROM NOTAFISCAL N INNER JOIN ENDEFORN E   ON N.CDFORNECED = E.CDFORNECED
                                                 INNER JOIN FORNECEDOR F ON E.CDFORNECED = F.CDFORNECED
                                                 INNER JOIN MUNICIPIO M  ON E.CDMUNICIPIO = M.CDMUNICIPIO
                                                                        AND E.CDPAIS      = M.CDPAIS
                                                                        AND E.SGESTADO    = M.SGESTADO
                              WHERE N.CDFILIAL     = P_FILIAL
                                AND N.NRLANCTONF   = P_LANCTONF
                                AND E.IDTPENDEFORN = 'T'
                             ORDER BY CDMENSAGEM) I
                              WHERE NOT EXISTS(SELECT DSDADOADIC
                                                 FROM DADOSADIC                                     
                                                WHERE (CDFILIAL   = P_FILIAL)
                                                  AND (NRLANCTONF = P_LANCTONF)
                                                  AND (DSDADOADIC = I.DSDADOADIC))) LOOP

          INSERT INTO DADOSADIC(CDFILIAL, NRLANCTONF, NRDADOADIC, DSDADOADIC)
                         VALUES(P_FILIAL, P_LANCTONF, V_DADOADIC, SUBSTR(C_ENDDADOSADIC.DSDADOADIC,1,250));

          V_DADOADIC := LPAD(RTRIM(TO_CHAR(TO_NUMBER(V_DADOADIC) + 1)),3,0);
      END LOOP;
   END IF;

   /*PREENCHENDO A TABELA DADOSADIC DE ACORDO COM OS VALORES DO ADICIONAL DE ALÍQUOTA DO FECP*/
   DELETE 
     FROM DADOSADIC
    WHERE CDFILIAL = P_FILIAL
      AND NRLANCTONF = P_LANCTONF
      AND UPPER(DSDADOADIC) LIKE 'ADICIONAL DE ALÍQUOTA DO IMPOSTO % DE % (FUNDO ESTADUAL DE COMBATE A POBREZA):%';

   V_STRVRADICALIQFECP := NULL;
   V_STRVRADICFECP := NULL;

   FOR C_VRADICALIQFECP IN (SELECT CASE P.CDIMPOSTONFE WHEN '00' THEN 'ICMS' WHEN '80' THEN 'ICMS-ST' END AS CDIMPOSTONFE, 
                                   I.VRADICALIQFECP, 
                                   SUM(NVL(I.VRADICFECP, 0)) AS VRADICFECP
                              FROM ITEMPROIMPOS I JOIN IMPOSTO P ON (I.CDIMPOSTO = P.CDIMPOSTO)
                             WHERE I.CDFILIAL = P_FILIAL
                               AND I.NRLANCTONF = P_LANCTONF
                               AND NVL(I.VRADICALIQFECP, 0) > 0
                               AND I.NRITPROIMPOS = '1'
                             GROUP BY P.CDIMPOSTONFE, 
                                   I.VRADICALIQFECP)
   LOOP
      SELECT DECODE(SUBSTR(LTRIM(TO_CHAR(ROUND(C_VRADICALIQFECP.VRADICALIQFECP, 2), '9999999999999.99')), 1, 1), '.', '0'||LTRIM(TO_CHAR(ROUND(C_VRADICALIQFECP.VRADICALIQFECP, 2), '9999999999999.99')), LTRIM(TO_CHAR(ROUND(C_VRADICALIQFECP.VRADICALIQFECP, 2), '9999999999999.99'))),
             DECODE(SUBSTR(LTRIM(TO_CHAR(ROUND(C_VRADICALIQFECP.VRADICFECP, 2), '9999999999999.99')), 1, 1), '.', '0'||LTRIM(TO_CHAR(ROUND(C_VRADICALIQFECP.VRADICFECP, 2), '9999999999999.99')), LTRIM(TO_CHAR(ROUND(C_VRADICALIQFECP.VRADICFECP, 2), '9999999999999.99')))
        INTO V_STRVRADICALIQFECP,
             V_STRVRADICFECP
        FROM DUAL;
      INSERT INTO DADOSADIC
         (CDFILIAL, 
          NRLANCTONF, 
          NRDADOADIC, 
          DSDADOADIC)
      VALUES
         (P_FILIAL, 
          P_LANCTONF, 
          V_DADOADIC,
          'Adicional de alíquota do imposto '||C_VRADICALIQFECP.CDIMPOSTONFE||' de '||V_STRVRADICALIQFECP||'% (Fundo Estadual de Combate a Pobreza): R$ '||V_STRVRADICFECP);

      V_DADOADIC := LPAD(RTRIM(TO_CHAR(TO_NUMBER(V_DADOADIC) + 1)),3,0);
   END LOOP;

   IF NOT(P_LANCESTQ IS NULL) AND (V_IDCTRLESTQ <> w_N) THEN

      /* INSERIDO POR LUCIANA CORREA PARA O SISTEMA DE PDV */
      IF (V_IDSISTEMA <> w_VMN) THEN

         BEGIN
            SELECT NRCTRLMOVEST, CDFILIALENTR, NRLANESTENTR
              INTO V_NRCTRLMOVEST, V_CDFILIALENTR, V_NRLANESTENTR
              FROM CTRLMOVIESTQ
             WHERE CDFILIALSAID = P_FILIAL
               AND NRLANESTSAID = P_LANCESTQ;
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_CDFILIALENTR := NULL;
               V_NRCTRLMOVEST := NULL;
               V_NRLANESTENTR := NULL;
         END;

         IF V_NRCTRLMOVEST IS NOT NULL THEN
            DELETE 
              FROM CTRLMOVIESTQ
             WHERE CDFILIAL = V_CDFILIEMIT
               AND NRCTRLMOVEST = V_NRCTRLMOVEST;

            DELETE 
              FROM ITLANCTOEST
             WHERE CDFILIAL = V_CDFILIALENTR
               AND NRLANCESTQ = V_NRLANESTENTR;

            DELETE 
              FROM LANCTOESTOQ
             WHERE CDFILIAL = V_CDFILIALENTR
               AND NRLANCESTQ = V_NRLANESTENTR;

         END IF;

         SELECT COUNT(*)
         INTO   V_COUNT
         FROM LANCTOESTOQ L, NOTAFISCAL N
         WHERE L.CDFILIAL   = P_FILIAL      AND
               L.NRLANCESTQ = P_LANCESTQ    AND
               L.NRLANCTONF = P_LANCTONF    AND
               L.CDFILIAL   = N.CDFILIAL    AND
               L.NRLANCTONF = N.NRLANCTONF;

         IF V_COUNT > 0 THEN

            DELETE FROM ITLANCTOEST
            WHERE CDFILIAL   = P_FILIAL AND
                  NRLANCESTQ = P_LANCESTQ;

            DELETE FROM LANCTOESTOQ
            WHERE CDFILIAL   = P_FILIAL AND
                  NRLANCESTQ = P_LANCESTQ;
         END IF;
      ELSE
         UPDATE LANCTOESTOQ
         SET DTLANCESTQ = P_INIVALID
         WHERE CDFILIAL   = P_FILIAL AND
               NRLANCESTQ = P_LANCESTQ;

         DELETE FROM ITLANCTOEST
         WHERE CDFILIAL   = P_FILIAL AND
               NRLANCESTQ = P_LANCESTQ;
      END IF;

      Begin
         SELECT T.NMTIPOOPER, F.NMFILIAL
         INTO   V_NMTIPOOPER, V_NMFILIRECE
         FROM NOTAFISCAL N, TIPOOPERAC T, FILIAL F
         WHERE
            (N.CDFILIAL     = P_FILIAL)       AND
            (N.NRLANCTONF   = P_LANCTONF)     AND
            (N.CDTIPOOPER   = T.CDTIPOOPER)   AND
            (N.IDENTRSAIDOP = T.IDENTRSAIDOP) AND
            (N.CDFILIRECE   = F.CDFILIAL(+));
      Exception
         When No_Data_Found Then
            V_NMTIPOOPER := Null; V_NMFILIRECE := Null;
      End;

      IF V_IDORIGDESTNF = w_L THEN
         V_DESCLANC := 'NF: '||P_LANCTONF||' - '||SUBSTR(V_NMTIPOOPER,1,25)||' - '||SUBSTR(V_NMFILIRECE,1,15);
      ELSE
         V_DESCLANC := 'LANC. ORIGEM: '||V_NRINSJURNF||' Nº'||P_LANCTONF||' SERIE '||V_SERIE;
      END IF;

      SELECT COUNT(*)
      INTO   V_COUNT
      FROM LANCTOESTOQ L, NOTAFISCAL N
      WHERE L.CDFILIAL   = P_FILIAL      AND
            L.NRLANCESTQ = P_LANCESTQ    AND
            L.NRLANCTONF = P_LANCTONF    AND
            L.CDFILIAL   = N.CDFILIAL    AND
            L.NRLANCTONF = N.NRLANCTONF;

      IF V_COUNT = 0 THEN
         INSERT INTO LANCTOESTOQ
            (CDFILIAL,NRLANCESTQ,NRLANCTONF,DSLANCESTQ,IDTPLANCTO,DTLANCESTQ,CDOPERADOR, CDFILIMOVI)
         VALUES
            (P_FILIAL, P_LANCESTQ, P_LANCTONF, V_DESCLANC, w_S, P_INIVALID,P_CDOPERADOR, V_CDFILIEMIT);
      END IF;


      IF (V_IDOPERDEVONF = w_S) THEN
         V_TIPOMOVI := w_5;
      ELSE
         V_TIPOMOVI := w_4;
      END IF;

      IF (V_IDSISTEMA = w_EXP) THEN
         Begin
            SELECT NVL(MAX(IDRETPROEXP),1)
              INTO V_IDRETPROEXP
              FROM PAREXPEDICAO
             WHERE CDFILIAL = V_CDFILIEMIT;
         Exception
            When No_Data_Found Then
               V_IDRETPROEXP := 1;
         End;

      END IF;

      IF (V_IDSISTEMA = w_VND) THEN
         SELECT CDFILIMOVI
         INTO   V_CDFILIMOVI
         FROM LANCTOESTOQ
         WHERE CDFILIAL   = P_FILIAL AND
               NRLANCTONF = P_LANCTONF;
         Begin
            SELECT NVL(IDATUEST,1)
            INTO   V_IDATUEST
            FROM PARAVEND
            WHERE CDFILIAL = V_CDFILIMOVI;
         Exception
            When No_Data_Found Then
               V_IDATUEST := 1;
         End;
      END IF;

      IF ((V_IDSISTEMA = w_EXP) AND (V_IDRETPROEXP = w_2)) OR ((V_IDSISTEMA = w_VND) AND (V_IDATUEST = w_1)) THEN

         FOR C_ITLANCTOEST IN (SELECT NRSEQITPROD,IP.CDPRODUTO,VRUNITITEM,VRTOTAITEM, NVL(CDFILIMOVI, CDFILIEMIT) AS CDFILIMOVI,
                                      QTITEMPROD,CDPRODESTO,VRBRUTITEM,VRDESCITEM,VRCONTITEM,
                                      NVL(IP.CDALMOXARIFE,' ') AS CDALMOXARIFE,
                                      NVL(IP.CDLOCALESTOQ,' ') AS CDLOCALESTOQ,
                                      NVL(NRLOTEESTQ,' ')      AS NRLOTEESTQ,
                                      NVL(NRSUBLOTE,' ')       AS NRSUBLOTE, IDCNTRESTOQ,
                                      IP.NRPEDIDO, IP.NRITEMPED, CDARVPROD, NMPRODUTO,
                                      NVL(IP.IDORIGEMPROD, 'N') AS IDORIGEMPROD
                               FROM ITEMPRODUTO IP, PRODUTO P, PRODFILI PF, NOTAFISCAL N
                               WHERE IP.CDFILIAL    = P_FILIAL     AND
                                     IP.NRLANCTONF  = N.NRLANCTONF AND
                                     IP.CDFILIAL    = N.CDFILIAL   AND
                                     IP.NRLANCTONF  = P_LANCTONF   AND
                                     P.CDPRODUTO    = IP.CDPRODUTO AND
                                     PF.CDFILIAL    = V_CDFILIEMIT AND
                                     PF.CDPRODUTO   = P.CDPRODESTO AND
                                     NVL(IP.IDATUESTPROD, 'S') = 'S') LOOP
            IF (C_ITLANCTOEST.IDCNTRESTOQ = w_S) THEN
               UPDATE ITEMPRODUTO
               SET CDPRODMOVI = C_ITLANCTOEST.CDPRODESTO
               WHERE (CDFILIAL    = P_FILIAL)    AND
                     (NRLANCTONF  = P_LANCTONF ) AND
                     (NRSEQITPROD = C_ITLANCTOEST.NRSEQITPROD);
            END IF;

            IF (V_IDUTILALMOX <> w_S AND  V_IDUTILLCESTQ <> w_S AND V_IDUTILLOTE <> w_S) THEN
               UPDATE ITEMPRODUTO
               SET CDALMOXARIFE  = ' ',
                   CDLOCALESTOQ  = ' ',
                   NRLOTEESTQ    = ' ',
                   NRSUBLOTE     = ' '
               WHERE (CDFILIAL     = P_FILIAL)    AND
                     (NRLANCTONF   = P_LANCTONF ) AND
                     (NRSEQITPROD  = C_ITLANCTOEST.NRSEQITPROD)  AND
                     ((CDALMOXARIFE IS NULL)       OR
                      (CDLOCALESTOQ IS NULL)       OR
                      (NRLOTEESTQ   IS NULL)       OR
                      (NRSUBLOTE    IS NULL));
            END IF;


            IF (V_IDSISTEMA = w_EXP) THEN
               BEGIN
                  SELECT IDTPCOMPPROD
                  INTO  V_IDTPCOMPPROD
                  FROM
                     PARAMPEDIDO
                  WHERE
                     CDFILIAL  = P_FILIAL;
               EXCEPTION
                  WHEN NO_DATA_FOUND THEN
                     V_IDTPCOMPPROD := W_F;
               END;
            ELSE
               V_IDTPCOMPPROD := W_F;
            END IF;

            SELECT COUNT(*)
            INTO   V_EXISTE_ROT
            FROM   ROTFABLOCAL
            WHERE  CDFILIAL  = C_ITLANCTOEST.CDFILIMOVI AND
                   CDPRODUTO = C_ITLANCTOEST.CDPRODUTO;

            IF (V_EXISTE_ROT > 0)AND(V_IDTPCOMPPROD = W_F) THEN
               V_EXISTE_ROT := V_EXISTE_ROT;

               INSERE_SUBPRODMAN(P_FILIAL,P_LANCESTQ,P_TIPOOPER,C_ITLANCTOEST.CDPRODUTO,
                                 C_ITLANCTOEST.QTITEMPROD,
                                 C_ITLANCTOEST.VRTOTAITEM,C_ITLANCTOEST.VRDESCITEM,
                                 C_ITLANCTOEST.VRBRUTITEM,C_ITLANCTOEST.VRCONTITEM,
                                 V_VRTOTALANCTO,V_QTDELANCTO,V_TIPOMOVI,P_INIVALID,
                                 C_ITLANCTOEST.CDPRODESTO,
                                 C_ITLANCTOEST.NRPEDIDO, C_ITLANCTOEST.NRITEMPED, V_IDTPCOMPPROD,
                                 C_ITLANCTOEST.CDALMOXARIFE,
                                 C_ITLANCTOEST.CDLOCALESTOQ, V_IDSISTEMA);
            ELSE
               SELECT COUNT(*)
               INTO   V_EXISTE_ROT
               FROM   ROTFABRICA
               WHERE  CDPRODUTO = C_ITLANCTOEST.CDPRODUTO;

               IF (V_EXISTE_ROT > 0)AND(V_IDTPCOMPPROD = W_F)  THEN
                  V_EXISTE_ROT := V_EXISTE_ROT;

                  INSERE_SUBPRODMAN(P_FILIAL,P_LANCESTQ,P_TIPOOPER,C_ITLANCTOEST.CDPRODUTO,
                                    C_ITLANCTOEST.QTITEMPROD,
                                    C_ITLANCTOEST.VRTOTAITEM,C_ITLANCTOEST.VRDESCITEM,
                                    C_ITLANCTOEST.VRBRUTITEM,C_ITLANCTOEST.VRCONTITEM,
                                    V_VRTOTALANCTO,V_QTDELANCTO,V_TIPOMOVI,P_INIVALID,
                                    C_ITLANCTOEST.CDPRODESTO,
                                    C_ITLANCTOEST.NRPEDIDO, C_ITLANCTOEST.NRITEMPED, V_IDTPCOMPPROD,
                                    C_ITLANCTOEST.CDALMOXARIFE, C_ITLANCTOEST.CDLOCALESTOQ, V_IDSISTEMA);
               ELSE
                  SELECT COUNT(*)
                  INTO V_EXISTE_ROT
                  FROM COMPITEMPED
                  WHERE
                     CDFILIAL = C_ITLANCTOEST.CDFILIMOVI  AND
                     NRPEDIDO = C_ITLANCTOEST.NRPEDIDO    AND
                     NRITEMPED  = C_ITLANCTOEST.NRITEMPED AND
                     CDPRODUTO = C_ITLANCTOEST.CDPRODUTO;

                  IF (V_EXISTE_ROT > 0)AND(V_IDTPCOMPPROD = W_V)  THEN

                     INSERE_SUBPRODMAN(P_FILIAL,P_LANCESTQ,P_TIPOOPER,C_ITLANCTOEST.CDPRODUTO,
                                       C_ITLANCTOEST.QTITEMPROD,
                                       C_ITLANCTOEST.VRTOTAITEM,C_ITLANCTOEST.VRDESCITEM,
                                       C_ITLANCTOEST.VRBRUTITEM,C_ITLANCTOEST.VRCONTITEM,
                                       V_VRTOTALANCTO,V_QTDELANCTO,V_TIPOMOVI,P_INIVALID,
                                       C_ITLANCTOEST.CDPRODESTO,
                                       C_ITLANCTOEST.NRPEDIDO, C_ITLANCTOEST.NRITEMPED, V_IDTPCOMPPROD,
                                       C_ITLANCTOEST.CDALMOXARIFE, C_ITLANCTOEST.CDLOCALESTOQ, V_IDSISTEMA);
                  ELSE

                     IF (C_ITLANCTOEST.IDCNTRESTOQ = w_S) THEN
                        Begin
                           SELECT VRFATOCONV
                           INTO   V_FATOCONV
                           FROM   PRODUTO
                           WHERE  CDPRODUTO = C_ITLANCTOEST.CDPRODUTO;
                        Exception
                           When No_Data_Found Then
                              V_FATOCONV := Null;
                        End;

                        IF (V_FATOCONV IS NULL) OR (V_FATOCONV = 0) THEN
                           V_FATOCONV := 1;
                        END IF;

                        V_QTDELANCTO   := C_ITLANCTOEST.QTITEMPROD;
                        V_VRTOTALANCTO := C_ITLANCTOEST.VRTOTAITEM - C_ITLANCTOEST.VRDESCITEM;

                        IF NOT(V_QTDELANCTO = 0) THEN
                           V_VRUNITLANCTO := V_VRTOTALANCTO/V_QTDELANCTO;
                        ELSE
                           V_VRUNITLANCTO := V_VRTOTALANCTO;
                        END IF;

                        IF (V_IDOPERDEVONF = w_S) THEN
                           IF (V_QTDELANCTO <> 0) THEN
                              V_TOTABRUT   := (C_ITLANCTOEST.VRBRUTITEM/V_QTDELANCTO)/V_FATOCONV;
                              V_TOTACONTAB := (C_ITLANCTOEST.VRCONTITEM/V_QTDELANCTO)/V_FATOCONV;
                           ELSE
                              V_TOTABRUT   := C_ITLANCTOEST.VRBRUTITEM/V_FATOCONV;
                              V_TOTACONTAB := C_ITLANCTOEST.VRCONTITEM/V_FATOCONV;
                           END IF;
                        ELSE
                           V_TOTABRUT   := 0;
                           V_TOTACONTAB := 0;
                        END IF;

                        IF (V_IDOPERDEVONF <> w_S) OR
                           ((V_IDOPERDEVONF = w_S) AND (V_QTDELANCTO <> 0)) THEN

                           SELECT NVL(MAX(NRSEQUITEM),0) + 1
                           INTO   V_NRSEQITPROD
                           FROM   ITLANCTOEST
                           WHERE  CDFILIAL   = P_FILIAL AND
                                  NRLANCESTQ = P_LANCESTQ;

                           INSERT INTO ITLANCTOEST
                              (CDFILIAL,NRLANCESTQ,NRSEQUITEM,CDPRODUTO,QTTOTLANCTO,VRUNILANCTO,VRTOTLANCTO,
                               IDTIPOMOVI,DTLANCMOVI,IDORDEMCLC,CDPRODMOVI,QTLANCTOEST,VRLANCTOBRUT, VRLANCTOEST,
                               CDFILIMOVI,CDALMOXARIFE,CDLOCALESTOQ,NRLOTEESTQ,NRSUBLOTE,NRLANCORIGRP, IDORIGEMPROD)
                           VALUES
                              (P_FILIAL,P_LANCESTQ,LPAD(V_NRSEQITPROD,4,w_0),C_ITLANCTOEST.CDPRODUTO,
                               V_QTDELANCTO,V_VRUNITLANCTO,V_VRTOTALANCTO,
                               V_TIPOMOVI,P_INIVALID,w_8,C_ITLANCTOEST.CDPRODESTO,
                               (V_QTDELANCTO * V_FATOCONV),V_TOTABRUT, V_TOTACONTAB,
                               V_CDFILIEMIT,C_ITLANCTOEST.CDALMOXARIFE,C_ITLANCTOEST.CDLOCALESTOQ,C_ITLANCTOEST.NRLOTEESTQ,
                               C_ITLANCTOEST.NRSUBLOTE,V_IDDOCESTOQ, C_ITLANCTOEST.IDORIGEMPROD);
                        END IF;
                     END IF;

                  END IF;

               END IF;
            END IF;     /* FIM DO IF DO SISTEMA */

         END LOOP;
      ELSE  /* DEMAIS SISTEMAS QUE NÃO SEJAM EXPEDICAO NEM GESTÃO DE VENDAS */
         BEGIN
            SELECT MAX(CDFILIAL)
              INTO V_CDFILIORIG
              FROM ITEMNOTAFISC
             WHERE CDFILIALIT   = P_FILIAL
               AND NRLANCTONFIT = P_LANCTONF;
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_CDFILIORIG := NULL;
         END;
         FOR C_ITLANCTOEST IN (SELECT NRSEQITPROD,
                                      IP.CDPRODUTO,
                                      VRUNITITEM,
                                      VRTOTAITEM,
                                      QTITEMPROD,
                                      CDPRODESTO,
                                      VRBRUTITEM,
                                      VRDESCITEM,
                                      VRCONTITEM,
                                      NVL(IP.CDALMOXARIFE,' ') AS CDALMOXARIFE,
                                      NVL(IP.CDLOCALESTOQ,' ') AS CDLOCALESTOQ,
                                      NVL(NRLOTEESTQ,' ')      AS NRLOTEESTQ,
                                      NVL(NRSUBLOTE,' ')       AS NRSUBLOTE,
                                      NVL(VRCONTITEMORIG, 0) VRCONTITEMORIG,
                                      NVL(VRBRUTITEMORIG, 0) VRBRUTITEMORIG,
                                      CDARVPROD,
                                      NMPRODUTO,
                                      NVL(IP.IDORIGEMPROD, 'N') AS IDORIGEMPROD
                               FROM ITEMPRODUTO IP, PRODUTO P, PRODFILI PF
                               WHERE IP.CDFILIAL    = P_FILIAL     AND
                                     IP.NRLANCTONF  = P_LANCTONF   AND
                                     P.CDPRODUTO    = IP.CDPRODUTO AND
                                     PF.CDFILIAL    = V_CDFILIEMIT AND
                                     PF.CDPRODUTO   = P.CDPRODESTO AND
                                     NVL(IDCNTRESTOQ, w_S) <> w_N AND
                                     NVL(IP.IDATUESTPROD, 'S') = 'S') LOOP

            UPDATE ITEMPRODUTO
            SET CDPRODMOVI = C_ITLANCTOEST.CDPRODESTO
            WHERE (CDFILIAL    = P_FILIAL)    AND
                  (NRLANCTONF  = P_LANCTONF ) AND
                  (NRSEQITPROD = C_ITLANCTOEST.NRSEQITPROD);

            BEGIN
               SELECT NVL(IDATUESTTPOP, 'S') AS IDATUESTTPOP, NVL(IDREMESSAINDU, 'N') AS IDREMESSAINDU
                 INTO V_IDATUESTTPOP, V_IDREMESSAINDU
                 FROM TIPOOPERAC
                WHERE IDENTRSAIDOP = w_S
                  AND CDTIPOOPER = P_TIPOOPER;
            EXCEPTION
               WHEN NO_DATA_FOUND THEN
                  V_IDATUESTTPOP := 'S';
                  V_IDREMESSAINDU := 'N';
            END;

            IF (V_IDUTILALMOX <> w_S AND V_IDUTILLCESTQ <> w_S AND V_IDUTILLOTE <> w_S) THEN
               UPDATE ITEMPRODUTO
               SET CDALMOXARIFE  = ' ',
                   CDLOCALESTOQ  = ' ',
                   NRLOTEESTQ    = ' ',
                   NRSUBLOTE     = ' '
               WHERE (CDFILIAL     = P_FILIAL)    AND
                     (NRLANCTONF   = P_LANCTONF ) AND
                     (NRSEQITPROD  = C_ITLANCTOEST.NRSEQITPROD)  AND
                     ((CDALMOXARIFE IS NULL)       OR
                      (CDLOCALESTOQ IS NULL)       OR
                      (NRLOTEESTQ   IS NULL)       OR
                      (NRSUBLOTE    IS NULL));
            END IF;

            BEGIN
               SELECT VRFATOCONV
               INTO   V_FATOCONV
               FROM PRODUTO P, ITEMPRODUTO IP
               WHERE P.CDPRODUTO    = IP.CDPRODUTO AND
                     IP.CDFILIAL    = P_FILIAL     AND
                     IP.NRLANCTONF  = P_LANCTONF   AND
                     IP.NRSEQITPROD = C_ITLANCTOEST.NRSEQITPROD;
            EXCEPTION
               WHEN NO_DATA_FOUND THEN
                  V_FATOCONV := NULL;
            END;

            IF (V_FATOCONV IS NULL) OR (V_FATOCONV = 0) THEN
               V_FATOCONV := 1;
            END IF;

            V_QTDELANCTO   := C_ITLANCTOEST.QTITEMPROD;
            V_VRTOTALANCTO := C_ITLANCTOEST.VRTOTAITEM - C_ITLANCTOEST.VRDESCITEM;

            IF NOT(V_QTDELANCTO = 0) THEN
               V_VRUNITLANCTO := V_VRTOTALANCTO/V_QTDELANCTO;
            ELSE
               V_VRUNITLANCTO := V_VRTOTALANCTO;
            END IF;

            IF (V_IDOPERDEVONF = w_S) OR (V_IDREMESSAINDU = w_S) THEN
               IF (V_QTDELANCTO <> 0) THEN
                  V_TOTABRUT   := (C_ITLANCTOEST.VRBRUTITEM/V_QTDELANCTO)/V_FATOCONV;
                  V_TOTACONTAB := (C_ITLANCTOEST.VRCONTITEM/V_QTDELANCTO)/V_FATOCONV;
                  IF C_ITLANCTOEST.VRBRUTITEMORIG <> 0 THEN
                     V_TOTABRUT := (C_ITLANCTOEST.VRBRUTITEMORIG/V_QTDELANCTO)/V_FATOCONV;
                  END IF;
                  IF C_ITLANCTOEST.VRCONTITEMORIG <> 0 THEN
                     V_TOTACONTAB := (C_ITLANCTOEST.VRCONTITEMORIG/V_QTDELANCTO)/V_FATOCONV;
                  END IF;
               ELSE
                  V_TOTABRUT   := C_ITLANCTOEST.VRBRUTITEM/V_FATOCONV;
                  V_TOTACONTAB := C_ITLANCTOEST.VRCONTITEM/V_FATOCONV;
               END IF;
            ELSE
               V_TOTABRUT   := 0;
               V_TOTACONTAB := 0;
            END IF;

            IF (V_IDOPERDEVONF <> w_S) OR ((V_IDOPERDEVONF = w_S) AND (V_QTDELANCTO <> 0)) THEN

               INSERT INTO ITLANCTOEST
                  (CDFILIAL, NRLANCESTQ, NRSEQUITEM,               CDPRODUTO,
                   QTTOTLANCTO, VRUNILANCTO,    VRTOTLANCTO,
                   IDTIPOMOVI, DTLANCMOVI, IDORDEMCLC,CDPRODMOVI,
                   QTLANCTOEST,               VRLANCTOBRUT, VRLANCTOEST,
                   CDFILIMOVI,  CDALMOXARIFE,               CDLOCALESTOQ,               NRLOTEESTQ,
                   NRSUBLOTE,              NRLANCORIGRP, IDORIGEMPROD)
               VALUES
                  (P_FILIAL, P_LANCESTQ, C_ITLANCTOEST.NRSEQITPROD,C_ITLANCTOEST.CDPRODUTO,
                   V_QTDELANCTO,V_VRUNITLANCTO, V_VRTOTALANCTO,
                   V_TIPOMOVI, P_INIVALID, w_8,       C_ITLANCTOEST.CDPRODESTO,
                  (V_QTDELANCTO * V_FATOCONV),V_TOTABRUT,   V_TOTACONTAB,
                   V_CDFILIEMIT,C_ITLANCTOEST.CDALMOXARIFE, C_ITLANCTOEST.CDLOCALESTOQ, C_ITLANCTOEST.NRLOTEESTQ,
                   C_ITLANCTOEST.NRSUBLOTE,V_IDDOCESTOQ, C_ITLANCTOEST.IDORIGEMPROD);
            END IF;

            /* Se NF Remessa para Industrialização e Operação Atualiza Estoque */
            IF (V_IDREMESSAINDU = 'S') AND (V_IDATUESTTPOP = 'S') THEN

               IF V_IDORIGDESTNF = 'C' THEN
                  BEGIN
                     SELECT NVL(CDALMOXINFOCLI, ' ') AS CDALMOXINFOCLI, NVL(CDLOCALINFOCLI, ' ') AS CDLOCALINFOCLI
                       INTO V_CDALMOXINFO, V_CDLOCALINFO
                       FROM AGENTETERCECLI
                      WHERE CDFILIAL = V_CDFILIEMIT
                        AND CDCLIENTE = P_CLIENTE;
                  EXCEPTION
                     WHEN NO_DATA_FOUND THEN
                        V_CDALMOXINFO := ' ';
                        V_CDLOCALINFO := ' ';
                  END;
               END IF;
               IF V_IDORIGDESTNF = 'F' THEN
                  BEGIN
                     SELECT NVL(CDALMOXINFOFOR, ' ') AS CDALMOXINFOFOR, NVL(CDLOCALINFOFOR, ' ') AS CDLOCALINFOFOR
                       INTO V_CDALMOXINFO, V_CDLOCALINFO
                       FROM AGENTETERCEFOR
                      WHERE CDFILIAL = V_CDFILIEMIT
                        AND CDFORNECED = P_CLIENTE;
                  EXCEPTION
                     WHEN NO_DATA_FOUND THEN
                        V_CDALMOXINFO := ' ';
                        V_CDLOCALINFO := ' ';
                  END;

                  BEGIN
                     SELECT CDFILIAL
                       INTO V_CDFILIAGENT
                       FROM FILIAL
                      WHERE CDFORNAGETERC = P_CLIENTE;
                  EXCEPTION
                     WHEN NO_DATA_FOUND THEN
                        V_CDFILIAGENT := NULL;
                  END;

                  IF NOT V_CDFILIAGENT IS NULL THEN
                     BEGIN
                        SELECT NVL(NVL(P.CDALMOXARIFE, F.CDALMOXARIFE), ' ') AS CDALMOXARIFE, NVL(NVL(P.CDLOCALESTOQ, F.CDLOCALESTOQ), ' ') AS CDLOCALESTOQ,
                               NVL(F.IDUTILLOTE, 'N') AS IDUTILLOTE
                          INTO V_CDALMOXARIFEAG, V_CDLOCALESTOQAG, V_IDUTILLOTEAG
                          FROM PARAMFILIAL F, PRODFILI P
                         WHERE F.CDFILIAL  = V_CDFILIAGENT
                           AND P.CDFILIAL  = V_CDFILIAGENT
                           AND P.CDPRODUTO = C_ITLANCTOEST.CDPRODESTO;
                     EXCEPTION
                        WHEN NO_DATA_FOUND THEN
                           V_CDALMOXARIFEAG := ' ';
                           V_CDLOCALESTOQAG := ' ';
                           V_IDUTILLOTEAG   := 'N';
                     END;

                     BEGIN
                        SELECT CDEMPRESA, CDINSCESTA, CDINSCMUNI
                          INTO V_CDEMPRESAAG, V_CDINSCESTAAG, V_CDINSCMUNIAG
                          FROM FILIAL
                         WHERE CDFILIAL  = V_CDFILIAGENT;
                     EXCEPTION
                        WHEN NO_DATA_FOUND THEN
                           V_CDEMPRESAAG  := NULL;
                           V_CDINSCESTAAG := NULL;
                           V_CDINSCMUNIAG := NULL;
                     END;

                     IF V_IDUTILLOTEAG = 'S' THEN
                        IF (V_NRLOTEESTQAG IS NULL) OR (V_NRLOTEESTQAG = ' ') THEN
                           PRXLOTEPRODEST(V_CDFILIAGENT, P_INIVALID, C_ITLANCTOEST.CDPRODESTO, V_NRLOTEESTQAG);
                           V_NRSUBLOTEAG := ' ';
                        END IF;
                     ELSE
                        V_NRLOTEESTQAG := ' ';
                        V_NRSUBLOTEAG  := ' ';
                     END IF;
                  END IF;
               END IF;

               IF (V_CDALMOXINFO IS NOT NULL) AND (V_CDALMOXINFO <> ' ') AND (V_CDFILIAGENT IS NULL) THEN

                  IF V_BOLANESTENTR THEN
                     --GERANDO O REGISTRO NA TABELA LANCTOESTOQ PARA A ENTRADA NO ALMOXAXARIFADO
                     IF (V_NRLANESTENTR IS NULL) OR (V_NRLANESTENTR = '') THEN
                        NOVO_CODIGO_NT('LANCTOEST'||P_FILIAL, V_NRLANESTENTR);
                        V_NRLANESTENTR := SUBSTR(V_NRLANESTENTR, 11, 10);
                     END IF;

                     INSERT INTO LANCTOESTOQ
                        (CDFILIAL,
                         NRLANCESTQ,
                         IDTPLANCTO,
                         DTLANCESTQ,
                         DSLANCESTQ,
                         CDFILIMOVI,
                         CDOPERADOR)
                     VALUES
                        (P_FILIAL,
                         V_NRLANESTENTR,
                         W_2,
                         P_INIVALID,
                         'Transferência de Estoque ' || V_NRLANESTENTR,
                         V_CDFILIEMIT,
                         P_CDOPERADOR);

                     --GERANDO O REGISTRO NA TABELA CTRLMOVIESTQ
                     IF (V_NRCTRLMOVEST IS NULL) OR (V_NRCTRLMOVEST = '') THEN
                        NOVO_CODIGO_NT('NRTRANSESTQ'||V_CDFILIEMIT, V_NRCTRLMOVEST);
                        V_NRCTRLMOVEST := SUBSTR(V_NRCTRLMOVEST, 11, 10);
                     END IF;

                     INSERT INTO CTRLMOVIESTQ
                        (CDFILIAL,
                         NRCTRLMOVEST,
                         CDFILIALENTR,
                         NRLANESTENTR,
                         CDFILIALSAID,
                         NRLANESTSAID,
                         CDALMOXENTR,
                         CDALMOXSAID,
                         CDLCESTENTR,
                         CDLCESTSAID,
                         DTMOVIESTQ,
                         NRREQUESTO)
                     VALUES
                        (V_CDFILIEMIT,
                         V_NRCTRLMOVEST,
                         P_FILIAL,
                         V_NRLANESTENTR,
                         P_FILIAL,
                         P_LANCESTQ,
                         V_CDALMOXINFO,
                         C_ITLANCTOEST.CDALMOXARIFE,
                         V_CDLOCALINFO,
                         C_ITLANCTOEST.CDLOCALESTOQ,
                         P_INIVALID,
                         '');

                     V_BOLANESTENTR := FALSE;
                  END IF;

                  --GERANDO O REGISTRO NA TABELA ITLANCTOEST
                  INSERT INTO ITLANCTOEST
                     (CDFILIAL,
                      NRLANCESTQ,
                      NRSEQUITEM,
                      CDPRODUTO,
                      DSLANCESTIT,
                      CDALMOXARIFE,
                      CDLOCALESTOQ,
                      NRLOTEESTQ,
                      NRSUBLOTE,
                      CDFILIMOVI,
                      CDPRODMOVI,
                      IDORDEMCLC,
                      DTLANCMOVI,
                      IDEVOLESTOQ,
                      QTTOTLANCTO,
                      IDTIPOMOVI,
                      QTLANCTOEST,
                      VRUNILANCTO,
                      VRTOTLANCTO,
                      VRLANCTOEST,
                      VRLANCTOBRUT,
                      IDORIGEMPROD)
                  VALUES
                     (P_FILIAL,
                     V_NRLANESTENTR,
                     C_ITLANCTOEST.NRSEQITPROD,
                     C_ITLANCTOEST.CDPRODUTO,
                     '',
                     V_CDALMOXINFO,
                     V_CDLOCALINFO,
                     C_ITLANCTOEST.NRLOTEESTQ,
                     C_ITLANCTOEST.NRSUBLOTE,
                     V_CDFILIEMIT,
                     C_ITLANCTOEST.CDPRODESTO,
                     W_2,
                     P_INIVALID,
                     W_S,
                     V_QTDELANCTO,
                     W_2,
                     V_QTDELANCTO * V_FATOCONV,
                     V_VRUNITLANCTO,
                     V_VRTOTALANCTO,
                     V_TOTACONTAB,
                     V_TOTABRUT,
                     C_ITLANCTOEST.IDORIGEMPROD);
               ELSE
                  /* Se o fornecedor da nota fiscal for agente de terceirização */
                  IF NOT V_CDFILIAGENT IS NULL THEN
                     IF V_CDFILIORIG IS NULL THEN
                        IF V_BOLANESTENTRAG THEN
                           /* Gerando o registro na tabela LANCTOESTOQ para a entrada na filial relacionada ao agente de terceirização */
                           NOVO_CODIGO_NT('LANCNF/FILIAL' || V_CDFILIAGENT, V_NRLANCTONFAG);
                           V_NRLANCTONFAG := SUBSTR(V_NRLANCTONFAG, 11, 10);

                           NOVO_CODIGO_NT('LANCTOEST'||V_CDFILIAGENT, V_NRLANESTENTRAG);
                           V_NRLANESTENTRAG := SUBSTR(V_NRLANESTENTRAG, 11, 10);

                           V_TPOPERRETORNO := NULL;
                           BEGIN
                              SELECT CDTPOOPRETORNO
                                INTO V_TPOPERRETORNO
                                FROM PARAMGERAL
                               WHERE CDPARGERAL = '0001';
                           EXCEPTION
                           WHEN NO_DATA_FOUND THEN
                              V_TPOPERRETORNO := NULL;
                           END;

                           IF (V_TPOPERRETORNO IS NULL) THEN
                              RAISE_APPLICATION_ERROR(-20501, 'Tipo de operação para geração de lançamento de estoque deve ser informado - (Parâmetros para Documentos Fiscais de Saída - Operador Logístico)', TRUE);
                           END IF;

                           INSERT INTO NOTAFISCAL
                              (CDFILIAL, NRLANCTONF, CDFILIRECE, CDEMPRESA, CDINSCESTA, CDSERIE, CDINSCMUNI,
                               IDTPIJURNF, NRINSJURNF, CDFORNECED, IDBLOQUEADO, IDDOCFISCAL, IDDOCFINANC,
                               NRNOTAFISC, DTEMISSAO, DTENTRSAID, VRPRODUTOS, VRNOTAFISC, IDENTRSAIDOP,
                               CDTIPOOPER, CDSERIEENTR, CDCLIENTE, CDFILIEMIT, IDORIGDESTNF)
                           VALUES
                              (V_CDFILIAGENT, V_NRLANCTONFAG, V_CDFILIAGENT, V_CDEMPRESAAG, V_CDINSCESTAAG, NULL, V_CDINSCMUNIAG,
                               V_IDTPIJURNF, V_NRINSJURNF, P_CLIENTE, 'N', 'N', 'S',
                               NULL, P_INIVALID, P_INIVALID, NVL(V_LIQUIDO,0), NVL(V_TOTALNOTA,0), 'E',
                               V_TPOPERRETORNO, NULL, NULL, NULL, V_IDORIGDESTNF);

                           INSERT INTO ITEMNOTAFISC
                              (CDFILIAL, NRLANCTONF, NRSEQUITNOTA, CDFILIALIT, NRLANCTONFIT)
                           VALUES
                              (V_CDFILIAGENT, V_NRLANCTONFAG, '001', P_FILIAL, P_LANCTONF);

                           INSERT INTO LANCTOESTOQ
                              (CDFILIAL,
                               NRLANCESTQ,
                               NRLANCTONF,
                               IDTPLANCTO,
                               DTLANCESTQ,
                               DSLANCESTQ,
                               CDFILIMOVI,
                               CDOPERADOR)
                           VALUES
                              (V_CDFILIAGENT,
                               V_NRLANESTENTRAG,
                               V_NRLANCTONFAG,
                               'E',
                               P_INIVALID,
                               'NF Remessa Armazenagem - lanç. ' || V_CDFILIEMIT || ' ' || P_LANCTONF,
                               V_CDFILIAGENT,
                               P_CDOPERADOR);

                           V_BOLANESTENTRAG := FALSE;
                        END IF;

                        INSERT INTO ITEMPRODUTO
                           (CDFILIAL, NRLANCTONF, NRSEQITPROD, CDPRODUTO,
                            CDPRODEMIS, DSPRODEMIS, IDATUVRESTOQ, QTITEMPROD,
                            VRUNITITEM, VRDESCITEM, VRTOTAITEM, VRCONTITEM,
                            VRBRUTITEM, IDCONFORITEM, CDFILIMOVI,
                            CDALMOXARIFE, CDLOCALESTOQ, NRLOTEESTQ, NRSUBLOTE,
                            CDPRODMOVI)
                        VALUES
                           (V_CDFILIAGENT, V_NRLANCTONFAG, C_ITLANCTOEST.NRSEQITPROD, C_ITLANCTOEST.CDPRODUTO,
                            C_ITLANCTOEST.CDARVPROD, C_ITLANCTOEST.NMPRODUTO, 'S', V_QTDELANCTO,
                            V_VRUNITLANCTO, C_ITLANCTOEST.VRDESCITEM, V_VRTOTALANCTO, V_VRTOTALANCTO,
                            V_VRTOTALANCTO, 'S', V_CDFILIAGENT,
                            V_CDALMOXARIFEAG, V_CDLOCALESTOQAG, V_NRLOTEESTQAG, V_NRSUBLOTEAG,
                            C_ITLANCTOEST.CDPRODESTO);

                        INSERT INTO ITLANCTOEST
                           (CDFILIAL,
                            NRLANCESTQ,
                            NRSEQUITEM,
                            CDPRODUTO,
                            DSLANCESTIT,
                            CDALMOXARIFE,
                            CDLOCALESTOQ,
                            NRLOTEESTQ,
                            NRSUBLOTE,
                            CDFILIMOVI,
                            CDPRODMOVI,
                            IDORDEMCLC,
                            DTLANCMOVI,
                            IDEVOLESTOQ,
                            QTTOTLANCTO,
                            IDTIPOMOVI,
                            QTLANCTOEST,
                            VRUNILANCTO,
                            VRTOTLANCTO,
                            VRLANCTOEST,
                            VRLANCTOBRUT,
                            IDORIGEMPROD)
                        VALUES
                           (V_CDFILIAGENT,
                            V_NRLANESTENTRAG,
                            C_ITLANCTOEST.NRSEQITPROD,
                            C_ITLANCTOEST.CDPRODUTO,
                            '',
                            V_CDALMOXARIFEAG,
                            V_CDLOCALESTOQAG,
                            V_NRLOTEESTQAG,
                            V_NRSUBLOTEAG,
                            V_CDFILIAGENT,
                            C_ITLANCTOEST.CDPRODESTO,
                            W_2,
                            P_INIVALID,
                            W_S,
                            V_QTDELANCTO,
                            W_2,
                            V_QTDELANCTO * V_FATOCONV,
                            V_VRUNITLANCTO,
                            V_VRTOTALANCTO,
                            V_TOTACONTAB,
                            V_TOTABRUT,
                            C_ITLANCTOEST.IDORIGEMPROD);
                     END IF;
                  END IF;
               END IF;
            END IF;
         END LOOP;
      END IF;
   END IF;
   IF (V_CDSITUCRT <> '3') THEN
      SELECT COUNT(*)
         INTO V_EXISTDSDADOSADIC
         FROM ITEMPRODUTO
      WHERE CDFILIAL   = P_FILIAL
        AND NRLANCTONF = P_LANCTONF
        AND (CDFISCOPERSN IN ('101', '201') OR SUBSTR(CDFISCOPERSN,2, 3) IN ('101', '201'));
      IF V_EXISTDSDADOSADIC > 0 THEN
         V_CDIMPOSICMS  := null;
         FOR C_ICMS IN (SELECT CDIMPOSTO
                          FROM IMPOSTO
                         WHERE CDIMPOSTONFE = '00')
         LOOP
            V_CDIMPOSICMS := V_CDIMPOSICMS||C_ICMS.CDIMPOSTO||'_';
         END LOOP;
         IF V_CDIMPOSICMS IS NOT NULL THEN
            SELECT SUM(VRIMPOSTOIT) VRIMPOSTOICMS, MAX(VRALIQITEM) VRALIQUOTAICMS
              INTO V_APROVICMS, V_ALIQAPROVICMS
              FROM ITEMPROIMPOS I
             WHERE I.CDFILIAL   = P_FILIAL
               AND I.NRLANCTONF   = P_LANCTONF
               AND I.NRITPROIMPOS = '1'
               AND (INSTR(V_CDIMPOSICMS,I.CDIMPOSTO||'_') > 0)
               AND I.NRSEQITPROD IN (SELECT NRSEQITPROD
                                       FROM ITEMPRODUTO IP
                                      WHERE IP.CDFILIAL = P_FILIAL
                                        AND IP.NRLANCTONF = P_LANCTONF
                                        AND (IP.CDFISCOPERSN IN ('101', '201') OR SUBSTR(IP.CDFISCOPERSN,2, 3) IN ('101', '201')));

            SELECT COUNT(*)
              INTO V_EXISTDSDADOSADIC
              FROM DADOSADIC
             WHERE CDFILIAL = P_FILIAL
               AND NRLANCTONF = P_LANCTONF
               AND DSDADOADIC LIKE 'Permite o aproveitamento do credito do ICMS no valor de R$ %';

            IF V_EXISTDSDADOSADIC = 0 THEN
               INSERT INTO DADOSADIC(CDFILIAL, NRLANCTONF, NRDADOADIC, DSDADOADIC)
                              VALUES(P_FILIAL, P_LANCTONF, V_DADOADIC, 'Permite o aproveitamento do credito do ICMS no valor de R$ '||DECODE(SUBSTR(LTRIM(TO_CHAR(ROUND(V_APROVICMS, 2), '9999999999999.99')), 1, 1), '.', '0'||LTRIM(TO_CHAR(ROUND(V_APROVICMS, 2), '9999999999999.99')), LTRIM(TO_CHAR(ROUND(V_APROVICMS, 2), '9999999999999.99')))|| ' corresp. a alíquota de '|| DECODE(SUBSTR(LTRIM(TO_CHAR(ROUND(V_ALIQAPROVICMS, 2), '9999999999999.99')), 1, 1), '.', '0'||LTRIM(TO_CHAR(ROUND(V_ALIQAPROVICMS, 2), '9999999999999.99')), LTRIM(TO_CHAR(ROUND(V_ALIQAPROVICMS, 2), '9999999999999.99'))) || '% conf. Art.23 da LC 123/06.');

               V_DADOADIC := LPAD(RTRIM(TO_CHAR(TO_NUMBER(V_DADOADIC) + 1)),3,0);
            ELSE
               UPDATE DADOSADIC
                  SET DSDADOADIC = 'Permite o aproveitamento do credito do ICMS no valor de R$ '||DECODE(SUBSTR(LTRIM(TO_CHAR(ROUND(V_APROVICMS, 2), '9999999999999.99')), 1, 1), '.', '0'||LTRIM(TO_CHAR(ROUND(V_APROVICMS, 2), '9999999999999.99')), LTRIM(TO_CHAR(ROUND(V_APROVICMS, 2), '9999999999999.99')))|| ' corresp. a alíquota de '|| DECODE(SUBSTR(LTRIM(TO_CHAR(ROUND(V_ALIQAPROVICMS, 2), '9999999999999.99')), 1, 1), '.', '0'||LTRIM(TO_CHAR(ROUND(V_ALIQAPROVICMS, 2), '9999999999999.99')), LTRIM(TO_CHAR(ROUND(V_ALIQAPROVICMS, 2), '9999999999999.99'))) || '% conf. Art.23 da LC 123/06.'
                 WHERE CDFILIAL = P_FILIAL
                   AND NRLANCTONF = P_LANCTONF
                   AND DSDADOADIC LIKE 'Permite o aproveitamento do credito do ICMS no valor de R$ %';
            END IF;
         END IF;
      END IF;
   END IF;
END;
/

CREATE OR REPLACE FUNCTION SPED_BLOCOC(
   P_CDIMPOSTO    IN IMPOSTO.CDIMPOSTO%TYPE,
   P_CDEMPRESA    IN EMPRESA.CDEMPRESA%TYPE,
   P_CDINSCESTA   IN EMPRESA.CDINSCESTA%TYPE,
   P_DTINICIAL    IN NOTAFISCAL.DTENTRSAID%TYPE,
   P_DTFINAL      IN NOTAFISCAL.DTENTRSAID%TYPE,
   P_LIVROMAG     IN NOTAFISCAL.NRLANCTONF%TYPE,
   P_NRSEQARQMAG  IN ARQMAGNETICO.NRSEQARQMAG%TYPE,
   P_PERFIL       IN NOTAFISCAL.IDSTATUS%TYPE,
   P_VERSAO       IN VARCHAR2,
   P_IDDIFALIQ    IN VARCHAR2,
   P_TOTALIZA     IN NUMBER,
   P_GERAFORSALE  IN VARCHAR2 DEFAULT 'N') RETURN VARCHAR  
AS
   V_CONTREGC        NUMBER;
   V_SEQADIC         NUMBER;
   V_MOVIMENT        NUMBER;
   V_TOTFORPER_S     NUMBER;
   V_TOTFORPER_E     NUMBER;
   V_VRFORAPER       NUMBER;
   V_VRFORAPER_E     NUMBER;
   V_SEQUPROD        NUMBER;
   V_SEQUENCIAL      VARCHAR2(100);
   V_IDFRETE         VARCHAR2(01);
   V_IDSEGUR         VARCHAR2(01);
   V_IDOUTROS        VARCHAR2(01);
   V_IDDESCONTO      VARCHAR2(01);
   V_PIS             VARCHAR2(02);
   V_COFINS          VARCHAR2(02);
   V_IPI             VARCHAR2(02);
   V_CDIMPOSTRIB     VARCHAR2(02);
   V_DTPERIODO       VARCHAR2(01);
   V_DADOS_2         VARCHAR2(10);
   V_IDSTATUS        VARCHAR2(01);
   V_ICMS            VARCHAR2(02);
   TIPOOPER_COMPL_S  VARCHAR(02);
   TIPOOPER_COMPL_E  VARCHAR(02);
   V_DTEMISSAO       DATE;
   V_DTENTRSAID      DATE;
   V_NRSEQUMAPAPU    VARCHAR2(10);
   V_COD_NAT         VARCHAR2(100);
   V_COD_PAR         VARCHAR2(100);
   V_UNID            VARCHAR2(100);
   V_PRODUTO         VARCHAR2(100);
   V_VRDEBESP        NUMBER;
   V_LINHA           VARCHAR2(255);
   V_NR_TOT          VARCHAR2(02);
   V_DESCR_NR_TOT    VARCHAR2(255);
   V_REG_C197        VARCHAR2(1000);
   V_COD_OBS         VARCHAR2(1000);
   V_SGESTADO        VARCHAR2(02);
   V_CDAJUSTEC195    VARCHAR2(10);
   V_IDGERREGC197    VARCHAR2(10);
   V_CDSITUCRT       VARCHAR2(01);
   V_VENDABRUTA      FLOAT;
   V_VENDACANC       FLOAT;
   V_IDDIFEALIQUOTA  VARCHAR2(02);
   V_CFOPC195        VARCHAR2(01);
   V_IDANTICMSARROZ  VARCHAR2(01);
   V_CDTPOPANTARROZ  VARCHAR2(03);
   V_CDAJUSTEXTEMP   VARCHAR2(10);
   V_IDTPCARGATRIB   VARCHAR2(01);
   V_CODC195         VARCHAR2(06);
   V_TXTC195         VARCHAR2(500);
   V_CDFORNECED      VARCHAR2(20);
   V_GERAC113        VARCHAR2(01);
   V_C195            VARCHAR2(06);
   V_NRSEQITEM       NUMBER;
   V_IDATUESTTPOP    VARCHAR2(01);
   V_CONTCTBL        VARCHAR2(100);
   V_UNIDADE         VARCHAR2(100);
BEGIN
   V_SEQUPROD := NVL(P_TOTALIZA,0);

   /*Busca o tipo de operação de complemento */
   BEGIN
      SELECT MAX(TIPOOPER_S), MAX(TIPOOPER_E)
        INTO TIPOOPER_COMPL_S, TIPOOPER_COMPL_E
        FROM (SELECT DECODE(IDENTRSAIDOP,'S',CDTIPOOPER,NULL) AS TIPOOPER_S,
                     DECODE(IDENTRSAIDOP,'E',CDTIPOOPER,NULL) AS TIPOOPER_E
                FROM TIPOOPERAC
               WHERE UPPER(NMTIPOOPER) LIKE '%NF COMPLEMENTO%'
                 AND CDTIPOOPER <> '03');
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         TIPOOPER_COMPL_S := NULL;
         TIPOOPER_COMPL_E := NULL;
   END;

   BEGIN
      SELECT MAX(EN.IDENCARGO)
        INTO V_IDFRETE
        FROM ENCARGO EN
       WHERE EN.CDENCARGONFE = '01';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
           V_IDFRETE     := NULL;
   END;

   BEGIN
      SELECT MAX(EN.IDENCARGO)
        INTO V_IDSEGUR
        FROM ENCARGO EN
       WHERE EN.CDENCARGONFE = '02';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
           V_IDSEGUR     := NULL;
   END;

   BEGIN
      SELECT MAX(EN.IDENCARGO)
        INTO V_IDDESCONTO
        FROM ENCARGO EN
       WHERE EN.CDENCARGONFE = '03';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
           V_IDDESCONTO  := NULL;
   END;

   BEGIN
      SELECT MAX(EN.IDENCARGO)
        INTO V_IDOUTROS
        FROM ENCARGO EN
       WHERE EN.CDENCARGONFE = '04';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
           V_IDOUTROS    := NULL;
   END;

   V_IPI         := '10';
   V_PIS         := '50';
   V_COFINS      := '60';
   V_CDIMPOSTRIB := '80';

   /*VERIFICA SE A EMPRESA É DO SIMPLES NACIONAL, '3' NAO É DO SIMPLES, APENAS 1 E 2*/
   SELECT NVL(MAX(CDSITUCRT), '3') CDSITUCRT
     INTO V_CDSITUCRT
     FROM PARAMEMPRESA
    WHERE CDEMPRESA = P_CDEMPRESA;

   IF V_CDSITUCRT = '3' THEN
      BEGIN
         SELECT NRSEQUMAPAPU
           INTO V_NRSEQUMAPAPU
           FROM MAPAAPURAC M
          WHERE M.CDEMPRESA    = P_CDEMPRESA
            AND M.CDINSCESTA   = P_CDINSCESTA
            AND M.CDIMPOSTO    = P_CDIMPOSTO
            AND M.DTINIPERIODO = P_DTINICIAL
            AND M.DTFIMPERIODO = P_DTFINAL;
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
            V_NRSEQUMAPAPU := NULL;
      END;
   END IF;

   IF V_CDSITUCRT <> '3' THEN
      BEGIN
         SELECT NRSEQUMAPAPU
           INTO V_NRSEQUMAPAPU
           FROM MAPAAPURACSN M
          WHERE M.CDEMPRESA    = P_CDEMPRESA
            AND M.DTINIPERIODO = P_DTINICIAL
            AND M.DTFIMPERIODO = P_DTFINAL;
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
            V_NRSEQUMAPAPU := NULL;
      END;
   END IF;

   /*ESTADO DA IE*/
   SELECT MAX(SGESTADO)
     INTO V_SGESTADO
     FROM INSCRESTAD
    WHERE CDEMPRESA  = P_CDEMPRESA
      AND CDINSCESTA = P_CDINSCESTA;

   V_IDTPCARGATRIB := 'N';

   /*VERIFICA SE EXISTE CARGA TRIBUTÁRIA GERADA COMO OUTROS DÉBITOS/CRÉDITOS,
     CASO CONTRÁRIO CONSIDERA COMO SE FOSSE DÉBITO/CRÉDITO NORMAL*/
   BEGIN
      SELECT MAX('O') AS IDTPCARGATRIB
        INTO V_IDTPCARGATRIB
        FROM ITMAPARECUP
       WHERE NRSEQUMAPAPU = V_NRSEQUMAPAPU
         AND IDTIPOITMAPR IN ('OC','OD')
         AND IDCARGATRIBUTARIA = 'S';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_IDTPCARGATRIB := 'N';
   END;

   V_SEQADIC := 000001; --Código da informação complementar, registro C110.

   IF V_CDSITUCRT = '3' THEN
      FOR C_REGC100 IN(SELECT ('|C100'                                                             || '|' ||
                              NF.CAMPO2                                                            || '|' ||
                              (CASE WHEN ((NF.CDSERIEENTR BETWEEN '890' AND '899') AND (NF.CDMODDOCFISC = '55')) THEN '1' ELSE NF.CAMPO3 END) || '|' ||
                              DECODE(NF.IDSTATUSNFE,'D','',DECODE(NF.IDSTATUS,'C','',REPLACE(REPLACE(REPLACE(REPLACE(NF.IDORIGDESTNF||DECODE(NF.IDORIGDESTNF, 'F', NF.CDFORNECED, DECODE(NF.IDORIGDESTNF, 'C', NF.CDCLIENTE , DECODE(NF.IDENTRSAIDOP, 'E', NF.CDFILIEMIT, NF.CDFILIRECE))),'.'),'-'),'/'),' '))) || '|' ||
                              NF.CDMODDOCFISC                                                      || '|' ||
                              DECODE(NF.IDSTATUSNFE, 'D', '04', DECODE(NF.IDSTATUSNFE, 'I', '05',DECODE(IDSTATUS,'C','02', DECODE(NF.IDENTRSAIDOP,'S', (CASE WHEN DTEMISSAO < P_DTINICIAL THEN DECODE(NF.CDTIPOOPER,'03','07',TIPOOPER_COMPL_S,'07','01') ELSE DECODE(NF.CDTIPOOPER,'03','06',TIPOOPER_COMPL_S,'06','00') END),(CASE WHEN ((NF.CDSERIEENTR BETWEEN '890' AND '899') AND (NF.CDMODDOCFISC = '55')) THEN '08'ELSE (CASE WHEN DTENTRSAID < P_DTINICIAL THEN DECODE(NF.CDTIPOOPER,'03','07',TIPOOPER_COMPL_E,'07','01')ELSE DECODE(NF.CDTIPOOPER,'03','06',TIPOOPER_COMPL_E,'06','00') END) END))))) ||'|'||
                              CASE WHEN LENGTH(NF.NRACESSONFE) = '44' THEN SUBSTR(NRACESSONFE,23,3) ELSE REPLACE(REPLACE(DECODE(NF.IDENTRSAIDOP, 'E', NF.CDSERIEENTR, NF.CDSERIE),'-',''),'.','') END  || '|' ||
                              DECODE(NF.IDENTRSAIDOP,'E',LTRIM(NF.NRNOTAFISC,'0'), DECODE(NF.NRACESSONFE, '', LTRIM(REPLACE(LTRIM(NF.NRNOTAFISC, '0'),' ')),DECODE(NF.IDSTATUS,'C',LTRIM(NF.NRNOTAFISC,'0'),LTRIM(NF.NRNOTAFISCALELE, '0')) )  )|| '|' ||
                              DECODE(NF.CDMODDOCFISC,'04','',NRACESSONFE)                               || '|' ||  --chave da nota fiscal eletronica
                              DECODE(NF.IDSTATUSNFE, 'D', '', DECODE(NF.IDSTATUS, 'C', '', DECODE(NF.IDSTATUSNFE,'I','',TO_CHAR(NF.DTEMISSAO,'ddmmyyyy'))) )      || '|' ) AS DADOS_1,
                              (REPLACE(LTRIM(TO_CHAR(ROUND(NF.VRCONTABILNF,2), '999999999990.00')), '.', ',') || '|' ||
                              DECODE(NF.IDSTATUSNFE, 'D', '', DECODE(NF.IDSTATUS, 'C', '', DECODE(NF.IDSTATUSNFE,'I','',DECODE(NVL(NF.QTDEPARC,0),0,'2',1,'0','1'))))    || '|' || -- campo 13
                              DECODE(NF.IDSTATUSNFE, 'D', '', DECODE(NF.IDSTATUS, 'C', '', DECODE(NF.IDSTATUSNFE,'I','',REPLACE(LTRIM(TO_CHAR((SELECT SUM(ROUND(NVL(VRENCARGODESC,0),2)) FROM ITEMPRODUTO WHERE CDFILIAL = NF.CDFILIAL AND NRLANCTONF = NF.NRLANCTONF AND NRSEQITPROD IS NOT NULL), '999999999990.00')), '.', ',')))) || '|' ||
                              REPLACE(LTRIM(TO_CHAR(ROUND(DECODE(NF.IDSTATUSNFE, 'D', '', DECODE(NF.IDSTATUS, 'C', '', DECODE(NF.IDSTATUSNFE,'I','', NVL(NF.VRIMPDESONERADO,0)))),2), '999999999990.00')), '.', ',') || '|' ||  -- abatimento no tributado e nao comercial desconto ICMS
                              DECODE(NF.IDSTATUSNFE, 'D', '', DECODE(NF.IDSTATUS, 'C', '', DECODE(NF.IDSTATUSNFE,'I','',REPLACE(LTRIM(TO_CHAR(ROUND(NF.VRPRODUTOS,2)+NVL((SELECT SUM(ROUND(NVL(VRDESCITEM,0),2) + ROUND(NVL(VRENCARGOIMPXML,0),2)) FROM ITEMPRODUTO WHERE CDFILIAL = NF.CDFILIAL AND NRLANCTONF = NF.NRLANCTONF AND NRSEQITPROD IS NOT NULL),0), '999999999990.00')), '.', ',')))) || '|' ||
                              DECODE(NF.IDSTATUSNFE, 'D', '', DECODE(NF.IDSTATUS, 'C', '', DECODE(NF.IDSTATUSNFE,'I','',RPAD(NVL(NF.IDPGTOFRETE, '9'), 1, ' '))))                                       || '|' ||
                              REPLACE(LTRIM(TO_CHAR(ROUND(DECODE(NF.IDSTATUSNFE, 'D', '', DECODE(NF.IDSTATUS, 'C', '', DECODE(NF.IDSTATUSNFE,'I','',VALOR_ENCARGO_NFE(NF.CDFILIAL, NF.NRLANCTONF, V_IDFRETE,  '01')))),2), '999999999990.00')), '.', ',') || '|' ||
                              REPLACE(LTRIM(TO_CHAR(ROUND(DECODE(NF.IDSTATUSNFE, 'D', '', DECODE(NF.IDSTATUS, 'C', '', DECODE(NF.IDSTATUSNFE,'I','',VALOR_ENCARGO_NFE(NF.CDFILIAL, NF.NRLANCTONF, V_IDSEGUR,  '02')))),2), '999999999990.00')), '.', ',') || '|' ||
                              /*REPLACE(LTRIM(TO_CHAR(ROUND(DECODE(NF.IDSTATUS, 'C', '', ABS(VALOR_IMPOSTO_NF(NF.CDFILIAL, NF.NRLANCTONF,V_CDIMPOSTRIB, 'I','1')) + ABS(VALOR_IMPOSTO_NF(NF.CDFILIAL, NF.NRLANCTONF, V_IPI, 'I','1'))),2), '999999999990.00')), '.', ',')  || '|' || --campo20*/
                              /*REPLACE(LTRIM(TO_CHAR(ROUND(DECODE(NF.IDSTATUSNFE, 'D', '', DECODE(NF.IDSTATUS, 'C', '', DECODE(NF.IDSTATUSNFE,'I','',VALOR_ENCARGO_NFE(NF.CDFILIAL, NF.NRLANCTONF, V_IDOUTROS, '04')))),2), '999999999990.00')), '.', ',') || '|' || -- Campo 20*/
                              DECODE(NF.IDSTATUSNFE, 'D', '', DECODE(NF.IDSTATUS, 'C', '', DECODE(NF.IDSTATUSNFE,'I','',REPLACE(LTRIM(TO_CHAR(ROUND((SELECT NVL(SUM(I.VRITEMENCA),0)
                                                                                                                                                       FROM ITEMENCARGO I, ENCARGO E
                                                                                                                                                      WHERE I.CDFILIAL     = NF.CDFILIAL
                                                                                                                                                        AND I.NRLANCTONF   = NF.NRLANCTONF
                                                                                                                                                        AND E.CDENCARGO    = I.CDENCARGO
                                                                                                                                                        AND E.IDENCARGO    = 'A'
                                                                                                                                                        AND E.CDENCARGONFE = '04'
                                                                                                                                                        AND I.CDENCARGO NOT IN (SELECT CDENCARGOIMPXML
                                                                                                                                                                                  FROM IMPOSTO I
                                                                                                                                                                                 WHERE CDIMPOSTONFE IN ('80','10'))),2), '999999999990.00')), '.', ',')))) || '|' || -- Campo 20 outras obrigações acessórias
                              REPLACE(LTRIM(TO_CHAR(ROUND(DECODE(NF.IDSTATUSNFE, 'D', '', DECODE(NF.IDSTATUS, 'C', '', DECODE(NF.IDSTATUSNFE,'I','',NF.VRBASECALCNF))),2), '999999999990.00')), '.', ',') || '|' || -- campo 21
                              REPLACE(LTRIM(TO_CHAR(ROUND(DECODE(NF.IDSTATUSNFE, 'D', '', DECODE(NF.IDSTATUS, 'C', '', DECODE(NF.IDSTATUSNFE,'I','',NF.VRIMPOSTONF))),2), '999999999990.00')), '.', ',') || '|' || -- campo 22
                              REPLACE(LTRIM(TO_CHAR(DECODE(NF.IDSTATUSNFE, 'D', '', DECODE(NF.IDSTATUS,'C','', DECODE(NF.IDSTATUSNFE,'I','',VALOR_IMPOSTO_NFE(NF.CDFILIAL, NF.NRLANCTONF,'80','B','1')))), '999999999990.00')), '.', ',') || '|' || -- base de calc susbt. trib
                              REPLACE(LTRIM(TO_CHAR(DECODE(NF.IDSTATUSNFE, 'D', '', DECODE(NF.IDSTATUS,'C','', DECODE(NF.IDSTATUSNFE,'I','',VALOR_IMPOSTO_NFE(NF.CDFILIAL, NF.NRLANCTONF,'80','I','1') + VALOR_FECP_NFE(NF.CDFILIAL, NF.NRLANCTONF,'80','I','1')))), '999999999990.00')), '.', ',') || '|' || -- valor do icms retido susbt. trib
                              REPLACE(LTRIM(TO_CHAR(DECODE(NF.IDSTATUSNFE, 'D', '', DECODE(NF.IDSTATUS,'C','', DECODE(NF.IDSTATUSNFE,'I','',VALOR_IMPOSTO_NFE(NF.CDFILIAL, NF.NRLANCTONF,'10','I','1')))), '999999999990.00')), '.', ',') || '|' || -- valor do IPI
                              REPLACE(LTRIM(TO_CHAR(ROUND(DECODE(NF.IDSTATUSNFE, 'D', '', DECODE(NF.IDSTATUS, 'C', '', DECODE(NF.IDSTATUSNFE,'I','',VALOR_IMPOSTO_NFE(NF.CDFILIAL, NF.NRLANCTONF, '50', 'I','1')))),2), '999999999990.00')), '.', ',') || '|' || -- valor do PIS
                              REPLACE(LTRIM(TO_CHAR(ROUND(DECODE(NF.IDSTATUSNFE, 'D', '', DECODE(NF.IDSTATUS, 'C', '', DECODE(NF.IDSTATUSNFE,'I','',VALOR_IMPOSTO_NFE(NF.CDFILIAL, NF.NRLANCTONF, '60', 'I','1')))),2), '999999999990.00')), '.', ',') || '|' || -- valor do COFINS
                              DECODE(NF.IDSTATUSNFE, 'D', '', DECODE(NF.IDSTATUS, 'C', '', DECODE(NF.IDSTATUSNFE,'I','','0,00'))) || '|' || -- pis retido por subst. trib.
                              DECODE(NF.IDSTATUSNFE, 'D', '', DECODE(NF.IDSTATUS, 'C', '', DECODE(NF.IDSTATUSNFE,'I','','0,00'))) || '|'  ) AS DADOS_3,
                              NF.CDFILIAL AS CDFILIAL, NF.NRLANCTONF AS NRLANCTONF, '' AS CDCAIXA, NF.NRINSJURTRAN, NF.IDTPIJURTRAN, NF.VRPBRUTOVOLU, NF.VRPLIQUVOLU,
                              NF.NRPLACAVEIC, NF.DSQTDEVOLU, NF.DSESPECVOLU, NF.DSMARCAVOLU, NF.DSNUMEVOLU, NF.CDFISCOPERNF, NF.NRNOTAFISC AS NRNOTAFISC,
                              NF.DTEMISSAO, NF.DTENTRSAID, NF.IDENTRSAIDOP, NF.VRIMPOSTONF, NF.CDMODDOCFISC, NF.IDSTATUS, NF.IDORIGDESTNF,
                              NF.IDORIGDESTNF||DECODE(NF.IDORIGDESTNF, 'F', NF.CDFORNECED, DECODE(NF.IDORIGDESTNF, 'C', NF.CDCLIENTE , DECODE(NF.IDENTRSAIDOP, 'E', NF.CDFILIEMIT, NF.CDFILIRECE))) AS COD_PAR,
                              DECODE(NF.IDSTATUSNFE, 'D', '04', DECODE(NF.IDSTATUSNFE, 'I', '05',DECODE(IDSTATUS,'C','02', DECODE(NF.IDENTRSAIDOP,'S', (CASE WHEN DTEMISSAO < P_DTINICIAL THEN DECODE(NF.CDTIPOOPER,'03','07',TIPOOPER_COMPL_S,'07','01') ELSE DECODE(NF.CDTIPOOPER,'03','06',TIPOOPER_COMPL_S,'06','00') END),(CASE WHEN ((NF.CDSERIEENTR BETWEEN '890' AND '899') AND (NF.CDMODDOCFISC = '55')) THEN '08'ELSE (CASE WHEN DTENTRSAID < P_DTINICIAL THEN DECODE(NF.CDTIPOOPER,'03','07',TIPOOPER_COMPL_E,'07','01')ELSE DECODE(NF.CDTIPOOPER,'03','06',TIPOOPER_COMPL_E,'06','00') END) END))))) AS SITU_DOC,
                              NF.IDSTATUSNFE, NVL(NF.IDSIMPLESNACIONAL,'N') AS IDSIMPLESNACIONAL, NF.QTDEPARC, NF.CDTIPOOPER, DECODE(NF.IDENTRSAIDOP,'S',NF.CDFILIEMIT,NF.CDFILIRECE) AS FILIAL
                         FROM (/*NF DE SAÍDA COM E SEM CARGA TRIBUTÁRIA*/
                               SELECT N.CAMPO2, N.CAMPO3, N.NRACESSONFE, N.CDFILIAL, N.NRLANCTONF, N.IDENTRSAIDOP, N.NRNOTAFISC, N.CDSERIE, N.CDSERIEENTR,
                                      N.NRINSJURNF, N.IDSTATUS, N.DTENTRSAID, N.VRNOTAFISC, N.VRPRODUTOS, N.IDPGTOFRETE,
                                      N.NRPLACAVEIC, N.DSQTDEVOLU, N.DSESPECVOLU, N.DSMARCAVOLU, N.DSNUMEVOLU,
                                      N.CDFILIEMIT, N.CDFILIRECE, N.DTEMISSAO, N.CDFISCOPERNF, N.CDMODDOCFISC, N.CDCLIENTE, N.CDFORNECED, N.IDORIGDESTNF,
                                      N.VRCONTABILNF, N.NRINSJURTRAN, N.IDTPIJURTRAN, N.VRPBRUTOVOLU, N.VRPLIQUVOLU,
                                      TO_CHAR(NVL(VALOR_IMPOSTO_NFE_CARGA(N.CDFILIAL, N.NRLANCTONF, 'B', 'I', '1'),0) - NVL(N.VRBASEC197,0) +
                                              NVL(DECODE(V_IDTPCARGATRIB,'O',0,DECODE(V_SGESTADO,'SP',0,VALOR_IMPOSTO_NFE_CARGA(N.CDFILIAL,N.NRLANCTONF,'B','C','1'))),0)) AS VRBASECALCNF,
                                      TO_CHAR(NVL(VALOR_IMPOSTO_NFE_CARGA(N.CDFILIAL, N.NRLANCTONF, 'I', 'I', '1'),0) - NVL(N.VRIMPOSTOC197,0) +
                                              NVL(DECODE(V_IDTPCARGATRIB,'O',0,VALOR_IMPOSTO_NFE_CARGA(N.CDFILIAL,N.NRLANCTONF,'I','C','1')),0)) AS VRIMPOSTONF,
                                      N.VROUTRCRED, N.VRISENTRIB, N.NRNOTAFISCALELE, N.CDTIPOOPER, N.IDSTATUSNFE, N.IDSIMPLESNACIONAL, N.QTDEPARC,
                                      (SELECT NVL(SUM(I.VRIMPOSTOIT),0) FROM ITEMPROIMPOS I, IMPOSTO IM WHERE I.IDIMPDESONERAIT = 'S' AND I.CDFILIAL = N.CDFILIAL AND I.NRLANCTONF = N.NRLANCTONF AND I.CDIMPOSTO = IM.CDIMPOSTO AND IM.CDIMPOSTONFE = P_CDIMPOSTO) VRIMPDESONERADO
                                FROM (SELECT DECODE(N.IDENTRSAIDOP, 'E', '0','1') AS CAMPO2,
                                             DECODE(N.IDENTRSAIDOP, 'E', DECODE(IDSTATUSNFE,'A','0',DECODE(IDSTATUS,'E','0','1')), '0') AS CAMPO3, NRACESSONFE,
                                             I.CDFILIAL, I.NRLANCTONF, N.IDENTRSAIDOP, N.NRNOTAFISC, NVL(SS.CDSERIENFE,N.CDSERIE) AS CDSERIE, NVL(SE.CDSERIEENTRNFE,N.CDSERIEENTR) AS CDSERIEENTR,
                                             N.NRINSJURNF, N.IDSTATUS, N.DTENTRSAID, N.VRNOTAFISC, TO_CHAR(N.VRPRODUTOS) AS VRPRODUTOS, N.IDPGTOFRETE,
                                             N.NRPLACAVEIC, N.DSQTDEVOLU, N.DSESPECVOLU, N.DSMARCAVOLU, N.DSNUMEVOLU,
                                             N.CDFILIEMIT, N.CDFILIRECE, N.DTEMISSAO, MAX(I.CDFISCOPERNF) AS CDFISCOPERNF, N.CDMODDOCFISC, N.CDCLIENTE, N.CDFORNECED, N.IDORIGDESTNF,
                                             TO_CHAR(SUM(I.VRCONTABILNF)) AS VRCONTABILNF, N.NRINSJURTRAN, N.IDTPIJURTRAN, N.VRPBRUTOVOLU, N.VRPLIQUVOLU,
                                             NVL(C_197.VRBASEC197,0) AS VRBASEC197, NVL(C_197.VRIMPOSTOC197,0) AS VRIMPOSTOC197,
                                             TO_CHAR(SUM(DECODE(I.CDFISCALNF,'3',I.VRCONTABILNF,0)))   AS VROUTRCRED,
                                             TO_CHAR(SUM(DECODE(I.CDFISCALNF,'2',I.VRCONTABILNF,'1',DECODE(I.VRPERREDBCNF,0, 0,I.VRCONTABILNF-I.VRBASECALCNF), 0))) AS VRISENTRIB,
                                             N.NRNOTAFISCALELE, N.CDTIPOOPER, N.IDSTATUSNFE,  DECODE(N.IDORIGDESTNF,'F',PF.IDSIMPLESNACIONAL,'N') AS IDSIMPLESNACIONAL,
                                             MAX((SELECT COUNT(DISTINCT NRPARCELAREC)
                                                    FROM CONTARECEBER C
                                                   WHERE N.CDFILIAL    = C.CDFILIAL
                                                     AND N.NRLANCTONF  = C.NRLANCTONF
                                                     AND C.NRLANBOLREC IS NOT NULL)) AS QTDEPARC
                                        FROM NOTAFISCAL N, IMPOSTONF I, IMPOSTO IP, PARAMFORNE PF, SERIENF SS, SERIEENTR SE,
                                             (SELECT NVL(SUM(IT.VRBASECALCIT),0) AS VRBASEC197,
                                                     NVL(SUM(ROUND(IT.VRIMPOSTOIT,2)),0)  AS VRIMPOSTOC197,
                                                     DT.CDFILIAL, DT.NRLANCTONF
                                                FROM ITEMPROIMPOS IT, IMPOSTO IM, DETITMAPARECUP DT
                                               WHERE IT.CDFILIAL     = DT.CDFILIAL
                                                 AND IT.NRLANCTONF   = DT.NRLANCTONF
                                                 AND IT.NRSEQITPROD  = DT.NRSEQITPROD
                                                 AND IT.CDIMPOSTO    = DT.CDIMPOSTO
                                                 AND IT.NRITPROIMPOS = DT.NRITPROIMPOS
                                                 AND IT.NRITPROIMPOS = '1'
                                                 AND IT.CDFISCALIT   = '1'
                                                 AND IT.CDIMPOSTO    = IM.CDIMPOSTO
                                                 AND IM.CDIMPOSTONFE = '00'
                                                 AND DT.IDTIPOITMAPR <> 'VI'
                                               GROUP BY DT.CDFILIAL, DT.NRLANCTONF) C_197
                                       WHERE I.NRSEQUMAPAPU    = V_NRSEQUMAPAPU
                                         AND IP.CDIMPOSTONFE   = P_CDIMPOSTO
                                         AND IP.CDIMPOSTO      = I.CDIMPOSTO
                                         AND (NVL(N.IDSISTEMA,'DFS') <> 'REC'
                                         AND NVL(N.IDSISTEMA, 'DFS') <> 'PAG'
                                         AND NVL(N.IDSISTEMA, 'DFS') <> 'CMP'
                                         AND NVL(N.IDSISTEMA, 'DFS') <> 'SUP'
                                         AND NVL(N.IDSISTEMA, 'DFS') <> 'TMP'
                                         AND NVL(N.IDSISTEMA, 'DFS') <> 'FIS')
                                         AND N.IDENTRSAIDOP    = 'S'
                                         AND NVL(I.IDIMPOSTONF, '1') <> '3'
                                         AND N.CDFILIAL        = I.CDFILIAL
                                         AND SE.CDSERIEENTR(+) = N.CDSERIEENTR
                                         AND SS.CDEMPRESA(+)   = N.CDEMPRESA
                                         AND SS.CDINSCESTA(+)  = N.CDINSCESTA
                                         AND SS.CDINSCMUNI(+)  = N.CDINSCMUNI
                                         AND SS.CDSERIE(+)     = N.CDSERIE
                                         AND N.NRLANCTONF      = I.NRLANCTONF
                                         AND N.CDFORNECED      = PF.CDFORNECED(+)
                                         AND ((N.IDSTATUS = 'A') OR (N.IDSTATUS = 'E'))
                                         AND N.CDMODDOCFISC IN ('01','1B','04','55')
                                         AND NVL(P_GERAFORSALE,'N') = 'N'
                                         AND N.CDFILIAL        = C_197.CDFILIAL(+)
                                         AND N.NRLANCTONF      = C_197.NRLANCTONF(+)
                                       GROUP BY DECODE(N.IDENTRSAIDOP, 'E', '0','1'), I.CDFILIAL, I.NRLANCTONF, N.IDENTRSAIDOP, N.NRNOTAFISC, NVL(SS.CDSERIENFE,N.CDSERIE),
                                                      NVL(SE.CDSERIEENTRNFE,N.CDSERIEENTR), N.NRINSJURNF, N.IDSTATUS, N.DTENTRSAID, N.VRNOTAFISC, TO_CHAR(N.VRPRODUTOS), N.IDPGTOFRETE,
                                                      N.DTEMISSAO, N.CDMODDOCFISC, N.CDCLIENTE, N.CDFORNECED, N.IDORIGDESTNF,
                                                      N.CDFILIEMIT, N.CDFILIRECE, N.NRINSJURTRAN, N.IDTPIJURTRAN, N.VRPBRUTOVOLU, N.VRPLIQUVOLU,
                                                      N.NRPLACAVEIC, N.DSQTDEVOLU, N.DSESPECVOLU, N.DSMARCAVOLU, N.DSNUMEVOLU, NRACESSONFE, N.NRNOTAFISCALELE, N.CDTIPOOPER, N.IDSTATUSNFE,
                                                      DECODE(N.IDORIGDESTNF,'F',PF.IDSIMPLESNACIONAL,'N'), NVL(C_197.VRBASEC197,0), NVL(C_197.VRIMPOSTOC197,0))N
                                UNION ALL
                               /******** NOTA CANCELADA *******/
                               SELECT DECODE(N.IDENTRSAIDOP, 'E', '0','1') AS CAMPO2,
                                      '0' AS CAMPO3, NRACESSONFE,
                                      N.CDFILIAL, N.NRLANCTONF, N.IDENTRSAIDOP, N.NRNOTAFISC, NVL(SS.CDSERIENFE,N.CDSERIE) AS CDSERIE, NVL(SE.CDSERIEENTRNFE,N.CDSERIEENTR) AS CDSERIEENTR,
                                      '' AS NRINSJURNF, N.IDSTATUS, N.DTENTRSAID, N.VRNOTAFISC, '' AS VRPRODUTOS, N.IDPGTOFRETE,
                                      N.NRPLACAVEIC, N.DSQTDEVOLU, N.DSESPECVOLU, N.DSMARCAVOLU, N.DSNUMEVOLU,
                                      '' AS CDFILIEMIT, '' AS CDFILIRECE, N.DTEMISSAO, '' AS CDFISCOPERNF, N.CDMODDOCFISC, '' AS CDCLIENTE, '' AS CDFORNECED, N.IDORIGDESTNF,
                                      '' AS VRCONTABILNF, N.NRINSJURTRAN, N.IDTPIJURTRAN, N.VRPBRUTOVOLU, N.VRPLIQUVOLU,
                                      '' AS VRBASECALCNF,
                                      '' AS VRIMPOSTONF,
                                      '' AS VROUTRCRED,
                                      '' AS VRISENTRIB,
                                      NRNOTAFISCALELE,
                                      N.CDTIPOOPER, N.IDSTATUSNFE, 'N' AS IDSIMPLESNACIONAL,
                                      0 AS QTDEPARC, 0 AS VRIMPDESONERADO
                                 FROM NOTAFISCAL N, SERIENF SS, SERIEENTR SE
                                WHERE (NVL(N.IDSISTEMA,'DFS') <> 'REC'
                                  AND NVL(N.IDSISTEMA, 'DFS') <> 'PAG'
                                  AND NVL(N.IDSISTEMA, 'DFS') <> 'CMP'
                                  AND NVL(N.IDSISTEMA, 'DFS') <> 'SUP'
                                  AND NVL(N.IDSISTEMA, 'DFS') <> 'TMP'
                                  AND NVL(N.IDSISTEMA, 'DFS') <> 'FIS')
                                  AND SE.CDSERIEENTR(+) = N.CDSERIEENTR
                                  AND SS.CDEMPRESA(+)   = N.CDEMPRESA
                                  AND SS.CDINSCESTA(+)  = N.CDINSCESTA
                                  AND SS.CDINSCMUNI(+)  = N.CDINSCMUNI
                                  AND SS.CDSERIE(+)     = N.CDSERIE
                                  AND N.IDENTRSAIDOP = 'S'
                                  AND N.IDSTATUS = 'C'
                                  AND N.CDMODDOCFISC IN ('01','1B','04','55')
                                  AND N.DTEMISSAO BETWEEN P_DTINICIAL AND P_DTFINAL
                                  AND N.CDINSCESTA = P_CDINSCESTA
                                  AND N.CDEMPRESA = P_CDEMPRESA
                                GROUP BY DECODE(N.IDENTRSAIDOP, 'E', '0','1'), N.CDFILIAL, N.NRLANCTONF, N.IDENTRSAIDOP, N.NRNOTAFISC, NVL(SS.CDSERIENFE,N.CDSERIE), NVL(SE.CDSERIEENTRNFE,N.CDSERIEENTR),
                                         N.IDSTATUS, N.DTENTRSAID, N.VRNOTAFISC, N.IDPGTOFRETE, N.CDMODDOCFISC, N.CDCLIENTE,
                                         N.CDFORNECED, N.IDORIGDESTNF, N.CDFILIEMIT, N.CDFILIRECE, N.DTEMISSAO, N.NRINSJURTRAN, N.IDTPIJURTRAN,
                                         N.VRPBRUTOVOLU, N.VRPLIQUVOLU, N.NRPLACAVEIC, N.DSQTDEVOLU, N.DSESPECVOLU, N.DSMARCAVOLU,
                                         N.DSNUMEVOLU, N.NRACESSONFE, N.CDTIPOOPER, N.IDSTATUSNFE, N.NRNOTAFISCALELE
                                UNION ALL
                               /******** NOTA DENEGADA *******/
                               /*Não é possível escriturar nota denegada na entrada, então mesmo que seja a transmissão de uma entrada
                                 deve ser escriturada como saída para manter o controle de numeração*/
                               SELECT '1' AS CAMPO2,
                                      '0' AS CAMPO3, NRACESSONFE,
                                      '' AS CDFILIAL, '' AS NRLANCTONF, N.IDENTRSAIDOP, N.NRNOTAFISC, NVL(NVL(SS.CDSERIENFE,N.CDSERIE),NVL(SE.CDSERIEENTR,N.CDSERIEENTR)) AS CDSERIE, '' AS CDSERIEENTR,
                                      '' AS NRINSJURNF, N.IDSTATUS, N.DTENTRSAID, N.VRNOTAFISC, '' AS VRPRODUTOS, N.IDPGTOFRETE,
                                      '' AS NRPLACAVEIC, '' AS DSQTDEVOLU, '' AS DSESPECVOLU, '' AS DSMARCAVOLU, N.DSNUMEVOLU,
                                      '' CDFILIEMIT, '' CDFILIRECE, N.DTEMISSAO, '' AS CDFISCOPERNF, N.CDMODDOCFISC, '' AS CDCLIENTE, '' AS CDFORNECED, N.IDORIGDESTNF,
                                      '' AS VRCONTABILNF, N.NRINSJURTRAN, N.IDTPIJURTRAN, N.VRPBRUTOVOLU, N.VRPLIQUVOLU,
                                      '' AS VRBASECALCNF,
                                      '' AS VRIMPOSTONF,
                                      '' AS VROUTRCRED,
                                      '' AS VRISENTRIB,
                                      NRNOTAFISCALELE,
                                      N.CDTIPOOPER, N.IDSTATUSNFE, 'N' AS IDSIMPLESNACIONAL,
                                      0 AS QTDEPARC, 0 AS VRIMPDESONERADO
                                 FROM NOTAFISCAL N, SERIENF SS, SERIEENTR SE
                                WHERE (NVL(N.IDSISTEMA,'DFS') <> 'REC'
                                  AND NVL(N.IDSISTEMA, 'DFS') <> 'PAG'
                                  AND NVL(N.IDSISTEMA, 'DFS') <> 'CMP'
                                  AND NVL(N.IDSISTEMA, 'DFS') <> 'SUP'
                                  AND NVL(N.IDSISTEMA, 'DFS') <> 'TMP'
                                  AND NVL(N.IDSISTEMA, 'DFS') <> 'FIS')
                                  AND SE.CDSERIEENTR(+) = N.CDSERIEENTR
                                  AND SS.CDEMPRESA(+)   = N.CDEMPRESA
                                  AND SS.CDINSCESTA(+)  = N.CDINSCESTA
                                  AND SS.CDINSCMUNI(+)  = N.CDINSCMUNI
                                  AND SS.CDSERIE(+)     = N.CDSERIE
                                  AND N.IDSTATUSNFE     = 'D'
                                  AND N.NRACESSONFE     IS NOT NULL
                                  AND N.CDMODDOCFISC    IN ('01','1B','04','55')
                                  AND N.DTEMISSAO       BETWEEN P_DTINICIAL AND P_DTFINAL
                                  AND N.CDINSCESTA      = P_CDINSCESTA
                                  AND N.CDEMPRESA       = P_CDEMPRESA
                                GROUP BY DECODE(N.IDENTRSAIDOP, 'E', '0','1'), N.CDFILIAL, N.NRLANCTONF, N.IDENTRSAIDOP, N.NRNOTAFISC,
                                         NVL(NVL(SS.CDSERIENFE,N.CDSERIE),NVL(SE.CDSERIEENTR,N.CDSERIEENTR)),
                                         N.IDSTATUS, N.DTENTRSAID, N.VRNOTAFISC, N.IDPGTOFRETE, N.CDMODDOCFISC, N.CDCLIENTE,
                                         N.CDFORNECED, N.IDORIGDESTNF, N.CDFILIEMIT, N.CDFILIRECE, N.DTEMISSAO, N.NRINSJURTRAN, N.IDTPIJURTRAN,
                                         N.VRPBRUTOVOLU, N.VRPLIQUVOLU, N.NRPLACAVEIC, N.DSQTDEVOLU, N.DSESPECVOLU, N.DSMARCAVOLU,
                                         N.DSNUMEVOLU, N.NRACESSONFE, N.CDTIPOOPER, N.IDSTATUSNFE, N.NRNOTAFISCALELE
                                UNION ALL
                               /******** NÚMERAÇÃO INUTILIZADA *******/
                               SELECT '1' AS CAMPO2,
                                      '0' AS CAMPO3,
                                      ''  AS NRACESSONFE,
                                      ''  AS CDFILIAL, '' AS NRLANCTONF,
                                      'S' AS IDENTRSAIDOP, N.NRINUTILNFELE AS NRNOTAFISC, N.CDSERIE AS CDSERIE, '' AS CDSERIEENTR,
                                      '' AS NRINSJURNF, 'I' AS IDSTATUS, N.DTINUTNFE AS DTENTRSAID, 0 AS VRNOTAFISC, '' AS VRPRODUTOS, '' AS IDPGTOFRETE,
                                      '' AS NRPLACAVEIC, '' AS DSQTDEVOLU, '' AS DSESPECVOLU, '' AS DSMARCAVOLU, '' AS DSNUMEVOLU,
                                      '' CDFILIEMIT, '' CDFILIRECE, N.DTINUTNFE AS DTEMISSAO, '' AS CDFISCOPERNF, '55' AS CDMODDOCFISC, '' AS CDCLIENTE, '' AS CDFORNECED, '' AS IDORIGDESTNF,
                                      '' AS VRCONTABILNF, '' AS NNRINSJURTRAN, '' AS IDTPIJURTRAN, 0 AS VRPBRUTOVOLU, 0 AS VRPLIQUVOLU,
                                      '' AS VRBASECALCNF,
                                      '' AS VRIMPOSTONF,
                                      '' AS VROUTRCRED,
                                      '' AS VRISENTRIB,
                                      N.NRINUTILNFELE AS NRNOTAFISCALELE,
                                      '' AS CDTIPOOPER, 'I' AS IDSTATUSNFE, 'N' AS IDSIMPLESNACIONAL,
                                      0 AS QTDEPARC, 0 AS VRIMPDESONERADO
                                 FROM NUMINUTILNFELE N
                                WHERE TRUNC(N.DTINUTNFE)BETWEEN P_DTINICIAL AND P_DTFINAL
                                  AND N.CDEMPRESA  = P_CDEMPRESA
                                  AND N.CDINSCESTA = P_CDINSCESTA
                                  AND N.NRPROTOCINUTNFE  <> 'TEKNISA'
                                UNION ALL
                               /*NF ENTRADA COM E SEM CARGA TRIBUTÁRIA*/
                               SELECT N.CAMPO2, N.CAMPO3, N.NRACESSONFE, N.CDFILIAL, N.NRLANCTONF, N.IDENTRSAIDOP, N.NRNOTAFISC, N.CDSERIE,
                                      N.CDSERIEENTR, N.NRINSJURNF, N.IDSTATUS, N.DTENTRSAID, N.VRNOTAFISC, N.VRPRODUTOS, N.IDPGTOFRETE,
                                      N.NRPLACAVEIC, N.DSQTDEVOLU, N.DSESPECVOLU, N.DSMARCAVOLU, N.DSNUMEVOLU, N.CDFILIEMIT, N.CDFILIRECE,
                                      N.DTEMISSAO, N.CDFISCOPERNF, N.CDMODDOCFISC, N.CDCLIENTE, N.CDFORNECED, N.IDORIGDESTNF,
                                      N.VRCONTABILNF, N.NRINSJURTRAN, N.IDTPIJURTRAN, N.VRPBRUTOVOLU, N.VRPLIQUVOLU,
                                      TO_CHAR(NVL(VALOR_IMPOSTO_NFE_CARGA(N.CDFILIAL, N.NRLANCTONF, 'B', 'I', '1'),0) - NVL(N.VRBASEC197,0) +
                                              NVL(DECODE(V_IDTPCARGATRIB,'O',0,DECODE(V_SGESTADO,'SP',0,VALOR_IMPOSTO_NFE_CARGA(N.CDFILIAL,N.NRLANCTONF,'B','C','1'))),0)) AS VRBASECALCNF,
                                      TO_CHAR(NVL(VALOR_IMPOSTO_NFE_CARGA(N.CDFILIAL, N.NRLANCTONF, 'I', 'I', '1'),0) - NVL(N.VRIMPOSTOC197,0) +
                                              NVL(DECODE(V_IDTPCARGATRIB,'O',0,DECODE(V_SGESTADO,'SP',0,VALOR_IMPOSTO_NFE_CARGA(N.CDFILIAL,N.NRLANCTONF,'I','C','1'))),0)) AS VRIMPOSTONF,
                                      N.VROUTRCRED, N.VRISENTRIB, N.NRNOTAFISCALELE, N.CDTIPOOPER, N.IDSTATUSNFE, N.IDSIMPLESNACIONAL, N.QTDEPARC,
                                      (SELECT NVL(SUM(I.VRIMPOSTOIT),0) FROM ITEMPROIMPOS I, IMPOSTO IM WHERE I.IDIMPDESONERAIT = 'S' AND I.CDFILIAL = N.CDFILIAL AND I.NRLANCTONF = N.NRLANCTONF AND I.CDIMPOSTO = IM.CDIMPOSTO AND IM.CDIMPOSTONFE = P_CDIMPOSTO) VRIMPDESONERADO
                                 FROM (SELECT DECODE(N.IDENTRSAIDOP, 'E', '0','1') AS CAMPO2,
                                              DECODE(N.IDENTRSAIDOP, 'E', DECODE(IDSTATUSNFE,'A','0',DECODE(IDSTATUS,'E','0','1')), '0') AS CAMPO3, NRACESSONFE,
                                              I.CDFILIAL, I.NRLANCTONF, N.IDENTRSAIDOP, N.NRNOTAFISC, NVL(SS.CDSERIENFE,N.CDSERIE) AS CDSERIE, NVL(SE.CDSERIEENTRNFE,N.CDSERIEENTR) AS CDSERIEENTR,
                                              N.NRINSJURNF, N.IDSTATUS, N.DTENTRSAID, N.VRNOTAFISC, TO_CHAR(N.VRPRODUTOS) AS VRPRODUTOS, N.IDPGTOFRETE,
                                              N.NRPLACAVEIC, N.DSQTDEVOLU, N.DSESPECVOLU, N.DSMARCAVOLU, N.DSNUMEVOLU,
                                              N.CDFILIEMIT, N.CDFILIRECE, N.DTEMISSAO, MAX(I.CDFISCOPERNF) AS CDFISCOPERNF, N.CDMODDOCFISC, N.CDCLIENTE, N.CDFORNECED, N.IDORIGDESTNF,
                                              TO_CHAR(SUM(I.VRCONTABILNF)) AS VRCONTABILNF, N.NRINSJURTRAN, N.IDTPIJURTRAN, N.VRPBRUTOVOLU, N.VRPLIQUVOLU,
                                              NVL(C_197.VRBASEC197,0) AS VRBASEC197, NVL(C_197.VRIMPOSTOC197,0) AS VRIMPOSTOC197,
                                              TO_CHAR(SUM(DECODE(I.CDFISCALNF,'3',I.VRCONTABILNF,0)))   AS VROUTRCRED,
                                              TO_CHAR(SUM(DECODE(I.CDFISCALNF,'2',I.VRCONTABILNF,'1',DECODE(I.VRPERREDBCNF,0, 0,I.VRCONTABILNF-I.VRBASECALCNF), 0))) AS VRISENTRIB,
                                              N.NRNOTAFISCALELE, N.CDTIPOOPER, N.IDSTATUSNFE, DECODE(N.IDORIGDESTNF,'F',PF.IDSIMPLESNACIONAL,'N') AS IDSIMPLESNACIONAL,
                                              MAX((SELECT COUNT(DISTINCT NRPARCELAPAG)
                                                     FROM CONTAPAGAR C
                                                    WHERE N.CDFILIAL    = C.CDFILIAL
                                                      AND N.NRLANCTONF  = C.NRLANCTONF
                                                      AND C.NRLANBOLPAG IS NOT NULL)) AS QTDEPARC
                                         FROM NOTAFISCAL N, IMPOSTONF I, IMPOSTO IP, PARAMFORNE PF, SERIEENTR SE, SERIENF SS,
                                              (SELECT NVL(SUM(IT.VRBASECALCIT),0) AS VRBASEC197,
                                                      NVL(SUM(ROUND(IT.VRIMPOSTOIT,2)),0)  AS VRIMPOSTOC197,
                                                      DT.CDFILIAL, DT.NRLANCTONF
                                                 FROM ITEMPROIMPOS IT, IMPOSTO IM, DETITMAPARECUP DT
                                                WHERE IT.CDFILIAL     = DT.CDFILIAL
                                                  AND IT.NRLANCTONF   = DT.NRLANCTONF
                                                  AND IT.NRSEQITPROD  = DT.NRSEQITPROD
                                                  AND IT.CDIMPOSTO    = DT.CDIMPOSTO
                                                  AND IT.NRITPROIMPOS = DT.NRITPROIMPOS
                                                  AND IT.NRITPROIMPOS = '1'
                                                  AND IT.CDFISCALIT   = '1'
                                                  AND IT.CDIMPOSTO    = IM.CDIMPOSTO
                                                  AND IM.CDIMPOSTONFE = '00'
                                                  AND DT.IDTIPOITMAPR <> 'VI'
                                                GROUP BY DT.CDFILIAL, DT.NRLANCTONF) C_197
                                        WHERE I.NRSEQUMAPAPU    = V_NRSEQUMAPAPU
                                          AND IP.CDIMPOSTONFE   = P_CDIMPOSTO
                                          AND IP.CDIMPOSTO      = I.CDIMPOSTO
                                          AND (NVL(N.IDSISTEMA,'DFS')  <> 'REC'
                                          AND NVL(N.IDSISTEMA, 'DFS')  <> 'PAG'
                                          AND NVL(N.IDSISTEMA, 'DFS')  <> 'CMP'
                                          AND NVL(N.IDSISTEMA, 'DFS')  <> 'SUP'
                                          AND NVL(N.IDSISTEMA, 'DFS')  <> 'TMP'
                                          AND NVL(N.IDSISTEMA, 'DFS')  <> 'FIS' )
                                          AND N.IDENTRSAIDOP    = 'E'
                                          AND PF.CDFORNECED(+)  = N.CDFORNECED
                                          AND NVL(I.IDIMPOSTONF, '1') <> '3'
                                          AND N.CDFILIAL        = I.CDFILIAL
                                          AND N.NRLANCTONF      = I.NRLANCTONF
                                          AND SE.CDSERIEENTR(+) = N.CDSERIEENTR
                                          AND SS.CDEMPRESA(+)   = N.CDEMPRESA
                                          AND SS.CDINSCESTA(+)  = N.CDINSCESTA
                                          AND SS.CDINSCMUNI(+)  = N.CDINSCMUNI
                                          AND SS.CDSERIE(+)     = N.CDSERIE
                                          AND ((N.IDSTATUS = 'A') OR (N.IDSTATUS = 'E'))
                                          AND N.CDMODDOCFISC IN ('01','1B','04','55')
                                          AND NVL(P_GERAFORSALE,'N') = 'N'
                                          AND N.CDFILIAL        = C_197.CDFILIAL(+)
                                          AND N.NRLANCTONF      = C_197.NRLANCTONF(+)
                                        GROUP BY DECODE(N.IDENTRSAIDOP, 'E', '0','1'), I.CDFILIAL, I.NRLANCTONF, N.IDENTRSAIDOP,
                                               N.NRNOTAFISC, NVL(SS.CDSERIENFE,N.CDSERIE), NVL(SE.CDSERIEENTRNFE,N.CDSERIEENTR), N.NRINSJURNF, N.IDSTATUS, N.DTENTRSAID, NRACESSONFE,
                                               N.VRNOTAFISC, TO_CHAR(N.VRPRODUTOS), N.IDPGTOFRETE, N.DTEMISSAO , N.CDMODDOCFISC, N.CDCLIENTE,
                                               N.CDFORNECED, N.IDORIGDESTNF, N.CDFILIEMIT, N.CDFILIRECE, N.NRINSJURTRAN, N.IDTPIJURTRAN, N.VRPBRUTOVOLU, N.VRPLIQUVOLU,
                                               N.NRPLACAVEIC, N.DSQTDEVOLU, N.DSESPECVOLU, N.DSMARCAVOLU, N.DSNUMEVOLU, NRACESSONFE, N.NRNOTAFISCALELE, N.CDTIPOOPER, IDSTATUSNFE,
                                               DECODE(N.IDORIGDESTNF,'F',PF.IDSIMPLESNACIONAL,'N'), NVL(C_197.VRBASEC197,0), NVL(C_197.VRIMPOSTOC197,0))N
                                UNION
                               /*******NOTAS FISCAIS FORSALE - C100 FOS ***********/
                               SELECT DECODE(NF.IDENTRSAIDOP, 'E', '0','1') AS CAMPO2,
                                      DECODE(NF.IDENTRSAIDOP, 'E', DECODE(IDSTATUS,'E','0','1'), '0') AS CAMPO3, NRACESSONFE,
                                      NF.CDFILIAL, NF.NRLANCTONF, NF.IDENTRSAIDOP, NF.NRNOTAFISC, NF.CDSERIE, NF.CDSERIEENTR,
                                      NF.NRINSJURNF, NF.IDSTATUS, NF.DTENTRSAID, NF.VRNOTAFISC, TO_CHAR(NF.VRPRODUTOS) AS VRPRODUTOS, NF.IDPGTOFRETE,
                                      NF.NRPLACAVEIC, NF.DSQTDEVOLU, NF.DSESPECVOLU, NF.DSMARCAVOLU, NF.DSNUMEVOLU,
                                      NF.CDFILIEMIT, NF.CDFILIRECE, NF.DTEMISSAO, MAX(NF.CDFISCOPERNF) AS CDFISCOPERNF, NF.CDMODDOCFISC, NF.CDCLIENTE, NF.CDFORNECED, NF.IDORIGDESTNF,
                                      NF.VRCONTABILNF AS VRCONTABILNF,
                                      NF.NRINSJURTRAN, NF.IDTPIJURTRAN, NF.VRPBRUTOVOLU, NF.VRPLIQUVOLU,
                                      TO_CHAR(VRBASECALCNF) AS VRBASECALCNF,
                                      TO_CHAR(VRIMPOSTONF),
                                      TO_CHAR(VROUTRCRED),
                                      TO_CHAR(VRISENTRIB),
                                      NF.NRNOTAFISCALELE,
                                      NF.CDTIPOOPER, '' AS IDSTATUSNFE, NF.IDSIMPLESNACIONAL, NF.QTDEPARC,
                                      (SELECT NVL(SUM(I.VRIMPOSTOIT),0) FROM ITEMPROIMPOS I, IMPOSTO IM WHERE I.IDIMPDESONERAIT = 'S' AND I.CDFILIAL = NF.CDFILIAL AND I.NRLANCTONF = NF.NRLANCTONF AND I.CDIMPOSTO = IM.CDIMPOSTO AND IM.CDIMPOSTONFE = P_CDIMPOSTO) VRIMPDESONERADO
                                 FROM ENDECLIE EC, ENDEFORN EF, ENDEFILI EFI,
                                      (SELECT DECODE(NVL(N.IDORIGDESTNF,DECODE(N.IDENTRSAIDOP,'S','C','F')),'C',CL.NRINSJURCLIE,'F',FO.NRINSJURFORN,'L',FI.NRINSJURFILI) AS NRINSJURNF,
                                              DECODE(NVL(N.IDORIGDESTNF,DECODE(N.IDENTRSAIDOP,'S','C','F')),'C',CL.NRINSESTCLIE,'F',FO.NRINSESTFORN,'L',FI.CDINSCESTA  ) AS NRINSEST,
                                              N.IDORIGDESTNF, N.CDCLIENTE, N.CDFORNECED, N.CDFILIEMIT, N.CDFILIRECE, N.NRNOTAFISC, I.CDFISCOPERNF,
                                              N.NRLANCTONF,N.CDFILIAL, N.IDENTRSAIDOP, DECODE(N.CDMODDOCFISC,'2D','55',N.CDMODDOCFISC) AS CDMODDOCFISC,
                                              NVL(SS.CDSERIENFE,N.CDSERIE) AS CDSERIE, NVL(SE.CDSERIEENTRNFE,N.CDSERIEENTR) AS CDSERIEENTR, N.DTENTRSAID, N.DTEMISSAO,
                                              TO_CHAR(SUM(VRCONTABILNF)) AS VRCONTABILNF,
                                              DECODE(I.CDFISCALNF,'1',SUM(VRBASECALCNF),0) AS VRBASECALCNF,
                                              DECODE(I.CDFISCALNF,'2',SUM(VRCONTABILNF),'1',SUM(DECODE(I.VRPERREDBCNF,0, 0,I.VRCONTABILNF-I.VRBASECALCNF)),0) AS VRISENTRIB,
                                              DECODE(I.CDFISCALNF,'3',SUM(VRCONTABILNF),0) AS VROUTRCRED,
                                              DECODE(I.CDFISCALNF,'1',SUM(VRIMPOSTONF ),0) AS VRIMPOSTONF,
                                              SUM(N.VRPRODUTOS) AS VRPRODUTOS,
                                              N.NRINSJURTRAN,N.IDTPIJURTRAN, N.VRPBRUTOVOLU, N.VRPLIQUVOLU, N.NRNOTAFISCALELE, I.VRPERREDBCNF,N.IDSTATUS,N.IDPGTOFRETE,
                                              N.NRPLACAVEIC, N.DSQTDEVOLU, N.DSESPECVOLU, N.DSMARCAVOLU, N.DSNUMEVOLU,N.VRNOTAFISC, NRACESSONFE, N.CDTIPOOPER,
                                              DECODE(N.IDORIGDESTNF,'F',PF.IDSIMPLESNACIONAL,'N') AS IDSIMPLESNACIONAL,
                                              MAX((SELECT COUNT(DISTINCT NRPARCELAREC)
                                                     FROM CONTARECEBER C
                                                    WHERE N.CDFILIAL    = C.CDFILIAL
                                                      AND N.NRLANCTONF  = C.NRLANCTONF
                                                      AND C.NRLANBOLREC IS NOT NULL)) AS QTDEPARC
                                         FROM NOTAFISCAL N, IMPOSTONF I, IMPOSTO IMP, CLIENTE CL, FORNECEDOR FO, FILIAL FI, PARAMFORNE PF, SERIENF SS, SERIEENTR SE
                                        WHERE N.CDFILIAL     = I.CDFILIAL
                                          AND N.NRLANCTONF   = I.NRLANCTONF
                                          AND IMP.CDIMPOSTO  = I.CDIMPOSTO
                                          AND N.CDCLIENTE    = CL.CDCLIENTE(+)
                                          AND N.CDFORNECED   = FO.CDFORNECED(+)
                                          AND N.CDFORNECED   = PF.CDFORNECED(+)
                                          AND N.CDFILIRECE   = FI.CDFILIAL(+)
                                          AND N.CDFILIEMIT   = FI.CDFILIAL(+)
                                          AND DTEMISSAO BETWEEN P_DTINICIAL AND P_DTFINAL
                                          AND ((N.IDSTATUS   = 'A' OR N.IDSTATUS = 'E') OR (N.IDSTATUSNFE = 'A' OR N.IDSTATUSNFE = 'T'))
                                          AND N.CDINSCESTA   = P_CDINSCESTA
                                          AND IMP.CDIMPOSTONFE = P_CDIMPOSTO
                                          AND (I.IDIMPOSTONF <> '3' OR IDIMPOSTONF IS NULL)
                                          AND (NVL(N.IDSISTEMA, 'DFS') <> 'REC'
                                          AND NVL(N.IDSISTEMA, 'DFS')  <> 'PAG'
                                          AND NVL(N.IDSISTEMA, 'DFS')  <> 'CMP'
                                          AND NVL(N.IDSISTEMA, 'DFS')  <> 'SUP'
                                          AND NVL(N.IDSISTEMA, 'DFS')  <> 'TMP'
                                          AND NVL(N.IDSISTEMA, 'DFS')  <> 'FIS')
                                          AND SE.CDSERIEENTR(+) = N.CDSERIEENTR
                                          AND SS.CDEMPRESA(+)   = N.CDEMPRESA
                                          AND SS.CDINSCESTA(+)  = N.CDINSCESTA
                                          AND SS.CDINSCMUNI(+)  = N.CDINSCMUNI
                                          AND SS.CDSERIE(+)     = N.CDSERIE
                                          AND N.CDMODDOCFISC IN ('01','1B','04','55','2D')
                                          AND N.IDENTRSAIDOP = 'S'
                                          AND NVL(P_GERAFORSALE,'N') = 'S'
                                        GROUP BY DECODE(NVL(N.IDORIGDESTNF,DECODE(N.IDENTRSAIDOP,'S','C','F')),'C',CL.NRINSJURCLIE,'F',FO.NRINSJURFORN,'L',FI.NRINSJURFILI),
                                                 DECODE(NVL(N.IDORIGDESTNF,DECODE(N.IDENTRSAIDOP,'S','C','F')),'C',CL.NRINSESTCLIE,'F',FO.NRINSESTFORN,'L',FI.CDINSCESTA),N.IDORIGDESTNF,
                                                 N.CDCLIENTE, N.CDFORNECED, N.CDFILIEMIT, N.CDFILIRECE, N.NRNOTAFISC, I.CDFISCOPERNF, N.NRLANCTONF,
                                                 N.CDFILIAL, N.IDENTRSAIDOP, N.CDMODDOCFISC, NVL(SS.CDSERIENFE,N.CDSERIE), NVL(SE.CDSERIEENTRNFE,N.CDSERIEENTR),
                                                 N.DTENTRSAID, N.DTEMISSAO,  I.CDFISCALNF, N.NRINSJURTRAN, N.IDTPIJURTRAN, N.VRPBRUTOVOLU,
                                                 N.VRPLIQUVOLU,N.NRNOTAFISCALELE,I.VRPERREDBCNF,N.IDSTATUS,IDPGTOFRETE,
                                                 N.NRPLACAVEIC, N.DSQTDEVOLU, N.DSESPECVOLU, N.DSMARCAVOLU, N.DSNUMEVOLU,N.VRNOTAFISC,NRACESSONFE,N.CDTIPOOPER,DECODE(N.IDORIGDESTNF,'F',PF.IDSIMPLESNACIONAL,'N'))NF
                                WHERE NF.CDCLIENTE    = EC.CDCLIENTE(+)
                                  AND NF.CDFORNECED   = EF.CDFORNECED(+)
                                  AND NF.CDFILIEMIT   = EFI.CDFILIAL(+)
                                  AND NF.CDFILIRECE   = EFI.CDFILIAL(+)
                                  AND IDTPENDECLIE(+) = 'P'
                                  AND IDTPENDEFORN(+) = 'P'
                                  AND IDTPENDEFILI(+) = 'P'
                                  AND NVL(P_GERAFORSALE,'N') = 'S'
                                GROUP BY DECODE(NF.IDENTRSAIDOP, 'E', '0','1'),
                                         DECODE(NF.IDENTRSAIDOP, 'E', DECODE(IDSTATUS,'E','0','1'), '0'), NRACESSONFE,
                                         NF.CDFILIAL, NF.NRLANCTONF, NF.IDENTRSAIDOP, NF.NRNOTAFISC, NF.CDSERIE, NF.CDSERIEENTR,
                                         NF.NRINSJURNF, NF.IDSTATUS, NF.DTENTRSAID, NF.VRNOTAFISC, TO_CHAR(NF.VRPRODUTOS), NF.IDPGTOFRETE,
                                         NF.NRPLACAVEIC, NF.DSQTDEVOLU, NF.DSESPECVOLU, NF.DSMARCAVOLU, NF.DSNUMEVOLU,
                                         NF.CDFILIEMIT, NF.CDFILIRECE, NF.DTEMISSAO, NF.CDMODDOCFISC, NF.CDCLIENTE, NF.CDFORNECED, NF.IDORIGDESTNF,
                                         NF.VRCONTABILNF, NF.NRINSJURTRAN, NF.IDTPIJURTRAN, NF.VRPBRUTOVOLU, NF.VRPLIQUVOLU,
                                         TO_CHAR(VRBASECALCNF), TO_CHAR(VRIMPOSTONF), TO_CHAR(VROUTRCRED), TO_CHAR(VRISENTRIB),
                                         NF.NRNOTAFISCALELE,NF.CDTIPOOPER,NF.IDSIMPLESNACIONAL, NF.QTDEPARC, NF.CDTIPOOPER)NF
                        UNION ALL
                       /*Registro C100 para Nota Fiscal Eletrônica para Consumidor Final (NFC-e)*/
                       SELECT ('|C100'                                                                || '|' ||
                               NF.CAMPO2                                                              || '|' ||
                               NF.CAMPO3                                                              || '|' ||
                               ''                                                                     || '|' ||
                               NF.CDMODDOCFISC                                                        || '|' ||
                               DECODE(NF.IDSTATUSNFCE,'D','04','I','05','C','02','00')                || '|' ||
                               REPLACE(REPLACE(NF.CDSERIE,'-',''),'.','')                             || '|' ||
                               LTRIM(NF.NRNOTAFISC,'0')                                               || '|' ||
                               NF.NRACESSONFCE                                                        || '|' ||
                               DECODE(NF.IDSTATUSNFCE,'D','','I','','C','',TO_CHAR(NF.DTEMISSAO,'ddmmyyyy')) || '|' ) AS DADOS_1,
                               (DECODE(NF.IDSTATUSNFCE,'D','','I','','C','',REPLACE(LTRIM(TO_CHAR(ROUND(NF.VRCONTABILNF,2),'999999999990.00')),'.',','))  || '|' || -- Campo 12 - Valor total do documento fiscal
                               DECODE(NF.IDSTATUSNFCE,'D','','I','','C','','0')                                                                           || '|' || -- Campo 13 - Indicador de Pagamento
                               DECODE(NF.IDSTATUSNFCE,'D','','I','','C','',REPLACE(LTRIM(TO_CHAR(NF.VRDESITVEND,'999999999990.00')),'.',','))             || '|' || -- Campo 14 - Valor total do desconto
                               DECODE(NF.IDSTATUSNFCE,'D','','I','','C','','0,00')                                                                        || '|' || -- Campo 15 - Abatimento não tributado e não comercial - desconto ICMS
                               DECODE(NF.IDSTATUSNFCE,'D','','I','','C','',REPLACE(LTRIM(TO_CHAR(ROUND(NF.VRCONTABILNF+NF.VRDESITVEND,2),'999999999990.00')),'.',',')) || '|' || -- Campo 16 - Valor total das mercadorias e serviços
                               DECODE(NF.IDSTATUSNFCE,'D','','I','','C','','9')                                                                           || '|' || -- Campo 17 - Indicador de Frete
                               DECODE(NF.IDSTATUSNFCE,'D','','I','','C','','0,00')                                                                        || '|' || -- Campo 18 - Valor de Frete
                               DECODE(NF.IDSTATUSNFCE,'D','','I','','C','','0,00')                                                                        || '|' || -- Campo 19 - Valor do Seguro
                               DECODE(NF.IDSTATUSNFCE,'D','','I','','C','','0,00')                                                                        || '|' || -- Campo 20 - Outras despesas acessórias
                               DECODE(NF.IDSTATUSNFCE,'D','','I','','C','',REPLACE(LTRIM(TO_CHAR(ROUND(NF.VRBASECALC,2 ),'999999999990.00')), '.', ','))  || '|' || -- Campo 21 - Valor da base de cálculo do ICMS
                               DECODE(NF.IDSTATUSNFCE,'D','','I','','C','',REPLACE(LTRIM(TO_CHAR(ROUND(NF.VRIMPOSTONF,2),'999999999990.00')), '.', ','))  || '|' || -- Campo 22 - Valor do ICMS
                               '' || '|' || -- base de calc susbt. trib
                               '' || '|' || -- valor do icms retido susbt. trib
                               '' || '|' || -- valor do IPI
                               '' || '|' || -- valor do PIS
                               '' || '|' || -- valor do COFINS
                               '' || '|' || -- pis retido por subst. trib.
                               '' || '|'  ) AS DADOS_3,
                               NF.CDFILIAL, NF.NRLANCTONF, NF.CDCAIXA, '' AS NRINSJURTRAN, '' AS IDTPIJURTRAN, 0 AS VRPBRUTOVOLU, 0 AS VRPLIQUVOLU,
                               '' AS NRPLACAVEIC, '' AS DSQTDEVOLU, '' AS DSESPECVOLU, '' AS DSMARCAVOLU, '' AS DSNUMEVOLU, '' AS CDFISCOPERNF, NF.NRNOTAFISC AS NRNOTAFISC,
                               NF.DTEMISSAO, NF.DTENTRSAID, NF.IDENTRSAIDOP, TO_CHAR(NF.VRIMPOSTONF) AS VRIMPOSTONF, NF.CDMODDOCFISC, NF.IDSTATUS, NF.IDORIGDESTNF,
                               '' AS COD_PAR, DECODE(NF.IDSTATUSNFCE,'D','04','I','05','C','02','00') AS SITU_DOC, NF.IDSTATUSNFCE AS IDSTATUSNFE,
                               'N' AS IDSIMPLESNACIONAL, NF.QTDEPARC, '' AS CDTIPOOPER, NF.CDFILIAL AS FILIAL
                         FROM (SELECT '1' AS CAMPO2, '0' AS CAMPO3, '65' AS CDMODDOCFISC, VE.IDSTATUSNFCE, VE.CDSERIENFCE AS CDSERIE, VE.NRNOTAFISCALCE AS NRNOTAFISC,
                                      SUM(TRUNC(IT.QTPRODVEND*(IT.VRUNITVEND+NVL(IT.VRUNITVENDCL,0)),2)-NVL(IT.VRDESITVEND,0)+NVL(IT.VRACRITVEND,0)) AS VRCONTABILNF,
                                      SUM(VRDESITVEND) AS VRDESITVEND, VE.NRACESSONFCE, TRUNC(VE.DTEMISSAONFCE) AS DTEMISSAO, IP.VRIMPOSTONF, IP.VRBASECALC,
                                      VE.CDFILIAL AS CDFILIAL, VE.NRSEQVENDA AS NRLANCTONF, VE.CDCAIXA, VE.DTENTRVENDA AS DTENTRSAID, 'S' AS IDENTRSAIDOP,
                                      '' AS IDSTATUS, '' AS IDORIGDESTNF, 1 AS QTDEPARC
                                 FROM VENDA VE, ITEMVENDA IT, FILIAL FI,
                                      (SELECT I.CDFILIAL, I.CDCAIXA, I.NRSEQVENDA,
                                              SUM(CASE WHEN I.VRPRBCREDUICMS > 0
                                                       THEN I.VRBASECALCREDUZ
                                                       ELSE TRUNC(T.QTPRODVEND*(T.VRUNITVEND+NVL(T.VRUNITVENDCL,0)),2)-NVL(T.VRDESITVEND,0)+NVL(T.VRACRITVEND,0) END) AS VRBASECALC,
                                              SUM(CASE WHEN I.VRPRBCREDUICMS > 0
                                                       THEN I.VRIMPOPRODREDUZ
                                                       ELSE TRUNC(I.VRIMPOPRODIT,2) END) AS VRIMPOSTONF
                                         FROM ITVENDAIMPOS I,  ITEMVENDA T,  VENDA V,  IMPOSTO M, FILIAL F
                                        WHERE F.CDEMPRESA       = P_CDEMPRESA
                                          AND F.CDINSCESTA      = P_CDINSCESTA
                                          AND F.CDEMPRESA       = V.CDEMPRESA
                                          AND F.CDFILIAL        = V.CDFILIAL
                                          AND TRUNC(V.DTEMISSAONFCE) BETWEEN P_DTINICIAL AND P_DTFINAL
                                          AND V.IDSITUVENDA     = 'O'
                                          AND V.IDTPAMBNFCE     = '1'
                                          AND V.IDSTATUSNFCE    = 'A'
                                          AND V.CDFILIAL        = T.CDFILIAL
                                          AND V.NRSEQVENDA      = T.NRSEQVENDA
                                          AND V.CDCAIXA         = T.CDCAIXA
                                          AND T.CDFILIAL        = I.CDFILIAL
                                          AND T.CDCAIXA         = I.CDCAIXA
                                          AND T.NRSEQUITVEND    = I.NRSEQUITVEND
                                          AND T.NRSEQVENDA      = I.NRSEQVENDA
                                          AND I.CDIMPOSTO       = M.CDIMPOSTO
                                          AND M.CDIMPOSTONFE    = P_CDIMPOSTO
                                          AND M.IDTPIMPOSFIS    = 'T'
                                          AND V.IDAPROVACAONFCE = 'A'
                                          AND V.IDTPEMISVEND    = 'N'
                                        GROUP BY I.CDFILIAL, I.CDCAIXA, I.NRSEQVENDA) IP
                                WHERE VE.CDEMPRESA       = P_CDEMPRESA
                                  AND TRUNC(VE.DTEMISSAONFCE) BETWEEN P_DTINICIAL AND P_DTFINAL
                                  AND VE.IDSITUVENDA     = 'O'
                                  AND VE.IDTPAMBNFCE     = '1'
                                  AND VE.IDSTATUSNFCE    = 'A'
                                  AND VE.IDAPROVACAONFCE = 'A'
                                  AND VE.CDFILIAL        = IT.CDFILIAL
                                  AND VE.NRSEQVENDA      = IT.NRSEQVENDA
                                  AND VE.CDCAIXA         = IT.CDCAIXA
                                  AND IT.CDFILIAL        = IP.CDFILIAL(+)
                                  AND IT.CDCAIXA         = IP.CDCAIXA(+)
                                  AND IT.NRSEQVENDA      = IP.NRSEQVENDA(+)
                                  AND VE.IDTPEMISVEND    = 'N'
                                  AND VE.CDFILIAL        = FI.CDFILIAL
                                  AND FI.CDEMPRESA       = P_CDEMPRESA
                                  AND FI.CDINSCESTA      = P_CDINSCESTA
                                GROUP BY VE.IDSTATUSNFCE, VE.CDSERIENFCE, VE.NRNOTAFISCALCE, VE.NRACESSONFCE,
                                         TRUNC(VE.DTEMISSAONFCE), VE.CDFILIAL, VE.NRSEQVENDA, VE.CDCAIXA,
                                         VE.DTENTRVENDA, IP.VRIMPOSTONF, IP.VRBASECALC
                                UNION ALL
                               SELECT '1' AS CAMPO2, '0' AS CAMPO3, '65' AS CDMODDOCFISC, VE.IDSTATUSNFCE, VE.CDSERIENFCE AS CDSERIE, VE.NRNOTAFISCALCE AS NRNOTAFISC,
                                      0 AS VRCONTABILNF, 0 AS VRDESITVEND, VE.NRACESSONFCE, TRUNC(VE.DTEMISSAONFCE) AS DTEMISSAO, 0 AS VRIMPOSTONF, 0 AS VRBASECALC,
                                      VE.CDFILIAL AS CDFILIAL, VE.NRSEQVENDA AS NRLANCTONF, VE.CDCAIXA, VE.DTENTRVENDA AS DTENTRSAID, 'S' AS IDENTRSAIDOP,
                                      'C' AS IDSTATUS, '' AS IDORIGDESTNF, 0 AS QTDEPARC
                                 FROM VENDA VE, FILIAL FI
                                WHERE VE.CDEMPRESA       = P_CDEMPRESA
                                  AND TRUNC(VE.DTEMISSAONFCE) BETWEEN P_DTINICIAL AND P_DTFINAL
                                  AND VE.IDSITUVENDA     = 'C'
                                  AND VE.IDTPAMBNFCE     = '1'
                                  AND VE.IDSTATUSNFCE    = 'C'
                                  AND VE.IDTPEMISVEND    = 'N'
                                  AND VE.CDFILIAL        = FI.CDFILIAL
                                  AND FI.CDEMPRESA       = P_CDEMPRESA
                                  AND FI.CDINSCESTA      = P_CDINSCESTA
                                UNION ALL
                               /******** NÚMERAÇÃO INUTILIZADA *******/
                               SELECT '1' AS CAMPO2, '0' AS CAMPO3, '65' AS CDMODDOCFISC, 'I' AS IDSTATUSNFCE, I.CDSERIENFCE AS CDSERIE,
                                      I.NRNOTAFISCALCE AS NRNOTAFISC, 0 AS VRCONTABILNF, 0 AS VRDESITVEND, ''  AS NRACESSONFE,
                                      TRUNC(I.DTHRINUTNFCE) AS DTEMISSAO, 0 AS VRIMPOSTONF, 0 AS VRBASECALC, I.CDFILIAL,
                                      '' AS NRSEQVENDA, I.CDCAIXA, I.DTENTRVENDA AS DTENTRSAID, 'S' AS IDENTRSAIDOP, 'I' AS IDSTATUS,
                                      '' AS IDORIGDESTNF, 0 AS QTDEPARC
                                 FROM INUTILIZANFCE I, FILIAL F
                                WHERE I.CDFILIAL    = F.CDFILIAL
                                  AND F.CDEMPRESA   = P_CDEMPRESA
                                  AND F.CDINSCESTA  = P_CDINSCESTA
                                  AND TRUNC(I.DTHRINUTNFCE) BETWEEN P_DTINICIAL AND P_DTFINAL
                                  AND I.IDTPAMBNFCE = '1')NF)LOOP

         IF C_REGC100.IDSTATUS = 'C' OR C_REGC100.IDSTATUSNFE = 'D' OR C_REGC100.IDSTATUSNFE = 'I' THEN
            V_DADOS_2 := '|';
         ELSE
            IF C_REGC100.IDENTRSAIDOP = 'E' THEN
               V_DADOS_2 := TO_CHAR(C_REGC100.DTENTRSAID,'ddmmyyyy') || '|';
            ELSE
               V_DADOS_2 := TO_CHAR(C_REGC100.DTEMISSAO,'ddmmyyyy') || '|';
            END IF;
         END IF;

         /* verifica a situacao do documento
         IF C_REGC100.IDENTRSAIDOP = 'E' THEN
            IF C_REGC100.IDSTATUS = 'C' THEN
               /* documentos cancelados
               V_DADOS_2 := '02|';
            ELSE
               IF NOT C_REGC100.DTENTRSAID BETWEEN P_DTINICIAL AND P_DTFINAL THEN
                  /* documentos de entrada fora do periodo
                  V_DADOS_2 := '01|';
               ELSE
                  V_DADOS_2 := '00|';
               END IF;
            END IF;
         ELSE
            IF C_REGC100.IDSTATUS = 'C' THEN
               /* documentos cancelados
               V_DADOS_2 := '02|';
            ELSE
               IF NOT C_REGC100.DTENTRSAID BETWEEN P_DTINICIAL AND P_DTFINAL THEN
                  /* documentos de entrada fora do periodo
                  V_DADOS_2 := '01|';
               ELSE
                  V_DADOS_2 := '00|';
               END IF;
            END IF;
         END IF;
         /* valor utilizado para o campo valores recolhidos ou a recolher, extra apuracao - E110
         IF V_DADOS_2 = '01|' AND C_REGC100.IDENTRSAIDOP = 'S' THEN
            V_VRDEBESP := NVL(V_VRDEBESP,0)+ C_REGC100.VRIMPOSTONF;
         END IF;
         */

         V_VRDEBESP := 0;
         /* valor total de imposto fora do periodo - nf saida */
         V_VRFORAPER := 0;
         IF (C_REGC100.SITU_DOC IN ('01', '07')) AND (C_REGC100.IDENTRSAIDOP = 'S') THEN
            BEGIN
               SELECT SUM(VRIMPOSTONF)
               INTO V_VRFORAPER
               FROM IMPOSTONF IP, IMPOSTO IM
               WHERE CDFILIAL        = C_REGC100.CDFILIAL
                 AND NRLANCTONF      = C_REGC100.NRLANCTONF
                 AND CDFISCALNF      = '1'
                 AND NVL(IDIMPOSTONF,'1') <> '3'
                 AND IP.CDIMPOSTO    = IM.CDIMPOSTO
                 AND IM.CDIMPOSTONFE = P_CDIMPOSTO;
            EXCEPTION
               WHEN NO_DATA_FOUND THEN
                  V_VRFORAPER := 0;
            END;
            V_TOTFORPER_S := NVL(V_TOTFORPER_S,0)+NVL(V_VRFORAPER,0);
         END IF;

         /* valor total de imposto fora do periodo - nf entrada
         V_VRFORAPER_E := 0;
         IF (V_DADOS_2 = '01|') AND (C_REGC100.IDENTRSAIDOP = 'E') THEN
            BEGIN
               SELECT SUM(VRIMPOSTONF)
               INTO V_VRFORAPER_E
               FROM IMPOSTONF
               WHERE CDFILIAL = C_REGC100.CDFILIAL
                 AND NRLANCTONF = C_REGC100.NRLANCTONF;
            EXCEPTION
               WHEN NO_DATA_FOUND THEN
                  V_VRFORAPER_E := 0;
            END;
            V_TOTFORPER_E :=  NVL(V_TOTFORPER_E,0)+NVL(V_VRFORAPER_E,0);
         END IF;
         */

         INSERT INTO ARQMAGNETICO
            (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
         VALUES
            ('19'||LPAD(RTRIM(V_CONTREGC), 8, '0'), C_REGC100.DADOS_1||V_DADOS_2||C_REGC100.DADOS_3, P_NRSEQARQMAG);
         V_CONTREGC :=  NVL(V_CONTREGC,0) + 1;
         V_SEQUENCIAL := LPAD(RTRIM(TO_CHAR(TO_NUMBER('1'))),3,'0');

         /* CODIGO DO PARTICIPANTE */
         SELECT MAX(CDCHAVEREG)
           INTO V_COD_PAR
           FROM TMP_REGDADOSSPED
          WHERE CDCHAVEREG = C_REGC100.COD_PAR
            AND CDREGISTRO = '0150';

         IF (V_COD_PAR IS NULL) AND (C_REGC100.COD_PAR IS NOT NULL) THEN
            V_SEQUPROD := NVL(V_SEQUPROD,0) + 1;
            INSERT INTO TMP_REGDADOSSPED
              (CDREGISTRO, CDCONTREGI, CDCHAVEREG)
            VALUES
              ('0150', V_SEQUPROD, C_REGC100.COD_PAR);
         END IF;

         /*REGISTRO C101 - INFORMAÇÃO COMPLEMENTAR DOS DOCUMENTOS FISCAIS QUANDO DAS
          OPERAÇÕES INTERESTADUAIS DESTINADAS A CONSUMIDOR FINAL NÃO CONTRIBUINTE EC 87/15*/
         FOR C_REGC101 IN (SELECT '|C101'                                                           || '|' ||
                                  REPLACE(LTRIM(TO_CHAR(VRFCP,       '999999999990.00')), '.', ',') || '|' ||
                                  REPLACE(LTRIM(TO_CHAR(VRDIFALDEST, '999999999990.00')), '.', ',') || '|' ||
                                  REPLACE(LTRIM(TO_CHAR(VRDIFALORIG, '999999999990.00')), '.', ',') || '|'  AS ARQC101
                             FROM (SELECT SUM(ROUND(DECODE(C_REGC100.IDENTRSAIDOP,'S',I.VRIMPOFCP,     DECODE(C.IDTIPOCFOP,'D',I.VRIMPOFCP,     0)),2)) AS VRFCP,
                                          SUM(ROUND(DECODE(C_REGC100.IDENTRSAIDOP,'S',I.VRIMPOPARTDEST,DECODE(C.IDTIPOCFOP,'D',I.VRIMPOPARTDEST,0)),2)) AS VRDIFALDEST,
                                          SUM(ROUND(DECODE(C_REGC100.IDENTRSAIDOP,'S',I.VRIMPOPARTREME,DECODE(C.IDTIPOCFOP,'D',I.VRIMPOPARTREME,0)),2)) AS VRDIFALORIG
                                     FROM ITEMPROIMPOS I, IMPOSTO IM, CFOPPADRAO C
                                    WHERE I.CDFILIAL      = C_REGC100.CDFILIAL
                                      AND I.NRLANCTONF    = C_REGC100.NRLANCTONF
                                      AND I.CDIMPOSTO     = IM.CDIMPOSTO
                                      AND IM.CDIMPOSTONFE = P_CDIMPOSTO
                                      AND I.CDFISCOPERIT  = C.CDCFOPPADRAO
                                      AND C_REGC100.CDMODDOCFISC = '55')
                            WHERE VRFCP > 0 OR VRDIFALDEST > 0 OR VRDIFALORIG > 0) LOOP

            INSERT INTO ARQMAGNETICO
               (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
            VALUES
               ('19'||LPAD(RTRIM(V_CONTREGC), 8, '0'), C_REGC101.ARQC101 , P_NRSEQARQMAG);
            V_CONTREGC   :=  NVL(V_CONTREGC,0) + 1;
            V_SEQUENCIAL := LPAD(RTRIM(TO_CHAR(TO_NUMBER('1'))),3,'0');
         END LOOP;

         V_COD_PAR := null;

         /*REGISTRO C110 - OBSERVAÇÃO DO DOCUMENTO*/
         FOR C_REGC110 IN (SELECT '|C110'                                  ||'|'||
                                  LPAD(RTRIM(TO_CHAR(V_SEQADIC)),6,'0')    ||'|'||
                                  'CUPOM FISCAL REFERENCIADO - COO NÚMERO '||TRIM(D.NRCOOCUPOMNF)||'|'  AS DSREGC110,
                                  '|C114'                                  ||'|'||
                                  '2D'                                     ||'|'||
                                  SUBSTR(D.NRSERIEIMPNF,1,21)              ||'|'||
                                  SUBSTR(LPAD(D.NRCOOCUPOMNF,10,'0'),5,6)  ||'|'||
                                  TO_CHAR(C_REGC100.DTEMISSAO,'DDMMYYYY')  ||'|' AS DSREGC114
                             FROM DADOSNF D, NOTAFISCAL N
                            WHERE D.NRLANCTONF  = C_REGC100.NRLANCTONF
                              AND D.CDFILIAL    = C_REGC100.CDFILIAL
                              AND D.NRECFCUPOMNF IS NOT NULL
                              AND D.NRLANCTONF  = N.NRLANCTONF
                              AND D.CDFILIAL    = N.CDFILIAL
                              AND C_REGC100.CDMODDOCFISC <> '65'
                              AND NOT ((N.IDSTATUSNFE = 'A') OR (N.CDMODDOCFISC = '55')))LOOP

            INSERT INTO ARQMAGNETICO
               (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
            VALUES
               ('19'||LPAD(RTRIM(V_CONTREGC), 8, '0'), C_REGC110.DSREGC110 , P_NRSEQARQMAG);
            V_CONTREGC :=  NVL(V_CONTREGC,0) + 1;
            V_SEQUENCIAL := LPAD(RTRIM(TO_CHAR(TO_NUMBER('1'))),3,'0');

            /*REGISTRO C114 - CUPOM FISCAL REFERENCIADO*/
            INSERT INTO ARQMAGNETICO
               (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
            VALUES
               ('19'||LPAD(RTRIM(V_CONTREGC), 8, '0'), C_REGC110.DSREGC114 , P_NRSEQARQMAG);
            V_CONTREGC :=  NVL(V_CONTREGC,0) + 1;
            V_SEQUENCIAL := LPAD(RTRIM(TO_CHAR(TO_NUMBER('1'))),3,'0');
            V_SEQADIC := V_SEQADIC +1;
         END LOOP;

         /*REGISTRO C110 - OBSERVAÇÃO DO DOCUMENTO -- DADOSADIC*/
         FOR C_REGC110 IN (SELECT D.DSDADOADIC AS DSREGC110
                             FROM DADOSADIC D, NOTAFISCAL N
                            WHERE D.NRLANCTONF = C_REGC100.NRLANCTONF
                              AND D.CDFILIAL   = C_REGC100.CDFILIAL
                              AND D.NRLANCTONF = N.NRLANCTONF
                              AND D.CDFILIAL   = N.CDFILIAL
                              AND C_REGC100.CDMODDOCFISC <> '65'
                              AND NOT ((N.IDSTATUSNFE = 'A') OR (N.CDMODDOCFISC = '55')))LOOP

            INSERT INTO ARQMAGNETICO
               (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
            VALUES
               ('19'||LPAD(RTRIM(V_CONTREGC), 8, '0'), '|C110|'||LPAD(RTRIM(TO_CHAR(V_SEQADIC)),6,'0')||'|'||TRIM(SUBSTR(C_REGC110.DSREGC110, 0,499))||'|', P_NRSEQARQMAG);
            V_CONTREGC   := NVL(V_CONTREGC,0) + 1;
            V_SEQUENCIAL := LPAD(RTRIM(TO_CHAR(TO_NUMBER('1'))),3,'0');

            V_SEQUPROD := NVL(V_SEQUPROD,0) + 1;
            INSERT INTO TMP_REGDADOSSPED
               (CDREGISTRO, CDCONTREGI, CDCHAVEREG, CDCAMPO1)
            VALUES
               ('0450', V_SEQUPROD, LPAD(RTRIM(TO_CHAR(V_SEQADIC)),6,'0'), TRIM(SUBSTR(C_REGC110.DSREGC110, 0, 499)));
            V_SEQUENCIAL := LPAD(RTRIM(TO_CHAR(TO_NUMBER('1'))),3,'0');
            V_SEQADIC    := V_SEQADIC +1;
         END LOOP;

         V_GERAC113 := 'N';
         /* C113 - documento fiscal referenciado */
         FOR C_REGC113 IN (SELECT REG        ||'|'||
                                  IND_OPER   ||'|'||
                                  IND_EMIT   ||'|'||
                                  REPLACE(REPLACE(REPLACE(REPLACE(COD_PART,'.'),'-'),'/'),' ') ||'|'||
                                  COD_MOD    ||'|'||
                                  SER        ||'|'||
                                  SUB        ||'|'||
                                  NUM_DOC    ||'|'||
                                  DT_DOC     ||'|'||
                                  CASE WHEN TO_NUMBER(P_VERSAO) >= 11 THEN CHV_DOCe ||'|' ELSE '' END AS DSREG_C113,
                                  COD_PART, CDFORNECED
                             FROM (SELECT '|C113' AS REG,
                                          '0' AS IND_OPER,
                                          DECODE(SUBSTR(NP.NRACESSONFE,7,14),REPLACE(REPLACE(REPLACE(I.NRINSJURIEST,'-',''),'.',''),'/',''),'0','1') AS IND_EMIT,
                                          'F'||NVL(F.CDFORNECED,NVL(NP.NRINSJURIEST,SUBSTR(NP.NRACESSONFE,7,14))) AS  COD_PART,
                                          NVL(NP.CDMODDOCFISC,SUBSTR(NP.NRACESSONFE,21,2)) AS COD_MOD,
                                          NVL(NP.CDSERIE,SUBSTR(NP.NRACESSONFE,23,3)) AS SER,
                                          '' AS SUB,
                                          NVL(NP.NRNOTAFISC,SUBSTR(NP.NRACESSONFE,26,9)) AS NUM_DOC,
                                          TO_CHAR(NP.DTEMISSAO,'ddmmyyyy') AS DT_DOC,
                                          NP.NRACESSONFE AS CHV_DOCe,
                                          'F'||F.CDFORNECED AS CDFORNECED
                                     FROM NFPRODRURAL NP, FORNECEDOR F, INSCRESTAD I
                                    WHERE NP.CDFILIAL     = C_REGC100.CDFILIAL
                                      AND NP.NRLANCTONF   = C_REGC100.NRLANCTONF
                                      AND I.CDINSCESTA    = P_CDINSCESTA
                                      AND C_REGC100.CDMODDOCFISC <> '65'
                                      AND NVL(NP.NRINSJURIEST,SUBSTR(NP.NRACESSONFE,7,14)) = REPLACE(REPLACE(REPLACE(F.NRINSJURFORN(+),'-',''),'.',''),'/','')))LOOP
            IF V_GERAC113 = 'N' THEN
               INSERT INTO ARQMAGNETICO
                  (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
               VALUES
                  ('19'||LPAD(RTRIM(V_CONTREGC), 8, '0'), '|C110|'||LPAD(RTRIM(TO_CHAR(V_SEQADIC)),6,'0')||'|'||'NOTAS FISCAIS DE PRODUTOR RURAL REFERENCIADAS A NF: '||C_REGC100.NRNOTAFISC||'|', P_NRSEQARQMAG);
               V_CONTREGC   := NVL(V_CONTREGC,0) + 1;
               V_SEQUENCIAL := LPAD(RTRIM(TO_CHAR(TO_NUMBER('1'))),3,'0');

               V_SEQUPROD := NVL(V_SEQUPROD,0) + 1;
               INSERT INTO TMP_REGDADOSSPED
                  (CDREGISTRO, CDCONTREGI, CDCHAVEREG, CDCAMPO1)
               VALUES
                  ('0450', V_SEQUPROD, LPAD(RTRIM(TO_CHAR(V_SEQADIC)),6,'0'), 'NOTAS FISCAIS DE PRODUTOR RURAL REFERENCIADAS A NF: '||C_REGC100.NRNOTAFISC);
               V_SEQUENCIAL := LPAD(RTRIM(TO_CHAR(TO_NUMBER('1'))),3,'0');
               V_SEQADIC    := V_SEQADIC +1;
            END IF;
            V_GERAC113 := 'S';

            /* verifica se o cnpj está cadastrado no sistema - o registro 0150 é obrigatório */
            IF C_REGC113.CDFORNECED IS NOT NULL THEN

               /* CODIGO DO PARTICIPANTE */
               SELECT MAX(CDCHAVEREG)
                 INTO V_COD_PAR
                 FROM TMP_REGDADOSSPED
                WHERE CDCHAVEREG = C_REGC113.CDFORNECED
                  AND CDREGISTRO = '0150';

               IF (V_COD_PAR IS NULL) AND (C_REGC113.CDFORNECED IS NOT NULL) THEN
                  V_SEQUPROD := NVL(V_SEQUPROD,0) + 1;
                  INSERT INTO TMP_REGDADOSSPED
                    (CDREGISTRO, CDCONTREGI, CDCHAVEREG)
                  VALUES
                    ('0150', V_SEQUPROD, C_REGC113.CDFORNECED);
               END IF;
            END IF;
            V_CDFORNECED := '';

            INSERT INTO ARQMAGNETICO
               (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
            VALUES
               ('19'||LPAD(RTRIM(V_CONTREGC), 8, '0'), C_REGC113.DSREG_C113, P_NRSEQARQMAG);
            V_CONTREGC   := NVL(V_CONTREGC,0) + 1;
         END LOOP;

         /*QUANDO A OPERAÇÃO FOR A PRAZO PARA AS ENTRADAS NOS MODELOS 1 E 1A DEVER SER GERADOS OS REGISTROS REFERENTES A FATURA*/
         IF (C_REGC100.CDMODDOCFISC IN ('01','1A')) AND (C_REGC100.QTDEPARC > 1) THEN
            /*REGISTRO C140*/
            FOR C_REGC140 IN (SELECT '|C140'                                                               ||'|'||
                                     DECODE(N.IDENTRSAIDOP,'E','1','S','0')                                ||'|'||
                                     DECODE(F.IDTPTITULOCRED,'XX','',F.IDTPTITULOCRED)                     ||'|'||
                                     TRIM(DECODE(F.IDTPTITULOCRED,'99',F.DSTPTITULOCRED,''))               ||'|'||
                                     LTRIM(N.NRNOTAFISC,'0')                                               ||'|'||
                                     LPAD(RTRIM(TO_CHAR(C_REGC100.QTDEPARC)),2,'0')                        ||'|'||
                                     REPLACE(LTRIM(TO_CHAR(SUM(C.VRORIGPAG),'999999999990.00')), '.', ',') ||'|' AS DSREG_C140
                                FROM NOTAFISCAL N, FORNECEDOR F, CONTAPAGAR C
                               WHERE N.CDFILIAL   = C_REGC100.CDFILIAL
                                 AND N.NRLANCTONF = C_REGC100.NRLANCTONF
                                 AND N.CDFORNECED = F.CDFORNECED
                                 AND N.CDFILIAL   = C.CDFILIAL
                                 AND N.NRLANCTONF = C.NRLANCTONF
                               GROUP BY N.IDENTRSAIDOP, F.IDTPTITULOCRED, F.DSTPTITULOCRED,
                                     N.NRNOTAFISC, C_REGC100.QTDEPARC) LOOP

               INSERT INTO ARQMAGNETICO
                  (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
               VALUES
                  ('19'||LPAD(RTRIM(V_CONTREGC), 8, '0'), C_REGC140.DSREG_C140, P_NRSEQARQMAG);
               V_CONTREGC   := NVL(V_CONTREGC,0) + 1;
            END LOOP;

            /*REGISTRO C141*/
            FOR C_REGC141 IN (SELECT '|C141'                                                               ||'|'||
                                     LPAD(RTRIM(TO_CHAR(C.NRPARCELAPAG)),2,'0')                             ||'|'||
                                     TO_CHAR(C.DTORIGVENPAG,'DDMMYYYY')                                    ||'|'||
                                     REPLACE(LTRIM(TO_CHAR(SUM(C.VRORIGPAG),'999999999990.00')), '.', ',') ||'|' AS DSREG_C141
                                FROM CONTAPAGAR C
                               WHERE C.CDFILIAL   = C_REGC100.CDFILIAL
                                 AND C.NRLANCTONF = C_REGC100.NRLANCTONF
                               GROUP BY C.NRPARCELAPAG, C.DTORIGVENPAG
                               ORDER BY C.NRPARCELAPAG) LOOP

               INSERT INTO ARQMAGNETICO
                  (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
               VALUES
                  ('19'||LPAD(RTRIM(V_CONTREGC), 8, '0'), C_REGC141.DSREG_C141, P_NRSEQARQMAG);
               V_CONTREGC   := NVL(V_CONTREGC,0) + 1;
            END LOOP;
         END IF;

         BEGIN
            SELECT IDATUESTTPOP
              INTO V_IDATUESTTPOP
              FROM TIPOOPERAC
             WHERE CDTIPOOPER   = C_REGC100.CDTIPOOPER
               AND IDENTRSAIDOP = C_REGC100.IDENTRSAIDOP;
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_IDATUESTTPOP := 'N';
         END;

         /*REGISTRO C170*/
         FOR C_REGC170 IN (SELECT COD_ITEM       || '|' ||
                                  DESCR_COMPL    || '|' ||
                                  QTD            || '|' AS PARTE1,
                                                    '|' ||
                                  VL_ITEM        || '|' ||
                                  VL_DESC        || '|' ||
                                  IND_MOV        || '|' ||
                                  CST_ICMS       || '|' ||
                                  CFOP           || '|' ||
                                  CFOP           || '|' || -- natureza da operacao campo 12
                                  VL_BC_ICMS     || '|' ||
                                  ALIQ_ICMS      || '|' ||
                                  VL_ICMS        || '|' ||
                                  VL_BC_ICMS_ST  || '|' || --16
                                  ALIQ_ST        || '|' || --17
                                  VL_ICMS_ST     || '|' || --18
                                  ''             || '|' || -- indicador de apurao do IPI CAMPO 19
                                  CST_IPI        || '|' || -- cst ipi campo 20
                                  '' 		        || '|' || -- Cdigo enquadramento IPI campo 21
                                  VL_BC_IPI      || '|' || --22
                                  ALIQ_IPI       || '|' || --23
                                  VL_IPI         || '|' || --24
                                  CST_PIS        || '|' || -- cst pis   campo 25
                                  VL_BC_PIS      || '|' ||
                                  ALIQ_PIS       || '|' ||
                                  ''   		    || '|' || -- quantidade base de calculo
                                  ''             || '|' || -- aliquota pis quantidade
                                  VL_PIS         || '|' ||
                                  CST_COFINS     || '|' || -- cst cofins campo 31
                                  VL_BC_COFINS   || '|' ||
                                  ALIQ_COFINS    || '|' ||
                                  ''	          || '|' || -- quantidade base de calculo
                                  ''             || '|' || -- aliquota cofins quantidade
                                  VL_COFINS      || '|' ||
                                  COD_CTA        || '|' ||
                                  CASE WHEN P_VERSAO >= '013' THEN VL_ABAT_NT || '|' ELSE '' END AS ARQ_C170,  -- codigo da conta analitica contabil deb/cred
                                  CDPRODUTO, CFOP AS CDFISCOPERIT, DSCDFISOPEIT, CDCLASFISC, COD_CTA, SGUNIDADE, VRFATOCONV, CDEXPPROD, IDPRODEST
                             FROM (/* NOTAS NÃO ELETRÓNICAS COM E SEM CARGA TRIBUTÁRIA */
                                  SELECT NVL(PA.CDARVPROD,PR.CDARVPROD) AS COD_ITEM,
                                         DECODE(C_REGC100.IDENTRSAIDOP, 'E', TRIM(RETIRA_CARACTER_ESPECIAL(IT.DSPRODEMIS, 'S'))) AS DESCR_COMPL,
                                         REPLACE(LTRIM(TO_CHAR(ROUND(IT.QTITEMPROD,3), '999999999990.000')), '.', ',') AS QTD,
                                         REPLACE(LTRIM(TO_CHAR(ROUND(NVL(IT.VRTOTAITEM,0),2)+ROUND(NVL(VRENCARGOIMPXML,0),2), '999999999990.00')), '.', ',') AS VL_ITEM,
                                         REPLACE(LTRIM(TO_CHAR(ROUND(NVL(IT.VRENCARGODESC,0),2), '999999999990.00')), '.', ',') AS VL_DESC,
                                         DECODE(NVL(V_IDATUESTTPOP,'N'),'N','1','0') AS IND_MOV,
                                         LPAD(NVL(IP.CDSITUTRIBIT,0),3,'0') AS CST_ICMS,
                                         IP.CDFISCOPERIT AS CFOP,
                                         REPLACE(LTRIM(TO_CHAR(ROUND(CASE WHEN DT.NRSEQDETITMAPA IS NULL OR DT.IDTIPOITMAPR = 'VI'
                                                                          THEN NVL(VALOR_IMPOSTO_ITEM_NFE_CARGA(IP.CDFILIAL,IP.NRLANCTONF,IP.NRSEQITPROD,'B','I','1'),0)
                                                                          ELSE 0 END +
                                                                     DECODE(V_IDTPCARGATRIB,'O',0,DECODE(V_SGESTADO,'SP',0,NVL(VALOR_IMPOSTO_ITEM_NFE_CARGA(IP.CDFILIAL,IP.NRLANCTONF,IP.NRSEQITPROD,'B','C','1'),0))), 2), '999999999990.00')), '.', ',') AS VL_BC_ICMS,
                                         REPLACE(LTRIM(TO_CHAR(ROUND(DECODE(IP.CDFISCALIT, '1', DECODE(DT.NRSEQDETITMAPA,'',IP.VRALIQITEM, 0), 0) ,2), '999999999990.00')), '.', ',') AS ALIQ_ICMS,
                                         REPLACE(LTRIM(TO_CHAR(ROUND(CASE WHEN DT.NRSEQDETITMAPA IS NULL OR DT.IDTIPOITMAPR = 'VI'
                                                                          THEN NVL(VALOR_IMPOSTO_ITEM_NFE_CARGA(IP.CDFILIAL,IP.NRLANCTONF,IP.NRSEQITPROD,'I','I','1'),0)
                                                                          ELSE 0 END +
                                                                     DECODE(V_IDTPCARGATRIB,'O',0,DECODE(C_REGC100.IDENTRSAIDOP,'S',NVL(VALOR_IMPOSTO_ITEM_NFE_CARGA(IP.CDFILIAL,IP.NRLANCTONF,IP.NRSEQITPROD,'I','C','1'),0),
                                                                                                                                    DECODE(V_SGESTADO,'SP',0,NVL(VALOR_IMPOSTO_ITEM_NFE_CARGA(IP.CDFILIAL,IP.NRLANCTONF,IP.NRSEQITPROD,'I','C','1'),0)))),2), '999999999990.00')), '.', ',') AS VL_ICMS,
                                         REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_CDIMPOSTRIB, 'B','1'),2), '999999999990.00')), '.', ',') AS VL_BC_ICMS_ST,
                                         REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_CDIMPOSTRIB, 'A','1') + VALOR_FECP_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_CDIMPOSTRIB, 'A','1'),2), '999999999990.00')), '.', ',') AS ALIQ_ST,
                                         REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_CDIMPOSTRIB, 'I','1') + VALOR_FECP_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_CDIMPOSTRIB, 'I','1'),2), '999999999990.00')), '.', ',') AS VL_ICMS_ST,
                                         (SELECT MAX(CDSITUTRIBITNFE)
                                            FROM ITEMPROIMPOS N, IMPOSTO IM
                                           WHERE IP.CDFILIAL     = N.CDFILIAL
                                             AND IP.NRLANCTONF   = N.NRLANCTONF
                                             AND IP.NRSEQITPROD  = N.NRSEQITPROD
                                             AND IM.CDIMPOSTO    = N.CDIMPOSTO
                                             AND N.NRITPROIMPOS  = '1'
                                             AND IM.CDIMPOSTONFE = V_IPI)  AS CST_IPI,
                                         REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_IPI, 'B','1'),2), '999999999990.00')), '.', ',') AS VL_BC_IPI,
                                         REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_IPI, 'A','1'),2), '999999999990.00')), '.', ',') AS ALIQ_IPI,
                                         REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_IPI, 'I','1'),2), '999999999990.00')), '.', ',') AS VL_IPI,
                                         (SELECT MAX(CDSITUTRIBITNFE)
                                            FROM ITEMPROIMPOS N, IMPOSTO IM
                                           WHERE IP.CDFILIAL     = N.CDFILIAL
                                             AND IP.NRLANCTONF   = N.NRLANCTONF
                                             AND IP.NRSEQITPROD  = N.NRSEQITPROD
                                             AND IM.CDIMPOSTO    = N.CDIMPOSTO
                                             AND N.NRITPROIMPOS  = '1'
                                             AND IM.CDIMPOSTONFE = V_PIS) AS CST_PIS,
                                         REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_PIS, 'B','1'),2), '999999999990.00')), '.', ',') AS VL_BC_PIS,
                                         REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_PIS, 'A','1'),2), '999999999990.00')), '.', ',') AS ALIQ_PIS,
                                         REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_PIS, 'I','1'),2), '999999999990.00')), '.', ',') AS VL_PIS,
                                         (SELECT MAX(CDSITUTRIBITNFE)
                                            FROM ITEMPROIMPOS N, IMPOSTO IM
                                           WHERE IP.CDFILIAL     = N.CDFILIAL
                                             AND IP.NRLANCTONF   = N.NRLANCTONF
                                             AND IP.NRSEQITPROD  = N.NRSEQITPROD
                                             AND IM.CDIMPOSTO    = N.CDIMPOSTO
                                             AND N.NRITPROIMPOS  = '1'
                                             AND IM.CDIMPOSTONFE = V_COFINS) AS CST_COFINS,
                                         REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_COFINS, 'B','1'),2), '999999999990.00')), '.', ',') AS VL_BC_COFINS,
                                         REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_COFINS, 'A','1'),2), '999999999990.00')), '.', ',') AS ALIQ_COFINS,
                                         REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_COFINS, 'I','1'),2), '999999999990.00')), '.', ',') AS VL_COFINS,
                                         CONTCTBL_SPED(C_REGC100.IDENTRSAIDOP, NVL(PA.CDPRODUTO,PR.CDPRODUTO), C_REGC100.CDTIPOOPER, C_REGC100.FILIAL) AS COD_CTA,
                                         REPLACE(LTRIM(TO_CHAR(ROUND(DECODE(IP.IDIMPDESONERAIT,'S',NVL(IP.VRIMPOSTOIT,0),0),2), '999999999990.00')), '.', ',') AS VL_ABAT_NT,
                                         NVL(PA.CDPRODUTO,PR.CDPRODUTO) AS CDPRODUTO, IT.DSCDFISOPEIT, IT.CDPRODNCMTRANS AS CDCLASFISC, PR.SGUNIDADE, PR.VRFATOCONV,
                                         '' AS CDEXPPROD, DECODE(PA.CDPRODUTO,PR.CDPRODUTO,'S','N') AS IDPRODEST
                                    FROM ITEMPRODUTO IT, PRODUTO PR, PRODUTO PA, ITEMPROIMPOS IP, IMPOSTO IM, DETITMAPARECUP DT
                                   WHERE IT.CDFILIAL      = C_REGC100.CDFILIAL
                                     AND IT.NRLANCTONF    = C_REGC100.NRLANCTONF
                                     AND IM.CDIMPOSTONFE  = P_CDIMPOSTO
                                     AND IM.CDIMPOSTO     = IP.CDIMPOSTO
                                     AND IT.CDFILIAL      = IP.CDFILIAL
                                     AND IT.NRLANCTONF    = IP.NRLANCTONF
                                     AND IT.NRSEQITPROD   = IP.NRSEQITPROD
                                     AND IT.CDPRODUTO     = PR.CDPRODUTO
                                     AND PR.CDPRODESTO    = PA.CDPRODUTO(+)
                                     AND IP.NRITPROIMPOS  =  '1'
                                     AND C_REGC100.CDMODDOCFISC NOT IN ('55','65')
                                     AND ROUND(IT.QTITEMPROD,3) > 0
                                     AND IP.CDFILIAL      = DT.CDFILIAL(+)
                                     AND IP.NRLANCTONF    = DT.NRLANCTONF(+)
                                     AND IP.CDIMPOSTO     = DT.CDIMPOSTO(+)
                                     AND IP.NRSEQITPROD   = DT.NRSEQITPROD(+)
                                     AND IP.NRITPROIMPOS  = DT.NRITPROIMPOS(+)
                                   UNION ALL
                                  /*NOTAS DE ENTRADA ELETRÓNICAS COM E SEM CARGA TRIBUTÁRIA */
                                  SELECT NVL(PA.CDARVPROD,PR.CDARVPROD) AS COD_ITEM,
                                         DECODE(C_REGC100.IDENTRSAIDOP, 'E', TRIM(RETIRA_CARACTER_ESPECIAL(IT.DSPRODEMIS, 'S'))) AS DESCR_COMPL,
                                         REPLACE(LTRIM(TO_CHAR(ROUND(IT.QTITEMPROD,3), '999999999990.000')), '.', ',') AS QTD,
                                         REPLACE(LTRIM(TO_CHAR(ROUND(NVL(IT.VRTOTAITEM,0),2)+ROUND(NVL(VRENCARGOIMPXML,0),2), '999999999990.00')), '.', ',') AS VL_ITEM,
                                         REPLACE(LTRIM(TO_CHAR(ROUND(NVL(IT.VRENCARGODESC,0),2), '999999999990.00')), '.', ',') AS VL_DESC,
                                         DECODE(NVL(V_IDATUESTTPOP,'N'),'N','1','0') AS IND_MOV,
                                         LPAD(NVL(IP.CDSITUTRIBIT,0),3,'0') AS CST_ICMS,
                                         IP.CDFISCOPERIT AS CFOP,
                                         REPLACE(LTRIM(TO_CHAR(ROUND(CASE WHEN DT.NRSEQDETITMAPA IS NULL OR DT.IDTIPOITMAPR = 'VI'
                                                                          THEN NVL(VALOR_IMPOSTO_ITEM_NFE_CARGA(IP.CDFILIAL,IP.NRLANCTONF,IP.NRSEQITPROD,'B','I','1'),0)
                                                                          ELSE 0 END +
                                                                     DECODE(V_IDTPCARGATRIB,'O',0,DECODE(V_SGESTADO,'SP',0,NVL(VALOR_IMPOSTO_ITEM_NFE_CARGA(IP.CDFILIAL,IP.NRLANCTONF,IP.NRSEQITPROD,'B','C','1'),0))),2), '999999999990.00')), '.', ',') AS VL_BC_ICMS,
                                         REPLACE(LTRIM(TO_CHAR(ROUND(DECODE(IP.CDFISCALIT, '1', DECODE(DT.NRSEQDETITMAPA,'',IP.VRALIQITEM,0), 0),2), '999999999990.00')), '.', ',') AS ALIQ_ICMS,
                                         REPLACE(LTRIM(TO_CHAR(ROUND(CASE WHEN DT.NRSEQDETITMAPA IS NULL OR DT.IDTIPOITMAPR = 'VI'
                                                                          THEN NVL(VALOR_IMPOSTO_ITEM_NFE_CARGA(IP.CDFILIAL,IP.NRLANCTONF,IP.NRSEQITPROD,'I','I','1'),0)
                                                                          ELSE 0 END +
                                                                     DECODE(V_IDTPCARGATRIB,'O',0,DECODE(V_SGESTADO,'SP',0,NVL(VALOR_IMPOSTO_ITEM_NFE_CARGA(IP.CDFILIAL,IP.NRLANCTONF,IP.NRSEQITPROD,'I','C','1'),0))),2), '999999999990.00')), '.', ',') AS VL_ICMS,
                                         REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_CDIMPOSTRIB, 'B','1'),2), '999999999990.00')), '.', ',') AS VL_BC_ICMS_ST,
                                         REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_CDIMPOSTRIB, 'A','1') + VALOR_FECP_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_CDIMPOSTRIB, 'A','1'),2), '999999999990.00')), '.', ',') AS ALIQ_ST,
                                         REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_CDIMPOSTRIB, 'I','1') + VALOR_FECP_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_CDIMPOSTRIB, 'I','1'),2), '999999999990.00')), '.', ',') AS VL_ICMS_ST,
                                         (SELECT MAX(CDSITUTRIBITNFE)
                                            FROM ITEMPROIMPOS N, IMPOSTO IM
                                           WHERE IP.CDFILIAL     = N.CDFILIAL
                                             AND IP.NRLANCTONF   = N.NRLANCTONF
                                             AND IP.NRSEQITPROD  = N.NRSEQITPROD
                                             AND IM.CDIMPOSTO    = N.CDIMPOSTO
                                             AND N.NRITPROIMPOS  = '1'
                                             AND IM.CDIMPOSTONFE = V_IPI) AS CST_IPI,
                                         REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_IPI, 'B','1'),2), '999999999990.00')), '.', ',') AS VL_BC_IPI,
                                         REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_IPI, 'A','1'),2), '999999999990.00')), '.', ',') AS ALIQ_IPI,
                                         REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_IPI, 'I','1'),2), '999999999990.00')), '.', ',') AS VL_IPI,
                                         (SELECT MAX(CDSITUTRIBITNFE)
                                            FROM ITEMPROIMPOS N, IMPOSTO IM
                                           WHERE IP.CDFILIAL     = N.CDFILIAL
                                             AND IP.NRLANCTONF   = N.NRLANCTONF
                                             AND IP.NRSEQITPROD  = N.NRSEQITPROD
                                             AND IM.CDIMPOSTO    = N.CDIMPOSTO
                                             AND N.NRITPROIMPOS  = '1'
                                             AND IM.CDIMPOSTONFE = V_PIS) AS CST_PIS,
                                         REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_PIS, 'B','1'),2), '999999999990.00')), '.', ',') AS VL_BC_PIS,
                                         REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_PIS, 'A','1'),2), '999999999990.00')), '.', ',') AS ALIQ_PIS,
                                         REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_PIS, 'I','1'),2), '999999999990.00')), '.', ',') AS VL_PIS,
                                         (SELECT MAX(CDSITUTRIBITNFE)
                                            FROM ITEMPROIMPOS N, IMPOSTO IM
                                           WHERE IP.CDFILIAL     = N.CDFILIAL
                                             AND IP.NRLANCTONF   = N.NRLANCTONF
                                             AND IP.NRSEQITPROD  = N.NRSEQITPROD
                                             AND IM.CDIMPOSTO    = N.CDIMPOSTO
                                             AND N.NRITPROIMPOS  = '1'
                                             AND IM.CDIMPOSTONFE = V_COFINS) AS CST_COFINS,
                                         REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_COFINS, 'B','1'),2), '999999999990.00')), '.', ',') AS VL_BC_COFINS,
                                         REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_COFINS, 'A','1'),2), '999999999990.00')), '.', ',') AS ALIQ_COFINS,
                                         REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_COFINS, 'I','1'),2), '999999999990.00')), '.', ',') AS VL_COFINS,
                                         CONTCTBL_SPED(C_REGC100.IDENTRSAIDOP, NVL(PA.CDPRODUTO,PR.CDPRODUTO), C_REGC100.CDTIPOOPER, C_REGC100.FILIAL) AS COD_CTA,
                                         REPLACE(LTRIM(TO_CHAR(ROUND(DECODE(IP.IDIMPDESONERAIT,'S',NVL(IP.VRIMPOSTOIT,0),0),2), '999999999990.00')), '.', ',') AS VL_ABAT_NT,
                                         NVL(PA.CDPRODUTO,PR.CDPRODUTO) AS CDPRODUTO, IT.DSCDFISOPEIT, IT.CDPRODNCMTRANS AS CDCLASFISC, PR.SGUNIDADE, PR.VRFATOCONV,
                                         (SELECT CP.CDEXPPROD FROM CODEXPPROD CP WHERE CP.CDLIVROMAG = P_LIVROMAG AND CP.CDPRODUTO = IT.CDPRODUTO) AS CDEXPPROD,
                                         DECODE(PA.CDPRODUTO,PR.CDPRODUTO,'S','N') AS IDPRODEST
                                    FROM ITEMPRODUTO IT, PRODUTO PR, PRODUTO PA, ITEMPROIMPOS IP, IMPOSTO IM, DETITMAPARECUP DT
                                   WHERE IT.CDFILIAL      = C_REGC100.CDFILIAL
                                     AND IT.NRLANCTONF    = C_REGC100.NRLANCTONF
                                     AND IM.CDIMPOSTONFE  = P_CDIMPOSTO
                                     AND IM.CDIMPOSTO     = IP.CDIMPOSTO
                                     AND IT.CDFILIAL      = IP.CDFILIAL
                                     AND IT.NRLANCTONF    = IP.NRLANCTONF
                                     AND IT.NRSEQITPROD   = IP.NRSEQITPROD
                                     AND IT.CDPRODUTO     = PR.CDPRODUTO
                                     AND PR.CDPRODESTO    = PA.CDPRODUTO(+)
                                     AND IP.NRITPROIMPOS  =  '1'
                                     AND C_REGC100.IDENTRSAIDOP = 'E'
                                     AND C_REGC100.CDMODDOCFISC = '55'
                                     AND C_REGC100.IDSTATUSNFE <> 'A'
                                     AND ROUND(IT.QTITEMPROD,3) > 0
                                     AND IP.CDFILIAL      = DT.CDFILIAL(+)
                                     AND IP.NRLANCTONF    = DT.NRLANCTONF(+)
                                     AND IP.CDIMPOSTO     = DT.CDIMPOSTO(+)
                                     AND IP.NRSEQITPROD   = DT.NRSEQITPROD(+)
                                     AND IP.NRITPROIMPOS  = DT.NRITPROIMPOS(+)
                                   UNION ALL
                                   /*NOTAS DE SAÍDA ELETRÔNICAS COM E SEM CARGA TRIBUTÁRIA - COM CÓDIGO DE INFORMAÇÃO ADICIONAL PARA O ESTADO DE PE */
                                  SELECT NVL(PA.CDARVPROD,PR.CDARVPROD) AS COD_ITEM,
                                         ' ' AS DESCR_COMPL,
                                         REPLACE(LTRIM(TO_CHAR(ROUND(IT.QTITEMPROD,3), '999999999990.000')), '.', ',') AS QTD,
                                         REPLACE(LTRIM(TO_CHAR(ROUND(NVL(IT.VRTOTAITEM,0),2)+ROUND(NVL(VRENCARGOIMPXML,0),2), '999999999990.00')), '.', ',') AS VL_ITEM,
                                         REPLACE(LTRIM(TO_CHAR(ROUND(NVL(IT.VRENCARGODESC,0),2), '999999999990.00')), '.', ',') AS VL_DESC,
                                         DECODE(NVL(V_IDATUESTTPOP,'N'),'N','1','0') AS IND_MOV,
                                         LPAD(NVL(IP.CDSITUTRIBIT,0),3,'0') AS CST_ICMS,
                                         IP.CDFISCOPERIT AS CFOP,
                                         REPLACE(LTRIM(TO_CHAR(ROUND(CASE WHEN DT.NRSEQDETITMAPA IS NULL OR DT.IDTIPOITMAPR = 'VI'
                                                                          THEN NVL(VALOR_IMPOSTO_ITEM_NFE_CARGA(IP.CDFILIAL,IP.NRLANCTONF,IP.NRSEQITPROD,'B','I','1'),0)
                                                                          ELSE 0 END +
                                                                     DECODE(V_IDTPCARGATRIB,'O',0,DECODE(V_SGESTADO,'SP',0,NVL(VALOR_IMPOSTO_ITEM_NFE_CARGA(IP.CDFILIAL,IP.NRLANCTONF,IP.NRSEQITPROD,'B','C','1'),0))),2), '999999999990.00')), '.', ',') AS VL_BC_ICMS,
                                         REPLACE(LTRIM(TO_CHAR(ROUND(DECODE(IP.CDFISCALIT, '1', DECODE(DT.NRSEQDETITMAPA,'',IP.VRALIQITEM,0), 0),2), '999999999990.00')), '.', ',') AS ALIQ_ICMS,
                                         REPLACE(LTRIM(TO_CHAR(ROUND(CASE WHEN DT.NRSEQDETITMAPA IS NULL OR DT.IDTIPOITMAPR = 'VI'
                                                                          THEN NVL(VALOR_IMPOSTO_ITEM_NFE_CARGA(IP.CDFILIAL,IP.NRLANCTONF,IP.NRSEQITPROD,'I','I','1'),0)
                                                                          ELSE 0 END +
                                                                     DECODE(V_IDTPCARGATRIB,'O',0,DECODE(V_SGESTADO,'SP',0,NVL(VALOR_IMPOSTO_ITEM_NFE_CARGA(IP.CDFILIAL,IP.NRLANCTONF,IP.NRSEQITPROD,'I','C','1'),0))),2), '999999999990.00')), '.', ',') AS VL_ICMS,
                                         REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_CDIMPOSTRIB, 'B','1'),2), '999999999990.00')), '.', ',') AS VL_BC_ICMS_ST,
                                         REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_CDIMPOSTRIB, 'A','1') + VALOR_FECP_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_CDIMPOSTRIB, 'A','1'),2), '999999999990.00')), '.', ',') AS ALIQ_ST,
                                         REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_CDIMPOSTRIB, 'I','1') + VALOR_FECP_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_CDIMPOSTRIB, 'I','1'),2), '999999999990.00')), '.', ',') AS VL_ICMS_ST,
                                         (SELECT MAX(CDSITUTRIBITNFE)
                                            FROM ITEMPROIMPOS N, IMPOSTO IM
                                           WHERE IP.CDFILIAL     = N.CDFILIAL
                                             AND IP.NRLANCTONF   = N.NRLANCTONF
                                             AND IP.NRSEQITPROD  = N.NRSEQITPROD
                                             AND IM.CDIMPOSTO    = N.CDIMPOSTO
                                             AND N.NRITPROIMPOS  = '1'
                                             AND IM.CDIMPOSTONFE = V_IPI) AS CST_IPI,
                                         REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_IPI, 'B','1'),2), '999999999990.00')), '.', ',') AS VL_BC_IPI,
                                         REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_IPI, 'A','1'),2), '999999999990.00')), '.', ',') AS ALIQ_IPI,
                                         REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_IPI, 'I','1'),2), '999999999990.00')), '.', ',') AS VL_IPI,
                                         (SELECT MAX(CDSITUTRIBITNFE)
                                            FROM ITEMPROIMPOS N, IMPOSTO IM
                                           WHERE IP.CDFILIAL     = N.CDFILIAL
                                             AND IP.NRLANCTONF   = N.NRLANCTONF
                                             AND IP.NRSEQITPROD  = N.NRSEQITPROD
                                             AND IM.CDIMPOSTO    = N.CDIMPOSTO
                                             AND N.NRITPROIMPOS  = '1'
                                             AND IM.CDIMPOSTONFE = V_PIS) AS CST_PIS,
                                         REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_PIS, 'B','1'),2), '999999999990.00')), '.', ',') AS VL_BC_PIS,
                                         REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_PIS, 'A','1'),2), '999999999990.00')), '.', ',') AS ALIQ_PIS,
                                         REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_PIS, 'I','1'),2), '999999999990.00')), '.', ',') AS VL_PIS,
                                         (SELECT MAX(CDSITUTRIBITNFE)
                                            FROM ITEMPROIMPOS N, IMPOSTO IM
                                           WHERE IP.CDFILIAL     = N.CDFILIAL
                                             AND IP.NRLANCTONF   = N.NRLANCTONF
                                             AND IP.NRSEQITPROD  = N.NRSEQITPROD
                                             AND IM.CDIMPOSTO    = N.CDIMPOSTO
                                             AND N.NRITPROIMPOS  = '1'
                                             AND IM.CDIMPOSTONFE = V_COFINS) AS CST_COFINS,
                                         REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_COFINS, 'B','1'),2), '999999999990.00')), '.', ',') AS VL_BC_COFINS,
                                         REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_COFINS, 'A','1'),2), '999999999990.00')), '.', ',') AS ALIQ_COFINS,
                                         REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_COFINS, 'I','1'),2), '999999999990.00')), '.', ',') AS VL_COFINS,
                                         CONTCTBL_SPED(C_REGC100.IDENTRSAIDOP, NVL(PA.CDPRODUTO,PR.CDPRODUTO), C_REGC100.CDTIPOOPER, C_REGC100.FILIAL) AS COD_CTA,
                                         REPLACE(LTRIM(TO_CHAR(ROUND(DECODE(IP.IDIMPDESONERAIT,'S',NVL(IP.VRIMPOSTOIT,0),0),2), '999999999990.00')), '.', ',') AS VL_ABAT_NT,
                                         NVL(PA.CDPRODUTO,PR.CDPRODUTO) AS CDPRODUTO, IT.DSCDFISOPEIT, IT.CDPRODNCMTRANS AS CDCLASFISC, PR.SGUNIDADE, PR.VRFATOCONV,
                                         CP.CDEXPPROD, DECODE(PA.CDPRODUTO,PR.CDPRODUTO,'S','N') AS IDPRODEST
                                    FROM ITEMPRODUTO IT, PRODUTO PR, PRODUTO PA, ITEMPROIMPOS IP, IMPOSTO IM, DETITMAPARECUP DT, CODEXPPROD CP
                                   WHERE V_SGESTADO       = 'PE'
                                     AND IT.CDFILIAL      = C_REGC100.CDFILIAL
                                     AND IT.NRLANCTONF    = C_REGC100.NRLANCTONF
                                     AND IM.CDIMPOSTONFE  = P_CDIMPOSTO
                                     AND IM.CDIMPOSTO     = IP.CDIMPOSTO
                                     AND IT.CDFILIAL      = IP.CDFILIAL
                                     AND IT.NRLANCTONF    = IP.NRLANCTONF
                                     AND IT.NRSEQITPROD   = IP.NRSEQITPROD
                                     AND IT.CDPRODUTO     = PR.CDPRODUTO
                                     AND PR.CDPRODESTO    = PA.CDPRODUTO(+)
                                     AND IP.NRITPROIMPOS  =  '1'
                                     AND C_REGC100.IDENTRSAIDOP = 'S'
                                     AND C_REGC100.CDMODDOCFISC = '55'
                                     AND ROUND(IT.QTITEMPROD,3) > 0
                                     AND IP.CDFILIAL      = DT.CDFILIAL(+)
                                     AND IP.NRLANCTONF    = DT.NRLANCTONF(+)
                                     AND IP.CDIMPOSTO     = DT.CDIMPOSTO(+)
                                     AND IP.NRSEQITPROD   = DT.NRSEQITPROD(+)
                                     AND IP.NRITPROIMPOS  = DT.NRITPROIMPOS(+)
                                     AND CP.CDLIVROMAG    = P_LIVROMAG
                                     AND CP.CDPRODUTO     = IT.CDPRODUTO
                                     AND CP.CDEXPPROD     IS NOT NULL)) LOOP

            /* CODIGO DO CFOP */
            SELECT MAX(CDCHAVEREG)
              INTO V_COD_NAT
              FROM TMP_REGDADOSSPED
             WHERE CDCHAVEREG = C_REGC170.CDFISCOPERIT
               AND CDREGISTRO = '0400';

            IF (V_COD_NAT IS NULL) AND (C_REGC170.CDFISCOPERIT IS NOT NULL) THEN
               V_SEQUPROD := NVL(V_SEQUPROD,0) + 1;
               INSERT INTO TMP_REGDADOSSPED
                 (CDREGISTRO, CDCONTREGI, CDCHAVEREG, CDCAMPO1, CDCAMPO2)
               VALUES
                 ('0400', V_SEQUPROD, C_REGC170.CDFISCOPERIT, C_REGC170.DSCDFISOPEIT, C_REGC100.IDENTRSAIDOP);
            END IF;
            V_COD_NAT := NULL;

            V_UNIDADE := C_REGC170.SGUNIDADE||CASE WHEN C_REGC170.IDPRODEST = 'N' THEN CONT_FATCONVERSAO_SPED(C_REGC170.SGUNIDADE, C_REGC170.VRFATOCONV) ELSE '' END;

            /* UNIDADE DE MEDIDA */
            SELECT MAX(CDCHAVEREG)
              INTO V_UNID
              FROM TMP_REGDADOSSPED
             WHERE CDCHAVEREG = V_UNIDADE
               AND CDREGISTRO = '0190';

            IF (V_UNID IS NULL) AND (V_UNIDADE IS NOT NULL) THEN
               V_SEQUPROD := NVL(V_SEQUPROD,0) + 1;
               INSERT INTO TMP_REGDADOSSPED
                 (CDREGISTRO, CDCONTREGI, CDCAMPO1, CDCAMPO2, CDCAMPO3, CDCHAVEREG)
               VALUES
                 ('0190', V_SEQUPROD, C_REGC170.SGUNIDADE, C_REGC170.VRFATOCONV, SUBSTR(V_UNIDADE,LENGTH(C_REGC170.SGUNIDADE)+1,LENGTH(V_UNIDADE)), V_UNIDADE);
            END IF;
            V_UNID := NULL;

            /* CODIGO DO PRODUTO */
            SELECT MAX(CDCHAVEREG)
              INTO V_PRODUTO
              FROM TMP_REGDADOSSPED
             WHERE CDCHAVEREG = C_REGC170.CDPRODUTO
               AND CDREGISTRO = '0200';
            IF (V_PRODUTO IS NULL) AND (C_REGC170.CDPRODUTO IS NOT NULL) THEN
               V_SEQUPROD := NVL(V_SEQUPROD,0) + 1;
               INSERT INTO TMP_REGDADOSSPED
                 (CDREGISTRO, CDCONTREGI, CDCHAVEREG, CDCAMPO3)
               VALUES
                 ('0200', V_SEQUPROD, C_REGC170.CDPRODUTO, C_REGC170.CDCLASFISC);
            END IF;
            V_PRODUTO := NULL;

            /* PLANO DE CONTAS REFERENCIAL */
            SELECT MAX(CDCHAVEREG)
              INTO V_CONTCTBL
              FROM TMP_REGDADOSSPED
             WHERE CDCHAVEREG = C_REGC170.COD_CTA
               AND CDREGISTRO = '0500';

            IF (V_CONTCTBL IS NULL) AND (C_REGC170.COD_CTA IS NOT NULL) THEN
               V_SEQUPROD := NVL(V_SEQUPROD,0) + 1;
               INSERT INTO TMP_REGDADOSSPED
                  (CDREGISTRO, CDCONTREGI, CDCHAVEREG)
               VALUES
                  ('0500', V_SEQUPROD, C_REGC170.COD_CTA);
            END IF;
            V_CONTCTBL := NULL;

            INSERT INTO ARQMAGNETICO
               (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
            VALUES
               ('19'||LPAD(RTRIM(V_CONTREGC), 8, '0'), '|C170'|| '|' ||V_SEQUENCIAL|| '|' || C_REGC170.PARTE1 ||V_UNIDADE||C_REGC170.ARQ_C170, P_NRSEQARQMAG);
            V_SEQUENCIAL := LPAD(RTRIM(TO_CHAR(TO_NUMBER(RTRIM(V_SEQUENCIAL))+1)), 3,'0');
            V_CONTREGC :=  NVL(V_CONTREGC,0) + 1;

            IF (V_SGESTADO = 'PE') AND (C_REGC170.CDEXPPROD IS NOT NULL) AND (P_VERSAO >= '013') THEN
               INSERT INTO ARQMAGNETICO
                  (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
               VALUES
                  ('19'||LPAD(RTRIM(V_CONTREGC), 8, '0'), '|C177'|| '|' || C_REGC170.CDEXPPROD || '|', P_NRSEQARQMAG);
               V_CONTREGC :=  NVL(V_CONTREGC,0) + 1;
            END IF;
         END LOOP;

         IF P_VERSAO NOT IN ( '001', '002') THEN
            /*REGISTRO C190*/
            /*É PASSADO O CSOSN APENAS QUANDO A EMPRESA É DO SIMPLES E O FORNECEDOR TAMBÉM, CASO A EMPRESA NAO SEJA DO SIMPLES, MAIS O FORNECEDOR
            SIM, MANDA O CST MESMO. NESTE CASO A EMPRESA NAO É SIMPLES */
            FOR C_REGC190 IN(SELECT ('|C190'      || '|' ||
                                     T.CST_ICMS   || '|' ||
                                     T.CFOP       || '|' ||
                                     REPLACE(LTRIM(TO_CHAR(ROUND(NVL(T.ALIQ_ICMS,0),2), '999999999990.00')), '.', ',') || '|' ||
                                     REPLACE(LTRIM(TO_CHAR(ROUND(NVL(T.VL_OPR,0),2),    '999999999990.00')), '.', ',') || '|' ||
                                     REPLACE(LTRIM(TO_CHAR(ROUND(NVL(T.VL_BC_ICMS,0),2),'999999999990.00')), '.', ',') || '|' ||
                                     REPLACE(LTRIM(TO_CHAR(ROUND(NVL(T.VL_ICMS,0),2),   '999999999990.00')), '.', ',') || '|' ||
                                     REPLACE(LTRIM(TO_CHAR(ROUND(NVL(T.BC_ST,0),2),     '999999999990.00')), '.', ',') || '|' ||
                                     REPLACE(LTRIM(TO_CHAR(ROUND(NVL(T.IMP_ST,0),2),    '999999999990.00')), '.', ',') || '|' ||
                                     REPLACE(LTRIM(TO_CHAR(ROUND(NVL(T.VL_RED_BC,0),2), '999999999990.00')), '.', ',') || '|' ||
                                     REPLACE(LTRIM(TO_CHAR(ROUND(NVL(VL_IPI,0),2),      '999999999990.00')), '.', ',') || '|' ||
                                     '' || '|') ARQ_C190,
                                     T.VL_ICMS, T.CFOP AS COD_NAT, T.CST_ICMS, T.ALIQ_ICMS
                               FROM (/*NOTAS DE SAIDA COM E SEM CARGA TRIBUTÁRIA*/
                                     SELECT I.CDSITUTRIBIT AS CST_ICMS,
                                            I.CDFISCOPERIT AS CFOP,
                                            CASE WHEN DT.NRSEQDETITMAPA IS NULL OR DT.IDTIPOITMAPR = 'VI'
                                                 THEN DECODE(I.CDFISCALIT,'1',I.VRALIQITEM,0)
                                                 ELSE 0 END AS ALIQ_ICMS,
                                            SUM(I.VRCONTITIMP)+NVL(SUM(VALOR_REDUCAO(I.CDFILIAL, I.NRLANCTONF, I.CDSITUTRIBIT, I.NRSEQITPROD, I.CDFISCOPERIT, NULL, NULL, NULL)),0) VL_OPR,
                                            SUM(CASE WHEN DT.NRSEQDETITMAPA IS NULL OR DT.IDTIPOITMAPR = 'VI'
                                                     THEN NVL(VALOR_IMPOSTO_ITEM_NFE_CARGA(I.CDFILIAL,I.NRLANCTONF,I.NRSEQITPROD,'B','I','1'),0) +
                                                          DECODE(V_IDTPCARGATRIB,'O',0,DECODE(V_SGESTADO,'SP',0,NVL(VALOR_IMPOSTO_ITEM_NFE_CARGA(I.CDFILIAL,I.NRLANCTONF,I.NRSEQITPROD,'B','C','1'),0)))
                                                     ELSE 0 END) AS VL_BC_ICMS,
                                            SUM(CASE WHEN DT.NRSEQDETITMAPA IS NULL OR DT.IDTIPOITMAPR = 'VI'
                                                     THEN NVL(VALOR_IMPOSTO_ITEM_NFE_CARGA(I.CDFILIAL,I.NRLANCTONF,I.NRSEQITPROD,'I','I','1'),0) +
                                                          DECODE(V_IDTPCARGATRIB,'O',0,NVL(VALOR_IMPOSTO_ITEM_NFE_CARGA(I.CDFILIAL,I.NRLANCTONF,I.NRSEQITPROD,'I','C','1'),0))
                                                     ELSE 0 END) AS VL_ICMS,
                                            NVL(SUM(CASE WHEN DT.NRSEQDETITMAPA IS NULL OR DT.IDTIPOITMAPR = 'VI'
                                                         THEN DECODE(I.CDFISCALIT,'1',VALOR_REDUCAO(I.CDFILIAL, I.NRLANCTONF, I.CDSITUTRIBIT, I.NRSEQITPROD, I.CDFISCOPERIT, NULL, NULL, NULL),0)
                                                         ELSE 0 END),0) AS VL_RED_BC,
                                            SUM((SELECT NVL(SUM(VRIMPOSTOIT),0)
                                                   FROM ITEMPROIMPOS IT, IMPOSTO IM
                                                  WHERE (IT.CDFILIAL     = I.CDFILIAL           ) AND
                                                        (IT.NRLANCTONF   = I.NRLANCTONF         ) AND
                                                        (IT.CDIMPOSTO    = IM.CDIMPOSTO         ) AND
                                                        (IT.NRITPROIMPOS = '1'                  ) AND
                                                        (IT.CDFISCALIT   = '1'                  ) AND
                                                        (IM.CDIMPOSTONFE = '10'                 ) AND
                                                        I.NRSEQITPROD = IT.NRSEQITPROD         )) AS VL_IPI,
                                            '' AS COD_OBS,
                                            SUM(VALOR_IMPOSTO_ITEM_NFE(I.CDFILIAL,I.NRLANCTONF,I.NRSEQITPROD,'80','B','1')) AS BC_ST,
                                            SUM(VALOR_IMPOSTO_ITEM_NFE(I.CDFILIAL,I.NRLANCTONF,I.NRSEQITPROD,'80','I','1') + VALOR_FECP_ITEM_NFE(I.CDFILIAL,I.NRLANCTONF,I.NRSEQITPROD,'80','I','1')) AS IMP_ST
                                       FROM ITEMPROIMPOS I, ITEMPRODUTO P, IMPOSTO IM, DETITMAPARECUP DT
                                      WHERE I.CDFILIAL      = C_REGC100.CDFILIAL
                                        AND I.NRLANCTONF    = C_REGC100.NRLANCTONF
                                        AND C_REGC100.IDENTRSAIDOP = 'S'
                                        AND C_REGC100.CDMODDOCFISC <> '65'
                                        AND I.NRITPROIMPOS  = '1'
                                        AND IM.CDIMPOSTONFE = P_CDIMPOSTO
                                        AND IM.CDIMPOSTO    = I.CDIMPOSTO
                                        AND I.CDFILIAL      = DT.CDFILIAL(+)
                                        AND I.NRLANCTONF    = DT.NRLANCTONF(+)
                                        AND I.CDIMPOSTO     = DT.CDIMPOSTO(+)
                                        AND I.NRSEQITPROD   = DT.NRSEQITPROD(+)
                                        AND I.NRITPROIMPOS  = DT.NRITPROIMPOS(+)
                                        AND I.CDFILIAL      = P.CDFILIAL
                                        AND I.NRLANCTONF    = P.NRLANCTONF
                                        AND I.NRSEQITPROD   = P.NRSEQITPROD
                                        AND (ROUND(P.QTITEMPROD,3) > 0 OR C_REGC100.SITU_DOC IN ('06','07'))
                                      GROUP BY I.CDSITUTRIBIT, I.CDFISCOPERIT, CASE WHEN DT.NRSEQDETITMAPA IS NULL OR DT.IDTIPOITMAPR = 'VI'
                                                                                    THEN DECODE(I.CDFISCALIT,'1',I.VRALIQITEM,0)
                                                                                    ELSE 0 END
                                      UNION ALL
                                     /*NOTAS DE ENTRADA COM E SEM CARGA TRIBUTÁRIA*/
                                     SELECT I.CDSITUTRIBIT AS CST_ICMS,
                                            I.CDFISCOPERIT AS CFOP,
                                            CASE WHEN DT.NRSEQDETITMAPA IS NULL OR DT.IDTIPOITMAPR = 'VI'
                                                 THEN DECODE(I.CDFISCALIT,'1',I.VRALIQITEM,0)
                                                 ELSE 0 END AS ALIQ_ICMS,
                                            SUM(I.VRCONTITIMP)+NVL(SUM(VALOR_REDUCAO(I.CDFILIAL, I.NRLANCTONF, I.CDSITUTRIBIT, I.NRSEQITPROD, I.CDFISCOPERIT, NULL, NULL, NULL)),0) VL_OPR,
                                            SUM(CASE WHEN DT.NRSEQDETITMAPA IS NULL OR DT.IDTIPOITMAPR = 'VI'
                                                     THEN NVL(VALOR_IMPOSTO_ITEM_NFE_CARGA(I.CDFILIAL,I.NRLANCTONF,I.NRSEQITPROD,'B','I','1'),0) +
                                                          DECODE(V_IDTPCARGATRIB,'O',0,DECODE(V_SGESTADO,'SP',0,NVL(VALOR_IMPOSTO_ITEM_NFE_CARGA(I.CDFILIAL,I.NRLANCTONF,I.NRSEQITPROD,'B','C','1'),0)))
                                                     ELSE 0 END) AS VL_BC_ICMS,
                                            SUM(CASE WHEN DT.NRSEQDETITMAPA IS NULL OR DT.IDTIPOITMAPR = 'VI'
                                                     THEN NVL(VALOR_IMPOSTO_ITEM_NFE_CARGA(I.CDFILIAL,I.NRLANCTONF,I.NRSEQITPROD,'I','I','1'),0) +
                                                          DECODE(V_IDTPCARGATRIB,'O',0,DECODE(V_SGESTADO,'SP',0,NVL(VALOR_IMPOSTO_ITEM_NFE_CARGA(I.CDFILIAL,I.NRLANCTONF,I.NRSEQITPROD,'I','C','1'),0)))
                                                     ELSE 0 END) AS VL_ICMS,
                                            NVL(SUM(CASE WHEN DT.NRSEQDETITMAPA IS NULL OR DT.IDTIPOITMAPR = 'VI'
                                                         THEN DECODE(I.CDFISCALIT,'1',VALOR_REDUCAO(I.CDFILIAL, I.NRLANCTONF, I.CDSITUTRIBIT, I.NRSEQITPROD, I.CDFISCOPERIT, NULL, NULL, NULL),0)
                                                         ELSE 0 END),0) AS VL_RED_BC,
                                            SUM((SELECT NVL(SUM(VRIMPOSTOIT),0)
                                                   FROM ITEMPROIMPOS IT, IMPOSTO IM
                                                  WHERE (IT.CDFILIAL     = I.CDFILIAL           ) AND
                                                        (IT.NRLANCTONF   = I.NRLANCTONF         ) AND
                                                        (IT.CDIMPOSTO    = IM.CDIMPOSTO         ) AND
                                                        (IT.NRITPROIMPOS = '1'                  ) AND
                                                        (IT.CDFISCALIT   = '1'                  ) AND
                                                        (IM.CDIMPOSTONFE = '10'                 ) AND
                                                        I.NRSEQITPROD = IT.NRSEQITPROD         )) AS VL_IPI,
                                            '' AS COD_OBS,
                                            SUM(VALOR_IMPOSTO_ITEM_NFE(I.CDFILIAL,I.NRLANCTONF,I.NRSEQITPROD,'80','B','1')) AS BC_ST,
                                            SUM(VALOR_IMPOSTO_ITEM_NFE(I.CDFILIAL,I.NRLANCTONF,I.NRSEQITPROD,'80','I','1') + VALOR_FECP_ITEM_NFE(I.CDFILIAL,I.NRLANCTONF,I.NRSEQITPROD,'80','I','1')) AS IMP_ST
                                       FROM ITEMPROIMPOS I, ITEMPRODUTO P, IMPOSTO IM, DETITMAPARECUP DT
                                      WHERE I.CDFILIAL      = C_REGC100.CDFILIAL
                                        AND I.NRLANCTONF    = C_REGC100.NRLANCTONF
                                        AND C_REGC100.IDENTRSAIDOP = 'E'
                                        AND C_REGC100.CDMODDOCFISC <> '65'
                                        AND I.NRITPROIMPOS  = '1'
                                        AND IM.CDIMPOSTONFE = P_CDIMPOSTO
                                        AND IM.CDIMPOSTO    = I.CDIMPOSTO
                                        AND I.CDFILIAL      = DT.CDFILIAL(+)
                                        AND I.NRLANCTONF    = DT.NRLANCTONF(+)
                                        AND I.CDIMPOSTO     = DT.CDIMPOSTO(+)
                                        AND I.NRSEQITPROD   = DT.NRSEQITPROD(+)
                                        AND I.NRITPROIMPOS  = DT.NRITPROIMPOS(+)
                                        AND I.CDFILIAL      = P.CDFILIAL
                                        AND I.NRLANCTONF    = P.NRLANCTONF
                                        AND I.NRSEQITPROD   = P.NRSEQITPROD
                                        AND (ROUND(P.QTITEMPROD,3) > 0 OR C_REGC100.SITU_DOC IN ('06','07'))
                                      GROUP BY I.CDSITUTRIBIT, I.CDFISCOPERIT, CASE WHEN DT.NRSEQDETITMAPA IS NULL OR DT.IDTIPOITMAPR = 'VI'
                                                                                    THEN DECODE(I.CDFISCALIT,'1',I.VRALIQITEM,0)
                                                                                    ELSE 0 END
                                      UNION ALL
                                     /*NFC-e*/
                                     SELECT NVL(LPAD(CDCSTPRODI,3,'0'), (CASE WHEN IM.IDTPIMPOSFIS = 'T' THEN '000'
                                                                              WHEN IM.IDTPIMPOSFIS = 'I' THEN '040'
                                                                              WHEN IM.IDTPIMPOSFIS = 'F' THEN '060'
                                                                              WHEN IM.IDTPIMPOSFIS = 'N' THEN '041' END)) AS CST_ICMS,
                                            NVL(CDCFOPPROD, '5102') AS CFOP,
                                            ROUND(IP.VRPEALPRODIT,2) AS ALIQ_ICMS,
                                            SUM(TRUNC((IT.QTPRODVEND  * (IT.VRUNITVEND+NVL(IT.VRUNITVENDCL,0))) - NVL(IT.VRDESITVEND,0) + NVL(IT.VRACRITVEND,0),2)) AS VL_OPR,
                                            SUM(CASE WHEN IM.IDTPIMPOSFIS = 'T' AND IM.CDIMPOSTONFE = P_CDIMPOSTO
                                                     THEN CASE WHEN IP.VRPRBCREDUICMS > 0
                                                               THEN IP.VRBASECALCREDUZ
                                                               ELSE TRUNC((IT.QTPRODVEND * (IT.VRUNITVEND+NVL(IT.VRUNITVENDCL,0))) - NVL(IT.VRDESITVEND,0) + NVL(IT.VRACRITVEND,0),2) END
                                                     ELSE 0 END) AS VL_BC_ICMS,
                                            SUM(CASE WHEN IM.IDTPIMPOSFIS = 'T' AND IM.CDIMPOSTONFE = P_CDIMPOSTO
                                                     THEN CASE WHEN IP.VRPRBCREDUICMS > 0
                                                               THEN IP.VRIMPOPRODREDUZ
                                                               ELSE TRUNC(VRIMPOPRODIT,2) END
                                                     ELSE 0 END) AS VL_ICMS,
                                            SUM(DECODE(IP.VRPRBCREDUICMS,0,0,IP.VRBCREDUZICMS)) AS VL_RED_BC,
                                            0 AS VL_IPI,
                                            '' AS COD_OBS,
                                            0 AS BC_ST,
                                            0 AS IMP_ST
                                       FROM ITEMVENDA IT, ITVENDAIMPOS IP, IMPOSTO IM
                                      WHERE IT.CDFILIAL     = C_REGC100.CDFILIAL
                                        AND IT.CDCAIXA      = C_REGC100.CDCAIXA
                                        AND IT.NRSEQVENDA   = C_REGC100.NRLANCTONF
                                        AND IT.CDFILIAL     = IP.CDFILIAL
                                        AND IT.CDCAIXA      = IP.CDCAIXA
                                        AND IT.NRSEQUITVEND = IP.NRSEQUITVEND
                                        AND IT.NRSEQVENDA   = IP.NRSEQVENDA
                                        AND IP.CDIMPOSTO    = IM.CDIMPOSTO
                                        AND NVL(C_REGC100.IDSTATUS,'A') <>  'C'
                                      GROUP BY NVL(LPAD(CDCSTPRODI,3,'0'), (CASE WHEN IM.IDTPIMPOSFIS = 'T' THEN '000'
                                                                 WHEN IM.IDTPIMPOSFIS = 'I' THEN '040'
                                                                 WHEN IM.IDTPIMPOSFIS = 'F' THEN '060'
                                                                 WHEN IM.IDTPIMPOSFIS = 'N' THEN '041' END)),
                                               CDCFOPPROD, IP.VRPEALPRODIT) T) LOOP
               INSERT INTO ARQMAGNETICO
                  (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
               VALUES
                  ('19'||LPAD(RTRIM(V_CONTREGC), 8, '0'), C_REGC190.ARQ_C190, P_NRSEQARQMAG);
               V_CONTREGC := NVL(V_CONTREGC,0) + 1;

               IF P_VERSAO >= '013' THEN
                  FOR C_REGC191 IN (SELECT '|C191'         || '|' ||
                                           REPLACE(LTRIM(TO_CHAR(SUM(CASE WHEN SUBSTR(IT.CDSITUTRIBIT,2,2) IN ('00','10','20','51','70','90') AND IM.CDIMPOSTONFE = '00'
                                                THEN ROUND(IT.VRADICFECP,2)
                                                ELSE 0 END),'999999999990.00')), '.', ',') || '|' ||
                                           REPLACE(LTRIM(TO_CHAR(SUM(CASE WHEN SUBSTR(IT.CDSITUTRIBIT,2,2) IN ('10','30','70','90') AND IM.CDIMPOSTONFE = '80'
                                                THEN ROUND(IT.VRADICFECP,2)
                                                ELSE 0 END),'999999999990.00')), '.', ',') || '|' ||
                                           REPLACE(LTRIM(TO_CHAR(SUM(CASE WHEN SUBSTR(IT.CDSITUTRIBIT,2,2) IN ('60')
                                                THEN ROUND(IT.VRADICFECP,2)
                                                ELSE 0 END),'999999999990.00')), '.', ',') || '|' AS ARQ_C191, IT.CDFISCOPERIT
                                      FROM ITEMPROIMPOS IT, ITEMPROIMPOS II, IMPOSTO IM
                                     WHERE IT.CDFILIAL     = C_REGC100.CDFILIAL
                                       AND IT.NRLANCTONF   = C_REGC100.NRLANCTONF
                                       AND IT.CDFISCOPERIT = C_REGC190.COD_NAT
                                       AND IT.CDSITUTRIBIT = C_REGC190.CST_ICMS
                                       AND IT.VRALIQITEM   = C_REGC190.ALIQ_ICMS
                                       AND IT.NRITPROIMPOS = '1'
                                       AND IT.CDFILIAL     = II.CDFILIAL
                                       AND IT.NRLANCTONF   = II.NRLANCTONF
                                       AND IT.NRSEQITPROD  = II.NRSEQITPROD
                                       AND II.CDFISCOPERIT = C_REGC190.COD_NAT
                                       AND II.CDSITUTRIBIT = C_REGC190.CST_ICMS
                                       AND II.CDIMPOSTO    = IM.CDIMPOSTO
                                       AND IM.CDIMPOSTONFE IN ('00','80')
                                       AND II.VRADICFECP   > 0
                                     GROUP BY IT.CDFISCOPERIT) LOOP
                      INSERT INTO ARQMAGNETICO
                         (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
                      VALUES
                         ('19'||LPAD(RTRIM(V_CONTREGC), 8, '0'), C_REGC191.ARQ_C191, P_NRSEQARQMAG);
                      V_CONTREGC := NVL(V_CONTREGC,0) + 1;
                  END LOOP;
               END IF;
            END LOOP;
         END IF;

         V_C195 := 'N';
         /* GERACAO DOS REGISTROS COM DIFERENCIAL DE ALIQUOTA E ANTECIPAÇÃO DE ICMS DO ARROZ*/
         FOR C_REGC197 IN (SELECT COD_AJ, DESCR_COMPL_AJ, COD_ITEM, IDTIPOITMAPR,
                                  REPLACE(LTRIM(TO_CHAR(ROUND(VL_BC_ICMS,2),'999999999990.00')), '.', ',') AS VL_BC_ICMS,
                                  REPLACE(LTRIM(TO_CHAR(ROUND(ALIQ_ICMS,2), '999999999990.00')), '.', ',') AS ALIQ_ICMS,
                                  REPLACE(LTRIM(TO_CHAR(ROUND(VL_ICMS,2),   '999999999990.00')), '.', ',') AS VL_ICMS,
                                  REPLACE(LTRIM(TO_CHAR(ROUND(VL_OUTROS,2), '999999999990.00')), '.', ',') AS VL_OUTROS,
                                  CDCFOPPADRAO, CDCLASFISC, CDPRODUTO
                             FROM (SELECT IM.CDAJUSTEITMAPA AS COD_AJ, IM.DSITEMMAPR AS DESCR_COMPL_AJ, '' AS COD_ITEM,
                                          0 AS VL_BC_ICMS, 0 AS ALIQ_ICMS,
                                          IM.VRITEMMAPR AS VL_ICMS,
                                          IM.VROUTROSITMAPR AS VL_OUTROS, IM.IDTIPOITMAPR,
                                          IM.CDCFOPPADRAO AS CDCFOPPADRAO, '' AS CDCLASFISC, '' AS CDPRODUTO
                                     FROM ITMAPARECUP IM
                                    WHERE IM.CDFILIAL     = C_REGC100.CDFILIAL
                                      AND IM.NRLANCTONF   = C_REGC100.NRLANCTONF
                                      AND C_REGC100.CDMODDOCFISC <> '65'
                                      AND IM.IDCOMPOEC197 = 'D'
                                    UNION ALL
                                   SELECT IM.CDAJUSTEITMAPA AS COD_AJ, IM.DSITEMMAPR AS DESCR_COMPL_AJ,
                                          NVL(PA.CDARVPROD,PR.CDARVPROD) AS COD_ITEM,
                                          SUM(DECODE(DT.IDSUBSTSOLIDST,'S',IT.VRBASECALCIT,DECODE(IT.CDFISCALIT,'1',IT.VRBASECALCIT,0))) AS VL_BC_ICMS,
                                          DECODE(DT.IDSUBSTSOLIDST,'S',IT.VRALIQITEM,DECODE(IT.CDFISCALIT,'1',IT.VRALIQITEM,0)) AS ALIQ_ICMS,
                                          SUM(ROUND(DECODE(DT.IDSUBSTSOLIDST,'S',DT.VRIMPOSTOIT,IT.VRIMPOSTOIT),2)) AS VL_ICMS,
                                          SUM(ROUND(IM.VROUTROSITMAPR,2)) AS VL_OUTROS, IM.IDTIPOITMAPR, '' AS CDCFOPPADRAO, IP.CDPRODNCMTRANS AS CDCLASFISC,
                                          NVL(PA.CDPRODUTO,PR.CDPRODUTO) AS CDPRODUTO
                                     FROM ITMAPARECUP IM, IMPOSTO IM, ITEMPROIMPOS IT, DETITMAPARECUP DT, PRODUTO PA, PRODUTO PR, ITEMPRODUTO IP
                                    WHERE IM.CDFILIAL     = C_REGC100.CDFILIAL
                                      AND IM.NRLANCTONF   = C_REGC100.NRLANCTONF
                                      AND C_REGC100.CDMODDOCFISC <> '65'
                                      AND IM.IDCOMPOEC197 = 'I'
                                      AND IM.CDFILIAL     = IT.CDFILIAL
                                      AND IM.NRLANCTONF   = IT.NRLANCTONF
                                      AND IT.CDIMPOSTO    = IM.CDIMPOSTO
                                      AND IM.CDIMPOSTONFE IN ('00','80')
                                      AND IT.CDIMPOSTO    = DT.CDIMPOSTO
                                      AND IM.NRSEQUMAPAPU = DT.NRSEQUMAPAPU
                                      AND IM.IDTIPOITMAPR = DT.IDTIPOITMAPR
                                      AND IM.NRSEQITMAPR  = DT.NRSEQITMAPR
                                      AND IT.CDFILIAL     = DT.CDFILIAL
                                      AND IT.NRLANCTONF   = DT.NRLANCTONF
                                      AND IT.NRSEQITPROD  = DT.NRSEQITPROD
                                      AND IT.NRITPROIMPOS = DT.NRITPROIMPOS
                                      AND IT.CDFILIAL     = IP.CDFILIAL
                                      AND IT.NRLANCTONF   = IP.NRLANCTONF
                                      AND IT.NRSEQITPROD  = IP.NRSEQITPROD
                                      AND DT.CDFILIAL     = IP.CDFILIAL
                                      AND DT.NRLANCTONF   = IP.NRLANCTONF
                                      AND DT.NRSEQITPROD  = IP.NRSEQITPROD
                                      AND PR.CDPRODUTO    = IP.CDPRODUTO
                                      AND PR.CDPRODESTO   = PA.CDPRODUTO(+)
                                      AND DT.IDTIPOITMAPR <> 'VI'
                                      AND ((IT.NRITPROIMPOS = '1' AND IT.CDFISCALIT = '1') OR (IT.NRITPROIMPOS = '3') OR (DT.IDSUBSTSOLIDST = 'S'))
                                    GROUP BY IM.CDAJUSTEITMAPA, IM.DSITEMMAPR, IT.CDFISCALIT, IT.VRALIQITEM, DT.IDSUBSTSOLIDST,
                                          NVL(PA.CDARVPROD,PR.CDARVPROD), IM.IDTIPOITMAPR, IP.CDPRODNCMTRANS, NVL(PA.CDPRODUTO,PR.CDPRODUTO)
                                    UNION ALL
                                   SELECT IM.CDAJUSTEITMAPA AS COD_AJ, IM.DSITEMMAPR AS DESCR_COMPL_AJ,
                                          NVL(PA.CDARVPROD,PR.CDARVPROD) AS COD_ITEM,
                                          SUM(DT.VROUTBASE) AS VL_BC_ICMS,
                                          NVL(DT.VROUTALIQ,0) AS ALIQ_ICMS,
                                          0 AS VL_ICMS,
                                          SUM(ROUND(DT.VROUTROSIMPIT,2)) AS VL_OUTROS, IM.IDTIPOITMAPR,
                                          IM.CDCFOPPADRAO, IP.CDPRODNCMTRANS AS CDCLASFISC,
                                          NVL(PA.CDPRODUTO,PR.CDPRODUTO) AS CDPRODUTO
                                     FROM ITMAPARECUP IM, DETITMAPARECUP DT, PRODUTO PA, PRODUTO PR, ITEMPRODUTO IP
                                    WHERE IM.CDFILIAL     = C_REGC100.CDFILIAL
                                      AND IM.NRLANCTONF   = C_REGC100.NRLANCTONF
                                      AND C_REGC100.CDMODDOCFISC <> '65'
                                      AND IM.IDCOMPOEC197 = 'I'
                                      AND IM.IDTIPOITMAPR = 'VI'
                                      AND IM.NRSEQUMAPAPU = DT.NRSEQUMAPAPU
                                      AND IM.IDTIPOITMAPR = DT.IDTIPOITMAPR
                                      AND IM.NRSEQITMAPR  = DT.NRSEQITMAPR
                                      AND DT.CDFILIAL     = IP.CDFILIAL
                                      AND DT.NRLANCTONF   = IP.NRLANCTONF
                                      AND DT.NRSEQITPROD  = IP.NRSEQITPROD
                                      AND PR.CDPRODUTO    = IP.CDPRODUTO
                                      AND PR.CDPRODESTO   = PA.CDPRODUTO(+)
                                    GROUP BY IM.CDAJUSTEITMAPA, IM.DSITEMMAPR,
                                          NVL(PA.CDARVPROD,PR.CDARVPROD), DT.VROUTALIQ,
                                          IM.IDTIPOITMAPR, IM.CDCFOPPADRAO, IP.CDPRODNCMTRANS,
                                          NVL(PA.CDPRODUTO,PR.CDPRODUTO)
                                    UNION ALL
                                   SELECT IM.CDAJUSTEITMAPA AS COD_AJ, IM.DSITEMMAPR AS DESCR_COMPL_AJ,
                                          NVL(PA.CDARVPROD,PR.CDARVPROD) AS COD_ITEM,
                                          SUM(DT.VROUTBASE) AS VL_BC_ICMS,
                                          NVL(DT.VROUTALIQ,0) AS ALIQ_ICMS,
                                          0 AS VL_ICMS,
                                          SUM(ROUND(DT.VROUTROSIMPIT,2)) AS VL_OUTROS, IM.IDTIPOITMAPR,
                                          IM.CDCFOPPADRAO, IP.CDCLASFISC AS CDCLASFISC,
                                          NVL(PA.CDPRODUTO,PR.CDPRODUTO) AS CDPRODUTO
                                     FROM ITMAPARECUP IM, DETITMAPARECUP DT, PRODUTO PA, PRODUTO PR, ITEMVENDA IP
                                    WHERE DT.CDFILIALVND   = C_REGC100.CDFILIAL
                                      AND DT.NRSEQVENDA    = C_REGC100.NRLANCTONF
                                      AND DT.CDCAIXA       = C_REGC100.CDCAIXA
                                      AND C_REGC100.CDMODDOCFISC = '65'
                                      AND IM.IDCOMPOEC197  = 'I'
                                      AND IM.IDTIPOITMAPR  = 'VI'
                                      AND IM.NRSEQUMAPAPU  = DT.NRSEQUMAPAPU
                                      AND IM.IDTIPOITMAPR  = DT.IDTIPOITMAPR
                                      AND IM.NRSEQITMAPR   = DT.NRSEQITMAPR
                                      AND DT.CDFILIALVND   = IP.CDFILIAL
                                      AND DT.CDCAIXA       = IP.CDCAIXA
                                      AND DT.NRSEQVENDA    = IP.NRSEQVENDA
                                      AND DT.NRSEQUITVEND  = IP.NRSEQUITVEND
                                      AND PR.CDPRODUTO     = IP.CDPRODUTO
                                      AND PR.CDPRODESTO    = PA.CDPRODUTO(+)
                                    GROUP BY IM.CDAJUSTEITMAPA, IM.DSITEMMAPR,
                                          NVL(PA.CDARVPROD,PR.CDARVPROD), DT.VROUTALIQ,
                                          IM.IDTIPOITMAPR, IM.CDCFOPPADRAO, IP.CDCLASFISC,
                                          NVL(PA.CDPRODUTO,PR.CDPRODUTO))
                            ORDER BY SUBSTR(COD_AJ,8,3), IDTIPOITMAPR, CDCFOPPADRAO, CDCLASFISC, CDPRODUTO) LOOP

             BEGIN
                SELECT LPAD(NVL(IT.CDITEMVARIAVEL,'0')||DECODE(C_REGC197.CDCFOPPADRAO,'','',SUBSTR(C_REGC197.DESCR_COMPL_AJ,2,3)),6,'0') AS COD_OBS,
                       TRIM(IT.DSAJUSTE) AS TXT
                  INTO V_CODC195, V_TXTC195
                  FROM ITEMVARAJEFD IT
                 WHERE IT.SGESTADO       = SUBSTR(C_REGC197.COD_AJ,1,2)
                   AND IT.CDITEMVARIAVEL = SUBSTR(C_REGC197.COD_AJ,8,3);
             EXCEPTION
                WHEN NO_DATA_FOUND THEN
                   V_CODC195 := '';
                   V_TXTC195 := '';
             END;

            /* CODIGO DO PRODUTO */
            SELECT MAX(CDCHAVEREG)
              INTO V_PRODUTO
              FROM TMP_REGDADOSSPED
             WHERE CDCHAVEREG = C_REGC197.CDPRODUTO
               AND CDREGISTRO = '0200';

            IF (V_PRODUTO IS NULL) AND (C_REGC197.CDPRODUTO IS NOT NULL) THEN
               V_SEQUPROD := NVL(V_SEQUPROD,0) + 1;
               INSERT INTO TMP_REGDADOSSPED
                 (CDREGISTRO, CDCONTREGI, CDCHAVEREG, CDCAMPO3)
               VALUES
                 ('0200', V_SEQUPROD, C_REGC197.CDPRODUTO, C_REGC197.CDCLASFISC);
            END IF;
            V_PRODUTO := NULL;

             V_COD_OBS := NULL;
             SELECT MAX(CDCHAVEREG)
               INTO V_COD_OBS
               FROM TMP_REGDADOSSPED
              WHERE CDCHAVEREG = V_CODC195
                AND CDREGISTRO = '0460';

             IF (V_COD_OBS IS NULL) THEN
                V_SEQUPROD := NVL(V_SEQUPROD,0) + 1;
                INSERT INTO TMP_REGDADOSSPED
                   (CDREGISTRO, CDCONTREGI, CDCHAVEREG, CDCAMPO1)
                VALUES
                   ('0460', V_SEQUPROD, NVL(V_CODC195,SUBSTR(C_REGC197.COD_AJ,8,3)), V_TXTC195);
             END IF;

             IF (V_C195 IS NULL) OR (V_C195 <> SUBSTR(C_REGC197.COD_AJ,8,3)||CASE WHEN C_REGC197.CDCFOPPADRAO IS NOT NULL THEN SUBSTR(C_REGC197.DESCR_COMPL_AJ,2,3) ELSE '' END) THEN
                INSERT INTO ARQMAGNETICO
                   (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
                VALUES
                   ('19'||LPAD(RTRIM(V_CONTREGC), 8, '0'), '|C195'  || '|' || V_CODC195 || '|' || '' || '|', P_NRSEQARQMAG);
                V_CONTREGC := NVL(V_CONTREGC,0) + 1;
             END IF;

             V_REG_C197 := '|C197'                   || '|' ||
                           C_REGC197.COD_AJ          || '|' ||
                           C_REGC197.DESCR_COMPL_AJ  || '|' ||
                           C_REGC197.COD_ITEM        || '|' ||
                           C_REGC197.VL_BC_ICMS      || '|' ||
                           C_REGC197.ALIQ_ICMS       || '|' ||
                           C_REGC197.VL_ICMS         || '|' ||
                           C_REGC197.VL_OUTROS       || '|' ;
             INSERT INTO ARQMAGNETICO
               (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
             VALUES
               ('19'||LPAD(RTRIM(V_CONTREGC), 8, '0'), V_REG_C197, P_NRSEQARQMAG);
             V_CONTREGC := NVL(V_CONTREGC,0) + 1;

             V_C195 := SUBSTR(C_REGC197.COD_AJ,8,3)||CASE WHEN C_REGC197.CDCFOPPADRAO IS NOT NULL THEN SUBSTR(C_REGC197.DESCR_COMPL_AJ,2,3) ELSE '' END;
         END LOOP;
      END LOOP;
   END IF;

   IF V_CDSITUCRT <> '3' THEN  /*SIMPLES NACIONAL*/
       FOR C_REGC100 IN(SELECT ('|C100'                                                              || '|' ||
                                NF.CAMPO2                                                            || '|' ||
                                (CASE WHEN ((NF.CDSERIEENTR BETWEEN '890' AND '899') AND (NF.CDMODDOCFISC = '55')) THEN '1' ELSE NF.CAMPO3 END) || '|' ||
                                DECODE(NF.IDSTATUSNFE,'D','',DECODE(NF.IDSTATUS,'C','',REPLACE(REPLACE(REPLACE(REPLACE(NF.IDORIGDESTNF||DECODE(NF.IDORIGDESTNF, 'F', NF.CDFORNECED, DECODE(NF.IDORIGDESTNF, 'C', NF.CDCLIENTE , DECODE(NF.IDENTRSAIDOP, 'E', NF.CDFILIEMIT, NF.CDFILIRECE))),'.'),'-'),'/'),' '))) || '|' ||
                                NF.CDMODDOCFISC                                                      || '|' ||
                                DECODE(NF.IDSTATUSNFE, 'D', '04', DECODE(IDSTATUS,'C','02', DECODE(NF.IDENTRSAIDOP,'S', (CASE WHEN DTEMISSAO < P_DTINICIAL THEN DECODE(NF.CDTIPOOPER,'03','07',TIPOOPER_COMPL_S,'07','01') ELSE DECODE(NF.CDTIPOOPER,'03','06',TIPOOPER_COMPL_S,'06','00') END), (CASE WHEN ((NF.CDSERIEENTR BETWEEN '890' AND '899') AND (NF.CDMODDOCFISC = '55')) THEN '08'ELSE (CASE WHEN DTENTRSAID < P_DTINICIAL THEN DECODE(NF.CDTIPOOPER,'03','07',TIPOOPER_COMPL_E,'07','01')ELSE DECODE(NF.CDTIPOOPER,'03','06',TIPOOPER_COMPL_E,'06','00') END) END)))) ||'|'||
                                CASE WHEN LENGTH(NF.NRACESSONFE) = '44' THEN SUBSTR(NRACESSONFE,23,3) ELSE REPLACE(REPLACE(DECODE(NF.IDENTRSAIDOP, 'E', NF.CDSERIEENTR, NF.CDSERIE),'-',''),'.','') END   || '|' ||
                                DECODE(NF.IDENTRSAIDOP, 'E', LTRIM(NF.NRNOTAFISC,'0'), DECODE(NF.NRACESSONFE, '', LTRIM(REPLACE(LTRIM(NF.NRNOTAFISC, '0'),' ')),DECODE(NF.IDSTATUS,'C',LTRIM(NF.NRNOTAFISC,'0'),LTRIM(NF.NRNOTAFISCALELE, '0')) )  )|| '|' ||
                                NRACESSONFE                                                                                        || '|' ||  --chave da nota fiscal eletronica
                                DECODE(NF.IDSTATUSNFE, 'D', '', DECODE(NF.IDSTATUS, 'C', '', TO_CHAR(NF.DTEMISSAO,'ddmmyyyy')) )   || '|' ) AS DADOS_1,
                                (REPLACE(LTRIM(TO_CHAR(ROUND(NF.VRCONTABILNF,2), '999999999990.00')), '.', ',')                    || '|' ||
                                DECODE(NF.IDSTATUSNFE, 'D', '', DECODE(NF.IDSTATUS, 'C', '', DECODE(NVL(NF.QTDEPARC,0),0,'2',1,'0','1'))) || '|' || -- campo 13
                                DECODE(NF.IDSTATUSNFE, 'D', '', DECODE(NF.IDSTATUS, 'C', '', REPLACE(LTRIM(TO_CHAR((SELECT SUM(ROUND(VRENCARGODESC,2)) FROM ITEMPRODUTO WHERE CDFILIAL = NF.CDFILIAL AND NRLANCTONF = NF.NRLANCTONF AND NRSEQITPROD IS NOT NULL), '999999999990.00')), '.', ','))) || '|' ||
                                REPLACE(LTRIM(TO_CHAR(ROUND(DECODE(NF.IDSTATUSNFE, 'D', '', DECODE(NF.IDSTATUS, 'C', '', VALOR_ENCARGO_NFE(NF.CDFILIAL, NF.NRLANCTONF, V_IDDESCONTO, '03'))),2), '999999999990.00')), '.', ',') || '|' ||  -- abatimento no tributado e nao comercial desconto ICMS
                                DECODE(NF.IDSTATUSNFE, 'D', '', DECODE(NF.IDSTATUS, 'C', '', REPLACE(LTRIM(TO_CHAR(ROUND(NF.VRPRODUTOS,2), '999999999990.00')), '.', ','))) || '|' ||
                                DECODE(NF.IDSTATUSNFE, 'D', '', DECODE(NF.IDSTATUS, 'C', '', RPAD(NVL(NF.IDPGTOFRETE, '9'), 1 , ' ')))                                      || '|' ||
                                REPLACE(LTRIM(TO_CHAR(ROUND(DECODE(NF.IDSTATUSNFE, 'D', '', DECODE(NF.IDSTATUS, 'C', '', VALOR_ENCARGO_NFE(NF.CDFILIAL, NF.NRLANCTONF, V_IDFRETE,  '01'))),2), '999999999990.00')), '.', ',') || '|' ||
                                REPLACE(LTRIM(TO_CHAR(ROUND(DECODE(NF.IDSTATUSNFE, 'D', '', DECODE(NF.IDSTATUS, 'C', '', VALOR_ENCARGO_NFE(NF.CDFILIAL, NF.NRLANCTONF, V_IDSEGUR,  '02'))),2), '999999999990.00')), '.', ',') || '|' ||
                                /*REPLACE(LTRIM(TO_CHAR(ROUND(DECODE(NF.IDSTATUS, 'C', '', ABS(VALOR_IMPOSTO_NF(NF.CDFILIAL, NF.NRLANCTONF,V_CDIMPOSTRIB, 'I','1')) + ABS(VALOR_IMPOSTO_NF(NF.CDFILIAL, NF.NRLANCTONF, V_IPI, 'I','1'))),2), '999999999990.00')), '.', ',')  || '|' || --campo20*/
                                REPLACE(LTRIM(TO_CHAR(ROUND(DECODE(NF.IDSTATUSNFE, 'D', '', DECODE(NF.IDSTATUS, 'C', '', VALOR_ENCARGO_NFE(NF.CDFILIAL, NF.NRLANCTONF, V_IDOUTROS, '04'))),2), '999999999990.00')), '.', ',') || '|' || -- Campo 20 outras obrigações acessórias
                                REPLACE(LTRIM(TO_CHAR(ROUND(DECODE(NF.IDSTATUSNFE, 'D', '', DECODE(NF.IDSTATUS, 'C', '', NF.VRBASECALCNF)),2), '999999999990.00')), '.', ',') || '|' || -- campo 21
                                REPLACE(LTRIM(TO_CHAR(ROUND(DECODE(NF.IDSTATUSNFE, 'D', '', DECODE(NF.IDSTATUS, 'C', '', NF.VRIMPOSTONF)),2), '999999999990.00')), '.', ',') || '|' || -- campo 22
                                REPLACE(LTRIM(TO_CHAR(DECODE(NF.IDSTATUSNFE, 'D', '', DECODE(NF.IDSTATUS,'C','',VALOR_IMPOSTO_NFE(NF.CDFILIAL, NF.NRLANCTONF,'80','B','1'))), '999999999990.00')), '.', ',') || '|' || -- base de calc susbt. trib
                                REPLACE(LTRIM(TO_CHAR(DECODE(NF.IDSTATUSNFE, 'D', '', DECODE(NF.IDSTATUS,'C','',VALOR_IMPOSTO_NFE(NF.CDFILIAL, NF.NRLANCTONF,'80','I','1') + VALOR_FECP_NFE(NF.CDFILIAL, NF.NRLANCTONF,'80','I','1'))), '999999999990.00')), '.', ',') || '|' || -- valor do icms retido susbt. trib
                                REPLACE(LTRIM(TO_CHAR(DECODE(NF.IDSTATUSNFE, 'D', '', DECODE(NF.IDSTATUS,'C','',VALOR_IMPOSTO_NFE(NF.CDFILIAL, NF.NRLANCTONF,'10','I','1'))), '999999999990.00')), '.', ',') || '|' || -- valor do IPI
                                REPLACE(LTRIM(TO_CHAR(ROUND(DECODE(NF.IDSTATUSNFE, 'D', '', DECODE(NF.IDSTATUS, 'C', '', VALOR_IMPOSTO_NFE(NF.CDFILIAL, NF.NRLANCTONF, '50', 'I','1'))),2), '999999999990.00')), '.', ',') || '|' || -- valor do PIS
                                REPLACE(LTRIM(TO_CHAR(ROUND(DECODE(NF.IDSTATUSNFE, 'D', '', DECODE(NF.IDSTATUS, 'C', '', VALOR_IMPOSTO_NFE(NF.CDFILIAL, NF.NRLANCTONF, '60', 'I','1'))),2), '999999999990.00')), '.', ',') || '|' || -- valor do COFINS
                                DECODE(NF.IDSTATUSNFE, 'D', '', DECODE(NF.IDSTATUS, 'C', '', '0,00')) || '|' || -- pis retido por subst. trib.
                                DECODE(NF.IDSTATUSNFE, 'D', '', DECODE(NF.IDSTATUS, 'C', '', '0,00')) || '|'  ) AS DADOS_3,
                                NF.CDFILIAL AS CDFILIAL, NF.NRLANCTONF AS NRLANCTONF, NF.NRINSJURTRAN, NF.IDTPIJURTRAN, NF.VRPBRUTOVOLU, NF.VRPLIQUVOLU,
                                NF.NRPLACAVEIC, NF.DSQTDEVOLU, NF.DSESPECVOLU, NF.DSMARCAVOLU, NF.DSNUMEVOLU, NF.CDFISCOPERNF, NF.NRNOTAFISC AS NRNOTAFISC,
                                NF.DTEMISSAO, NF.DTENTRSAID, NF.IDENTRSAIDOP, NF.VRIMPOSTONF, NF.CDMODDOCFISC, NF.IDSTATUS, NF.IDORIGDESTNF,
                                NF.IDORIGDESTNF||DECODE(NF.IDORIGDESTNF, 'F', NF.CDFORNECED, DECODE(NF.IDORIGDESTNF, 'C', NF.CDCLIENTE , DECODE(NF.IDENTRSAIDOP, 'E', NF.CDFILIEMIT, NF.CDFILIRECE))) AS COD_PAR,
                                DECODE(IDSTATUS,'C','02',DECODE(NF.IDENTRSAIDOP,'S', (CASE WHEN DTEMISSAO < P_DTINICIAL THEN DECODE(NF.CDTIPOOPER,'03','07',TIPOOPER_COMPL_S,'07','01') ELSE DECODE(NF.CDTIPOOPER,'03','06',TIPOOPER_COMPL_S,'06','00') END),(CASE WHEN DTENTRSAID < P_DTINICIAL THEN DECODE(NF.CDTIPOOPER,'03','07',TIPOOPER_COMPL_E,'07','01')ELSE DECODE(NF.CDTIPOOPER,'03','06',TIPOOPER_COMPL_E,'06','00') END))) AS SITU_DOC,
                                NF.IDSTATUSNFE, NVL(NF.IDSIMPLESNACIONAL,'N') AS IDSIMPLESNACIONAL, NF.QTDEPARC, NF.CDTIPOOPER, DECODE(NF.IDENTRSAIDOP,'S',NF.CDFILIEMIT,NF.CDFILIRECE) AS FILIAL
                        FROM (/*NF SAÍDA SEM CARGA TRIBUTÁRIA*/
                              SELECT DECODE(N.IDENTRSAIDOP, 'E', '0','1') AS CAMPO2,
                                     DECODE(N.IDENTRSAIDOP, 'E', DECODE(IDSTATUSNFE,'A','0',DECODE(IDSTATUS,'E','0','1')), '0') AS CAMPO3, NRACESSONFE,
                                     I.CDFILIAL, I.NRLANCTONF, N.IDENTRSAIDOP, N.NRNOTAFISC, NVL(SS.CDSERIENFE,N.CDSERIE) AS CDSERIE, NVL(SE.CDSERIEENTRNFE,N.CDSERIEENTR) AS CDSERIEENTR,
                                     N.NRINSJURNF, N.IDSTATUS, N.DTENTRSAID, N.VRNOTAFISC, TO_CHAR(N.VRPRODUTOS) AS VRPRODUTOS, N.IDPGTOFRETE,
                                     N.NRPLACAVEIC, N.DSQTDEVOLU, N.DSESPECVOLU, N.DSMARCAVOLU, N.DSNUMEVOLU,
                                     N.CDFILIEMIT, N.CDFILIRECE, N.DTEMISSAO, MAX(I.CDFISCOPERNF) AS CDFISCOPERNF, N.CDMODDOCFISC, N.CDCLIENTE, N.CDFORNECED, N.IDORIGDESTNF,
                                     TO_CHAR(SUM(I.VRCONTABILNF)) AS VRCONTABILNF, N.NRINSJURTRAN, N.IDTPIJURTRAN, N.VRPBRUTOVOLU, N.VRPLIQUVOLU,
                                     TO_CHAR(SUM(DECODE(I.CDFISCALNF,'1',I.VRBASECALCNF,0))) AS VRBASECALCNF,
                                     TO_CHAR(SUM(DECODE(I.CDFISCALNF,'1',I.VRIMPOSTONF,0)))  AS VRIMPOSTONF,
                                     TO_CHAR(SUM(DECODE(I.CDFISCALNF,'3',I.VRCONTABILNF,0)))   AS VROUTRCRED,
                                     TO_CHAR(SUM(DECODE(I.CDFISCALNF,'2',I.VRCONTABILNF,'1',DECODE(I.VRPERREDBCNF,0, 0,I.VRCONTABILNF-I.VRBASECALCNF), 0))) AS VRISENTRIB,
                                     N.NRNOTAFISCALELE, N.CDTIPOOPER, N.IDSTATUSNFE, DECODE(N.IDORIGDESTNF,'F',PF.IDSIMPLESNACIONAL,'S') AS IDSIMPLESNACIONAL,
                                     MAX((SELECT COUNT(DISTINCT NRPARCELAREC)
                                            FROM CONTARECEBER C
                                           WHERE N.CDFILIAL = C.CDFILIAL
                                             AND N.NRLANCTONF = C.NRLANCTONF
                                             AND C.NRLANBOLREC IS NOT NULL)) AS QTDEPARC
                              FROM NOTAFISCAL N, IMPOSTONF I, IMPOSTO IP, PARAMFORNE PF, SERIENF SS, SERIEENTR SE
                              WHERE N.NRSEQUMAPAPUSN  = V_NRSEQUMAPAPU
                                AND N.CDINSCESTA      = P_CDINSCESTA
                                AND IP.CDIMPOSTONFE   = P_CDIMPOSTO
                                AND IP.CDIMPOSTO      = I.CDIMPOSTO
                                AND (NVL(N.IDSISTEMA,'DFS') <> 'REC'
                                AND NVL(N.IDSISTEMA, 'DFS') <> 'PAG'
                                AND NVL(N.IDSISTEMA, 'DFS') <> 'CMP'
                                AND NVL(N.IDSISTEMA, 'DFS') <> 'SUP'
                                AND NVL(N.IDSISTEMA, 'DFS') <> 'TMP'
                                AND NVL(N.IDSISTEMA, 'DFS') <> 'FIS')
                                AND SE.CDSERIEENTR(+) = N.CDSERIEENTR
                                AND SS.CDEMPRESA(+)   = N.CDEMPRESA
                                AND SS.CDINSCESTA(+)  = N.CDINSCESTA
                                AND SS.CDINSCMUNI(+)  = N.CDINSCMUNI
                                AND SS.CDSERIE(+)     = N.CDSERIE
                                AND N.IDENTRSAIDOP    = 'S'
                                AND NVL(I.IDIMPOSTONF, '1') <> '3'
                                AND N.CDFILIAL        = I.CDFILIAL
                                AND N.NRLANCTONF      = I.NRLANCTONF
                                AND N.CDFORNECED      = PF.CDFORNECED(+)
                                AND ((N.IDSTATUS = 'A') OR (N.IDSTATUS = 'E'))
                                AND N.CDMODDOCFISC IN ('01','1B','04','55')
                                AND NVL(P_GERAFORSALE,'N') = 'N'
                                AND VALOR_IMPOSTO_NFE(I.CDFILIAL,I.NRLANCTONF,'03','I','1') = 0
                              GROUP BY DECODE(N.IDENTRSAIDOP, 'E', '0','1'), I.CDFILIAL, I.NRLANCTONF, N.IDENTRSAIDOP, N.NRNOTAFISC, NVL(SS.CDSERIENFE,N.CDSERIE), NVL(SE.CDSERIEENTRNFE,N.CDSERIEENTR),
                                     N.NRINSJURNF, N.IDSTATUS, N.DTENTRSAID, N.VRNOTAFISC, TO_CHAR(N.VRPRODUTOS), N.IDPGTOFRETE,
                                     N.DTEMISSAO, N.CDMODDOCFISC, N.CDCLIENTE, N.CDFORNECED, N.IDORIGDESTNF,
                                     N.CDFILIEMIT, N.CDFILIRECE, N.NRINSJURTRAN, N.IDTPIJURTRAN, N.VRPBRUTOVOLU, N.VRPLIQUVOLU,
                                     N.NRPLACAVEIC, N.DSQTDEVOLU, N.DSESPECVOLU, N.DSMARCAVOLU, N.DSNUMEVOLU, NRACESSONFE, N.NRNOTAFISCALELE, N.CDTIPOOPER, N.IDSTATUSNFE,
                                     DECODE(N.IDORIGDESTNF,'F',PF.IDSIMPLESNACIONAL,'S')
                              UNION ALL
                              /*NF SAÍDA COM CARGA TRIBUTÁRIA*/
                              SELECT DECODE(N.IDENTRSAIDOP, 'E', '0','1') AS CAMPO2,
                                     DECODE(N.IDENTRSAIDOP, 'E', DECODE(IDSTATUSNFE,'A','0',DECODE(IDSTATUS,'E','0','1')), '0') AS CAMPO3, NRACESSONFE,
                                     I.CDFILIAL, I.NRLANCTONF, N.IDENTRSAIDOP, N.NRNOTAFISC, NVL(SS.CDSERIENFE,N.CDSERIE) AS CDSERIE, NVL(SE.CDSERIEENTRNFE,N.CDSERIEENTR) AS CDSERIEENTR,
                                     N.NRINSJURNF, N.IDSTATUS, N.DTENTRSAID, N.VRNOTAFISC, TO_CHAR(N.VRPRODUTOS) AS VRPRODUTOS, N.IDPGTOFRETE,
                                     N.NRPLACAVEIC, N.DSQTDEVOLU, N.DSESPECVOLU, N.DSMARCAVOLU, N.DSNUMEVOLU,
                                     N.CDFILIEMIT, N.CDFILIRECE, N.DTEMISSAO, MAX(I.CDFISCOPERNF) AS CDFISCOPERNF, N.CDMODDOCFISC, N.CDCLIENTE, N.CDFORNECED, N.IDORIGDESTNF,
                                     TO_CHAR(SUM(I.VRCONTABILNF)) AS VRCONTABILNF, N.NRINSJURTRAN, N.IDTPIJURTRAN, N.VRPBRUTOVOLU, N.VRPLIQUVOLU,
                                     TO_CHAR(DECODE(V_IDTPCARGATRIB,'O',0,DECODE(V_SGESTADO,'SP',0,VALOR_IMPOSTO_NFE(I.CDFILIAL,I.NRLANCTONF,'03','B','1')))) AS VRBASECALCNF,
                                     TO_CHAR(DECODE(V_IDTPCARGATRIB,'O',0,VALOR_IMPOSTO_NFE(I.CDFILIAL,I.NRLANCTONF,'03','I','1')))  AS VRIMPOSTONF,
                                     TO_CHAR(SUM(DECODE(I.CDFISCALNF,'3',I.VRCONTABILNF,0)))   AS VROUTRCRED,
                                     TO_CHAR(SUM(DECODE(I.CDFISCALNF,'2',I.VRCONTABILNF,'1',DECODE(I.VRPERREDBCNF,0, 0,I.VRCONTABILNF-I.VRBASECALCNF), 0))) AS VRISENTRIB,
                                     N.NRNOTAFISCALELE, N.CDTIPOOPER, N.IDSTATUSNFE, DECODE(N.IDORIGDESTNF,'F',PF.IDSIMPLESNACIONAL,'S') AS IDSIMPLESNACIONAL,
                                     MAX((SELECT COUNT(DISTINCT NRPARCELAREC)
                                            FROM CONTARECEBER C
                                           WHERE N.CDFILIAL = C.CDFILIAL
                                             AND N.NRLANCTONF = C.NRLANCTONF
                                             AND C.NRLANBOLREC IS NOT NULL)) AS QTDEPARC
                              FROM NOTAFISCAL N, IMPOSTONF I, IMPOSTO IP, PARAMFORNE PF, SERIENF SS, SERIEENTR SE
                              WHERE N.NRSEQUMAPAPUSN  = V_NRSEQUMAPAPU
                                AND N.CDINSCESTA      = P_CDINSCESTA
                                AND IP.CDIMPOSTONFE   = P_CDIMPOSTO
                                AND IP.CDIMPOSTO      = I.CDIMPOSTO
                                AND (NVL(N.IDSISTEMA,'DFS') <> 'REC'
                                AND NVL(N.IDSISTEMA, 'DFS') <> 'PAG'
                                AND NVL(N.IDSISTEMA, 'DFS') <> 'CMP'
                                AND NVL(N.IDSISTEMA, 'DFS') <> 'SUP'
                                AND NVL(N.IDSISTEMA, 'DFS') <> 'TMP'
                                AND NVL(N.IDSISTEMA, 'DFS') <> 'FIS')
                                AND SE.CDSERIEENTR(+) = N.CDSERIEENTR
                                AND SS.CDEMPRESA(+)   = N.CDEMPRESA
                                AND SS.CDINSCESTA(+)  = N.CDINSCESTA
                                AND SS.CDINSCMUNI(+)  = N.CDINSCMUNI
                                AND SS.CDSERIE(+)     = N.CDSERIE
                                AND N.IDENTRSAIDOP    = 'S'
                                AND NVL(I.IDIMPOSTONF, '1') <> '3'
                                AND N.CDFILIAL        = I.CDFILIAL
                                AND N.NRLANCTONF      = I.NRLANCTONF
                                AND N.CDFORNECED      = PF.CDFORNECED(+)
                                AND ((N.IDSTATUS = 'A') OR (N.IDSTATUS = 'E'))
                                AND N.CDMODDOCFISC IN ('01','1B','04','55')
                                AND NVL(P_GERAFORSALE,'N') = 'N'
                                AND VALOR_IMPOSTO_NFE(I.CDFILIAL,I.NRLANCTONF,'03','I','1') > 0
                              GROUP BY DECODE(N.IDENTRSAIDOP, 'E', '0','1'), I.CDFILIAL, I.NRLANCTONF, N.IDENTRSAIDOP, N.NRNOTAFISC, NVL(SS.CDSERIENFE,N.CDSERIE), NVL(SE.CDSERIEENTRNFE,N.CDSERIEENTR),
                                     N.NRINSJURNF, N.IDSTATUS, N.DTENTRSAID, N.VRNOTAFISC, TO_CHAR(N.VRPRODUTOS), N.IDPGTOFRETE,
                                     N.DTEMISSAO, N.CDMODDOCFISC, N.CDCLIENTE, N.CDFORNECED, N.IDORIGDESTNF,
                                     N.CDFILIEMIT, N.CDFILIRECE, N.NRINSJURTRAN, N.IDTPIJURTRAN, N.VRPBRUTOVOLU, N.VRPLIQUVOLU,
                                     N.NRPLACAVEIC, N.DSQTDEVOLU, N.DSESPECVOLU, N.DSMARCAVOLU, N.DSNUMEVOLU, NRACESSONFE, N.NRNOTAFISCALELE, N.CDTIPOOPER, N.IDSTATUSNFE,
                                     DECODE(N.IDORIGDESTNF,'F',PF.IDSIMPLESNACIONAL,'S'), VALOR_IMPOSTO_NFE(I.CDFILIAL,I.NRLANCTONF,'03','B','1'), VALOR_IMPOSTO_NFE(I.CDFILIAL,I.NRLANCTONF,'03','I','1')
                              UNION ALL
                              /******** NOTA CANCELADA *******/
                              SELECT DECODE(N.IDENTRSAIDOP, 'E', '0','1') AS CAMPO2,
                                     '0' AS CAMPO3, NRACESSONFE,
                                     N.CDFILIAL, N.NRLANCTONF, N.IDENTRSAIDOP, N.NRNOTAFISC,NVL(SS.CDSERIENFE,N.CDSERIE) AS CDSERIE, NVL(SE.CDSERIEENTRNFE,N.CDSERIEENTR) AS CDSERIEENTR,
                                     '' AS NRINSJURNF, N.IDSTATUS, N.DTENTRSAID, N.VRNOTAFISC, '' AS VRPRODUTOS, N.IDPGTOFRETE,
                                     N.NRPLACAVEIC, N.DSQTDEVOLU, N.DSESPECVOLU, N.DSMARCAVOLU, N.DSNUMEVOLU,
                                     '' AS CDFILIEMIT, '' AS CDFILIRECE, N.DTEMISSAO, '' AS CDFISCOPERNF, N.CDMODDOCFISC, '' AS CDCLIENTE, '' AS CDFORNECED, N.IDORIGDESTNF,
                                     '' AS VRCONTABILNF, N.NRINSJURTRAN, N.IDTPIJURTRAN, N.VRPBRUTOVOLU, N.VRPLIQUVOLU,
                                     '' AS VRBASECALCNF,
                                     '' AS VRIMPOSTONF,
                                     '' AS VROUTRCRED,
                                     '' AS VRISENTRIB,
                                     NRNOTAFISCALELE,
                                     N.CDTIPOOPER, N.IDSTATUSNFE, 'N' AS IDSIMPLESNACIONAL, 0 AS QTDEPARC
                               FROM NOTAFISCAL N, SERIENF SS, SERIEENTR SE
                              WHERE (NVL(N.IDSISTEMA,'DFS') <> 'REC'
                                AND NVL(N.IDSISTEMA, 'DFS') <> 'PAG'
                                AND NVL(N.IDSISTEMA, 'DFS') <> 'CMP'
                                AND NVL(N.IDSISTEMA, 'DFS') <> 'SUP'
                                AND NVL(N.IDSISTEMA, 'DFS') <> 'TMP'
                                AND NVL(N.IDSISTEMA, 'DFS') <> 'FIS')
                                AND SE.CDSERIEENTR(+) = N.CDSERIEENTR
                                AND SS.CDEMPRESA(+)   = N.CDEMPRESA
                                AND SS.CDINSCESTA(+)  = N.CDINSCESTA
                                AND SS.CDINSCMUNI(+)  = N.CDINSCMUNI
                                AND SS.CDSERIE(+)     = N.CDSERIE
                                AND N.IDENTRSAIDOP = 'S'
                                AND N.IDSTATUS = 'C'
                                AND N.CDMODDOCFISC IN ('01','1B','04','55')
                                AND N.DTEMISSAO BETWEEN P_DTINICIAL AND P_DTFINAL
                                AND N.CDINSCESTA = P_CDINSCESTA
                                AND N.CDEMPRESA = P_CDEMPRESA
                              GROUP BY DECODE(N.IDENTRSAIDOP, 'E', '0','1'), N.CDFILIAL, N.NRLANCTONF, N.IDENTRSAIDOP, N.NRNOTAFISC, NVL(SS.CDSERIENFE,N.CDSERIE), NVL(SE.CDSERIEENTRNFE,N.CDSERIEENTR),
                                       N.IDSTATUS, N.DTENTRSAID, N.VRNOTAFISC, N.IDPGTOFRETE, N.CDMODDOCFISC, N.CDCLIENTE,
                                       N.CDFORNECED, N.IDORIGDESTNF, N.CDFILIEMIT, N.CDFILIRECE, N.DTEMISSAO, N.NRINSJURTRAN, N.IDTPIJURTRAN,
                                       N.VRPBRUTOVOLU, N.VRPLIQUVOLU, N.NRPLACAVEIC, N.DSQTDEVOLU, N.DSESPECVOLU, N.DSMARCAVOLU,
                                       N.DSNUMEVOLU, N.NRACESSONFE, N.CDTIPOOPER, N.IDSTATUSNFE, N.NRNOTAFISCALELE
                              UNION ALL
                              /*NF ENTRADA SEM CARGA TRIBUTÁRIA*/
                              SELECT DECODE(N.IDENTRSAIDOP, 'E', '0','1') AS CAMPO2,
                                     DECODE(N.IDENTRSAIDOP, 'E', DECODE(IDSTATUSNFE,'A','0',DECODE(IDSTATUS,'E','0','1')), '0') AS CAMPO3, NRACESSONFE,
                                     I.CDFILIAL, I.NRLANCTONF, N.IDENTRSAIDOP, N.NRNOTAFISC, NVL(SS.CDSERIENFE,N.CDSERIE) AS CDSERIE, NVL(SE.CDSERIEENTRNFE,N.CDSERIEENTR) AS CDSERIEENTR,
                                     N.NRINSJURNF, N.IDSTATUS, N.DTENTRSAID, N.VRNOTAFISC, TO_CHAR(N.VRPRODUTOS) AS VRPRODUTOS, N.IDPGTOFRETE,
                                     N.NRPLACAVEIC, N.DSQTDEVOLU, N.DSESPECVOLU, N.DSMARCAVOLU, N.DSNUMEVOLU,
                                     N.CDFILIEMIT, N.CDFILIRECE, N.DTEMISSAO, MAX(I.CDFISCOPERNF) AS CDFISCOPERNF, N.CDMODDOCFISC, N.CDCLIENTE, N.CDFORNECED, N.IDORIGDESTNF,
                                     TO_CHAR(SUM(I.VRCONTABILNF)) AS VRCONTABILNF, N.NRINSJURTRAN, N.IDTPIJURTRAN, N.VRPBRUTOVOLU, N.VRPLIQUVOLU,
                                     TO_CHAR(SUM(DECODE(I.CDFISCALNF,'1',I.VRBASECALCNF,0))) AS VRBASECALCNF,
                                     TO_CHAR(SUM(DECODE(I.CDFISCALNF,'1',I.VRIMPOSTONF,0)))  AS VRIMPOSTONF,
                                     TO_CHAR(SUM(DECODE(I.CDFISCALNF,'3',I.VRCONTABILNF,0)))   AS VROUTRCRED,
                                     TO_CHAR(SUM(DECODE(I.CDFISCALNF,'2',I.VRCONTABILNF,'1',DECODE(I.VRPERREDBCNF,0, 0,I.VRCONTABILNF-I.VRBASECALCNF), 0))) AS VRISENTRIB,
                                     N.NRNOTAFISCALELE, N.CDTIPOOPER, N.IDSTATUSNFE, DECODE(N.IDORIGDESTNF,'F',PF.IDSIMPLESNACIONAL,'N') AS IDSIMPLESNACIONAL,
                                     MAX((SELECT COUNT(DISTINCT C.NRPARCELAPAG)
                                            FROM CONTAPAGAR C
                                           WHERE N.CDFILIAL   = C.CDFILIAL
                                             AND N.NRLANCTONF = C.NRLANCTONF
                                             AND C.NRLANBOLPAG IS NOT NULL)) AS QTDEPARC
                              FROM NOTAFISCAL N, IMPOSTONF I, IMPOSTO IP, PARAMFORNE PF, SERIENF SS, SERIEENTR SE
                              WHERE N.NRSEQUMAPAPUSN  = V_NRSEQUMAPAPU
                                AND N.CDINSCESTA      = P_CDINSCESTA
                                AND IP.CDIMPOSTONFE   = P_CDIMPOSTO
                                AND IP.CDIMPOSTO      = I.CDIMPOSTO
                                AND (NVL(N.IDSISTEMA,'DFS')  <> 'REC'
                                AND NVL(N.IDSISTEMA, 'DFS')  <> 'PAG'
                                AND NVL(N.IDSISTEMA, 'DFS')  <> 'CMP'
                                AND NVL(N.IDSISTEMA, 'DFS')  <> 'SUP'
                                AND NVL(N.IDSISTEMA, 'DFS')  <> 'TMP'
                                AND NVL(N.IDSISTEMA, 'DFS')  <> 'FIS')
                                AND SE.CDSERIEENTR(+) = N.CDSERIEENTR
                                AND SS.CDEMPRESA(+)   = N.CDEMPRESA
                                AND SS.CDINSCESTA(+)  = N.CDINSCESTA
                                AND SS.CDINSCMUNI(+)  = N.CDINSCMUNI
                                AND SS.CDSERIE(+)     = N.CDSERIE
                                AND N.IDENTRSAIDOP    = 'E'
                                AND PF.CDFORNECED(+)  = N.CDFORNECED
                                AND NVL(I.IDIMPOSTONF, '1') <> '3'
                                AND N.CDFILIAL        = I.CDFILIAL
                                AND N.NRLANCTONF      = I.NRLANCTONF
                                AND ((N.IDSTATUS = 'A') OR (N.IDSTATUS = 'E'))
                                AND N.CDMODDOCFISC IN ('01','1B','04','55')
                                AND NVL(P_GERAFORSALE,'N') = 'N'
                                AND VALOR_IMPOSTO_NFE(I.CDFILIAL,I.NRLANCTONF,'03','I','1') = 0
                              GROUP BY DECODE(N.IDENTRSAIDOP, 'E', '0','1'), I.CDFILIAL, I.NRLANCTONF, N.IDENTRSAIDOP,
                                     N.NRNOTAFISC, NVL(SS.CDSERIENFE,N.CDSERIE), NVL(SE.CDSERIEENTRNFE,N.CDSERIEENTR), N.NRINSJURNF, N.IDSTATUS, N.DTENTRSAID, NRACESSONFE,
                                     N.VRNOTAFISC, TO_CHAR(N.VRPRODUTOS), N.IDPGTOFRETE, N.DTEMISSAO , N.CDMODDOCFISC, N.CDCLIENTE,
                                     N.CDFORNECED, N.IDORIGDESTNF, N.CDFILIEMIT, N.CDFILIRECE, N.NRINSJURTRAN, N.IDTPIJURTRAN, N.VRPBRUTOVOLU, N.VRPLIQUVOLU,
                                     N.NRPLACAVEIC, N.DSQTDEVOLU, N.DSESPECVOLU, N.DSMARCAVOLU, N.DSNUMEVOLU, NRACESSONFE, N.NRNOTAFISCALELE, N.CDTIPOOPER, IDSTATUSNFE,
                                     DECODE(N.IDORIGDESTNF,'F',PF.IDSIMPLESNACIONAL,'N')
                              UNION ALL
                              /*NF ENTRADA COM CARGA TRIBUTÁRIA*/
                              SELECT DECODE(N.IDENTRSAIDOP, 'E', '0','1') AS CAMPO2,
                                     DECODE(N.IDENTRSAIDOP, 'E', DECODE(IDSTATUSNFE,'A','0',DECODE(IDSTATUS,'E','0','1')), '0') AS CAMPO3, NRACESSONFE,
                                     I.CDFILIAL, I.NRLANCTONF, N.IDENTRSAIDOP, N.NRNOTAFISC, NVL(SS.CDSERIENFE,N.CDSERIE) AS CDSERIE, NVL(SE.CDSERIEENTRNFE,N.CDSERIEENTR) AS CDSERIEENTR,
                                     N.NRINSJURNF, N.IDSTATUS, N.DTENTRSAID, N.VRNOTAFISC, TO_CHAR(N.VRPRODUTOS) AS VRPRODUTOS, N.IDPGTOFRETE,
                                     N.NRPLACAVEIC, N.DSQTDEVOLU, N.DSESPECVOLU, N.DSMARCAVOLU, N.DSNUMEVOLU,
                                     N.CDFILIEMIT, N.CDFILIRECE, N.DTEMISSAO, MAX(I.CDFISCOPERNF) AS CDFISCOPERNF, N.CDMODDOCFISC, N.CDCLIENTE, N.CDFORNECED, N.IDORIGDESTNF,
                                     TO_CHAR(SUM(I.VRCONTABILNF)) AS VRCONTABILNF, N.NRINSJURTRAN, N.IDTPIJURTRAN, N.VRPBRUTOVOLU, N.VRPLIQUVOLU,
                                     TO_CHAR(SUM(DECODE(I.CDFISCALNF,'1',I.VRBASECALCNF,0)+DECODE(V_IDTPCARGATRIB,'O',0,CASE WHEN V_SGESTADO <> 'SP' THEN VALOR_IMPOSTO_NFE(I.CDFILIAL,I.NRLANCTONF,'03','B','1') ELSE 0 END))) AS VRBASECALCNF,
                                     TO_CHAR(SUM(DECODE(I.CDFISCALNF,'1',I.VRIMPOSTONF, 0)+DECODE(V_IDTPCARGATRIB,'O',0,CASE WHEN V_SGESTADO <> 'SP' THEN VALOR_IMPOSTO_NFE(I.CDFILIAL,I.NRLANCTONF,'03','I','1') ELSE 0 END))) AS VRIMPOSTONF,
                                     TO_CHAR(SUM(DECODE(I.CDFISCALNF,'3',I.VRCONTABILNF,0)))   AS VROUTRCRED,
                                     TO_CHAR(SUM(DECODE(I.CDFISCALNF,'2',I.VRCONTABILNF,'1',DECODE(I.VRPERREDBCNF,0, 0,I.VRCONTABILNF-I.VRBASECALCNF), 0))) AS VRISENTRIB,
                                     N.NRNOTAFISCALELE, N.CDTIPOOPER, N.IDSTATUSNFE, DECODE(N.IDORIGDESTNF,'F',PF.IDSIMPLESNACIONAL,'N') AS IDSIMPLESNACIONAL,
                                     MAX((SELECT COUNT(DISTINCT NRPARCELAPAG)
                                            FROM CONTAPAGAR C
                                           WHERE N.CDFILIAL = C.CDFILIAL
                                             AND N.NRLANCTONF = C.NRLANCTONF
                                             AND C.NRLANBOLPAG IS NOT NULL)) AS QTDEPARC
                              FROM NOTAFISCAL N, IMPOSTONF I, IMPOSTO IP, PARAMFORNE PF, SERIENF SS, SERIEENTR SE
                              WHERE N.NRSEQUMAPAPUSN  = V_NRSEQUMAPAPU
                                AND N.CDINSCESTA      = P_CDINSCESTA
                                AND IP.CDIMPOSTONFE   = P_CDIMPOSTO
                                AND IP.CDIMPOSTO      = I.CDIMPOSTO
                                AND (NVL(N.IDSISTEMA,'DFS')  <> 'REC'
                                AND NVL(N.IDSISTEMA, 'DFS')  <> 'PAG'
                                AND NVL(N.IDSISTEMA, 'DFS')  <> 'CMP'
                                AND NVL(N.IDSISTEMA, 'DFS')  <> 'SUP'
                                AND NVL(N.IDSISTEMA, 'DFS')  <> 'TMP'
                                AND NVL(N.IDSISTEMA, 'DFS')  <> 'FIS')
                                AND SE.CDSERIEENTR(+) = N.CDSERIEENTR
                                AND SS.CDEMPRESA(+)   = N.CDEMPRESA
                                AND SS.CDINSCESTA(+)  = N.CDINSCESTA
                                AND SS.CDINSCMUNI(+)  = N.CDINSCMUNI
                                AND SS.CDSERIE(+)     = N.CDSERIE
                                AND N.IDENTRSAIDOP    = 'E'
                                AND PF.CDFORNECED(+)  = N.CDFORNECED
                                AND NVL(I.IDIMPOSTONF, '1') <> '3'
                                AND N.CDFILIAL        = I.CDFILIAL
                                AND N.NRLANCTONF      = I.NRLANCTONF
                                AND ((N.IDSTATUS = 'A') OR (N.IDSTATUS = 'E'))
                                AND N.CDMODDOCFISC IN ('01','1B','04','55')
                                AND NVL(P_GERAFORSALE,'N') = 'N'
                                AND VALOR_IMPOSTO_NFE(I.CDFILIAL,I.NRLANCTONF,'03','I','1') > 0
                              GROUP BY DECODE(N.IDENTRSAIDOP, 'E', '0','1'), I.CDFILIAL, I.NRLANCTONF, N.IDENTRSAIDOP,
                                     N.NRNOTAFISC, NVL(SS.CDSERIENFE,N.CDSERIE), NVL(SE.CDSERIEENTRNFE,N.CDSERIEENTR), N.NRINSJURNF, N.IDSTATUS, N.DTENTRSAID, NRACESSONFE,
                                     N.VRNOTAFISC, TO_CHAR(N.VRPRODUTOS), N.IDPGTOFRETE, N.DTEMISSAO , N.CDMODDOCFISC, N.CDCLIENTE,
                                     N.CDFORNECED, N.IDORIGDESTNF, N.CDFILIEMIT, N.CDFILIRECE, N.NRINSJURTRAN, N.IDTPIJURTRAN, N.VRPBRUTOVOLU, N.VRPLIQUVOLU,
                                     N.NRPLACAVEIC, N.DSQTDEVOLU, N.DSESPECVOLU, N.DSMARCAVOLU, N.DSNUMEVOLU, NRACESSONFE, N.NRNOTAFISCALELE, N.CDTIPOOPER, IDSTATUSNFE,
                                     DECODE(N.IDORIGDESTNF,'F',PF.IDSIMPLESNACIONAL,'N')
                              UNION
                              /*******NOTAS FISCAIS FORSALE - C100 FOS ***********/
                              SELECT DECODE(NF.IDENTRSAIDOP, 'E', '0','1') AS CAMPO2,
                                     DECODE(NF.IDENTRSAIDOP, 'E', DECODE(IDSTATUS,'E','0','1'), '0') AS CAMPO3, NRACESSONFE,
                                     NF.CDFILIAL, NF.NRLANCTONF, NF.IDENTRSAIDOP, NF.NRNOTAFISC, NF.CDSERIE, NF.CDSERIEENTR,
                                     NF.NRINSJURNF, NF.IDSTATUS, NF.DTENTRSAID, NF.VRNOTAFISC, TO_CHAR(NF.VRPRODUTOS) AS VRPRODUTOS, NF.IDPGTOFRETE,
                                     NF.NRPLACAVEIC, NF.DSQTDEVOLU, NF.DSESPECVOLU, NF.DSMARCAVOLU, NF.DSNUMEVOLU,
                                     NF.CDFILIEMIT, NF.CDFILIRECE, NF.DTEMISSAO, MAX(NF.CDFISCOPERNF) AS CDFISCOPERNF, NF.CDMODDOCFISC, NF.CDCLIENTE, NF.CDFORNECED, NF.IDORIGDESTNF,
                                     NF.VRCONTABILNF AS VRCONTABILNF,
                                     NF.NRINSJURTRAN, NF.IDTPIJURTRAN, NF.VRPBRUTOVOLU, NF.VRPLIQUVOLU,
                                     TO_CHAR(VRBASECALCNF) AS VRBASECALCNF,
                                     TO_CHAR(VRIMPOSTONF),
                                     TO_CHAR(VROUTRCRED),
                                     TO_CHAR(VRISENTRIB),
                                     NF.NRNOTAFISCALELE,
                                     NF.CDTIPOOPER, '' AS IDSTATUSNFE, NF.IDSIMPLESNACIONAL, NF.QTDEPARC
                               FROM  ENDECLIE EC, ENDEFORN EF, ENDEFILI EFI,
                                (SELECT DECODE(NVL(N.IDORIGDESTNF,DECODE(N.IDENTRSAIDOP,'S','C','F')),'C',CL.NRINSJURCLIE,'F',FO.NRINSJURFORN,'L',FI.NRINSJURFILI) AS NRINSJURNF,
                                        DECODE(NVL(N.IDORIGDESTNF,DECODE(N.IDENTRSAIDOP,'S','C','F')),'C',CL.NRINSESTCLIE,'F',FO.NRINSESTFORN,'L',FI.CDINSCESTA  ) AS NRINSEST,
                                        N.IDORIGDESTNF, N.CDCLIENTE, N.CDFORNECED, N.CDFILIEMIT, N.CDFILIRECE, N.NRNOTAFISC, I.CDFISCOPERNF,
                                        N.NRLANCTONF,N.CDFILIAL, N.IDENTRSAIDOP, DECODE(N.CDMODDOCFISC,'2D','55',N.CDMODDOCFISC) AS CDMODDOCFISC,
                                        NVL(SS.CDSERIENFE,N.CDSERIE) AS CDSERIE, NVL(SE.CDSERIEENTRNFE,N.CDSERIEENTR) AS CDSERIEENTR, N.DTENTRSAID, N.DTEMISSAO,
                                        TO_CHAR(SUM(VRCONTABILNF)) AS VRCONTABILNF,
                                        DECODE(I.CDFISCALNF,'1',SUM(VRBASECALCNF),0) AS VRBASECALCNF,
                                        DECODE(I.CDFISCALNF,'2',SUM(VRCONTABILNF),'1',SUM(DECODE(I.VRPERREDBCNF,0, 0,I.VRCONTABILNF-I.VRBASECALCNF)),0) AS VRISENTRIB,
                                        DECODE(I.CDFISCALNF,'3',SUM(VRCONTABILNF),0) AS VROUTRCRED,
                                        DECODE(I.CDFISCALNF,'1',SUM(VRIMPOSTONF ),0) AS VRIMPOSTONF,
                                        SUM(N.VRPRODUTOS) AS VRPRODUTOS,
                                        N.NRINSJURTRAN,N.IDTPIJURTRAN, N.VRPBRUTOVOLU, N.VRPLIQUVOLU, N.NRNOTAFISCALELE, I.VRPERREDBCNF,N.IDSTATUS,N.IDPGTOFRETE,
                                        N.NRPLACAVEIC, N.DSQTDEVOLU, N.DSESPECVOLU, N.DSMARCAVOLU, N.DSNUMEVOLU,N.VRNOTAFISC, NRACESSONFE, N.CDTIPOOPER,
                                        DECODE(N.IDORIGDESTNF,'F',PF.IDSIMPLESNACIONAL,'S') AS IDSIMPLESNACIONAL,
                                        MAX((SELECT COUNT(DISTINCT NRPARCELAREC)
                                               FROM CONTARECEBER C
                                              WHERE N.CDFILIAL    = C.CDFILIAL
                                                AND N.NRLANCTONF  = C.NRLANCTONF
                                                AND C.NRLANBOLREC IS NOT NULL)) AS QTDEPARC
                                   FROM NOTAFISCAL N, IMPOSTONF I, IMPOSTO IMP, CLIENTE CL, FORNECEDOR FO, FILIAL FI, PARAMFORNE PF, SERIENF SS, SERIEENTR SE
                                  WHERE N.CDFILIAL     = I.CDFILIAL
                                    AND N.NRLANCTONF   = I.NRLANCTONF
                                    AND IMP.CDIMPOSTO  = I.CDIMPOSTO
                                    AND N.CDCLIENTE    = CL.CDCLIENTE(+)
                                    AND N.CDFORNECED   = FO.CDFORNECED(+)
                                    AND N.CDFORNECED   = PF.CDFORNECED(+)
                                    AND N.CDFILIRECE   = FI.CDFILIAL(+)
                                    AND N.CDFILIEMIT   = FI.CDFILIAL(+)
                                    AND DTEMISSAO BETWEEN P_DTINICIAL AND P_DTFINAL
                                    AND ((N.IDSTATUS   = 'A' OR N.IDSTATUS = 'E') OR (N.IDSTATUSNFE = 'A' OR N.IDSTATUSNFE = 'T'))
                                    AND N.CDINSCESTA   = P_CDINSCESTA
                                    AND IMP.CDIMPOSTONFE = P_CDIMPOSTO
                                    AND (I.IDIMPOSTONF <> '3' OR IDIMPOSTONF IS NULL)
                                    AND (NVL(N.IDSISTEMA, 'DFS') <> 'REC'
                                    AND NVL(N.IDSISTEMA, 'DFS')  <> 'PAG'
                                    AND NVL(N.IDSISTEMA, 'DFS')  <> 'CMP'
                                    AND NVL(N.IDSISTEMA, 'DFS')  <> 'SUP'
                                    AND NVL(N.IDSISTEMA, 'DFS')  <> 'TMP'
                                    AND NVL(N.IDSISTEMA, 'DFS')  <> 'FIS')
                                    AND SE.CDSERIEENTR(+) = N.CDSERIEENTR
                                    AND SS.CDEMPRESA(+)   = N.CDEMPRESA
                                    AND SS.CDINSCESTA(+)  = N.CDINSCESTA
                                    AND SS.CDINSCMUNI(+)  = N.CDINSCMUNI
                                    AND SS.CDSERIE(+)     = N.CDSERIE
                                    AND N.CDMODDOCFISC IN ('01','1B','04','55','2D')
                                    AND N.IDENTRSAIDOP = 'S'
                                    AND NVL(P_GERAFORSALE,'N') = 'S'
                                  GROUP BY DECODE(NVL(N.IDORIGDESTNF,DECODE(N.IDENTRSAIDOP,'S','C','F')),'C',CL.NRINSJURCLIE,'F',FO.NRINSJURFORN,'L',FI.NRINSJURFILI),
                                           DECODE(NVL(N.IDORIGDESTNF,DECODE(N.IDENTRSAIDOP,'S','C','F')),'C',CL.NRINSESTCLIE,'F',FO.NRINSESTFORN,'L',FI.CDINSCESTA),N.IDORIGDESTNF,
                                           N.CDCLIENTE, N.CDFORNECED, N.CDFILIEMIT, N.CDFILIRECE, N.NRNOTAFISC, I.CDFISCOPERNF, N.NRLANCTONF,
                                           N.CDFILIAL, N.IDENTRSAIDOP, N.CDMODDOCFISC, NVL(SS.CDSERIENFE,N.CDSERIE), NVL(SE.CDSERIEENTRNFE,N.CDSERIEENTR),
                                           N.DTENTRSAID, N.DTEMISSAO,  I.CDFISCALNF, N.NRINSJURTRAN, N.IDTPIJURTRAN, N.VRPBRUTOVOLU,
                                           N.VRPLIQUVOLU,N.NRNOTAFISCALELE,I.VRPERREDBCNF,N.IDSTATUS,IDPGTOFRETE,
                                           N.NRPLACAVEIC, N.DSQTDEVOLU, N.DSESPECVOLU, N.DSMARCAVOLU, N.DSNUMEVOLU,N.VRNOTAFISC,NRACESSONFE,N.CDTIPOOPER,DECODE(N.IDORIGDESTNF,'F',PF.IDSIMPLESNACIONAL,'S'))NF
                              WHERE NF.CDCLIENTE    = EC.CDCLIENTE(+)
                                AND NF.CDFORNECED   = EF.CDFORNECED(+)
                                AND NF.CDFILIEMIT   = EFI.CDFILIAL(+)
                                AND NF.CDFILIRECE   = EFI.CDFILIAL(+)
                                AND IDTPENDECLIE(+) = 'P'
                                AND IDTPENDEFORN(+) = 'P'
                                AND IDTPENDEFILI(+) = 'P'
                                AND NVL(P_GERAFORSALE,'N') = 'S'
                              GROUP BY DECODE(NF.IDENTRSAIDOP, 'E', '0','1'),
                                       DECODE(NF.IDENTRSAIDOP, 'E', DECODE(IDSTATUS,'E','0','1'), '0'), NRACESSONFE,
                                       NF.CDFILIAL, NF.NRLANCTONF, NF.IDENTRSAIDOP, NF.NRNOTAFISC, NF.CDSERIE, NF.CDSERIEENTR,
                                       NF.NRINSJURNF, NF.IDSTATUS, NF.DTENTRSAID, NF.VRNOTAFISC, TO_CHAR(NF.VRPRODUTOS), NF.IDPGTOFRETE,
                                       NF.NRPLACAVEIC, NF.DSQTDEVOLU, NF.DSESPECVOLU, NF.DSMARCAVOLU, NF.DSNUMEVOLU,
                                       NF.CDFILIEMIT, NF.CDFILIRECE, NF.DTEMISSAO, NF.CDMODDOCFISC, NF.CDCLIENTE, NF.CDFORNECED, NF.IDORIGDESTNF,
                                       NF.VRCONTABILNF, NF.NRINSJURTRAN, NF.IDTPIJURTRAN, NF.VRPBRUTOVOLU, NF.VRPLIQUVOLU,
                                       TO_CHAR(VRBASECALCNF), TO_CHAR(VRIMPOSTONF), TO_CHAR(VROUTRCRED), TO_CHAR(VRISENTRIB),
                                       NF.NRNOTAFISCALELE,NF.CDTIPOOPER,NF.IDSIMPLESNACIONAL, NF.QTDEPARC)NF )LOOP
           IF C_REGC100.IDSTATUS = 'C' THEN
              V_DADOS_2 := '|';
           ELSE
              IF C_REGC100.IDENTRSAIDOP = 'E' THEN
                 V_DADOS_2 := TO_CHAR(C_REGC100.DTENTRSAID,'ddmmyyyy') || '|';
              ELSE
                 V_DADOS_2 := TO_CHAR(C_REGC100.DTEMISSAO,'ddmmyyyy') || '|';
              END IF;
           END IF;
          V_VRDEBESP := 0;
          /* valor total de imposto fora do periodo - nf saida */
          V_VRFORAPER := 0;
          IF (C_REGC100.SITU_DOC IN ('01', '07')) AND (C_REGC100.IDENTRSAIDOP = 'S') THEN
             BEGIN
                SELECT SUM(VRIMPOSTONF)
                INTO V_VRFORAPER
                FROM IMPOSTONF
                WHERE CDFILIAL = C_REGC100.CDFILIAL
                  AND NRLANCTONF = C_REGC100.NRLANCTONF
                  AND CDFISCALNF = '1'
                  AND NVL(IDIMPOSTONF,'1') <> '3';
             EXCEPTION
                WHEN NO_DATA_FOUND THEN
                   V_VRFORAPER := 0;
             END;
             V_TOTFORPER_S :=  NVL(V_TOTFORPER_S,0)+NVL(V_VRFORAPER,0);
          END IF;

          INSERT INTO ARQMAGNETICO
            (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
          VALUES
            ('19'||LPAD(RTRIM(V_CONTREGC), 8, '0'), C_REGC100.DADOS_1||V_DADOS_2||C_REGC100.DADOS_3, P_NRSEQARQMAG);
          V_CONTREGC :=  NVL(V_CONTREGC,0) + 1;
          V_SEQUENCIAL := LPAD(RTRIM(TO_CHAR(TO_NUMBER('1'))),3,'0');

          /* CODIGO DO PARTICIPANTE */
          SELECT MAX(CDCHAVEREG)
            INTO V_COD_PAR
            FROM TMP_REGDADOSSPED
           WHERE CDCHAVEREG = C_REGC100.COD_PAR
             AND CDREGISTRO = '0150';

          IF (V_COD_PAR IS NULL) AND (C_REGC100.COD_PAR IS NOT NULL) THEN
             V_SEQUPROD := NVL(V_SEQUPROD,0) + 1;
             INSERT INTO TMP_REGDADOSSPED
               (CDREGISTRO, CDCONTREGI, CDCHAVEREG)
             VALUES
               ('0150', V_SEQUPROD, C_REGC100.COD_PAR);
          END IF;
          V_COD_PAR := NULL;
          /*REGISTRO C110 - OBSERVAÇÃO DO DOCUMENTO*/
          FOR C_REGC110 IN (SELECT '|C110'                                  ||'|'||
                                   LPAD(RTRIM(TO_CHAR(V_SEQADIC)),6,'0')    ||'|'||
                                   'CUPOM FISCAL REFERENCIADO - COO NÚMERO '||TRIM(D.NRCOOCUPOMNF)||'|'  AS DSREGC110,
                                   '|C114'                                  ||'|'||
                                   '2D'                                     ||'|'||
                                   SUBSTR(D.NRSERIEIMPNF,1,21)              ||'|'||
                                   SUBSTR(LPAD(D.NRCOOCUPOMNF,10,'0'),5,6)  ||'|'||
                                   TO_CHAR(C_REGC100.DTEMISSAO,'DDMMYYYY')  ||'|' AS DSREGC114
                              FROM DADOSNF D, NOTAFISCAL N
                             WHERE D.NRLANCTONF  = C_REGC100.NRLANCTONF
                               AND D.CDFILIAL    = C_REGC100.CDFILIAL
                               AND D.NRECFCUPOMNF IS NOT NULL
                               AND D.NRLANCTONF  = N.NRLANCTONF
                               AND D.CDFILIAL    = N.CDFILIAL
                               AND NOT ((N.IDSTATUSNFE = 'A') OR (N.CDMODDOCFISC = '55')))LOOP

             INSERT INTO ARQMAGNETICO
                (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
              VALUES ('19'||LPAD(RTRIM(V_CONTREGC), 8, '0'), C_REGC110.DSREGC110 , P_NRSEQARQMAG);
                   V_CONTREGC :=  NVL(V_CONTREGC,0) + 1;
                   V_SEQUENCIAL := LPAD(RTRIM(TO_CHAR(TO_NUMBER('1'))),3,'0');

             /*REGISTRO C114 - CUPOM FISCAL REFERENCIADO*/
             INSERT INTO ARQMAGNETICO
                (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
              VALUES ('19'||LPAD(RTRIM(V_CONTREGC), 8, '0'), C_REGC110.DSREGC114 , P_NRSEQARQMAG);
                   V_CONTREGC :=  NVL(V_CONTREGC,0) + 1;
                   V_SEQUENCIAL := LPAD(RTRIM(TO_CHAR(TO_NUMBER('1'))),3,'0');
              V_SEQADIC := V_SEQADIC +1;
          END LOOP;

          /*REGISTRO C110 - OBSERVAÇÃO DO DOCUMENTO -- DADOSADIC*/
          FOR C_REGC110 IN (SELECT D.DSDADOADIC AS DSREGC110
                              FROM DADOSADIC D, NOTAFISCAL N
                             WHERE D.NRLANCTONF  = C_REGC100.NRLANCTONF
                               AND D.CDFILIAL    = C_REGC100.CDFILIAL
                               AND D.NRLANCTONF  = N.NRLANCTONF
                               AND D.CDFILIAL    = N.CDFILIAL
                               AND NOT ((N.IDSTATUSNFE = 'A') OR (N.CDMODDOCFISC = '55')))LOOP
             V_SEQUPROD := NVL(V_SEQUPROD,0) + 1;

             INSERT INTO ARQMAGNETICO (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
             VALUES ('19'||LPAD(RTRIM(V_CONTREGC), 8, '0'), '|C110|'||LPAD(RTRIM(TO_CHAR(V_SEQADIC)),6,'0')||'|'||TRIM(SUBSTR(C_REGC110.DSREGC110, 0,499))||'|', P_NRSEQARQMAG);
             V_CONTREGC :=  NVL(V_CONTREGC,0) + 1;
             V_SEQUENCIAL := LPAD(RTRIM(TO_CHAR(TO_NUMBER('1'))),3,'0');

             INSERT INTO TMP_REGDADOSSPED (CDREGISTRO, CDCONTREGI, CDCHAVEREG, CDCAMPO1)
             VALUES ('0450', V_SEQUPROD, LPAD(RTRIM(TO_CHAR(V_SEQADIC)),6,'0'), TRIM(SUBSTR(C_REGC110.DSREGC110, 0, 499)));
             V_SEQUENCIAL := LPAD(RTRIM(TO_CHAR(TO_NUMBER('1'))),3,'0');
             V_SEQADIC := V_SEQADIC +1;
          END LOOP;

          /*QUANDO A OPERAÇÃO FOR A PRAZO PARA AS ENTRADAS NOS MODELOS 1 E 1A DEVER SER GERADOS OS REGISTROS REFERENTES A FATURA*/
          IF (C_REGC100.CDMODDOCFISC IN ('01','1A')) AND (C_REGC100.QTDEPARC > 1) THEN
             /*REGISTRO C140*/
             FOR C_REGC140 IN (SELECT '|C140'                                                               ||'|'||
                                      DECODE(N.IDENTRSAIDOP,'E','1','S','0')                                ||'|'||
                                      DECODE(F.IDTPTITULOCRED,'XX','',F.IDTPTITULOCRED)                     ||'|'||
                                      DECODE(F.IDTPTITULOCRED,'99',F.DSTPTITULOCRED,'')                     ||'|'||
                                      LTRIM(N.NRNOTAFISC,'0')                                               ||'|'||
                                      LPAD(RTRIM(TO_CHAR(C_REGC100.QTDEPARC)),2,'0')                        ||'|'||
                                      REPLACE(LTRIM(TO_CHAR(SUM(C.VRORIGPAG),'999999999990.00')), '.', ',') ||'|' AS DSREG_C140
                                 FROM NOTAFISCAL N, FORNECEDOR F, CONTAPAGAR C
                                WHERE N.CDFILIAL   = C_REGC100.CDFILIAL
                                  AND N.NRLANCTONF = C_REGC100.NRLANCTONF
                                  AND N.CDFORNECED = F.CDFORNECED
                                  AND N.CDFILIAL   = C.CDFILIAL
                                  AND N.NRLANCTONF = C.NRLANCTONF
                                GROUP BY N.IDENTRSAIDOP, F.IDTPTITULOCRED, F.DSTPTITULOCRED,
                                      N.NRNOTAFISC, C_REGC100.QTDEPARC) LOOP

                INSERT INTO ARQMAGNETICO
                   (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
                VALUES
                   ('19'||LPAD(RTRIM(V_CONTREGC), 8, '0'), C_REGC140.DSREG_C140, P_NRSEQARQMAG);
                V_CONTREGC   := NVL(V_CONTREGC,0) + 1;
             END LOOP;

             /*REGISTRO C141*/
             FOR C_REGC141 IN (SELECT '|C141'                                                               ||'|'||
                                      LPAD(RTRIM(TO_CHAR(C.NRPARCELAPAG)),2,'0')                            ||'|'||
                                      TO_CHAR(C.DTORIGVENPAG,'DDMMYYYY')                                    ||'|'||
                                      REPLACE(LTRIM(TO_CHAR(SUM(C.VRORIGPAG),'999999999990.00')), '.', ',') ||'|' AS DSREG_C141
                                 FROM CONTAPAGAR C
                                WHERE C.CDFILIAL   = C_REGC100.CDFILIAL
                                  AND C.NRLANCTONF = C_REGC100.NRLANCTONF
                                GROUP BY C.NRPARCELAPAG, C.DTORIGVENPAG
                                ORDER BY C.NRPARCELAPAG) LOOP

                INSERT INTO ARQMAGNETICO
                   (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
                VALUES
                   ('19'||LPAD(RTRIM(V_CONTREGC), 8, '0'), C_REGC141.DSREG_C141, P_NRSEQARQMAG);
                V_CONTREGC   := NVL(V_CONTREGC,0) + 1;
             END LOOP;
          END IF;

          BEGIN
            SELECT IDATUESTTPOP
              INTO V_IDATUESTTPOP
              FROM TIPOOPERAC
             WHERE CDTIPOOPER   = C_REGC100.CDTIPOOPER
               AND IDENTRSAIDOP = C_REGC100.IDENTRSAIDOP;
          EXCEPTION
             WHEN NO_DATA_FOUND THEN
                V_IDATUESTTPOP := 'N';
          END;

          /*REGISTRO C170*/
          FOR C_REGC170 IN (SELECT COD_ITEM       || '|' ||
                                  DESCR_COMPL    || '|' ||
                                  QTD            || '|' ||
                                  UNID           || '|' ||
                                  VL_ITEM        || '|' ||
                                  VL_DESC        || '|' ||
                                  IND_MOV        || '|' ||
                                  CST_ICMS       || '|' ||
                                  CFOP           || '|' ||
                                  CFOP           || '|' || -- natureza da operacao campo 12
                                  VL_BC_ICMS     || '|' ||
                                  ALIQ_ICMS      || '|' ||
                                  VL_ICMS        || '|' ||
                                  VL_BC_ICMS_ST  || '|' || --16
                                  ALIQ_ST        || '|' || --17
                                  VL_ICMS_ST     || '|' || --18
                                  ''             || '|' || -- indicador de apurao do IPI CAMPO 19
                                  CST_IPI        || '|' || -- cst ipi campo 20
                                  '' 		       || '|' || -- Cdigo enquadramento IPI campo 21
                                  VL_BC_IPI      || '|' || --22
                                  ALIQ_IPI       || '|' || --23
                                  VL_IPI         || '|' || --24
                                  CST_PIS        || '|' || -- cst pis   campo 25
                                  VL_BC_PIS      || '|' ||
                                  ALIQ_PIS       || '|' ||
                                  ''  			    || '|' || -- quantidade base de calculo
                                  ''             || '|' || -- aliquota pis quantidade
                                  VL_PIS         || '|' ||
                                  CST_COFINS     || '|' || -- cst cofins campo 31
                                  VL_BC_COFINS   || '|' ||
                                  ALIQ_COFINS    || '|' ||
                                  ''    	       || '|' || -- quantidade base de calculo
                                  ''             || '|' || -- aliquota cofins quantidade
                                  VL_COFINS      || '|' ||
                                  COD_CTA        || '|' ||
                                  CASE WHEN P_VERSAO >= '013' THEN VL_ABAT_NT || '|' ELSE '' END AS ARQ_C170,  -- codigo da conta analitica contabil deb/cred
                                  CDPRODUTO, UNID, CFOP AS CDFISCOPERIT, DSCDFISOPEIT, CDCLASFISC, COD_CTA
                             FROM (/* NOTAS NÃO ELETRÓNICAS SEM CARGA TRIBUTÁRIA */
                                   SELECT PR.CDARVPROD AS COD_ITEM,
                                           DECODE(C_REGC100.IDENTRSAIDOP, 'E', TRIM(RETIRA_CARACTER_ESPECIAL(IT.DSPRODEMIS, 'S'))) AS DESCR_COMPL,
                                           REPLACE(LTRIM(TO_CHAR(ROUND(IT.QTITEMPROD,3), '999999999990.000')), '.', ',') AS QTD,
                                           PR.SGUNIDADE  AS UNID,
                                           REPLACE(LTRIM(TO_CHAR(ROUND(IT.VRTOTAITEM,2), '999999999990.00')), '.', ',') AS VL_ITEM,
                                           REPLACE(LTRIM(TO_CHAR(ROUND(NVL(IT.VRENCARGODESC,0),2), '999999999990.00')), '.', ',') AS VL_DESC,
                                           DECODE(NVL(V_IDATUESTTPOP,'N'),'N','1','0') AS IND_MOV,
                                           LPAD(NVL(IP.CDSITUTRIBIT,0),3,'0') AS CST_ICMS,
                                           IP.CDFISCOPERIT AS CFOP,
                                           REPLACE(LTRIM(TO_CHAR(ROUND(DECODE(IP.CDFISCALIT, '1', IP.VRBASECALCIT, 0),2), '999999999990.00')), '.', ',') AS VL_BC_ICMS,
                                           REPLACE(LTRIM(TO_CHAR(ROUND(DECODE(IP.CDFISCALIT, '1', IP.VRALIQITEM, 0),2), '999999999990.00')), '.', ',')   AS ALIQ_ICMS,
                                           REPLACE(LTRIM(TO_CHAR(ROUND(DECODE(IP.CDFISCALIT, '1', IP.VRIMPOSTOIT, 0),2), '999999999990.00')), '.', ',')  AS VL_ICMS,
                                           REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_CDIMPOSTRIB, 'B','1'),2), '999999999990.00')), '.', ',') AS VL_BC_ICMS_ST,
                                           REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_CDIMPOSTRIB, 'A','1') + VALOR_FECP_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_CDIMPOSTRIB, 'A','1'),2), '999999999990.00')), '.', ',') AS ALIQ_ST,
                                           REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_CDIMPOSTRIB, 'I','1') + VALOR_FECP_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_CDIMPOSTRIB, 'I','1'),2), '999999999990.00')), '.', ',') AS VL_ICMS_ST,
                                           (SELECT MAX(CDSITUTRIBITNFE)
                                              FROM ITEMPROIMPOS N, IMPOSTO IM
                                             WHERE IP.CDFILIAL     = N.CDFILIAL
                                               AND IP.NRLANCTONF   = N.NRLANCTONF
                                               AND IP.NRSEQITPROD  = N.NRSEQITPROD
                                               AND IM.CDIMPOSTO    = N.CDIMPOSTO
                                               AND N.NRITPROIMPOS  = '1'
                                               AND IM.CDIMPOSTONFE = V_IPI) AS CST_IPI,
                                           REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_IPI, 'B','1'),2), '999999999990.00')), '.', ',') AS VL_BC_IPI,
                                           REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_IPI, 'A','1'),2), '999999999990.00')), '.', ',') AS ALIQ_IPI,
                                           REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_IPI, 'I','1'),2), '999999999990.00')), '.', ',') AS VL_IPI,
                                           (SELECT MAX(CDSITUTRIBITNFE)
                                              FROM ITEMPROIMPOS N, IMPOSTO IM
                                             WHERE IP.CDFILIAL     = N.CDFILIAL
                                               AND IP.NRLANCTONF   = N.NRLANCTONF
                                               AND IP.NRSEQITPROD  = N.NRSEQITPROD
                                               AND IM.CDIMPOSTO    = N.CDIMPOSTO
                                               AND N.NRITPROIMPOS  = '1'
                                               AND IM.CDIMPOSTONFE = V_PIS) AS CST_PIS,
                                           REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_PIS, 'B','1'),2), '999999999990.00')), '.', ',') AS VL_BC_PIS,
                                           REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_PIS, 'A','1'),2), '999999999990.00')), '.', ',') AS ALIQ_PIS,
                                           REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_PIS, 'I','1'),2), '999999999990.00')), '.', ',') AS VL_PIS,
                                           (SELECT MAX(CDSITUTRIBITNFE)
                                              FROM ITEMPROIMPOS N, IMPOSTO IM
                                             WHERE IP.CDFILIAL     = N.CDFILIAL
                                               AND IP.NRLANCTONF   = N.NRLANCTONF
                                               AND IP.NRSEQITPROD  = N.NRSEQITPROD
                                               AND IM.CDIMPOSTO    = N.CDIMPOSTO
                                               AND N.NRITPROIMPOS  = '1'
                                               AND IM.CDIMPOSTONFE = V_COFINS) AS CST_COFINS,
                                           REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_COFINS, 'B','1'),2), '999999999990.00')), '.', ',') AS VL_BC_COFINS,
                                           REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_COFINS, 'A','1'),2), '999999999990.00')), '.', ',') AS ALIQ_COFINS,
                                           REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_COFINS, 'I','1'),2), '999999999990.00')), '.', ',') AS VL_COFINS,
                                           CONTCTBL_SPED(C_REGC100.IDENTRSAIDOP, PR.CDPRODUTO, C_REGC100.CDTIPOOPER, C_REGC100.FILIAL)  AS COD_CTA,
                                           REPLACE(LTRIM(TO_CHAR(ROUND(DECODE(IP.IDIMPDESONERAIT,'S',NVL(IP.VRIMPOSTOIT,0),0),2), '999999999990.00')), '.', ',') AS VL_ABAT_NT,
                                           PR.CDPRODUTO, IT.DSCDFISOPEIT, IT.CDPRODNCMTRANS AS CDCLASFISC
                                   FROM ITEMPRODUTO IT, PRODUTO PR, ITEMPROIMPOS IP, IMPOSTO IM
                                   WHERE IT.CDFILIAL      = C_REGC100.CDFILIAL
                                     AND IT.NRLANCTONF    = C_REGC100.NRLANCTONF
                                     AND IM.CDIMPOSTONFE  = P_CDIMPOSTO
                                     AND IM.CDIMPOSTO     = IP.CDIMPOSTO
                                     AND IT.CDFILIAL      = IP.CDFILIAL
                                     AND IT.NRLANCTONF    = IP.NRLANCTONF
                                     AND IT.NRSEQITPROD   = IP.NRSEQITPROD
                                     AND IT.CDPRODUTO     = PR.CDPRODUTO
                                     AND IP.NRITPROIMPOS  =  '1'
                                     AND C_REGC100.CDMODDOCFISC <> '55'
                                     AND ROUND(IT.QTITEMPROD,3) > 0
                                     AND VALOR_IMPOSTO_NFE(IP.CDFILIAL,IP.NRLANCTONF,'03','I','1') = 0
                                   UNION ALL
                                   /* NOTAS NÃO ELETRÓNICAS COM CARGA TRIBUTÁRIA */
                                   SELECT PR.CDARVPROD AS COD_ITEM,
                                           DECODE(C_REGC100.IDENTRSAIDOP, 'E', TRIM(RETIRA_CARACTER_ESPECIAL(IT.DSPRODEMIS, 'S'))) AS DESCR_COMPL,
                                           REPLACE(LTRIM(TO_CHAR(ROUND(IT.QTITEMPROD,3), '999999999990.000')), '.', ',') AS QTD,
                                           PR.SGUNIDADE AS UNID,
                                           REPLACE(LTRIM(TO_CHAR(ROUND(IT.VRTOTAITEM,2), '999999999990.00')), '.', ',')  AS VL_ITEM,
                                           REPLACE(LTRIM(TO_CHAR(ROUND(NVL(IT.VRENCARGODESC,0),2), '999999999990.00')), '.', ',') AS VL_DESC,
                                           DECODE(NVL(V_IDATUESTTPOP,'N'),'N','1','0') AS IND_MOV,
                                           LPAD(NVL(IP.CDSITUTRIBIT,0),3,'0') AS CST_ICMS,
                                           IP.CDFISCOPERIT AS CFOP,
                                           REPLACE(LTRIM(TO_CHAR(ROUND(DECODE(IP.CDFISCALIT, '1', IP.VRBASECALCIT, 0) + DECODE(V_IDTPCARGATRIB,'O',0,CASE WHEN V_SGESTADO <> 'SP' THEN VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL,IP.NRLANCTONF,IP.NRSEQITPROD,'03','B','1') ELSE 0 END),2), '999999999990.00')), '.', ',') AS VL_BC_ICMS,
                                           REPLACE(LTRIM(TO_CHAR(ROUND(DECODE(IP.CDFISCALIT, '1', IP.VRALIQITEM, 0),2), '999999999990.00')), '.', ',') AS ALIQ_ICMS,
                                           REPLACE(LTRIM(TO_CHAR(ROUND(DECODE(IP.CDFISCALIT, '1', IP.VRIMPOSTOIT,  0) + DECODE(V_IDTPCARGATRIB,'O',0,DECODE(C_REGC100.IDENTRSAIDOP, 'S', VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL,IP.NRLANCTONF,IP.NRSEQITPROD,'03','I','1'), CASE WHEN V_SGESTADO <> 'SP' THEN VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL,IP.NRLANCTONF,IP.NRSEQITPROD,'03','I','1') ELSE 0 END)),2), '999999999990.00')), '.', ',') AS VL_ICMS,
                                           REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_CDIMPOSTRIB, 'B','1'),2), '999999999990.00')), '.', ',') AS VL_BC_ICMS_ST,
                                           REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_CDIMPOSTRIB, 'A','1') + VALOR_FECP_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_CDIMPOSTRIB, 'A','1'),2), '999999999990.00')), '.', ',') AS ALIQ_ST,
                                           REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_CDIMPOSTRIB, 'I','1') + VALOR_FECP_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_CDIMPOSTRIB, 'I','1'),2), '999999999990.00')), '.', ',') AS VL_ICMS_ST,
                                           (SELECT MAX(CDSITUTRIBITNFE)
                                              FROM ITEMPROIMPOS N, IMPOSTO IM
                                             WHERE IP.CDFILIAL     = N.CDFILIAL
                                               AND IP.NRLANCTONF   = N.NRLANCTONF
                                               AND IP.NRSEQITPROD  = N.NRSEQITPROD
                                               AND IM.CDIMPOSTO    = N.CDIMPOSTO
                                               AND N.NRITPROIMPOS  = '1'
                                               AND IM.CDIMPOSTONFE = V_IPI) AS CST_IPI,
                                           REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_IPI, 'B','1'),2), '999999999990.00')), '.', ',') AS VL_BC_IPI,
                                           REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_IPI, 'A','1'),2), '999999999990.00')), '.', ',') AS ALIQ_IPI,
                                           REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_IPI, 'I','1'),2), '999999999990.00')), '.', ',') AS VL_IPI,
                                           (SELECT MAX(CDSITUTRIBITNFE)
                                              FROM ITEMPROIMPOS N, IMPOSTO IM
                                             WHERE IP.CDFILIAL     = N.CDFILIAL
                                               AND IP.NRLANCTONF   = N.NRLANCTONF
                                               AND IP.NRSEQITPROD  = N.NRSEQITPROD
                                               AND IM.CDIMPOSTO    = N.CDIMPOSTO
                                               AND N.NRITPROIMPOS  = '1'
                                               AND IM.CDIMPOSTONFE = V_PIS) AS CST_PIS,
                                           REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_PIS, 'B','1'),2), '999999999990.00')), '.', ',') AS VL_BC_PIS,
                                           REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_PIS, 'A','1'),2), '999999999990.00')), '.', ',') AS ALIQ_PIS, 
                                           REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_PIS, 'I','1'),2), '999999999990.00')), '.', ',') AS VL_PIS,

                                           (SELECT MAX(CDSITUTRIBITNFE)
                                              FROM ITEMPROIMPOS N, IMPOSTO IM
                                             WHERE IP.CDFILIAL     = N.CDFILIAL
                                               AND IP.NRLANCTONF   = N.NRLANCTONF
                                               AND IP.NRSEQITPROD  = N.NRSEQITPROD
                                               AND IM.CDIMPOSTO    = N.CDIMPOSTO
                                               AND N.NRITPROIMPOS  = '1'
                                               AND IM.CDIMPOSTONFE = V_COFINS) AS CST_COFINS,
                                           REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_COFINS, 'B','1'),2), '999999999990.00')), '.', ',') AS VL_BC_COFINS,
                                           REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_COFINS, 'A','1'),2), '999999999990.00')), '.', ',') AS ALIQ_COFINS,
                                           REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_COFINS, 'I','1'),2), '999999999990.00')), '.', ',') AS VL_COFINS,
                                           CONTCTBL_SPED(C_REGC100.IDENTRSAIDOP, PR.CDPRODUTO, C_REGC100.CDTIPOOPER, C_REGC100.FILIAL)  AS COD_CTA,
                                           REPLACE(LTRIM(TO_CHAR(ROUND(DECODE(IP.IDIMPDESONERAIT,'S',NVL(IP.VRIMPOSTOIT,0),0),2), '999999999990.00')), '.', ',') AS VL_ABAT_NT,
                                           PR.CDPRODUTO, IT.DSCDFISOPEIT, IT.CDPRODNCMTRANS AS CDCLASFISC
                                   FROM ITEMPRODUTO IT, PRODUTO PR, ITEMPROIMPOS IP, IMPOSTO IM
                                   WHERE IT.CDFILIAL      = C_REGC100.CDFILIAL
                                     AND IT.NRLANCTONF    = C_REGC100.NRLANCTONF
                                     AND IM.CDIMPOSTONFE  = P_CDIMPOSTO
                                     AND IM.CDIMPOSTO     = IP.CDIMPOSTO
                                     AND IT.CDFILIAL      = IP.CDFILIAL
                                     AND IT.NRLANCTONF    = IP.NRLANCTONF
                                     AND IT.NRSEQITPROD   = IP.NRSEQITPROD
                                     AND IT.CDPRODUTO     = PR.CDPRODUTO
                                     AND IP.NRITPROIMPOS  =  '1'
                                     AND C_REGC100.CDMODDOCFISC <> '55'
                                     AND ROUND(IT.QTITEMPROD,3) > 0
                                     AND VALOR_IMPOSTO_NFE(IP.CDFILIAL,IP.NRLANCTONF,'03','I','1') > 0
                                   UNION ALL
                                   /* NOTAS DE ENTRADA ELETRÓNICAS SEM CARGA TRIBUTÁRIA */
                                   SELECT PR.CDARVPROD AS COD_ITEM,
                                           DECODE(C_REGC100.IDENTRSAIDOP, 'E', TRIM(RETIRA_CARACTER_ESPECIAL(IT.DSPRODEMIS, 'S'))) AS DESCR_COMPL,
                                           REPLACE(LTRIM(TO_CHAR(ROUND(IT.QTITEMPROD,3), '999999999990.000')), '.', ',') AS QTD,
                                           PR.SGUNIDADE AS UNID,
                                           REPLACE(LTRIM(TO_CHAR(ROUND(IT.VRTOTAITEM,2), '999999999990.00')), '.', ',') AS VL_ITEM,
                                           REPLACE(LTRIM(TO_CHAR(ROUND(NVL(IT.VRENCARGODESC,0),2), '999999999990.00')), '.', ',') AS VL_DESC,
                                           DECODE(NVL(V_IDATUESTTPOP,'N'),'N','1','0') AS IND_MOV,
                                           DECODE(C_REGC100.IDSIMPLESNACIONAL,'S',(DECODE(LENGTH(IT.CDFISCOPERSN),4,SUBSTR(IT.CDFISCOPERSN,2,3),LPAD(NVL(IT.CDFISCOPERSN,0),3,'0'))),LPAD(NVL(IP.CDSITUTRIBIT,0),3,'0')) AS CST_ICMS,
                                           IP.CDFISCOPERIT AS CFOP,
                                           REPLACE(LTRIM(TO_CHAR(ROUND(DECODE(IP.CDFISCALIT, '1', IP.VRBASECALCIT, 0),2), '999999999990.00')), '.', ',') AS VL_BC_ICMS,
                                           REPLACE(LTRIM(TO_CHAR(ROUND(DECODE(IP.CDFISCALIT, '1', IP.VRALIQITEM, 0),2), '999999999990.00')), '.', ',') AS ALIQ_ICMS,
                                           REPLACE(LTRIM(TO_CHAR(ROUND(DECODE(IP.CDFISCALIT, '1', IP.VRIMPOSTOIT, 0),2), '999999999990.00')), '.', ',') AS VL_ICMS,
                                           REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_CDIMPOSTRIB, 'B','1'),2), '999999999990.00')), '.', ',') AS VL_BC_ICMS_ST,
                                           REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_CDIMPOSTRIB, 'A','1') + VALOR_FECP_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_CDIMPOSTRIB, 'A','1'),2), '999999999990.00')), '.', ',') AS ALIQ_ST,
                                           REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_CDIMPOSTRIB, 'I','1') + VALOR_FECP_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_CDIMPOSTRIB, 'I','1'),2), '999999999990.00')), '.', ',') AS VL_ICMS_ST,
                                           (SELECT MAX(CDSITUTRIBITNFE)
                                              FROM ITEMPROIMPOS N, IMPOSTO IM
                                             WHERE IP.CDFILIAL     = N.CDFILIAL
                                               AND IP.NRLANCTONF   = N.NRLANCTONF
                                               AND IP.NRSEQITPROD  = N.NRSEQITPROD
                                               AND IM.CDIMPOSTO    = N.CDIMPOSTO
                                               AND N.NRITPROIMPOS  = '1'
                                               AND IM.CDIMPOSTONFE = V_IPI) AS CST_IPI,
                                           REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_IPI, 'B','1'),2), '999999999990.00')), '.', ',') AS VL_BC_IPI,
                                           REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_IPI, 'A','1'),2), '999999999990.00')), '.', ',') AS ALIQ_IPI,
                                           REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_IPI, 'I','1'),2), '999999999990.00')), '.', ',') AS VL_IPI,
                                           (SELECT MAX(CDSITUTRIBITNFE)
                                              FROM ITEMPROIMPOS N, IMPOSTO IM
                                             WHERE IP.CDFILIAL     = N.CDFILIAL
                                               AND IP.NRLANCTONF   = N.NRLANCTONF
                                               AND IP.NRSEQITPROD  = N.NRSEQITPROD
                                               AND IM.CDIMPOSTO    = N.CDIMPOSTO
                                               AND N.NRITPROIMPOS  = '1'
                                               AND IM.CDIMPOSTONFE = V_PIS) AS CST_PIS,
                                           REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_PIS, 'B','1'),2), '999999999990.00')), '.', ',') AS VL_BC_PIS,
                                           REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_PIS, 'A','1'),2), '999999999990.00')), '.', ',') AS ALIQ_PIS,
                                           REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_PIS, 'I','1'),2), '999999999990.00')), '.', ',') AS VL_PIS,
                                           (SELECT MAX(CDSITUTRIBITNFE)
                                              FROM ITEMPROIMPOS N, IMPOSTO IM
                                             WHERE IP.CDFILIAL     = N.CDFILIAL
                                               AND IP.NRLANCTONF   = N.NRLANCTONF
                                               AND IP.NRSEQITPROD  = N.NRSEQITPROD
                                               AND IM.CDIMPOSTO    = N.CDIMPOSTO
                                               AND N.NRITPROIMPOS  = '1'
                                               AND IM.CDIMPOSTONFE = V_COFINS) AS CST_COFINS,
                                           REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_COFINS, 'B','1'),2), '999999999990.00')), '.', ',') AS VL_BC_COFINS,
                                           REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_COFINS, 'A','1'),2), '999999999990.00')), '.', ',') AS ALIQ_COFINS,
                                           REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_COFINS, 'I','1'),2), '999999999990.00')), '.', ',') AS VL_COFINS,
                                           CONTCTBL_SPED(C_REGC100.IDENTRSAIDOP, PR.CDPRODUTO, C_REGC100.CDTIPOOPER, C_REGC100.FILIAL)  AS COD_CTA,
                                           REPLACE(LTRIM(TO_CHAR(ROUND(DECODE(IP.IDIMPDESONERAIT,'S',NVL(IP.VRIMPOSTOIT,0),0),2), '999999999990.00')), '.', ',') AS VL_ABAT_NT,
                                           PR.CDPRODUTO, IT.DSCDFISOPEIT, IT.CDPRODNCMTRANS AS CDCLASFISC
                                    FROM ITEMPRODUTO IT, PRODUTO PR, ITEMPROIMPOS IP, IMPOSTO IM
                                   WHERE IT.CDFILIAL      = C_REGC100.CDFILIAL
                                     AND IT.NRLANCTONF    = C_REGC100.NRLANCTONF
                                     AND IM.CDIMPOSTONFE  = P_CDIMPOSTO
                                     AND IM.CDIMPOSTO     = IP.CDIMPOSTO
                                     AND IT.CDFILIAL      = IP.CDFILIAL
                                     AND IT.NRLANCTONF    = IP.NRLANCTONF
                                     AND IT.NRSEQITPROD   = IP.NRSEQITPROD
                                     AND IT.CDPRODUTO     = PR.CDPRODUTO
                                     AND IP.NRITPROIMPOS  =  '1'
                                     AND C_REGC100.IDENTRSAIDOP = 'E'
                                     AND C_REGC100.CDMODDOCFISC = '55'
                                     AND C_REGC100.IDSTATUSNFE <> 'A'
                                     AND ROUND(IT.QTITEMPROD,3) > 0
                                     AND VALOR_IMPOSTO_NFE(IP.CDFILIAL,IP.NRLANCTONF,'03','I','1') = 0
                                   UNION ALL
                                   /* NOTAS DE ENTRADA ELETRÓNICAS COM CARGA TRIBUTÁRIA */
                                   SELECT PR.CDARVPROD AS COD_ITEM,
                                           DECODE(C_REGC100.IDENTRSAIDOP, 'E', TRIM(RETIRA_CARACTER_ESPECIAL(IT.DSPRODEMIS,'S'))) AS DESCR_COMPL,
                                           REPLACE(LTRIM(TO_CHAR(ROUND(IT.QTITEMPROD,3), '999999999990.000')), '.', ',') AS QTD,
                                           PR.SGUNIDADE AS UNID,
                                           REPLACE(LTRIM(TO_CHAR(ROUND(IT.VRTOTAITEM,2), '999999999990.00')), '.', ',') AS VL_ITEM,
                                           REPLACE(LTRIM(TO_CHAR(ROUND(NVL(IT.VRENCARGODESC,0),2), '999999999990.00')), '.', ',') AS VL_DESC,
                                           DECODE(NVL(V_IDATUESTTPOP,'N'),'N','1','0') AS IND_MOV,
                                           DECODE(C_REGC100.IDSIMPLESNACIONAL,'S',(DECODE(LENGTH(IT.CDFISCOPERSN),4,SUBSTR(IT.CDFISCOPERSN,2,3),LPAD(NVL(IT.CDFISCOPERSN,0),3,'0'))), LPAD(NVL(IP.CDSITUTRIBIT,0),3,'0')) AS CST_ICMS,
                                           IP.CDFISCOPERIT AS CFOP,
                                           REPLACE(LTRIM(TO_CHAR(ROUND(DECODE(IP.CDFISCALIT, '1', IP.VRBASECALCIT, 0) + DECODE(V_IDTPCARGATRIB,'O',0,CASE WHEN V_SGESTADO <> 'SP' THEN VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL,IP.NRLANCTONF,IP.NRSEQITPROD,'03','B','1') ELSE 0 END),2), '999999999990.00')), '.', ',') AS VL_BC_ICMS,
                                           REPLACE(LTRIM(TO_CHAR(ROUND(DECODE(IP.CDFISCALIT, '1', IP.VRALIQITEM, 0),2), '999999999990.00')), '.', ',') AS ALIQ_ICMS,
                                           REPLACE(LTRIM(TO_CHAR(ROUND(DECODE(IP.CDFISCALIT, '1', IP.VRIMPOSTOIT,  0) + DECODE(V_IDTPCARGATRIB,'O',0,CASE WHEN V_SGESTADO <> 'SP' THEN VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL,IP.NRLANCTONF,IP.NRSEQITPROD,'03','I','1') ELSE 0 END),2), '999999999990.00')), '.', ',') AS VL_ICMS,
                                           REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_CDIMPOSTRIB, 'B','1'),2), '999999999990.00')), '.', ',') AS VL_BC_ICMS_ST,
                                           REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_CDIMPOSTRIB, 'A','1') + VALOR_FECP_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_CDIMPOSTRIB, 'A','1'),2), '999999999990.00')), '.', ',') AS ALIQ_ST,
                                           REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_CDIMPOSTRIB, 'I','1') + VALOR_FECP_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_CDIMPOSTRIB, 'I','1'),2), '999999999990.00')), '.', ',') AS VL_ICMS_ST,
                                           (SELECT MAX(CDSITUTRIBITNFE)
                                              FROM ITEMPROIMPOS N, IMPOSTO IM
                                             WHERE IP.CDFILIAL     = N.CDFILIAL
                                               AND IP.NRLANCTONF   = N.NRLANCTONF
                                               AND IP.NRSEQITPROD  = N.NRSEQITPROD
                                               AND IM.CDIMPOSTO    = N.CDIMPOSTO
                                               AND N.NRITPROIMPOS  = '1'
                                               AND IM.CDIMPOSTONFE = V_IPI) AS CST_IPI,
                                           REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_IPI, 'B','1'),2), '999999999990.00')), '.', ',') AS VL_BC_IPI,
                                           REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_IPI, 'A','1'),2), '999999999990.00')), '.', ',') AS ALIQ_IPI,
                                           REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_IPI, 'I','1'),2), '999999999990.00')), '.', ',') AS VL_IPI,
                                           (SELECT MAX(CDSITUTRIBITNFE)
                                              FROM ITEMPROIMPOS N, IMPOSTO IM
                                             WHERE IP.CDFILIAL     = N.CDFILIAL
                                               AND IP.NRLANCTONF   = N.NRLANCTONF
                                               AND IP.NRSEQITPROD  = N.NRSEQITPROD
                                               AND IM.CDIMPOSTO    = N.CDIMPOSTO
                                               AND N.NRITPROIMPOS  = '1'
                                               AND IM.CDIMPOSTONFE = V_PIS) AS CST_PIS,
                                           REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_PIS, 'B','1'),2), '999999999990.00')), '.', ',') AS VL_BC_PIS, 
                                           REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_PIS, 'A','1'),2), '999999999990.00')), '.', ',') AS ALIQ_PIS,
                                           REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_PIS, 'I','1'),2), '999999999990.00')), '.', ',') AS VL_PIS,

                                           (SELECT MAX(CDSITUTRIBITNFE)
                                              FROM ITEMPROIMPOS N, IMPOSTO IM
                                             WHERE IP.CDFILIAL     = N.CDFILIAL
                                               AND IP.NRLANCTONF   = N.NRLANCTONF
                                               AND IP.NRSEQITPROD  = N.NRSEQITPROD
                                               AND IM.CDIMPOSTO    = N.CDIMPOSTO
                                               AND N.NRITPROIMPOS  = '1'
                                               AND IM.CDIMPOSTONFE = V_COFINS) AS CST_COFINS,
                                           REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_COFINS, 'B','1'),2), '999999999990.00')), '.', ',') AS VL_BC_COFINS,
                                           REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_COFINS, 'A','1'),2), '999999999990.00')), '.', ',') AS ALIQ_COFINS,
                                           REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF, IP.NRSEQITPROD, V_COFINS, 'I','1'),2), '999999999990.00')), '.', ',') AS VL_COFINS,
                                           CONTCTBL_SPED(C_REGC100.IDENTRSAIDOP, PR.CDPRODUTO, C_REGC100.CDTIPOOPER, C_REGC100.FILIAL)  AS COD_CTA,
                                           REPLACE(LTRIM(TO_CHAR(ROUND(DECODE(IP.IDIMPDESONERAIT,'S',NVL(IP.VRIMPOSTOIT,0),0),2), '999999999990.00')), '.', ',') AS VL_ABAT_NT,
                                           PR.CDPRODUTO, IT.DSCDFISOPEIT, IT.CDPRODNCMTRANS AS CDCLASFISC
                                    FROM ITEMPRODUTO IT, PRODUTO PR, ITEMPROIMPOS IP, IMPOSTO IM
                                   WHERE IT.CDFILIAL      = C_REGC100.CDFILIAL
                                     AND IT.NRLANCTONF    = C_REGC100.NRLANCTONF
                                     AND IM.CDIMPOSTONFE  = P_CDIMPOSTO
                                     AND IM.CDIMPOSTO     = IP.CDIMPOSTO
                                     AND IT.CDFILIAL      = IP.CDFILIAL
                                     AND IT.NRLANCTONF    = IP.NRLANCTONF
                                     AND IT.NRSEQITPROD   = IP.NRSEQITPROD
                                     AND IT.CDPRODUTO     = PR.CDPRODUTO
                                     AND IP.NRITPROIMPOS  =  '1'
                                     AND C_REGC100.IDENTRSAIDOP = 'E'
                                     AND C_REGC100.CDMODDOCFISC = '55'
                                     AND C_REGC100.IDSTATUSNFE <> 'A'
                                     AND ROUND(IT.QTITEMPROD,3) > 0
                                     AND VALOR_IMPOSTO_NFE(IP.CDFILIAL,IP.NRLANCTONF,'03','I','1') > 0)) LOOP
            INSERT INTO ARQMAGNETICO
               (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
            VALUES
               ('19'||LPAD(RTRIM(V_CONTREGC), 8, '0'), '|C170'|| '|' ||V_SEQUENCIAL|| '|' || C_REGC170.ARQ_C170, P_NRSEQARQMAG);
            V_SEQUENCIAL := LPAD(RTRIM(TO_CHAR(TO_NUMBER(RTRIM(V_SEQUENCIAL))+1)), 3,'0');
            V_CONTREGC :=  NVL(V_CONTREGC,0) + 1;

            /* CODIGO DO CFOP */
            SELECT MAX(CDCHAVEREG)
              INTO V_COD_NAT
              FROM TMP_REGDADOSSPED
             WHERE CDCHAVEREG = C_REGC170.CDFISCOPERIT
               AND CDREGISTRO = '0400';

            IF (V_COD_NAT IS NULL) AND (C_REGC170.CDFISCOPERIT IS NOT NULL) THEN
               V_SEQUPROD := NVL(V_SEQUPROD,0) + 1;
               INSERT INTO TMP_REGDADOSSPED
                 (CDREGISTRO, CDCONTREGI, CDCHAVEREG, CDCAMPO1, CDCAMPO2)
               VALUES
                 ('0400', V_SEQUPROD, C_REGC170.CDFISCOPERIT, C_REGC170.DSCDFISOPEIT, C_REGC100.IDENTRSAIDOP);
            END IF;
            V_COD_NAT := NULL;

            /* UNIDADE DE MEDIDA */
            SELECT MAX(CDCHAVEREG)
              INTO V_UNID
              FROM TMP_REGDADOSSPED
             WHERE CDCHAVEREG = C_REGC170.UNID
               AND CDREGISTRO = '0190';

            IF (V_UNID IS NULL) AND (C_REGC170.UNID IS NOT NULL) THEN
               V_SEQUPROD := NVL(V_SEQUPROD,0) + 1;
               INSERT INTO TMP_REGDADOSSPED
                 (CDREGISTRO, CDCONTREGI, CDCHAVEREG)
               VALUES
                 ('0190', V_SEQUPROD, C_REGC170.UNID);
            END IF;
            V_UNID := NULL;

            /* CODIGO DO PRODUTO */
            SELECT MAX(CDCHAVEREG)
              INTO V_PRODUTO
              FROM TMP_REGDADOSSPED
             WHERE CDCHAVEREG = C_REGC170.CDPRODUTO
               AND CDREGISTRO = '0200';

            IF (V_PRODUTO IS NULL) AND (C_REGC170.CDPRODUTO IS NOT NULL) THEN
               V_SEQUPROD := NVL(V_SEQUPROD,0) + 1;
               INSERT INTO TMP_REGDADOSSPED
                 (CDREGISTRO, CDCONTREGI, CDCHAVEREG, CDCAMPO3)
               VALUES
                 ('0200', V_SEQUPROD, C_REGC170.CDPRODUTO, C_REGC170.CDCLASFISC);
            END IF;
            V_PRODUTO := NULL;

            /* PLANO DE CONTAS REFERENCIAL */
            SELECT MAX(CDCHAVEREG)
              INTO V_CONTCTBL
              FROM TMP_REGDADOSSPED
             WHERE CDCHAVEREG = C_REGC170.COD_CTA
               AND CDREGISTRO = '0500';

            IF (V_CONTCTBL IS NULL) AND (C_REGC170.COD_CTA IS NOT NULL) THEN
               V_SEQUPROD := NVL(V_SEQUPROD,0) + 1;
               INSERT INTO TMP_REGDADOSSPED
                  (CDREGISTRO, CDCONTREGI, CDCHAVEREG)
               VALUES
                  ('0500', V_SEQUPROD, C_REGC170.COD_CTA);
            END IF;
            V_CONTCTBL := NULL;
          END LOOP;

          IF P_VERSAO NOT IN ( '001', '002') THEN
             /*REGISTRO C190*/
             IF (C_REGC100.IDSIMPLESNACIONAL <> 'S') OR (C_REGC100.IDSIMPLESNACIONAL = 'S' AND C_REGC100.CDMODDOCFISC <> '55') THEN
                 FOR C_REGC190 IN(SELECT ('|C190'      || '|' ||
                                          T.CST_ICMS   || '|' ||
                                          T.CFOP       || '|' ||
                                          REPLACE(LTRIM(TO_CHAR(ROUND(T.ALIQ_ICMS,2), '999999999990.00')), '.', ',') || '|' ||
                                          REPLACE(LTRIM(TO_CHAR(ROUND(T.VL_OPR,2),    '999999999990.00')), '.', ',') || '|' ||
                                          REPLACE(LTRIM(TO_CHAR(ROUND(T.VL_BC_ICMS,2),'999999999990.00')), '.', ',') || '|' ||
                                          REPLACE(LTRIM(TO_CHAR(ROUND(T.VL_ICMS,2),   '999999999990.00')), '.', ',') || '|' ||
                                          REPLACE(LTRIM(TO_CHAR(ROUND(T.BC_ST,2),     '999999999990.00')), '.', ',') || '|' ||
                                          REPLACE(LTRIM(TO_CHAR(ROUND(T.IMP_ST,2),    '999999999990.00')), '.', ',') || '|' ||
                                          REPLACE(LTRIM(TO_CHAR(ROUND(T.VL_RED_BC,2), '999999999990.00')), '.', ',') || '|' ||
                                          REPLACE(LTRIM(TO_CHAR(ROUND(VL_IPI,2),      '999999999990.00')), '.', ',') || '|' ||
                                          '' || '|') ARQ_C190,
                                          T.VL_ICMS, T.CFOP AS COD_NAT, T.CST_ICMS, T.ALIQ_ICMS
                                  FROM (/* NOTAS DE SAÍDA SEM CARGA TRIBUTÁRIA */
                                        SELECT I.CDSITUTRIBIT AS CST_ICMS,
                                               I.CDFISCOPERIT AS CFOP,
                                               DECODE(I.CDFISCALIT, '1', I.VRALIQITEM, 0) AS ALIQ_ICMS,
                                               SUM(I.VRCONTITIMP)+NVL(SUM(VALOR_REDUCAO(I.CDFILIAL, I.NRLANCTONF, I.CDSITUTRIBIT, I.NRSEQITPROD, I.CDFISCOPERIT, NULL, NULL, NULL)),0) VL_OPR,
                                               SUM(DECODE(I.CDFISCALIT, '1', I.VRBASECALCIT, 0)) AS VL_BC_ICMS,
                                               SUM(DECODE(I.CDFISCALIT, '1', I.VRIMPOSTOIT, 0)) AS VL_ICMS,
                                               NVL(SUM(DECODE(I.CDFISCALIT,'1',VALOR_REDUCAO(I.CDFILIAL, I.NRLANCTONF, I.CDSITUTRIBIT, I.NRSEQITPROD, I.CDFISCOPERIT, NULL, NULL, NULL),0)),0) AS VL_RED_BC,
                                               SUM((SELECT NVL(SUM(VRIMPOSTOIT),0)
                                                      FROM ITEMPROIMPOS IT, IMPOSTO IM
                                                     WHERE (IT.CDFILIAL     = I.CDFILIAL           ) AND
                                                           (IT.NRLANCTONF   = I.NRLANCTONF         ) AND
                                                           (IT.CDIMPOSTO    = IM.CDIMPOSTO         ) AND
                                                           (IT.NRITPROIMPOS = '1'                  ) AND
                                                           (IT.CDFISCALIT   = '1'                  ) AND
                                                           (IM.CDIMPOSTONFE = '10'                 ) AND
                                                           I.NRSEQITPROD = IT.NRSEQITPROD         )) AS VL_IPI,
                                               '' AS COD_OBS,
                                               SUM(VALOR_IMPOSTO_ITEM_NFE(I.CDFILIAL,I.NRLANCTONF,I.NRSEQITPROD,'80','B','1')) AS BC_ST,
                                               SUM(VALOR_IMPOSTO_ITEM_NFE(I.CDFILIAL,I.NRLANCTONF,I.NRSEQITPROD,'80','I','1') + VALOR_FECP_ITEM_NFE(I.CDFILIAL,I.NRLANCTONF,I.NRSEQITPROD,'80','I','1')) AS IMP_ST
                                          FROM ITEMPROIMPOS I, IMPOSTO IM
                                         WHERE I.CDFILIAL      = C_REGC100.CDFILIAL
                                           AND I.NRLANCTONF    = C_REGC100.NRLANCTONF
                                           AND C_REGC100.IDENTRSAIDOP = 'S'
                                           AND I.NRITPROIMPOS  = '1'
                                           AND IM.CDIMPOSTONFE = P_CDIMPOSTO
                                           AND IM.CDIMPOSTO    = I.CDIMPOSTO
                                           AND VALOR_IMPOSTO_NFE(I.CDFILIAL,I.NRLANCTONF,'03','I','1') = 0
                                         GROUP BY I.CDSITUTRIBIT, CDFISCOPERIT, DECODE(CDFISCALIT, '1', VRALIQITEM, 0)
                                        UNION ALL
                                        /* NOTAS DE SAÍDA COM CARGA TRIBUTÁRIA */
                                        SELECT I.CDSITUTRIBIT AS CST_ICMS,
                                               I.CDFISCOPERIT AS CFOP,
                                               DECODE(I.CDFISCALIT, '1', I.VRALIQITEM, 0) AS ALIQ_ICMS,
                                               SUM(I.VRCONTITIMP)+NVL(SUM(VALOR_REDUCAO(I.CDFILIAL, I.NRLANCTONF, I.CDSITUTRIBIT, I.NRSEQITPROD, I.CDFISCOPERIT, NULL, NULL, NULL)),0) VL_OPR,
                                               DECODE(V_IDTPCARGATRIB,'O',0,DECODE(V_SGESTADO,'SP',0,SUM(VALOR_IMPOSTO_ITEM_NFE(I.CDFILIAL,I.NRLANCTONF,I.NRSEQITPROD,'03','B','1')))) AS VL_BC_ICMS,
                                               SUM(DECODE(V_IDTPCARGATRIB,'O',0,VALOR_IMPOSTO_ITEM_NFE(I.CDFILIAL,I.NRLANCTONF,I.NRSEQITPROD,'03','I','1'))) AS VL_ICMS,
                                               NVL(SUM(DECODE(I.CDFISCALIT,'1',VALOR_REDUCAO(I.CDFILIAL, I.NRLANCTONF, I.CDSITUTRIBIT, I.NRSEQITPROD, I.CDFISCOPERIT, NULL, NULL, NULL),0)),0) AS VL_RED_BC,
                                               SUM((SELECT NVL(SUM(VRIMPOSTOIT),0)
                                                      FROM ITEMPROIMPOS IT, IMPOSTO IM
                                                     WHERE (IT.CDFILIAL     = I.CDFILIAL           ) AND
                                                           (IT.NRLANCTONF   = I.NRLANCTONF         ) AND
                                                           (IT.CDIMPOSTO    = IM.CDIMPOSTO         ) AND
                                                           (IT.NRITPROIMPOS = '1'                  ) AND
                                                           (IT.CDFISCALIT   = '1'                  ) AND
                                                           (IM.CDIMPOSTONFE = '10'                 ) AND
                                                           I.NRSEQITPROD = IT.NRSEQITPROD         )) AS VL_IPI,
                                               '' AS COD_OBS,
                                               SUM(VALOR_IMPOSTO_ITEM_NFE(I.CDFILIAL,I.NRLANCTONF,I.NRSEQITPROD,'80','B','1')) AS BC_ST,
                                               SUM(VALOR_IMPOSTO_ITEM_NFE(I.CDFILIAL,I.NRLANCTONF,I.NRSEQITPROD,'80','I','1') + VALOR_FECP_ITEM_NFE(I.CDFILIAL,I.NRLANCTONF,I.NRSEQITPROD,'80','I','1')) AS IMP_ST
                                          FROM ITEMPROIMPOS I, IMPOSTO IM
                                         WHERE I.CDFILIAL      = C_REGC100.CDFILIAL
                                           AND I.NRLANCTONF    = C_REGC100.NRLANCTONF
                                           AND C_REGC100.IDENTRSAIDOP = 'S'
                                           AND I.NRITPROIMPOS  = '1'
                                           AND IM.CDIMPOSTONFE = P_CDIMPOSTO
                                           AND IM.CDIMPOSTO    = I.CDIMPOSTO
                                           AND VALOR_IMPOSTO_NFE(I.CDFILIAL,I.NRLANCTONF,'03','I','1') > 0
                                         GROUP BY I.CDSITUTRIBIT, CDFISCOPERIT, DECODE(CDFISCALIT, '1', VRALIQITEM, 0)
                                        UNION ALL
                                        /* NOTAS DE ENTRADA SEM CARGA TRIBUTÁRIA */
                                        SELECT I.CDSITUTRIBIT AS CST_ICMS,
                                               I.CDFISCOPERIT AS CFOP,
                                               DECODE(I.CDFISCALIT, '1', I.VRALIQITEM, 0) AS ALIQ_ICMS,
                                               SUM(I.VRCONTITIMP)+NVL(SUM(VALOR_REDUCAO(I.CDFILIAL, I.NRLANCTONF, I.CDSITUTRIBIT, I.NRSEQITPROD, I.CDFISCOPERIT, NULL, NULL, NULL)),0) VL_OPR,
                                               SUM(DECODE(CDFISCALIT, '1', VRBASECALCIT, 0)) AS VL_BC_ICMS,
                                               SUM(DECODE(CDFISCALIT, '1', VRIMPOSTOIT, 0)) AS VL_ICMS,
                                               NVL(SUM(DECODE(I.CDFISCALIT,'1',VALOR_REDUCAO(I.CDFILIAL, I.NRLANCTONF, I.CDSITUTRIBIT, I.NRSEQITPROD, I.CDFISCOPERIT, NULL, NULL, NULL),0)),0) AS VL_RED_BC,
                                               SUM((SELECT NVL(SUM(VRIMPOSTOIT),0)
                                                      FROM ITEMPROIMPOS IT, IMPOSTO IM
                                                     WHERE (IT.CDFILIAL     = I.CDFILIAL           ) AND
                                                           (IT.NRLANCTONF   = I.NRLANCTONF         ) AND
                                                           (IT.CDIMPOSTO    = IM.CDIMPOSTO         ) AND
                                                           (IT.NRITPROIMPOS = '1'                  ) AND
                                                           (IT.CDFISCALIT   = '1'                  ) AND
                                                           (IM.CDIMPOSTONFE = '10'                 ) AND
                                                           I.NRSEQITPROD = IT.NRSEQITPROD         )) AS VL_IPI,
                                               '' AS COD_OBS,
                                               SUM(VALOR_IMPOSTO_ITEM_NFE(I.CDFILIAL,I.NRLANCTONF,I.NRSEQITPROD,'80','B','1')) AS BC_ST,
                                               SUM(VALOR_IMPOSTO_ITEM_NFE(I.CDFILIAL,I.NRLANCTONF,I.NRSEQITPROD,'80','I','1') + VALOR_FECP_ITEM_NFE(I.CDFILIAL,I.NRLANCTONF,I.NRSEQITPROD,'80','I','1')) AS IMP_ST
                                          FROM ITEMPROIMPOS I, IMPOSTO IM
                                         WHERE I.CDFILIAL      = C_REGC100.CDFILIAL
                                           AND I.NRLANCTONF    = C_REGC100.NRLANCTONF
                                           AND C_REGC100.IDENTRSAIDOP = 'E'
                                           AND I.NRITPROIMPOS  = '1'
                                           AND IM.CDIMPOSTONFE = P_CDIMPOSTO
                                           AND IM.CDIMPOSTO    = I.CDIMPOSTO
                                           AND VALOR_IMPOSTO_NFE(I.CDFILIAL,I.NRLANCTONF,'03','I','1') = 0
                                         GROUP BY I.CDSITUTRIBIT, CDFISCOPERIT, DECODE(CDFISCALIT, '1', VRALIQITEM, 0)
                                        UNION ALL
                                        /* NOTAS DE ENTRADA COM CARGA TRIBUTÁRIA */
                                        SELECT I.CDSITUTRIBIT AS CST_ICMS,
                                               I.CDFISCOPERIT AS CFOP,
                                               DECODE(I.CDFISCALIT, '1', I.VRALIQITEM, 0) AS ALIQ_ICMS,
                                               SUM(I.VRCONTITIMP)+NVL(SUM(VALOR_REDUCAO(I.CDFILIAL, I.NRLANCTONF, I.CDSITUTRIBIT, I.NRSEQITPROD, I.CDFISCOPERIT, NULL, NULL, NULL)),0) VL_OPR,
                                               SUM(DECODE(CDFISCALIT,'1',VRBASECALCIT, 0) + DECODE(V_IDTPCARGATRIB,'O',0,DECODE(CDFISCALIT, '1', CASE WHEN V_SGESTADO <> 'SP' THEN VRBASECALCIT ELSE 0 END, 0))) AS VL_BC_ICMS,
                                               SUM(DECODE(CDFISCALIT,'1',VRIMPOSTOIT,  0) + DECODE(V_IDTPCARGATRIB,'O',0,DECODE(CDFISCALIT, '1', CASE WHEN V_SGESTADO <> 'SP' THEN VRIMPOSTOIT  ELSE 0 END, 0))) AS VL_ICMS,
                                               NVL(SUM(DECODE(I.CDFISCALIT,'1',VALOR_REDUCAO(I.CDFILIAL, I.NRLANCTONF, I.CDSITUTRIBIT, I.NRSEQITPROD, I.CDFISCOPERIT, NULL, NULL, NULL),0)),0) AS VL_RED_BC,
                                               SUM((SELECT NVL(SUM(VRIMPOSTOIT),0)
                                                      FROM ITEMPROIMPOS IT, IMPOSTO IM
                                                     WHERE (IT.CDFILIAL     = I.CDFILIAL           ) AND
                                                           (IT.NRLANCTONF   = I.NRLANCTONF         ) AND
                                                           (IT.CDIMPOSTO    = IM.CDIMPOSTO         ) AND
                                                           (IT.NRITPROIMPOS = '1'                  ) AND
                                                           (IT.CDFISCALIT   = '1'                  ) AND
                                                           (IM.CDIMPOSTONFE = '10'                 ) AND
                                                           I.NRSEQITPROD = IT.NRSEQITPROD         )) AS VL_IPI,
                                               '' AS COD_OBS,
                                               SUM(VALOR_IMPOSTO_ITEM_NFE(I.CDFILIAL,I.NRLANCTONF,I.NRSEQITPROD,'80','B','1')) AS BC_ST,
                                               SUM(VALOR_IMPOSTO_ITEM_NFE(I.CDFILIAL,I.NRLANCTONF,I.NRSEQITPROD,'80','I','1') + VALOR_FECP_ITEM_NFE(I.CDFILIAL,I.NRLANCTONF,I.NRSEQITPROD,'80','I','1')) AS IMP_ST
                                          FROM ITEMPROIMPOS I, IMPOSTO IM
                                         WHERE I.CDFILIAL      = C_REGC100.CDFILIAL
                                           AND I.NRLANCTONF    = C_REGC100.NRLANCTONF
                                           AND C_REGC100.IDENTRSAIDOP = 'E'
                                           AND I.NRITPROIMPOS  = '1'
                                           AND IM.CDIMPOSTONFE = P_CDIMPOSTO
                                           AND IM.CDIMPOSTO    = I.CDIMPOSTO
                                           AND VALOR_IMPOSTO_NFE(I.CDFILIAL,I.NRLANCTONF,'03','I','1') > 0
                                         GROUP BY I.CDSITUTRIBIT, CDFISCOPERIT, DECODE(CDFISCALIT, '1', VRALIQITEM, 0) ) T ) LOOP
                    INSERT INTO ARQMAGNETICO
                      (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
                    VALUES
                      ('19'||LPAD(RTRIM(V_CONTREGC), 8, '0'), C_REGC190.ARQ_C190, P_NRSEQARQMAG);
                    V_CONTREGC := NVL(V_CONTREGC,0) + 1;

                    IF P_VERSAO >= '013' THEN
                       FOR C_REGC191 IN (SELECT '|C191'          || '|' ||
                                                REPLACE(LTRIM(TO_CHAR(SUM(CASE WHEN SUBSTR(IT.CDSITUTRIBIT,2,2) IN ('00','10','20','51','70','90') AND IM.CDIMPOSTONFE = '00'
                                                     THEN ROUND(IT.VRADICFECP,2)
                                                     ELSE 0 END),'999999999990.00')), '.', ',') || '|' ||
                                                REPLACE(LTRIM(TO_CHAR(SUM(CASE WHEN SUBSTR(IT.CDSITUTRIBIT,2,2) IN ('10','30','70','90') AND IM.CDIMPOSTONFE = '80'
                                                     THEN ROUND(IT.VRADICFECP,2)
                                                     ELSE 0 END),'999999999990.00')), '.', ',') || '|' ||
                                                REPLACE(LTRIM(TO_CHAR(SUM(CASE WHEN SUBSTR(IT.CDSITUTRIBIT,2,2) IN ('60')
                                                     THEN ROUND(IT.VRADICFECP,2)
                                                     ELSE 0 END),'999999999990.00')), '.', ',') || '|' AS ARQ_C191, IT.CDFISCOPERIT
                                           FROM ITEMPROIMPOS IT, ITEMPROIMPOS II, IMPOSTO IM
                                          WHERE IT.CDFILIAL     = C_REGC100.CDFILIAL
                                            AND IT.NRLANCTONF   = C_REGC100.NRLANCTONF
                                            AND IT.CDFISCOPERIT = C_REGC190.COD_NAT
                                            AND IT.CDSITUTRIBIT = C_REGC190.CST_ICMS
                                            AND IT.VRALIQITEM   = C_REGC190.ALIQ_ICMS
                                            AND IT.NRITPROIMPOS = '1'
                                            AND IT.CDFILIAL     = II.CDFILIAL
                                            AND IT.NRLANCTONF   = II.NRLANCTONF
                                            AND IT.NRSEQITPROD  = II.NRSEQITPROD
                                            AND II.CDFISCOPERIT = C_REGC190.COD_NAT
                                            AND II.CDSITUTRIBIT = C_REGC190.CST_ICMS
                                            AND II.CDIMPOSTO    = IM.CDIMPOSTO
                                            AND IM.CDIMPOSTONFE IN ('00','80')
                                            AND II.VRADICFECP   > 0
                                          GROUP BY IT.CDFISCOPERIT) LOOP
                          INSERT INTO ARQMAGNETICO
                             (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
                          VALUES
                             ('19'||LPAD(RTRIM(V_CONTREGC), 8, '0'), C_REGC191.ARQ_C191, P_NRSEQARQMAG);
                          V_CONTREGC := NVL(V_CONTREGC,0) + 1;
                       END LOOP;
                    END IF;
                 END LOOP;
             END IF;

             IF (C_REGC100.IDSIMPLESNACIONAL = 'S' AND C_REGC100.CDMODDOCFISC = '55') THEN
                 FOR C_REGC190 IN(SELECT ('|C190'      || '|' ||
                                          T.CST_ICMS   || '|' ||
                                          T.CFOP       || '|' ||
                                          REPLACE(LTRIM(TO_CHAR(ROUND(T.ALIQ_ICMS,2), '999999999990.00')), '.', ',') || '|' ||
                                          REPLACE(LTRIM(TO_CHAR(ROUND(T.VL_OPR,2),    '999999999990.00')), '.', ',') || '|' ||
                                          REPLACE(LTRIM(TO_CHAR(ROUND(T.VL_BC_ICMS,2),'999999999990.00')), '.', ',') || '|' ||
                                          REPLACE(LTRIM(TO_CHAR(ROUND(T.VL_ICMS,2),   '999999999990.00')), '.', ',') || '|' ||
                                          REPLACE(LTRIM(TO_CHAR(ROUND(T.BC_ST,2),     '999999999990.00')), '.', ',') || '|' ||
                                          REPLACE(LTRIM(TO_CHAR(ROUND(T.IMP_ST,2),    '999999999990.00')), '.', ',') || '|' ||
                                          REPLACE(LTRIM(TO_CHAR(ROUND(T.VL_RED_BC,2), '999999999990.00')), '.', ',') || '|' ||
                                          REPLACE(LTRIM(TO_CHAR(ROUND(VL_IPI,2),      '999999999990.00')), '.', ',') || '|' ||
                                          '' || '|') ARQ_C190,
                                          T.VL_ICMS, T.CFOP AS COD_NAT, T.CST_ICMS, T.ALIQ_ICMS
                                  FROM (/* NOTAS DE SAÍDA SEM CARGA TRIBUTÁRIA */
                                        SELECT DECODE(LENGTH(IT.CDFISCOPERSN),4,SUBSTR(IT.CDFISCOPERSN,2,3),IT.CDFISCOPERSN) AS CST_ICMS,
                                               I.CDFISCOPERIT AS CFOP,
                                               DECODE(I.CDFISCALIT, '1', I.VRALIQITEM, 0) AS ALIQ_ICMS,
                                               SUM(I.VRCONTITIMP)+NVL(SUM(VALOR_REDUCAO(I.CDFILIAL, I.NRLANCTONF, I.CDSITUTRIBIT, I.NRSEQITPROD, I.CDFISCOPERIT, IT.CDFISCOPERSN, C_REGC100.CDMODDOCFISC, C_REGC100.IDSIMPLESNACIONAL)),0) VL_OPR,
                                               SUM(DECODE(I.CDFISCALIT, '1', I.VRBASECALCIT, 0)) AS VL_BC_ICMS,
                                               SUM(DECODE(I.CDFISCALIT, '1', I.VRIMPOSTOIT, 0)) AS VL_ICMS,
                                               NVL(SUM(DECODE(I.CDFISCALIT,'1',VALOR_REDUCAO(I.CDFILIAL, I.NRLANCTONF, I.CDSITUTRIBIT, I.NRSEQITPROD, I.CDFISCOPERIT, IT.CDFISCOPERSN, C_REGC100.CDMODDOCFISC, C_REGC100.IDSIMPLESNACIONAL),0)),0) AS VL_RED_BC,
                                               SUM((SELECT NVL(SUM(VRIMPOSTOIT),0)
                                                      FROM ITEMPROIMPOS IT, IMPOSTO IM
                                                     WHERE (IT.CDFILIAL     = I.CDFILIAL           ) AND
                                                           (IT.NRLANCTONF   = I.NRLANCTONF         ) AND
                                                           (IT.CDIMPOSTO    = IM.CDIMPOSTO         ) AND
                                                           (IT.NRITPROIMPOS = '1'                  ) AND
                                                           (IT.CDFISCALIT   = '1'                  ) AND
                                                           (IM.CDIMPOSTONFE = '10'                 ) AND
                                                           I.NRSEQITPROD = IT.NRSEQITPROD         )) AS VL_IPI,
                                               '' AS COD_OBS,
                                               SUM(VALOR_IMPOSTO_ITEM_NFE(I.CDFILIAL,I.NRLANCTONF,I.NRSEQITPROD,'80','B','1')) AS BC_ST,
                                               SUM(VALOR_IMPOSTO_ITEM_NFE(I.CDFILIAL,I.NRLANCTONF,I.NRSEQITPROD,'80','I','1') + VALOR_FECP_ITEM_NFE(I.CDFILIAL,I.NRLANCTONF,I.NRSEQITPROD,'80','I','1')) AS IMP_ST
                                          FROM ITEMPROIMPOS I, IMPOSTO IM, ITEMPRODUTO IT
                                         WHERE I.CDFILIAL      = C_REGC100.CDFILIAL
                                           AND I.NRLANCTONF    = C_REGC100.NRLANCTONF
                                           AND C_REGC100.IDENTRSAIDOP = 'S'
                                           AND I.NRITPROIMPOS  = '1'
                                           AND IM.CDIMPOSTONFE = P_CDIMPOSTO
                                           AND IM.CDIMPOSTO    = I.CDIMPOSTO
                                           AND I.CDFILIAL      = IT.CDFILIAL
                                           AND I.NRLANCTONF    = IT.NRLANCTONF
                                           AND I.NRSEQITPROD   = IT.NRSEQITPROD
                                           AND VALOR_IMPOSTO_NFE(I.CDFILIAL,I.NRLANCTONF,'03','I','1') = 0
                                         GROUP BY DECODE(LENGTH(IT.CDFISCOPERSN),4,SUBSTR(IT.CDFISCOPERSN,2,3),IT.CDFISCOPERSN), CDFISCOPERIT, DECODE(CDFISCALIT, '1', VRALIQITEM, 0)
                                        UNION ALL
                                        /* NOTAS DE SAÍDA COM CARGA TRIBUTÁRIA */
                                        SELECT DECODE(LENGTH(IT.CDFISCOPERSN),4,SUBSTR(IT.CDFISCOPERSN,2,3),IT.CDFISCOPERSN) AS CST_ICMS,
                                               I.CDFISCOPERIT AS CFOP,
                                               DECODE(I.CDFISCALIT, '1', I.VRALIQITEM, 0) AS ALIQ_ICMS,
                                               SUM(I.VRCONTITIMP)+NVL(SUM(VALOR_REDUCAO(I.CDFILIAL, I.NRLANCTONF, I.CDSITUTRIBIT, I.NRSEQITPROD, I.CDFISCOPERIT, IT.CDFISCOPERSN, C_REGC100.CDMODDOCFISC, C_REGC100.IDSIMPLESNACIONAL)),0) VL_OPR,
                                               DECODE(V_IDTPCARGATRIB,'O',0,DECODE(V_SGESTADO,'SP',0,SUM(VALOR_IMPOSTO_ITEM_NFE(I.CDFILIAL,I.NRLANCTONF,I.NRSEQITPROD,'03','B','1')))) AS VL_BC_ICMS,
                                               SUM(DECODE(V_IDTPCARGATRIB,'O',0,VALOR_IMPOSTO_ITEM_NFE(I.CDFILIAL,I.NRLANCTONF,I.NRSEQITPROD,'03','I','1'))) AS VL_ICMS,
                                               NVL(SUM(DECODE(I.CDFISCALIT,'1',VALOR_REDUCAO(I.CDFILIAL, I.NRLANCTONF, I.CDSITUTRIBIT, I.NRSEQITPROD, I.CDFISCOPERIT, IT.CDFISCOPERSN, C_REGC100.CDMODDOCFISC, C_REGC100.IDSIMPLESNACIONAL),0)),0) AS VL_RED_BC,
                                               SUM((SELECT NVL(SUM(VRIMPOSTOIT),0)
                                                      FROM ITEMPROIMPOS IT, IMPOSTO IM
                                                     WHERE (IT.CDFILIAL     = I.CDFILIAL           ) AND
                                                           (IT.NRLANCTONF   = I.NRLANCTONF         ) AND
                                                           (IT.CDIMPOSTO    = IM.CDIMPOSTO         ) AND
                                                           (IT.NRITPROIMPOS = '1'                  ) AND
                                                           (IT.CDFISCALIT   = '1'                  ) AND
                                                           (IM.CDIMPOSTONFE = '10'                 ) AND
                                                           I.NRSEQITPROD = IT.NRSEQITPROD         )) AS VL_IPI,
                                               '' AS COD_OBS,
                                               SUM(VALOR_IMPOSTO_ITEM_NFE(I.CDFILIAL,I.NRLANCTONF,I.NRSEQITPROD,'80','B','1')) AS BC_ST,
                                               SUM(VALOR_IMPOSTO_ITEM_NFE(I.CDFILIAL,I.NRLANCTONF,I.NRSEQITPROD,'80','I','1') + VALOR_FECP_ITEM_NFE(I.CDFILIAL,I.NRLANCTONF,I.NRSEQITPROD,'80','I','1')) AS IMP_ST
                                          FROM ITEMPROIMPOS I, IMPOSTO IM, ITEMPRODUTO IT
                                         WHERE I.CDFILIAL      = C_REGC100.CDFILIAL
                                           AND I.NRLANCTONF    = C_REGC100.NRLANCTONF
                                           AND C_REGC100.IDENTRSAIDOP = 'S'
                                           AND I.NRITPROIMPOS  = '1'
                                           AND IM.CDIMPOSTONFE = P_CDIMPOSTO
                                           AND IM.CDIMPOSTO    = I.CDIMPOSTO
                                           AND I.CDFILIAL      = IT.CDFILIAL
                                           AND I.NRLANCTONF    = IT.NRLANCTONF
                                           AND I.NRSEQITPROD   = IT.NRSEQITPROD
                                           AND VALOR_IMPOSTO_NFE(I.CDFILIAL,I.NRLANCTONF,'03','I','1') > 0
                                         GROUP BY DECODE(LENGTH(IT.CDFISCOPERSN),4,SUBSTR(IT.CDFISCOPERSN,2,3),IT.CDFISCOPERSN), CDFISCOPERIT, DECODE(CDFISCALIT, '1', VRALIQITEM, 0)
                                        UNION ALL
                                        /* NOTAS DE ENTRADA SEM CARGA TRIBUTÁRIA */
                                        SELECT DECODE(LENGTH(IT.CDFISCOPERSN),4,SUBSTR(IT.CDFISCOPERSN,2,3),IT.CDFISCOPERSN) AS CST_ICMS,
                                               I.CDFISCOPERIT AS CFOP,
                                               DECODE(I.CDFISCALIT, '1', I.VRALIQITEM, 0) AS ALIQ_ICMS,
                                               SUM(I.VRCONTITIMP)+NVL(SUM(VALOR_REDUCAO(I.CDFILIAL, I.NRLANCTONF, I.CDSITUTRIBIT, I.NRSEQITPROD, I.CDFISCOPERIT, IT.CDFISCOPERSN, C_REGC100.CDMODDOCFISC, C_REGC100.IDSIMPLESNACIONAL)),0) VL_OPR,
                                               SUM(DECODE(I.CDFISCALIT, '1', I.VRBASECALCIT, 0)) AS VL_BC_ICMS,
                                               SUM(DECODE(I.CDFISCALIT, '1', I.VRIMPOSTOIT, 0)) AS VL_ICMS,
                                               NVL(SUM(DECODE(I.CDFISCALIT,'1',VALOR_REDUCAO(I.CDFILIAL, I.NRLANCTONF, I.CDSITUTRIBIT, I.NRSEQITPROD, I.CDFISCOPERIT, IT.CDFISCOPERSN, C_REGC100.CDMODDOCFISC, C_REGC100.IDSIMPLESNACIONAL),0)),0) AS VL_RED_BC,
                                               SUM((SELECT NVL(SUM(VRIMPOSTOIT),0)
                                                      FROM ITEMPROIMPOS IT, IMPOSTO IM
                                                     WHERE (IT.CDFILIAL     = I.CDFILIAL           ) AND
                                                           (IT.NRLANCTONF   = I.NRLANCTONF         ) AND
                                                           (IT.CDIMPOSTO    = IM.CDIMPOSTO         ) AND
                                                           (IT.NRITPROIMPOS = '1'                  ) AND
                                                           (IT.CDFISCALIT   = '1'                  ) AND
                                                           (IM.CDIMPOSTONFE = '10'                 ) AND
                                                           I.NRSEQITPROD = IT.NRSEQITPROD         )) AS VL_IPI,
                                               '' AS COD_OBS,
                                               SUM(VALOR_IMPOSTO_ITEM_NFE(I.CDFILIAL,I.NRLANCTONF,I.NRSEQITPROD,'80','B','1')) AS BC_ST,
                                               SUM(VALOR_IMPOSTO_ITEM_NFE(I.CDFILIAL,I.NRLANCTONF,I.NRSEQITPROD,'80','I','1') + VALOR_FECP_ITEM_NFE(I.CDFILIAL,I.NRLANCTONF,I.NRSEQITPROD,'80','I','1')) AS IMP_ST
                                          FROM ITEMPROIMPOS I, IMPOSTO IM, ITEMPRODUTO IT
                                         WHERE I.CDFILIAL      = C_REGC100.CDFILIAL
                                           AND I.NRLANCTONF    = C_REGC100.NRLANCTONF
                                           AND C_REGC100.IDENTRSAIDOP = 'E'
                                           AND I.NRITPROIMPOS  = '1'
                                           AND IM.CDIMPOSTONFE = P_CDIMPOSTO
                                           AND IM.CDIMPOSTO    = I.CDIMPOSTO
                                           AND I.CDFILIAL      = IT.CDFILIAL
                                           AND I.NRLANCTONF    = IT.NRLANCTONF
                                           AND I.NRSEQITPROD   = IT.NRSEQITPROD
                                           AND VALOR_IMPOSTO_NFE(I.CDFILIAL,I.NRLANCTONF,'03','I','1') = 0
                                         GROUP BY DECODE(LENGTH(IT.CDFISCOPERSN),4,SUBSTR(IT.CDFISCOPERSN,2,3),IT.CDFISCOPERSN), CDFISCOPERIT, DECODE(CDFISCALIT, '1', VRALIQITEM, 0)
                                        UNION ALL
                                        /* NOTAS DE ENTRADA COM CARGA TRIBUTÁRIA */
                                        SELECT DECODE(LENGTH(IT.CDFISCOPERSN),4,SUBSTR(IT.CDFISCOPERSN,2,3),IT.CDFISCOPERSN) AS CST_ICMS,
                                               I.CDFISCOPERIT AS CFOP,
                                               DECODE(I.CDFISCALIT, '1', I.VRALIQITEM, 0) AS ALIQ_ICMS,
                                               SUM(I.VRCONTITIMP)+NVL(SUM(VALOR_REDUCAO(I.CDFILIAL, I.NRLANCTONF, I.CDSITUTRIBIT, I.NRSEQITPROD, I.CDFISCOPERIT, IT.CDFISCOPERSN, C_REGC100.CDMODDOCFISC, C_REGC100.IDSIMPLESNACIONAL)),0) VL_OPR,
                                               SUM(DECODE(CDFISCALIT,'1',VRBASECALCIT, 0) + DECODE(V_IDTPCARGATRIB,'O',0,DECODE(CDFISCALIT,'1',CASE WHEN V_SGESTADO <> 'SP' THEN VRBASECALCIT ELSE 0 END, 0))) AS VL_BC_ICMS,
                                               SUM(DECODE(CDFISCALIT,'1',VRIMPOSTOIT,  0) + DECODE(V_IDTPCARGATRIB,'O',0,DECODE(CDFISCALIT,'1',CASE WHEN V_SGESTADO <> 'SP' THEN VRIMPOSTOIT  ELSE 0 END, 0))) AS VL_ICMS,
                                               NVL(SUM(DECODE(I.CDFISCALIT,'1',VALOR_REDUCAO(I.CDFILIAL, I.NRLANCTONF, I.CDSITUTRIBIT, I.NRSEQITPROD, I.CDFISCOPERIT, IT.CDFISCOPERSN, C_REGC100.CDMODDOCFISC, C_REGC100.IDSIMPLESNACIONAL),0)),0) AS VL_RED_BC,
                                               SUM((SELECT NVL(SUM(VRIMPOSTOIT),0)
                                                      FROM ITEMPROIMPOS IT, IMPOSTO IM
                                                     WHERE (IT.CDFILIAL     = I.CDFILIAL           ) AND
                                                           (IT.NRLANCTONF   = I.NRLANCTONF         ) AND
                                                           (IT.CDIMPOSTO    = IM.CDIMPOSTO         ) AND
                                                           (IT.NRITPROIMPOS = '1'                  ) AND
                                                           (IT.CDFISCALIT   = '1'                  ) AND
                                                           (IM.CDIMPOSTONFE = '10'                 ) AND
                                                           I.NRSEQITPROD = IT.NRSEQITPROD         )) AS VL_IPI,
                                               '' AS COD_OBS,
                                               SUM(VALOR_IMPOSTO_ITEM_NFE(I.CDFILIAL,I.NRLANCTONF,I.NRSEQITPROD,'80','B','1')) AS BC_ST,
                                               SUM(VALOR_IMPOSTO_ITEM_NFE(I.CDFILIAL,I.NRLANCTONF,I.NRSEQITPROD,'80','I','1') + VALOR_FECP_ITEM_NFE(I.CDFILIAL,I.NRLANCTONF,I.NRSEQITPROD,'80','I','1')) AS IMP_ST
                                          FROM ITEMPROIMPOS I, IMPOSTO IM, ITEMPRODUTO IT
                                         WHERE I.CDFILIAL      = C_REGC100.CDFILIAL
                                           AND I.NRLANCTONF    = C_REGC100.NRLANCTONF
                                           AND C_REGC100.IDENTRSAIDOP = 'E'
                                           AND I.NRITPROIMPOS  = '1'
                                           AND IM.CDIMPOSTONFE = P_CDIMPOSTO
                                           AND IM.CDIMPOSTO    = I.CDIMPOSTO
                                           AND I.CDFILIAL      = IT.CDFILIAL
                                           AND I.NRLANCTONF    = IT.NRLANCTONF
                                           AND I.NRSEQITPROD   = IT.NRSEQITPROD
                                           AND VALOR_IMPOSTO_NFE(I.CDFILIAL,I.NRLANCTONF,'03','I','1') > 0
                                         GROUP BY DECODE(LENGTH(IT.CDFISCOPERSN),4,SUBSTR(IT.CDFISCOPERSN,2,3),IT.CDFISCOPERSN), CDFISCOPERIT, DECODE(CDFISCALIT, '1', VRALIQITEM, 0) ) T ) LOOP
                    INSERT INTO ARQMAGNETICO
                      (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
                    VALUES
                      ('19'||LPAD(RTRIM(V_CONTREGC), 8, '0'), C_REGC190.ARQ_C190, P_NRSEQARQMAG);
                    V_CONTREGC := NVL(V_CONTREGC,0) + 1;

                    IF P_VERSAO >= '013' THEN
                       FOR C_REGC191 IN (SELECT '|C191'          || '|' ||
                                                REPLACE(LTRIM(TO_CHAR(SUM(CASE WHEN DECODE(LENGTH(IP.CDFISCOPERSN),4,SUBSTR(IP.CDFISCOPERSN,2,3),IP.CDFISCOPERSN) <> '500' AND IM.CDIMPOSTONFE = '00'
                                                     THEN ROUND(IT.VRADICFECP,2)
                                                     ELSE 0 END),'999999999990.00')), '.', ',') || '|' ||
                                                REPLACE(LTRIM(TO_CHAR(SUM(CASE WHEN DECODE(LENGTH(IP.CDFISCOPERSN),4,SUBSTR(IP.CDFISCOPERSN,2,3),IP.CDFISCOPERSN) IN ('201','202','203','900') AND IM.CDIMPOSTONFE = '80'
                                                     THEN ROUND(IT.VRADICFECP,2)
                                                     ELSE 0 END),'999999999990.00')), '.', ',') || '|' ||
                                                REPLACE(LTRIM(TO_CHAR(SUM(CASE WHEN DECODE(LENGTH(IP.CDFISCOPERSN),4,SUBSTR(IP.CDFISCOPERSN,2,3),IP.CDFISCOPERSN) = '500'
                                                     THEN ROUND(IT.VRADICFECP,2)
                                                     ELSE 0 END),'999999999990.00')), '.', ',') || '|' AS ARQ_C191, IT.CDFISCOPERIT
                                           FROM ITEMPROIMPOS IT, ITEMPROIMPOS II, IMPOSTO IM, ITEMPRODUTO IP
                                          WHERE IT.CDFILIAL     = C_REGC100.CDFILIAL
                                            AND IT.NRLANCTONF   = C_REGC100.NRLANCTONF
                                            AND IT.CDFISCOPERIT = C_REGC190.COD_NAT
                                            AND IT.VRALIQITEM   = C_REGC190.ALIQ_ICMS
                                            AND IT.NRITPROIMPOS = '1'
                                            AND IT.CDFILIAL     = II.CDFILIAL
                                            AND IT.NRLANCTONF   = II.NRLANCTONF
                                            AND IT.NRSEQITPROD  = II.NRSEQITPROD
                                            AND II.CDFISCOPERIT = C_REGC190.COD_NAT
                                            AND II.CDIMPOSTO    = IM.CDIMPOSTO
                                            AND IM.CDIMPOSTONFE IN ('00','80')
                                            AND II.VRADICFECP   > 0
                                            AND II.CDFILIAL     = IP.CDFILIAL
                                            AND II.NRLANCTONF   = IP.NRLANCTONF
                                            AND II.NRSEQITPROD  = IP.NRSEQITPROD
                                            AND DECODE(LENGTH(IP.CDFISCOPERSN),4,SUBSTR(IP.CDFISCOPERSN,2,3),IP.CDFISCOPERSN) = C_REGC190.CST_ICMS
                                          GROUP BY IT.CDFISCOPERIT) LOOP
                          INSERT INTO ARQMAGNETICO
                             (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
                          VALUES
                             ('19'||LPAD(RTRIM(V_CONTREGC), 8, '0'), C_REGC191.ARQ_C191, P_NRSEQARQMAG);
                          V_CONTREGC := NVL(V_CONTREGC,0) + 1;
                       END LOOP;
                    END IF;
                 END LOOP;
             END IF;
          END IF;
          /* geracao dos registros com diferencial  de aliquota */
          IF P_IDDIFALIQ = 'S' THEN
             SELECT MAX(SGESTADO)
               INTO V_SGESTADO
               FROM INSCRESTAD
              WHERE CDEMPRESA = P_CDEMPRESA
                AND CDINSCESTA = P_CDINSCESTA;

             IF C_REGC100.IDENTRSAIDOP = 'E' THEN

                /*BUSCA O CÓDIGO DE AJUSTE CADASTRADO PARA ESTA IE*/
                BEGIN
                   SELECT CDAJUSTEC195, IDGERREGC197, IDDIFEALIQUOTA
                     INTO V_CDAJUSTEC195,V_IDGERREGC197, V_IDDIFEALIQUOTA
                     FROM PARAMESTSPED
                    WHERE CDEMPRESA  = P_CDEMPRESA
                      AND CDINSCESTA = P_CDINSCESTA;
                EXCEPTION
                   WHEN NO_DATA_FOUND THEN
                      V_CDAJUSTEC195:= NULL;
                      V_IDGERREGC197:= NULL;
                END;

                /* REGISTRO C195 */
                FOR C_REGC195 IN (SELECT REPLACE(LTRIM(TO_CHAR(ROUND(SUM(VRBASECALCIT),2), '999999999990.00')), '.', ',') AS VL_BC_ICMS,
                                         REPLACE(LTRIM(TO_CHAR(ROUND((SUM(VRIMPOSTOIT)/SUM(VRBASECALCIT))*100,2), '999999999990.00')), '.', ',') AS ALIQ_ICMS,
                                         REPLACE(LTRIM(TO_CHAR(ROUND(SUM(VRIMPOSTOIT),2), '999999999990.00')), '.', ',') AS VL_ICMS,
                                         0 AS VL_OUTROS,
                                         'Diferencial de Alíquota' AS DESCR_COMPL_AJ,
                                         V_CDAJUSTEC195 AS COD_AJ
                                    FROM ITEMPROIMPOS I, IMPOSTO IM
                                   WHERE NRITPROIMPOS    = '3'
                                     AND IM.CDIMPOSTONFE = P_CDIMPOSTO
                                     AND I.CDIMPOSTO     = IM.CDIMPOSTO
                                     AND I.NRLANCTONF    = C_REGC100.NRLANCTONF
                                     AND I.CDFILIAL      = C_REGC100.CDFILIAL
                                     AND V_CDAJUSTEC195  IS NOT NULL
                                     AND V_IDGERREGC197  = 'S'
                                     AND NVL(V_IDDIFEALIQUOTA,'DA') <> 'OD'
                                    GROUP BY V_CDAJUSTEC195,'Diferencial de Alíquota')LOOP
                   INSERT INTO ARQMAGNETICO
                     (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
                   VALUES
                     ('19'||LPAD(RTRIM(V_CONTREGC), 8, '0'), '|C195'  || '|' || '000001' || '|' || ''  || '|', P_NRSEQARQMAG);
                   V_CONTREGC := NVL(V_CONTREGC,0) + 1;

                   IF NVL(V_IDGERREGC197,'N') = 'S' THEN
                      V_REG_C197 := '|C197'                   || '|' ||
                                    C_REGC195.COD_AJ          || '|' ||
                                    C_REGC195.DESCR_COMPL_AJ  || '|' ||
                                    ''                        || '|' ||
                                    C_REGC195.VL_BC_ICMS      || '|' ||
                                    C_REGC195.ALIQ_ICMS       || '|' ||
                                    C_REGC195.VL_ICMS         || '|' ||
                                    C_REGC195.VL_OUTROS       || '|' ;
                      INSERT INTO ARQMAGNETICO
                        (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
                      VALUES
                        ('19'||LPAD(RTRIM(V_CONTREGC), 8, '0'), V_REG_C197, P_NRSEQARQMAG);
                      V_CONTREGC := NVL(V_CONTREGC,0) + 1;
                   END IF;
                   SELECT MAX(CDCHAVEREG)
                     INTO V_COD_OBS
                     FROM TMP_REGDADOSSPED
                    WHERE CDCHAVEREG = '000001'
                      AND CDREGISTRO = '0460';

                   IF (V_COD_OBS IS NULL) THEN

                      V_SEQUPROD := NVL(V_SEQUPROD,0) + 1;
                      INSERT INTO TMP_REGDADOSSPED
                        (CDREGISTRO, CDCONTREGI, CDCHAVEREG, CDCAMPO1)
                      VALUES
                        ('0460', V_SEQUPROD, '000001', 'Diferencial de Alíquota');
                   END IF;

                END LOOP;
             END IF;
          END IF;
       END LOOP;
   END IF;


   IF V_CDSITUCRT = '3' AND P_PERFIL = 'B' THEN
      FOR C_REGC300 IN (SELECT ('|C300'    || '|' ||
                               COD_MOD     || '|' ||
                               SERIE       || '|' ||
                               ''          || '|' ||
                               NUM_DOC     || '|' ||
                               NUM_DOC     || '|' ||
                               DT_DOC      || '|' ||
                               VL_DOC      || '|' ||
                               VL_PIS      || '|' ||
                               VL_COFINS   || '|' ||
                               COD_CTA     || '|' ) AS ARQ_C300, NRLANCTONF, CDFILIAL, COD_CTA
                          FROM (SELECT N.CDMODDOCFISC  AS COD_MOD,
                                       NVL(SS.CDSERIENFE,N.CDSERIE) AS SERIE,
                                       SUBSTR(LPAD(NRNOTAFISC,10,'0'),5,6) AS NUM_DOC,
                                       TO_CHAR(N.DTEMISSAO,'ddmmyyyy') AS DT_DOC,
                                       REPLACE(LTRIM(TO_CHAR(ROUND(N.VRNOTAFISC,2), '999999999990.00')), '.', ',') AS VL_DOC,
                                       REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_NFE(I.CDFILIAL, I.NRLANCTONF, '50', 'I','1'),2), '999999999990.00')), '.', ',') AS VL_PIS,
                                       REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_NFE(I.CDFILIAL, I.NRLANCTONF, '60', 'I','1'),2), '999999999990.00')), '.', ',') AS VL_COFINS,
                                       MAX((SELECT MAX(CONTCTBL_SPED(N.IDENTRSAIDOP,I.CDPRODUTO,N.CDTIPOOPER,N.CDFILIEMIT))
                                              FROM ITEMPRODUTO I
                                             WHERE I.CDFILIAL   = N.CDFILIAL
                                               AND I.NRLANCTONF = N.NRLANCTONF)) AS COD_CTA,
                                       I.NRLANCTONF, I.CDFILIAL
                                  FROM IMPOSTONF I, NOTAFISCAL N, IMPOSTO IM, SERIENF SS
                                 WHERE IM.CDIMPOSTONFE   = P_CDIMPOSTO
                                   AND I.NRSEQUMAPAPU    = V_NRSEQUMAPAPU
                                   AND IM.CDIMPOSTO      = I.CDIMPOSTO
                                   AND N.CDMODDOCFISC    = '02'
                                   AND NVL(I.IDIMPOSTONF, '1') <> '3'
                                   AND I.CDFILIAL        = N.CDFILIAL
                                   AND I.NRLANCTONF      = N.NRLANCTONF
                                   AND N.IDENTRSAIDOP    = 'S'
                                   AND SS.CDEMPRESA(+)   = N.CDEMPRESA
                                   AND SS.CDINSCESTA(+)  = N.CDINSCESTA
                                   AND SS.CDINSCMUNI(+)  = N.CDINSCMUNI
                                   AND SS.CDSERIE(+)     = N.CDSERIE
                                   AND NVL(P_GERAFORSALE,'N')  = 'N'
                                   AND (NVL(N.IDSISTEMA,'DFS') <> 'REC'
                                   AND NVL(N.IDSISTEMA, 'DFS') <> 'PAG'
                                   AND NVL(N.IDSISTEMA, 'DFS') <> 'CMP'
                                   AND NVL(N.IDSISTEMA, 'DFS') <> 'SUP'
                                   AND NVL(N.IDSISTEMA, 'DFS') <> 'TMP'
                                   AND NVL(N.IDSISTEMA, 'DFS') <> 'FIS')
                                 GROUP BY N.CDMODDOCFISC,  NVL(SS.CDSERIENFE,N.CDSERIE), SUBSTR(LPAD(NRNOTAFISC,10,'0'),5,6), N.DTEMISSAO,N.VRNOTAFISC,
                                       VALOR_IMPOSTO_NFE(I.CDFILIAL, I.NRLANCTONF, '50', 'I','1'),
                                       VALOR_IMPOSTO_NFE(I.CDFILIAL, I.NRLANCTONF, '60', 'I','1'),
                                       I.NRLANCTONF, I.CDFILIAL)) LOOP
         INSERT INTO ARQMAGNETICO
           (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
         VALUES
           ('20'||LPAD(RTRIM(V_CONTREGC), 8, '0'), C_REGC300.ARQ_C300, P_NRSEQARQMAG);
         V_CONTREGC := NVL(V_CONTREGC,0) + 1;

         /* PLANO DE CONTAS REFERENCIAL */
         SELECT MAX(CDCHAVEREG)
           INTO V_CONTCTBL
           FROM TMP_REGDADOSSPED
          WHERE CDCHAVEREG = C_REGC300.COD_CTA
            AND CDREGISTRO = '0500';

         IF (V_CONTCTBL IS NULL) AND (C_REGC300.COD_CTA IS NOT NULL) THEN
            V_SEQUPROD := NVL(V_SEQUPROD,0) + 1;
            INSERT INTO TMP_REGDADOSSPED
               (CDREGISTRO, CDCONTREGI, CDCHAVEREG)
            VALUES
               ('0500', V_SEQUPROD, C_REGC300.COD_CTA);
         END IF;
         V_CONTCTBL := NULL;

         FOR C_REGC310 IN (SELECT ('|C310'       || '|' ||
                                  LTRIM(N.NRNOTAFISC, '0')  || '|'  ) AS ARQ_C310
                             FROM NOTAFISCAL N
                            WHERE N.CDFILIAL = C_REGC300.CDFILIAL
                              AND N.NRLANCTONF = C_REGC300.NRLANCTONF
                              AND N.IDENTRSAIDOP = 'S'
                              AND N.IDSTATUS = 'C') LOOP
            INSERT INTO ARQMAGNETICO
               (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
            VALUES
               ('20'||LPAD(RTRIM(V_CONTREGC), 8, '0'), C_REGC310.ARQ_C310, P_NRSEQARQMAG);
            V_CONTREGC := NVL(V_CONTREGC,0) + 1;
         END LOOP;

         FOR C_REGC320 IN(SELECT ('|C320'         || '|' ||
                                   CDSITUTRIBIT    || '|' ||
                                   CDFISCOPERIT    || '|' ||
                                   REPLACE(LTRIM(TO_CHAR(ROUND(VRALIQITEM,2), '999999999990.00')), '.', ',')    || '|' ||
                                   REPLACE(LTRIM(TO_CHAR(ABS(ROUND(SUM(VRCONTITIMP)+NVL(SUM(VALOR_REDUCAO(CDFILIAL, NRLANCTONF, CDSITUTRIBIT, NRSEQITPROD, CDFISCOPERIT, NULL, NULL, NULL)),0),2)), '999999999990.00')), '.', ',')    || '|' ||
                                   REPLACE(LTRIM(TO_CHAR(ROUND(SUM(DECODE(CDFISCALIT,'1',VRBASECALCIT,0) + DECODE(V_IDTPCARGATRIB,'O',0,VALOR_IMPOSTO_ITEM_NFE(IT.CDFILIAL,IT.NRLANCTONF,IT.NRSEQITPROD,'03','B','1'))),2), '999999999990.00')), '.', ',')    || '|' ||
                                   REPLACE(LTRIM(TO_CHAR(ROUND(SUM(DECODE(CDFISCALIT,'1',VRIMPOSTOIT, 0) + DECODE(V_IDTPCARGATRIB,'O',0,VALOR_IMPOSTO_ITEM_NFE(IT.CDFILIAL,IT.NRLANCTONF,IT.NRSEQITPROD,'03','I','1'))),2), '999999999990.00')), '.', ',')    || '|' ||
                                   REPLACE(LTRIM(TO_CHAR(ABS(ROUND(NVL(SUM(VALOR_REDUCAO(CDFILIAL, NRLANCTONF, CDSITUTRIBIT, NRSEQITPROD, CDFISCOPERIT, NULL, NULL, NULL) ),0),2)), '999999999990.00')), '.', ',')    || '|' ||
                                   ''  || '|'  ) AS ARQ_C320, CDFILIAL, NRLANCTONF, CDSITUTRIBIT, CDFISCOPERIT, VRALIQITEM
                             FROM ITEMPROIMPOS IT, IMPOSTO IM
                            WHERE IT.CDFILIAL     = C_REGC300.CDFILIAL
                              AND IT.NRLANCTONF   = C_REGC300.NRLANCTONF
                              AND IM.CDIMPOSTONFE = P_CDIMPOSTO
                              AND IM.CDIMPOSTO    = IT.CDIMPOSTO
                              AND IT.NRITPROIMPOS = '1'
                            GROUP BY CDSITUTRIBIT, CDFISCOPERIT, VRALIQITEM,
                                  CDFILIAL, NRLANCTONF) LOOP
             INSERT INTO ARQMAGNETICO 
               (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
             VALUES 
               ('20'||LPAD(RTRIM(V_CONTREGC), 8, '0'), C_REGC320.ARQ_C320, P_NRSEQARQMAG); 
             V_CONTREGC := NVL(V_CONTREGC,0) + 1; 
             FOR C_REGC321 IN(SELECT ('|C321'         || '|' ||
                                      P.CDARVPROD      || '|' ||
                                      REPLACE(LTRIM(TO_CHAR(ROUND(SUM(IT.QTITEMPROD),3), '999999999990.000')), '.', ',')  || '|' ||
                                      P.SGUNIDADE     || '|' ||
                                      REPLACE(LTRIM(TO_CHAR(ABS(ROUND(SUM(VRCONTITIMP)+NVL(SUM(VALOR_REDUCAO(I.CDFILIAL, I.NRLANCTONF, I.CDSITUTRIBIT, I.NRSEQITPROD, I.CDFISCOPERIT, NULL, NULL, NULL)),0),2)), '999999999990.00')), '.', ',')    || '|' ||
                                      REPLACE(LTRIM(TO_CHAR(ROUND(SUM(IT.VRENCARGODESC),2), '999999999990.00')), '.', ',')    || '|' ||
                                      REPLACE(LTRIM(TO_CHAR(ROUND(SUM(DECODE(CDFISCALIT,'1',VRBASECALCIT, 0)+DECODE(V_IDTPCARGATRIB,'O',0,VALOR_IMPOSTO_ITEM_NFE(I.CDFILIAL,I.NRLANCTONF,I.NRSEQITPROD,'03','B','1'))),2), '999999999990.00')), '.', ',')   || '|' ||
                                      REPLACE(LTRIM(TO_CHAR(ROUND(SUM(DECODE(CDFISCALIT,'1',I.VRIMPOSTOIT,0)+DECODE(V_IDTPCARGATRIB,'O',0,VALOR_IMPOSTO_ITEM_NFE(I.CDFILIAL,I.NRLANCTONF,I.NRSEQITPROD,'03','I','1'))),2), '999999999990.00')), '.', ',')    || '|' ||
                                      REPLACE(LTRIM(TO_CHAR(ROUND(SUM(VALOR_IMPOSTO_NFE(I.CDFILIAL, I.NRLANCTONF, '50', 'I','1')),2), '999999999990.00')), '.', ',')    || '|' ||
                                      REPLACE(LTRIM(TO_CHAR(ROUND(SUM(VALOR_IMPOSTO_NFE(I.CDFILIAL, I.NRLANCTONF, '60', 'I','1')),2), '999999999990.00')), '.', ',')    || '|'  ) AS ARQ_C321,
                                      P.CDPRODUTO, P.SGUNIDADE UNID, IT.CDPRODNCMTRANS AS CDCLASFISC
                                 FROM ITEMPROIMPOS I, ITEMPRODUTO IT, PRODUTO P, IMPOSTO IM
                                WHERE IT.CDFILIAL     = C_REGC320.CDFILIAL
                                  AND IT.NRLANCTONF   = C_REGC320.NRLANCTONF
                                  AND I.CDFILIAL      = IT.CDFILIAL
                                  AND I.NRLANCTONF    = IT.NRLANCTONF
                                  AND I.NRSEQITPROD   = IT.NRSEQITPROD
                                  AND IT.CDPRODUTO    = P.CDPRODUTO
                                  AND IM.CDIMPOSTONFE = P_CDIMPOSTO
                                  AND IM.CDIMPOSTO    = I.CDIMPOSTO
                                  AND VRALIQITEM      = C_REGC320.VRALIQITEM
                                  AND CDSITUTRIBIT    = C_REGC320.CDSITUTRIBIT
                                  AND CDFISCOPERIT    = C_REGC320.CDFISCOPERIT
                                  AND NRITPROIMPOS    = '1'
                                GROUP BY P.CDARVPROD, P.CDPRODUTO, P.SGUNIDADE, IT.CDPRODNCMTRANS) LOOP
                   INSERT INTO ARQMAGNETICO 
                     (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG) 
                   VALUES 
                     ('20'||LPAD(RTRIM(V_CONTREGC), 8, '0'), C_REGC321.ARQ_C321, P_NRSEQARQMAG); 
                   V_CONTREGC := NVL(V_CONTREGC,0) + 1; 
                /* CODIGO DO PRODUTO */
                SELECT MAX(CDCHAVEREG) 
                  INTO V_PRODUTO 
                  FROM TMP_REGDADOSSPED 
                 WHERE CDCHAVEREG = C_REGC321.CDPRODUTO 
                   AND CDREGISTRO = '0200';
                IF (V_PRODUTO IS NULL) AND (C_REGC321.CDPRODUTO IS NOT NULL) THEN
                   V_SEQUPROD := NVL(V_SEQUPROD,0) + 1; 
                   INSERT INTO TMP_REGDADOSSPED 
                     (CDREGISTRO, CDCONTREGI, CDCHAVEREG, CDCAMPO3)
                   VALUES 
                     ('0200', V_SEQUPROD, C_REGC321.CDPRODUTO, C_REGC321.CDCLASFISC);
                END IF; 
                V_PRODUTO := NULL; 
                /* UNIDADE DE MEDIDA */
                SELECT MAX(CDCHAVEREG) 
                  INTO V_UNID 
                  FROM TMP_REGDADOSSPED 
                 WHERE CDCHAVEREG = C_REGC321.UNID 
                   AND CDREGISTRO = '0190'; 
                IF (V_UNID IS NULL) AND (C_REGC321.UNID IS NOT NULL) THEN 
                   V_SEQUPROD := NVL(V_SEQUPROD,0) + 1; 
                   INSERT INTO TMP_REGDADOSSPED 
                     (CDREGISTRO, CDCONTREGI, CDCHAVEREG) 
                   VALUES 
                     ('0190', V_SEQUPROD, C_REGC321.UNID); 
                END IF; 
                V_UNID := NULL; 
             END LOOP; 
          END LOOP; 
       END LOOP; 
   END IF; 
 
   IF V_CDSITUCRT <> '3' AND P_PERFIL = 'B' THEN /*SIMPLES NACIONAL*/
      FOR C_REGC300 IN (SELECT '|C300'     || '|' ||
                               COD_MOD     || '|' ||
                               SERIE       || '|' ||
                               ''          || '|' ||
                               NUM_DOC     || '|' ||
                               NUM_DOC     || '|' ||
                               DT_DOC      || '|' ||
                               VL_DOC      || '|' ||
                               VL_PIS      || '|' ||
                               VL_COFINS   || '|' ||
                               COD_CTA     || '|'  AS ARQ_C300, NRLANCTONF, CDFILIAL, COD_CTA
                          FROM (SELECT N.CDMODDOCFISC AS COD_MOD,
                                       NVL(SS.CDSERIENFE,N.CDSERIE) AS SERIE,
                                       SUBSTR(LPAD(NRNOTAFISC,10,'0'),5,6) AS NUM_DOC,
                                       TO_CHAR(N.DTEMISSAO,'ddmmyyyy') AS DT_DOC,
                                       REPLACE(LTRIM(TO_CHAR(ROUND(N.VRNOTAFISC,2), '999999999990.00')), '.', ',') AS VL_DOC,
                                       REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_NFE(I.CDFILIAL, I.NRLANCTONF, '50', 'I','1'),2), '999999999990.00')), '.', ',') AS VL_PIS,
                                       REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_NFE(I.CDFILIAL, I.NRLANCTONF, '60', 'I','1'),2), '999999999990.00')), '.', ',') AS VL_COFINS,
                                       MAX((SELECT MAX(CONTCTBL_SPED(N.IDENTRSAIDOP,I.CDPRODUTO,N.CDTIPOOPER,N.CDFILIEMIT))
                                              FROM ITEMPRODUTO I
                                             WHERE I.CDFILIAL   = N.CDFILIAL
                                               AND I.NRLANCTONF = N.NRLANCTONF)) AS COD_CTA, I.NRLANCTONF, I.CDFILIAL
                                  FROM IMPOSTONF I, NOTAFISCAL N, IMPOSTO IM, SERIENF SS
                                 WHERE IM.CDIMPOSTONFE = P_CDIMPOSTO
                                   AND N.NRSEQUMAPAPUSN  = V_NRSEQUMAPAPU
                                   AND N.CDINSCESTA    = P_CDINSCESTA
                                   AND IM.CDIMPOSTO    = I.CDIMPOSTO
                                   AND N.CDMODDOCFISC  = '02'
                                   AND NVL(I.IDIMPOSTONF, '1') <> '3'
                                   AND I.CDFILIAL      = N.CDFILIAL
                                   AND I.NRLANCTONF    = N.NRLANCTONF
                                   AND N.IDENTRSAIDOP  = 'S'
                                   AND SS.CDEMPRESA(+)   = N.CDEMPRESA
                                   AND SS.CDINSCESTA(+)  = N.CDINSCESTA
                                   AND SS.CDINSCMUNI(+)  = N.CDINSCMUNI
                                   AND SS.CDSERIE(+)     = N.CDSERIE
                                   AND NVL(P_GERAFORSALE,'N') = 'N'
                                   AND (NVL(N.IDSISTEMA,'DFS') <> 'REC'
                                   AND NVL(N.IDSISTEMA, 'DFS') <> 'PAG'
                                   AND NVL(N.IDSISTEMA, 'DFS') <> 'CMP'
                                   AND NVL(N.IDSISTEMA, 'DFS') <> 'SUP'
                                   AND NVL(N.IDSISTEMA, 'DFS') <> 'TMP'
                                   AND NVL(N.IDSISTEMA, 'DFS') <> 'FIS')
                                 GROUP BY N.CDMODDOCFISC, NVL(SS.CDSERIENFE,N.CDSERIE), SUBSTR(LPAD(NRNOTAFISC,10,'0'),5,6), N.DTEMISSAO,N.VRNOTAFISC,
                                       VALOR_IMPOSTO_NFE(I.CDFILIAL, I.NRLANCTONF, '50', 'I','1'), VALOR_IMPOSTO_NFE(I.CDFILIAL, I.NRLANCTONF, '60', 'I','1'),
                                       I.NRLANCTONF, I.CDFILIAL)) LOOP

         INSERT INTO ARQMAGNETICO
            (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
         VALUES
            ('20'||LPAD(RTRIM(V_CONTREGC), 8, '0'), C_REGC300.ARQ_C300, P_NRSEQARQMAG);
         V_CONTREGC := NVL(V_CONTREGC,0) + 1;

         /* PLANO DE CONTAS REFERENCIAL */
         SELECT MAX(CDCHAVEREG)
           INTO V_CONTCTBL
           FROM TMP_REGDADOSSPED
          WHERE CDCHAVEREG = C_REGC300.COD_CTA
            AND CDREGISTRO = '0500';

         IF (V_CONTCTBL IS NULL) AND (C_REGC300.COD_CTA IS NOT NULL) THEN
            V_SEQUPROD := NVL(V_SEQUPROD,0) + 1;
            INSERT INTO TMP_REGDADOSSPED
               (CDREGISTRO, CDCONTREGI, CDCHAVEREG)
            VALUES
               ('0500', V_SEQUPROD, C_REGC300.COD_CTA);
         END IF;
         V_CONTCTBL := NULL;

         FOR C_REGC310 IN (SELECT ('|C310'       || '|' ||
                                  LTRIM(N.NRNOTAFISC, '0')  || '|'  ) AS ARQ_C310
                             FROM NOTAFISCAL N
                            WHERE N.CDFILIAL = C_REGC300.CDFILIAL
                              AND N.NRLANCTONF = C_REGC300.NRLANCTONF
                              AND N.IDENTRSAIDOP = 'S'
                              AND N.IDSTATUS = 'C') LOOP
            INSERT INTO ARQMAGNETICO
               (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
            VALUES
               ('20'||LPAD(RTRIM(V_CONTREGC), 8, '0'), C_REGC310.ARQ_C310, P_NRSEQARQMAG);
            V_CONTREGC := NVL(V_CONTREGC,0) + 1;
         END LOOP;

         FOR C_REGC320 IN (SELECT ('|C320'         || '|' ||
                                  CDSITUTRIBIT    || '|' ||
                                  CDFISCOPERIT    || '|' ||
                                  REPLACE(LTRIM(TO_CHAR(ROUND(VRALIQITEM,2), '999999999990.00')), '.', ',')    || '|' ||
                                  REPLACE(LTRIM(TO_CHAR(ABS(ROUND(SUM(VRCONTITIMP)+NVL(SUM(VALOR_REDUCAO(CDFILIAL, NRLANCTONF, CDSITUTRIBIT, NRSEQITPROD, CDFISCOPERIT, NULL, NULL, NULL)),0),2)), '999999999990.00')), '.', ',')    || '|' ||
                                  REPLACE(LTRIM(TO_CHAR(ROUND(SUM(DECODE(CDFISCALIT,'1',VRBASECALCIT,0)+DECODE(V_IDTPCARGATRIB,'O',0,VALOR_IMPOSTO_ITEM_NFE(IT.CDFILIAL,IT.NRLANCTONF,IT.NRSEQITPROD,'03','I','1'))),2), '999999999990.00')), '.', ',')    || '|' ||
                                  REPLACE(LTRIM(TO_CHAR(ROUND(SUM(DECODE(CDFISCALIT,'1',VRIMPOSTOIT, 0)+DECODE(V_IDTPCARGATRIB,'O',0,VALOR_IMPOSTO_ITEM_NFE(IT.CDFILIAL,IT.NRLANCTONF,IT.NRSEQITPROD,'03','I','1'))),2), '999999999990.00')), '.', ',')    || '|' ||
                                  REPLACE(LTRIM(TO_CHAR(ABS(ROUND(NVL(SUM(VALOR_REDUCAO(CDFILIAL, NRLANCTONF, CDSITUTRIBIT, NRSEQITPROD, CDFISCOPERIT, NULL, NULL, NULL) ),0),2)), '999999999990.00')), '.', ',')    || '|' ||
                                  ''  || '|'  ) AS ARQ_C320, CDFILIAL, NRLANCTONF, CDSITUTRIBIT, CDFISCOPERIT, VRALIQITEM
                             FROM ITEMPROIMPOS IT, IMPOSTO IM
                            WHERE IT.CDFILIAL     = C_REGC300.CDFILIAL
                              AND IT.NRLANCTONF   = C_REGC300.NRLANCTONF
                              AND IM.CDIMPOSTONFE = P_CDIMPOSTO
                              AND IM.CDIMPOSTO    = IT.CDIMPOSTO
                              AND IT.NRITPROIMPOS = '1'
                            GROUP BY CDSITUTRIBIT, CDFISCOPERIT, VRALIQITEM,
                                  CDFILIAL, NRLANCTONF) LOOP

            INSERT INTO ARQMAGNETICO
               (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
            VALUES
               ('20'||LPAD(RTRIM(V_CONTREGC), 8, '0'), C_REGC320.ARQ_C320, P_NRSEQARQMAG);
            V_CONTREGC := NVL(V_CONTREGC,0) + 1;

            FOR C_REGC321 IN (SELECT ('|C321'         || '|' ||
                                     P.CDARVPROD      || '|' ||
                                     ROUND(SUM(IT.QTITEMPROD),3)   || '|' ||
                                     P.SGUNIDADE     || '|' ||
                                     REPLACE(LTRIM(TO_CHAR(ABS(ROUND(SUM(VRCONTITIMP)+NVL(SUM(VALOR_REDUCAO(I.CDFILIAL, I.NRLANCTONF, I.CDSITUTRIBIT, I.NRSEQITPROD, I.CDFISCOPERIT, NULL, NULL, NULL)),0),2)), '999999999990.00')), '.', ',')    || '|' ||
                                     REPLACE(LTRIM(TO_CHAR(ROUND(SUM(IT.VRENCARGODESC),2), '999999999990.00')), '.', ',')    || '|' ||
                                     REPLACE(LTRIM(TO_CHAR(ROUND(SUM(DECODE(CDFISCALIT,'1',VRBASECALCIT, 0)+DECODE(V_IDTPCARGATRIB,'O',0,VALOR_IMPOSTO_ITEM_NFE(I.CDFILIAL,I.NRLANCTONF,I.NRSEQITPROD,'03','I','1'))),2), '999999999990.00')), '.', ',')   || '|' ||
                                     REPLACE(LTRIM(TO_CHAR(ROUND(SUM(DECODE(CDFISCALIT,'1',I.VRIMPOSTOIT,0)+DECODE(V_IDTPCARGATRIB,'O',0,VALOR_IMPOSTO_ITEM_NFE(I.CDFILIAL,I.NRLANCTONF,I.NRSEQITPROD,'03','I','1'))),2), '999999999990.00')), '.', ',')   || '|' ||
                                     REPLACE(LTRIM(TO_CHAR(ROUND(SUM(VALOR_IMPOSTO_NFE(I.CDFILIAL, I.NRLANCTONF, '50', 'I','1')),2), '999999999990.00')), '.', ',')    || '|' ||
                                     REPLACE(LTRIM(TO_CHAR(ROUND(SUM(VALOR_IMPOSTO_NFE(I.CDFILIAL, I.NRLANCTONF, '60', 'I','1')),2), '999999999990.00')), '.', ',')    || '|'  ) AS ARQ_C321,
                                     P.CDPRODUTO, P.SGUNIDADE AS UNID, IT.CDPRODNCMTRANS AS CDCLASFISC
                                FROM ITEMPROIMPOS I, ITEMPRODUTO IT, PRODUTO P, IMPOSTO IM
                               WHERE IT.CDFILIAL     = C_REGC320.CDFILIAL
                                 AND IT.NRLANCTONF   = C_REGC320.NRLANCTONF
                                 AND I.CDFILIAL      = IT.CDFILIAL
                                 AND I.NRLANCTONF    = IT.NRLANCTONF
                                 AND I.NRSEQITPROD   = IT.NRSEQITPROD
                                 AND IT.CDPRODUTO    = P.CDPRODUTO
                                 AND IM.CDIMPOSTONFE = P_CDIMPOSTO
                                 AND IM.CDIMPOSTO    = I.CDIMPOSTO
                                 AND VRALIQITEM      = C_REGC320.VRALIQITEM
                                 AND CDSITUTRIBIT    = C_REGC320.CDSITUTRIBIT
                                 AND CDFISCOPERIT    = C_REGC320.CDFISCOPERIT
                                 AND NRITPROIMPOS    = '1'
                               GROUP BY P.CDARVPROD, P.CDPRODUTO, P.SGUNIDADE, IT.CDPRODNCMTRANS) LOOP

               INSERT INTO ARQMAGNETICO
                  (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
               VALUES
                  ('20'||LPAD(RTRIM(V_CONTREGC), 8, '0'), C_REGC321.ARQ_C321, P_NRSEQARQMAG);
               V_CONTREGC := NVL(V_CONTREGC,0) + 1;

               /* CODIGO DO PRODUTO */
               SELECT MAX(CDCHAVEREG)
                 INTO V_PRODUTO
                 FROM TMP_REGDADOSSPED
                WHERE CDCHAVEREG = C_REGC321.CDPRODUTO
                  AND CDREGISTRO = '0200';
               IF (V_PRODUTO IS NULL) AND (C_REGC321.CDPRODUTO IS NOT NULL) THEN
                  V_SEQUPROD := NVL(V_SEQUPROD,0) + 1;
                  INSERT INTO TMP_REGDADOSSPED
                    (CDREGISTRO, CDCONTREGI, CDCHAVEREG, CDCAMPO3)
                  VALUES
                    ('0200', V_SEQUPROD, C_REGC321.CDPRODUTO, C_REGC321.CDCLASFISC);
               END IF;
               V_PRODUTO := NULL;

               /* UNIDADE DE MEDIDA */
               SELECT MAX(CDCHAVEREG)
                 INTO V_UNID
                 FROM TMP_REGDADOSSPED
                WHERE CDCHAVEREG = C_REGC321.UNID
                  AND CDREGISTRO = '0190';
               IF (V_UNID IS NULL) AND (C_REGC321.UNID IS NOT NULL) THEN
                  V_SEQUPROD := NVL(V_SEQUPROD,0) + 1;
                  INSERT INTO TMP_REGDADOSSPED
                    (CDREGISTRO, CDCONTREGI, CDCHAVEREG)
                  VALUES
                    ('0190', V_SEQUPROD, C_REGC321.UNID);
               END IF;
               V_UNID := NULL;
            END LOOP;
         END LOOP;
      END LOOP;
   END IF;

   IF V_CDSITUCRT = '3' AND P_PERFIL = 'A' THEN
      /*REGISTRO C350*/
      FOR C_REGC350 IN (SELECT '|C350'       || '|' ||
                               SERIE         || '|' ||
                               ''            || '|' ||
                               NUM_DOC       || '|' ||
                               DT_DOC        || '|' ||
                               CNPJ_CPF      || '|' || --CPF_CNPJ
                               VL_MERC       || '|' ||
                               VL_DOC        || '|' ||
                               VL_DESC       || '|' ||
                               VL_PIS        || '|' ||
                               VL_COFINS     || '|' ||
                               COD_CTA       || '|' AS ARQ_C350, NRLANCTONF, CDFILIAL, CDCLIENTE, CDCAIXA, COD_CTA
                          FROM (SELECT NVL(SS.CDSERIENFE,N.CDSERIE) AS SERIE,
                                       SUBSTR(LPAD(NRNOTAFISC,10,'0'),5,6) AS NUM_DOC,
                                       TO_CHAR(N.DTEMISSAO,'ddmmyyyy') AS DT_DOC,
                                       NVL(SUBSTR(REPLACE(REPLACE(REPLACE(REPLACE(CASE WHEN (LENGTH(N.NRINSJURNF) = 14 OR LENGTH(N.NRINSJURNF) = 11) THEN N.NRINSJURNF ELSE N.NRINSJURNFPAULI END,'.'),'-'),'/'),' '),1,14),'') AS CNPJ_CPF,
                                       REPLACE(LTRIM(TO_CHAR(ROUND(N.VRPRODUTOS,2), '999999999990.00')), '.', ',') AS VL_MERC,
                                       REPLACE(LTRIM(TO_CHAR(ROUND(N.VRNOTAFISC,2), '999999999990.00')), '.', ',') AS VL_DOC,
                                       REPLACE(LTRIM(TO_CHAR(ROUND(SUM(T.VRITEMENCA),2), '999999999990.00')), '.', ',') AS VL_DESC,
                                       REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_NFE(I.CDFILIAL, I.NRLANCTONF, '50', 'I','1'),2), '999999999990.00')), '.', ',') AS VL_PIS,
                                       REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_NFE(I.CDFILIAL, I.NRLANCTONF, '60', 'I','1'),2), '999999999990.00')), '.', ',') AS VL_COFINS,
                                       MAX((SELECT MAX(CONTCTBL_SPED(N.IDENTRSAIDOP,I.CDPRODUTO,N.CDTIPOOPER,N.CDFILIEMIT))
                                                     FROM ITEMPRODUTO I
                                                    WHERE I.CDFILIAL   = N.CDFILIAL
                                                      AND I.NRLANCTONF = N.NRLANCTONF)) AS COD_CTA,
                                       I.NRLANCTONF, I.CDFILIAL, N.CDCLIENTE, '' AS  CDCAIXA
                                  FROM IMPOSTONF I, NOTAFISCAL N, ENCARGO E, ITEMENCARGO T, IMPOSTO IM, SERIENF SS
                                 WHERE I.CDIMPOSTO      = IM.CDIMPOSTO
                                   AND IM.CDIMPOSTONFE  = P_CDIMPOSTO
                                   AND I.NRSEQUMAPAPU   = V_NRSEQUMAPAPU
                                   AND N.CDFILIAL       = T.CDFILIAL
                                   AND N.NRLANCTONF     = T.NRLANCTONF
                                   AND E.CDENCARGO      = T.CDENCARGO
                                   AND E.IDENCARGO      = 'D'
                                   AND N.CDMODDOCFISC   = '02'
                                   AND NVL(I.IDIMPOSTONF, '1') <> '3'
                                   AND I.CDFILIAL       = N.CDFILIAL
                                   AND I.NRLANCTONF     = N.NRLANCTONF
                                   AND N.IDENTRSAIDOP   = 'S'
                                   AND SS.CDEMPRESA(+)  = N.CDEMPRESA
                                   AND SS.CDINSCESTA(+) = N.CDINSCESTA
                                   AND SS.CDINSCMUNI(+) = N.CDINSCMUNI
                                   AND SS.CDSERIE(+)    = N.CDSERIE
                                   AND NVL(P_GERAFORSALE,'N') = 'N'
                                   AND (NVL(N.IDSISTEMA,'DFS') <> 'REC'
                                   AND NVL(N.IDSISTEMA, 'DFS') <> 'PAG'
                                   AND NVL(N.IDSISTEMA, 'DFS') <> 'CMP'
                                   AND NVL(N.IDSISTEMA, 'DFS') <> 'SUP'
                                   AND NVL(N.IDSISTEMA, 'DFS') <> 'TMP'
                                   AND NVL(N.IDSISTEMA, 'DFS') <> 'FIS')
                                 GROUP BY NVL(SS.CDSERIENFE,N.CDSERIE), SUBSTR(LPAD(NRNOTAFISC,10,'0'),5,6), TO_CHAR(N.DTEMISSAO,'ddmmyyyy'),
                                       N.CDCLIENTE, N.VRPRODUTOS, N.VRNOTAFISC,
                                       VALOR_IMPOSTO_NFE(I.CDFILIAL, I.NRLANCTONF, '50', 'I','1'),
                                       VALOR_IMPOSTO_NFE(I.CDFILIAL, I.NRLANCTONF, '60', 'I','1'),
                                       I.NRLANCTONF, I.CDFILIAL, '',
                                       NVL(SUBSTR(REPLACE(REPLACE(REPLACE(REPLACE(CASE WHEN (LENGTH(N.NRINSJURNF) = 14 OR LENGTH(N.NRINSJURNF) = 11) THEN N.NRINSJURNF ELSE N.NRINSJURNFPAULI END,'.'),'-'),'/'),' '),1,14),'')
                                 UNION
                                 /*GERA C350 PARA O FORSALE - C300 FOS*/
                                SELECT 'D' AS SERIE,
                                       SUBSTR(LPAD(NRNOTAFISC,10,'0'),5,6) AS NUM_DOC,
                                       TO_CHAR(DTEMISSAO,'DDMMYYYY') AS DT_DOC,
                                       NVL(REPLACE(REPLACE(REPLACE(REPLACE(NRINSCRCONS,'.'),'-'),'/'),' '),'') AS CNPJ_CPF,
                                       REPLACE(LTRIM(TO_CHAR(ROUND(VRNOTAFISC+VRDESITVEND,2), '999999999990.00')), '.', ',') AS VL_MERC,
                                       REPLACE(LTRIM(TO_CHAR(ROUND(VRNOTAFISC,2), '999999999990.00')), '.', ',')  AS VL_DOC,
                                       REPLACE(LTRIM(TO_CHAR(ROUND(VRDESITVEND,2), '999999999990.00')), '.', ',') AS VL_DESC,
                                       '0,00' AS VL_PIS,
                                       '0,00' AS VL_COFINS,
                                       CONTCTBL_SPED('S','',CDTIPOOPER,CDFILIAL) AS COD_CTA,
                                       NRLANCTONF, CDFILIAL, '' CDCLIENTE, CDCAIXA
                                  FROM (SELECT VE.DTENTRVENDA AS DTEMISSAO, VE.NRSERIEVND AS CDSERIE ,VE.NRSUBSERIEVND ,VE.NRORDEMVND AS NRNOTAFISC,
                                               SUM(TRUNC(IT.QTPRODVEND * (IT.VRUNITVEND+NVL(IT.VRUNITVENDCL,0)),2) - NVL(IT.VRDESITVEND,0) + NVL(IT.VRACRITVEND,0)) AS VRNOTAFISC,
                                               SUM(VRDESITVEND) AS VRDESITVEND, PV.CDTPOPERCNTREC AS CDTIPOOPER,
                                               VE.CDFILIAL, VE.NRSEQVENDA AS NRLANCTONF, VE.CDCAIXA, VE.NRINSCRCONS
                                          FROM VENDA VE, ITEMVENDA IT, PARAVEND PV
                                         WHERE VE.CDEMPRESA     =  P_CDEMPRESA
                                           AND VE.CDFILIAL      = IT.CDFILIAL
                                           AND VE.NRSEQVENDA    = IT.NRSEQVENDA
                                           AND VE.CDCAIXA       = IT.CDCAIXA
                                           AND VE.DTENTRVENDA   BETWEEN P_DTINICIAL AND P_DTFINAL
                                           AND VE.IDSITUVENDA   = 'O'
                                           AND VE.NRORDEMVND    IS NOT NULL
                                           AND VE.NRSUBSERIEVND IS NOT NULL
                                           AND VE.NRSERIEVND    IS NOT NULL
                                           AND NVL(P_GERAFORSALE,'N') = 'S'
                                           AND VE.CDFILIAL      = PV.CDFILIAL(+)
                                         GROUP BY VE.DTENTRVENDA, VE.NRSERIEVND, VE.NRSUBSERIEVND, VE.NRORDEMVND, VE.NRSEQVENDA,
                                               VE.CDFILIAL, VE.CDCAIXA, VE.NRINSCRCONS, PV.CDTPOPERCNTREC))) LOOP
         INSERT INTO ARQMAGNETICO
            (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
         VALUES
            ('24'||LPAD(RTRIM(V_CONTREGC), 8, '0'), C_REGC350.ARQ_C350, P_NRSEQARQMAG);
         V_CONTREGC := NVL(V_CONTREGC,0) + 1;

         /* PLANO DE CONTAS REFERENCIAL */
         SELECT MAX(CDCHAVEREG)
           INTO V_CONTCTBL
           FROM TMP_REGDADOSSPED
          WHERE CDCHAVEREG = C_REGC350.COD_CTA
            AND CDREGISTRO = '0500';

         IF (V_CONTCTBL IS NULL) AND (C_REGC350.COD_CTA IS NOT NULL) THEN
            V_SEQUPROD := NVL(V_SEQUPROD,0) + 1;
            INSERT INTO TMP_REGDADOSSPED
               (CDREGISTRO, CDCONTREGI, CDCHAVEREG)
            VALUES
               ('0500', V_SEQUPROD, C_REGC350.COD_CTA);
         END IF;
         V_CONTCTBL := NULL;

         V_NRSEQITEM := 0;
         FOR C_REGC370 IN(SELECT (P.CDARVPROD  || '|' ||
                                  REPLACE(LTRIM(TO_CHAR(ROUND(IT.QTITEMPROD,3), '99999999990.000')), '.', ',')  ||'|'||
                                  P.SGUNIDADE               || '|' ||
                                  REPLACE(LTRIM(TO_CHAR(ROUND((SUM(I.VRCONTITIMP)),2), '999999999990.00')), '.', ',')    || '|' ||
                                  REPLACE(LTRIM(TO_CHAR(ROUND((SUM(IT.VRENCARGODESC)),2), '999999999990.00')), '.', ',')    || '|' ) AS ARQ_C370,
                                  P.CDPRODUTO, P.SGUNIDADE AS UNID, IT.CDPRODNCMTRANS AS CDCLASFISC
                            FROM ITEMPROIMPOS I, ITEMPRODUTO IT, PRODUTO P, IMPOSTO IM
                           WHERE IT.CDFILIAL      = C_REGC350.CDFILIAL
                             AND IT.NRLANCTONF    = C_REGC350.NRLANCTONF
                             AND I.CDIMPOSTO      = IM.CDIMPOSTO
                             AND I.CDFILIAL       = IT.CDFILIAL
                             AND I.NRLANCTONF     = IT.NRLANCTONF
                             AND I.NRSEQITPROD    = IT.NRSEQITPROD
                             AND IT.CDPRODUTO     = P.CDPRODUTO
                             AND IM.CDIMPOSTONFE  = P_CDIMPOSTO
                             AND NVL(P_GERAFORSALE,'N') = 'N'
                           GROUP BY SUBSTR(I.NRSEQITPROD,2,3), P.CDARVPROD, IT.QTITEMPROD, P.SGUNIDADE, P.CDPRODUTO, IT.CDPRODNCMTRANS
                           UNION
                          SELECT CDARVPROD    ||'|'||
                                 REPLACE(LTRIM(TO_CHAR(ROUND(QTPRODVEND,3), '99999999990.000')), '.', ',')  ||'|'||
                                 SGUNIDADE    ||'|'||
                                 REPLACE(LTRIM(TO_CHAR(ROUND(VR_TOT_IT,2), '999999999990.00')), '.', ',')   ||'|'||
                                 REPLACE(LTRIM(TO_CHAR(ROUND(VRDESITVEND,2), '999999999990.00')), '.', ',') ||'|' AS ARQ_C370,
                                 CDPRODUTO, SGUNIDADE AS UNID, CDCLASFISC
                           FROM (SELECT NRSEQUITVEND,
                                        CDARVPROD,
                                        QTPRODVEND,
                                        P.SGUNIDADE,
                                        (IV.VRUNITVEND+NVL(IV.VRUNITVENDCL,0)+NVL(IV.VRACRITVEND,0)) AS VR_TOT_IT,
                                        VRDESITVEND, P.CDPRODUTO, IV.CDCLASFISC
                                   FROM ITEMVENDA IV, PRODUTO P
                                  WHERE IV.CDFILIAL = C_REGC350.CDFILIAL
                                    AND IV.CDCAIXA = C_REGC350.CDCAIXA
                                    AND IV.NRSEQVENDA =  C_REGC350.NRLANCTONF
                                    AND NVL(P_GERAFORSALE,'N') = 'S'
                                    AND IV.CDPRODUTO = P.CDPRODUTO)NF) LOOP

               V_NRSEQITEM := NVL(V_NRSEQITEM,0)+1;
               INSERT INTO ARQMAGNETICO
                 (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG) 
               VALUES
                 ('24'||LPAD(RTRIM(V_CONTREGC), 8, '0'), '|C370|'||LPAD(V_NRSEQITEM,3,'0')||'|'||C_REGC370.ARQ_C370, P_NRSEQARQMAG);
               V_CONTREGC := NVL(V_CONTREGC,0) + 1;
 
               /* CODIGO DO PRODUTO */
               SELECT MAX(CDCHAVEREG)
                 INTO V_PRODUTO
                 FROM TMP_REGDADOSSPED
                WHERE CDCHAVEREG = C_REGC370.CDPRODUTO
                  AND CDREGISTRO = '0200';

               IF (V_PRODUTO IS NULL) AND (C_REGC370.CDPRODUTO IS NOT NULL) THEN
                  V_SEQUPROD := NVL(V_SEQUPROD,0) + 1; 
                  INSERT INTO TMP_REGDADOSSPED
                    (CDREGISTRO, CDCONTREGI, CDCHAVEREG, CDCAMPO3)
                  VALUES
                    ('0200', V_SEQUPROD, C_REGC370.CDPRODUTO, C_REGC370.CDCLASFISC);
               END IF;
               V_PRODUTO := NULL;

               /* UNIDADE DE MEDIDA */
               SELECT MAX(CDCHAVEREG)
                 INTO V_UNID 
                 FROM TMP_REGDADOSSPED
                WHERE CDCHAVEREG = C_REGC370.UNID
                  AND CDREGISTRO = '0190';

               IF (V_UNID IS NULL) AND (C_REGC370.UNID IS NOT NULL) THEN
                  V_SEQUPROD := NVL(V_SEQUPROD,0) + 1;
                  INSERT INTO TMP_REGDADOSSPED
                    (CDREGISTRO, CDCONTREGI, CDCHAVEREG)
                  VALUES
                    ('0190', V_SEQUPROD, C_REGC370.UNID);
               END IF;
               V_UNID := NULL;
         END LOOP;

         FOR C_REGC390 IN(SELECT ('|C390'         || '|' ||
                                  NF.CDSITUTRIBNF|| '|' ||
                                  NF.CDFISCOPERNF    || '|' ||
                                  REPLACE(LTRIM(TO_CHAR(ROUND(NF.VRALIQNF,2),     '999999999990.00')), '.', ',')  || '|' ||
                                  REPLACE(LTRIM(TO_CHAR(ROUND(NF.VRCONTABILNF,2), '999999999990.00')), '.', ',')  || '|' ||
                                  REPLACE(LTRIM(TO_CHAR(ROUND(NF.VRBASECALCNF + DECODE(V_IDTPCARGATRIB,'O',0,DECODE(V_SGESTADO,'SP',0,NVL(NF.VRBASECARGA,0))),2), '999999999990.00')), '.', ',')  || '|' ||
                                  REPLACE(LTRIM(TO_CHAR(ROUND(NF.VRIMPOSTONF  + DECODE(V_IDTPCARGATRIB,'O',0,NVL(NF.VRIMPCARGA, 0)),2), '999999999990.00')), '.', ',')  || '|' ||
                                  REPLACE(LTRIM(TO_CHAR(ROUND(NF.VRREDBCALC,2),   '999999999990.00')), '.', ',')  || '|' ||
                                  ''  || '|'  ) AS ARQ_C390, CDFISCOPERNF
                            FROM (SELECT NVL(CDSITUTRIBNF,'000') AS CDSITUTRIBNF,
                                         CDFISCOPERNF,
                                         VRALIQNF,
                                         SUM(VRCONTABILNF) AS VRCONTABILNF,
                                         SUM((SELECT SUM(VRBASECALCNF)
                                                FROM IMPOSTONF IP
                                               WHERE IP.CDFILIAL     = I.CDFILIAL
                                                 AND IP.NRLANCTONF   = I.NRLANCTONF
                                                 AND IP.CDFISCOPERNF = I.CDFISCOPERNF
                                                 AND IP.CDIMPOSTO    = IM.CDIMPCARGATRIB)) AS VRBASECARGA,
                                         SUM(VRBASECALCNF) AS VRBASECALCNF,
                                         SUM(VRIMPCARGATRIBI) AS VRIMPCARGA,
                                         SUM(VRIMPOSTONF) AS VRIMPOSTONF,
                                         SUM(DECODE(IDIMPOSTONF, '2', VRCONTABILNF, '0')) AS VRREDBCALC
                                    FROM IMPOSTONF I, IMPOSTO IM
                                   WHERE I.CDFILIAL      = C_REGC350.CDFILIAL
                                     AND I.NRLANCTONF    = C_REGC350.NRLANCTONF
                                     AND I.CDIMPOSTO     = IM.CDIMPOSTO
                                     AND IM.CDIMPOSTONFE = P_CDIMPOSTO
                                     AND IDIMPOSTONF     <> '3'
                                     AND NVL(P_GERAFORSALE,'N') = 'N' 
                                   GROUP BY NVL(CDSITUTRIBNF,'000'), CDFISCOPERNF, VRALIQNF)NF
                           UNION
                          /*GERA REGISTRO C390 PARA O FOS - C390 FOS*/
                          SELECT '|C390'      ||'|'||
                                 CDSITUTRIBIT ||'|'||
                                 CDFISCOPERIT ||'|'||
                                 VRALIQITEM   ||'|'||
                                 REPLACE(LTRIM(TO_CHAR(ROUND(VR_OPER,2), '999999999990.00')), '.', ',')    ||'|'||
                                 REPLACE(LTRIM(TO_CHAR(ROUND(VR_BC_ICMS,2), '999999999990.00')), '.', ',') ||'|'||
                                 REPLACE(LTRIM(TO_CHAR(ROUND(VR_ICMS,2), '999999999990.00')), '.', ',')    ||'|'||
                                 REPLACE(LTRIM(TO_CHAR(ROUND(VR_RED,2), '999999999990.00')), '.', ',')     ||'|'||
                                 COD_OB       ||'|' AS ARQ_C390, CDFISCOPERIT AS CDFISCOPERNF
                            FROM (SELECT (NVL(LPAD(IVI.CDCSTPRODI,3,'0'), CASE WHEN IP.IDTPIMPOSFIS = 'T' THEN '000'
                                                                               WHEN IP.IDTPIMPOSFIS = 'I' THEN '040'
                                                                               WHEN IP.IDTPIMPOSFIS = 'F' THEN '060'
                                                                               WHEN IP.IDTPIMPOSFIS = 'N' THEN '041' END)) AS CDSITUTRIBIT,
                                         NVL(IVI.CDCSTPRODPC,'5102')  AS CDFISCOPERIT,
                                         REPLACE(LTRIM(TO_CHAR(ROUND(IVI.VRPEALPRODIT,2), '999999999990.00')), '.', ',') AS VRALIQITEM,
                                         (CASE WHEN IP.CDIMPOSTONFE = P_CDIMPOSTO
                                               THEN SUM(TRUNC(IV.QTPRODVEND * (IV.VRUNITVEND+NVL(IV.VRUNITVENDCL,0)),2) - NVL(IV.VRDESITVEND,0) + NVL(IV.VRACRITVEND,0))
                                               ELSE 0 END) AS VR_OPER,
                                         (CASE WHEN IP.IDTPIMPOSFIS = 'T' AND IP.CDIMPOSTONFE = P_CDIMPOSTO
                                               THEN SUM(TRUNC(IV.QTPRODVEND * (IV.VRUNITVEND+NVL(IV.VRUNITVENDCL,0)),2) - NVL(IV.VRDESITVEND,0) + NVL(IV.VRACRITVEND,0))
                                               ELSE 0 END) AS VR_BC_ICMS,
                                         (CASE WHEN IP.IDTPIMPOSFIS = 'T' AND IP.CDIMPOSTONFE = P_CDIMPOSTO
                                               THEN SUM(IVI.VRIMPOPRODIT)
                                               ELSE 0 END) AS VR_ICMS,
                                         0 AS VR_RED,'' AS COD_OB, IP.CDIMPOSTONFE
                                    FROM ITEMVENDA IV, ITVENDAIMPOS IVI, IMPOSTO IP
                                   WHERE IV.CDFILIAL     = IVI.CDFILIAL
                                     AND IV.CDCAIXA      = IVI.CDCAIXA
                                     AND IV.NRSEQUITVEND = IVI.NRSEQUITVEND
                                     AND IV.NRSEQVENDA   = IVI.NRSEQVENDA
                                     AND IV.CDFILIAL     = C_REGC350.CDFILIAL
                                     AND IV.CDCAIXA      =  C_REGC350.CDCAIXA
                                     AND IV.NRSEQVENDA   = C_REGC350.NRLANCTONF
                                     AND NVL(P_GERAFORSALE,'N') = 'S'
                                     AND IP.CDIMPOSTO    = IVI.CDIMPOSTO
                                   GROUP BY IVI.CDCSTPRODI, IVI.CDCSTPRODPC, IP.IDTPIMPOSFIS, IVI.VRPEALPRODIT, IP.CDIMPOSTONFE)NF
                           WHERE NF.CDIMPOSTONFE = P_CDIMPOSTO) LOOP
            INSERT INTO ARQMAGNETICO
              (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
            VALUES
              ('24'||LPAD(RTRIM(V_CONTREGC), 8, '0'), C_REGC390.ARQ_C390, P_NRSEQARQMAG);
            V_CONTREGC := NVL(V_CONTREGC,0) + 1;
         END LOOP;
      END LOOP;
   END IF;

   IF V_CDSITUCRT <> '3' AND P_PERFIL = 'A' THEN  /*SIMPLES NACIONAL*/
      /*REGISTRO C350*/
      FOR C_REGC350 IN (SELECT '|C350'     || '|' ||
                               SERIE       || '|' ||
                               ''          || '|' ||
                               NUM_DOC     || '|' ||
                               DT_DOC      || '|' ||
                               CNPJ_CPF    || '|' ||
                               VL_MERC     || '|' ||
                               VL_DOC      || '|' ||
                               VL_DESC     || '|' ||
                               VL_PIS      || '|' ||
                               VL_COFINS   || '|' ||
                               COD_CTA     || '|' AS ARQ_C350, NRLANCTONF, CDFILIAL, CDCLIENTE, CDCAIXA, COD_CTA
                          FROM (SELECT NVL(SS.CDSERIENFE,N.CDSERIE) AS SERIE,
                                       LTRIM(NRNOTAFISC, '0') AS NUM_DOC,
                                       TO_CHAR(N.DTEMISSAO,'ddmmyyyy') AS DT_DOC,
                                       NVL(SUBSTR(REPLACE(REPLACE(REPLACE(REPLACE(N.NRINSJURNF,'.'),'-'),'/'),' '),1,14),'') AS CNPJ_CPF,
                                       REPLACE(LTRIM(TO_CHAR(ROUND(N.VRPRODUTOS,2), '999999999990.00')), '.', ',') AS VL_MERC,
                                       REPLACE(LTRIM(TO_CHAR(ROUND(N.VRNOTAFISC,2), '999999999990.00')), '.', ',') AS VL_DOC,
                                       REPLACE(LTRIM(TO_CHAR(ROUND(SUM(T.VRITEMENCA),2), '999999999990.00')), '.', ',') AS VL_DESC,
                                       REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_NFE(I.CDFILIAL, I.NRLANCTONF, '50', 'I','1'),2), '999999999990.00')), '.', ',') AS VL_PIS,
                                       REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_NFE(I.CDFILIAL, I.NRLANCTONF, '60', 'I','1'),2), '999999999990.00')), '.', ',') AS VL_COFINS,
                                       MAX((SELECT MAX(CONTCTBL_SPED(N.IDENTRSAIDOP,I.CDPRODUTO,N.CDTIPOOPER,N.CDFILIEMIT))
                                                     FROM ITEMPRODUTO I
                                                    WHERE I.CDFILIAL   = N.CDFILIAL
                                                      AND I.NRLANCTONF = N.NRLANCTONF)) AS COD_CTA,
                                       I.NRLANCTONF, I.CDFILIAL, N.CDCLIENTE, '' AS  CDCAIXA
                                  FROM IMPOSTONF I, NOTAFISCAL N, ENCARGO E, ITEMENCARGO T, IMPOSTO IM, SERIENF SS
                                 WHERE I.CDIMPOSTO = IM.CDIMPOSTO
                                   AND IM.CDIMPOSTONFE = P_CDIMPOSTO
                                   AND N.NRSEQUMAPAPUSN = V_NRSEQUMAPAPU
                                   AND N.CDINSCESTA = P_CDINSCESTA
                                   AND N.CDFILIAL = T.CDFILIAL
                                   AND N.NRLANCTONF = T.NRLANCTONF
                                   AND E.CDENCARGO = T.CDENCARGO
                                   AND E.IDENCARGO = 'D'
                                   AND N.CDMODDOCFISC = '02'
                                   AND NVL(I.IDIMPOSTONF, '1') <> '3'
                                   AND I.CDFILIAL = N.CDFILIAL
                                   AND I.NRLANCTONF = N.NRLANCTONF
                                   AND N.IDENTRSAIDOP = 'S'
                                   AND SS.CDEMPRESA(+)   = N.CDEMPRESA
                                   AND SS.CDINSCESTA(+)  = N.CDINSCESTA
                                   AND SS.CDINSCMUNI(+)  = N.CDINSCMUNI
                                   AND SS.CDSERIE(+)     = N.CDSERIE
                                   AND NVL(P_GERAFORSALE,'N') = 'N'
                                   AND (NVL(N.IDSISTEMA,'DFS') <> 'REC'
                                   AND NVL(N.IDSISTEMA, 'DFS') <> 'PAG'
                                   AND NVL(N.IDSISTEMA, 'DFS') <> 'CMP'
                                   AND NVL(N.IDSISTEMA, 'DFS') <> 'SUP'
                                   AND NVL(N.IDSISTEMA, 'DFS') <> 'TMP'
                                   AND NVL(N.IDSISTEMA, 'DFS') <> 'FIS')
                                 GROUP BY NVL(SS.CDSERIENFE,N.CDSERIE), LTRIM(NRNOTAFISC, '0'),TO_CHAR(N.DTEMISSAO,'ddmmyyyy'),
                                          NVL(SUBSTR(REPLACE(REPLACE(REPLACE(REPLACE(N.NRINSJURNF,'.'),'-'),'/'),' '),1,14),''),
                                          N.CDCLIENTE, N.VRPRODUTOS, N.VRNOTAFISC,
                                          VALOR_IMPOSTO_NFE(I.CDFILIAL, I.NRLANCTONF, '50', 'I','1'),
                                          VALOR_IMPOSTO_NFE(I.CDFILIAL, I.NRLANCTONF, '60', 'I','1'),
                                          I.NRLANCTONF, I.CDFILIAL, ''
                                 UNION
                                /*GERA C350 PARA O FORSALE - C300 FOS*/
                                SELECT 'D' AS SERIE,
                                       SUBSTR(LPAD(NRNOTAFISC,10,'0'),5,6) AS NUM_DOC,
                                       TO_CHAR(DTEMISSAO,'DDMMYYYY') AS DT_DOC,
                                       NVL(REPLACE(REPLACE(REPLACE(REPLACE(NRINSCRCONS,'.'),'-'),'/'),' '),'') AS CNPJ_CPF,
                                       REPLACE(LTRIM(TO_CHAR(ROUND(VRNOTAFISC+VRDESITVEND,2), '999999999990.00')), '.', ',') AS VL_MERC,
                                       REPLACE(LTRIM(TO_CHAR(ROUND(VRNOTAFISC, 2), '999999999990.00')), '.', ',') AS VL_DOC,
                                       REPLACE(LTRIM(TO_CHAR(ROUND(VRDESITVEND,2), '999999999990.00')), '.', ',') AS VL_DESC,
                                       '0,00' AS VL_PIS,
                                       '0,00' AS VL_COFINS,
                                       CONTCTBL_SPED('S','',CDTIPOOPER,CDFILIAL) AS COD_CTA,
                                       NRLANCTONF, CDFILIAL, '' CDCLIENTE ,CDCAIXA
                                  FROM (SELECT VE.DTENTRVENDA AS DTEMISSAO, VE.NRSERIEVND AS CDSERIE ,VE.NRSUBSERIEVND ,VE.NRORDEMVND AS NRNOTAFISC,
                                               SUM(TRUNC(IT.QTPRODVEND * (IT.VRUNITVEND+NVL(IT.VRUNITVENDCL,0)),2) - NVL(IT.VRDESITVEND,0) + NVL(IT.VRACRITVEND,0)) AS VRNOTAFISC,
                                               SUM(VRDESITVEND) AS VRDESITVEND, PV.CDTPOPERCNTREC AS CDTIPOOPER,
                                               VE.CDFILIAL, VE.NRSEQVENDA AS NRLANCTONF, VE.CDCAIXA, VE.NRINSCRCONS
                                          FROM VENDA VE, ITEMVENDA IT, PARAVEND PV
                                         WHERE VE.CDEMPRESA   =  P_CDEMPRESA
                                           AND VE.CDFILIAL    = IT.CDFILIAL
                                           AND VE.NRSEQVENDA  = IT.NRSEQVENDA
                                           AND VE.CDCAIXA     = IT.CDCAIXA
                                           AND VE.DTENTRVENDA BETWEEN P_DTINICIAL AND P_DTFINAL
                                           AND VE.IDSITUVENDA = 'O'
                                           AND VE.NRORDEMVND  IS NOT NULL
                                           AND NVL(P_GERAFORSALE,'N') = 'S'
                                           AND VE.CDFILIAL    = PV.CDFILIAL(+)
                                         GROUP BY VE.DTENTRVENDA, VE.NRSERIEVND,VE.NRSUBSERIEVND, VE.NRORDEMVND, VE.NRSEQVENDA,
                                               VE.CDFILIAL, VE.CDCAIXA, VE.NRINSCRCONS, PV.CDTPOPERCNTREC))) LOOP
         INSERT INTO ARQMAGNETICO
           (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
         VALUES
           ('24'||LPAD(RTRIM(V_CONTREGC), 8, '0'), C_REGC350.ARQ_C350, P_NRSEQARQMAG);
         V_CONTREGC := NVL(V_CONTREGC,0) + 1;

         /* PLANO DE CONTAS REFERENCIAL */
         SELECT MAX(CDCHAVEREG)
           INTO V_CONTCTBL
           FROM TMP_REGDADOSSPED
          WHERE CDCHAVEREG = C_REGC350.COD_CTA
            AND CDREGISTRO = '0500';

         IF (V_CONTCTBL IS NULL) AND (C_REGC350.COD_CTA IS NOT NULL) THEN
            V_SEQUPROD := NVL(V_SEQUPROD,0) + 1;
            INSERT INTO TMP_REGDADOSSPED
               (CDREGISTRO, CDCONTREGI, CDCHAVEREG)
            VALUES
               ('0500', V_SEQUPROD, C_REGC350.COD_CTA);
         END IF;
         V_CONTCTBL := NULL;

         V_NRSEQITEM := 0;
         FOR C_REGC370 IN(SELECT (P.CDARVPROD  || '|' ||
                                  IT.QTITEMPROD             || '|' ||
                                  P.SGUNIDADE               || '|' ||
                                  REPLACE(LTRIM(TO_CHAR(ROUND((SUM(I.VRCONTITIMP)),2), '999999999990.00')), '.', ',')    || '|' ||
                                  REPLACE(LTRIM(TO_CHAR(ROUND((SUM(IT.VRENCARGODESC)),2), '999999999990.00')), '.', ',')    || '|' ) AS ARQ_C370,
                                  P.CDPRODUTO, P.SGUNIDADE AS UNID, IT.CDPRODNCMTRANS AS CDCLASFISC
                            FROM ITEMPROIMPOS I, ITEMPRODUTO IT, PRODUTO P, IMPOSTO IM
                           WHERE IT.CDFILIAL      = C_REGC350.CDFILIAL
                             AND IT.NRLANCTONF    = C_REGC350.NRLANCTONF
                             AND I.CDIMPOSTO      = IM.CDIMPOSTO
                             AND I.CDFILIAL       = IT.CDFILIAL
                             AND I.NRLANCTONF     = IT.NRLANCTONF
                             AND I.NRSEQITPROD    = IT.NRSEQITPROD
                             AND IT.CDPRODUTO     = P.CDPRODUTO
                             AND IM.CDIMPOSTONFE  = P_CDIMPOSTO
                             AND NVL(P_GERAFORSALE,'N') = 'N'
                           GROUP BY SUBSTR(I.NRSEQITPROD,2,3), P.CDARVPROD, IT.QTITEMPROD, P.SGUNIDADE, P.CDPRODUTO, IT.CDPRODNCMTRANS
                           UNION
                          SELECT CDARVPROD    ||'|'||
                                 REPLACE(LTRIM(TO_CHAR(ROUND(QTPRODVEND, 3), '99999999990.000')), '.', ',') ||'|'||
                                 SGUNIDADE    ||'|'||
                                 REPLACE(LTRIM(TO_CHAR(ROUND(VR_TOT_IT,  2), '999999999990.00')), '.', ',') ||'|'||
                                 REPLACE(LTRIM(TO_CHAR(ROUND(VRDESITVEND,2), '999999999990.00')), '.', ',') ||'|' AS ARQ_C370,
                                 CDPRODUTO, SGUNIDADE AS UNID, CDCLASFISC
                           FROM (SELECT NRSEQUITVEND,
                                        P.CDARVPROD,
                                        QTPRODVEND,
                                        P.SGUNIDADE,
                                        (IV.VRUNITVEND+NVL(IV.VRUNITVENDCL,0)+NVL(IV.VRACRITVEND,0))  AS VR_TOT_IT,
                                        VRDESITVEND, P.CDPRODUTO, IV.CDCLASFISC
                                   FROM ITEMVENDA IV, PRODUTO P
                                  WHERE IV.CDFILIAL   = C_REGC350.CDFILIAL
                                    AND IV.CDCAIXA    = C_REGC350.CDCAIXA
                                    AND IV.NRSEQVENDA =  C_REGC350.NRLANCTONF
                                    AND NVL(P_GERAFORSALE,'N') = 'S'
                                    AND IV.CDPRODUTO  = P.CDPRODUTO)NF) LOOP

               V_NRSEQITEM := NVL(V_NRSEQITEM,0)+1;
               INSERT INTO ARQMAGNETICO
                 (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
               VALUES
                 ('24'||LPAD(RTRIM(V_CONTREGC), 8, '0'), '|C370|'||LPAD(V_NRSEQITEM,3,'0')||'|'||C_REGC370.ARQ_C370, P_NRSEQARQMAG);
               V_CONTREGC := NVL(V_CONTREGC,0) + 1;

               /* CODIGO DO PRODUTO */
               SELECT MAX(CDCHAVEREG)
                 INTO V_PRODUTO
                 FROM TMP_REGDADOSSPED
                WHERE CDCHAVEREG = C_REGC370.CDPRODUTO
                  AND CDREGISTRO = '0200';

               IF (V_PRODUTO IS NULL) AND (C_REGC370.CDPRODUTO IS NOT NULL) THEN
                  V_SEQUPROD := NVL(V_SEQUPROD,0) + 1;
                  INSERT INTO TMP_REGDADOSSPED
                    (CDREGISTRO, CDCONTREGI, CDCHAVEREG, CDCAMPO3)
                  VALUES
                    ('0200', V_SEQUPROD, C_REGC370.CDPRODUTO, C_REGC370.CDCLASFISC);
               END IF;
               V_PRODUTO := NULL;

               /* UNIDADE DE MEDIDA */
               SELECT MAX(CDCHAVEREG)
                 INTO V_UNID
                 FROM TMP_REGDADOSSPED
                WHERE CDCHAVEREG = C_REGC370.UNID
                  AND CDREGISTRO = '0190';

               IF (V_UNID IS NULL) AND (C_REGC370.UNID IS NOT NULL) THEN
                  V_SEQUPROD := NVL(V_SEQUPROD,0) + 1;
                  INSERT INTO TMP_REGDADOSSPED
                    (CDREGISTRO, CDCONTREGI, CDCHAVEREG)
                  VALUES
                    ('0190', V_SEQUPROD, C_REGC370.UNID);
               END IF;
               V_UNID := NULL;
         END LOOP;

         FOR C_REGC390 IN(SELECT ('|C390'         || '|' ||
                                  NF.CDSITUTRIBNF|| '|' ||
                                  NF.CDFISCOPERNF    || '|' ||
                                  REPLACE(LTRIM(TO_CHAR(ROUND(NF.VRALIQNF,2), '999999999990.00')), '.', ',')    || '|' ||
                                  REPLACE(LTRIM(TO_CHAR(ROUND(NF.VRCONTABILNF,2), '999999999990.00')), '.', ',')    || '|' ||
                                  REPLACE(LTRIM(TO_CHAR(ROUND(NF.VRBASECALCNF + DECODE(V_IDTPCARGATRIB,'O',0,DECODE(V_SGESTADO,'SP',0,NVL(NF.VRBASECARGA,0))),2), '999999999990.00')), '.', ',')    || '|' ||
                                  REPLACE(LTRIM(TO_CHAR(ROUND(NF.VRIMPOSTONF  + DECODE(V_IDTPCARGATRIB,'O',0,NVL(NF.VRIMPCARGA,0)),2), '999999999990.00')), '.', ',')    || '|' ||
                                  REPLACE(LTRIM(TO_CHAR(ROUND(NF.VRREDBCALC,2), '999999999990.00')), '.', ',')    || '|' ||
                                  ''  || '|'  ) AS ARQ_C390, CDFISCOPERNF
                          FROM(SELECT NVL(CDSITUTRIBNF,'000') AS CDSITUTRIBNF,
                                      CDFISCOPERNF,
                                      VRALIQNF,
                                      SUM(VRCONTABILNF) AS VRCONTABILNF,
                                      SUM(VRBASECALCNF) AS VRBASECALCNF,
                                      SUM((SELECT SUM(VRBASECALCNF)
                                             FROM IMPOSTONF IP
                                            WHERE IP.CDFILIAL     = I.CDFILIAL
                                              AND IP.NRLANCTONF   = I.NRLANCTONF
                                              AND IP.CDFISCOPERNF = I.CDFISCOPERNF
                                              AND IP.CDIMPOSTO    = IM.CDIMPCARGATRIB)) AS VRBASECARGA,
                                      SUM(VRIMPOSTONF) AS VRIMPOSTONF,
                                      SUM(VRIMPCARGATRIBI) AS VRIMPCARGA,
                                      SUM(DECODE(IDIMPOSTONF, '2', VRCONTABILNF, '0')) AS VRREDBCALC
                                 FROM IMPOSTONF I, IMPOSTO IM 
                                WHERE I.CDFILIAL      = C_REGC350.CDFILIAL
                                  AND I.NRLANCTONF    = C_REGC350.NRLANCTONF 
                                  AND I.CDIMPOSTO     = IM.CDIMPOSTO
                                  AND IM.CDIMPOSTONFE = P_CDIMPOSTO
                                  AND IDIMPOSTONF <> '3'
                                  AND NVL(P_GERAFORSALE,'N') = 'N'
                                GROUP BY NVL(CDSITUTRIBNF,'000'), CDFISCOPERNF, VRALIQNF) NF
                          UNION
                          /*GERA REGISTRO C390 PARA O FOS - C390 FOS*/
                          SELECT '|C390'      ||'|'||
                                 CDSITUTRIBIT ||'|'||
                                 CDFISCOPERIT ||'|'||
                                 VRALIQITEM   ||'|'||
                                 REPLACE(LTRIM(TO_CHAR(ROUND(VR_OPER,2), '999999999990.00')), '.', ',')    ||'|'||
                                 REPLACE(LTRIM(TO_CHAR(ROUND(VR_BC_ICMS,2), '999999999990.00')), '.', ',') ||'|'||
                                 REPLACE(LTRIM(TO_CHAR(ROUND(VR_ICMS,2), '999999999990.00')), '.', ',')    ||'|'||
                                 REPLACE(LTRIM(TO_CHAR(ROUND(VR_RED,2), '999999999990.00')), '.', ',')     ||'|'||
                                 COD_OB       ||'|' AS ARQ_C390, CDFISCOPERIT AS CDFISCOPERNF
                            FROM (SELECT (NVL(LPAD(IVI.CDCSTPRODI,3,'0'), CASE WHEN IP.IDTPIMPOSFIS = 'T' THEN '000'
                                                                               WHEN IP.IDTPIMPOSFIS = 'I' THEN '040'
                                                                               WHEN IP.IDTPIMPOSFIS = 'F' THEN '060'
                                                                               WHEN IP.IDTPIMPOSFIS = 'N' THEN '041' END)) AS CDSITUTRIBIT,
                                         NVL(IVI.CDCSTPRODPC,'5102')  AS CDFISCOPERIT,
                                         REPLACE(LTRIM(TO_CHAR(ROUND(IVI.VRPEALPRODIT,2), '999999999990.00')), '.', ',') AS VRALIQITEM,
                                         (CASE WHEN IP.CDIMPOSTONFE = P_CDIMPOSTO
                                               THEN SUM(TRUNC(IV.QTPRODVEND * (IV.VRUNITVEND+NVL(IV.VRUNITVENDCL,0)),2) - NVL(IV.VRDESITVEND,0) + NVL(IV.VRACRITVEND,0))
                                               ELSE 0 END) AS VR_OPER,
                                         (CASE WHEN IP.IDTPIMPOSFIS = 'T' AND IP.CDIMPOSTONFE = P_CDIMPOSTO
                                               THEN SUM(TRUNC(IV.QTPRODVEND * (IV.VRUNITVEND+NVL(IV.VRUNITVENDCL,0)),2) - NVL(IV.VRDESITVEND,0) + NVL(IV.VRACRITVEND,0))
                                               ELSE 0 END) AS VR_BC_ICMS,
                                         (CASE WHEN IP.IDTPIMPOSFIS = 'T' AND IP.CDIMPOSTONFE = P_CDIMPOSTO
                                               THEN SUM(IVI.VRIMPOPRODIT)
                                               ELSE 0 END) AS VR_ICMS,
                                         0 AS VR_RED,'' AS COD_OB, IP.CDIMPOSTONFE
                                    FROM ITEMVENDA IV, ITVENDAIMPOS IVI, IMPOSTO IP
                                   WHERE IV.CDFILIAL     = IVI.CDFILIAL
                                     AND IV.CDCAIXA      = IVI.CDCAIXA
                                     AND IV.NRSEQUITVEND = IVI.NRSEQUITVEND
                                     AND IV.NRSEQVENDA   = IVI.NRSEQVENDA
                                     AND IV.CDFILIAL     = C_REGC350.CDFILIAL
                                     AND IV.CDCAIXA      =  C_REGC350.CDCAIXA
                                     AND IV.NRSEQVENDA   = C_REGC350.NRLANCTONF
                                     AND NVL(P_GERAFORSALE,'N') = 'S'
                                     AND IP.CDIMPOSTO    = IVI.CDIMPOSTO
                                   GROUP BY IVI.CDCSTPRODI, IVI.CDCSTPRODPC, IP.IDTPIMPOSFIS, IVI.VRPEALPRODIT, IP.CDIMPOSTONFE)NF
                           WHERE NF.CDIMPOSTONFE = P_CDIMPOSTO) LOOP
            INSERT INTO ARQMAGNETICO
              (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
            VALUES
              ('24'||LPAD(RTRIM(V_CONTREGC), 8, '0'), C_REGC390.ARQ_C390, P_NRSEQARQMAG);
            V_CONTREGC := NVL(V_CONTREGC,0) + 1;
         END LOOP;
      END LOOP;
   END IF;
 
   /* registro c400 */
   FOR C_REGC400 IN (SELECT '|C400'            || '|' ||
                            '2D'               || '|' ||
                            'M'                || '|' ||  --DSMODMARCAECF
                            NRSERIEREDZ1       || '|' ||
                            CDCAIXA            || '|'   AS C400,
                            CDCAIXA, NRSERIEREDZ 
                       FROM (SELECT SUBSTR(NRSERIEREDZ,1,21) AS NRSERIEREDZ1,
                                    SUBSTR(REPLACE('','|','-'),1,20) AS DSMODMARCAECF, --DSMODMARCAECF
                                    CDCAIXA, RZ.NRSERIEREDZ
                               FROM REDUCAOZ RZ ,FILIAL FI
                              WHERE RZ.DTREDUCAOZ BETWEEN P_DTINICIAL AND P_DTFINAL 
                                AND RZ.CDFILIAL    = FI.CDFILIAL 
                                AND FI.CDEMPRESA   = P_CDEMPRESA 
                                AND FI.CDINSCESTA  = P_CDINSCESTA 
                                AND NRSERIEREDZ IS NOT NULL
                                AND RZ.IDSTATUS    = 'A'
                                AND ((V_CDSITUCRT = '3') OR (V_CDSITUCRT <> '3' AND V_SGESTADO <> 'CE'))
                              GROUP BY SUBSTR(NRSERIEREDZ,1,20), SUBSTR(REPLACE('','|','-'),1,20) , --DSMODMARCAECF
                                       CDCAIXA, RZ.NRSERIEREDZ) )LOOP 
      INSERT INTO ARQMAGNETICO 
        (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG) 
      VALUES 
        ('25'||LPAD(RTRIM(V_CONTREGC), 8, '0'), C_REGC400.C400, P_NRSEQARQMAG); 
      V_CONTREGC := NVL(V_CONTREGC,0) + 1; 
      FOR C_REGC405 IN (SELECT ('|C405'                                                                           || '|' || 
                                TO_CHAR(RZ.DTREDUCAOZ,'ddmmyyyy')                                                 || '|' ||
                                LPAD(LTRIM(NVL(RZ.NRREINIREDZ,'0'),'0'), 3, '0')                                  || '|' || 
                                LPAD(LTRIM(NVL(RZ.NRREDREDZ,'0'),'0'), 6, '0')                                    || '|' || 
                                CASE WHEN RZ.DTREDUCAOZ < '01/01/2014' THEN LPAD(LTRIM(NVL(RZ.NRULTCFREDZ,'0'),'0'), 6, '0') ELSE LPAD(LTRIM(NVL(RZ.NRULTCFREDZ,'0'),'0'), 9, '0') END || '|' || --atualizacao do layout para 2014
                                REPLACE(LTRIM(TO_CHAR(TRUNC(RZ.VRGTREDZ,2), '999999999990.00')), '.', ',')        || '|' || 
                                REPLACE(LTRIM(TO_CHAR(TRUNC(DECODE(RZ.VRVENLIQREDZ,0,RZ.VRVENBRUREDZ,RZ.VRVENLIQREDZ),2), '999999999990.00')), '.', ',')    || '|' ) AS C405, 
                                DTREDUCAOZ, RZ.NRECFREDZ, RZ.CDFILIAL 
                          FROM REDUCAOZ RZ, FILIAL FI 
                         WHERE RZ.CDFILIAL    = FI.CDFILIAL 
                           AND RZ.DTREDUCAOZ BETWEEN P_DTINICIAL AND P_DTFINAL 
                           AND FI.CDEMPRESA   = P_CDEMPRESA 
                           AND FI.CDINSCESTA  = P_CDINSCESTA 
                           AND RZ.CDCAIXA     = C_REGC400.CDCAIXA 
                           AND RZ.NRSERIEREDZ = C_REGC400.NRSERIEREDZ
                           AND RZ.IDSTATUS    = 'A' 
                           AND VRVENBRUREDZ   > 0 
                         ORDER BY TO_CHAR(RZ.DTREDUCAOZ,'ddmmyyyy')) LOOP
         INSERT INTO ARQMAGNETICO 
           (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG) 
         VALUES 
           ('25'||LPAD(RTRIM(V_CONTREGC), 8, '0'), C_REGC405.C405, P_NRSEQARQMAG); 
         V_CONTREGC := NVL(V_CONTREGC,0) + 1; 
         FOR C_420 IN (SELECT ('|C420'          || '|' || 
                                 VRALIQIMPRZ    || '|' || 
                                 VRBCALCIMPRZ   || '|' ) AS PARTE1, 
                                 VRALIQIMPRZ, 
                                 ALIQ_NR_TOT, 
                                 DTREDUCAOZ, CDFILIAL 
                            FROM (SELECT IDTPIMPOSFIS||LPAD(REPLACE(REPLACE(LTRIM(TO_CHAR(ROUND(VRALIQIMPRZ,2), '99.00')), '.', ','),',',''), 4, '0') AS VRALIQIMPRZ, 
                                         REPLACE(LTRIM(TO_CHAR(TRUNC(SUM(R.VRBCALCIMPRZ),2), '999999999990.00')), '.', ',') AS VRBCALCIMPRZ, 
                                         R.DTREDUCAOZ, VRALIQIMPRZ AS ALIQ_NR_TOT, FI.CDFILIAL, VRVENBRUREDZ, VRTOTCANREDZ 
                                    FROM IMPOSTOREDZ R, IMPOSTO I, FILIAL FI, REDUCAOZ Z 
                                   WHERE R.CDCAIXA      = C_REGC400.CDCAIXA
                                     AND R.DTREDUCAOZ   = C_REGC405.DTREDUCAOZ
                                     AND R.CDIMPOSTO    = I.CDIMPOSTO
                                     AND I.IDTPIMPOSFIS = 'T'
                                     AND FI.CDEMPRESA   = P_CDEMPRESA
                                     AND FI.CDINSCESTA  = P_CDINSCESTA
                                     AND FI.CDFILIAL    = R.CDFILIAL
                                     AND R.CDCAIXA      = Z.CDCAIXA
                                     AND R.NRECFREDZ    = Z.NRECFREDZ
                                     AND R.DTREDUCAOZ   = Z.DTREDUCAOZ
                                     AND R.CDFILIAL     = Z.CDFILIAL
                                     AND Z.NRECFREDZ    = C_REGC405.NRECFREDZ
                                     AND Z.NRSERIEREDZ  = C_REGC400.NRSERIEREDZ
                                    GROUP BY R.DTREDUCAOZ, IDTPIMPOSFIS||LPAD(REPLACE(REPLACE(LTRIM(TO_CHAR(ROUND(VRALIQIMPRZ,2), '99.00')), '.', ','),',',''), 4, '0'), 
                                             VRALIQIMPRZ, FI.CDFILIAL, VRVENBRUREDZ, VRTOTCANREDZ 
                                   UNION ALL 
                                  SELECT 'F1' AS VRALIQIMPRZ, 
                                         REPLACE(LTRIM(TO_CHAR(TRUNC(SUM(VRSTRIBREDZ),2), '999999999990.00')), '.', ',') AS VRBCALCIMPRZ, /* VALOR DE SUBSTITUICAO TRIBUTARIA */
                                         RE.DTREDUCAOZ, 0 AS ALIQ_NR_TOT, FI.CDFILIAL, VRVENBRUREDZ, VRTOTCANREDZ 
                                    FROM REDUCAOZ RE, FILIAL FI 
                                   WHERE RE.CDCAIXA     = C_REGC400.CDCAIXA 
                                     AND RE.DTREDUCAOZ  = C_REGC405.DTREDUCAOZ 
                                     AND RE.VRSTRIBREDZ > 0
                                     AND FI.CDEMPRESA   = P_CDEMPRESA
                                     AND FI.CDINSCESTA  = P_CDINSCESTA
                                     AND FI.CDFILIAL    = RE.CDFILIAL
                                     AND RE.NRECFREDZ   = C_REGC405.NRECFREDZ
                                     AND RE.NRSERIEREDZ = C_REGC400.NRSERIEREDZ
                                   GROUP BY RE.DTREDUCAOZ, FI.CDFILIAL, VRVENBRUREDZ, VRTOTCANREDZ 
                                   UNION ALL 
                                  SELECT DECODE(VRVENBRUREDZ,VRTOTCANREDZ ,'CAN-O','N1') AS VRALIQIMPRZ, 
                                         REPLACE(LTRIM(TO_CHAR(TRUNC(SUM(VRNINCIDREDZ),2), '999999999990.00')), '.', ',') AS VRBCALCIMPRZ, /* VALOR DE NAO TRIBUTADAS */
                                         RE.DTREDUCAOZ, 0 AS ALIQ_NR_TOT, FI.CDFILIAL, VRVENBRUREDZ, VRTOTCANREDZ 
                                    FROM REDUCAOZ RE, FILIAL FI
                                   WHERE RE.CDCAIXA      = C_REGC400.CDCAIXA
                                     AND RE.DTREDUCAOZ   = C_REGC405.DTREDUCAOZ
                                     AND RE.VRNINCIDREDZ > 0
                                     AND FI.CDEMPRESA    = P_CDEMPRESA
                                     AND FI.CDINSCESTA   = P_CDINSCESTA
                                     AND FI.CDFILIAL     = RE.CDFILIAL
                                     AND RE.NRECFREDZ    = C_REGC405.NRECFREDZ
                                     AND RE.NRSERIEREDZ  = C_REGC400.NRSERIEREDZ
                                   GROUP BY RE.DTREDUCAOZ, FI.CDFILIAL, VRVENBRUREDZ, VRTOTCANREDZ 
                                   UNION ALL 
                                  SELECT 'I1' AS VRALIQIMPRZ, 
                                         REPLACE(LTRIM(TO_CHAR(TRUNC(SUM(VRISENCREDZ),2), '999999999990.00')), '.', ',') AS VRBCALCIMPRZ, /* VALOR DE ISENTO */
                                         RE.DTREDUCAOZ, 0 AS ALIQ_NR_TOT, FI.CDFILIAL, VRVENBRUREDZ, VRTOTCANREDZ 
                                    FROM REDUCAOZ RE, FILIAL FI 
                                   WHERE RE.CDCAIXA     = C_REGC400.CDCAIXA
                                     AND RE.DTREDUCAOZ  = C_REGC405.DTREDUCAOZ
                                     AND RE.VRISENCREDZ > 0
                                     AND FI.CDEMPRESA   = P_CDEMPRESA
                                     AND FI.CDINSCESTA  = P_CDINSCESTA
                                     AND FI.CDFILIAL    = RE.CDFILIAL
                                     AND RE.NRECFREDZ   = C_REGC405.NRECFREDZ
                                     AND RE.NRSERIEREDZ = C_REGC400.NRSERIEREDZ
                                   GROUP BY RE.DTREDUCAOZ, FI.CDFILIAL, VRVENBRUREDZ, VRTOTCANREDZ)) LOOP 
               FOR C_NR_TOT IN (SELECT VRALIQIMPRZ, LPAD(TO_CHAR(ROWNUM), 2, '0') AS SEQUENCIAL 
                                  FROM (SELECT VRALIQIMPRZ 
                                          FROM IMPOSTOREDZ 
                                         WHERE DTREDUCAOZ BETWEEN P_DTINICIAL AND P_DTFINAL 
                                         GROUP BY VRALIQIMPRZ) )LOOP 
                  IF (C_NR_TOT.VRALIQIMPRZ = C_420.ALIQ_NR_TOT) AND (C_420.ALIQ_NR_TOT > 0) THEN 
                     V_NR_TOT := C_NR_TOT.SEQUENCIAL; 
                     V_DESCR_NR_TOT := 'ALIQUOTA ' || V_NR_TOT; 
                  END IF; 
               END LOOP; 
               V_LINHA := C_420.PARTE1      || 
                          V_NR_TOT          || '|' || 
                          V_DESCR_NR_TOT    || '|'; 
                V_NR_TOT       := NULL; 
                V_DESCR_NR_TOT := NULL; 
               INSERT INTO ARQMAGNETICO 
                 (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG) 
               VALUES
                 ('25'||LPAD(RTRIM(V_CONTREGC), 8, '0'), V_LINHA, P_NRSEQARQMAG);
               V_CONTREGC := NVL(V_CONTREGC,0) + 1;
            IF P_PERFIL = 'B' THEN
               FOR C_425 IN (SELECT DISTINCT('|C425'|| '|' ||
                                    CDARVPROD       || '|' ||
                                    QTPRODVEND      || '|' ||
                                    SGUNIDADE       || '|' ||
                                    VRITEM          || '|' || 
                                    VRPIS           || '|' ||
                                    VRCOFINS        || '|'  ) AS C425, 
                                    CDPRODUTO, 
                                    SGUNIDADE AS UNID, CDCLASFISC
                               FROM (SELECT P.CDARVPROD, 
                                            REPLACE(LTRIM(TO_CHAR(SUM(QTPRODVEND), '999999999990.000')), '.', ',')  AS QTPRODVEND, 
                                            SGUNIDADE,
                                            REPLACE(LTRIM(TO_CHAR(ROUND(SUM(VRTOTAL),2), '999999999990.00')), '.', ',')  AS VRITEM, 
                                            '0,00' AS VRPIS, 
                                            '0,00' AS VRCOFINS,
                                            P.CDPRODUTO, I.CDCLASFISC
                                       FROM PRODUTO P, 
                                            (SELECT DISTINCT R.DTREDUCAOZ
                                              FROM REDUCAOZ R, IMPOSTOREDZ IR, IMPOSTO I 
                                             WHERE R.DTREDUCAOZ  = C_420.DTREDUCAOZ 
                                               AND R.CDCAIXA = C_REGC400.CDCAIXA
                                               AND R.CDFILIAL = IR.CDFILIAL 
                                               AND R.CDCAIXA = IR.CDCAIXA 
                                               AND R.NRECFREDZ = IR.NRECFREDZ
                                               AND R.DTREDUCAOZ = IR.DTREDUCAOZ 
                                               AND R.CDFILIAL = C_420.CDFILIAL 
                                               AND I.CDIMPOSTO = IR.CDIMPOSTO) R,
                                            (SELECT V.CDFILIAL, V.CDCAIXA, V.NRSEQVENDA, IT.CDPRODUTO, V.DTENTRVENDA, 
                                                    NVL(IT.VRUNITVEND,0) AS VRUNITVEND, 
                                                    NVL(IT.QTPRODVEND,0) AS QTPRODVEND,
                                                    (TRUNC(QTPRODVEND * (IT.VRUNITVEND+NVL(IT.VRUNITVENDCL,0)),2) - VRDESITVEND + VRACRITVEND) AS VRTOTAL,
                                                    IT.CDCLASFISC
                                               FROM ITVENDAIMPOS I, IMPOSTO P, ITEMVENDA IT, VENDA V
                                              WHERE I.CDIMPOSTO = P.CDIMPOSTO 
                                                AND I.CDFILIAL = IT.CDFILIAL 
                                                AND I.CDCAIXA = IT.CDCAIXA
                                                AND I.NRSEQVENDA = IT.NRSEQVENDA 
                                                AND I.NRSEQUITVEND = IT.NRSEQUITVEND
                                                AND I.CDFILIAL = V.CDFILIAL
                                                AND I.CDCAIXA = V.CDCAIXA
                                                AND V.CDCAIXA = C_REGC400.CDCAIXA
                                                AND I.NRSEQVENDA = V.NRSEQVENDA
                                                AND DTENTRVENDA = C_420.DTREDUCAOZ
                                                AND IDSITUVENDA = 'O'
                                                AND V.NRCUPOMFIS IS NOT NULL
                                                AND C_420.VRALIQIMPRZ = IDTPIMPOSFIS||LPAD(REPLACE(REPLACE(LTRIM(TO_CHAR(ROUND(VRPEALPRODIT,2), '99.00')), '.', ','),',',''), 4,'0')
                                                AND V.CDFILIAL = C_420.CDFILIAL
                                                AND IDTPIMPOSFIS = 'T'
                                              UNION ALL
                                              SELECT V.CDFILIAL, V.CDCAIXA, V.NRSEQVENDA, IT.CDPRODUTO, V.DTENTRVENDA,
                                                    NVL(IT.VRUNITVEND,0) AS VRUNITVEND,
                                                    NVL(IT.QTPRODVEND,0) AS QTPRODVEND,
                                                    (TRUNC(QTPRODVEND * (IT.VRUNITVEND+NVL(IT.VRUNITVENDCL,0)),2) - VRDESITVEND + VRACRITVEND) AS VRTOTAL,
                                                    IT.CDCLASFISC
                                               FROM ITVENDAIMPOS I, IMPOSTO P, ITEMVENDA IT, VENDA V
                                              WHERE I.CDIMPOSTO = P.CDIMPOSTO
                                                AND I.CDFILIAL = IT.CDFILIAL
                                                AND I.CDCAIXA = IT.CDCAIXA
                                                AND I.NRSEQVENDA = IT.NRSEQVENDA
                                                AND I.NRSEQUITVEND = IT.NRSEQUITVEND
                                                AND I.CDFILIAL = V.CDFILIAL
                                                AND I.CDCAIXA = V.CDCAIXA
                                                AND V.CDCAIXA = C_REGC400.CDCAIXA
                                                AND I.NRSEQVENDA = V.NRSEQVENDA
                                                AND DTENTRVENDA = C_420.DTREDUCAOZ
                                                AND V.NRCUPOMFIS IS NOT NULL
                                                AND IDSITUVENDA = 'O'
                                                AND C_420.VRALIQIMPRZ = IDTPIMPOSFIS||'1'
                                                AND V.CDFILIAL = C_420.CDFILIAL
                                                AND IDTPIMPOSFIS <> 'T'   ) I
                                      WHERE R.DTREDUCAOZ(+) = I.DTENTRVENDA
                                        AND P.CDPRODUTO     = I.CDPRODUTO
                                     GROUP BY P.CDARVPROD, SGUNIDADE, P.CDPRODUTO, I.CDCLASFISC)) LOOP
                  INSERT INTO ARQMAGNETICO 
                    (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG) 
                  VALUES 
                    ('25'||LPAD(RTRIM(V_CONTREGC), 8, '0'), C_425.C425, P_NRSEQARQMAG); 
                  V_CONTREGC := NVL(V_CONTREGC,0) + 1; 
                  /* UNIDADE DE MEDIDA */
                  SELECT MAX(CDCHAVEREG) 
                    INTO V_UNID 
                    FROM TMP_REGDADOSSPED 
                   WHERE CDCHAVEREG = C_425.UNID 
                     AND CDREGISTRO = '0190'; 
                  IF (V_UNID IS NULL) AND (C_425.UNID IS NOT NULL) THEN 
                     V_SEQUPROD := NVL(V_SEQUPROD,0) + 1; 
                     INSERT INTO TMP_REGDADOSSPED 
                       (CDREGISTRO, CDCONTREGI, CDCHAVEREG) 
                     VALUES 
                       ('0190', V_SEQUPROD, C_425.UNID); 
                  END IF; 
                  V_UNID := NULL; 
                  /* CODIGO DO PRODUTO */
                  SELECT MAX(CDCHAVEREG) 
                    INTO V_PRODUTO 
                    FROM TMP_REGDADOSSPED 
                   WHERE CDCHAVEREG = C_425.CDPRODUTO 
                     AND CDREGISTRO = '0200';
                  IF (V_PRODUTO IS NULL) AND (C_425.CDPRODUTO IS NOT NULL) THEN 
                     V_SEQUPROD := NVL(V_SEQUPROD,0) + 1; 
                     INSERT INTO TMP_REGDADOSSPED 
                       (CDREGISTRO, CDCONTREGI, CDCHAVEREG, CDCAMPO3)
                     VALUES 
                       ('0200', V_SEQUPROD, C_425.CDPRODUTO, C_425.CDCLASFISC);
                  END IF; 
                  V_PRODUTO := NULL; 
               END LOOP; 
            END IF; 
         END LOOP; 
 
         FOR C_C460 IN (SELECT (REG      || '|' || 
                               COD_MOD   || '|' || 
                               COD_SIT   || '|' || 
                               NUM_DOC   || '|' || 
                               DT_DOC    || '|' || 
                               VL_DOC    || '|' || 
                               VL_PIS    || '|' || 
                               VL_COFINS || '|' || 
                               CPF_CNPJ  || '|' || 
                               NOM_ADQ   || '|' )AS REG_C460, 
                               CDCAIXA, CDFILIAL, DTREDUCAOZ ,NRSERIEREDZ , NRCUPOMFIS 
                          FROM (SELECT '|C460' AS REG, 
                                       '2D' AS COD_MOD, 
                                       '00' AS COD_SIT, 
                                       CASE WHEN V.DTENTRVENDA < '01/01/2014' THEN LPAD(LTRIM(NVL(V.NRCUPOMFIS,'0'),'0'), 6, '0') ELSE LPAD(LTRIM(NVL(V.NRCUPOMFIS,'0'),'0'), 9, '0') END AS NUM_DOC, --atualizacao do layout para 2014
                                       TO_CHAR(V.DTENTRVENDA, 'DDMMYYYY') AS DT_DOC, 
                                       REPLACE(LTRIM(TO_CHAR(SUM(TRUNC(IV.QTPRODVEND * (IV.VRUNITVEND+NVL(IV.VRUNITVENDCL,0)),2) - NVL(IV.VRDESITVEND,0) + NVL(IV.VRACRITVEND,0)),'999999999990.00')),'.',',') AS VL_DOC, 
                                       0 AS VL_PIS, 
                                       0 AS VL_COFINS, 
                                       NVL(REPLACE(REPLACE(REPLACE(REPLACE(V.NRINSCRCONS,'.'),'-'),'/'),' '),'') AS CPF_CNPJ, 
                                       '' AS NOM_ADQ, V.NRCUPOMFIS, IV.CDCAIXA, V.CDFILIAL, V.DTENTRVENDA AS DTREDUCAOZ, V.NRSERIEIMPVND AS NRSERIEREDZ 
                                  FROM ITEMVENDA IV, ITVENDAIMPOS IVI, VENDA V, IMPOSTO IP 
                                 WHERE IV.CDFILIAL = IVI.CDFILIAL 
                                   AND IV.CDCAIXA  = IVI.CDCAIXA 
                                   AND IV.NRSEQUITVEND = IVI.NRSEQUITVEND 
                                   AND IV.NRSEQVENDA  = IVI.NRSEQVENDA 
                                   AND IV.CDFILIAL    = V.CDFILIAL 
                                   AND IV.CDCAIXA     = V.CDCAIXA 
                                   AND IV.NRSEQVENDA  = V.NRSEQVENDA 
                                   AND IV.CDFILIAL    = C_REGC405.CDFILIAL 
                                   AND IV.CDCAIXA     = C_REGC400.CDCAIXA 
                                   AND V.DTENTRVENDA  = C_REGC405.DTREDUCAOZ 
                                   AND V.IDSITUVENDA  = 'O' 
			                          AND P_PERFIL = 'A' 
                                   AND V.NRCUPOMFIS IS NOT NULL
                                   --AND NVL(P_GERAFORSALE,'N') = 'S'
                                   AND IP.CDIMPOSTO = IVI.CDIMPOSTO
                                 GROUP BY V.NRCUPOMFIS, DTENTRVENDA, V.NRSERIEIMPVND, IV.CDCAIXA, V.CDFILIAL, V.NRINSCRCONS))LOOP
               INSERT INTO ARQMAGNETICO
                 (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
               VALUES
                 ('25'||LPAD(RTRIM(V_CONTREGC), 8, '0'), C_C460.REG_C460, P_NRSEQARQMAG);
               V_CONTREGC := NVL(V_CONTREGC,0) + 1;
            FOR C_470 IN (SELECT REG        || '|' ||
                                 COD_ITEM   || '|' ||
                                 QTD        || '|' ||
                                 QTD_CANC   || '|' ||
                                 UNID       || '|' || 
                                 VL_ITEM    || '|' || 
                                 CST_ICMS   || '|' || 
                                 CFOP       || '|' ||
                                 ALIQ_ICMS  || '|' || 
                                 VL_PIS     || '|' || 
                                 VL_COFINS  || '|' AS REG_C470,
                                 CDPRODUTO, UNID, CDCLASFISC
                            FROM (SELECT '|C470' AS REG, 
                                         CDARVPROD AS COD_ITEM, 
                                         REPLACE(LTRIM(TO_CHAR(QTPRODVEND, '999999999990.000')), '.', ',') AS QTD,
                                         '0' AS QTD_CANC,
                                         SGUNIDADE AS UNID,
                                         REPLACE(LTRIM(TO_CHAR(TRUNC(VRTOTAL,2), '999999999990.00')), '.', ',') AS VL_ITEM, 
                                         NVL(LPAD(CDCSTPRODI,3,'0'),DECODE(IDTPIMPOSFIS,'F','060','I','040','N','041','T',CASE WHEN VRPERCREDUCAO > 0 THEN '020' ELSE '000' END)) AS CST_ICMS,
                                         NVL(CDCFOPPROD,DECODE(IDTPIMPOSFIS,'F','5405','5102')) AS CFOP,
                                         REPLACE(LTRIM(TO_CHAR(TRUNC(VRPEALPRODIT,2), '999999999990.00')), '.', ',') AS ALIQ_ICMS, 
                                         '0' AS VL_PIS, 
                                         '0' AS VL_COFINS, 
                                         P.CDPRODUTO, I.CDCLASFISC AS CDCLASFISC
                                    FROM PRODUTO P, 
                                        (SELECT DISTINCT R.DTREDUCAOZ 
                                           FROM REDUCAOZ R, IMPOSTOREDZ IR, IMPOSTO I 
                                          WHERE R.DTREDUCAOZ  = C_C460.DTREDUCAOZ
                                            AND R.CDCAIXA     = C_C460.CDCAIXA
                                            AND R.CDFILIAL    = IR.CDFILIAL
                                            AND R.CDCAIXA     = IR.CDCAIXA
                                            AND R.NRECFREDZ   = IR.NRECFREDZ
                                            AND R.DTREDUCAOZ  = IR.DTREDUCAOZ
                                            AND R.CDFILIAL    = C_C460.CDFILIAL
                                            AND R.NRSERIEREDZ = C_C460.NRSERIEREDZ
                                            AND R.NRECFREDZ   = C_REGC405.NRECFREDZ
                                            AND P_PERFIL      = 'A'
                                            AND R.NRECFREDZ   = C_REGC405.NRECFREDZ
                                            AND I.CDIMPOSTO   = IR.CDIMPOSTO) R,
                                         (SELECT V.CDFILIAL, V.CDCAIXA, V.NRSEQVENDA, IT.CDPRODUTO, V.DTENTRVENDA,
                                                 NVL(IT.VRUNITVEND,0) AS VRUNITVEND,
                                                 NVL(IT.QTPRODVEND,0) AS QTPRODVEND, 
                                                 TRUNC(IT.QTPRODVEND * (IT.VRUNITVEND+NVL(IT.VRUNITVENDCL,0)),2) - IT.VRDESITVEND + IT.VRACRITVEND AS VRTOTAL,
                                                 I.VRPEALPRODIT, P.IDTPIMPOSFIS, NVL(A.VRPERCREDUCAO,0) AS VRPERCREDUCAO, IT.CDCLASFISC, I.CDCFOPPROD, I.CDCSTPRODI
                                            FROM ITVENDAIMPOS I, IMPOSTO P, ITEMVENDA IT, VENDA V, ALIQIMPFIS A
                                           WHERE I.CDIMPOSTO    = P.CDIMPOSTO
                                             AND I.CDFILIAL     = IT.CDFILIAL
                                             AND I.CDCAIXA      = IT.CDCAIXA
                                             AND I.NRSEQVENDA   = IT.NRSEQVENDA
                                             AND I.NRSEQUITVEND = IT.NRSEQUITVEND
                                             AND I.CDFILIAL     = V.CDFILIAL
                                             AND I.CDCAIXA      = V.CDCAIXA
                                             AND V.CDCAIXA      = C_C460.CDCAIXA
                                             AND V.NRCUPOMFIS   = C_C460.NRCUPOMFIS
                                             AND I.NRSEQVENDA   = V.NRSEQVENDA
                                             AND V.DTENTRVENDA  = C_C460.DTREDUCAOZ
                                             AND V.NRCUPOMFIS   IS NOT NULL
                                             AND V.IDSITUVENDA  = 'O'
                                             AND IT.CDFILIAL    = A.CDFILIAL(+)
                                             AND IT.CDPRODUTO   = A.CDPRODUTO(+)
                                             --AND V.NRORDEMVND IS NULL
                                             AND NVL(NRSERIEIMPVND,NRSERIEVND) = C_C460.NRSERIEREDZ/*REDUÇÃO PELA IMPRESSORA*/
                                             --AND C_420.VRALIQIMPRZ = IDTPIMPOSFIS||LPAD(REPLACE(REPLACE(LTRIM(TO_CHAR(ROUND(VRPEALPRODIT,2), '99.00')), '.', ','),',',''), 4, '0')
                                             AND V.CDFILIAL = C_C460.CDFILIAL
                                             AND P_PERFIL = 'A'
                                             /*AND IDTPIMPOSFIS = 'T'*/)I
                                           /*
                                           UNION ALL
                                           SELECT V.CDFILIAL, V.CDCAIXA, V.NRSEQVENDA, IT.CDPRODUTO, V.DTENTRVENDA,
                                                 NVL(IT.VRUNITVEND,0) AS VRUNITVEND,
                                                 NVL(IT.QTPRODVEND,0) AS QTPRODVEND,
                                                 (TRUNC(QTPRODVEND * (VRUNITVEND+NVL(IV.VRUNITVENDCL,0)),2) - VRDESITVEND + VRACRITVEND) AS VRTOTAL,
                                                 VRPEALPRODIT, IT.CDCLASFISC
                                            FROM ITVENDAIMPOS I, IMPOSTO P, ITEMVENDA IT, VENDA V
                                           WHERE I.CDIMPOSTO = P.CDIMPOSTO
                                             AND I.CDFILIAL = IT.CDFILIAL
                                             AND I.CDCAIXA = IT.CDCAIXA
                                             AND I.NRSEQVENDA = IT.NRSEQVENDA
                                             AND I.NRSEQUITVEND = IT.NRSEQUITVEND
                                             AND I.CDFILIAL = V.CDFILIAL
                                             AND I.CDCAIXA = V.CDCAIXA
                                             AND V.CDCAIXA = C_C460.CDCAIXA
                                             AND I.NRSEQVENDA = V.NRSEQVENDA
                                             AND DTENTRVENDA = C_C460.DTREDUCAOZ
                                             AND IDSITUVENDA = 'O'
                                             --AND C_420.VRALIQIMPRZ = IDTPIMPOSFIS||'1'
                                             AND V.CDFILIAL = C_C460.CDFILIAL
                                             AND P_PERFIL = 'A'
                                             AND IDTPIMPOSFIS <> 'T'
                                             */
                                   WHERE R.DTREDUCAOZ(+) = I.DTENTRVENDA
                                     AND P.CDPRODUTO     = I.CDPRODUTO
                                   --GROUP BY CDARVPROD, SGUNIDADE, REPLACE(LTRIM(TO_CHAR(TRUNC(VRPEALPRODIT,2), '999999999990.00')), '.', ','),
                                            --P.CDPRODUTO, IDTPIMPOSFIS, CDCLASFISC
                                   ))LOOP
 
               INSERT INTO ARQMAGNETICO 
                 (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG) 
               VALUES 
                 ('25'||LPAD(RTRIM(V_CONTREGC), 8, '0'), C_470.REG_C470, P_NRSEQARQMAG); 
               V_CONTREGC := NVL(V_CONTREGC,0) + 1; 
 
               SELECT MAX(CDCHAVEREG) 
                 INTO V_UNID 
                 FROM TMP_REGDADOSSPED 
                WHERE CDCHAVEREG = C_470.UNID 
                  AND CDREGISTRO = '0190'; 
 
               IF (V_UNID IS NULL) AND (C_470.UNID IS NOT NULL) THEN 
                  V_SEQUPROD := NVL(V_SEQUPROD,0) + 1; 
                  INSERT INTO TMP_REGDADOSSPED 
                    (CDREGISTRO, CDCONTREGI, CDCHAVEREG) 
                  VALUES 
                    ('0190', V_SEQUPROD, C_470.UNID); 
               END IF; 
 
               V_UNID := NULL; 
               SELECT MAX(CDCHAVEREG) 
                 INTO V_PRODUTO 
                 FROM TMP_REGDADOSSPED 
                WHERE CDCHAVEREG = C_470.CDPRODUTO 
                  AND CDREGISTRO = '0200'; 
 
               IF (V_PRODUTO IS NULL) AND (C_470.CDPRODUTO IS NOT NULL) THEN 
                  V_SEQUPROD := NVL(V_SEQUPROD,0) + 1; 
                  INSERT INTO TMP_REGDADOSSPED 
                    (CDREGISTRO, CDCONTREGI, CDCHAVEREG, CDCAMPO3)
                  VALUES 
                    ('0200', V_SEQUPROD, C_470.CDPRODUTO, C_470.CDCLASFISC); 
               END IF; 
               V_PRODUTO := NULL; 
 
            END LOOP; 
         END LOOP; 
    /*VERIFICA O TOTAL DA VENDA BRUTA E O TOTAL DE CANCELAMENTOS*/
      SELECT VRVENBRUREDZ, VRTOTCANREDZ 
        INTO V_VENDABRUTA, V_VENDACANC 
        FROM REDUCAOZ 
       WHERE DTREDUCAOZ  = C_REGC405.DTREDUCAOZ 
         AND CDCAIXA     = C_REGC400.CDCAIXA 
         AND NRECFREDZ   = C_REGC405.NRECFREDZ 
         AND CDFILIAL    = C_REGC405.CDFILIAL 
         AND NRSERIEREDZ = C_REGC400.NRSERIEREDZ; 
 
       IF V_VENDABRUTA <> V_VENDACANC  THEN /*VERIFICA SE TODAS AS VENDAS FORAM CANCELADAS PARA GERAR O REGISTRO C490*/
 
         FOR C_490 IN (SELECT '|C490'     || '|' ||
                                 CST_ICMS    || '|' ||
                                 CFOP        || '|' ||
                                 REPLACE(LTRIM(TO_CHAR(ROUND(ALIQ_ICMS,2), '999999999990.00')), '.', ',')      || '|' ||
                                 REPLACE(LTRIM(TO_CHAR(TRUNC(VL_OPR,2), '999999999990.00')), '.', ',')|| '|' ||
                                 REPLACE(LTRIM(TO_CHAR(TRUNC(VL_BC_ICMS,2), '999999999990.00')), '.', ',')|| '|' ||
                                 REPLACE(LTRIM(TO_CHAR(TRUNC(VL_ICMS,2), '999999999990.00')), '.', ',')|| '|' ||
                                 COD_OBS     || '|' AS C490
                         FROM (SELECT '000' AS CST_ICMS,
                                      '5102' AS CFOP,
                                      VRALIQIMPRZ AS ALIQ_ICMS,
                                      SUM(VRBCALCIMPRZ) AS VL_OPR,
                                      SUM(VRBCALCIMPRZ) AS VL_BC_ICMS,
                                      SUM(VRIMPOSTORZ) AS VL_ICMS,
                                      '' COD_OBS
                                 FROM IMPOSTOREDZ R, FILIAL FI, REDUCAOZ Z, IMPOSTO IM
                                WHERE R.DTREDUCAOZ    = C_REGC405.DTREDUCAOZ
                                  AND R.CDCAIXA       = C_REGC400.CDCAIXA
                                  AND IM.CDIMPOSTONFE = P_CDIMPOSTO
                                  AND R.CDIMPOSTO     = IM.CDIMPOSTO
                                  AND FI.CDEMPRESA    = P_CDEMPRESA
                                  AND FI.CDINSCESTA   = P_CDINSCESTA
                                  AND FI.CDFILIAL     = R.CDFILIAL
                                  AND R.CDFILIAL      = Z.CDFILIAL
                                  AND R.CDCAIXA       = Z.CDCAIXA
                                  AND R.NRECFREDZ     = Z.NRECFREDZ
                                  AND R.DTREDUCAOZ    = Z.DTREDUCAOZ
                                  AND Z.NRECFREDZ     = C_REGC405.NRECFREDZ
                                  AND Z.NRSERIEREDZ   = C_REGC400.NRSERIEREDZ
                                  AND Z.NRLANCTONF    IS NULL
                                GROUP BY R.VRALIQIMPRZ
                                UNION ALL
                               SELECT '0'||SUBSTR(NVL(LPAD(IP.CDSITUTRIBNF,3,'0'),DECODE(IP.VRPERREDBCNF,0,'000','020')),2,2) AS CST_ICMS,
                                      NVL(IP.CDFISCOPERNF,'5102') AS CFOP,
                                      R.VRALIQIMPRZ AS ALIQ_ICMS,
                                      SUM(IP.VRCONTABILNF) + NVL(SUM(DECODE(IP.VRPERREDBCNF,0,0,(SELECT SUM(VRCONTABILNF)
                                                                                                   FROM IMPOSTONF II
                                                                                                  WHERE II.CDFILIAL    = IP.CDFILIAL
                                                                                                    AND II.NRLANCTONF  = IP.NRLANCTONF
                                                                                                    AND II.IDIMPOSTONF = '2'))),0) AS VL_OPR,
                                      SUM(IP.VRBASECALCNF) AS VL_BC_ICMS,
                                      SUM(IP.VRIMPOSTONF)  AS VL_ICMS,
                                      '' COD_OBS
                                 FROM IMPOSTOREDZ R, IMPOSTONF IP, FILIAL FI, REDUCAOZ Z, IMPOSTO IM, IMPOSTO I
                                WHERE R.DTREDUCAOZ    = C_REGC405.DTREDUCAOZ
                                  AND R.CDCAIXA       = C_REGC400.CDCAIXA
                                  AND Z.CDFILIALNF    = IP.CDFILIAL
                                  AND Z.NRLANCTONF    = IP.NRLANCTONF
                                  AND R.VRALIQIMPRZ   = IP.VRALIQNF
                                  AND IP.CDIMPOSTO    = I.CDIMPOSTO
                                  AND I.CDIMPOSTONFE  IN ('00','03')
                                  AND IM.CDIMPOSTONFE = P_CDIMPOSTO
                                  AND R.CDIMPOSTO     = IM.CDIMPOSTO
                                  AND FI.CDEMPRESA    = P_CDEMPRESA
                                  AND FI.CDINSCESTA   = P_CDINSCESTA
                                  AND FI.CDFILIAL     = R.CDFILIAL
                                  AND R.CDFILIAL      = Z.CDFILIAL
                                  AND R.CDCAIXA       = Z.CDCAIXA
                                  AND R.NRECFREDZ     = Z.NRECFREDZ
                                  AND R.DTREDUCAOZ    = Z.DTREDUCAOZ
                                  AND Z.NRECFREDZ     = C_REGC405.NRECFREDZ
                                  AND Z.NRSERIEREDZ   = C_REGC400.NRSERIEREDZ
                                  AND Z.NRLANCTONF    IS NOT NULL
                                GROUP BY R.VRALIQIMPRZ,  '0'||SUBSTR(NVL(LPAD(IP.CDSITUTRIBNF,3,'0'),DECODE(IP.VRPERREDBCNF,0,'000','020')),2,2), IP.CDFISCOPERNF
                                UNION ALL
                               SELECT '060'  AS CST_ICMS,
                                      '5405' AS CFOP,
                                      0      AS ALIQ_ICMS,
                                      SUM(VRSTRIBREDZ) AS VL_OPR, /* VALOR DE SUBSTITUICAO TRIBUTARIA */
                                      0 VL_BC_ICMS,
                                      0 VL_ICMS,
                                      '' COD_OBS
                                 FROM REDUCAOZ RE, FILIAL FI
                                WHERE RE.CDCAIXA     = C_REGC400.CDCAIXA
                                  AND RE.DTREDUCAOZ  = C_REGC405.DTREDUCAOZ
                                  AND VRSTRIBREDZ    > 0
                                  AND FI.CDEMPRESA   = P_CDEMPRESA
                                  AND FI.CDINSCESTA  = P_CDINSCESTA
                                  AND FI.CDFILIAL    = RE.CDFILIAL
                                  AND RE.NRECFREDZ   = C_REGC405.NRECFREDZ
                                  AND RE.NRSERIEREDZ = C_REGC400.NRSERIEREDZ
                                  AND RE.NRLANCTONF  IS NULL
                                GROUP BY '060', '5405'
                                UNION ALL
                               SELECT '040'  AS CST_ICMS,
                                      '5102' AS CFOP,
                                      0      AS ALIQ_ICMS,
                                      SUM(VRISENCREDZ) AS VL_OPR, /* VALOR DE ISENÇÃO */
                                      0 VL_BC_ICMS,
                                      0 VL_ICMS,
                                      '' COD_OBS
                                 FROM REDUCAOZ RE, FILIAL FI
                                WHERE RE.CDCAIXA     = C_REGC400.CDCAIXA
                                  AND RE.DTREDUCAOZ  = C_REGC405.DTREDUCAOZ
                                  AND VRISENCREDZ    > 0
                                  AND FI.CDEMPRESA   = P_CDEMPRESA
                                  AND FI.CDINSCESTA  = P_CDINSCESTA
                                  AND FI.CDFILIAL    = RE.CDFILIAL
                                  AND RE.NRECFREDZ   = C_REGC405.NRECFREDZ
                                  AND RE.NRSERIEREDZ = C_REGC400.NRSERIEREDZ
                                  AND RE.NRLANCTONF  IS NULL
                                GROUP BY '040', '5102'
                                UNION ALL
                               SELECT '041'  AS CST_ICMS,
                                      '5102' AS CFOP,
                                      0      AS ALIQ_ICMS,
                                      SUM(VRNINCIDREDZ) AS VL_OPR, /* VALOR DE NÃO INCIDENCIA */
                                      0 VL_BC_ICMS,
                                      0 VL_ICMS,
                                      '' COD_OBS
                                 FROM REDUCAOZ RE, FILIAL FI
                                WHERE RE.CDCAIXA     = C_REGC400.CDCAIXA
                                  AND RE.DTREDUCAOZ  = C_REGC405.DTREDUCAOZ
                                  AND VRNINCIDREDZ   > 0
                                  AND FI.CDEMPRESA   = P_CDEMPRESA
                                  AND FI.CDINSCESTA  = P_CDINSCESTA
                                  AND FI.CDFILIAL    = RE.CDFILIAL
                                  AND RE.NRECFREDZ   = C_REGC405.NRECFREDZ
                                  AND RE.NRSERIEREDZ = C_REGC400.NRSERIEREDZ
                                  AND RE.NRLANCTONF  IS NULL
                                GROUP BY '041', '5102'
								        UNION ALL
								       SELECT '0'||SUBSTR(NVL(LPAD(IP.CDSITUTRIBNF,3,'0'),DECODE(IP.VRPERREDBCNF,0,'000','020')),2,2) AS CST_ICMS,
                                      NVL(IP.CDFISCOPERNF,'5102') AS CFOP,
                                      0 AS ALIQ_ICMS,
                                      SUM(IP.VRCONTABILNF) AS VL_OPR,
                                      0 AS VL_BC_ICMS,
                                      0 AS VL_ICMS,
                                      '' COD_OBS
                                 FROM IMPOSTONF IP, FILIAL FI, REDUCAOZ Z, IMPOSTO IM
                                WHERE Z.DTREDUCAOZ    = C_REGC405.DTREDUCAOZ
                                  AND Z.CDCAIXA       = C_REGC400.CDCAIXA
                                  AND Z.CDFILIALNF    = IP.CDFILIAL
                                  AND Z.NRLANCTONF    = IP.NRLANCTONF
                                  AND IP.CDIMPOSTO    = IM.CDIMPOSTO
                                  AND IM.CDIMPOSTONFE = P_CDIMPOSTO
                                  AND FI.CDEMPRESA    = P_CDEMPRESA
                                  AND FI.CDINSCESTA   = P_CDINSCESTA
                                  AND FI.CDFILIAL     = Z.CDFILIAL
                                  AND Z.NRECFREDZ     = C_REGC405.NRECFREDZ
                                  AND Z.NRSERIEREDZ   = C_REGC400.NRSERIEREDZ
                                  AND IP.CDFISCALNF   <> '1'
                                  AND IP.IDIMPOSTONF  <> '2'
                                  AND Z.NRLANCTONF    IS NOT NULL
                                  AND NVL(IP.VRIMPCARGATRIBI,0) = 0
                                GROUP BY '0'||SUBSTR(NVL(LPAD(IP.CDSITUTRIBNF,3,'0'),DECODE(IP.VRPERREDBCNF,0,'000','020')),2,2), IP.CDFISCOPERNF)) LOOP
            INSERT INTO ARQMAGNETICO
              (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
            VALUES
              ('25'||LPAD(RTRIM(V_CONTREGC), 8, '0'), C_490.C490, P_NRSEQARQMAG);
            V_CONTREGC := NVL(V_CONTREGC,0) + 1;
         END LOOP;
       END IF;
      END LOOP;
   END LOOP;
   V_DADOS_2 := '';
   V_COD_PAR := '';

   IF V_CDSITUCRT = '3' THEN
      FOR C_500 IN (SELECT REG                 || '|' ||
                            IND_OPER            || '|' ||
                            IND_EMIT            || '|' ||
                            REPLACE(REPLACE(REPLACE(REPLACE(COD_PAR,'.'),'-'),'/'),' ') || '|' ||
                            COD_MOD             || '|' AS PART_1,
                            SER                 || '|' ||
                            SUB                 || '|' ||
                            COD_CONS            || '|' ||
                            NUM_DOC             || '|' ||
                            DT_DOC              || '|' ||
                            DT_E_S              || '|' ||
                            REPLACE(LTRIM(TO_CHAR(ROUND(VL_DOC,2), '999999999990.00')), '.', ',')    || '|' ||
                            VL_DESC             || '|' ||
                            REPLACE(LTRIM(TO_CHAR(ROUND(VL_FORN,2), '999999999990.00')), '.', ',')   || '|' ||
                            REPLACE(LTRIM(TO_CHAR(ROUND(VL_SERV_NT,2), '999999999990.00')), '.', ',')|| '|' ||
                            VL_TERC             || '|' ||
                            VL_DA               || '|' ||
                            REPLACE(LTRIM(TO_CHAR(ROUND(VL_BC_ICMS + DECODE(V_IDTPCARGATRIB,'O',0,DECODE(V_SGESTADO,'SP',0,NVL(VRBASECARGA,0))),2), '999999999990.00')), '.', ',')|| '|' ||
                            REPLACE(LTRIM(TO_CHAR(ROUND(VL_ICMS    + DECODE(V_IDTPCARGATRIB,'O',0,NVL(DECODE(IDENTRSAIDOP,'S',VRIMPCARGA,DECODE(V_SGESTADO,'SP',0,VRIMPCARGA)),0)),2), '999999999990.00')), '.', ',')   || '|' ||
                            VL_BC_ICMS_ST       || '|' ||
                            VL_ICMS_ST          || '|' ||
                            COD_INF             || '|' ||
                            VL_PIS              || '|' ||
                            VL_COFINS           || '|' ||
                            TP_LIGACAO          || '|' ||
                            COD_GRUPO_TENSAO    || '|' AS PART_2,
                            IDSTATUS, DTEMISSAO, CDFILIAL, NRLANCTONF, COD_PAR,
                            IDENTRSAIDOP, IDORIGDESTNF, CDTIPOOPER, FILIAL
                       FROM (SELECT '|C500' AS REG,
                                    DECODE(N.IDENTRSAIDOP, 'E', '0','1')  AS IND_OPER,
                                    '1' AS IND_EMIT,
                                    N.IDORIGDESTNF||N.CDFORNECED AS COD_PAR,
                                    N.CDMODDOCFISC AS COD_MOD,
                                    NVL(SE.CDSERIEENTRNFE,N.CDSERIEENTR) AS SER,
                                    '' AS SUB,
                                    '01' AS COD_CONS,
                                    LTRIM(N.NRNOTAFISC, '0') AS NUM_DOC,
                                    TO_CHAR(N.DTEMISSAO,'ddmmyyyy') AS DT_DOC,
                                    TO_CHAR(N.DTENTRSAID,'ddmmyyyy') AS DT_E_S,
                                    SUM(I.VRCONTABILNF) AS VL_DOC,
                                    '0,00' AS VL_DESC,
                                    SUM(I.VRCONTABILNF) AS VL_FORN,
                                    SUM(DECODE(CDFISCALNF, '2', VRCONTABILNF, 0)) AS VL_SERV_NT,
                                    '0,00' AS VL_TERC,
                                    '0,00' AS VL_DA,
                                    SUM(DECODE(CDFISCALNF, '1', VRBASECALCNF, 0)) AS VL_BC_ICMS,
                                    SUM((SELECT SUM(VRBASECALCNF)
                                           FROM IMPOSTONF IP
                                          WHERE IP.CDFILIAL   = I.CDFILIAL
                                            AND IP.NRLANCTONF = I.NRLANCTONF
                                            AND IP.CDIMPOSTO  = IM.CDIMPCARGATRIB)) AS VRBASECARGA,
                                    SUM(DECODE(CDFISCALNF, '1', VRIMPOSTONF, 0)) AS VL_ICMS,
                                    SUM(VRIMPCARGATRIBI) AS VRIMPCARGA,
                                    '0,00' AS VL_BC_ICMS_ST,
                                    '0,00' AS VL_ICMS_ST,
                                    '' AS COD_INF,
                                    '0,00' AS VL_PIS,
                                    '0,00' AS VL_COFINS,
                                    '1' AS TP_LIGACAO,
                                    '01' AS COD_GRUPO_TENSAO,
                                    N.IDSTATUS, N.DTENTRSAID AS DTEMISSAO, N.CDFILIAL, N.NRLANCTONF, N.IDENTRSAIDOP,
                                    N.IDORIGDESTNF, N.CDTIPOOPER, N.CDFILIRECE AS FILIAL
                               FROM NOTAFISCAL N, IMPOSTONF I, FORNECEDOR F, IMPOSTO IM, SERIEENTR SE
                              WHERE I.NRSEQUMAPAPU    = V_NRSEQUMAPAPU
                                AND IM.CDIMPOSTONFE   = P_CDIMPOSTO
                                AND I.CDIMPOSTO       = IM.CDIMPOSTO
                                AND (NVL(N.IDSISTEMA,'DFS') <> 'REC'
                                AND NVL(N.IDSISTEMA, 'DFS') <> 'PAG'
                                AND NVL(N.IDSISTEMA, 'DFS') <> 'CMP'
                                AND NVL(N.IDSISTEMA, 'DFS') <> 'SUP'
                                AND NVL(N.IDSISTEMA, 'DFS') <> 'TMP'
                                AND NVL(N.IDSISTEMA, 'DFS') <> 'FIS')
                                AND SE.CDSERIEENTR(+) = N.CDSERIEENTR
                                AND N.IDENTRSAIDOP    = 'E' 
                                AND NVL(I.IDIMPOSTONF, '1') <> '3' 
                                AND N.CDFILIAL        = I.CDFILIAL 
                                AND N.NRLANCTONF      = I.NRLANCTONF
                                AND ((N.IDSTATUS = 'A') OR (N.IDSTATUS = 'E')) 
                                AND N.CDMODDOCFISC IN ('06', '29','28') 
                                AND N.CDFORNECED   = F.CDFORNECED 
                                AND N.IDORIGDESTNF = 'F' 
                              GROUP BY DECODE(N.IDENTRSAIDOP, 'E', '0','1'), N.IDORIGDESTNF||N.CDFORNECED, N.CDMODDOCFISC,
                                    NVL(SE.CDSERIEENTRNFE,N.CDSERIEENTR), LTRIM(N.NRNOTAFISC, '0'), TO_CHAR(N.DTEMISSAO,'ddmmyyyy'),
                                    TO_CHAR(N.DTENTRSAID,'ddmmyyyy'), N.IDSTATUS, N.DTENTRSAID, N.CDFILIAL, N.NRLANCTONF,
                                    N.IDENTRSAIDOP, N.IDORIGDESTNF, N.CDTIPOOPER, N.CDFILIRECE
                             UNION ALL 
                             SELECT '|C500' AS REG, 
                                    DECODE(N.IDENTRSAIDOP, 'E', '0','1') AS IND_OPER, 
                                    '1' AS IND_EMIT,
                                    N.IDORIGDESTNF||N.CDCLIENTE AS COD_PAR,
                                    N.CDMODDOCFISC AS COD_MOD, 
                                    NVL(SE.CDSERIEENTRNFE,N.CDSERIEENTR) AS SER, 
                                    '' AS SUB, 
                                    '01' AS COD_CONS, 
                                    LTRIM(N.NRNOTAFISC, '0') AS NUM_DOC,
                                    TO_CHAR(N.DTEMISSAO,'ddmmyyyy') AS DT_DOC,
                                    TO_CHAR(N.DTENTRSAID,'ddmmyyyy') AS DT_E_S,
                                    SUM(I.VRCONTABILNF) AS VL_DOC, 
                                    '0,00' AS VL_DESC, 
                                    SUM(I.VRCONTABILNF) AS VL_FORN, 
                                    SUM(DECODE(CDFISCALNF, '2', VRCONTABILNF, 0)) AS VL_SERV_NT,
                                    '0,00' AS VL_TERC, 
                                    '0,00' AS VL_DA, 
                                    SUM(DECODE(CDFISCALNF, '1', VRBASECALCNF, 0)) AS VL_BC_ICMS, 
                                    SUM((SELECT SUM(VRBASECALCNF) 
                                           FROM IMPOSTONF IP 
                                          WHERE IP.CDFILIAL   = I.CDFILIAL
                                            AND IP.NRLANCTONF = I.NRLANCTONF 
                                            AND IP.CDIMPOSTO  = IM.CDIMPCARGATRIB)) AS VRBASECARGA,
                                    SUM(DECODE(CDFISCALNF, '1', VRIMPOSTONF, 0)) AS VL_ICMS,
                                    SUM(VRIMPCARGATRIBI) AS VRIMPCARGA, 
                                    '0,00' AS VL_BC_ICMS_ST, 
                                    '0,00' AS VL_ICMS_ST,
                                    '' AS COD_INF, 
                                    '0,00' AS VL_PIS, 
                                    '0,00' AS VL_COFINS, 
                                    '1' AS TP_LIGACAO, 
                                    '01' AS COD_GRUPO_TENSAO, 
                                    N.IDSTATUS, N.DTENTRSAID AS DTEMISSAO, N.CDFILIAL, N.NRLANCTONF, N.IDENTRSAIDOP,
                                    N.IDORIGDESTNF, N.CDTIPOOPER, N.CDFILIRECE AS FILIAL
                               FROM NOTAFISCAL N, IMPOSTONF I, CLIENTE C, IMPOSTO IM, SERIEENTR SE 
                              WHERE I.NRSEQUMAPAPU    = V_NRSEQUMAPAPU 
                                AND IM.CDIMPOSTONFE   = P_CDIMPOSTO 
                                AND I.CDIMPOSTO       = IM.CDIMPOSTO 
                                AND (NVL(N.IDSISTEMA,'DFS') <> 'REC'
                                AND NVL(N.IDSISTEMA, 'DFS') <> 'PAG' 
                                AND NVL(N.IDSISTEMA, 'DFS') <> 'CMP' 
                                AND NVL(N.IDSISTEMA, 'DFS') <> 'SUP' 
                                AND NVL(N.IDSISTEMA, 'DFS') <> 'TMP' 
                                AND NVL(N.IDSISTEMA, 'DFS') <> 'FIS') 
                                AND SE.CDSERIEENTR(+) = N.CDSERIEENTR
                                AND N.IDENTRSAIDOP    = 'E' 
                                AND NVL(I.IDIMPOSTONF, '1') <> '3' 
                                AND N.CDFILIAL        = I.CDFILIAL 
                                AND N.NRLANCTONF      = I.NRLANCTONF 
                                AND ((N.IDSTATUS = 'A') OR (N.IDSTATUS = 'E')) 
                                AND N.CDMODDOCFISC IN ('06', '29','28')
                                AND N.CDCLIENTE = C.CDCLIENTE
                                AND N.IDORIGDESTNF = 'C' 
                              GROUP BY DECODE(N.IDENTRSAIDOP, 'E', '0','1'), N.IDORIGDESTNF||N.CDCLIENTE, N.CDMODDOCFISC,
                                    NVL(SE.CDSERIEENTRNFE,N.CDSERIEENTR), LTRIM(N.NRNOTAFISC, '0'), TO_CHAR(N.DTEMISSAO,'ddmmyyyy'),
                                    TO_CHAR(N.DTENTRSAID,'ddmmyyyy'), N.IDSTATUS, N.DTENTRSAID, N.CDFILIAL, N.NRLANCTONF,
                                    N.IDENTRSAIDOP, N.IDORIGDESTNF, N.CDTIPOOPER, N.CDFILIRECE
                             UNION ALL 
                             SELECT '|C500' AS REG, 
                                    DECODE(N.IDENTRSAIDOP, 'E', '0','1') AS IND_OPER, 
                                    '1' AS IND_EMIT, 
                                    N.IDORIGDESTNF||N.CDFILIEMIT AS COD_PAR,
                                    N.CDMODDOCFISC AS COD_MOD,
                                    NVL(SE.CDSERIE,N.CDSERIE) AS SER,
                                    '' AS SUB, 
                                    '01' AS COD_CONS, 
                                    LTRIM(N.NRNOTAFISC, '0') AS NUM_DOC, 
                                    TO_CHAR(N.DTEMISSAO,'ddmmyyyy') AS DT_DOC,
                                    TO_CHAR(N.DTENTRSAID,'ddmmyyyy') AS DT_E_S,
                                    SUM(I.VRCONTABILNF) AS VL_DOC, 
                                    '0,00' AS VL_DESC, 
                                    SUM(I.VRCONTABILNF) AS VL_FORN, 
                                    SUM(DECODE(CDFISCALNF, '2', VRCONTABILNF, 0)) AS VL_SERV_NT, 
                                    '0,00' AS VL_TERC, 
                                    '0,00' AS VL_DA,
                                    SUM(DECODE(CDFISCALNF, '1', VRBASECALCNF, 0)) AS VL_BC_ICMS, 
                                    SUM((SELECT SUM(VRBASECALCNF) 
                                           FROM IMPOSTONF IP 
                                          WHERE IP.CDFILIAL   = I.CDFILIAL 
                                            AND IP.NRLANCTONF = I.NRLANCTONF 
                                            AND IP.CDIMPOSTO  = IM.CDIMPCARGATRIB)) AS VRBASECARGA,
                                    SUM(DECODE(CDFISCALNF, '1', VRIMPOSTONF, 0)) AS VL_ICMS, 
                                    SUM(VRIMPCARGATRIBI) AS VRIMPCARGA, 
                                    '0,00' AS VL_BC_ICMS_ST, 
                                    '0,00' AS VL_ICMS_ST, 
                                    '' AS COD_INF, 
                                    '0,00' AS VL_PIS,
                                    '0,00' AS VL_COFINS, 
                                    '1' AS TP_LIGACAO, 
                                    '01' AS COD_GRUPO_TENSAO, 
                                    N.IDSTATUS, N.DTEMISSAO, N.CDFILIAL, N.NRLANCTONF, N.IDENTRSAIDOP,
                                    N.IDORIGDESTNF, N.CDTIPOOPER, N.CDFILIEMIT AS FILIAL
                               FROM NOTAFISCAL N, IMPOSTONF I, FILIAL F, IMPOSTO IM, SERIENF SE
                              WHERE I.NRSEQUMAPAPU    = V_NRSEQUMAPAPU 
                                AND IM.CDIMPOSTO      = P_CDIMPOSTO 
                                AND IM.CDIMPOSTO      = IM.CDIMPOSTO
                                AND (NVL(N.IDSISTEMA,'DFS') <> 'REC' 
                                AND NVL(N.IDSISTEMA, 'DFS') <> 'PAG' 
                                AND NVL(N.IDSISTEMA, 'DFS') <> 'CMP'
                                AND NVL(N.IDSISTEMA, 'DFS') <> 'SUP' 
                                AND NVL(N.IDSISTEMA, 'DFS') <> 'TMP' 
                                AND NVL(N.IDSISTEMA, 'DFS') <> 'FIS')
                                AND SE.CDEMPRESA(+)   = N.CDEMPRESA
                                AND SE.CDINSCESTA(+)  = N.CDINSCESTA
                                AND SE.CDINSCMUNI(+)  = N.CDINSCMUNI
                                AND SE.CDSERIE(+)     = N.CDSERIE
                                AND N.IDENTRSAIDOP    = 'S'
                                AND NVL(I.IDIMPOSTONF, '1') <> '3' 
                                AND N.CDFILIAL        = I.CDFILIAL 
                                AND N.NRLANCTONF      = I.NRLANCTONF 
                                AND ((N.IDSTATUS = 'A') OR (N.IDSTATUS = 'E'))
                                AND N.CDMODDOCFISC IN ('06', '29','28') 
                                AND N.CDFILIEMIT = F.CDFILIAL 
                                AND IDORIGDESTNF = 'L' 
                              GROUP BY DECODE(N.IDENTRSAIDOP, 'E', '0','1'), N.IDORIGDESTNF||N.CDFILIEMIT, N.CDMODDOCFISC,
                                    NVL(SE.CDSERIE,N.CDSERIE), LTRIM(N.NRNOTAFISC, '0'), TO_CHAR(N.DTEMISSAO,'ddmmyyyy'),
                                    TO_CHAR(N.DTENTRSAID,'ddmmyyyy'), N.IDSTATUS, N.DTEMISSAO, N.CDFILIAL, N.NRLANCTONF,
                                    N.IDENTRSAIDOP, N.IDORIGDESTNF, N.CDTIPOOPER, N.CDFILIEMIT)) LOOP
          /* CODIDO DO PARTICIPANTE */
          SELECT MAX(CDCHAVEREG)
            INTO V_COD_PAR
            FROM TMP_REGDADOSSPED
           WHERE CDCHAVEREG = C_500.COD_PAR
             AND CDREGISTRO = '0150';
 
          IF (V_COD_PAR IS NULL) AND (C_500.COD_PAR IS NOT NULL) THEN
             V_SEQUPROD := NVL(V_SEQUPROD,0) + 1;
             INSERT INTO TMP_REGDADOSSPED
               (CDREGISTRO, CDCONTREGI, CDCHAVEREG)
             VALUES 
               ('0150', V_SEQUPROD, C_500.COD_PAR);
          END IF;

          V_COD_PAR := '';
          IF C_500.IDSTATUS = 'C' THEN
             /* documentos cancelados */
             V_DADOS_2 := '02|';
          ELSE
             IF NOT C_500.DTEMISSAO BETWEEN P_DTINICIAL AND P_DTFINAL THEN 
                /* documentos fora do periodo */
                V_DADOS_2 := '01|';
             ELSE
                V_DADOS_2 := '00|';
             END IF;
          END IF; 
          INSERT INTO ARQMAGNETICO 
            (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG) 
          VALUES 
            ('25'||LPAD(RTRIM(V_CONTREGC), 8, '0'), C_500.PART_1||V_DADOS_2||C_500.PART_2, P_NRSEQARQMAG); 
          V_CONTREGC := NVL(V_CONTREGC,0) + 1; 
          V_SEQUENCIAL := LPAD(RTRIM(TO_CHAR(TO_NUMBER('1'))),3,'0'); 
          FOR C_510 IN (SELECT COD_ITEM         || '|' || 
                               COD_CLASS        || '|' || 
                               QTD              || '|' || 
                               UNID             || '|' || 
                               REPLACE(LTRIM(TO_CHAR(ROUND(VL_ITEM,2), '999999999990.00')), '.', ',')    || '|' || 
                               VL_DESC          || '|' || 
                               CST_ICMS         || '|' || 
                               CFOP             || '|' || 
                               REPLACE(LTRIM(TO_CHAR(ROUND(VL_BC_ICMS + DECODE(V_IDTPCARGATRIB,'O',0,DECODE(V_SGESTADO,'SP',0,NVL(VRBASECARGA,0))),2), '999999999990.00')), '.', ',') || '|' || 
                               REPLACE(LTRIM(TO_CHAR(ROUND(ALIQ_ICMS,2), '999999999990.00')), '.', ',')  || '|' || 
                               REPLACE(LTRIM(TO_CHAR(ROUND(VL_ICMS    + DECODE(V_IDTPCARGATRIB,'O',0,DECODE(C_500.IDENTRSAIDOP,'E',DECODE(V_SGESTADO,'SP',0,NVL(VRIMPCARGA,0)),NVL(VRIMPCARGA,0))),2), '999999999990.00')), '.', ',')    || '|' ||
                               VL_BC_ICMS_ST    || '|' ||
                               ALIQ_ST          || '|' ||
                               VL_ICMS_ST       || '|' ||
                               IND_REC          || '|' ||
                               COD_PART         || '|' ||
                               VL_PIS           || '|' ||
                               VL_COFINS        || '|' ||
                               COD_CTA          || '|' AS REGC510,
                               CDPRODUTO, UNID, CDCLASFISC, COD_CTA
                         FROM (SELECT CDARVPROD AS COD_ITEM,
                                      '0601' AS COD_CLASS,
                                      QTITEMPROD AS QTD,
                                      SGUNIDADE AS UNID,
                                      VRUNITITEM AS VL_ITEM,
                                      '0,00' AS VL_DESC,
                                      CDSITUTRIBIT AS CST_ICMS,
                                      CDFISCOPERIT AS CFOP,
                                      DECODE(CDFISCALIT, '1', VRBASECALCIT, 0) AS VL_BC_ICMS,
                                      (SELECT SUM(IT.VRBASECALCIT)
                                         FROM ITEMPROIMPOS IP
                                        WHERE IP.CDFILIAL   = IT.CDFILIAL
                                          AND IP.NRLANCTONF = IT.NRLANCTONF
                                          AND IP.CDIMPOSTO  = IM.CDIMPCARGATRIB) AS VRBASECARGA,
                                      DECODE(CDFISCALIT, '1', VRALIQITEM, 0) AS ALIQ_ICMS,
                                      DECODE(CDFISCALIT, '1', VRIMPOSTOIT, 0) AS VL_ICMS,
                                      (SELECT SUM(IT.VRIMPOSTOIT)
                                         FROM ITEMPROIMPOS IP
                                        WHERE IP.CDFILIAL   = IT.CDFILIAL
                                          AND IP.NRLANCTONF = IT.NRLANCTONF
                                          AND IP.CDIMPOSTO  = IM.CDIMPCARGATRIB) AS VRIMPCARGA,
                                      '0,00' AS VL_BC_ICMS_ST,
                                      '0,00' AS ALIQ_ST,
                                      '0,00' AS VL_ICMS_ST,
                                      '1' AS IND_REC,
                                      '' AS COD_PART,
                                      '0,00' AS VL_PIS,
                                      '0,00' AS VL_COFINS,
                                      CONTCTBL_SPED(C_500.IDENTRSAIDOP, I.CDPRODUTO, C_500.CDTIPOOPER, C_500.FILIAL) AS COD_CTA,
                                      P.CDPRODUTO,
                                      I.CDPRODNCMTRANS AS CDCLASFISC
                                 FROM ITEMPRODUTO I, ITEMPROIMPOS IT, PRODUTO P, IMPOSTO IM
                                WHERE I.CDFILIAL = C_500.CDFILIAL 
                                  AND I.NRLANCTONF = C_500.NRLANCTONF 
                                  AND I.CDFILIAL = IT.CDFILIAL 
                                  AND I.NRLANCTONF = IT.NRLANCTONF 
                                  AND I.NRSEQITPROD = IT.NRSEQITPROD 
                                  AND SUBSTR(IT.CDFISCOPERIT,1,1) IN ('5','6','7') 
                                  AND P.CDPRODUTO = I.CDPRODUTO 
                                  AND IM.CDIMPOSTO = IT.CDIMPOSTO) ) LOOP

            INSERT INTO ARQMAGNETICO
               (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
            VALUES
               ('25'||LPAD(RTRIM(V_CONTREGC), 8, '0'), '|C510|'||V_SEQUENCIAL||'|'||C_510.REGC510, P_NRSEQARQMAG);
            V_CONTREGC := NVL(V_CONTREGC,0) + 1;
            V_SEQUENCIAL := LPAD(RTRIM(TO_CHAR(TO_NUMBER(RTRIM(V_SEQUENCIAL))+1)), 3,'0');

            /* CODIGO DO PRODUTO */
            SELECT MAX(CDCHAVEREG)
              INTO V_PRODUTO
              FROM TMP_REGDADOSSPED
             WHERE CDCHAVEREG = C_510.CDPRODUTO
               AND CDREGISTRO = '0200';
            IF V_PRODUTO IS NULL AND (C_510.CDPRODUTO IS NOT NULL) THEN
               V_SEQUPROD := NVL(V_SEQUPROD,0) + 1;
               INSERT INTO TMP_REGDADOSSPED
                  (CDREGISTRO, CDCONTREGI, CDCHAVEREG, CDCAMPO3)
               VALUES
                  ('0200', V_SEQUPROD, C_510.CDPRODUTO, C_510.CDCLASFISC);
            END IF;
            V_PRODUTO := '';

            /* UNIDADE DE MEDIDA */
            SELECT MAX(CDCHAVEREG)
              INTO V_UNID
              FROM TMP_REGDADOSSPED
             WHERE CDCHAVEREG = C_510.UNID
               AND CDREGISTRO = '0190';
            IF (V_UNID IS NULL) AND (C_510.UNID IS NOT NULL) THEN
               V_SEQUPROD := NVL(V_SEQUPROD,0) + 1;
               INSERT INTO TMP_REGDADOSSPED
                  (CDREGISTRO, CDCONTREGI, CDCHAVEREG)
               VALUES
                  ('0190', V_SEQUPROD, C_510.UNID);
            END IF;
            V_UNID := '';

            /* PLANO DE CONTAS REFERENCIAL */
            SELECT MAX(CDCHAVEREG)
              INTO V_CONTCTBL
              FROM TMP_REGDADOSSPED
             WHERE CDCHAVEREG = C_510.COD_CTA
               AND CDREGISTRO = '0500';

            IF (V_CONTCTBL IS NULL) AND (C_510.COD_CTA IS NOT NULL) THEN
               V_SEQUPROD := NVL(V_SEQUPROD,0) + 1;
               INSERT INTO TMP_REGDADOSSPED
                  (CDREGISTRO, CDCONTREGI, CDCHAVEREG)
               VALUES
                  ('0500', V_SEQUPROD, C_510.COD_CTA);
            END IF;
            V_CONTCTBL := '';
          END LOOP;

          FOR C_590 IN(SELECT ('|C590'      || '|' || 
                               T.CST_ICMS   || '|' || 
                               T.CFOP       || '|' || 
                               REPLACE(LTRIM(TO_CHAR(ROUND(T.ALIQ_ICMS,2), '999999999990.00')), '.', ',')      || '|' || 
                               REPLACE(LTRIM(TO_CHAR(ROUND(T.VL_OPR,2), '999999999990.00')), '.', ',')      || '|' || 
                               REPLACE(LTRIM(TO_CHAR(ROUND(T.VL_BC_ICMS + DECODE(V_IDTPCARGATRIB,'O',0,DECODE(V_SGESTADO,'SP',0,NVL(VRBASECARGA,0))),2), '999999999990.00')), '.', ',')      || '|' || 
                               REPLACE(LTRIM(TO_CHAR(ROUND(T.VL_ICMS    + DECODE(V_IDTPCARGATRIB,'O',0,NVL(DECODE(C_500.IDENTRSAIDOP,'E',DECODE(V_SGESTADO,'SP',0,VRIMPCARGA),VRIMPCARGA),0)),2), '999999999990.00')), '.', ',')      || '|' || 
                               REPLACE(LTRIM(TO_CHAR(ROUND(0,2), '999999999990.00')), '.', ',')      || '|' || 
                               REPLACE(LTRIM(TO_CHAR(ROUND(0,2), '999999999990.00')), '.', ',')      || '|' || 
                               REPLACE(LTRIM(TO_CHAR(ROUND(T.VL_RED_BC,2), '999999999990.00')), '.', ',')      || '|' || 
                               '' || '|') ARQ_C590 
                       FROM (SELECT CDSITUTRIBIT AS CST_ICMS, 
                                    CDFISCOPERIT AS CFOP, 
                                    DECODE(CDFISCALIT, '1', VRALIQITEM, 0) AS ALIQ_ICMS, 
                                    SUM(VRCONTITIMP)+NVL(SUM(VALOR_REDUCAO(I.CDFILIAL, I.NRLANCTONF, I.CDSITUTRIBIT, I.NRSEQITPROD, I.CDFISCOPERIT, NULL, NULL, NULL)),0) VL_OPR, 
                                    SUM(DECODE(CDFISCALIT, '1', VRBASECALCIT, 0)) AS VL_BC_ICMS, 
                                    SUM((SELECT SUM(IP.VRBASECALCIT) 
                                           FROM ITEMPROIMPOS IP 
                                          WHERE IP.CDFILIAL     = I.CDFILIAL
                                            AND IP.NRLANCTONF   = I.NRLANCTONF
                                            AND IP.CDSITUTRIBIT = I.CDSITUTRIBIT 
                                            AND IP.CDFISCOPERIT = I.CDFISCOPERIT 
                                            AND IP.CDIMPOSTO    = IM.CDIMPCARGATRIB)) AS VRBASECARGA,
                                    SUM(DECODE(CDFISCALIT, '1', VRIMPOSTOIT, 0)) AS VL_ICMS, 
                                    SUM((SELECT SUM(IP.VRIMPOSTOIT) 
                                           FROM ITEMPROIMPOS IP 
                                          WHERE IP.CDFILIAL     = I.CDFILIAL
                                            AND IP.NRLANCTONF   = I.NRLANCTONF
                                            AND IP.CDSITUTRIBIT = I.CDSITUTRIBIT 
                                            AND IP.CDFISCOPERIT = I.CDFISCOPERIT 
                                            AND IP.CDIMPOSTO    = IM.CDIMPCARGATRIB)) AS VRIMPCARGA, 
                                    0 AS VL_BC_ICMS_ST, 
                                    0 AS VL_ICMS_ST, 
                                    NVL(SUM(VALOR_REDUCAO(I.CDFILIAL, I.NRLANCTONF, I.CDSITUTRIBIT, I.NRSEQITPROD, I.CDFISCOPERIT, NULL, NULL, NULL) ),0) AS VL_RED_BC, 
                                    0 AS VL_IPI, 
                                    '' AS COD_OBS 
                               FROM ITEMPROIMPOS I, IMPOSTO IM 
                              WHERE I.CDFILIAL      = C_500.CDFILIAL 
                                AND I.NRLANCTONF    = C_500.NRLANCTONF 
                                AND I.NRITPROIMPOS    = '1' 
                                AND IM.CDIMPOSTO    = I.CDIMPOSTO 
                                AND IM.CDIMPOSTONFE = P_CDIMPOSTO 
                              GROUP BY CDSITUTRIBIT, I.CDFISCOPERIT, DECODE(I.CDFISCALIT, '1', I.VRALIQITEM, 0) ) T ) LOOP 
             INSERT INTO ARQMAGNETICO 
               (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG) 
             VALUES 
               ('25'||LPAD(RTRIM(V_CONTREGC), 8, '0'), C_590.ARQ_C590, P_NRSEQARQMAG); 
             V_CONTREGC := NVL(V_CONTREGC,0) + 1; 
          END LOOP; 
       END LOOP; 
   END IF; 
 
   IF V_CDSITUCRT <> '3' THEN   /*SIMPLES NACIONAL*/
       FOR C_500 IN (SELECT REG                 || '|' ||
                            IND_OPER            || '|' || 
                            IND_EMIT            || '|' ||
                            REPLACE(REPLACE(REPLACE(REPLACE(COD_PAR,'.'),'-'),'/'),' ') || '|' || 
                            COD_MOD             || '|' AS PART_1,
                            SER                 || '|' ||
                            SUB                 || '|' || 
                            COD_CONS            || '|' || 
                            NUM_DOC             || '|' || 
                            DT_DOC              || '|' || 
                            DT_E_S              || '|' || 
                            REPLACE(LTRIM(TO_CHAR(ROUND(VL_DOC,2), '999999999990.00')), '.', ',')    || '|' || 
                            VL_DESC             || '|' || 
                            REPLACE(LTRIM(TO_CHAR(ROUND(VL_FORN,2), '999999999990.00')), '.', ',')   || '|' || 
                            REPLACE(LTRIM(TO_CHAR(ROUND(VL_SERV_NT,2), '999999999990.00')), '.', ',')|| '|' || 
                            VL_TERC             || '|' || 
                            VL_DA               || '|' || 
                            REPLACE(LTRIM(TO_CHAR(ROUND(VL_BC_ICMS + DECODE(V_IDTPCARGATRIB,'O',0,DECODE(V_SGESTADO,'SP',0,NVL(VRBASECARGA,0))),2), '999999999990.00')), '.', ',')|| '|' || 
                            REPLACE(LTRIM(TO_CHAR(ROUND(VL_ICMS    + DECODE(V_IDTPCARGATRIB,'O',0,DECODE(IDENTRSAIDOP,'S',NVL(VRIMPCARGA,0),DECODE(V_SGESTADO,'SP',0,NVL(VRIMPCARGA,0)))),2), '999999999990.00')), '.', ',')   || '|' || 
                            VL_BC_ICMS_ST       || '|' || 
                            VL_ICMS_ST          || '|' || 
                            COD_INF             || '|' || 
                            VL_PIS              || '|' || 
                            VL_COFINS           || '|' || 
                            TP_LIGACAO          || '|' || 
                            COD_GRUPO_TENSAO    || '|' AS PART_2, 
                            IDSTATUS, DTEMISSAO, CDFILIAL, NRLANCTONF, COD_PAR, IDENTRSAIDOP,
                            IDORIGDESTNF, CDTIPOOPER, FILIAL
                       FROM (SELECT '|C500' AS REG,
                                    DECODE(N.IDENTRSAIDOP, 'E', '0','1')  AS IND_OPER,
                                    '1' AS IND_EMIT,
                                    N.IDORIGDESTNF||N.CDFORNECED AS COD_PAR,
                                    N.CDMODDOCFISC AS COD_MOD,
                                    NVL(SE.CDSERIEENTRNFE,N.CDSERIEENTR) AS SER,
                                    '' AS SUB,
                                    '01' AS COD_CONS,
                                    LTRIM(N.NRNOTAFISC, '0') AS NUM_DOC,
                                    TO_CHAR(N.DTEMISSAO,'ddmmyyyy') AS DT_DOC,
                                    TO_CHAR(N.DTENTRSAID,'ddmmyyyy') AS DT_E_S,
                                    SUM(I.VRCONTABILNF) AS VL_DOC,
                                    '0,00' AS VL_DESC,
                                    SUM(I.VRCONTABILNF) AS VL_FORN,
                                    SUM(DECODE(CDFISCALNF, '2', VRCONTABILNF, 0)) AS VL_SERV_NT,
                                    '0,00' AS VL_TERC,
                                    '0,00' AS VL_DA,
                                    SUM(DECODE(CDFISCALNF, '1', VRBASECALCNF, 0)) AS VL_BC_ICMS,
                                    SUM((SELECT SUM(VRBASECALCNF)
                                           FROM IMPOSTONF IP
                                          WHERE IP.CDFILIAL   = I.CDFILIAL
                                            AND IP.NRLANCTONF = I.NRLANCTONF
                                            AND IP.CDIMPOSTO  = IM.CDIMPCARGATRIB)) AS VRBASECARGA,
                                    SUM(DECODE(CDFISCALNF, '1', VRIMPOSTONF, 0)) AS VL_ICMS,
                                    SUM(VRIMPCARGATRIBI) AS VRIMPCARGA,
                                    '0,00' AS VL_BC_ICMS_ST,
                                    '0,00' AS VL_ICMS_ST,
                                    '' AS COD_INF,
                                    '0,00' AS VL_PIS,
                                    '0,00' AS VL_COFINS,
                                    '1' AS TP_LIGACAO,
                                    '01' AS COD_GRUPO_TENSAO,
                                    N.IDSTATUS, N.DTEMISSAO, N.CDFILIAL, N.NRLANCTONF, N.IDENTRSAIDOP,
                                    N.IDORIGDESTNF, N.CDTIPOOPER, N.CDFILIRECE AS FILIAL
                               FROM NOTAFISCAL N, IMPOSTONF I, FORNECEDOR F, IMPOSTO IM, SERIEENTR SE
                              WHERE N.NRSEQUMAPAPUSN  = V_NRSEQUMAPAPU
                                AND N.CDINSCESTA      = P_CDINSCESTA
                                AND IM.CDIMPOSTONFE   = P_CDIMPOSTO 
                                AND I.CDIMPOSTO       = IM.CDIMPOSTO 
                                AND (NVL(N.IDSISTEMA,'DFS') <> 'REC' 
                                AND NVL(N.IDSISTEMA, 'DFS') <> 'PAG' 
                                AND NVL(N.IDSISTEMA, 'DFS') <> 'CMP' 
                                AND NVL(N.IDSISTEMA, 'DFS') <> 'SUP' 
                                AND NVL(N.IDSISTEMA, 'DFS') <> 'TMP' 
                                AND NVL(N.IDSISTEMA, 'DFS') <> 'FIS') 
                                AND SE.CDSERIEENTR(+)    = N.CDSERIEENTR 
                                AND N.IDENTRSAIDOP    = 'E' 
                                AND NVL(I.IDIMPOSTONF, '1') <> '3'
                                AND N.CDFILIAL        = I.CDFILIAL 
                                AND N.NRLANCTONF      = I.NRLANCTONF 
                                AND ((N.IDSTATUS = 'A') OR (N.IDSTATUS = 'E')) 
                                AND N.CDMODDOCFISC IN ('06', '29','28') 
                                AND N.CDFORNECED   = F.CDFORNECED 
                                AND N.IDORIGDESTNF = 'F' 
                              GROUP BY DECODE(N.IDENTRSAIDOP, 'E', '0','1'), N.IDORIGDESTNF||N.CDFORNECED, N.CDMODDOCFISC,
                                    NVL(SE.CDSERIEENTRNFE,N.CDSERIEENTR), LTRIM(N.NRNOTAFISC, '0'), TO_CHAR(N.DTEMISSAO,'ddmmyyyy'),
                                    TO_CHAR(N.DTENTRSAID,'ddmmyyyy'), N.IDSTATUS, N.DTEMISSAO, N.CDFILIAL, N.NRLANCTONF,
                                    N.IDENTRSAIDOP, N.IDORIGDESTNF, N.CDTIPOOPER, N.CDFILIRECE
                              UNION ALL
                              SELECT '|C500' AS REG, 
                                    DECODE(N.IDENTRSAIDOP, 'E', '0','1') AS IND_OPER, 
                                    '1' AS IND_EMIT, 
                                    N.IDORIGDESTNF||N.CDCLIENTE AS COD_PAR,
                                    N.CDMODDOCFISC AS COD_MOD, 
                                    NVL(SE.CDSERIEENTRNFE,N.CDSERIEENTR) AS SER, 
                                    '' AS SUB, 
                                    '01' AS COD_CONS, 
                                    LTRIM(N.NRNOTAFISC, '0') AS NUM_DOC, 
                                    TO_CHAR(N.DTEMISSAO,'ddmmyyyy') AS DT_DOC,
                                    TO_CHAR(N.DTENTRSAID,'ddmmyyyy') AS DT_E_S,
                                    SUM(I.VRCONTABILNF) AS VL_DOC, 
                                    '0,00' AS VL_DESC, 
                                    SUM(I.VRCONTABILNF) AS VL_FORN, 
                                    SUM(DECODE(CDFISCALNF, '2', VRCONTABILNF, 0)) AS VL_SERV_NT, 
                                    '0,00' AS VL_TERC, 
                                    '0,00' AS VL_DA, 
                                    SUM(DECODE(CDFISCALNF, '1', VRBASECALCNF, 0)) AS VL_BC_ICMS, 
                                    SUM((SELECT SUM(VRBASECALCNF) 
                                           FROM IMPOSTONF IP 
                                          WHERE IP.CDFILIAL   = I.CDFILIAL 
                                            AND IP.NRLANCTONF = I.NRLANCTONF 
                                            AND IP.CDIMPOSTO  = IM.CDIMPCARGATRIB)) AS VRBASECARGA,
                                    SUM(DECODE(CDFISCALNF, '1', VRIMPOSTONF, 0)) AS VL_ICMS, 
                                    SUM(VRIMPCARGATRIBI) AS VRIMPCARGA, 
                                    '0,00' AS VL_BC_ICMS_ST, 
                                    '0,00' AS VL_ICMS_ST,
                                    '' AS COD_INF, 
                                    '0,00' AS VL_PIS, 
                                    '0,00' AS VL_COFINS, 
                                    '1' AS TP_LIGACAO, 
                                    '01' AS COD_GRUPO_TENSAO, 
                                    N.IDSTATUS, N.DTEMISSAO, N.CDFILIAL, N.NRLANCTONF, N.IDENTRSAIDOP,
                                    N.IDORIGDESTNF, N.CDTIPOOPER, N.CDFILIRECE AS FILIAL
                               FROM NOTAFISCAL N, IMPOSTONF I, CLIENTE C, IMPOSTO IM, SERIEENTR SE 
                              WHERE N.NRSEQUMAPAPUSN  = V_NRSEQUMAPAPU 
                                AND N.CDINSCESTA      = P_CDINSCESTA 
                                AND IM.CDIMPOSTONFE   = P_CDIMPOSTO 
                                AND I.CDIMPOSTO       = IM.CDIMPOSTO 
                                AND (NVL(N.IDSISTEMA,'DFS') <> 'REC' 
                                AND NVL(N.IDSISTEMA, 'DFS') <> 'PAG' 
                                AND NVL(N.IDSISTEMA, 'DFS') <> 'CMP' 
                                AND NVL(N.IDSISTEMA, 'DFS') <> 'SUP' 
                                AND NVL(N.IDSISTEMA, 'DFS') <> 'TMP' 
                                AND NVL(N.IDSISTEMA, 'DFS') <> 'FIS') 
                                AND SE.CDSERIEENTR(+)    = N.CDSERIEENTR 
                                AND N.IDENTRSAIDOP    = 'E'
                                AND NVL(I.IDIMPOSTONF, '1') <> '3' 
                                AND N.CDFILIAL        = I.CDFILIAL 
                                AND N.NRLANCTONF      = I.NRLANCTONF 
                                AND ((N.IDSTATUS = 'A') OR (N.IDSTATUS = 'E')) 
                                AND N.CDMODDOCFISC IN ('06', '29','28') 
                                AND N.CDCLIENTE = C.CDCLIENTE 
                                AND N.IDORIGDESTNF = 'C' 
                              GROUP BY DECODE(N.IDENTRSAIDOP, 'E', '0','1'), N.IDORIGDESTNF||N.CDCLIENTE, N.CDMODDOCFISC,
                                    NVL(SE.CDSERIEENTRNFE,N.CDSERIEENTR), LTRIM(N.NRNOTAFISC, '0'), TO_CHAR(N.DTEMISSAO,'ddmmyyyy'),
                                    TO_CHAR(N.DTENTRSAID,'ddmmyyyy'), N.IDSTATUS, N.DTEMISSAO, N.CDFILIAL, N.NRLANCTONF,
                                    N.IDENTRSAIDOP, N.IDORIGDESTNF, N.CDTIPOOPER, N.CDFILIRECE
                              UNION ALL 
                             SELECT '|C500' AS REG, 
                                    DECODE(N.IDENTRSAIDOP, 'E', '0','1') AS IND_OPER, 
                                    '1' AS IND_EMIT, 
                                    N.IDORIGDESTNF||N.CDFILIEMIT AS COD_PAR,
                                    N.CDMODDOCFISC AS COD_MOD, 
                                    NVL(SE.CDSERIE,N.CDSERIE) AS SER,
                                    '' AS SUB, 
                                    '01' AS COD_CONS, 
                                    LTRIM(N.NRNOTAFISC, '0') AS NUM_DOC, 
                                    TO_CHAR(N.DTEMISSAO,'ddmmyyyy') AS DT_DOC,
                                    TO_CHAR(N.DTENTRSAID,'ddmmyyyy') AS DT_E_S,
                                    SUM(I.VRCONTABILNF) AS VL_DOC, 
                                    '0,00' AS VL_DESC, 
                                    SUM(I.VRCONTABILNF) AS VL_FORN, 
                                    SUM(DECODE(CDFISCALNF, '2', VRCONTABILNF, 0)) AS VL_SERV_NT, 
                                    '0,00' AS VL_TERC, 
                                    '0,00' AS VL_DA, 
                                    SUM(DECODE(CDFISCALNF, '1', VRBASECALCNF, 0)) AS VL_BC_ICMS, 
                                    SUM((SELECT SUM(VRBASECALCNF) 
                                           FROM IMPOSTONF IP 
                                          WHERE IP.CDFILIAL   = I.CDFILIAL
                                            AND IP.NRLANCTONF = I.NRLANCTONF 
                                            AND IP.CDIMPOSTO  = IM.CDIMPCARGATRIB)) AS VRBASECARGA,
                                    SUM(DECODE(CDFISCALNF, '1', VRIMPOSTONF, 0)) AS VL_ICMS, 
                                    SUM(VRIMPCARGATRIBI) AS VRIMPCARGA, 
                                    '0,00' AS VL_BC_ICMS_ST, 
                                    '0,00' AS VL_ICMS_ST, 
                                    '' AS COD_INF, 
                                    '0,00' AS VL_PIS, 
                                    '0,00' AS VL_COFINS, 
                                    '1' AS TP_LIGACAO, 
                                    '01' AS COD_GRUPO_TENSAO, 
                                    N.IDSTATUS, N.DTEMISSAO, N.CDFILIAL, N.NRLANCTONF, N.IDENTRSAIDOP,
                                    N.IDORIGDESTNF, N.CDTIPOOPER, N.CDFILIEMIT AS FILIAL
                               FROM NOTAFISCAL N, IMPOSTONF I, FILIAL F, IMPOSTO IM, SERIENF SE
                              WHERE N.NRSEQUMAPAPUSN  = V_NRSEQUMAPAPU 
                                AND N.CDINSCESTA      = P_CDINSCESTA 
                                AND IM.CDIMPOSTO      = P_CDIMPOSTO 
                                AND IM.CDIMPOSTO      = IM.CDIMPOSTO 
                                AND (NVL(N.IDSISTEMA,'DFS') <> 'REC' 
                                AND NVL(N.IDSISTEMA, 'DFS') <> 'PAG' 
                                AND NVL(N.IDSISTEMA, 'DFS') <> 'CMP' 
                                AND NVL(N.IDSISTEMA, 'DFS') <> 'SUP' 
                                AND NVL(N.IDSISTEMA, 'DFS') <> 'TMP' 
                                AND NVL(N.IDSISTEMA, 'DFS') <> 'FIS')
                                AND SE.CDEMPRESA(+)   = N.CDEMPRESA
                                AND SE.CDINSCESTA(+)  = N.CDINSCESTA
                                AND SE.CDINSCMUNI(+)  = N.CDINSCMUNI
                                AND SE.CDSERIE(+)     = N.CDSERIE
                                AND N.IDENTRSAIDOP    = 'S'
                                AND NVL(I.IDIMPOSTONF, '1') <> '3'
                                AND N.CDFILIAL        = I.CDFILIAL 
                                AND N.NRLANCTONF      = I.NRLANCTONF 
                                AND ((N.IDSTATUS = 'A') OR (N.IDSTATUS = 'E')) 
                                AND N.CDMODDOCFISC IN ('06', '29','28') 
                                AND N.CDFILIEMIT = F.CDFILIAL
                                AND IDORIGDESTNF = 'L' 
                              GROUP BY DECODE(N.IDENTRSAIDOP, 'E', '0','1'), N.IDORIGDESTNF||N.CDFILIEMIT, N.CDMODDOCFISC, NVL(SE.CDSERIE,N.CDSERIE),
                                    LTRIM(N.NRNOTAFISC, '0'), TO_CHAR(N.DTEMISSAO,'ddmmyyyy'), TO_CHAR(N.DTENTRSAID,'ddmmyyyy'),
                                    N.IDSTATUS, N.DTEMISSAO, N.CDFILIAL, N.NRLANCTONF, N.IDENTRSAIDOP,
                                    N.IDORIGDESTNF, N.CDTIPOOPER, N.CDFILIEMIT)) LOOP

         /* CODIGO DO PARTICIPANTE */
         SELECT MAX(CDCHAVEREG)
           INTO V_COD_PAR
           FROM TMP_REGDADOSSPED
          WHERE CDCHAVEREG = C_500.COD_PAR
            AND CDREGISTRO = '0150';

         IF (V_COD_PAR IS NULL) AND (C_500.COD_PAR IS NOT NULL) THEN
            V_SEQUPROD := NVL(V_SEQUPROD,0) + 1;
            INSERT INTO TMP_REGDADOSSPED
              (CDREGISTRO, CDCONTREGI, CDCHAVEREG)
            VALUES
              ('0150', V_SEQUPROD, C_500.COD_PAR);
         END IF;

         V_COD_PAR := '';
         IF C_500.IDSTATUS = 'C' THEN
            /* documentos cancelados */
            V_DADOS_2 := '02|';
         ELSE
            IF NOT C_500.DTEMISSAO BETWEEN P_DTINICIAL AND P_DTFINAL THEN
               /* documentos fora do periodo */
               V_DADOS_2 := '01|';
            ELSE
               V_DADOS_2 := '00|';
            END IF;
         END IF;

         INSERT INTO ARQMAGNETICO
            (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
         VALUES
            ('25'||LPAD(RTRIM(V_CONTREGC), 8, '0'), C_500.PART_1||V_DADOS_2||C_500.PART_2, P_NRSEQARQMAG);
         V_CONTREGC := NVL(V_CONTREGC,0) + 1;
         V_SEQUENCIAL := LPAD(RTRIM(TO_CHAR(TO_NUMBER('1'))),3,'0');
 
         FOR C_510 IN (SELECT COD_ITEM         || '|' ||
                              COD_CLASS        || '|' ||
                              QTD              || '|' ||
                              UNID             || '|' ||
                              REPLACE(LTRIM(TO_CHAR(ROUND(VL_ITEM,2), '999999999990.00')), '.', ',')    || '|' ||
                              VL_DESC          || '|' ||
                              CST_ICMS         || '|' ||
                              CFOP             || '|' ||
                              REPLACE(LTRIM(TO_CHAR(ROUND(VL_BC_ICMS + DECODE(V_IDTPCARGATRIB,'O',0,DECODE(V_SGESTADO,'SP',0,NVL(VRBASECARGA,0))),2), '999999999990.00')), '.', ',') || '|' ||
                              REPLACE(LTRIM(TO_CHAR(ROUND(ALIQ_ICMS,2), '999999999990.00')), '.', ',')  || '|' ||
                              REPLACE(LTRIM(TO_CHAR(ROUND(VL_ICMS    + DECODE(V_IDTPCARGATRIB,'O',0,DECODE(C_500.IDENTRSAIDOP,'S',NVL(VRIMPCARGA,0),DECODE(V_SGESTADO,'SP',0,NVL(VRIMPCARGA,0)))),2), '999999999990.00')), '.', ',')    || '|' ||
                              VL_BC_ICMS_ST    || '|' ||
                              ALIQ_ST          || '|' ||
                              VL_ICMS_ST       || '|' ||
                              IND_REC          || '|' ||
                              COD_PART         || '|' ||
                              VL_PIS           || '|' ||
                              VL_COFINS        || '|' ||
                              COD_CTA          || '|' AS REGC510,
                              CDPRODUTO, UNID, CDCLASFISC, COD_CTA
                         FROM (SELECT CDARVPROD AS COD_ITEM,
                                      '0601' AS COD_CLASS,
                                      QTITEMPROD AS QTD,
                                      SGUNIDADE AS UNID,
                                      VRUNITITEM AS VL_ITEM,
                                      '0,00' AS VL_DESC,
                                      CDSITUTRIBIT AS CST_ICMS,
                                      CDFISCOPERIT AS CFOP,
                                      DECODE(CDFISCALIT, '1', VRBASECALCIT, 0) AS VL_BC_ICMS,
                                      (SELECT SUM(IT.VRBASECALCIT)
                                         FROM ITEMPROIMPOS IP
                                        WHERE IP.CDFILIAL   = IT.CDFILIAL
                                          AND IP.NRLANCTONF = IT.NRLANCTONF
                                          AND IP.CDIMPOSTO  = IM.CDIMPCARGATRIB) AS VRBASECARGA,
                                      DECODE(CDFISCALIT, '1', VRALIQITEM, 0) AS ALIQ_ICMS,
                                      DECODE(CDFISCALIT, '1', VRIMPOSTOIT, 0) AS VL_ICMS,
                                      (SELECT SUM(IT.VRIMPOSTOIT)
                                         FROM ITEMPROIMPOS IP
                                        WHERE IP.CDFILIAL   = IT.CDFILIAL
                                          AND IP.NRLANCTONF = IT.NRLANCTONF
                                          AND IP.CDIMPOSTO  = IM.CDIMPCARGATRIB) AS VRIMPCARGA,
                                      '0,00' AS VL_BC_ICMS_ST,
                                      '0,00' AS ALIQ_ST,
                                      '0,00' AS VL_ICMS_ST,
                                      '1' AS IND_REC,
                                      '' AS COD_PART,
                                      '0,00' AS VL_PIS,
                                      '0,00' AS VL_COFINS,
                                      CONTCTBL_SPED(C_500.IDENTRSAIDOP, I.CDPRODUTO, C_500.CDTIPOOPER, C_500.FILIAL) AS COD_CTA,
                                      P.CDPRODUTO,
                                      I.CDPRODNCMTRANS AS CDCLASFISC
                                 FROM ITEMPRODUTO I, ITEMPROIMPOS IT, PRODUTO P, IMPOSTO IM
                                WHERE I.CDFILIAL = C_500.CDFILIAL
                                  AND I.NRLANCTONF = C_500.NRLANCTONF
                                  AND I.CDFILIAL = IT.CDFILIAL
                                  AND I.NRLANCTONF = IT.NRLANCTONF
                                  AND I.NRSEQITPROD = IT.NRSEQITPROD
                                  AND SUBSTR(IT.CDFISCOPERIT,1,1) IN ('5','6','7')
                                  AND P.CDPRODUTO = I.CDPRODUTO
                                  AND IM.CDIMPOSTO = IT.CDIMPOSTO)) LOOP

            INSERT INTO ARQMAGNETICO
               (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
            VALUES
               ('25'||LPAD(RTRIM(V_CONTREGC), 8, '0'), '|C510|'||V_SEQUENCIAL||'|'||C_510.REGC510, P_NRSEQARQMAG);
            V_CONTREGC := NVL(V_CONTREGC,0) + 1;
            V_SEQUENCIAL := LPAD(RTRIM(TO_CHAR(TO_NUMBER(RTRIM(V_SEQUENCIAL))+1)), 3,'0');

            /* CODIGO DO PRODUTO */
            SELECT MAX(CDCHAVEREG)
              INTO V_PRODUTO
              FROM TMP_REGDADOSSPED
             WHERE CDCHAVEREG = C_510.CDPRODUTO
               AND CDREGISTRO = '0200';

            IF V_PRODUTO IS NULL AND (C_510.CDPRODUTO IS NOT NULL) THEN
               V_SEQUPROD := NVL(V_SEQUPROD,0) + 1;
               INSERT INTO TMP_REGDADOSSPED
                 (CDREGISTRO, CDCONTREGI, CDCHAVEREG, CDCAMPO3)
               VALUES
                 ('0200', V_SEQUPROD, C_510.CDPRODUTO, C_510.CDCLASFISC);
            END IF;
            V_PRODUTO := '';

            /* UNIDADE DE MEDIDA */
            SELECT MAX(CDCHAVEREG)
              INTO V_UNID
              FROM TMP_REGDADOSSPED
             WHERE CDCHAVEREG = C_510.UNID
               AND CDREGISTRO = '0190';
            IF (V_UNID IS NULL) AND (C_510.UNID IS NOT NULL) THEN
               V_SEQUPROD := NVL(V_SEQUPROD,0) + 1;
               INSERT INTO TMP_REGDADOSSPED
                 (CDREGISTRO, CDCONTREGI, CDCHAVEREG)
               VALUES
                 ('0190', V_SEQUPROD, C_510.UNID);
            END IF;
            V_UNID := '';

            SELECT MAX(CDCHAVEREG)
              INTO V_CONTCTBL
              FROM TMP_REGDADOSSPED
             WHERE CDCHAVEREG = C_510.COD_CTA
               AND CDREGISTRO = '0500';

            IF (V_CONTCTBL IS NULL) AND (C_510.COD_CTA IS NOT NULL) THEN
               V_SEQUPROD := NVL(V_SEQUPROD,0) + 1;
               INSERT INTO TMP_REGDADOSSPED
                  (CDREGISTRO, CDCONTREGI, CDCHAVEREG)
               VALUES
                  ('0500', V_SEQUPROD, C_510.COD_CTA);
            END IF;
            V_CONTCTBL := '';
         END LOOP;
         FOR C_590 IN (SELECT ('|C590'     || '|' ||
                              T.CST_ICMS   || '|' ||
                              T.CFOP       || '|' ||
                              REPLACE(LTRIM(TO_CHAR(ROUND(T.ALIQ_ICMS,2), '999999999990.00')), '.', ',')      || '|' ||
                              REPLACE(LTRIM(TO_CHAR(ROUND(T.VL_OPR,2), '999999999990.00')), '.', ',')      || '|' ||
                              REPLACE(LTRIM(TO_CHAR(ROUND(T.VL_BC_ICMS + DECODE(V_IDTPCARGATRIB,'O',0,DECODE(V_SGESTADO,'SP',0,NVL(VRBASECARGA,0))),2), '999999999990.00')), '.', ',')      || '|' ||
                              REPLACE(LTRIM(TO_CHAR(ROUND(T.VL_ICMS    + DECODE(V_IDTPCARGATRIB,'O',0,DECODE(C_500.IDENTRSAIDOP,'E',DECODE(V_SGESTADO,'SP',0,NVL(VRIMPCARGA,0)),NVL(VRIMPCARGA,0))),2), '999999999990.00')), '.', ',')      || '|' ||
                              REPLACE(LTRIM(TO_CHAR(ROUND(0,2), '999999999990.00')), '.', ',')      || '|' ||
                              REPLACE(LTRIM(TO_CHAR(ROUND(0,2), '999999999990.00')), '.', ',')      || '|' ||
                              REPLACE(LTRIM(TO_CHAR(ROUND(T.VL_RED_BC,2), '999999999990.00')), '.', ',')      || '|' ||
                              '' || '|') ARQ_C590
                         FROM (SELECT CDSITUTRIBIT AS CST_ICMS,
                                      CDFISCOPERIT AS CFOP,
                                      DECODE(CDFISCALIT, '1', VRALIQITEM, 0) AS ALIQ_ICMS,
                                      SUM(VRCONTITIMP)+NVL(SUM(VALOR_REDUCAO(I.CDFILIAL, I.NRLANCTONF, I.CDSITUTRIBIT, I.NRSEQITPROD, I.CDFISCOPERIT, NULL, NULL, NULL)),0) VL_OPR,
                                      SUM(DECODE(CDFISCALIT, '1', VRBASECALCIT, 0)) AS VL_BC_ICMS,
                                      SUM((SELECT SUM(IP.VRBASECALCIT)
                                             FROM ITEMPROIMPOS IP
                                            WHERE IP.CDFILIAL     = I.CDFILIAL
                                              AND IP.NRLANCTONF   = I.NRLANCTONF
                                              AND IP.CDSITUTRIBIT = I.CDSITUTRIBIT
                                              AND IP.CDFISCOPERIT = I.CDFISCOPERIT
                                              AND IP.CDIMPOSTO    = IM.CDIMPCARGATRIB)) AS VRBASECARGA,
                                      SUM(DECODE(CDFISCALIT, '1', VRIMPOSTOIT, 0)) AS VL_ICMS,
                                      SUM((SELECT SUM(IP.VRIMPOSTOIT)
                                             FROM ITEMPROIMPOS IP
                                            WHERE IP.CDFILIAL     = I.CDFILIAL
                                              AND IP.NRLANCTONF   = I.NRLANCTONF
                                              AND IP.CDSITUTRIBIT = I.CDSITUTRIBIT
                                              AND IP.CDFISCOPERIT = I.CDFISCOPERIT
                                              AND IP.CDIMPOSTO    = IM.CDIMPCARGATRIB)) AS VRIMPCARGA,
                                      0 AS VL_BC_ICMS_ST,
                                      0 AS VL_ICMS_ST,
                                      NVL(SUM(VALOR_REDUCAO(I.CDFILIAL, I.NRLANCTONF, I.CDSITUTRIBIT, I.NRSEQITPROD, I.CDFISCOPERIT, NULL, NULL, NULL) ),0) AS VL_RED_BC,
                                      0 AS VL_IPI,
                                      '' AS COD_OBS
                                 FROM ITEMPROIMPOS I, IMPOSTO IM
                                WHERE I.CDFILIAL      = C_500.CDFILIAL
                                  AND I.NRLANCTONF    = C_500.NRLANCTONF
                                  AND I.NRITPROIMPOS    = '1'
                                  AND IM.CDIMPOSTO    = I.CDIMPOSTO
                                  AND IM.CDIMPOSTONFE = P_CDIMPOSTO
                                GROUP BY CDSITUTRIBIT, I.CDFISCOPERIT, DECODE(I.CDFISCALIT, '1', I.VRALIQITEM, 0) ) T ) LOOP

            INSERT INTO ARQMAGNETICO
              (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
            VALUES
              ('25'||LPAD(RTRIM(V_CONTREGC), 8, '0'), C_590.ARQ_C590, P_NRSEQARQMAG);
            V_CONTREGC := NVL(V_CONTREGC,0) + 1;
            
         END LOOP;
      END LOOP;
   END IF;
 
   /* REGISTRO REFERENTE AO CF-E SAT */
   FOR C_800 IN (SELECT (REG         || '|' ||
                         COD_MOD     || '|' ||
                         COD_SIT     || '|' || 
                         NUM_CFE     || '|' ||
                         DT_DOC      || '|' || 
                         VL_CFE      || '|' ||
                         VL_PIS      || '|' || 
                         VL_COFINS   || '|' ||
                         CNPJ_CPF    || '|' ||
                         NR_SAT      || '|' || 
                         CHV_CFE     || '|' ||
                         VL_DESC     || '|' ||
                         VL_MERC     || '|' ||
                         VL_OUT_DA   || '|' ||
                         VL_ICMS     || '|' || 
                         VL_PIS_ST   || '|' ||
                         VL_COFINS_ST|| '|') AS ARQ_C800, DTEMISSAO, CDFILIAL, CDCAIXA, NRSEQVENDA
                   FROM (SELECT '|C800' AS REG, '59' AS COD_MOD, DECODE(VE.IDSTATUSNFCE,'C','02','A','00') AS COD_SIT,
                                LPAD(NVL(VE.NRNOTAFISCALCE,0),6,'0') AS NUM_CFE, 
                                DECODE(VE.IDSTATUSNFCE,'C','',TO_CHAR(VE.DTEMISSAONFCE,'DDMMYYYY')) AS DT_DOC, 
                                DECODE(VE.IDSTATUSNFCE,'C','',REPLACE(LTRIM(TO_CHAR(SUM(TRUNC(IT.QTPRODVEND*(IT.VRUNITVEND+NVL(IT.VRUNITVENDCL,0))-NVL(IT.VRDESITVEND,0)+NVL(IT.VRACRITVEND,0),2)),'999999999990.00')),'.',',')) AS VL_CFE, 
                                '' AS VL_PIS, '' AS VL_COFINS,/*Contribuinte que apresenta EFD Contribuições não precisa informar valores de PIS e COFINS*/
                                DECODE(VE.IDSTATUSNFCE,'C','',REPLACE(REPLACE(REPLACE(REPLACE(VE.NRINSCRCONS,'.'),'-'),'/'),' ')) AS CNPJ_CPF, 
                                VE.CDSERIESAT AS NR_SAT, SUBSTR(VE.NRACESSONFCE,4,44) AS CHV_CFE, 
                                DECODE(VE.IDSTATUSNFCE,'C','',REPLACE(LTRIM(TO_CHAR(SUM(TRUNC(NVL(IT.VRDESITVEND,0),2)),'999999999990.00')),'.',',')) AS VL_DESC, 
                                DECODE(VE.IDSTATUSNFCE,'C','',REPLACE(LTRIM(TO_CHAR(SUM(TRUNC(IT.QTPRODVEND*(IT.VRUNITVEND+NVL(IT.VRUNITVENDCL,0)),2)),'999999999990.00')),'.',',')) AS VL_MERC,
                                DECODE(VE.IDSTATUSNFCE,'C','',REPLACE(LTRIM(TO_CHAR(SUM(TRUNC(NVL(IT.VRACRITVEND,0),2)),'999999999990.00')),'.',',')) AS VL_OUT_DA, 
                                DECODE(VE.IDSTATUSNFCE,'C','',REPLACE(LTRIM(TO_CHAR(SUM(ROUND(II.VRIMPOPRODIT, 2)),'999999999990.00')),'.',',')) AS VL_ICMS, 
                                DECODE(VE.IDSTATUSNFCE,'C','',0) AS VL_PIS_ST, DECODE(VE.IDSTATUSNFCE,'C','',0) AS VL_COFINS_ST, TRUNC(VE.DTEMISSAONFCE) AS DTEMISSAO, VE.CDFILIAL, VE.CDCAIXA, VE.NRSEQVENDA 
                           FROM VENDA VE, FILIAL FI, ITEMVENDA IT, ITVENDAIMPOS II 
                          WHERE TRUNC(VE.DTEMISSAONFCE) BETWEEN P_DTINICIAL AND P_DTFINAL 
                            AND VE.IDTPEMISVEND    = 'S' 
                            AND VE.CDFILIAL        = FI.CDFILIAL 
                            AND FI.CDEMPRESA       = P_CDEMPRESA 
                            AND FI.CDINSCESTA      = P_CDINSCESTA 
                            AND VE.IDSITUVENDA     IN ('O','C') 
                            AND ((VE.IDAPROVACAONFCE = 'A' AND VE.IDSTATUSNFCE = 'A') OR (VE.IDSTATUSNFCE = 'C')) 
                            AND VE.IDTPAMBNFCE     = '1' 
                            AND P_PERFIL           = 'A' 
                            AND VE.CDFILIAL        = IT.CDFILIAL 
                            AND VE.CDCAIXA         = IT.CDCAIXA 
                            AND VE.NRSEQVENDA      = IT.NRSEQVENDA 
                            AND IT.CDFILIAL        = II.CDFILIAL 
                            AND IT.CDCAIXA         = II.CDCAIXA 
                            AND IT.NRSEQVENDA      = II.NRSEQVENDA 
                            AND IT.NRSEQUITVEND    = II.NRSEQUITVEND
                            AND ((V_CDSITUCRT = '3') OR (V_CDSITUCRT <> '3' AND V_SGESTADO <> 'CE'))
                         GROUP BY VE.IDSTATUSNFCE, LPAD(NVL(VE.NRNOTAFISCALCE,0),6,'0'), 
                                  DECODE(VE.IDSTATUSNFCE,'C','',TO_CHAR(VE.DTEMISSAONFCE,'DDMMYYYY')), 
                                  DECODE(VE.IDSTATUSNFCE,'C','',REPLACE(REPLACE(REPLACE(REPLACE(VE.NRINSCRCONS,'.'),'-'),'/'),' ')), 
                                  VE.CDSERIESAT, SUBSTR(VE.NRACESSONFCE,4,44), 
                                  TRUNC(VE.DTEMISSAONFCE), VE.CDFILIAL, VE.CDCAIXA, VE.NRSEQVENDA 
                         ORDER BY NUM_CFE)) LOOP 
 
      INSERT INTO ARQMAGNETICO 
         (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG) 
      VALUES 
         ('28'||LPAD(RTRIM(V_CONTREGC), 8, '0'), C_800.ARQ_C800, P_NRSEQARQMAG); 
      V_CONTREGC := NVL(V_CONTREGC,0) + 1; 
 
      FOR C_850 IN (SELECT (REG          || '|' || 
                            CST_ICMS     || '|' || 
                            CFOP         || '|' || 
                            ALIQ_ICMS    || '|' || 
                            VL_OPR       || '|' || 
                            VL_BC_ICMS   || '|' ||
                            VL_ICMS      || '|' || 
                            COD_OBS      || '|' ) ARQ_C850 
                      FROM (SELECT '|C850' AS REG, LPAD(II.CDCSTPRODI,3,'0') AS CST_ICMS, II.CDCFOPPROD AS CFOP, 
                                   REPLACE(LTRIM(TO_CHAR(II.VRPEALPRODIT,'999990.00')),'.',',') AS ALIQ_ICMS,
                                   REPLACE(LTRIM(TO_CHAR(SUM(TRUNC(IT.QTPRODVEND*(IT.VRUNITVEND+NVL(IT.VRUNITVENDCL,0))-NVL(IT.VRDESITVEND,0)+NVL(IT.VRACRITVEND,0),2)),'999999999990.00')),'.',',') AS VL_OPR, 
                                   REPLACE(LTRIM(TO_CHAR(SUM(DECODE(II.VRPEALPRODIT,0,0,TRUNC(IT.QTPRODVEND*(IT.VRUNITVEND+NVL(IT.VRUNITVENDCL,0))-NVL(IT.VRDESITVEND,0)+NVL(IT.VRACRITVEND,0),2))),   '999999999990.00')),'.',',') AS VL_BC_ICMS, 
                                   REPLACE(LTRIM(TO_CHAR(SUM(ROUND(II.VRIMPOPRODIT, 2)),'999999999990.00')),'.',',') AS VL_ICMS, 
                                   '' AS COD_OBS 
                              FROM VENDA VE, ITEMVENDA IT, ITVENDAIMPOS II 
                             WHERE VE.IDAPROVACAONFCE      = 'A' 
                               AND TRUNC(VE.DTEMISSAONFCE) = C_800.DTEMISSAO 
                               AND VE.CDCAIXA              = C_800.CDCAIXA 
                               AND VE.CDFILIAL             = C_800.CDFILIAL 
                               AND VE.NRSEQVENDA           = C_800.NRSEQVENDA 
                               AND VE.IDTPEMISVEND         = 'S' 
                               AND VE.IDSITUVENDA          = 'O' 
                               AND VE.IDSTATUSNFCE         = 'A' 
                               AND VE.IDTPAMBNFCE          = '1' 
                               AND VE.CDFILIAL             = IT.CDFILIAL 
                               AND VE.CDCAIXA              = IT.CDCAIXA 
                               AND VE.NRSEQVENDA           = IT.NRSEQVENDA 
                               AND IT.CDFILIAL             = II.CDFILIAL 
                               AND IT.CDCAIXA              = II.CDCAIXA 
                               AND IT.NRSEQVENDA           = II.NRSEQVENDA 
                               AND IT.NRSEQUITVEND         = II.NRSEQUITVEND 
                            GROUP BY LPAD(II.CDCSTPRODI,3,'0'), II.CDCFOPPROD, II.VRPEALPRODIT)) LOOP 
 
         INSERT INTO ARQMAGNETICO 
            (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG) 
         VALUES 
            ('28'||LPAD(RTRIM(V_CONTREGC), 8, '0'), C_850.ARQ_C850, P_NRSEQARQMAG); 
         V_CONTREGC := NVL(V_CONTREGC,0) + 1; 
      END LOOP; 
   END LOOP; 
 
   FOR C_860 IN (SELECT (REG     || '|' || 
                         COD_MOD || '|' || 
                         NR_SAT  || '|' || 
                         DT_DOC  || '|' || 
                         DOC_INI || '|' || 
                         DOC_FIM || '|' ) ARQ_C860, NR_SAT, DTEMISSAO 
                   FROM (SELECT '|C860' AS REG, '59' AS COD_MOD, VE.CDSERIESAT AS NR_SAT, TO_CHAR(TRUNC(VE.DTEMISSAONFCE),'DDMMYYYY') AS DT_DOC, 
                                MIN(LPAD(NVL(VE.NRNOTAFISCALCE,0),6,'0')) DOC_INI, MAX(LPAD(NVL(VE.NRNOTAFISCALCE,0),6,'0')) DOC_FIM, 
                                TRUNC(VE.DTEMISSAONFCE) AS DTEMISSAO 
                           FROM VENDA VE, FILIAL FI 
                          WHERE TRUNC(VE.DTEMISSAONFCE) BETWEEN P_DTINICIAL AND P_DTFINAL 
                            AND VE.IDTPEMISVEND    = 'S' 
                            AND VE.CDFILIAL        = FI.CDFILIAL 
                            AND FI.CDEMPRESA       = P_CDEMPRESA 
                            AND FI.CDINSCESTA      = P_CDINSCESTA 
                            AND P_PERFIL           = 'B' 
                            AND VE.IDSITUVENDA     IN ('O','C') 
                            AND ((VE.IDAPROVACAONFCE = 'A' AND VE.IDSTATUSNFCE = 'A') OR (VE.IDSTATUSNFCE = 'C')) 
                            AND VE.IDTPAMBNFCE     = '1'
                            AND ((V_CDSITUCRT = '3') OR (V_CDSITUCRT <> '3' AND V_SGESTADO <> 'CE'))
                          GROUP BY VE.CDSERIESAT, TRUNC(VE.DTEMISSAONFCE))) LOOP 
 
      INSERT INTO ARQMAGNETICO 
         (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG) 
      VALUES 
         ('28'||LPAD(RTRIM(V_CONTREGC), 8, '0'), C_860.ARQ_C860, P_NRSEQARQMAG); 
      V_CONTREGC := NVL(V_CONTREGC,0) + 1; 
 
      FOR C_890 IN (SELECT (REG          || '|' || 
                            CST_ICMS     || '|' || 
                            CFOP         || '|' || 
                            ALIQ_ICMS    || '|' || 
                            VL_OPR       || '|' ||
                            VL_BC_ICMS   || '|' ||
                            VL_ICMS      || '|' || 
                            COD_OBS      || '|' ) ARQ_C890 
                      FROM (SELECT '|C890' AS REG, LPAD(II.CDCSTPRODI,3,'0') AS CST_ICMS, II.CDCFOPPROD AS CFOP, 
                                   REPLACE(LTRIM(TO_CHAR(II.VRPEALPRODIT,'999990.00')),'.',',') AS ALIQ_ICMS,
                                   REPLACE(LTRIM(TO_CHAR(SUM(TRUNC(IT.QTPRODVEND*(IT.VRUNITVEND+NVL(IT.VRUNITVENDCL,0))-NVL(IT.VRDESITVEND,0)+NVL(IT.VRACRITVEND,0),2)),'999999999990.00')),'.',',') AS VL_OPR, 
                                   REPLACE(LTRIM(TO_CHAR(SUM(DECODE(II.VRPEALPRODIT,0,0,TRUNC(IT.QTPRODVEND*(IT.VRUNITVEND+NVL(IT.VRUNITVENDCL,0))-NVL(IT.VRDESITVEND,0)+NVL(IT.VRACRITVEND,0),2))),   '999999999990.00')),'.',',') AS VL_BC_ICMS, 
                                   REPLACE(LTRIM(TO_CHAR(SUM(ROUND(II.VRIMPOPRODIT,2)),'999999999990.00')),'.',',') AS VL_ICMS,
                                   '' AS COD_OBS 
                              FROM VENDA VE, FILIAL FI, ITEMVENDA IT, ITVENDAIMPOS II 
                             WHERE VE.IDAPROVACAONFCE      = 'A' 
                               AND VE.CDFILIAL             = FI.CDFILIAL 
                               AND FI.CDEMPRESA            = P_CDEMPRESA 
                               AND FI.CDINSCESTA           = P_CDINSCESTA 
                               AND TRUNC(VE.DTEMISSAONFCE) = C_860.DTEMISSAO 
                               AND VE.CDSERIESAT           = C_860.NR_SAT 
                               AND VE.IDTPEMISVEND         = 'S' 
                               AND VE.IDSITUVENDA          = 'O' 
                               AND VE.IDSTATUSNFCE         = 'A' 
                               AND VE.IDTPAMBNFCE          = '1' 
                               AND VE.CDFILIAL             = IT.CDFILIAL 
                               AND VE.CDCAIXA              = IT.CDCAIXA 
                               AND VE.NRSEQVENDA           = IT.NRSEQVENDA 
                               AND IT.CDFILIAL             = II.CDFILIAL 
                               AND IT.CDCAIXA              = II.CDCAIXA 
                               AND IT.NRSEQVENDA           = II.NRSEQVENDA 
                               AND IT.NRSEQUITVEND         = II.NRSEQUITVEND 
                            GROUP BY II.CDCSTPRODI, II.CDCFOPPROD, II.VRPEALPRODIT)) LOOP 
 
         INSERT INTO ARQMAGNETICO 
            (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG) 
         VALUES 
            ('28'||LPAD(RTRIM(V_CONTREGC), 8, '0'), C_890.ARQ_C890, P_NRSEQARQMAG); 
         V_CONTREGC := NVL(V_CONTREGC,0) + 1; 
 
      END LOOP; 
   END LOOP; 
 
   IF V_CONTREGC <> 0 THEN 
      V_MOVIMENT := 0; 
   ELSE 
      V_MOVIMENT := 1; 
   END IF; 
   /* ABERTURA DO REGISTRO C */
   V_CONTREGC := NVL(V_CONTREGC,0) + 1; 
   INSERT INTO ARQMAGNETICO 
     (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG) 
   VALUES 
     ('18'||LPAD('0', 8, '0'), '|C001'|| '|' ||V_MOVIMENT|| '|', P_NRSEQARQMAG); 
   /* ENCERRAMENTO DO BLOCO C */
   V_CONTREGC := NVL(V_CONTREGC,0) + 1; 
   INSERT INTO ARQMAGNETICO 
     (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG) 
   VALUES 
     ('40'||LPAD(RTRIM(V_CONTREGC), 8, '0'), '|C990'|| '|' ||V_CONTREGC|| '|', P_NRSEQARQMAG); 
   RETURN(LPAD(TO_CHAR(NVL(V_CONTREGC,0)),10, '0')||LPAD(TO_CHAR(NVL(V_TOTFORPER_S,0)),10,'0')||LPAD(TO_CHAR(NVL(V_VRFORAPER_E,0)),10,'0')||LPAD(TO_CHAR(NVL(V_SEQUPROD,0)), 10, '0')||LPAD(TO_CHAR(NVL(V_VRDEBESP,0)), 10, '0'));
END;
/

CREATE OR REPLACE FUNCTION SPED_BLOCOE (
   P_CDIMPOSTO    IN IMPOSTO.CDIMPOSTO%TYPE,
   P_CDEMPRESA    IN EMPRESA.CDEMPRESA%TYPE,
   P_CDINSCESTA   IN EMPRESA.CDINSCESTA%TYPE,
   P_DTINICIAL    IN NOTAFISCAL.DTENTRSAID%TYPE,
   P_DTFINAL      IN NOTAFISCAL.DTENTRSAID%TYPE,
   P_LIVROMAG     IN NOTAFISCAL.IDSTATUS%TYPE,
   P_NRSEQARQMAG  IN ARQMAGNETICO.NRSEQARQMAG%TYPE,
   P_TOTFORPER_S  IN IMPOSTONF.VRIMPOSTONF%TYPE,
   P_TOTFORPER_E  IN IMPOSTONF.VRIMPOSTONF%TYPE,
   P_VL_DEB_EXTE  IN IMPOSTONF.VRIMPOSTONF%TYPE,
   P_GERAFORSALE  IN VARCHAR2 DEFAULT 'N',
   P_IDDIFALIQ    IN VARCHAR2) RETURN NUMBER
AS
   V_CONTREGE              NUMBER;
   V_MOVIMENT              NUMBER;
   V_IMP_1605              NUMBER;
   V_IMP_5605              NUMBER;
   V_AJ_DEBITOS            NUMBER;
   V_VRTOT_AJ_DEB          NUMBER;
   V_VR_ESTORNO_CRED       NUMBER;
   V_AJ_CREDITOS           NUMBER;
   V_VL_TOT_AJ_CREDITOS    NUMBER;
   V_VL_ESTORNOS_DEB       NUMBER;
   V_VL_TOT_DED            NUMBER;
   V_VR_DEB_ESP            NUMBER;
   V_C197ENTRADA           NUMBER;
   V_C197SAIDA             NUMBER;
   V_CDIMPOSTRIB           VARCHAR2(02);
   V_SGESTADO              VARCHAR2(02);
   V_VREXTRAPUR            NUMBER;
   V_VROUTRDEB             NUMBER;
   V_REG_E210              VARCHAR2(300);
   V_CDSITUCRT             VARCHAR2(01);
   V_AJ_DEBITOS_DIFAL      NUMBER;
   V_AJ_DEBITOS_FCP        NUMBER;
   V_AJ_CREDITOS_DIFAL     NUMBER;
   V_AJ_CREDITOS_FCP       NUMBER;
   V_VL_TOT_DED_DIFAL      NUMBER;
   V_VL_TOT_DED_FCP        NUMBER;
   V_VR_DEB_ESP_DIFAL      NUMBER;
   V_VR_DEB_ESP_FCP        NUMBER;
   V_AJ_DEBITO_DOC_ST      NUMBER;
   V_EXISTE_IPI            VARCHAR2(01);
BEGIN
   BEGIN
      SELECT SGESTADO
        INTO V_SGESTADO
        FROM INSCRESTAD
       WHERE CDEMPRESA  = P_CDEMPRESA
         AND CDINSCESTA = P_CDINSCESTA;
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_SGESTADO := NULL;
   END;

   /*VERIFICA SE A EMPRESA É DO SIMPLES NACIONAL, '3' NAO É DO SIMPLES, APENAS 1 E 2*/
   SELECT NVL(MAX(CDSITUCRT), '3') CDSITUCRT
     INTO V_CDSITUCRT
     FROM PARAMEMPRESA
    WHERE CDEMPRESA = P_CDEMPRESA;

   IF (V_CDSITUCRT = '3') THEN
      FOR C_REGE100 IN (SELECT DISTINCT ('|E100'                    || '|' ||
                                TO_CHAR(DTINIPERIODO,'DDMMYYYY')    || '|' ||
                                TO_CHAR(DTFIMPERIODO,'DDMMYYYY')    || '|'  ) AS ARQ_E100,
                                TO_CHAR(DTINIPERIODO,'DDMMYYYY') as DTINICIAL,
                                TO_CHAR(DTFIMPERIODO,'DDMMYYYY') as DTFINAL,
                                NRSEQUMAPAPU
                        FROM MAPAAPURAC
                        WHERE CDEMPRESA     = P_CDEMPRESA                   AND
                              CDINSCESTA    = P_CDINSCESTA                  AND
                              DTINIPERIODO  = P_DTINICIAL                   AND
                              DTFIMPERIODO  = P_DTFINAL                     AND
                              CDIMPOSTO     = P_CDIMPOSTO  ) LOOP
         V_CONTREGE := NVL(V_CONTREGE,0) + 1;
         INSERT INTO ARQMAGNETICO
           (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
         VALUES
           ('53'||LPAD(RTRIM(V_CONTREGE), 8, '0'), C_REGE100.ARQ_E100, P_NRSEQARQMAG);

         /*BUSCA O VALOR DO C197 GERADO COM BASE NOS ITENS, POIS OS MESMOS
           DEVEM SER ABATIDOS DO DÉBITO E CRÉDITO NORMAL*/
         SELECT NVL(SUM(DECODE(NF.IDENTRSAIDOP,'E',IT.VRIMPOSTOIT,0)),0) AS VRENTRADA,
                NVL(SUM(DECODE(NF.IDENTRSAIDOP,'S',IT.VRIMPOSTOIT,0)),0) AS VRSAIDA
           INTO V_C197ENTRADA, V_C197SAIDA
           FROM NOTAFISCAL NF, ITEMPROIMPOS IT, IMPOSTO IM, DETITMAPARECUP DT
          WHERE DT.NRSEQUMAPAPU = C_REGE100.NRSEQUMAPAPU
            AND NF.CDFILIAL     = IT.CDFILIAL
            AND NF.NRLANCTONF   = IT.NRLANCTONF
            AND IT.CDFILIAL     = DT.CDFILIAL
            AND IT.NRLANCTONF   = DT.NRLANCTONF
            AND IT.NRSEQITPROD  = DT.NRSEQITPROD
            AND IT.CDIMPOSTO    = DT.CDIMPOSTO
            AND IT.NRITPROIMPOS = DT.NRITPROIMPOS
            AND IT.CDIMPOSTO    = IM.CDIMPOSTO
            AND IM.CDIMPOSTONFE = '00'
            AND IT.NRITPROIMPOS = '1';

         /* BUSCA O VALOR DO CFOP "1.605 - RECEBIMENTO, POR TRANSFERÊNCIA,
            DE SALDO DEVEDOR DO ICMS DE OUTRO ESTABELECIMENTO DA MESMA EMPRESA",
            QUE ACRESCE O VALOR DOS DÉBITOS*/
         SELECT NVL(SUM(VRIMPOSTONF),0)
           INTO V_IMP_1605
           FROM IMPOSTONF I, IMPOSTO IP
          WHERE I.NRSEQUMAPAPU  = C_REGE100.NRSEQUMAPAPU
            AND IP.CDIMPOSTONFE = P_CDIMPOSTO
            AND NVL(IDIMPOSTONF,'1') <> '3'
            AND CDFISCOPERNF    = '1605'
            AND IP.CDIMPOSTO    = I.CDIMPOSTO;

         /* BUSCA O VALOR DO CFOP "5.605 - TRANSFERÊNCIA DE SALDO DEVEDOR DE ICMS
            DE OUTRO ESTABELECIMENTO DA MESMA EMPRESA", QUE ACRESCE O VALOR DOS CRÉDITOS*/
         SELECT NVL(SUM(VRIMPOSTONF),0)
           INTO V_IMP_5605
           FROM IMPOSTONF I
          WHERE NRSEQUMAPAPU = C_REGE100.NRSEQUMAPAPU
            AND I.CDIMPOSTO  = P_CDIMPOSTO
            AND NVL(IDIMPOSTONF,'1') <> '3'
            AND CDFISCOPERNF = '5605';

         /* BUSCA OS VALORES DE AJUSTE A DÉBITO - DOC. FISCAL PRESENTES NA APURAÇÃO,
            DE ACORDO COM O CÓDIGO DE AJUSTE - CAMPO 3 E110 */
         SELECT NVL(SUM(VRITEMMAPR),0)
           INTO V_AJ_DEBITOS
           FROM (SELECT NVL(SUM(ROUND(DECODE(SUBSTR(IM.CDAJUSTEITMAPA,3,1),'9',0,IT.VRIMPOSTOIT),2)),0) AS VRITEMMAPR
                   FROM ITMAPARECUP IM, ITEMPROIMPOS IT, IMPOSTO II, DETITMAPARECUP DT
                  WHERE IM.NRSEQUMAPAPU = C_REGE100.NRSEQUMAPAPU
                    AND IM.IDCOMPOEC197 = 'I'
                    AND IM.CDFILIAL     = IT.CDFILIAL
                    AND IM.NRLANCTONF   = IT.NRLANCTONF
                    AND IT.CDIMPOSTO    = II.CDIMPOSTO
                    AND II.CDIMPOSTONFE = P_CDIMPOSTO
                    AND SUBSTR(IM.CDAJUSTEITMAPA,4,1) IN ('0','2','9')
                    AND IM.NRSEQUMAPAPU = DT.NRSEQUMAPAPU
                    AND IM.IDTIPOITMAPR = DT.IDTIPOITMAPR
                    AND IM.NRSEQITMAPR  = DT.NRSEQITMAPR
                    AND IT.CDFILIAL     = DT.CDFILIAL
                    AND IT.NRLANCTONF   = DT.NRLANCTONF
                    AND IT.NRSEQITPROD  = DT.NRSEQITPROD
                    AND IT.NRITPROIMPOS = DT.NRITPROIMPOS
                    AND ((IT.NRITPROIMPOS = '1' AND IT.CDFISCALIT = '1') OR (IT.NRITPROIMPOS = '3'))
                    AND SUBSTR(IM.CDAJUSTEITMAPA,3,1) IN ('3','4','5')
                    AND SUBSTR(IM.CDAJUSTEITMAPA,4,1) IN ('0','3','4','5','6','7','8')
                  UNION ALL
                 SELECT ROUND(DECODE(SUBSTR(IM.CDAJUSTEITMAPA,3,1),'9',0,IM.VRITEMMAPR),2) AS VRITEMMAPR
                   FROM ITMAPARECUP IM
                  WHERE IM.NRSEQUMAPAPU = C_REGE100.NRSEQUMAPAPU
                    AND IM.IDCOMPOEC197 = 'D'
                    AND SUBSTR(IM.CDAJUSTEITMAPA,3,1) IN ('3','4','5')
                    AND SUBSTR(IM.CDAJUSTEITMAPA,4,1) IN ('0','3','4','5','6','7','8'));

         /* VALOR TOTAL DE AJUSTE A DÉBITO - CAMPO 4 E110 */
         SELECT NVL(SUM(VRITEMMAPR),0)
           INTO V_VRTOT_AJ_DEB
           FROM ITMAPARECUP IT
          WHERE IT.NRSEQUMAPAPU = C_REGE100.NRSEQUMAPAPU
            AND IT.IDCOMPOEC197 = 'N'
            AND SUBSTR(IT.CDAJUSTEITMAPA,3,1) = '0'
            AND SUBSTR(IT.CDAJUSTEITMAPA,4,1) = '0'
            AND (((NVL(P_IDDIFALIQ,'N') = 'S') AND (IDTIPOITMAPR = 'DA')) OR (IDTIPOITMAPR <> 'DA'));

         /* VALOR DO ESTORNO DE CRÉDITO - CAMPO 5 E110 */
         SELECT NVL(SUM(VRITEMMAPR),0)
           INTO V_VR_ESTORNO_CRED
           FROM ITMAPARECUP IT
          WHERE IT.NRSEQUMAPAPU = C_REGE100.NRSEQUMAPAPU
            AND IT.IDCOMPOEC197 = 'N'
            AND SUBSTR(IT.CDAJUSTEITMAPA,3,1) = '0'
            AND SUBSTR(IT.CDAJUSTEITMAPA,4,1) = '1'
            AND (((NVL(P_IDDIFALIQ,'N') = 'S') AND (IDTIPOITMAPR = 'DA')) OR (IDTIPOITMAPR <> 'DA'));

         /* BUSCA OS VALORES DE AJUSTE A CRÉDITO - DOC. FISCAL PRESENTES NA APURAÇÃO,
            DE ACORDO COM O CÓDIGO DE AJUSTE - CAMPO 7 E110*/
         SELECT NVL(SUM(VRITEMMAPR),0)
           INTO V_AJ_CREDITOS
           FROM (SELECT NVL(SUM(ROUND(DECODE(SUBSTR(IM.CDAJUSTEITMAPA,3,1),'9',0,DECODE(IT.CDFISCALIT,'1',IT.VRIMPOSTOIT,0)),2)),0) AS VRITEMMAPR
                   FROM ITMAPARECUP IM, ITEMPROIMPOS IT, IMPOSTO II, DETITMAPARECUP DT
                  WHERE IM.NRSEQUMAPAPU = C_REGE100.NRSEQUMAPAPU
                    AND IM.IDCOMPOEC197 = 'I'
                    AND IM.CDFILIAL     = IT.CDFILIAL
                    AND IM.NRLANCTONF   = IT.NRLANCTONF
                    AND IT.CDIMPOSTO    = II.CDIMPOSTO
                    AND II.CDIMPOSTONFE = P_CDIMPOSTO
                    AND SUBSTR(IM.CDAJUSTEITMAPA,4,1) IN ('0','2','9')
                    AND IM.NRSEQUMAPAPU = DT.NRSEQUMAPAPU
                    AND IM.IDTIPOITMAPR = DT.IDTIPOITMAPR
                    AND IM.NRSEQITMAPR  = DT.NRSEQITMAPR
                    AND IT.CDFILIAL     = DT.CDFILIAL
                    AND IT.NRLANCTONF   = DT.NRLANCTONF
                    AND IT.NRSEQITPROD  = DT.NRSEQITPROD
                    AND IT.NRITPROIMPOS = DT.NRITPROIMPOS
                    AND SUBSTR(IM.CDAJUSTEITMAPA,3,1) IN ('0','1','2')
                    AND SUBSTR(IM.CDAJUSTEITMAPA,4,1) IN ('0','3','4','5','6','7','8')
                  UNION ALL
                 SELECT ROUND(DECODE(SUBSTR(IM.CDAJUSTEITMAPA,3,1),'9',0,IM.VRITEMMAPR),2) AS VRITEMMAPR
                   FROM ITMAPARECUP IM
                  WHERE IM.NRSEQUMAPAPU = C_REGE100.NRSEQUMAPAPU
                    AND IM.IDCOMPOEC197 = 'D'
                    AND SUBSTR(IM.CDAJUSTEITMAPA,3,1) IN ('0','1','2')
                    AND SUBSTR(IM.CDAJUSTEITMAPA,4,1) IN ('0','3','4','5','6','7','8'));

         /* VALOR TOTAL DE AJUSTE A CREDITO - CAMPO 8 E110 */
         SELECT NVL(SUM(VRITEMMAPR),0)
           INTO V_VL_TOT_AJ_CREDITOS
           FROM ITMAPARECUP IT
          WHERE IT.NRSEQUMAPAPU = C_REGE100.NRSEQUMAPAPU
            AND IT.IDCOMPOEC197 = 'N'
            AND SUBSTR(IT.CDAJUSTEITMAPA,3,1) = '0'
            AND SUBSTR(IT.CDAJUSTEITMAPA,4,1) = '2'
            AND (((NVL(P_IDDIFALIQ,'N') = 'S') AND (IDTIPOITMAPR = 'DA')) OR (IDTIPOITMAPR <> 'DA'));

         /* VALOR TOTAL DE AJUSTE A ESTORNO DE DEBITOS- CAMPO 9 E110 */
         SELECT NVL(SUM(VRITEMMAPR),0)
           INTO V_VL_ESTORNOS_DEB
           FROM ITMAPARECUP IT
          WHERE IT.NRSEQUMAPAPU = C_REGE100.NRSEQUMAPAPU
            AND IT.IDCOMPOEC197 = 'N'
            AND SUBSTR(IT.CDAJUSTEITMAPA,3,1) = '0'
            AND SUBSTR(IT.CDAJUSTEITMAPA,4,1) = '3'
            AND (((NVL(P_IDDIFALIQ,'N') = 'S') AND (IDTIPOITMAPR = 'DA')) OR (IDTIPOITMAPR <> 'DA'));

         /*VALOR TOTAL DAS DEDUÇÕES - CAMPO 12 E110 */
         SELECT NVL(SUM(VRITEMMAPR),0)
           INTO V_VL_TOT_DED
           FROM (SELECT ROUND(DECODE(SUBSTR(IM.CDAJUSTEITMAPA,3,1),'9',0,IM.VRITEMMAPR),2) AS VRITEMMAPR
                   FROM ITMAPARECUP IM
                  WHERE IM.NRSEQUMAPAPU = C_REGE100.NRSEQUMAPAPU
                    AND IM.IDCOMPOEC197 = 'D'
                    AND SUBSTR(IM.CDAJUSTEITMAPA,3,1) = '6'
                    AND SUBSTR(IM.CDAJUSTEITMAPA,4,1) = '0'
                  UNION ALL
                 SELECT SUM(ROUND(DECODE(SUBSTR(IM.CDAJUSTEITMAPA,3,1),'9',0,DECODE(IT.CDFISCALIT,'1',IT.VRIMPOSTOIT,0)),2)) AS VRITEMMAPR
                   FROM ITMAPARECUP IM, ITEMPROIMPOS IT, IMPOSTO II, DETITMAPARECUP DT
                  WHERE IM.NRSEQUMAPAPU = C_REGE100.NRSEQUMAPAPU
                    AND IM.IDCOMPOEC197 = 'I'
                    AND IM.CDFILIAL     = IT.CDFILIAL
                    AND IM.NRLANCTONF   = IT.NRLANCTONF
                    AND IT.CDIMPOSTO    = II.CDIMPOSTO
                    AND II.CDIMPOSTONFE = P_CDIMPOSTO
                    AND SUBSTR(IM.CDAJUSTEITMAPA,4,1) IN ('0','2','9')
                    AND IM.NRSEQUMAPAPU = DT.NRSEQUMAPAPU
                    AND IM.IDTIPOITMAPR = DT.IDTIPOITMAPR
                    AND IM.NRSEQITMAPR  = DT.NRSEQITMAPR
                    AND IT.CDFILIAL     = DT.CDFILIAL
                    AND IT.NRLANCTONF   = DT.NRLANCTONF
                    AND IT.NRSEQITPROD  = DT.NRSEQITPROD
                    AND IT.NRITPROIMPOS = DT.NRITPROIMPOS
                    AND SUBSTR(IM.CDAJUSTEITMAPA,3,1) = '6'
                    AND SUBSTR(IM.CDAJUSTEITMAPA,4,1) = '0'
                  UNION ALL
                  SELECT SUM(VRITEMMAPR) AS VRITEMMAPR
                    FROM ITMAPARECUP IT
                   WHERE IT.NRSEQUMAPAPU = C_REGE100.NRSEQUMAPAPU
                     AND IT.IDCOMPOEC197 = 'N'
                     AND SUBSTR(IT.CDAJUSTEITMAPA,3,1) = '0'
                     AND SUBSTR(IT.CDAJUSTEITMAPA,4,1) = '4'
                     AND (((NVL(P_IDDIFALIQ,'N') = 'S') AND (IDTIPOITMAPR = 'DA')) OR (IDTIPOITMAPR <> 'DA')));

         /*BUSCA OS VALOR DOS DÉBITOS ESPECIAIS - CAMPO 15 E110*/
         SELECT NVL(SUM(VRITEMMAPR),0)
           INTO V_VR_DEB_ESP
            FROM (SELECT ROUND(DECODE(SUBSTR(IM.CDAJUSTEITMAPA,3,1),'9',0,IM.VRITEMMAPR),2) AS VRITEMMAPR
                   FROM ITMAPARECUP IM
                  WHERE IM.NRSEQUMAPAPU = C_REGE100.NRSEQUMAPAPU
                    AND IM.IDCOMPOEC197 = 'D'
                    AND SUBSTR(IM.CDAJUSTEITMAPA,3,1) = '7'
                    AND SUBSTR(IM.CDAJUSTEITMAPA,4,1) = '0'
                  UNION ALL
                 SELECT SUM(ROUND(DECODE(SUBSTR(IM.CDAJUSTEITMAPA,3,1),'9',0,IT.VRIMPOSTOIT),2)) AS VRITEMMAPR
                   FROM ITMAPARECUP IM, ITEMPROIMPOS IT, IMPOSTO II, DETITMAPARECUP DT
                  WHERE IM.NRSEQUMAPAPU = C_REGE100.NRSEQUMAPAPU
                    AND IM.IDCOMPOEC197 = 'I'
                    AND IM.CDFILIAL     = IT.CDFILIAL
                    AND IM.NRLANCTONF   = IT.NRLANCTONF
                    AND IT.CDIMPOSTO    = II.CDIMPOSTO
                    AND II.CDIMPOSTONFE = P_CDIMPOSTO
                    AND SUBSTR(IM.CDAJUSTEITMAPA,4,1) IN ('0','2','9')
                    AND IM.NRSEQUMAPAPU = DT.NRSEQUMAPAPU
                    AND IM.IDTIPOITMAPR = DT.IDTIPOITMAPR
                    AND IM.NRSEQITMAPR  = DT.NRSEQITMAPR
                    AND IT.CDFILIAL     = DT.CDFILIAL
                    AND IT.NRLANCTONF   = DT.NRLANCTONF
                    AND IT.NRSEQITPROD  = DT.NRSEQITPROD
                    AND IT.NRITPROIMPOS = DT.NRITPROIMPOS
                    AND ((IT.NRITPROIMPOS = '1' AND IT.CDFISCALIT = '1') OR (IT.NRITPROIMPOS = '3'))
                    AND SUBSTR(IM.CDAJUSTEITMAPA,3,1) = '7'
                    AND SUBSTR(IM.CDAJUSTEITMAPA,4,1) = '0'
                  UNION ALL
                  SELECT SUM(VRITEMMAPR) AS VRITEMMAPR
                    FROM ITMAPARECUP IT
                   WHERE IT.NRSEQUMAPAPU = C_REGE100.NRSEQUMAPAPU
                     AND IT.IDCOMPOEC197 = 'N'
                     AND SUBSTR(IT.CDAJUSTEITMAPA,3,1) = '0'
                     AND SUBSTR(IT.CDAJUSTEITMAPA,4,1) = '5'
                     AND (((NVL(P_IDDIFALIQ,'N') = 'S') AND (IDTIPOITMAPR = 'DA')) OR (IDTIPOITMAPR <> 'DA')));

         FOR C_REGE110 IN (SELECT ('|E110'   || '|' ||
                                   REPLACE(LTRIM(TO_CHAR(NVL(ROUND(VRNORMDEBI,  2),0),'999999999990.00')), '.', ',')   || '|' ||
                                   REPLACE(LTRIM(TO_CHAR(NVL(ROUND(VRAJUSTEDEB, 2),0),'999999999990.00')), '.', ',')   || '|' ||
                                   REPLACE(LTRIM(TO_CHAR(NVL(ROUND(VROUTRDEBI,  2),0),'999999999990.00')), '.', ',')   || '|' ||
                                   REPLACE(LTRIM(TO_CHAR(NVL(ROUND(VRESTOCRED,  2),0),'999999999990.00')), '.', ',')   || '|' ||
                                   REPLACE(LTRIM(TO_CHAR(NVL(ROUND(VRNORMCRED,  2),0),'999999999990.00')), '.', ',')   || '|' ||
                                   REPLACE(LTRIM(TO_CHAR(NVL(ROUND(VRAJUSTECRED,2),0),'999999999990.00')), '.', ',')   || '|' ||
                                   REPLACE(LTRIM(TO_CHAR(NVL(ROUND(VROUTRCRED,  2),0),'999999999990.00')), '.', ',')   || '|' ||
                                   REPLACE(LTRIM(TO_CHAR(NVL(ROUND(VRESTODEBI,  2),0),'999999999990.00')), '.', ',')   || '|' ||
                                   REPLACE(LTRIM(TO_CHAR(NVL(ROUND(VRSLDCRANTE, 2),0),'999999999990.00')), '.', ',')   || '|' ||
                                   REPLACE(LTRIM(TO_CHAR(NVL(ROUND(DECODE(VRSALDOAPUR,ABS(VRSALDOAPUR),VRSALDOAPUR,0),2),0), '999999999990.00')), '.', ',')   || '|' || -- SALDO APURADO
                                   REPLACE(LTRIM(TO_CHAR(NVL(ROUND(VRDEDUCAO,   2),0),'999999999990.00')), '.', ',')   || '|' ||
                                   REPLACE(LTRIM(TO_CHAR(NVL(ROUND(DECODE(VRSALDOAPUR-VRDEDUCAO,ABS(VRSALDOAPUR-VRDEDUCAO),VRSALDOAPUR-VRDEDUCAO,0),     2),0),'999999999990.00')), '.', ',')   || '|' || --ICMS A RECOLHER
                                   REPLACE(LTRIM(TO_CHAR(NVL(ROUND(DECODE(VRSALDOAPUR-VRDEDUCAO,ABS(VRSALDOAPUR-VRDEDUCAO),0,ABS(VRSALDOAPUR-VRDEDUCAO)),2),0),'999999999990.00')), '.', ',')   || '|' || --SALDO CREDOR A TRANSPORTAR
                                   REPLACE(LTRIM(TO_CHAR(NVL(ROUND(VRDEBESP,   2),0),'999999999990.00')), '.', ',')   || '|') AS ARQ_E110
                              FROM (SELECT VRNORMDEBI, VRAJUSTEDEB, VROUTRDEBI, VRESTOCRED, VRNORMCRED, VRAJUSTECRED, VROUTRCRED, VRESTODEBI,
                                           VRSLDCRANTE, VRDEDUCAO, VRDEBESP, (VRNORMDEBI + V_AJ_DEBITOS + V_VRTOT_AJ_DEB + V_VR_ESTORNO_CRED) -
                                           (VRNORMCRED + V_AJ_CREDITOS + V_VL_TOT_AJ_CREDITOS + V_VL_ESTORNOS_DEB + VRSLDCRANTE) AS VRSALDOAPUR
                                      FROM (SELECT DISTINCT CASE WHEN NVL(VRNORMDEBI,0) + V_IMP_1605 - NVL(P_TOTFORPER_S,0) - V_IMP_5605 - V_C197SAIDA > 0
                                                                 THEN NVL(VRNORMDEBI,0) + V_IMP_1605 - NVL(P_TOTFORPER_S,0) - V_IMP_5605 - V_C197SAIDA
                                                                 ELSE 0 END AS VRNORMDEBI,
                                                   V_AJ_DEBITOS         AS VRAJUSTEDEB,
                                                   V_VRTOT_AJ_DEB       AS VROUTRDEBI,
                                                   V_VR_ESTORNO_CRED    AS VRESTOCRED,
                                                   CASE WHEN NVL(VRNORMCRED,0) + V_IMP_5605 - V_IMP_1605 - V_C197ENTRADA > 0
                                                        THEN NVL(VRNORMCRED,0) + V_IMP_5605 - V_IMP_1605 - V_C197ENTRADA
                                                        ELSE 0 END AS VRNORMCRED,
                                                   V_AJ_CREDITOS        AS VRAJUSTECRED,
                                                   V_VL_TOT_AJ_CREDITOS AS VROUTRCRED,
                                                   V_VL_ESTORNOS_DEB    AS VRESTODEBI,
                                                   NVL(VRSLDCRANTE,0)   AS VRSLDCRANTE,
                                                   V_VL_TOT_DED         AS VRDEDUCAO,
                                                   NVL(P_TOTFORPER_S,0) + V_VR_DEB_ESP AS VRDEBESP,
                                                   M.NRSEQUMAPAPU
                                              FROM MAPAAPURAC M, MAPARECUP R
                                             WHERE M.NRSEQUMAPAPU = R.NRSEQUMAPAPU
                                               AND R.NRSEQUMAPAPU = C_REGE100.NRSEQUMAPAPU
                                               AND M.CDIMPOSTO    = P_CDIMPOSTO)))LOOP

            INSERT INTO ARQMAGNETICO
              (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
            VALUES
              ('54'||LPAD(RTRIM(V_CONTREGE), 8, '0'), C_REGE110.ARQ_E110, P_NRSEQARQMAG);
            V_CONTREGE := NVL(V_CONTREGE,0) + 1;

            FOR C_E111 IN (SELECT '|E111'                                                                          || '|' ||
                                  TRIM(REPLACE(REPLACE(CDAJUSTEITMAPA, CHR(10), ' ' ), CHR(9), ' '))               || '|' ||
                                  TRIM(REPLACE(REPLACE(DSITEMMAPR,     CHR(10), ' ' ), CHR(9), ' '))               || '|' ||
                                  REPLACE(LTRIM(TO_CHAR(NVL(ROUND(VRITEMMAPR,2),0), '999999999990.00')), '.', ',') || '|' AS E111,
                                  R.CDFILIAL, R.NRLANCTONF, R.VRITEMMAPR
                             FROM ITMAPARECUP R
                            WHERE R.NRSEQUMAPAPU = C_REGE100.NRSEQUMAPAPU
                              AND R.IDCOMPOEC197 = 'N'
                              AND (((NVL(P_IDDIFALIQ,'N') = 'S') AND (IDTIPOITMAPR = 'DA')) OR (IDTIPOITMAPR <> 'DA'))) LOOP
               INSERT INTO ARQMAGNETICO
                 (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
               VALUES
                 ('54'||LPAD(RTRIM(V_CONTREGE), 8, '0'), C_E111.E111, P_NRSEQARQMAG);
               V_CONTREGE := NVL(V_CONTREGE,0) + 1;

               FOR C_E113 IN (SELECT '|E113'                                                                                 || '|' ||
                                     CNPJ                                                                                    || '|' ||
                                     CDMODDOCFISC                                                                            || '|' ||
                                     SERIE                                                                                   || '|' ||
                                     ''                                                                                      || '|' ||
                                     LTRIM(NRNOTAFISC,0)                                                                     || '|' ||
                                     REPLACE(TO_CHAR(DTEMISSAO,'DDMMYYYY'),'/','')                                           || '|' ||
                                     ''                                                                                      || '|' ||
                                     REPLACE(LTRIM(TO_CHAR(NVL(ROUND(C_E111.VRITEMMAPR,2),0), '999999999990.00')), '.', ',') || '|' ||
                                     CASE WHEN P_DTINICIAL >= TO_DATE('01/01/2017') THEN NRACESSONFE ||'|' ELSE '' END AS E113
                                FROM (SELECT NF.IDORIGDESTNF||FI.CDFILIAL AS CNPJ,
                                             CDMODDOCFISC,
                                             CASE WHEN IDENTRSAIDOP = 'E' THEN NF.CDSERIEENTR ELSE NF.CDSERIE END AS SERIE,
                                             NF.NRNOTAFISC, NF.DTEMISSAO, NF.NRLANCTONF, NF.CDFILIAL, NF.NRACESSONFE
                                        FROM NOTAFISCAL NF, FILIAL FI
                                       WHERE DECODE(IDENTRSAIDOP,'E',NF.CDFILIEMIT,NF.CDFILIRECE) = FI.CDFILIAL
                                         AND NF.CDEMPRESA  = FI.CDEMPRESA
                                         AND NVL(NF.IDORIGDESTNF,'L') = 'L'
                                         AND NF.NRLANCTONF = C_E111.NRLANCTONF
                                         AND NF.CDFILIAL   = C_E111.CDFILIAL
                                       UNION
                                      SELECT NF.IDORIGDESTNF||REPLACE(REPLACE(REPLACE(NF.CDCLIENTE,'.',''),'/',''),'-','') AS CNPJ,
                                             NF.CDMODDOCFISC,
                                             CASE WHEN IDENTRSAIDOP = 'E' THEN NF.CDSERIEENTR ELSE NF.CDSERIE END AS SERIE,
                                             NF.NRNOTAFISC, NF.DTEMISSAO, NF.NRLANCTONF, NF.CDFILIAL, NF.NRACESSONFE
                                        FROM CLIENTE CL, NOTAFISCAL NF
                                       WHERE CL.CDCLIENTE  = NF.CDCLIENTE
                                         AND NVL(NF.IDORIGDESTNF,'C') = 'C'
                                         AND NF.NRLANCTONF = C_E111.NRLANCTONF
                                         AND NF.CDFILIAL   = C_E111.CDFILIAL
                                       UNION
                                      SELECT NF.IDORIGDESTNF||REPLACE(REPLACE(REPLACE(NF.CDFORNECED,'.',''),'/',''),'-','') AS CNPJ,
                                             NF.CDMODDOCFISC,
                                             CASE WHEN IDENTRSAIDOP = 'E' THEN NF.CDSERIEENTR ELSE NF.CDSERIE END AS SERIE,
                                             NF.NRNOTAFISC, NF.DTEMISSAO, NF.NRLANCTONF, NF.CDFILIAL, NF.NRACESSONFE
                                        FROM FORNECEDOR FO, NOTAFISCAL NF
                                       WHERE FO.CDFORNECED = NF.CDFORNECED
                                         AND NVL(NF.IDORIGDESTNF,'F') = 'F'
                                         AND NF.NRLANCTONF = C_E111.NRLANCTONF
                                         AND NF.CDFILIAL   = C_E111.CDFILIAL)) LOOP
                  INSERT INTO ARQMAGNETICO
                    (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
                  VALUES
                    ('54'||LPAD(RTRIM(V_CONTREGE), 8, '0'), C_E113.E113, P_NRSEQARQMAG);
                  V_CONTREGE := NVL(V_CONTREGE,0) + 1;
               END LOOP;
            END LOOP;
         END LOOP;

         FOR C_REGE115 IN (SELECT '|E115'          ||'|'||
                                   CDINFADICMAPA   ||'|'||
                                   REPLACE(LTRIM(TO_CHAR(NVL(ROUND(VRINFADICMAPA,2),0), '999999999990.00')), '.', ',') ||'|'||
                                   DSINFADICMAPA                                                                       ||'|' AS E115
                              FROM INFADICMAPA
                             WHERE NRSEQUMAPAPU = C_REGE100.NRSEQUMAPAPU) LOOP
            V_CONTREGE := NVL(V_CONTREGE,0) + 1;
            INSERT INTO ARQMAGNETICO
              (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
            VALUES
              ('54'||LPAD(RTRIM(V_CONTREGE), 8, '0'), C_REGE115.E115, P_NRSEQARQMAG);
         END LOOP;

         FOR C_REGE116 IN (SELECT '|E116'                         || '|' ||
                                  '000'                           || '|' ||
                                  REPLACE(LTRIM(TO_CHAR(NVL(ROUND(VRRECEGUIA,2),0), '999999999990.00')), '.', ',')   || '|' || --VRTOTAIMPOS+NVL(P_VL_DEB_EXTE,0)
                                  TO_CHAR(DTVENCGUIA, 'DDMMYYYY') || '|' ||
                                  CDRECEGUIA                      || '|' ||
                                  ''                              || '|' ||
                                  ''                              || '|' ||
                                  ''                              || '|' ||
                                  ''                              || '|' ||
                                  TO_CHAR(DTINIPERIODO, 'MMYYYY') || '|'  AS ARQ_E116
                             FROM MAPAAPURAC M
                            WHERE M.NRSEQUMAPAPU = C_REGE100.NRSEQUMAPAPU
                              AND M.VRTOTAIMPOS > 0
                            UNION ALL
                           SELECT '|E116'                         || '|' ||
                                  LPAD(CDOBRIGAGUIA, 3, '0')      || '|' ||
                                  REPLACE(LTRIM(TO_CHAR(NVL(ROUND(VRRECEITAGUIA,2),0), '999999999990.00')), '.', ',') || '|' ||
                                  TO_CHAR(DTVENCGUIACOMPL, 'DDMMYYYY')  || '|' ||
                                  CDRECEITAGUIA     || '|' ||
                                  LPAD(LTRIM(NRPROCESSOGUIA, '0'), 15, '0')          || '|' ||
                                  DECODE(NRPROCESSOGUIA,'','',NVL(IDORIGEMGUIA,'0')) || '|' ||
                                  DSHISTGUIACOMPL   || '|' ||
                                  '' || '|'  ||
                                  TO_CHAR(DTINIPERIODO, 'MMYYYY') || '|' AS ARQ_E116
                             FROM GUIACOMPLMAPA G, MAPAAPURAC M
                            WHERE G.NRSEQUMAPAPU = M.NRSEQUMAPAPU
                              AND M.NRSEQUMAPAPU = C_REGE100.NRSEQUMAPAPU) LOOP
            V_CONTREGE := NVL(V_CONTREGE,0) + 1;
            INSERT INTO ARQMAGNETICO
              (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
            VALUES
              ('55'||LPAD(RTRIM(V_CONTREGE), 8, '0'), C_REGE116.ARQ_E116, P_NRSEQARQMAG);
         END LOOP;
      END LOOP;

      /*REGISTRO E200 - ICMS ST*/
      FOR C_REGE200 IN (SELECT '|E200'                             || '|' ||
                               ME.SGESTADO                         || '|' ||
                               TO_CHAR(MP.DTINIPERIODO,'DDMMYYYY') || '|' ||
                               TO_CHAR(MP.DTFIMPERIODO,'DDMMYYYY') || '|'   AS ARQ_E200,
                               ME.NRSEQUMAPAPU, ME.SGESTADO,
                               SUM(ME.VRDEBITONORMAL + ME.VROUTROSDEBITOS) AS VRTOTDEB,
                               SUM(ME.VRCREDITONORMAL + ME.VRCREDANTERIOR + ME.VROUTROSCREDITOS) AS VRTOTCRE
                          FROM MAPAAPURAC MP, MAPAAPURESTADO ME
                         WHERE MP.CDEMPRESA    = P_CDEMPRESA    AND
                               MP.CDINSCESTA   = P_CDINSCESTA   AND
                               MP.DTINIPERIODO = P_DTINICIAL    AND
                               MP.DTFIMPERIODO = P_DTFINAL      AND
                               MP.CDIMPOSTO    = '80'           AND
                               ME.NRSEQUMAPAPU = MP.NRSEQUMAPAPU
                         GROUP BY ME.NRSEQUMAPAPU, ME.SGESTADO,
                                  TO_CHAR(MP.DTINIPERIODO,'DDMMYYYY'),
                                  TO_CHAR(MP.DTFIMPERIODO,'DDMMYYYY')
                         ORDER BY ME.SGESTADO) LOOP

         V_CONTREGE := NVL(V_CONTREGE,0) + 1;
         INSERT INTO ARQMAGNETICO
           (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
         VALUES
           ('56'||LPAD(RTRIM(V_CONTREGE), 7, '0')||'1', C_REGE200.ARQ_E200, P_NRSEQARQMAG);

         V_VROUTRDEB := 0;
         V_VREXTRAPUR:= 0;
         /*busca o valor de débito extra apuração e outros débitos*/
         FOR C_DEBEXT IN(SELECT CASE WHEN SUBSTR(CDAJUSTEAPURSG,3,1) = '1' AND SUBSTR(CDAJUSTEAPURSG,4,1) = '5'
                                     THEN VRAJUSTEAPURSG ELSE 0 END AS VREXTRAAPUR,
                                CASE WHEN SUBSTR(CDAJUSTEAPURSG,3,1) = '1' AND SUBSTR(CDAJUSTEAPURSG,4,1) = '5'
                                     THEN 0 ELSE VRAJUSTEAPURSG END AS VROUTRDEB
                           FROM AJUSTMAPAAPURSG A
                          WHERE A.NRSEQUMAPAPU = C_REGE200.NRSEQUMAPAPU
                            AND A.SGESTADO     = C_REGE200.SGESTADO)LOOP
            V_VROUTRDEB := NVL(V_VROUTRDEB,0 ) + NVL(C_DEBEXT.VROUTRDEB,0  );
            V_VREXTRAPUR:= NVL(V_VREXTRAPUR,0) + NVL(C_DEBEXT.VREXTRAAPUR,0);
         END LOOP;

         V_AJ_DEBITO_DOC_ST := 0;

         /* BUSCA OS VALORES DE AJUSTE A DÉBITO - DOC. FISCAL PRESENTES NA APURAÇÃO,
            DE ACORDO COM O CÓDIGO DE AJUSTE PARA O ICMS ST - SUBSTITUÍDO SOLIDÁRIO */
         SELECT NVL(SUM(VRITEMMAPR),0)
           INTO V_AJ_DEBITO_DOC_ST
           FROM (SELECT NVL(SUM(ROUND(DECODE(SUBSTR(IM.CDAJUSTEITMAPA,3,1),'9',0,DECODE(DT.IDSUBSTSOLIDST,'S',DT.VRIMPOSTOIT,IT.VRIMPOSTOIT)),2) + VALOR_FECP_ITEM_NFE(IT.CDFILIAL, IT.NRLANCTONF,IT.NRSEQITPROD,'80','I','1',IT.NRITPROIMPOS)),0) AS VRITEMMAPR
                   FROM ITMAPARECUP IM, ITEMPROIMPOS IT, IMPOSTO II, DETITMAPARECUP DT, NOTAFISCAL NF, INSCRESTAD IE
                  WHERE IM.NRSEQUMAPAPU = C_REGE200.NRSEQUMAPAPU
                    AND IM.IDCOMPOEC197 = 'I'
                    AND IM.CDFILIAL     = IT.CDFILIAL
                    AND IM.NRLANCTONF   = IT.NRLANCTONF
                    AND IT.CDIMPOSTO    = II.CDIMPOSTO
                    AND II.CDIMPOSTONFE = '80'
                    AND SUBSTR(IM.CDAJUSTEITMAPA,4,1) IN ('1','9')
                    AND IM.NRSEQUMAPAPU = DT.NRSEQUMAPAPU
                    AND IM.IDTIPOITMAPR = DT.IDTIPOITMAPR
                    AND IM.NRSEQITMAPR  = DT.NRSEQITMAPR
                    AND IT.CDFILIAL     = DT.CDFILIAL
                    AND IT.NRLANCTONF   = DT.NRLANCTONF
                    AND IT.NRSEQITPROD  = DT.NRSEQITPROD
                    AND IT.NRITPROIMPOS = DT.NRITPROIMPOS
                    AND SUBSTR(IM.CDAJUSTEITMAPA,3,1) IN ('3','4','5')
                    AND NF.CDFILIAL     = IT.CDFILIAL
                    AND NF.NRLANCTONF   = IT.NRLANCTONF
                    AND NF.CDINSCESTA   = IE.CDINSCESTA
                    AND IE.SGESTADO     = C_REGE200.SGESTADO);

         SELECT '|E210'                                                                                                                           ||'|'||
                DECODE((NVL(C_REGE200.VRTOTDEB,0)+NVL(V_AJ_DEBITO_DOC_ST,0)),0,DECODE(NVL(C_REGE200.VRTOTCRE,0),0,'0','1'),'1')                                               ||'|'|| --INDICADOR DE MOVIMENTO(CAMPO 2)
                REPLACE(LTRIM(TO_CHAR(NVL(ROUND(SUM(ME.VRCREDANTERIOR),2),0),'999999999990.00')),'.',',')                                         ||'|'|| -- SALDO CREDOR PERIDODO ANTERIOR ST(CAMPO 3)
                REPLACE(LTRIM(TO_CHAR(NVL(ROUND(SUM(ME.VRDEVMAPA),2),0),'999999999990.00')),'.',',')                                              ||'|'|| --SALDO CREDOR DE DEVOLUO(CAMPO 4)
                REPLACE(LTRIM(TO_CHAR(NVL(ROUND(SUM(ME.VRRESSAMAPA),2),0),'999999999990.00')),'.',',')                                            ||'|'|| -- VALOR DE RESSARCIMENTO(CAMPO 5)
                REPLACE(LTRIM(TO_CHAR(NVL(ROUND(SUM(ME.VROUTROSCREDITOS+ME.VRCREDITONORMAL),2),0),'999999999990.00')),'.',',')                    ||'|'|| --VALOR DE OUT. CRED. + EST. DEB(CAMPO 6)
                '0,00'                                                                                                                            ||'|'|| --AJUSTE A CREDITO ST DOC. FISCAL(CAMPO 7)
                REPLACE(LTRIM(TO_CHAR(NVL(ROUND(SUM(ME.VRDEBITONORMAL),2),0),'999999999990.00')),'.',',')                                         ||'|'|| --VALOR RETENO ST (CAMPO 8)
                REPLACE(LTRIM(TO_CHAR(NVL(ROUND(SUM(V_VROUTRDEB),2),0),'999999999990.00')),'.',',')                                               ||'|'|| -- VALOR DE OUT. DEB. + ESTORNO CRED. (CAMPO 9)
                REPLACE(LTRIM(TO_CHAR(NVL(V_AJ_DEBITO_DOC_ST,0),'999999999990.00')),'.',',')                                                      ||'|'|| --VALOR AJUSTE A DEB. DOC. FISC(CAMPO 10)
                REPLACE(LTRIM(TO_CHAR(NVL(ROUND(SUM(ME.VRIMPARECOLHER+NVL(V_AJ_DEBITO_DOC_ST,0)-V_VREXTRAPUR),2),0),'999999999990.00')),'.',',')                            ||'|'|| --VALOR SALDO DEB ANT. DEDUES(CAMPO 11)
                REPLACE(LTRIM(TO_CHAR(NVL(ROUND(SUM(DECODE(ME.SGESTADO,V_SGESTADO,MR.VRDEDUCAO,0)),2),0),'999999999990.00')),'.',',')             ||'|'|| -- VALOR DA DEDUCAO(CAMPO 12)
                REPLACE(LTRIM(TO_CHAR(NVL(ROUND(SUM(DECODE(ME.SGESTADO,V_SGESTADO,ME.VRIMPARECOLHER+NVL(V_AJ_DEBITO_DOC_ST,0)-MR.VRDEDUCAO-V_VREXTRAPUR,ME.VRIMPARECOLHER+NVL(V_AJ_DEBITO_DOC_ST,0)-V_VREXTRAPUR)),2),0),'999999999990.00')),'.',',')||'|'|| -- VALOR IMP. RECOLHER (CAMPO 13)
                REPLACE(LTRIM(TO_CHAR(NVL(ROUND(SUM(ME.VRSALDOCREDOR),2),0),'999999999990.00')),'.',',')                                          ||'|'|| --VALOR SALDO CREDOR(CAMPO 14)
                REPLACE(LTRIM(TO_CHAR(NVL(ROUND(SUM(V_VREXTRAPUR),2),0),'999999999990.00')),'.',',')                                              ||'|' --VALOR EXTRA APURAÇÃO(CAMPO 15)
           INTO V_REG_E210
           FROM MAPAAPURAC MP, MAPARECUP MR, MAPAAPURESTADO ME
          WHERE MP.NRSEQUMAPAPU = C_REGE200.NRSEQUMAPAPU AND
                MR.NRSEQUMAPAPU = C_REGE200.NRSEQUMAPAPU AND
                ME.NRSEQUMAPAPU = C_REGE200.NRSEQUMAPAPU AND
                ME.SGESTADO     = C_REGE200.SGESTADO;

         /*INSERTE O REGISTRO E210*/
         V_CONTREGE := NVL(V_CONTREGE,0) + 1;
         INSERT INTO ARQMAGNETICO
            (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
          VALUES
            ('56'||LPAD(RTRIM(V_CONTREGE), 7, '0')||'2',V_REG_E210, P_NRSEQARQMAG);

         FOR C_E220 IN (SELECT '|E220'
                               || '|' || A.CDAJUSTEAPURSG
                               || '|' || A.DSAJUSTEAPURSG
                               || '|' || REPLACE(LTRIM(TO_CHAR(NVL(ROUND(A.VRAJUSTEAPURSG,2),0), '999999999990.00')), '.', ',')
                               || '|' AS E220
                          FROM AJUSTMAPAAPURSG A
                         WHERE A.NRSEQUMAPAPU = C_REGE200.NRSEQUMAPAPU
                           AND A.SGESTADO     = C_REGE200.SGESTADO)LOOP
            INSERT INTO ARQMAGNETICO
               (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
             VALUES
               ('56'||LPAD(RTRIM(V_CONTREGE), 7, '0')||'3', C_E220.E220, P_NRSEQARQMAG);
            V_CONTREGE := NVL(V_CONTREGE,0) + 1;
         END LOOP;

         FOR C_REGE250 IN (SELECT ARQ_E250
                             FROM (SELECT '|E250'                            || '|' ||
                                          LPAD(NVL(DT.CDOBRIGACAO,'001'),3,'0')        || '|' ||
                                          REPLACE(LTRIM(TO_CHAR(NVL(ROUND(NVL(DT.VRRECEITA,0)+NVL(V_AJ_DEBITO_DOC_ST,0),2),0), '999999999990.00')),'.',',') || '|' ||
                                          TO_CHAR(NVL(DT.DTVENCDET,MP.DTVENCGUIA),'DDMMYYYY')  || '|' ||
                                          NVL(DT.CDRECEITA,MP.CDRECEGUIA)   || '|' ||
                                          DT.NRPROCESSO                     || '|' ||
                                          DT.IDORIGEMDET                    || '|' ||
                                          DT.DSHISTORICO                    || '|' ||
                                          ''                                || '|' ||
                                          TO_CHAR(MP.DTINIPERIODO, 'MMYYYY')|| '|' AS ARQ_E250,
                                          NVL(DT.VRRECEITA,0) + NVL(V_AJ_DEBITO_DOC_ST,0) AS VRGUIA
                                     FROM DETAUFMAPAEST DT, MAPAAPURAC MP
                                    WHERE DT.NRSEQUMAPAPU(+) = C_REGE200.NRSEQUMAPAPU
                                      AND DT.SGESTADO(+)     = C_REGE200.SGESTADO
                                      AND DT.NRSEQUMAPAPU(+) = MP.NRSEQUMAPAPU
                                      AND MP.NRSEQUMAPAPU    = C_REGE200.NRSEQUMAPAPU)
                            WHERE VRGUIA > 0) LOOP
         V_CONTREGE := NVL(V_CONTREGE,0) + 1;
            INSERT INTO ARQMAGNETICO
              (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
            VALUES
              ('56'||LPAD(RTRIM(V_CONTREGE), 7, '0')||'4', C_REGE250.ARQ_E250, P_NRSEQARQMAG);
         END LOOP;
      END LOOP;

      /*REGISTRO E300 - PERÍODO DE APURAÇÃO DO ICMS DIFERENCIAL DE ALÍQUOTA – UF ORIGEM/DESTINO EC 87/15*/
      FOR C_REGE300 IN (SELECT ('|E300'             || '|' ||
                               ME.SGESTADO         || '|' ||
                               TO_CHAR(MP.DTINIPERIODO,'DDMMYYYY') || '|' ||
                               TO_CHAR(MP.DTFIMPERIODO,'DDMMYYYY') || '|') AS ARQ_E300,
                               ME.NRSEQUMAPAPU, ME.NRSEQMAPAPURESTNC
                          FROM MAPAAPURESTADONC ME, MAPAAPURAC MP
                         WHERE MP.CDEMPRESA     = P_CDEMPRESA
                           AND MP.CDINSCESTA    = P_CDINSCESTA
                           AND MP.DTINIPERIODO  = P_DTINICIAL
                           AND MP.DTFIMPERIODO  = P_DTFINAL
                           AND MP.CDIMPOSTO     = P_CDIMPOSTO
                           AND MP.NRSEQUMAPAPU  = ME.NRSEQUMAPAPU) LOOP

         INSERT INTO ARQMAGNETICO
            (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
         VALUES
            ('57'||LPAD(RTRIM(V_CONTREGE), 8, '0'), C_REGE300.ARQ_E300, P_NRSEQARQMAG);
         V_CONTREGE := NVL(V_CONTREGE,0) + 1;

         /* BUSCA OS VALORES DE AJUSTE A DÉBITO DE ACORDO COM O CÓDIGO DE AJUSTE */
         V_AJ_DEBITOS_DIFAL := 0;
         V_AJ_DEBITOS_FCP   := 0;
         BEGIN
            SELECT NVL(SUM(DECODE(IT.IDAJUSTENC,'D',IT.VRITEMMAPR,0)),0) AS AJ_DEBITOS_DIFAL,
                   NVL(SUM(DECODE(IT.IDAJUSTENC,'F',IT.VRITEMMAPR,0)),0) AS AJ_DEBITOS_FCP
              INTO V_AJ_DEBITOS_DIFAL, V_AJ_DEBITOS_FCP
              FROM ITMAPARECUPNC IT
             WHERE IT.NRSEQUMAPAPU      = C_REGE300.NRSEQUMAPAPU
               AND IT.NRSEQMAPAPURESTNC = C_REGE300.NRSEQMAPAPURESTNC
               AND IT.IDTIPOITMAPR      IN ('OD', 'EC')
               AND SUBSTR(IT.CDAJUSTEITMAPA,3,1) IN ('2')
               AND SUBSTR(IT.CDAJUSTEITMAPA,4,1) IN ('0','1');
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_AJ_DEBITOS_DIFAL := 0;
               V_AJ_DEBITOS_FCP   := 0;
         END;

         /* BUSCA OS VALORES DE AJUSTE A CRÉDITO DE ACORDO COM O CÓDIGO DE AJUSTE */
         V_AJ_CREDITOS_DIFAL := 0;
         V_AJ_CREDITOS_FCP   := 0;
         BEGIN
            SELECT NVL(SUM(DECODE(IT.IDAJUSTENC,'D',IT.VRITEMMAPR,0)),0) AS AJ_CREDITOS_DIFAL,
                   NVL(SUM(DECODE(IT.IDAJUSTENC,'F',IT.VRITEMMAPR,0)),0) AS AJ_CREDITOS_FCP
              INTO V_AJ_CREDITOS_DIFAL, V_AJ_CREDITOS_FCP
              FROM ITMAPARECUPNC IT
             WHERE IT.NRSEQUMAPAPU      = C_REGE300.NRSEQUMAPAPU
               AND IT.NRSEQMAPAPURESTNC = C_REGE300.NRSEQMAPAPURESTNC
               AND IT.IDTIPOITMAPR      IN ('OC', 'ED')
               AND SUBSTR(IT.CDAJUSTEITMAPA,3,1) IN ('2')
               AND SUBSTR(IT.CDAJUSTEITMAPA,4,1) IN ('2','3');
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_AJ_CREDITOS_DIFAL := 0;
               V_AJ_CREDITOS_FCP   := 0;
         END;

         /* BUSCA OS VALORES DE AJUSTE DE DEDUÇÃO DE ACORDO COM O CÓDIGO DE AJUSTE */
         V_VL_TOT_DED_DIFAL := 0;
         V_VL_TOT_DED_FCP   := 0;
         BEGIN
            SELECT NVL(SUM(DECODE(IT.IDAJUSTENC,'D',IT.VRITEMMAPR,0)),0) AS VL_TOT_DED_DIFAL,
                   NVL(SUM(DECODE(IT.IDAJUSTENC,'F',IT.VRITEMMAPR,0)),0) AS VL_TOT_DED_FCP
              INTO V_VL_TOT_DED_DIFAL, V_VL_TOT_DED_FCP
              FROM ITMAPARECUPNC IT
             WHERE IT.NRSEQUMAPAPU      = C_REGE300.NRSEQUMAPAPU
               AND IT.NRSEQMAPAPURESTNC = C_REGE300.NRSEQMAPAPURESTNC
               AND IT.IDTIPOITMAPR      IN ('DD')
               AND SUBSTR(IT.CDAJUSTEITMAPA,3,1) IN ('2')
               AND SUBSTR(IT.CDAJUSTEITMAPA,4,1) IN ('4');
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_VL_TOT_DED_DIFAL := 0;
               V_VL_TOT_DED_FCP   := 0;
         END;

         /* BUSCA OS VALORES DE DÉBITO ESPECIAL DE ACORDO COM O CÓDIGO DE AJUSTE */
         V_VR_DEB_ESP_DIFAL := 0;
         V_VR_DEB_ESP_FCP   := 0;
         BEGIN
            SELECT NVL(SUM(DECODE(IT.IDAJUSTENC,'D',IT.VRITEMMAPR,0)),0) AS VR_DEB_ESP_DIFAL,
                   NVL(SUM(DECODE(IT.IDAJUSTENC,'F',IT.VRITEMMAPR,0)),0) AS VR_DEB_ESP_FCP
              INTO V_VR_DEB_ESP_DIFAL, V_VR_DEB_ESP_FCP
              FROM ITMAPARECUPNC IT
             WHERE IT.NRSEQUMAPAPU      = C_REGE300.NRSEQUMAPAPU
               AND IT.NRSEQMAPAPURESTNC = C_REGE300.NRSEQMAPAPURESTNC
               AND IT.IDTIPOITMAPR      IN ('OD', 'EC')
               AND SUBSTR(IT.CDAJUSTEITMAPA,3,1) IN ('2')
               AND SUBSTR(IT.CDAJUSTEITMAPA,4,1) IN ('5');
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_VR_DEB_ESP_DIFAL := 0;
               V_VR_DEB_ESP_FCP   := 0;
         END;

         FOR C_REGE310 IN (SELECT '|E310'                                                                            || '|' ||
                                   CASE WHEN MR.VRSALDOCRED > 0 OR MR.VRSALDODEVE > 0 THEN '1' ELSE '0' END           || '|' ||
                                   REPLACE(LTRIM(TO_CHAR(NVL(ROUND(MR.VRSLDCRANTE, 2),0),'999999999990.00')),'.',',') || '|' ||
                                   REPLACE(LTRIM(TO_CHAR(NVL(ROUND(MR.VRDEBIDIFAL, 2),0),'999999999990.00')),'.',',') || '|' ||
                                   REPLACE(LTRIM(TO_CHAR(NVL(ROUND(AJ_DEBITOS,   2),0),'999999999990.00')),'.',',') || '|' ||
                                   REPLACE(LTRIM(TO_CHAR(NVL(ROUND(MR.VRDEBIFCP,   2),0),'999999999990.00')),'.',',') || '|' ||
                                   REPLACE(LTRIM(TO_CHAR(NVL(ROUND(MR.VRCREDDIFAL, 2),0),'999999999990.00')),'.',',') || '|' ||
                                   REPLACE(LTRIM(TO_CHAR(NVL(ROUND(MR.VRCREDFCP,   2),0),'999999999990.00')),'.',',') || '|' ||
                                   REPLACE(LTRIM(TO_CHAR(NVL(ROUND(AJ_CREDITOS,  2),0),'999999999990.00')),'.',',') || '|' ||
                                   REPLACE(LTRIM(TO_CHAR(NVL(ROUND(CASE WHEN (MR.VRDEBIDIFAL + AJ_DEBITOS + MR.VRDEBIFCP) - (MR.VRCREDDIFAL + MR.VRCREDFCP + AJ_CREDITOS + MR.VRSLDCRANTE) > 0
                                                                        THEN (MR.VRDEBIDIFAL + AJ_DEBITOS + MR.VRDEBIFCP) - (MR.VRCREDDIFAL + MR.VRCREDFCP + AJ_CREDITOS + MR.VRSLDCRANTE)
                                                                        ELSE 0 END,2),0),'999999999990.00')),'.',',') || '|' ||
                                   REPLACE(LTRIM(TO_CHAR(NVL(ROUND(MR.VRDEDUCAO,   2),0),'999999999990.00')),'.',',') || '|' ||
                                   REPLACE(LTRIM(TO_CHAR(NVL(ROUND(CASE WHEN (MR.VRDEBIDIFAL + AJ_DEBITOS + MR.VRDEBIFCP) - (MR.VRCREDDIFAL + MR.VRCREDFCP + AJ_CREDITOS + MR.VRSLDCRANTE + MR.VRDEDUCAO) > 0
                                                                        THEN (MR.VRDEBIDIFAL + AJ_DEBITOS + MR.VRDEBIFCP) - (MR.VRCREDDIFAL + MR.VRCREDFCP + AJ_CREDITOS + MR.VRSLDCRANTE + MR.VRDEDUCAO)
                                                                        ELSE 0 END,2),0),'999999999990.00')),'.',',') || '|' ||
                                   REPLACE(LTRIM(TO_CHAR(NVL(ROUND(CASE WHEN (MR.VRCREDDIFAL + MR.VRCREDFCP + AJ_CREDITOS + MR.VRSLDCRANTE + MR.VRDEDUCAO) - (MR.VRDEBIDIFAL + AJ_DEBITOS + MR.VRDEBIFCP) > 0
                                                                        THEN (MR.VRCREDDIFAL + MR.VRCREDFCP + AJ_CREDITOS + MR.VRSLDCRANTE + MR.VRDEDUCAO) - (MR.VRDEBIDIFAL + AJ_DEBITOS + MR.VRDEBIFCP)
                                                                        ELSE 0 END,2),0),'999999999990.00')),'.',',') || '|' ||
                                   REPLACE(LTRIM(TO_CHAR(NVL(ROUND(VR_DEB_ESP,   2),0),'999999999990.00')),'.',',') || '|' AS ARQE310
                              FROM (SELECT NVL(M.VRSALDOCREDDIFAL,0) + NVL(M.VRSALDOCREDFCP,0) AS VRSALDOCRED,
                                           NVL(M.VRSALDODEVEDIFAL,0) + NVL(M.VRSALDODEVEFCP,0) AS VRSALDODEVE,
                                           NVL(M.VRSLDCRANTEDIFAL,0) + NVL(M.VRSLDCRANTEFCP,0) AS VRSLDCRANTE,
                                           M.VRDEBIDIFAL, M.VRDEBIFCP, M.VRCREDDIFAL, M.VRCREDFCP,
                                           (V_AJ_DEBITOS_DIFAL + V_AJ_DEBITOS_FCP) AS AJ_DEBITOS,
                                           (V_AJ_CREDITOS_DIFAL + V_AJ_CREDITOS_FCP) AS AJ_CREDITOS,
                                           (M.VRDEDUCAODIFAL + M.VRDEDUCAOFCP) AS VRDEDUCAO,
                                           (V_VR_DEB_ESP_DIFAL + V_VR_DEB_ESP_FCP) AS VR_DEB_ESP
                                      FROM MAPARECUPNC M
                                     WHERE M.NRSEQUMAPAPU      = C_REGE300.NRSEQUMAPAPU
                                       AND M.NRSEQMAPAPURESTNC = C_REGE300.NRSEQMAPAPURESTNC
                                       AND P_DTINICIAL         < TO_DATE('01/01/2017')) MR
                             UNION ALL
                            SELECT '|E310'                                                                                || '|' ||
                                   CASE WHEN MR.VRSALDOCREDDIFAL > 0 OR MR.VRSALDODEVEDIFAL > 0 OR
                                             MR.VRSALDOCREDFCP   > 0 OR MR.VRSALDODEVEFCP   > 0 THEN '1' ELSE '0' END     || '|' ||
                                   REPLACE(LTRIM(TO_CHAR(NVL(ROUND(MR.VRSLDCRANTEDIFAL,2),0),'999999999990.00')),'.',',') || '|' ||
                                   REPLACE(LTRIM(TO_CHAR(NVL(ROUND(MR.VRDEBIDIFAL,     2),0),'999999999990.00')),'.',',') || '|' ||
                                   REPLACE(LTRIM(TO_CHAR(NVL(ROUND(V_AJ_DEBITOS_DIFAL, 2),0),'999999999990.00')),'.',',') || '|' ||
                                   REPLACE(LTRIM(TO_CHAR(NVL(ROUND(MR.VRCREDDIFAL,     2),0),'999999999990.00')),'.',',') || '|' ||
                                   REPLACE(LTRIM(TO_CHAR(NVL(ROUND(V_AJ_CREDITOS_DIFAL,2),0),'999999999990.00')),'.',',') || '|' ||
                                   REPLACE(LTRIM(TO_CHAR(NVL(ROUND(CASE WHEN (MR.VRDEBIDIFAL + V_AJ_DEBITOS_DIFAL) - (MR.VRCREDDIFAL + V_AJ_CREDITOS_DIFAL + MR.VRSLDCRANTEDIFAL) > 0
                                                                        THEN (MR.VRDEBIDIFAL + V_AJ_DEBITOS_DIFAL) - (MR.VRCREDDIFAL + V_AJ_CREDITOS_DIFAL + MR.VRSLDCRANTEDIFAL)
                                                                        ELSE 0 END,    2),0),'999999999990.00')),'.',',') || '|' ||
                                   REPLACE(LTRIM(TO_CHAR(NVL(ROUND(MR.VRDEDUCAODIFAL,  2),0),'999999999990.00')),'.',',') || '|' ||
                                   REPLACE(LTRIM(TO_CHAR(NVL(ROUND(CASE WHEN (MR.VRDEBIDIFAL + V_AJ_DEBITOS_DIFAL) - (MR.VRCREDDIFAL + V_AJ_CREDITOS_DIFAL + MR.VRSLDCRANTEDIFAL + MR.VRDEDUCAODIFAL) > 0
                                                                        THEN (MR.VRDEBIDIFAL + V_AJ_DEBITOS_DIFAL) - (MR.VRCREDDIFAL + V_AJ_CREDITOS_DIFAL + MR.VRSLDCRANTEDIFAL + MR.VRDEDUCAODIFAL)
                                                                        ELSE 0 END,    2),0),'999999999990.00')),'.',',') || '|' ||
                                   REPLACE(LTRIM(TO_CHAR(NVL(ROUND(CASE WHEN (MR.VRCREDDIFAL + V_AJ_CREDITOS_DIFAL + MR.VRSLDCRANTEDIFAL + MR.VRDEDUCAODIFAL) - (MR.VRDEBIDIFAL + V_AJ_DEBITOS_DIFAL) > 0
                                                                        THEN (MR.VRCREDDIFAL + V_AJ_CREDITOS_DIFAL + MR.VRSLDCRANTEDIFAL + MR.VRDEDUCAODIFAL) - (MR.VRDEBIDIFAL + V_AJ_DEBITOS_DIFAL)
                                                                        ELSE 0 END,    2),0),'999999999990.00')),'.',',') || '|' ||
                                   REPLACE(LTRIM(TO_CHAR(NVL(ROUND(V_VR_DEB_ESP_DIFAL, 2),0),'999999999990.00')),'.',',') || '|' ||
                                   REPLACE(LTRIM(TO_CHAR(NVL(ROUND(MR.VRSLDCRANTEFCP,  2),0),'999999999990.00')),'.',',') || '|' ||
                                   REPLACE(LTRIM(TO_CHAR(NVL(ROUND(MR.VRDEBIFCP,       2),0),'999999999990.00')),'.',',') || '|' ||
                                   REPLACE(LTRIM(TO_CHAR(NVL(ROUND(V_AJ_DEBITOS_FCP,   2),0),'999999999990.00')),'.',',') || '|' ||
                                   REPLACE(LTRIM(TO_CHAR(NVL(ROUND(MR.VRCREDFCP,       2),0),'999999999990.00')),'.',',') || '|' ||
                                   REPLACE(LTRIM(TO_CHAR(NVL(ROUND(V_AJ_CREDITOS_FCP,  2),0),'999999999990.00')),'.',',') || '|' ||
                                   REPLACE(LTRIM(TO_CHAR(NVL(ROUND(CASE WHEN (MR.VRDEBIFCP + V_AJ_DEBITOS_FCP) - (MR.VRCREDFCP + V_AJ_CREDITOS_FCP + MR.VRSLDCRANTEFCP) > 0
                                                                        THEN (MR.VRDEBIFCP + V_AJ_DEBITOS_FCP) - (MR.VRCREDFCP + V_AJ_CREDITOS_FCP + MR.VRSLDCRANTEFCP)
                                                                        ELSE 0 END,    2),0),'999999999990.00')),'.',',') || '|' ||
                                   REPLACE(LTRIM(TO_CHAR(NVL(ROUND(MR.VRDEDUCAOFCP,    2),0),'999999999990.00')),'.',',') || '|' ||
                                   REPLACE(LTRIM(TO_CHAR(NVL(ROUND(CASE WHEN (MR.VRDEBIFCP + V_AJ_DEBITOS_FCP) - (MR.VRCREDFCP + V_AJ_CREDITOS_FCP + MR.VRSLDCRANTEFCP + MR.VRDEDUCAOFCP) > 0
                                                                        THEN (MR.VRDEBIFCP + V_AJ_DEBITOS_FCP) - (MR.VRCREDFCP + V_AJ_CREDITOS_FCP + MR.VRSLDCRANTEFCP + MR.VRDEDUCAOFCP)
                                                                        ELSE 0 END,    2),0),'999999999990.00')),'.',',') || '|' ||
                                   REPLACE(LTRIM(TO_CHAR(NVL(ROUND(CASE WHEN (MR.VRCREDFCP + V_AJ_CREDITOS_FCP + MR.VRSLDCRANTEFCP + MR.VRDEDUCAOFCP) - (MR.VRDEBIFCP + V_AJ_DEBITOS_FCP) > 0
                                                                        THEN (MR.VRCREDFCP + V_AJ_CREDITOS_FCP + MR.VRSLDCRANTEFCP + MR.VRDEDUCAOFCP) - (MR.VRDEBIFCP + V_AJ_DEBITOS_FCP)
                                                                        ELSE 0 END,    2),0),'999999999990.00')),'.',',') || '|' ||
                                   REPLACE(LTRIM(TO_CHAR(NVL(ROUND(V_VR_DEB_ESP_FCP,   2),0),'999999999990.00')),'.',',') || '|' AS ARQE310
                              FROM MAPARECUPNC MR
                             WHERE MR.NRSEQUMAPAPU      = C_REGE300.NRSEQUMAPAPU
                               AND MR.NRSEQMAPAPURESTNC = C_REGE300.NRSEQMAPAPURESTNC
                               AND P_DTINICIAL         >= TO_DATE('01/01/2017')) LOOP

            INSERT INTO ARQMAGNETICO
               (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
            VALUES
               ('57'||LPAD(RTRIM(V_CONTREGE), 8, '0'), C_REGE310.ARQE310, P_NRSEQARQMAG);
            V_CONTREGE := NVL(V_CONTREGE,0) + 1;

            FOR C_REGE311 IN (SELECT '|E311'             || '|' ||
                                     IT.CDAJUSTEITMAPA   || '|' ||
                                     IT.DSITEMMAPR       || '|' ||
                                     REPLACE(LTRIM(TO_CHAR(NVL(ROUND(IT.VRITEMMAPR, 2),0),'999999999990.00')),'.',',') || '|' AS ARQE311,
                                     IT.NRSEQITMAPRECNC
                                FROM ITMAPARECUPNC IT
                               WHERE IT.NRSEQUMAPAPU      = C_REGE300.NRSEQUMAPAPU
                                 AND IT.NRSEQMAPAPURESTNC = C_REGE300.NRSEQMAPAPURESTNC)LOOP

               INSERT INTO ARQMAGNETICO
                  (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
               VALUES
                  ('57'||LPAD(RTRIM(V_CONTREGE), 8, '0'), C_REGE311.ARQE311, P_NRSEQARQMAG);
               V_CONTREGE := NVL(V_CONTREGE,0) + 1;

               FOR C_REGE312 IN (SELECT '|E312'                     || '|' ||
                                        IT.NRDOCARRECAD             || '|' ||
                                        LPAD(IT.NRPROCESSO,15,'0')  || '|' ||
                                        CASE WHEN IT.NRPROCESSO IS NULL THEN '' ELSE IT.IDORIGEMPROC END || '|' ||
                                        IT.DSPROCESSO               || '|' ||
                                        ''                          || '|' AS ARQE312
                                   FROM ITMAPARECUPNC IT
                                  WHERE IT.NRSEQUMAPAPU      = C_REGE300.NRSEQUMAPAPU
                                    AND IT.NRSEQMAPAPURESTNC = C_REGE300.NRSEQMAPAPURESTNC
                                    AND IT.NRSEQITMAPRECNC   = C_REGE311.NRSEQITMAPRECNC
                                    AND (IT.NRDOCARRECAD IS NOT NULL OR IT.NRPROCESSO IS NOT NULL))LOOP

                  INSERT INTO ARQMAGNETICO
                     (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
                  VALUES
                     ('57'||LPAD(RTRIM(V_CONTREGE), 8, '0'), C_REGE312.ARQE312, P_NRSEQARQMAG);
                  V_CONTREGE := NVL(V_CONTREGE,0) + 1;
               END LOOP;

               FOR C_REGE313 IN (SELECT '|E313'                          || '|' ||
                                        NF.IDORIGDESTNF||REPLACE(REPLACE(REPLACE(REPLACE(DECODE(NF.IDORIGDESTNF, 'F', NF.CDFORNECED, DECODE(NF.IDORIGDESTNF, 'C', NF.CDCLIENTE , DECODE(NF.IDENTRSAIDOP, 'E', NF.CDFILIEMIT, NF.CDFILIRECE))),'.'),'-'),'/'),' ') || '|' ||
                                        NF.CDMODDOCFISC                  || '|' ||
                                        CASE WHEN LENGTH(NF.NRACESSONFE) = '44' THEN SUBSTR(NRACESSONFE,23,3) ELSE REPLACE(REPLACE(DECODE(NF.IDENTRSAIDOP, 'E', NF.CDSERIEENTR, NF.CDSERIE),'-',''),'.','') END  || '|' ||
                                        ''                               || '|' ||
                                        DECODE(NF.IDENTRSAIDOP,'E',LTRIM(NF.NRNOTAFISC,'0'),DECODE(NF.NRACESSONFE,'',LTRIM(NF.NRNOTAFISC,'0'),LTRIM(NF.NRNOTAFISCALELE,'0'))) || '|' ||
                                        NF.NRACESSONFE                   || '|' ||
                                        TO_CHAR(NF.DTEMISSAO,'DDMMYYYY') || '|' ||
                                        ''                               || '|' ||
                                        REPLACE(LTRIM(TO_CHAR(NVL(ROUND(IT.VRITEMMAPR, 2),0),'999999999990.00')),'.',',') || '|' AS ARQE313
                                   FROM ITMAPARECUPNC IT, NOTAFISCAL NF
                                  WHERE IT.NRSEQUMAPAPU      = C_REGE300.NRSEQUMAPAPU
                                    AND IT.NRSEQMAPAPURESTNC = C_REGE300.NRSEQMAPAPURESTNC
                                    AND IT.NRSEQITMAPRECNC   = C_REGE311.NRSEQITMAPRECNC
                                    AND IT.CDFILIAL          = NF.CDFILIAL
                                    AND IT.NRLANCTONF        = NF.NRLANCTONF)LOOP

                  INSERT INTO ARQMAGNETICO
                     (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
                  VALUES
                     ('57'||LPAD(RTRIM(V_CONTREGE), 8, '0'), C_REGE313.ARQE313, P_NRSEQARQMAG);
                  V_CONTREGE := NVL(V_CONTREGE,0) + 1;
               END LOOP;
            END LOOP;

            FOR C_REGE316 IN (SELECT '|E316'                          || '|' ||
                                     LPAD(G.CDOBRIGAGUIA,3,'0')       || '|' ||
                                     REPLACE(LTRIM(TO_CHAR(NVL(ROUND(G.VRRECEITAGUIA, 2),0),'999999999990.00')),'.',',') || '|' ||
                                     TO_CHAR(G.DTVENCGUIA,'DDMMYYYY') || '|' ||
                                     G.CDRECEITAGUIA                  || '|' ||
                                     LPAD(G.NRPROCESSOGUIA,15,'0')    || '|' ||
                                     CASE WHEN G.NRPROCESSOGUIA IS NULL THEN '' ELSE G.IDORIGEMPROC END || '|' ||
                                     G.DSPROCESSOGUIA                 || '|' ||
                                     ''                               || '|' ||
                                     TO_CHAR(P_DTINICIAL,'MMYYYY')    || '|' AS ARQE316
                                FROM GUIAAPURMAPANC G
                               WHERE G.NRSEQUMAPAPU      = C_REGE300.NRSEQUMAPAPU
                                 AND G.NRSEQMAPAPURESTNC = C_REGE300.NRSEQMAPAPURESTNC)LOOP

               INSERT INTO ARQMAGNETICO
                  (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
               VALUES
                  ('57'||LPAD(RTRIM(V_CONTREGE), 8, '0'), C_REGE316.ARQE316, P_NRSEQARQMAG);
               V_CONTREGE := NVL(V_CONTREGE,0) + 1;
            END LOOP;
         END LOOP;
      END LOOP;

      /*REGISTRO DE APURAÇÃO DO IPI*/
      V_EXISTE_IPI := 'N';
      FOR C_REGE510 IN (SELECT '|E510'                                                                                     || '|' ||
                               IT.CDFISCOPERIT                                                                             || '|' ||
                               IT.CDSITUTRIBITNFE                                                                          || '|' ||
                               REPLACE(LTRIM(TO_CHAR(NVL(ROUND(SUM(IT.VRCONTITIMP),2),0), '999999999990.00')), '.', ',')   || '|' ||
                               REPLACE(LTRIM(TO_CHAR(NVL(ROUND(SUM(DECODE(IT.CDFISCALIT,'1',IT.VRBASECALCIT,0)),2),0),'999999999990.00')),'.',',') || '|' ||
                               REPLACE(LTRIM(TO_CHAR(NVL(ROUND(SUM(DECODE(IT.CDFISCALIT,'1',IT.VRIMPOSTOIT, 0)),2),0),'999999999990.00')),'.',',') || '|' AS ARQ_E510
                          FROM ITEMPROIMPOS IT,
                               (SELECT DISTINCT N.NRLANCTONF, N.CDFILIAL, I.CDIMPOSTO
                                  FROM MAPAAPURAC M, NOTAFISCAL N, IMPOSTONF I
                                 WHERE M.CDEMPRESA       = P_CDEMPRESA
                                   AND M.DTINIPERIODO    = P_DTINICIAL
                                   AND M.DTFIMPERIODO    = P_DTFINAL
                                   AND M.CDIMPOSTO       = '10'
                                   AND ((I.NRSEQUMAPAPU  = M.NRSEQUMAPAPU) OR (M.NRSEQUMAPAPU = I.NRSEQMAPOIMP))
                                   AND NVL(I.IDIMPOSTONF,'1') <> '3'
                                   AND N.CDFILIAL        = I.CDFILIAL
                                   AND N.NRLANCTONF      = I.NRLANCTONF
                                   AND N.CDINSCESTA      = P_CDINSCESTA
                                   AND NVL(N.CDSERIE,' ') <> 'ECF'
                                   AND ((N.IDSTATUS = 'A') OR (N.IDSTATUS = 'E'))) N
                         WHERE IT.CDFILIAL = N.CDFILIAL
                           AND IT.NRLANCTONF = N.NRLANCTONF
                           AND IT.CDIMPOSTO = N.CDIMPOSTO
                           AND NVL(IT.NRITPROIMPOS,'1') <> '3'
                         GROUP BY IT.CDFISCOPERIT, IT.CDSITUTRIBITNFE)LOOP
         V_EXISTE_IPI := 'S';
         V_CONTREGE := NVL(V_CONTREGE,0) + 1;
         INSERT INTO ARQMAGNETICO
           (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
         VALUES
           ('59'||LPAD(RTRIM(V_CONTREGE), 8, '0'), C_REGE510.ARQ_E510, P_NRSEQARQMAG);
      END LOOP;

      /*REGISTRO E500 - APURAÇÃO IPI*/
      IF V_EXISTE_IPI = 'S' THEN
         FOR C_REGE500 IN (SELECT ('|E500'                          || '|' ||
                                   '0'                              || '|' ||
                                   TO_CHAR(DTINIPERIODO,'DDMMYYYY') || '|' ||
                                   TO_CHAR(DTFIMPERIODO,'DDMMYYYY') || '|'  ) AS ARQ_E500,
                                   TO_CHAR(DTINIPERIODO,'DDMMYYYY') as DTINICIAL,
                                   TO_CHAR(DTFIMPERIODO,'DDMMYYYY') as DTFINAL
                              FROM MAPAAPURAC M, MAPARECUP R
                             WHERE M.CDEMPRESA    = P_CDEMPRESA
                               AND M.CDIMPOSTO    = '10'
                               AND M.DTINIPERIODO = P_DTINICIAL
                               AND M.DTFIMPERIODO = P_DTFINAL
                               AND M.NRSEQUMAPAPU = R.NRSEQUMAPAPU
                               AND (M.CDINSCESTA  = P_CDINSCESTA OR M.CDINSCESTA IS NULL)) LOOP
            V_CONTREGE := NVL(V_CONTREGE,0) + 1;
            INSERT INTO ARQMAGNETICO
              (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
            VALUES
              ('58'||LPAD(RTRIM(V_CONTREGE), 8, '0'), C_REGE500.ARQ_E500, P_NRSEQARQMAG);
         END LOOP;

         /*REGISTRO E520*/
         FOR C_REGE520 IN (SELECT ('|E520'                                                                            || '|' ||
                                  REPLACE(LTRIM(TO_CHAR(NVL(ROUND(VRSLDCRANTE,2),0), '999999999990.00')), '.', ',')  || '|' ||
                                  REPLACE(LTRIM(TO_CHAR(NVL(ROUND(VRNORMDEBI,2),0), '999999999990.00')), '.', ',')   || '|' ||
                                  REPLACE(LTRIM(TO_CHAR(NVL(ROUND(VRNORMCRED,2),0), '999999999990.00')), '.', ',')   || '|' ||
                                  REPLACE(LTRIM(TO_CHAR(NVL(ROUND(VROUTRDEBI+ VRESTOCRED,2),0), '999999999990.00')), '.', ',')   || '|' ||
                                  REPLACE(LTRIM(TO_CHAR(NVL(ROUND(VROUTRCRED+VRESTODEBI,2),0), '999999999990.00')), '.', ',')   || '|' ||
                                  REPLACE(LTRIM(TO_CHAR(NVL(ROUND(VRSALDOCRED,2),0), '999999999990.00')), '.', ',')  || '|' ||
                                  REPLACE(LTRIM(TO_CHAR(NVL(ROUND((VRTOTAIMPOS),2),0), '999999999990.00')), '.', ',')   || '|' ) AS ARQ_E520,
                                  M.NRSEQUMAPAPU
                             FROM MAPAAPURAC M, MAPARECUP R
                            WHERE M.CDEMPRESA    = P_CDEMPRESA
                              AND M.CDIMPOSTO    = '10'
                              AND M.DTINIPERIODO = P_DTINICIAL
                              AND M.DTFIMPERIODO = P_DTFINAL
                              AND (M.CDINSCESTA  = P_CDINSCESTA OR M.CDINSCESTA IS NULL)
                              AND M.NRSEQUMAPAPU = R.NRSEQUMAPAPU) LOOP
            V_CONTREGE := NVL(V_CONTREGE,0) + 1;
            INSERT INTO ARQMAGNETICO
               (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
            VALUES
               ('60'||LPAD(RTRIM(V_CONTREGE), 8, '0'), C_REGE520.ARQ_E520, P_NRSEQARQMAG);
            FOR C_REGE530 IN (SELECT '|E530'                                                                                   ||'|'||
                                     DECODE(IT.IDTIPOITMAPR,'EC','0','ED','1','OD','0','OC','1')                               ||'|'||
                                     REPLACE(LTRIM(TO_CHAR(ROUND(IT.VRITEMMAPR,2),'999999999990.00')),'.',',')                 ||'|'||
                                     SUBSTR(LPAD(TRIM(REPLACE(REPLACE(IT.CDAJUSTEITMAPA,CHR(10),' '),CHR(9),' ')),10,'0'),8,3) ||'|'||
                                     DECODE(IT.NRLANCTONF,'','9','3')                                                           ||'|'||
                                     NF.NRNOTAFISC                                                                             ||'|'||
                                     TRIM(REPLACE(REPLACE(IT.DSITEMMAPR,CHR(10),' '),CHR(9),' '))                              ||'|' AS ARQ_E530,
                                     IT.CDFILIAL, IT.NRLANCTONF, IT.VRITEMMAPR
                                FROM ITMAPARECUP IT, NOTAFISCAL NF
                               WHERE IT.NRSEQUMAPAPU = C_REGE520.NRSEQUMAPAPU
                                 AND IT.CDFILIAL     = NF.CDFILIAL(+)
                                 AND IT.NRLANCTONF   = NF.NRLANCTONF(+)) LOOP

               V_CONTREGE := NVL(V_CONTREGE,0) + 1;
               INSERT INTO ARQMAGNETICO
                  (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
               VALUES
                  ('60'||LPAD(RTRIM(V_CONTREGE), 8, '0'), C_REGE530.ARQ_E530, P_NRSEQARQMAG);

               FOR C_REGC531 IN (SELECT '|E531'                                                                                  || '|' ||
                                        CNPJ                                                                                    || '|' ||
                                        CDMODDOCFISC                                                                            || '|' ||
                                        SERIE                                                                                   || '|' ||
                                        ''                                                                                      || '|' ||
                                        LTRIM(NRNOTAFISC,0)                                                                     || '|' ||
                                        REPLACE(TO_CHAR(DTEMISSAO,'DDMMYYYY'),'/','')                                           || '|' ||
                                        ''                                                                                      || '|' ||
                                        REPLACE(LTRIM(TO_CHAR(NVL(ROUND(C_REGE530.VRITEMMAPR,2),0), '999999999990.00')), '.', ',') || '|' ||
                                        NRACESSONFE  || '|' AS ARQ_E531
                                   FROM (SELECT NF.IDORIGDESTNF||FI.CDFILIAL AS CNPJ,
                                                CDMODDOCFISC,
                                                CASE WHEN IDENTRSAIDOP = 'E' THEN NF.CDSERIEENTR ELSE NF.CDSERIE END AS SERIE,
                                                NF.NRNOTAFISC, NF.DTEMISSAO, NF.NRLANCTONF, NF.CDFILIAL, NF.NRACESSONFE
                                           FROM NOTAFISCAL NF, FILIAL FI
                                          WHERE DECODE(IDENTRSAIDOP,'E',NF.CDFILIEMIT,NF.CDFILIRECE) = FI.CDFILIAL
                                            AND NF.CDEMPRESA  = FI.CDEMPRESA
                                            AND NVL(NF.IDORIGDESTNF,'L') = 'L'
                                            AND NF.NRLANCTONF = C_REGE530.NRLANCTONF
                                            AND NF.CDFILIAL   = C_REGE530.CDFILIAL
                                          UNION
                                         SELECT NF.IDORIGDESTNF||REPLACE(REPLACE(REPLACE(NF.CDCLIENTE,'.',''),'/',''),'-','') AS CNPJ,
                                                NF.CDMODDOCFISC,
                                                CASE WHEN IDENTRSAIDOP = 'E' THEN NF.CDSERIEENTR ELSE NF.CDSERIE END AS SERIE,
                                                NF.NRNOTAFISC, NF.DTEMISSAO, NF.NRLANCTONF, NF.CDFILIAL, NF.NRACESSONFE
                                           FROM CLIENTE CL, NOTAFISCAL NF
                                          WHERE CL.CDCLIENTE  = NF.CDCLIENTE
                                            AND NVL(NF.IDORIGDESTNF,'C') = 'C'
                                            AND NF.NRLANCTONF = C_REGE530.NRLANCTONF
                                            AND NF.CDFILIAL   = C_REGE530.CDFILIAL
                                          UNION
                                         SELECT NF.IDORIGDESTNF||REPLACE(REPLACE(REPLACE(NF.CDFORNECED,'.',''),'/',''),'-','') AS CNPJ,
                                                NF.CDMODDOCFISC,
                                                CASE WHEN IDENTRSAIDOP = 'E' THEN NF.CDSERIEENTR ELSE NF.CDSERIE END AS SERIE,
                                                NF.NRNOTAFISC, NF.DTEMISSAO, NF.NRLANCTONF, NF.CDFILIAL, NF.NRACESSONFE
                                           FROM FORNECEDOR FO, NOTAFISCAL NF
                                          WHERE FO.CDFORNECED = NF.CDFORNECED
                                            AND NVL(NF.IDORIGDESTNF,'F') = 'F'
                                            AND NF.NRLANCTONF = C_REGE530.NRLANCTONF
                                            AND NF.CDFILIAL   = C_REGE530.CDFILIAL)) LOOP

                  V_CONTREGE := NVL(V_CONTREGE,0) + 1;
                  INSERT INTO ARQMAGNETICO
                     (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
                  VALUES
                     ('60'||LPAD(RTRIM(V_CONTREGE), 8, '0'), C_REGC531.ARQ_E531, P_NRSEQARQMAG);
               END LOOP;
            END LOOP;
         END LOOP;
      END IF;
   END IF;

   IF (NVL(P_GERAFORSALE,'N') = 'N')  AND (V_CDSITUCRT <> '3') THEN   /*SIMPLES NACIONAL*/
      FOR C_REGE100 IN (SELECT DISTINCT ('|E100'                   || '|' ||
                               TO_CHAR(DTINIPERIODO,'DDMMYYYY')    || '|' ||
                               TO_CHAR(DTFIMPERIODO,'DDMMYYYY')    || '|'  ) AS ARQ_E100,
                               TO_CHAR(DTINIPERIODO,'DDMMYYYY') as DTINICIAL,
                               TO_CHAR(DTFIMPERIODO,'DDMMYYYY') as DTFINAL,
                               NRSEQUMAPAPU
                          FROM MAPAAPURACSN
                         WHERE CDEMPRESA    = P_CDEMPRESA
                           AND DTINIPERIODO = P_DTINICIAL
                           AND DTFIMPERIODO = P_DTFINAL) LOOP
         V_CONTREGE := NVL(V_CONTREGE,0) + 1;
         INSERT INTO ARQMAGNETICO
           (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
         VALUES
           ('53'||LPAD(RTRIM(V_CONTREGE), 8, '0'), C_REGE100.ARQ_E100, P_NRSEQARQMAG);
         V_CONTREGE := NVL(V_CONTREGE,0) + 1;
         INSERT INTO ARQMAGNETICO
            (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
         VALUES
            ('54'||LPAD(RTRIM(V_CONTREGE), 8, '0'),'|E110|00000000000000|0,00|00000000000000|00000000000000|00000000000000|0,00|00000000000000|00000000000000|00000000000000|00000000000000|00000000000000|00000000000000|00000000000000|00000000000000|', P_NRSEQARQMAG);
      END LOOP;
   END IF;

   /* abertuta do bloco E */
   IF NVL(V_CONTREGE,0) <> 0 THEN
      V_MOVIMENT := 0;
   ELSE
      V_MOVIMENT := 1;
   END IF;
   V_CONTREGE := NVL(V_CONTREGE,0) + 1;
   INSERT INTO ARQMAGNETICO
     (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
   VALUES
     ('52'||LPAD(RTRIM(V_CONTREGE), 8, '0'), '|E001'|| '|' ||V_MOVIMENT|| '|', P_NRSEQARQMAG);

   /* ENCERRAMENTO DO BLOCO E */
   V_CONTREGE := NVL(V_CONTREGE,0) + 1;
   INSERT INTO ARQMAGNETICO
     (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
   VALUES
     ('61'||LPAD(RTRIM(V_CONTREGE), 8, '0'), '|E990'|| '|' ||V_CONTREGE|| '|', P_NRSEQARQMAG);
   RETURN(V_CONTREGE);
END;
